#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   MakeRulesFile.py
#

import os
import sys

def getFoldersFiles(wdir):
    dirNames = []
    fileNames = []
    for (root, dirs, files) in os.walk(wdir):
        for dirName in dirs:
            dirNames += [root + "/" + dirName]
        for fileName in files:
            if fileName[-1] != "~":
                fileNames += [root + "/" + fileName]
    return [dirNames, fileNames]

wdir = sys.argv[1]
[folders, files] = getFoldersFiles(wdir)

cont = "#!/usr/bin/make -f\n"
cont += "include /usr/share/cdbs/1/rules/debhelper.mk\n"
cont += "install/treefoam::\n"
for folder in folders:
    cont += "\tinstall -pd $(DEB_DESTDIR)opt/" + folder + "\n"
for name in files:
    folder = "/".join(name.split("/")[:-1])
    cont += "\tinstall " + name + " $(DEB_DESTDIR)opt/" + folder + "\n"

f=open("rules", "w"); f.write(cont); f.close()

