#!/usr/bin/env python
# -*- coding: UTF-8 -*-
#
#       regionWallBoundaryConditions
#
#   regionWallBoundaryConditionsDictに基づきregion間の境界条件を設定する
#
#   14/11/14    新規作成
#
#


import os
import pyTreeFoam
import createBCsForMultiRegionDialog

import gettext
treeFoamPath = os.environ["TreeFoamPath"]
gettext.install("treefoam", treeFoamPath + "/data/locale")

caseDir = os.getcwd()

[fluidRegions, solidRegions] = pyTreeFoam.getZonesInRegionProperties(caseDir)

if len(fluidRegions) == 0 and len(solidRegions) == 0:
    mess = _(u"\nこのcaseには、regionPropertiesが存在しません。")
    print mess

else:
    [error, mess] = createBCsForMultiRegionDialog.replaceRegionFieldBoundaryConditions(
        caseDir, fluidRegions, solidRegions)

    if error != "OK":
        print mess
    else:
        mess = _(u"\nregion間の境界条件とinternalFieldをregionWallBoundaryConditionsDictに従い、設定しなおしました。")
        print mess

