#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   remakeStl
#
#       ｶﾚﾝﾄﾌｫﾙﾀﾞ内にあるstlﾌｧｲﾙのsolid名をﾁｪｯｸし、solid名を追記する。
#       既にsolid名が記入されている場合は、修正しない。
#
#   12/09/22    新規作成
#   13/10/15    国際化のため修正
#      10/26    unicodeのprint文をencodeして出力（バグ修正）
#

import glob
import sys
import os

def renameHeder(fileName, solidName):
    f = open(fileName)
    contents = f.readlines()
    f.close()
    words = contents[0].split()
    if len(words) >= 2:
        mess = fileName + _(u"\tOK   :solid名あり。->") + words[1] 
        print mess.encode("utf-8")
        return
    elif len(words) == 1:
        contents[0] = words[0] + " " + solidName + "\n"
        f = open(fileName, "w")
        for line in contents:
            f.write(line)
        f.close()
        print fileName + _(u"\tOK   :修正。-> model 追加").encode("utf-8")
    else:
        print fileName + _(u"\tError:修正できません。").encode("utf-8")


#言語の設定
import gettext
treeFoamPath = os.environ["TreeFoamPath"]
gettext.install("treefoam", treeFoamPath + "/data/locale")

if len(sys.argv) == 2:
    solidName = sys.argv[1]
    files = glob.glob("*.stl")
    for name in files:
        renameHeder(name, solidName)
else:
    print _(u"\nERROR: 引数の数が合いません。\n").encode("utf-8")
   
