#!/usr/bin/env python
# -*- coding: UTF-8 -*-
#
#   runCfMeshClearBoundary.py
#
#       cfMesh(cartesianMesh)を実行し、boundaryの整合をとる
#
#   15/10/02    新規作成
#

import os, sys, gettext
import pyTreeFoam
import getFoamContents
import setFoamContents

treeFoamPath = os.environ["TreeFoamPath"]
gettext.install("treefoam", treeFoamPath + "/data/locale")

caseDir = sys.argv[1]

#mesh作成
comm  = "cartesianMesh | tee solve.log\n"
pyTreeFoam.runOFUtility(comm)

#boundaryの整合
currTime = getFoamContents.getCurrTimeFolder(caseDir)
relPolyMeshDir = getFoamContents.getCurrMeshDir(caseDir, currTime, ".", "boundary")
polyMeshDir = caseDir + "/" + relPolyMeshDir
fieldDir = caseDir + "/" + currTime
setFoamContents.clearNullBoundaryAllFields(fieldDir, polyMeshDir)


