#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#  thinOutData.py
#
#   voltageCurrentData.txtの内容を間引きする。
#   <使い方>
#   thinOutData.py [option]
#       <option>
#       省略        全体が200行になる様にサンプリングする。
#       -n N        全体がN行になる様にサンプリングする。
#       -s N        N行間隔で1行をサンプリングする。
#       -t N        N病間隔で1行をサンプリングする。
#       -h          ヘルプを表示
#       --number N  -nと同じ
#       --skip N    -sと同じ
#       --tome N    -tと同じ
#       --help      -hと同じ
#
#           programed by s.Fujii
#           10/12/24    新規作成
#           14/02/13    -tオプション追加
#



import sys


fileName = "voltageCurrentData.txt"
job = ""
N = 200
helpMessage ='''
---------thinOutData.pyのヘルプ---------------
   voltageCurrentData.txtの内容を間引きする。
   <使い方>
   thinOutData.py [option]
       <option>
       省略        全体が200行になる様にサンプリングする。
       -n N        全体がN行になる様にサンプリングする。
       -s N        N行間隔で1行をサンプリングする。
       -t N        N秒間隔で1行をサンプリングする。
       -h          ヘルプを表示
       --number N  -nと同じ
       --skip N    -sと同じ
       --time N    -tと同じ
       --help      -hと同じ

'''
data = []


def getCommLine():
    global N
    commArg = sys.argv
    job = "n"
    i=1
    while (i<len(commArg)):
        comm = commArg[i]
        if (comm == "-n" or comm == "--number"):
            job = "n"
            i=i+1
            N = commArg[i]
        if (comm == "-s" or comm == "--skip"):
            job = "s"
            i=i+1
            N = commArg[i]
        if (comm == "-t" or comm == "--time"):
            job = "t"
            i += 1
            N = commArg[i]
        if (comm == "-h" or comm == "--help"):
            job = "h"
            print helpMessage
        if (comm != "-n" and comm != "--number" and
          comm != "-s" and comm != "--skip" and
          comm != "-h" and comm != "--help" and
          comm != "-t" and comm != "--time"):
            job = "h"
            print helpMessage
        i=i+1
    return job

#
#  getThinOutData
#
def getThinOutData(N):
    f=open(fileName)
    for line in f.readlines():
        data.append(line)
    maxTime = float(data[-1].split()[0])
    deltaT = maxTime/float(N)
    outTime = float(data[1].split()[0])
    print data[0],
    i = 1
    while i<len(data):
        line = data[i]
        time = float(line.split()[0])
        if time >= outTime:
            print line,
            outTime += deltaT
        i += 1

#
#  getTimeThinOutData
#
def getTimeThinOutData(T):
    data = []
    f=open(fileName)
    for line in f.readlines():
        data.append(line)
    maxTime = float(data[-1].split()[0])
    deltaT = float(T)
    outTime = float(data[1].split()[0])
    print data[0],
    i = 1
    while i<len(data):
        line = data[i]
        time = float(line.split()[0])
        if time >= outTime:
            print line,
            outTime += deltaT
        i += 1
    

#
#  skipOutData
#
def skipOutData(N):
    f=open(fileName)
    for line in f.readlines():
        data.append(line)
    print data[0],
    i = 1
    outI = 1
    while i<len(data):
        line = data[i]
        if i >= outI:
            print line,
            outI += int(N)
        i += 1




job = getCommLine()
if (job == "n"):
    getThinOutData(N)
elif (job == "s"):
    skipOutData(N)
elif (job == "t"):
    getTimeThinOutData(N)


