#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   unv2fistr.py
#
#       unv →　abaqus　→　fistr　の順にメッシュ変換
#
#       unv2fistr.py <unvファイル名>
#
#
#   15/03/19    新規作成
#

import sys
import os
import glob

#
#  printMsg
#
def printMsg():
    msg = """
<unv2fistr.py>
unvフォーマットのmeshをFrontISTR用mesh(HECMWフォーマット）に変換する。
この変換は、unv -> abaqus -> fistr の順番で変換している。

<使い方>
unv2fistr.py <unvファイル>

例：
unv2fistr.py name.unv
unv2fistr.py name
"""
    print msg

#
#  abaqus2fistr
#    abaqusをfistrに変換
def abaqus2fistr(fileName, newName):
    print
    print "convert abaqus to fistr..."
    comm = "abaqus2fistr.py " + fileName
    print comm
    os.system(comm)

#
#  unv2abaqus
#    unvをabaqusに変換
def unv2abaqus(fileName, newName):
    print
    print "convert unv to abaqus..."
    comm = "unv2abaqus.py " + fileName + " " + newName + " N"
    print comm
    os.system(comm)


if __name__=='__main__':
    name = sys.argv[1]
    if name[:len("-h")] == "-h" or name[:len("--help")] == "--help":
        printMsg()
    else:
        #file名を取得
        fileDir = "/".join(sys.argv[1].split("/")[:-1])
        if fileDir == "":
            fileDir = os.getcwd()
        fileName = sys.argv[1].split("/")[-1]
        if fileName[-4:] != ".unv":
            fileName += ".unv"
        #file有無チェック
        if len(glob.glob(fileDir+"/"+fileName)) == 0:
            print
            print "error:「" + fileDir + "/" + fileName + "」が存在しません。"
            exit()
        #abaqusに変換
        newName = fileName.split(".")[0]
        unv2abaqus(fileDir+"/"+fileName, fileDir+"/"+newName)
        #fistrに変換
        abaqusName = newName + ".inp"
        fistrName = newName + ".msh"
        abaqus2fistr(fileDir+"/"+abaqusName, fileDir+"/"+fistrName)


