#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   MakePatchDialog.py
#
#       12/08/29    faceZoneの名称をfaceZone_****→faces_****変更に伴い修正
#       12/09/10    makePatch:createBafflesがOF-2.1.0以降変わった為、修正
#       13/10/10    多言語化対応
#          12/21    stdout、stderrの設定（import logFileCreater）を追加
#       15/07/17    dialogの起動方法を修正
#       16/12/31    makePatch:OF-ext用に修正
#


# generated by wxGlade 0.6.3 on Sun Jan 24 20:28:35 2010

import wx
import os
import OKDialog
import glob
import pyTreeFoam

import logFileCreater; logFileCreater.log()


# begin wxGlade: extracode
# end wxGlade

frame_1 = ""
names = []

def Show(lists):
    global frame_1, names
    names = lists
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()


class MyFrame(wx.Frame):
    global frame_1, names
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_3 = wx.StaticText(self, -1, _(u"          内部パッチを作成します"))
        self.label_1 = wx.StaticText(self, -1, _(u"　　faceZoneを選択"))
        self.list_box_1 = wx.ListBox(self, -1, choices=names, style=wx.LB_MULTIPLE)
        self.label_2 = wx.StaticText(self, -1, _(u"faceZoneを選択して「作成」をクリック "))
        self.button_2 = wx.Button(self, -1, _(u"キャンセル"))
        self.button_3 = wx.Button(self, -1, _(u"作成"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.cancel, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.makePatch, self.button_3)
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_(u"内部パッチ作成"))
        self.list_box_1.SetMinSize((200, 100))
        self.list_box_1.SetSelection(0)
        self.button_2.SetFocus()
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3 = wx.BoxSizer(wx.VERTICAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add((20, 20), 0, 0, 0)
        sizer_1.Add(self.label_3, 0, 0, 0)
        sizer_1.Add((20, 10), 0, 0, 0)
        sizer_1.Add(self.label_1, 0, 0, 0)
        sizer_2.Add((20, 20), 0, 0, 0)
        sizer_2.Add(self.list_box_1, 0, 0, 0)
        sizer_2.Add((20, 20), 0, 0, 0)
        sizer_3.Add((20, 20), 0, 0, 0)
        sizer_3.Add(self.label_2, 0, 0, 0)
        sizer_4.Add((20, 20), 0, wx.ALIGN_RIGHT, 0)
        sizer_4.Add(self.button_2, 0, wx.ALIGN_RIGHT|wx.ALIGN_BOTTOM, 0)
        sizer_4.Add((10, 20), 0, wx.ALIGN_RIGHT, 0)
        sizer_4.Add(self.button_3, 0, wx.ALIGN_RIGHT|wx.ALIGN_BOTTOM, 0)
        sizer_4.Add((10, 20), 0, wx.ALIGN_RIGHT, 0)
        sizer_3.Add(sizer_4, 1, wx.EXPAND, 0)
        sizer_2.Add(sizer_3, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_2, 0, wx.EXPAND, 0)
        sizer_1.Add((20, 20), 0, 0, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    def cancel(self, event): # wxGlade: MyFrame.<event_handler>
        frame_1.Destroy()
        event.Skip()

    def makePatch(self, event): # wxGlade: MyFrame.<event_handler>
        subCase = glob.glob("./subCase")
        if len(subCase) == 0:
            print _(u"内部パッチを作成しています。")
            frame_1.Destroy()
            patches = []
            faceZones = []
            patchNo = frame_1.list_box_1.GetSelections()
            for n in patchNo:
                patches.append(names[n][6:])
                faceZones.append(names[n])
            #bashrcFoam = pyTreeFoam.getBashrcFoam()
            configData = pyTreeFoam.readConfigTreeFoam()
            OFversion = configData[0]
            bashrcFoam = configData[1]
            for name in patches:
                if OFversion[:3] == "ext":
                    #OF-ext
                    pyTreeFoam.runOFUtility("makePatch " + name)
                elif OFversion < '2.1.0':
                    #OF-1.7以前
                    #os.system(". " + bashrcFoam + ";makePatch " + name)
                    pyTreeFoam.runOFUtility("makePatch " + name)
                else:
                    #OF-2.1.0以降
                    #os.system(". " + bashrcFoam + ";makePatch2.0 " + name)
                    pyTreeFoam.runOFUtility("makePatch2.0 " + name)
            title = _(u"内部パッチの作成")
            img = "info"
            message =  _(u"内部パッチ\n  ")
            for name in patches:
                message = message + name + ", "
            message = message[:-2] + _(u"\nを作成しました。")
            OKDialog.Show(title, img, message)
        else:
            title = _("エラー")
            message = _("既に「subCase」フォルダがあります。削除して内部patchを作成してください。")
            self.errDialog(title, message)
        event.Skip()


    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

# end of class MyFrame


if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
