#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   ScaleOKDialog.py
#
#       programed by s.fujii
#       10/02/20    「enter」キーで実行する様に変更
#       12/01/17    累計の倍率を保存する様に変更
#       13/10/10    多言語化対応
#          10/27    mesh.unvファイル場所を任意に変更。これに伴い修正
#          11/16    OKDialogのimportを廃止
#          12/21    stdout、stderrの設定（import logFileCreater）を追加
#       15/07/17    dialogの起動方法を修正
#          10/07    iconPathの設定を修正
#       17/02/26    倍率変更の履歴保存を削除
#

# generated by wxGlade 0.6.3 on Mon Jan  4 23:22:38 2010

import wx
import os
import glob
import pyTreeFoam
import pyMeshOperation

import logFileCreater; logFileCreater.log()


#-------------------修正内容-------------------
#アイコン変更
#        self.bitmap_2 = wx.StaticBitmap(self, -1, wx.Bitmap(importantIcon32, wx.BITMAP_TYPE_ANY))
#

# begin wxGlade: extracode
# end wxGlade

scale = ""
mess = ""
frame_1 = ""
MagFile = ""
importantIcon32Name = "warning32.png"


def Show(mess1, modelSize):
    global mess, frame_1, scale, MagFile
    MagFile = os.getcwd() + "/constant/magnification"
    #MagFile = modelDir + "/magnification"
    mess = mess1
    scale = modelSize
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = ScaleFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()


class ScaleFrame(wx.Frame):
    global mess, frame_1, scale, MagFile
    def __init__(self, *args, **kwds):
        #iconPath = os.getenv("HOME") + "/TreeFoam/icons"
        iconPath = os.getenv("TreeFoamPath") + "/icons"
        importantIcon32 = iconPath + "/" + importantIcon32Name
        # begin wxGlade: ScaleFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.bitmap_2 = wx.StaticBitmap(self, -1, wx.Bitmap(importantIcon32, wx.BITMAP_TYPE_ANY))
        self.label_1 = wx.StaticText(self, -1, _(u"モデルのスケールを変更します"))
        self.label_3 = wx.StaticText(self, -1, _(u"大きさ XYZ: "))
        self.label_4 = wx.StaticText(self, -1, "")
        self.label_2 = wx.StaticText(self, -1, "scale:")
        self.text_ctrl_1 = wx.TextCtrl(self, -1, "1.0")
        self.label_5 = wx.StaticText(self, -1, "")
        self.button_1 = wx.Button(self, -1, _(u"キャンセル"))
        self.button_2 = wx.Button(self, -1, "OK")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.offScale, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.getScale, self.button_2)
        # end wxGlade

        self.label_1.SetLabel(mess)
        self.label_3.SetLabel(_(u"モデルの大きさ XYZ: ") + scale)

    def __set_properties(self):
        # begin wxGlade: ScaleFrame.__set_properties
        self.SetTitle(_(u"モデルのスケール変更"))
        #self.label_1.SetFont(wx.Font(12, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, ""))
        self.text_ctrl_1.SetMinSize((100, 27))
        self.button_1.SetFocus()
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: ScaleFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add((20, 20), 0, 0, 0)
        sizer_2.Add(self.bitmap_2, 0, wx.LEFT, 20)
        sizer_2.Add(self.label_1, 0, wx.LEFT|wx.ALIGN_CENTER_VERTICAL, 10)
        sizer_1.Add(sizer_2, 0, wx.EXPAND, 0)
        sizer_1.Add((20, 20), 0, 0, 0)
        sizer_5.Add(self.label_3, 0, wx.LEFT, 20)
        sizer_1.Add(sizer_5, 0, wx.EXPAND, 0)
        sizer_6.Add(self.label_4, 0, wx.LEFT|wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_1.Add(sizer_6, 0, wx.EXPAND, 0)
        sizer_1.Add((20, 10), 0, 0, 0)
        sizer_3.Add(self.label_2, 0, wx.LEFT|wx.ALIGN_CENTER_VERTICAL, 50)
        sizer_3.Add((10, 20), 0, 0, 0)
        sizer_3.Add(self.text_ctrl_1, 0, 0, 0)
        sizer_1.Add(sizer_3, 0, wx.EXPAND, 0)
        sizer_1.Add(self.label_5, 0, wx.LEFT|wx.TOP|wx.BOTTOM, 10)
        sizer_4.Add((200, 20), 0, 0, 0)
        sizer_4.Add(self.button_1, 0, 0, 0)
        sizer_4.Add((10, 20), 0, 0, 0)
        sizer_4.Add(self.button_2, 0, 0, 0)
        sizer_4.Add((10, 20), 0, 0, 0)
        sizer_1.Add(sizer_4, 0, wx.EXPAND, 0)
        sizer_1.Add((20, 20), 0, 0, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade


    def offScale(self, event): # wxGlade: ScaleFrame.<event_handler>
        self.Destroy()

    def getScale(self, event): # wxGlade: ScaleFrame.<event_handler>
        scale = self.text_ctrl_1.GetValue()
        self.changeScale(scale)
        self.Destroy()
        #event.Skip()


    def changeScale(self, scale):
        try:
            a = float(scale)
        except:
            title = "error message"
            message = _(u"エラーが発生しました。\n  入力されたtextが数字に変換できなかったか、\n  modelフォルダ無い為入力したscaleが保存できなかった\n事が考えられます。")
            self.errDialog(title, message)
            return

        command = 'transformPoints -scale "(' + scale + ' ' + scale + ' ' + scale + ')"'
        print command
        pyTreeFoam.runOFUtility(command)
        newSize = pyMeshOperation.getModelSize()
        newScale = " x ".join([str(newSize[0]), str(newSize[1]), str(newSize[2])])
        title = _(u"スケールの変更")
        message = _(u"モデルのスケールは、「") + scale + _(u"」倍に変更されました。") + "\n"
        message += "\n" + _(u"現在の大きさ: ") + newScale
        self.okDialog(title,message)

    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        if ans == wx.ID_OK:
            dlg.Destroy()
            return "OK"
        else:
            dlg.Destroy()
            return "CANCEL"

    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()



# end of class ScaleFrame


if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = ScaleFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
