#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   addDeleteRegionDialog.py
#
#       multiRegion内のregionを追加・削除する
#
#   13/06/22    新規作成
#      06/23    region名変更時、boundaryのsampleRegion、samplePatchの内容も修正。
#               （名称変更時、実行できなくなるため）
#      06/24    region削除時、boundaryのpatch名、patchTypeも修正
#      07/03    region削除、変更時にconstant内のregionが修正されない場合があり修正
#      09/28    gzip, binaryに対応。region削除時、boundaryFieldのクリアを追加。
#               region名変更後、boundaryFieldが読み込めないバグを修正。
#      10/15    国際化のため、修正
#               全region削除にバグあり、修正
#      12/21    stdout、stderrの設定（import logFileCreater）を追加
#   14/10/21    remakeFieldPatchName:unicodeｴﾗｰ発生したため、修正。
#   15/02/26    region操作時、結果folder有無を確認する様に修正
#      02/27    addRegionFolder:追加したregionにファイルの配布、boundaryの作成追加
#      03/02    copyFilesFluidSolid:修正（regName付きfileの配布を追加）
#      07/17    dialogの起動方法を修正
#
#

# generated by wxGlade 0.6.5 on Sat Jun 22 11:53:22 2013

import wx
import os
import gio
import glob
import pyTreeFoam
import getFoamContents
import setFoamContents
import inputTextDDialog

import logFileCreater; logFileCreater.log()


# begin wxGlade: extracode
# end wxGlade

fluid = []
solid = []
caseDir = ""


def Show(caseDir1):
    global caseDir
    caseDir = caseDir1
    initialize()
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, -1, _(u"設定されているRegion名を追加、変更、削除する。\n\n　追加：meshコピー要。\n　変更：boundaryとboundaryField内の\n　　　　region名、patch名も修正する。\n　削除：boundary内の削除regionに対応した\n　　　　patch名、patchTypeも修正する。"))
        self.list_box_1 = wx.ListBox(self, -1, choices=[], style=wx.LB_MULTIPLE)
        self.button_2 = wx.Button(self, -1, _(u"追加"))
        self.button_7 = wx.Button(self, -1, _(u"変更"))
        self.button_1 = wx.Button(self, -1, _(u"削除"))
        self.sizer_2_staticbox = wx.StaticBox(self, -1, _(u"流体のregion"))
        self.list_box_2 = wx.ListBox(self, -1, choices=[], style=wx.LB_MULTIPLE)
        self.button_4 = wx.Button(self, -1, _(u"追加"))
        self.button_8 = wx.Button(self, -1, _(u"変更"))
        self.button_3 = wx.Button(self, -1, _(u"削除"))
        self.sizer_6_staticbox = wx.StaticBox(self, -1, _(u"固体のregion"))
        self.button_5 = wx.Button(self, -1, _(u"全region削除..."))
        self.button_6 = wx.Button(self, -1, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onAddFluid, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onChangeFluid, self.button_7)
        self.Bind(wx.EVT_BUTTON, self.onDelFluid, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onAddSolid, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onChangeSolid, self.button_8)
        self.Bind(wx.EVT_BUTTON, self.onDelSolid, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onDelAll, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_6)
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_(u"regionの追加・削除"))
        self.list_box_1.SetMinSize((150, 100))
        self.button_2.SetMinSize((60, 25))
        self.button_7.SetMinSize((60, 25))
        self.button_1.SetMinSize((60, 25))
        self.list_box_2.SetMinSize((150, 100))
        self.button_4.SetMinSize((60, 25))
        self.button_8.SetMinSize((60, 25))
        self.button_3.SetMinSize((60, 25))
        # end wxGlade

        self.list_box_1.Clear()
        self.list_box_1.AppendItems(fluid)
        self.list_box_2.Clear()
        self.list_box_2.AppendItems(solid)


    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_10 = wx.BoxSizer(wx.VERTICAL)
        sizer_11 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_6_staticbox.Lower()
        sizer_6 = wx.StaticBoxSizer(self.sizer_6_staticbox, wx.HORIZONTAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_9 = wx.BoxSizer(wx.VERTICAL)
        sizer_7 = wx.BoxSizer(wx.VERTICAL)
        self.sizer_2_staticbox.Lower()
        sizer_2 = wx.StaticBoxSizer(self.sizer_2_staticbox, wx.HORIZONTAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_5 = wx.BoxSizer(wx.VERTICAL)
        sizer_3 = wx.BoxSizer(wx.VERTICAL)
        sizer_1.Add(self.label_1, 0, wx.ALL | wx.ALIGN_CENTER_HORIZONTAL, 20)
        sizer_3.Add(self.list_box_1, 1, wx.ALL | wx.EXPAND, 5)
        sizer_2.Add(sizer_3, 1, wx.EXPAND, 0)
        sizer_5.Add(self.button_2, 0, wx.BOTTOM | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_5.Add(self.button_7, 0, 0, 0)
        sizer_5.Add(self.button_1, 0, wx.TOP | wx.BOTTOM | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_4.Add(sizer_5, 1, wx.EXPAND, 0)
        sizer_2.Add(sizer_4, 0, wx.ALIGN_BOTTOM, 0)
        sizer_1.Add(sizer_2, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_7.Add(self.list_box_2, 1, wx.ALL | wx.EXPAND, 5)
        sizer_6.Add(sizer_7, 1, wx.EXPAND, 0)
        sizer_9.Add(self.button_4, 0, wx.BOTTOM, 5)
        sizer_9.Add(self.button_8, 0, 0, 0)
        sizer_9.Add(self.button_3, 0, wx.TOP | wx.BOTTOM | wx.ALIGN_BOTTOM, 5)
        sizer_8.Add(sizer_9, 0, wx.EXPAND, 0)
        sizer_6.Add(sizer_8, 0, wx.ALIGN_BOTTOM, 0)
        sizer_1.Add(sizer_6, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_11.Add(self.button_5, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM, 10)
        sizer_11.Add(self.button_6, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.ALIGN_BOTTOM, 10)
        sizer_10.Add(sizer_11, 0, wx.ALIGN_RIGHT, 0)
        sizer_1.Add(sizer_10, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #流体region削除
    def onDelFluid(self, event):  # wxGlade: MyFrame.<event_handler>
        self.deleteRegions("fluid")

    #流体region追加
    def onAddFluid(self, event):  # wxGlade: MyFrame.<event_handler>
        self.addRegion("fluid")

    #流体region名変更
    def onChangeFluid(self, event):  # wxGlade: MyFrame.<event_handler>
        self.changeRegion("fluid")

    #固体region削除
    def onDelSolid(self, event):  # wxGlade: MyFrame.<event_handler>
        self.deleteRegions("solid")

    #固体region追加
    def onAddSolid(self, event):  # wxGlade: MyFrame.<event_handler>
        self.addRegion("solid")

    #固体region名変更
    def onChangeSolid(self, event):  # wxGlade: MyFrame.<event_handler>
        self.changeRegion("solid")

    #全region削除
    def onDelAll(self, event):  # wxGlade: MyFrame.<event_handler>
        self.deleteAllRegions()

    #close
    def onClose(self, event):  # wxGlade: MyFrame.<event_handler>
        self.Destroy()

# end of class MyFrame

    #
    #  deleteAllRegions
    #    全regionを削除
    def deleteAllRegions(self):
        global fluid, solid
        allRegions = fluid + solid
        if len(allRegions) == 0:
            mess = _(u"このcaseには、regionがありません。")
            self.errDialog(_(u"エラー"), mess)
            return

        if self.isResultFolders(caseDir) == True:
            return

        title = _(u"全regionの削除")
        mess = _(u"全regionをゴミ箱に移動しますか。")
        ans = self.okCancelDialog(title, mess)
        if ans == "OK":
            mess = _(u"本当に、全regionを削除しますか？")
            ans = self.okCancelDialog(_(u"警告"), mess)
            if ans != "OK":
                return
        else:
            return

        #全regionを削除
        for regName in allRegions:
            error = deleteRegionFolder(caseDir, regName)
            if error != "":
                mess = _(u"regionが削除できませんでした。")
                self.errDialog(_(u"エラー"), mess)
                break
        #削除後の終了処理
        if error == "":
            fluid = []
            solid = []
            self.list_box_1.Clear()
            self.list_box_2.Clear()
            deleteRegionProperties(caseDir)
            mess = _(u"全regionを削除しました。")
            self.okDialog(_(u"全regionの削除"), mess)

    #
    #  changeRegion
    #    region名を変更する
    def changeRegion(self, region):
        global fluid, solid
        if region == "fluid":
            regionNames = fluid
            listBox = self.list_box_1
        else:
            regionNames = solid
            listBox = self.list_box_2
        selNames = self.getSelNames(listBox)
        if len(selNames) == 0:
            mess = _(u"regionを選択してください。")
            self.errDialog(_(u"エラー"), mess)
            return

        if len(selNames) > 1:
            mess = _(u"複数のregionは、選択できません。")
            self.errDialog(_(u"エラー"), mess)
            return

        if len(regionNames) == 0:
            mess = _(u"regionが存在しません。")
            self.errDialog(_(u"エラー"), mess)
            return

        if self.isResultFolders(caseDir) == True:
            return

        #newNameの取得
        selName = selNames[0]
        newName = self.inputRegionName(selName)
        if newName != "":
            #newNameのチェック
            same = 0
            for regName in regionNames:
                if regName == newName:
                    same = 1
                    break
            if same == 1:
                mess = _(u"入力したregion名は、既に使われています。\n別の名前で入力しなおしてください。")
                self.errDialog(_(u"エラー"), mess)
                return

            #newRegionsを取得
            i = 0
            for regName in regionNames:
                if regName == selName:
                    regionNames[i] = newName
                    break
                i += 1
            #listBox修正
            listBox.Clear()
            listBox.AppendItems(regionNames)
            #regionPropertiesの修正
            if region == "fluid":
                fluid = regionNames
            else:
                solid = regionNames
            setFoamContents.makeRegionProperties(caseDir, fluid, solid)
            #folder rename
            error = renameRegionFolder(caseDir, selName, newName)
            if error != "":
                mess = _(u"region名が変更できません。")
                self.errDialog(_(u"エラー"), mess)
                return
            #boundaryの内容修正
            error = renameBoundaryContents(caseDir, selName, newName)
            if error != "":
                mess = _(u"boundary内のregion名が変更できません。")
                self.errDialog(_(u"エラー"), mess)
                return
            #boundaryFieldの境界patch名修正
            error = renameBoundaryFieldContents(caseDir, selName, newName)
            if error != "":
                mess = _(u"boundaryField内の境界patch名が変更できません。")
                self.errDialog(_(u"エラー"), mess)
            else:
                mess = _(u"region名を変更しました。")
                self.okDialog(_(u"region名の変更"), mess)
        return

    #  isResultFolders
    #    結果folderがあるかどうかチェック
    def isResultFolders(self, caseDir):
        ans = False
        timeFolders = pyTreeFoam.getTimeFolders(caseDir)
        if len(timeFolders) > 1:
            mess = _(u"timeFolderが複数あります。\n")
            mess += _(u"結果folderを削除してください。")
            self.errDialog(_(u"エラー"), mess)
            ans = True
        else:
            ans = False
        return ans

    #
    #  deleteRegions
    #    regionを削除する（複数選択可）
    def deleteRegions(self, region):
        global fluid, solid
        if region == "fluid":
            regionNames = fluid
            listBox = self.list_box_1
        else:
            regionNames = solid
            listBox = self.list_box_2
        delNames = self.getSelNames(listBox)
        if len(delNames) == 0:
            mess = _(u"regionを選択してください。")
            self.errDialog(_(u"エラー"), mess)
            return

        if len(regionNames) == 0:
            mess = _(u"regionが存在しません。")
            self.errDialog(_(u"エラー"), mess)
            return

        title = _(u"regionの削除")
        mess = _(u"regionを削除しますか？\n\n削除後は、元に戻りません。")
        ans = self.okCancelDialog(title, mess)
        if ans != "OK":
            return

        #newRegionsを取得
        newRegions = []
        for regName in regionNames:
            for delName in delNames:
                same = 0
                if regName == delName:
                    same = 1
                    break
            if same == 0:
                newRegions.append(regName)
        #regionPopertiesの修正
        if region == "fluid":
            fluid = newRegions
        else:
            solid = newRegions
        setFoamContents.makeRegionProperties(caseDir, fluid, solid)
        #listBox修正
        listBox.Clear()
        listBox.AppendItems(newRegions)
        #folder削除
        for delName in delNames:
            error = deleteRegionFolder(caseDir, delName)
            if error != "":
                mess = _(u"「") + delName + _(u"」が削除できませんでした。")
                self.errdialog(_(u"エラー"), mess)
                break
            else:
                print _(u"削除: ") + delName
        if error != "":
            mess = _(u"regionが削除できませんでした。")
            self.errDialog(_(u"エラー"), mess)
            return

        #polyMesh/boundaryのpatchName、patchTypeを修正
        for delName in delNames:
            error = renameBoundaryPatchType(caseDir, delName)
            if error != "":
                break
        if error != "":
            mess = _(u"polyMesh/boundaryのpatchTypeが修正できませんでした。")
            self.errDialog(_(u"エラー"), mess)
            return

        #空白boundaryFieldをzeroGradientに設定
        regions = fluid + solid
        for region in regions:
            currTime = getFoamContents.getCurrTimeFolder(caseDir)
            fieldDir = caseDir + "/" + currTime + "/" + region
            meshRelDir = getFoamContents.getCurrMeshDir(caseDir, currTime,
                        region, "boundary")
            meshRel = "/".join(meshRelDir.split("/")[:-1])
            polyMeshDir = caseDir + "/" + meshRel
            Flist = pyTreeFoam.getFieldNames(fieldDir)
            setFoamContents.clearNullBoundaryFields(fieldDir, polyMeshDir, Flist)
        #終了メッセージ
        mess = _(u"regionを削除しました。\n削除したregionに関係するpolyMesh/boundaryのpatch名とpatchTypeを修正しています。\nboundaryFieldのpatchTypeは、「zeroGradient」に修正しています。")
        self.okDialog(_(u"regionの削除"), mess)


    def getSelNames(self, listBox):
        selNo = listBox.GetSelections()
        selNames = []
        for n in selNo:
            name = listBox.GetString(n)
            selNames.append(name)
        return selNames

    #
    #  addRegion
    #    regionを追加する
    def addRegion(self, region):
        global fluid, solid
        newName = "newRegion_"
        regionNames = []
        if region == "fluid":
            regionNames = fluid
            listBox = self.list_box_1
        else:
            regionNames = solid
            listBox = self.list_box_2
        allRegions = fluid + solid
        i = 0
        while i<10:
            name = newName + str(i)
            same = 0
            for regionName in allRegions:
                if name == regionName:
                    i += 1
                    same = 1
                    break
            if same == 0:
                newName = name
                break
        if i >= 10:
            mess = _(u"基本の名前を変更してください。")
            self.errDialog(_(u"エラー"), mess)
            return

        text = self.inputRegionName(newName)
        if text != u"":
            same = 0
            for regionName in allRegions:
                if regionName == text:
                    mess = _(u"同じ名前のregionがあります。")
                    self.errDialog(_(u"エラー"), mess)
                    same = 1
                    break
            if same == 0:
                newName = text
                regionNames.append(newName)
                if region == "fluid":
                    fluid = regionNames
                else:
                    solid = regionNames
                listBox.Clear()
                listBox.AppendItems(regionNames)
                #regionPropertiesを作成
                setFoamContents.makeRegionProperties(caseDir, fluid, solid)
                #folderを作成
                error = addRegionFolder(caseDir, newName, region)
                if error != "":
                    mess = _(u"regionを追加できませんでした。")
                    self.errDialog(_(u"エラー"), mess)
                else:
                    mess = _(u"新しいregion「") + newName + _(u"」を追加しました。")
                    self.okDialog(_(u"region追加"), mess)

    #  region名の入力
    #    textBoxからregion名を取得する
    def inputRegionName(self, newName):
        inputTextDDialog.title = _(u"region名の入力")
        inputTextDDialog.message = _(u"新しいregion名を入力してください。")
        inputTextDDialog.inputText = newName
        dialog = inputTextDDialog.MyDialog(None)
        result = dialog.ShowModal()
        if inputTextDDialog.status == "OK":
            text = inputTextDDialog.inputText
        else:
            text = u""
        return text


    #-------- universal dialog ---------------
    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        res = dlg.ShowModal()
        if res == wx.ID_OK:
            ans = "OK"
        else:
            ans = "CANCEL"
        dlg.Destroy()
        return ans

#
#  renameBoundaryFieldContents
#    region内の各fieldの境界patch名変更
def renameBoundaryFieldContents(caseDir, selName, newName):
    regions = fluid + solid
    iniTimeDir = caseDir + "/" + pyTreeFoam.getTimeFolders(caseDir)[0]
    for region in regions:
        fieldDir = iniTimeDir + "/" + region
        fields = pyTreeFoam.getFieldNames(fieldDir)
        for field in fields:
            fileName = fieldDir + "/" + field
            cont = getFoamContents.readFileFull(fileName)
            newCont = remakeFieldPatchName(cont, selName, newName)
            getFoamContents.writeFileFull(fileName, newCont)
    return ""

#  remakeFieldPatchName
#    fieldの境界patchを修正
def remakeFieldPatchName(cont, selName, newName):
    #boundaryFieldの内容を取得
    p = getFoamContents.skipFoamFileMem(cont, 0)
    [bCont, p] = getFoamContents.getKeywordContentsMem("boundaryField", cont, p)
    ep = p - 2
    sp = ep - len(bCont)
    header = cont[:sp]
    footer = cont[ep:]
    #boundaryField修正
    lines = []
    line = " "
    p = 0
    while line != "" and p <len(bCont):
        #1行を取得
        [line, p, kind] = getFoamContents.get1lineMem(bCont, p)
        [patchName, pp] = getFoamContents.getKeywordMem(line, 0)
        n = patchName.find("_to_")
        if n > 0:
            #境界面のpatch名をチェック修正
            newline = checkPatchName(patchName, line, selName, newName)
            #lineを追加
            lines.append("    " + newline)
        else:
            #通常のpatchはそのまま追加
            lines.append("    " + line)
    #全内容を追加
    allCont = header + "\n".join(lines).encode("utf-8") + footer
    return allCont

#
#  renameBoundaryContents
#    boundaryの内容を修正する
def renameBoundaryContents(caseDir, selName, newName):
    names = fluid + solid
    iniTime = pyTreeFoam.getTimeFolders(caseDir)[0]
    loc = getBoundaryLocation(caseDir, iniTime)
    for regName in names:
        boundary = caseDir + "/" + loc + "/" + regName + "/polyMesh/boundary"
        f=open(boundary); cont=f.read(); f.close()
        cont = remakeBoundaryCont(cont, selName, newName)
        f=open(boundary, "w"); f.write(cont); f.close()
    if loc != "constant":
        for regName in names:
            boundary = caseDir + "/constant/" + regName + "/polyMesh/boundary"
            f=open(boundary); cont=f.read(); f.close()
            cont = remakeBoundaryCont(cont, selName, newName)
            f=open(boundary, "w"); f.write(cont); f.close()
    return ""

def remakeBoundaryCont(cont, selName, newName):
    #boundaryの内容を取得
    p = getFoamContents.skipFoamFileMem(cont, 0)
    [patchesConts, p] = getFoamContents.getSmallPairMem(cont, p)
    #boundary以外（header、footer）を取得
    ep = p -1
    sp = ep - len(patchesConts)
    header = cont[:sp]
    footer = cont[ep:]
    #boundary修正
    lines = []
    line = " "
    p = 0
    while line!="" and p<len(patchesConts):
        #1行を取得
        [line, p, kind] = getFoamContents.get1lineMem(patchesConts, p)
        [patchName, pp] = getFoamContents.getKeywordMem(line, 0)
        n = patchName.find("_to_")
        if n > 0:
            #patch名をチェック修正
            tline = checkPatchName(patchName, line, selName, newName)
            line = tline
            #境界面のpatch内容を修正する
            keyword = " "
            pn = len(selName+"_to_")
            while keyword != "" and pp<len(line):
                #patch内容に旧のregion名があるか確認
                [keyword , pp] = getFoamContents.getKeywordMem(line, pp)
                if keyword == selName:
                    #旧region名を新に置き換え
                    newCont = line[:pp-1-len(selName)] + newName + line[pp-1:]
                    line = newCont
                elif keyword[:pn] == selName + "_to_":
                    #「旧region_to_xxxx」形式のregion名を新に置き換え
                    newKey = newName + "_to_" + keyword[pn:]
                    newCont = line[:pp-1-len(keyword)] + newKey + line[pp-1:]
                    line = newCont
                elif keyword[-pn:] == "_to_" + selName:
                    #「xxxx_to_旧region」形式のregion名を新に置き換え
                    newKey = keyword[:-pn] + "_to_" + newName
                    newCont = line[:pp-1-len(keyword)] + newKey + line[pp-1:]
                    line = newCont
            #1行を保存
            lines.append("    " + line)       
        else:
            #通常のpatchはそのまま保存
            lines.append("    " + line)
    #全内容を作成
    allCont = header + "\n" + "\n".join(lines) + "\n" + footer
    return allCont

#  checkPatchName
#    patch名を修正する
def checkPatchName(patchName, line, selName, newName):
    newLine = line
    n = len(selName+"_to_")
    if (patchName[:n] == selName+"_to_"):
        newLine = newName + "_to_" + line[n:]
    elif (patchName[-n:] == "_to_" + selName):
        newLine = patchName[:-n] + "_to_" + newName + line[len(patchName):]
    return newLine

#
#  renameRegionFolder
#    region名を変更する（folder名の変更のみ）
def renameRegionFolder(caseDir, selFolder, newFolder):
    global fluid, solid
    error = ""
    times = pyTreeFoam.getTimeFolders(caseDir)
    for time in times:
        timeDir = caseDir + "/" + time
        renameFolder(timeDir, selFolder, newFolder)
    constantDir = caseDir + "/constant"
    systemDir = caseDir + "/system"
    renameFolder(constantDir, selFolder, newFolder)
    renameFolder(systemDir, selFolder, newFolder)
    return error

def renameFolder(folderDir, selFolder, newFolder):
    selName = folderDir + "/" + selFolder
    newName = folderDir + "/" + newFolder
    comm = "mv -f " + selName + " " + newName
    os.system(comm)

#  deleteRegionProperties
#    regionPropertiesを削除
def deleteRegionProperties(caseDir):
    folderDir = caseDir + "/constant"
    fileName = "regionProperties"
    deleteFolder(folderDir, fileName)

#  renameBoundaryPatchType
#    削除したregionに関係するpatch名とpatchTypeを修正する
def renameBoundaryPatchType(caseDir, delRegion):
    regions = fluid + solid
    error = ""
    currTime = getFoamContents.getCurrTimeFolder(caseDir)
    for regName in regions:
        boundaryRelDir = getFoamContents.getCurrMeshDir(caseDir, currTime,
                        regName, "boundary")
        boundary = caseDir + "/" + boundaryRelDir + "/boundary"
        f=open(boundary); cont=f.read(); f.close()
        newCont = renameBoundaryPatchTypeMem(cont, delRegion)
        f=open(boundary, "w"); f.write(newCont); f.close()
    return error

def renameBoundaryPatchTypeMem(cont, delRegion):
    #boundaryの内容を取得
    p = getFoamContents.skipFoamFileMem(cont, 0)
    [patchesConts, p] = getFoamContents.getSmallPairMem(cont, p)
    #boundary以外（header、footer）を取得
    ep = p -1
    sp = ep - len(patchesConts)
    header = cont[:sp]
    footer = cont[ep:]
    #boundary修正
    lines = []
    line = " "
    p = 0
    while line!="" and p<len(patchesConts):
        #1行を取得
        [line, p, kind] = getFoamContents.get1lineMem(patchesConts, p)
        [patchName, pp] = getFoamContents.getKeywordMem(line, 0)
        n = patchName.find("_to_")
        if n > 0:
            #patchTypeをチェック修正
            tline = checkPatchType(patchName, line, delRegion)
            line = tline
            #1行を保存
            lines.append("    "+line)
        else:
            #通常の行はそのまま保存
            lines.append("    "+line)
    #全内容を作成
    allCont = header + "\n" + "\n".join(lines) + "\n" + footer
    return allCont

def checkPatchType(patchName, line, delRegion):
    newLine = line
    n = len("_to_"+delRegion)
    if (patchName[-n:] == "_to_" + delRegion):
        lines = []
        lines.append(patchName + "Del")
        lines.append("    {")
        lines.append("        type    patch;")
        conts = line.split("\n")[1:]
        for cont in conts:
            [keyword, p] = getFoamContents.getKeywordMem(cont, 0)
            if keyword == "nFaces" or keyword == "startFace":
                lines.append(cont)
        lines.append("    }")
        newLine = "\n".join(lines) + "\n"
    return newLine

#
#  deleteRegionFolder
#    regionを削除する
def deleteRegionFolder(caseDir, delRegion):
    global fluid, solid
    error = ""
    iniTime = pyTreeFoam.getTimeFolders(caseDir)[0]
    loc = getBoundaryLocation(caseDir, iniTime)
    iniTimeDir = caseDir + "/" + iniTime
    constantDir = caseDir + "/constant"
    systemDir = caseDir + "/system"
    deleteFolder(iniTimeDir, delRegion)
    deleteFolder(constantDir, delRegion)
    deleteFolder(systemDir, delRegion)
    return error

def deleteFolder(folderDir, delFolder):
    delName = folderDir + "/" + delFolder
    if len(glob.glob(delName)) != 0:
        obj = gio.File(delName.encode("utf-8"))
        obj.trash()

#
#  addRegionFolder
#    regionfolderを追加
def addRegionFolder(caseDir, newRegion, fluidSolid):
    error = ""
    iniTime = pyTreeFoam.getTimeFolders(caseDir)[0]
    loc = getBoundaryLocation(caseDir, iniTime)
    iniTimeDir = caseDir + "/" + iniTime
    constantDir = caseDir + "/" + loc
    systemDir = caseDir + "/system"
    addFolder(iniTimeDir, newRegion)
    copyFilesFluidSolid(iniTimeDir, newRegion, fluidSolid)
    addFolder(constantDir, newRegion)
    copyFilesFluidSolid(constantDir, newRegion, fluidSolid)
    addFolder(systemDir, newRegion)
    copyFilesFluidSolid(systemDir, newRegion, fluidSolid)
    polyMeshDir = caseDir + "/" + loc + "/" + newRegion
    addFolder(polyMeshDir, "polyMesh")
    createBoundaryFile(polyMeshDir)
    return error

def addFolder(folderDir, newFolder):
    comm = "mkdir " + folderDir + "/" + newFolder
    os.system(comm)

def copyFilesFluidSolid(folderDir, newFolder, fluidSolid):
    if fluidSolid == "fluid":
        copyFolder = folderDir + "/fluidRegions"
    else:
        copyFolder = folderDir + "/solidRegions"
    files = glob.glob(copyFolder+"/*")
    specNames = []
    #ファイルを配布
    for fileName in files:
        name = fileName.split("/")[-1]
        if len(name.split(".")) == 1:
            comm = "cp " + fileName + " " + folderDir + "/" + newFolder
            os.system(comm)
        else:
            specNames.append(fileName)
    #regName付きfileを配布
    for fileName in specNames:
        name = fileName.split("/")[-1]
        words = name.split(".")
        regName = words[1]
        if regName == newFolder:
            names = fileName.split("/")
            newName = folderDir + "/" + newFolder + "/" + words[0]
            comm = "cp " + fileName + " " + newName 
            os.system(comm)


def createBoundaryFile(polyMeshDir):
    fileName = polyMeshDir + "/polyMesh/boundary"
    comm = "touch " + fileName
    os.system(comm)

#
#  getBoundaryLocation
#    boundaryのlocationを返す
def getBoundaryLocation(caseDir, maxTime):
    regNames = fluid + solid
    #iniTime = pyTreeFoam.getTimeFolders(caseDir)[0]
    relPolyMeshDir = getFoamContents.getCurrMeshDir(caseDir, maxTime,
                        regNames[0], "boundary")
    loc = relPolyMeshDir.split("/")[-3]
    return loc

#
#  initialize
#    初期化
def initialize():
    global caseDir, fluid, solid
    regionProperties = caseDir + "/constant/regionProperties"
    if len(glob.glob(regionProperties)) > 0:
        [fluid, solid] = pyTreeFoam.getZonesInRegionProperties(caseDir)
    else:
        fluid = []
        solid = []



if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
