#!/usr/bin/env python
# -*- coding: UTF-8 -*-
# generated by wxGlade 0.6.7+ on Tue Sep 29 17:58:10 2015
#
#   cfMeshDialog.py
#
#       cfMeshDict作成、実行
#
#   15/09/29    新規作成
#      11/11    createFmsFile:cfMesh用のcsvファイルかどうかのエラーチェック追加
#   17/02/13    runCfMesh_sub:gnome-terminalのオプションを「-t」→「--name=」に変更。
#
#---------------code作成後の修正項目---------------------
#
#   ・アイコンのDirを書き直す（絶対path→相対path(./icons/***.png)）
#

import wx
import os
import sys
import glob
import csv
import pyTreeFoam
import getFoamContents
import setFoamContents
import getOpenFolderDDialog
import inputTextDDialog
import createCfMeshDict


# begin wxGlade: dependencies
import gettext
# end wxGlade

# begin wxGlade: extracode
# end wxGlade

helyxDataFile = "data/helyxOS_data"
caseDir = ""
stlDir = ""
surfaceAngle = ""
csvFileNames = []
csvFileName = ""
otherData = []
data = []



class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):

        savePath = os.getcwd()
        os.chdir(os.environ["TreeFoamPath"])

        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.bitmap_1 = wx.StaticBitmap(self, wx.ID_ANY, wx.Bitmap("./icons/editMesh.png", wx.BITMAP_TYPE_ANY))
        self.label_1 = wx.StaticText(self, wx.ID_ANY, _(u"cfMeshによるmesh作成"), style=wx.ALIGN_CENTRE)
        self.button_3 = wx.Button(self, wx.ID_ANY, _(u"開く"))
        self.text_ctrl_2 = wx.TextCtrl(self, wx.ID_ANY, "")
        self.button_8 = wx.Button(self, wx.ID_ANY, _(u"参照..."))
        self.button_2 = wx.Button(self, wx.ID_ANY, _(u"stlチェック..."))
        self.label_4 = wx.StaticText(self, wx.ID_ANY, _(u"stlのsolid名やscaleを変更する"))
        self.sizer_33_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"stlファイル"))
        self.combo_box_1 = wx.ComboBox(self, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.label_2 = wx.StaticText(self, wx.ID_ANY, _(u":編集・実行の対象となるcsvファイル名"))
        self.button_13 = wx.Button(self, wx.ID_ANY, _(u"csv作成..."))
        self.button_14 = wx.Button(self, wx.ID_ANY, _(u"csv編集"))
        self.button_15 = wx.Button(self, wx.ID_ANY, _(u"meshDict作成..."))
        self.button_10 = wx.Button(self, wx.ID_ANY, _(u"meshDict編集"))
        self.button_11 = wx.Button(self, wx.ID_ANY, _(u"cfMesh実行..."))
        self.button_16 = wx.Button(self, wx.ID_ANY, _(u"boundary整合..."))
        self.label_14 = wx.StaticText(self, wx.ID_ANY, _(u"csvファイルを作成・編集して、csvファイルからmeshDictを作り出す。 \ncsvファイルは、stlファイルと同じfolderに保存される。"))
        self.sizer_41_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"csvファイルによるmesh作成"))
        self.button_1 = wx.Button(self, wx.ID_ANY, _("checkMesh"))
        self.button_12 = wx.Button(self, wx.ID_ANY, _(u"paraFoam起動"))
        self.button_5 = wx.Button(self, wx.ID_ANY, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onOpenFolder, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onSetStlLocation, self.button_8)
        self.Bind(wx.EVT_BUTTON, self.onStlCheck, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onCreateCsv, self.button_13)
        self.Bind(wx.EVT_BUTTON, self.onOpenCaseFolder, self.button_14)
        self.Bind(wx.EVT_BUTTON, self.onCreateMeshDict, self.button_15)
        self.Bind(wx.EVT_BUTTON, self.onEditMeshDict, self.button_10)
        self.Bind(wx.EVT_BUTTON, self.onRunCfMesh, self.button_11)
        self.Bind(wx.EVT_BUTTON, self.onChangePatchName, self.button_16)
        self.Bind(wx.EVT_BUTTON, self.onCheckMesh, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onRunParaFoam, self.button_12)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_5)
        # end wxGlade

        os.chdir(savePath)
        self.SetTitle(_(u"cfMeshによるmesh作成"))
        self.setDataToTextBox()
        self.setCsvFileNamesToBox()        

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_("frame_1"))
        self.button_3.SetMinSize((40, 30))
        self.text_ctrl_2.SetMinSize((330, 28))
        self.button_8.SetMinSize((60, 30))
        self.button_2.SetMinSize((110, 30))
        self.combo_box_1.SetMinSize((220, 30))
        self.button_13.SetMinSize((110, 30))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_10 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_11 = wx.BoxSizer(wx.VERTICAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_41_staticbox.Lower()
        sizer_41 = wx.StaticBoxSizer(self.sizer_41_staticbox, wx.VERTICAL)
        sizer_43 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_42 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_33_staticbox.Lower()
        sizer_33 = wx.StaticBoxSizer(self.sizer_33_staticbox, wx.VERTICAL)
        sizer_12 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_34 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_35 = wx.BoxSizer(wx.VERTICAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2.Add(self.bitmap_1, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_2.Add(self.label_1, 0, wx.ALL | wx.ALIGN_CENTER_VERTICAL, 10)
        sizer_1.Add(sizer_2, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_34.Add(self.button_3, 0, wx.LEFT | wx.ALIGN_BOTTOM, 20)
        sizer_35.Add(self.text_ctrl_2, 0, wx.EXPAND | wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_34.Add(sizer_35, 1, wx.EXPAND, 0)
        sizer_34.Add(self.button_8, 0, wx.LEFT | wx.RIGHT, 0)
        sizer_33.Add(sizer_34, 0, wx.EXPAND, 0)
        sizer_12.Add(self.button_2, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_12.Add(self.label_4, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_33.Add(sizer_12, 1, wx.EXPAND, 0)
        sizer_33.Add((20, 5), 0, 0, 0)
        sizer_1.Add(sizer_33, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_3.Add(self.combo_box_1, 0, wx.LEFT, 20)
        sizer_3.Add(self.label_2, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_41.Add(sizer_3, 1, wx.EXPAND, 0)
        sizer_42.Add(self.button_13, 0, wx.LEFT, 20)
        sizer_42.Add(self.button_14, 0, wx.LEFT, 20)
        sizer_42.Add(self.button_15, 0, wx.LEFT, 10)
        sizer_41.Add(sizer_42, 1, wx.EXPAND, 0)
        sizer_43.Add((130, 20), 0, 0, 0)
        sizer_43.Add(self.button_10, 0, wx.LEFT, 20)
        sizer_43.Add(self.button_11, 0, wx.LEFT, 10)
        sizer_43.Add(self.button_16, 0, wx.LEFT, 10)
        sizer_41.Add(sizer_43, 0, wx.EXPAND, 0)
        sizer_41.Add(self.label_14, 0, wx.LEFT, 40)
        sizer_1.Add(sizer_41, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_11.Add((20, 10), 0, 0, 0)
        sizer_6.Add(self.button_1, 0, wx.RIGHT, 5)
        sizer_6.Add(self.button_12, 0, wx.RIGHT | wx.BOTTOM, 20)
        sizer_6.Add(self.button_5, 0, wx.RIGHT | wx.BOTTOM | wx.ALIGN_RIGHT | wx.ALIGN_BOTTOM, 20)
        sizer_11.Add(sizer_6, 1, wx.ALIGN_RIGHT, 0)
        sizer_10.Add(sizer_11, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_10, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #開く
    def onOpenFolder(self, event):  # wxGlade: MyFrame.<event_handler>
        self.openStlFolder()

    #stl場所参照
    def onSetStlLocation(self, event):  # wxGlade: MyFrame.<event_handler>
        self.getStlDir()

    #stlファイルチェック
    def onStlCheck(self, event):  # wxGlade: MyFrame.<event_handler>
        self.stlCheck()

    #csvファイル作成
    def onCreateCsv(self, event):  # wxGlade: MyFrame.<event_handler>
        self.createCsvFile()
        self.openCaseFolder()

    #csvファイル編集
    def onOpenCaseFolder(self, event):  # wxGlade: MyFrame.<event_handler>
        self.openCaseFolder()

    #meshDict作成
    def onCreateMeshDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.createMeshDict()

    #meshDict編集
    def onEditMeshDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.editMeshDict()

    #cfMesh実行
    def onRunCfMesh(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runOnlyCfMesh()

    #boundaryの整合
    def onChangePatchName(self, event):  # wxGlade: MyFrame.<event_handler>
        self.changePatchName()

    #checkMesh実行
    def onCheckMesh(self, event):  # wxGlade: MyFrame.<event_handler>
        self.checkMesh()

    #paraFoam実行
    def onRunParaFoam(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runParaFoam()

    #閉じる
    def onClose(self, event):  # wxGlade: MyFrame.<event_handler>
        self.Destroy()

# end of class MyFrame

    #
    #  openStlFolder
    #    stlFolderを開く
    def openStlFolder(self):
        global caseDir, stlDir
        if len(glob.glob(stlDir)) == 0:
            mess = _(u"設定したfolderは存在しません。\nstlファイルの場所を再設定してください。")
            self.errDialog(_(u"エラー"), mess)
            return
        pyTreeFoam.openFolderNautilus(stlDir)

    #  setDataToTextBox
    #    textBoxにdataをセット
    def setDataToTextBox(self):
        global caseDir, stlDir, surfaceAngle
        [stlDir, surfaceAngle, clearMesh] = getHelyxosData(caseDir)
        self.text_ctrl_2.SetValue(stlDir)

    #  setCsvFilNamesToBox
    #    csvファイル名をcomboBoxにセット
    def setCsvFileNamesToBox(self):
        global csvFileNames
        csvFileNames = getCsvFileNames(stlDir)
        self.combo_box_1.Clear()
        self.combo_box_1.AppendItems(csvFileNames)

    #
    #  getStlDir
    #    stlDirの取得
    def getStlDir(self):
        global stlDir, caseDir
        rootDir = os.environ["HOME"].encode("utf-8")
        title = _(u"開く")
        message = _(u"folderを選択する")
        stlAbsDir = getAbsPath(stlDir)
        [stat, ansDir] = getOpenFolderDDialog.Show(title, message, rootDir, caseDir, stlAbsDir)
        if stat == "OK":
            stlDir = ansDir
            self.text_ctrl_2.SetValue(stlDir)
            self.setCsvFileNamesToBox()
            saveStlDir(caseDir, stlDir)

    #  setCsvFilNamesToBox
    #    csvファイル名をcomboBoxにセット
    def setCsvFileNamesToBox(self):
        global csvFileNames
        csvFileNames = getCsvFileNames(stlDir)
        self.combo_box_1.Clear()
        self.combo_box_1.AppendItems(csvFileNames)

    #
    #  stlCheck
    #    stlファイルのsolid名をチェック
    def stlCheck(self):
        global stlDir, caseDir
        wdir = self.text_ctrl_2.GetValue()
        stlDir = getAbsPath(wdir)
        comm = "editStlFilesDialog.py " + caseDir + " " + stlDir + " &"
        os.system(comm)

    #
    #  createCsvFile
    #    blockMesh, snappyHexMeshDict作成用のcsvファイル作成
    def createCsvFile(self):
        global csvFileName, csvFileNames
        #file名の取得
        inputTextDDialog.title = _(u"ファイル名の入力")
        inputTextDDialog.message = _(u"csvファイル名を入力してください。")
        inputTextDDialog.inputText = "cfMeshDict.csv"
        dialog = inputTextDDialog.MyDialog(None)
        result = dialog.ShowModal()
        if inputTextDDialog.status == "OK":
            text = inputTextDDialog.inputText
        else:
            text = u""
        if text != u"":
            csvFileName = text
            #stlDirのチェック
            #stlDirAbs = getAbsPath(stlDir)
            stlDirAbs = stlDir
            #csvファイル作成
            error = createCfMeshDict.createCsvFile(caseDir, stlDirAbs,
                        csvFileName)
            if error != 0:
                title = _(u"エラー")
                mess = _(u"エラーが発生しました。\nlogを確認してください。")
                self.errDialog(title, mess)
                return

            title = _(u"csvファイル作成")
            mess = _(u"cfMeshDict作成用のcsvファイルをstlDir内に作成しました。\n")
            mess += _(u"office等でcsvファイルを編集し、cellSize等を設定してください。")
            self.okDialog(title, mess)
            self.setCsvFileNamesToBox()
            self.combo_box_1.SetStringSelection(csvFileName)
        return

    #
    #  openCaseFolder
    #    csv fileを編集する
    def openCaseFolder(self):
        global csvFileName, caseDir, stlDir
        stlAbsDir = stlDir
        if stlAbsDir[0] != "/":
            stlAbsDir = caseDir + "/" + stlAbsDir
        office = ""
        pathes = os.environ["PATH"].split(":")
        for path in pathes:
            name = glob.glob(path + "/loffice")
            if len(name) != 0:
                office = "loffice"
                break
            name = glob.glob(path + "/ooffice")
            if len(name) != 0:
                office = "ooffice"
                break
        if office == "":
            pyTreeFoam.openFolderNautilus(stlAbsDir)
        else:
            fileName = self.combo_box_1.GetStringSelection()
            if fileName == "":
                title = _(u"csvファイル編集")
                mess = _(u"csvファイルが選択されていません。\n")
                mess += _(u"編集するcsvファイルを選択してください。")
                self.errDialog(title, mess)
                return
            else:
                csvFileName = stlAbsDir + "/" + fileName
                comm = office + " " + csvFileName + "&"
                os.system(comm)

    #
    #  createMeshDict
    #    meshDict作成とcfMesh実行
    def createMeshDict(self):
        global caseDir
        meshDict = caseDir + "/system/meshDict"
        mess = u""
        title = _(u"cfMesh実行")
        if len(glob.glob(meshDict)) == 0:
            createDefaultMeshDict(caseDir)
            mess += _(u"「meshDict」ファイルがsystemフォルダ内に存在しない為、defaultのmeshDictを作成しました\n\n")
        #実行の確認
        mess += _(u"csvファイルから、cfMesh用のmeshDictを作り出します。")
        stat = self.okCancelDialog(title, mess)
        if stat != "OK":
            return
        #mesh作成
        self.runCfMesh_sub()

    #
    #  runCfMesh_sub
    #    cfMesh実行
    def runCfMesh_sub(self):
        #fmsファイル作成、meshDict作成
        csvFileName = self.combo_box_1.GetStringSelection()
        error = createFmsFile(stlDir, csvFileName)
        if error != "":
            title = _(u"エラー")
            self.errDialog(title, error)
            return

        title = _(u"meshDict作成")
        mess = _(u"meshDictを作成しました")
        mess += _(u"\n\n引き続き、cartesianMeshを実行して、meshを作成しますか？")
        stat = self.okCancelDialog(title, mess)
        if stat != "OK":
            return

        #mesh作成
        caseName = caseDir.split("/")[-1]
        config = pyTreeFoam.readConfigTreeFoam()
        envOpenFOAM = config[1]
        saveDir = os.getcwd()
        os.chdir(caseDir)
        cont  = "#!/bin/bash\n"
        cont += "runCfMeshClearBoundary.py " + caseDir
        comm = "echo " + "'" + cont + "'" + " > run"
        os.system(comm)
        os.system("chmod a+x run")
        comm = "gnome-terminal --name=" + caseName + " --geometry=120x20 --zoom=0.9 -x bash --rcfile run"
        os.system(comm)
        os.chdir(saveDir)
 
    #
    #  editMeshDict
    #    meshDictの編集
    def editMeshDict(self):
        fileName = caseDir + "/system/meshDict"
        pyTreeFoam.runEditor(fileName)

    #
    #  runOnlyCfMesh
    #    mesh作成
    def runOnlyCfMesh(self):
        caseName = caseDir.split("/")[-1]
        config = pyTreeFoam.readConfigTreeFoam()
        envOpenFOAM = config[1]
        saveDir = os.getcwd()
        os.chdir(caseDir)
        cont  = "#!/bin/bash\n"
        cont += ". " + envOpenFOAM + "\n"
        cont += "cartesianMesh | tee solve.log\n"
        comm = "echo " + "'" + cont + "'" + " > run"
        os.system(comm)
        os.system("chmod a+x run")
        comm = "gnome-terminal -t " + caseName + " --geometry=120x20 --zoom=0.9 -x bash --rcfile run"
        os.system(comm)
        os.chdir(saveDir)

    #
    #  changePatchName
    #    patch名の修正
    def changePatchName(self):
        title = _(u"boundary整合")
        mess = _(u"boundaryと各boundaryFieldの整合をとります。")
        mess += _(u"\n(boundaryの整合と空patchの削除)")
        stat = self.okCancelDialog(title, mess)
        if stat != "OK":
            return

        currTime = getFoamContents.getCurrTimeFolder(caseDir)
        relPolyMeshDir = getFoamContents.getCurrMeshDir(caseDir, currTime, ".",
                "boundary")
        polyMeshDir = caseDir + "/" + relPolyMeshDir
        fieldDir = caseDir + "/" + currTime
        setFoamContents.clearNullBoundaryAllFields(fieldDir, polyMeshDir)
        mess = _(u"boundaryの整合を取りました。")
        self.okDialog(title, mess)

    #
    #  checkMesh
    #    checkMeshの実行
    def checkMesh(self):
        caseName = caseDir.split("/")[-1]
        cont  = "#!/bin/bash\n"
        cont += "checkMesh | tee solve.log\n"
        comm = "echo " + "'" + cont + "'" + " > run"
        os.system(comm)
        os.system("chmod a+x run")
        comm = "gnome-terminal -t " + caseName + " --geometry=120x20 --zoom=0.9 -x bash --rcfile run"
        #os.system(comm)
        pyTreeFoam.runOFUtility(comm)

    #
    #  runParaFoam
    #    paraFoamの起動
    def runParaFoam(self):
        config = pyTreeFoam.readConfigTreeFoam()
        paraFoamFix = config[4]
        comm = "runParaFoamOptionDialog.py " + paraFoamFix + " " + caseDir + " &"
        pyTreeFoam.runCommand(comm.encode("utf-8"))


    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def yesNoDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.YES | wx.NO | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        stat = ""
        if ans == wx.ID_YES:
            stat = "YES"
        else:
            stat = "NO"
        return stat

    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        stat = ""
        if ans == wx.ID_OK:
            stat = "OK"
        else:
            stat = "CANCEL"
        return stat




#
#  getHelyxosData
#    HelyxOSのデータ取得
def getHelyxosData(caseDir):
    global helyxDataFile, stlDir, surfaceAngle
    helyxData = helyxDataFile.split("/")[-1]
    fileNameCase = caseDir + "/" + helyxData
    fileNameTr = os.environ["TreeFoamUserPath"] + "/" + helyxDataFile
    if len(glob.glob(fileNameCase)) == 1:
        fileName = fileNameCase
    elif len(glob.glob(fileNameTr)) == 1:
        fileName = fileNameTr
    else:
        fileName = fileNameTr
        stlDir = "./model"
        surfaceAngle = "150"
        clearMesh = "yes"
        contents = "stlDir   " + stlDir + "\n"
        contents+= "surfaceAngle    " + surfaceAngle + "\n"
        contents+= "clearMesh    yes\n"
        f=open(fileName, "w")
        f.write(contents)
        f.close()

    f=open(fileName)
    contents = f.readlines()
    f.close()
    for line in contents:
        comm = line.split()
        if len(comm) > 1:
            if comm[0] == "stlDir":
                stlDir = comm[1]
            elif comm[0] == "surfaceAngle":
                surfaceAngle = comm[1]
            elif comm[0] == "clearMesh":
                clearMesh = comm[1]
    return [stlDir, surfaceAngle, clearMesh]

#  saveStlDir
#    stlDirをHelyxos_dataに保存する。
def saveStlDir(caseDir, modelDir):
    helyxData = helyxDataFile.split("/")[-1]
    fileNameCase = caseDir + "/" + helyxData
    fileNameTr = os.environ["TreeFoamUserPath"] + "/" + helyxDataFile
    if len(glob.glob(fileNameCase)) == 0:
        comm = "cp " + fileNameTr + " " + caseDir
        os.system(comm)
    fileName = fileNameCase
    f=open(fileName); cont=f.readlines(); f.close()
    i = 0
    while i < len(cont):
        line = cont[i]
        comm = line.split()
        if comm[0] == "stlDir":
            cont[i] = comm[0] + " " + modelDir + "\n"
            break            
        i += 1
    f=open(fileName, "w")
    for line in cont:
        f.write(line)
    f.close()

#
#  createDefaultMeshDict
#    defaultのmeshDictを作成する
def createDefaultMeshDict(caseDir):
    TreeFoamPath = os.getenv("TreeFoamPath")
    cfMeshFolders = glob.glob(TreeFoamPath + "/data/cfMesh/*")
    cfMeshFolders.sort()
    latestFolder = cfMeshFolders[-1]
    comm = "cp " + latestFolder + "/meshDict " + caseDir + "/system"
    os.system(comm)

#
#  createFmsFile
#    fmsファイル作成
def createFmsFile(stlDir, csvFileName):
    fileName = stlDir + "/" + csvFileName
    [otherData, data, keyword] = readCsvData(fileName)
    #エラーチェック
    flag = 0
    for word in keyword:
        if word == "cfMesh":
            flag = 1
            break
    if flag == 0:
        error = _(u"選択しているcsvファイルは、cfMesh用ではありません。")
        error += _(u"\n「csv編集」ボタンで、ファイル内容を確認してください。")
        return error

    stlFiles = []
    for line in data:
        if (line[1] == "wall" or line[1] == "patch" or line[1] == "empty" or
            line[1] == "symmetry" or line[1] == "symmetryPlane"):
            stlFiles.append(stlDir + "/" + line[0] + ".stl")
    #solid名を各ファイルに設定
    error = setSolidNameInStlFile(stlFiles)
    if error != "":
        return error

    print _(u"stlファイルにsolid名を追加しました。")
    #stlFileを結合
    mergeName = stlDir + "/assy.stl"
    if len(glob.glob(mergeName)) != 0:
        comm = "rm -rf " + mergeName
        os.system(comm)
    error = mergeStlFiles(stlFiles, mergeName)
    if error != "":
        return error

    print _(u"stlファイルを結合して、assy.stlを作成しました。")
    #fmsファイル作成
    angle = otherData[2]
    surfaceFile = "model.fms"
    comm = "surfaceFeatureEdges -angle " + angle + " " + mergeName + " " + stlDir + "/" + surfaceFile
    print comm
    results = pyTreeFoam.runOFUtilityReturnStat(comm)
    if results[0] != "OK":
        error = _(u"特徴線が抽出出来ませんでした。")
        error += _(u"\nlogを確認してください。")
        return error

    print _(u"assy.stlから特徴線を抽出し、model.fmsファイルを作成しました。")
    #meshDic作成
    createCfMeshDict.createMeshDict(caseDir, stlDir, surfaceFile, otherData, data)
    return ""



#
#  setSolidNameInStlFile
#    各stlファイルにsolid名をセット
def setSolidNameInStlFile(stlFiles):
    error = ""
    flag = 0
    for stlName in stlFiles:
        #flag = 0
        fileName = stlName
        solidName = stlName.split("/")[-1][:-4]
        f=open(fileName); lines=f.readlines(); f.close()
        words = lines[0].split()
        oldName = ""
        if len(words)>1:
            oldName = words[1]
        lines[0] = "solid " + solidName + "\n"
        i = len(lines) - 1
        while i> 0:
            words = lines[i].split()
            if words[0] == "endsolid":
                endName = ""
                if len(words) > 1:
                    endName = words[1]
                break
            i -= 1
        if oldName == endName:
            #solid名をセット
            lines[0] = "solid " + solidName + "\n"
            lines[i] = "endsolid " + solidName + "\n"
            f=open(fileName, "w")
            for line in lines:
                f.write(line)
            f.close()
        else:
            #solid名セットできず
            flag += 1
    if flag != 0:
        error = str(flag) + _(u" ヶのファイルでsolid名がセットできていません。")
        error += _(u"\nstlファイルの書式を確認してください。")
    return error

#
#  mergeStlFiles
#    stlファイルを結合
def mergeStlFiles(stlNames, mergeName):
    error = ""
    fa = open(mergeName, "a")
    for stlName in stlNames:
        readName = stlName
        f=open(readName); cont=f.read(); f.close()
        if cont[-1] != "\n":
            cont += "\n"
        fa.write(cont)
    fa.close()
    return error


#
#  readCsvData
#    csvデータの読込
def readCsvData(fileName):
    global otherData, data
    if os.path.isfile(fileName) == False:
        return [[],[],[]]

    #tab区切りorカンマ区切りのチェックの為、1行読込
    f=open(fileName); line=f.readline(); f.close()
    if len(line.split("\t")) != 1:
        #tab区切り
        f=open(fileName); tabCont=f.readlines(); f.close()
        contents = []
        for line in tabCont:
            contents.append(",".join(line.split("\t")))
        cont = csv.reader(contents)
    else:
        #カンマ区切り
        cont = csv.reader(file(fileName))
    #データの読込
    otherData = []
    data = []
    keyword = []
    readStl = 0
    maxCellSize = ""
    minCellSize = ""
    featureAngle = ""
    for row in cont:
        flag = 0
        for val in row:
            if val != "":
                flag = 1
                break
        if flag == 1:
            if row[1] == "maxCellSize":
                maxCellSize = row[2]
            elif row[1] == "minCellSize":
                minCellSize = row[2]
            elif row[1] == "featureAngle":
                featureAngle = row[2]
            elif row[0] == "stlFile":
                readStl = 1
            else:
                if readStl == 1:
                    data.append(row)
                elif len(row[0]) > 1:
                    if row[0][0] == "<":
                        word = row[0][1:].split(">")
                        if word[0] != "":
                            keyword.append(word[0])
    otherData = [maxCellSize, minCellSize, featureAngle]
    return [otherData, data, keyword]

#
#  getCsvFileNames
#    csvファイルを取得し、返す
def getCsvFileNames(csvDir):
    files = glob.glob(csvDir + "/*.csv")
    names = []
    for name in files:
        names.append(name.split("/")[-1])
    names.sort()
    return names

#
#  getAbsPath
#    相対pathを絶対pathに変換する
def getAbsPath(wdir):
    if len(wdir) == 0:
        return wdir
    if wdir[0] != "/":
        paPath = os.getcwd()
        wdir = paPath + "/" + wdir
    wdir = os.path.abspath(wdir)
    return wdir



if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    caseDir = sys.argv[1]
    stlDir = sys.argv[2]
    caseDir = getAbsPath(caseDir)
    stlDir = getAbsPath(stlDir)

    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, wx.ID_ANY, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
