#!/usr/bin/env python
# -*- coding: UTF-8 -*-
#
#       changeConfigTreeFoamDialog.py
#
#       configTreeFoamの修正用dialog
#       wxGladeの出力そのままで修正不要
#
#   12/05.20    新規作成
#   12/09/12    OpenFOAMのバージョンセットを追加
#   13/04/30    バグ修正（helyxOSの変更ができていなかった。）
#      10/09    言語の設定を追加
#      12/21    logFile項目追加
#               stdout、stderrの設定（import logFileCreater）を追加
#      12/22    バグ修正（未設定項目が書き込めない）
#   14/07/12    dialogをframeに変更（TreeFoamが「segmentation fault」発生する為）
#   15/07/17    dialog起動方法を修正
#      07/23    dialogを作り直し
#               　fileの編集とappフォルダ内容をcomboBoxの候補に設定
#      07/25    setSelectDataToComboBoxes:バグ修正
#      07/26    ボタンを追加（setDefaultContents）
#   16/06/02    onSet:OFversionの書き込み追加。
#


# generated by wxGlade 0.6.7+ on Wed Jul 22 18:42:25 2015
#

import wx
import os
import sys
import glob
import pyTreeFoam

import logFileCreater; logFileCreater.log()


# begin wxGlade: dependencies
import gettext
# end wxGlade

# begin wxGlade: extracode
# end wxGlade


configFile = ""
language_old = ""
logFile_old = ""
configData = []
langs = ["Japanese", "English"]
logs = ["yes", "no"]
bashrcs = []
helyxes = []
paras = []
salomes = []
cads = []
editors = []



class MyDialog(wx.Dialog):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyDialog.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE | wx.RESIZE_BORDER | wx.THICK_FRAME
        wx.Dialog.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, wx.ID_ANY, _(u"TreeFoam設定変更"))
        self.label_12 = wx.StaticText(self, wx.ID_ANY, _(u"TreeFoamの設定を変更します。\n変更内容は、「$TreeFoamUserPath/configTreeFoam」の内容も変更されます。"))
        self.static_line_1 = wx.StaticLine(self, wx.ID_ANY)
        self.label_15 = wx.StaticText(self, wx.ID_ANY, _("language"))
        self.combo_box_lang = wx.ComboBox(self, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.label_16 = wx.StaticText(self, wx.ID_ANY, _(u"言語の設定"))
        self.label_17 = wx.StaticText(self, wx.ID_ANY, _("logFile"))
        self.combo_box_log = wx.ComboBox(self, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.label_18 = wx.StaticText(self, wx.ID_ANY, _(u"logFileの作成"))
        self.button_1 = wx.Button(self, wx.ID_ANY, _("bashrc-FOAM*"))
        self.combo_box_bash = wx.ComboBox(self, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.label_3 = wx.StaticText(self, wx.ID_ANY, _(u"OpenFOAM環境設定ファイル"))
        self.button_4 = wx.Button(self, wx.ID_ANY, _("runHelyxos*"))
        self.combo_box_helyx = wx.ComboBox(self, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.label_14 = wx.StaticText(self, wx.ID_ANY, _(u"HelyxOS起動ファイル"))
        self.button_5 = wx.Button(self, wx.ID_ANY, _("runParaFoam*"))
        self.combo_box_para = wx.ComboBox(self, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.label_5 = wx.StaticText(self, wx.ID_ANY, _(u"paraFoamの起動ファイル"))
        self.button_6 = wx.Button(self, wx.ID_ANY, _("runSalomeMeca*"))
        self.combo_box_salome = wx.ComboBox(self, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.label_7 = wx.StaticText(self, wx.ID_ANY, _(u"SalomeMecaの起動ファイル"))
        self.button_7 = wx.Button(self, wx.ID_ANY, _("runCAD*"))
        self.combo_box_cad = wx.ComboBox(self, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.label_9 = wx.StaticText(self, wx.ID_ANY, _(u"CADの起動ファイル"))
        self.button_8 = wx.Button(self, wx.ID_ANY, _("runEditor*"))
        self.combo_box_editor = wx.ComboBox(self, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.label_11 = wx.StaticText(self, wx.ID_ANY, _(u"editorの起動ファイル"))
        self.button_11 = wx.Button(self, wx.ID_ANY, _("configTreeFoam"))
        self.button_9 = wx.Button(self, wx.ID_ANY, _(u"$TreeFoamUserPath/appフォルダ開く"))
        self.button_10 = wx.Button(self, wx.ID_ANY, _(u"フォルダ内を再読込"))
        self.button_12 = wx.Button(self, wx.ID_ANY, _(u"defaultの設定に戻す"))
        self.static_line_2 = wx.StaticLine(self, wx.ID_ANY)
        self.button_3 = wx.Button(self, wx.ID_ANY, _(u"設定"))
        self.button_2 = wx.Button(self, wx.ID_ANY, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onEditBashrcFoam, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onEditRunHelyxos, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onEditRunParaFoam, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.onEditRunSalomeMeca, self.button_6)
        self.Bind(wx.EVT_BUTTON, self.onEditRunCAD, self.button_7)
        self.Bind(wx.EVT_BUTTON, self.onEditRunEditor, self.button_8)
        self.Bind(wx.EVT_BUTTON, self.onEditConfigTreeFoam, self.button_11)
        self.Bind(wx.EVT_BUTTON, self.onOpenAppFolder, self.button_9)
        self.Bind(wx.EVT_BUTTON, self.onReloadFolder, self.button_10)
        self.Bind(wx.EVT_BUTTON, self.onSetDefaultContents, self.button_12)
        self.Bind(wx.EVT_BUTTON, self.onSet, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onCancel, self.button_2)
        # end wxGlade

        self.setDataToComboBoxes()
        self.setSelectDataToComboBoxes()


    def __set_properties(self):
        # begin wxGlade: MyDialog.__set_properties
        self.SetTitle(_(u"TreeFoanの設定変更"))
        self.label_15.SetMinSize((110, 18))
        self.combo_box_lang.SetMinSize((400, 30))
        self.label_16.SetMinSize((200, 18))
        self.label_17.SetMinSize((110, 18))
        self.combo_box_log.SetMinSize((400, 30))
        self.label_18.SetMinSize((200, 18))
        self.button_1.SetMinSize((110, 30))
        self.button_1.SetToolTipString(_(u"選択しているファイルを編集する"))
        self.combo_box_bash.SetMinSize((400, 30))
        self.label_3.SetMinSize((200, 18))
        self.button_4.SetMinSize((110, 30))
        self.button_4.SetToolTipString(_(u"選択しているファイルを編集する"))
        self.combo_box_helyx.SetMinSize((400, 30))
        self.label_14.SetMinSize((200, 18))
        self.button_5.SetMinSize((110, 30))
        self.button_5.SetToolTipString(_(u"選択しているファイルを編集する"))
        self.combo_box_para.SetMinSize((400, 30))
        self.label_5.SetMinSize((200, 18))
        self.button_6.SetMinSize((110, 30))
        self.button_6.SetToolTipString(_(u"選択しているファイルを編集する"))
        self.combo_box_salome.SetMinSize((400, 30))
        self.label_7.SetMinSize((200, 18))
        self.button_7.SetMinSize((110, 30))
        self.button_7.SetToolTipString(_(u"選択しているファイルを編集する"))
        self.combo_box_cad.SetMinSize((400, 30))
        self.label_9.SetMinSize((200, 18))
        self.button_8.SetMinSize((110, 30))
        self.button_8.SetToolTipString(_(u"選択しているファイルを編集する"))
        self.combo_box_editor.SetMinSize((400, 30))
        self.label_11.SetMinSize((200, 18))
        self.button_11.SetMinSize((110, 30))
        self.button_11.SetToolTipString(_(u"configTreeFoamをeditorで開く"))
        self.button_9.SetToolTipString(_(u"ファイルを追加、削除、renameする時に使用する"))
        self.button_10.SetToolTipString(_(u"ファイルを追加、削除、renameした内容を再読込する"))
        self.button_12.SetToolTipString(_(u"configTreeFoamをdefaultの状態に戻します"))
        # end wxGlade
        self.SetTitle(_(u"TreeFoamの設定変更"))


    def __do_layout(self):
        # begin wxGlade: MyDialog.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_12 = wx.BoxSizer(wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_21 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_10 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_11 = wx.BoxSizer(wx.VERTICAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_9 = wx.BoxSizer(wx.VERTICAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7 = wx.BoxSizer(wx.VERTICAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_5 = wx.BoxSizer(wx.VERTICAL)
        sizer_15 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_16 = wx.BoxSizer(wx.VERTICAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3 = wx.BoxSizer(wx.VERTICAL)
        sizer_19 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_20 = wx.BoxSizer(wx.VERTICAL)
        sizer_17 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_18 = wx.BoxSizer(wx.VERTICAL)
        sizer_14 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.label_1, 0, wx.ALL | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_14.Add((50, 20), 0, 0, 0)
        sizer_14.Add(self.label_12, 0, wx.LEFT | wx.BOTTOM, 5)
        sizer_1.Add(sizer_14, 1, wx.EXPAND, 0)
        sizer_1.Add(self.static_line_1, 0, wx.ALL | wx.EXPAND, 5)
        sizer_17.Add((10, 20), 0, 0, 0)
        sizer_17.Add(self.label_15, 0, wx.ALL, 5)
        sizer_18.Add(self.combo_box_lang, 0, wx.EXPAND, 0)
        sizer_17.Add(sizer_18, 1, wx.EXPAND, 0)
        sizer_17.Add(self.label_16, 0, wx.ALL, 5)
        sizer_1.Add(sizer_17, 1, wx.EXPAND, 0)
        sizer_19.Add((10, 20), 0, 0, 0)
        sizer_19.Add(self.label_17, 0, wx.ALL, 5)
        sizer_20.Add(self.combo_box_log, 0, wx.EXPAND, 0)
        sizer_19.Add(sizer_20, 1, wx.EXPAND, 0)
        sizer_19.Add(self.label_18, 0, wx.ALL, 5)
        sizer_1.Add(sizer_19, 1, wx.EXPAND, 0)
        sizer_2.Add((10, 20), 0, 0, 0)
        sizer_2.Add(self.button_1, 0, wx.LEFT | wx.RIGHT, 5)
        sizer_3.Add(self.combo_box_bash, 0, wx.EXPAND, 0)
        sizer_2.Add(sizer_3, 1, wx.EXPAND, 0)
        sizer_2.Add(self.label_3, 0, wx.ALL, 5)
        sizer_1.Add(sizer_2, 1, wx.EXPAND, 0)
        sizer_15.Add((10, 20), 0, 0, 0)
        sizer_15.Add(self.button_4, 0, wx.LEFT | wx.RIGHT, 5)
        sizer_16.Add(self.combo_box_helyx, 0, wx.EXPAND, 0)
        sizer_15.Add(sizer_16, 1, wx.EXPAND, 0)
        sizer_15.Add(self.label_14, 0, wx.ALL, 5)
        sizer_1.Add(sizer_15, 1, wx.EXPAND, 0)
        sizer_4.Add((10, 20), 0, 0, 0)
        sizer_4.Add(self.button_5, 0, wx.LEFT | wx.RIGHT, 5)
        sizer_5.Add(self.combo_box_para, 0, wx.EXPAND, 0)
        sizer_4.Add(sizer_5, 1, wx.EXPAND, 0)
        sizer_4.Add(self.label_5, 0, wx.ALL, 5)
        sizer_1.Add(sizer_4, 1, wx.EXPAND, 0)
        sizer_6.Add((10, 20), 0, 0, 0)
        sizer_6.Add(self.button_6, 0, wx.LEFT | wx.RIGHT, 5)
        sizer_7.Add(self.combo_box_salome, 0, wx.EXPAND, 0)
        sizer_6.Add(sizer_7, 1, wx.EXPAND, 0)
        sizer_6.Add(self.label_7, 0, wx.ALL, 5)
        sizer_1.Add(sizer_6, 1, wx.EXPAND, 0)
        sizer_8.Add((10, 20), 0, 0, 0)
        sizer_8.Add(self.button_7, 0, wx.LEFT | wx.RIGHT, 5)
        sizer_9.Add(self.combo_box_cad, 0, wx.EXPAND, 0)
        sizer_8.Add(sizer_9, 1, wx.EXPAND, 0)
        sizer_8.Add(self.label_9, 0, wx.ALL, 5)
        sizer_1.Add(sizer_8, 1, wx.EXPAND, 0)
        sizer_10.Add((10, 20), 0, 0, 0)
        sizer_10.Add(self.button_8, 0, wx.LEFT | wx.RIGHT, 5)
        sizer_11.Add(self.combo_box_editor, 0, wx.EXPAND, 0)
        sizer_10.Add(sizer_11, 1, wx.EXPAND, 0)
        sizer_10.Add(self.label_11, 0, wx.ALL, 5)
        sizer_1.Add(sizer_10, 1, wx.EXPAND, 0)
        sizer_21.Add((10, 20), 0, 0, 0)
        sizer_21.Add(self.button_11, 0, wx.LEFT | wx.RIGHT, 5)
        sizer_21.Add(self.button_9, 0, wx.LEFT | wx.RIGHT, 5)
        sizer_21.Add(self.button_10, 0, wx.LEFT | wx.RIGHT, 5)
        sizer_21.Add(self.button_12, 0, wx.LEFT, 20)
        sizer_1.Add(sizer_21, 1, wx.EXPAND, 0)
        sizer_1.Add(self.static_line_2, 0, wx.ALL | wx.EXPAND, 5)
        sizer_1.Add((20, 10), 0, 0, 0)
        sizer_13.Add(self.button_3, 0, wx.LEFT | wx.RIGHT, 20)
        sizer_13.Add(self.button_2, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM, 10)
        sizer_12.Add(sizer_13, 1, wx.ALIGN_RIGHT, 0)
        sizer_1.Add(sizer_12, 1, wx.EXPAND | wx.ALIGN_RIGHT, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #bashrcFoamの編集
    def onEditBashrcFoam(self, event):  # wxGlade: MyDialog.<event_handler>
        self.editBashrcFoam(event)

    #runHelyxosの編集
    def onEditRunHelyxos(self, event):  # wxGlade: MyDialog.<event_handler>
        self.editRunHelyxos(event)

    #runParaFoamの編集
    def onEditRunParaFoam(self, event):  # wxGlade: MyDialog.<event_handler>
        self.editRunParaFoam(event)

    #runSalomeMecaの編集
    def onEditRunSalomeMeca(self, event):  # wxGlade: MyDialog.<event_handler>
        self.editRunSalomeMeca(event)

    #runCADの編集
    def onEditRunCAD(self, event):  # wxGlade: MyDialog.<event_handler>
        self.editRunCAD(event)

    #runEditorの編集
    def onEditRunEditor(self, event):  # wxGlade: MyDialog.<event_handler>
        self.editRunEditor(event)

    #configTreeFoamの編集
    def onEditConfigTreeFoam(self, event):  # wxGlade: MyDialog.<event_handler>
        self.editConfigTreeFoam(event)

    #appフォルダを開く
    def onOpenAppFolder(self, event):  # wxGlade: MyDialog.<event_handler>
        self.openAppFolder(event)

    #folderを再読込する
    def onReloadFolder(self, event):  # wxGlade: MyDialog.<event_handler>
        self.reloadFolder(event)

    #defaultに戻す
    def onSetDefaultContents(self, event):  # wxGlade: MyDialog.<event_handler>
        self.setDefaultContents(event)

    #設定
    def onSet(self, event):  # wxGlade: MyDialog.<event_handler>
        self.setConfigTreeFoam(event)
        self.setOFversion()
        self.Destroy()

    #キャンセル
    def onCancel(self, event):  # wxGlade: MyDialog.<event_handler>
        self.Destroy()


    #
    #  setDataToComboBoxes
    #    comboBoxにデータをセット
    def setDataToComboBoxes(self):
        self.combo_box_lang.Clear()
        self.combo_box_lang.AppendItems(langs)
        self.combo_box_log.Clear()
        self.combo_box_log.AppendItems(logs)
        self.combo_box_bash.Clear()
        self.combo_box_bash.AppendItems(bashes)
        self.combo_box_helyx.Clear()
        self.combo_box_helyx.AppendItems(helyxes)
        self.combo_box_para.Clear()
        self.combo_box_para.AppendItems(paras)
        self.combo_box_salome.Clear()
        self.combo_box_salome.AppendItems(salomes)
        self.combo_box_cad.Clear()
        self.combo_box_cad.AppendItems(cads)
        self.combo_box_editor.Clear()
        self.combo_box_editor.AppendItems(editors)

    #
    #  setSelectDataToComboBoxes
    #    現在の値をcomboBoxにセット
    def setSelectDataToComboBoxes(self):

        def setSelectionData(comboBox, val):
            if comboBox.GetCount() > 0:
                comboBox.SetStringSelection(val)
                if comboBox.GetStringSelection() != val:
                    comboBox.SetValue(val)
            else:
                comboBox.SetValue(val)

        lang = configData[9]
        log = configData[10]
        bashrcFoam = renameEnvVal(configData[1])
        paraFoam = renameEnvVal(configData[4])
        salomeMeca = renameEnvVal(configData[5])
        cad = renameEnvVal(configData[6])
        editor = renameEnvVal(configData[7])
        helyx = renameEnvVal(configData[8])
        setSelectionData(self.combo_box_lang, lang)
        setSelectionData(self.combo_box_log, log)
        setSelectionData(self.combo_box_bash, bashrcFoam)
        setSelectionData(self.combo_box_helyx, helyx)
        setSelectionData(self.combo_box_para, paraFoam)
        setSelectionData(self.combo_box_salome, salomeMeca)
        setSelectionData(self.combo_box_cad, cad)
        setSelectionData(self.combo_box_editor, editor)

    #
    #  editConfigTreeFoam
    #    configTreeFoamを開く
    def editConfigTreeFoam(self, event):
        pyTreeFoam.runEditor(configFile)        

    #
    #  openAppFolder
    #    appフォルダを開く
    def openAppFolder(self, event):
        openDir = os.getenv("TreeFoamUserPath") + "/app"
        pyTreeFoam.openFolderNautilus(openDir)

    #
    #  reloadFolder
    #    appフォルダ内容を再読み込み
    def reloadFolder(self, event):
        initialize()
        self.setDataToComboBoxes()

    #
    #  setDefaultContents
    #    defaultの設定に戻す
    def setDefaultContents(self, event):
        title = _(u"configTreeFoamの設定")
        mess = _(u"configTreeFoamの設定をdefaultの状態に戻します\n")
        mess += _(u"よろしいですか？")
        stat = self.okCancelDialog(title, mess)
        if stat != "OK":
            return

        copyFiles = glob.glob(os.getenv("TreeFoamPath") + "/app/*")
        pasteDir = os.getenv("TreeFoamUserPath") + "/app"
        for copyFile in copyFiles:
            comm = "cp " + copyFile + " " + pasteDir
            os.system(comm)
        copyFile = os.getenv("TreeFoamPath") + "/configTreeFoam"
        pasteDir = os.getenv("TreeFoamUserPath")
        comm = "cp " + copyFile + " " + pasteDir
        os.system(comm)
        initialize()
        self.setDataToComboBoxes()
        self.setSelectDataToComboBoxes()

    #  editBashrcFoam
    #    bashrcFoamの編集
    def editBashrcFoam(self, event):
        editName = self.combo_box_bash.GetValue()
        self.editSelectFile(editName)

    #  editRunHelyxos
    def editRunHelyxos(self, event):
        editName = self.combo_box_helyx.GetValue()
        self.editSelectFile(editName)

    #  editRunParaFoam
    def editRunParaFoam(self, event):
        editName = self.combo_box_para.GetValue()
        self.editSelectFile(editName)

    #  editRunSalomeMeca
    def editRunSalomeMeca(self, event):
        editName = self.combo_box_salome.GetValue()
        self.editSelectFile(editName)

    #  editRunCAD
    def editRunCAD(self, event):
        editName = self.combo_box_cad.GetValue()
        self.editSelectFile(editName)

    #  editRunEditor
    def editRunEditor(self, event):
        editName = self.combo_box_editor.GetValue()
        self.editSelectFile(editName)

    #  editSelectFile
    def editSelectFile(self, fileName):
        name = os.path.expandvars(fileName)     #環境変数を展開
        if len(glob.glob(name)) != 0:
            pyTreeFoam.runEditor(fileName)
        else:
            title =_(u"エラー")
            mess =  _(u"openできません\n")
            mess += _(u"「$TreeFoamUserPath/app」内に、該当するファイルがありません")
            self.errDialog(title, mess)

    #
    #  setConfigTreeFoam
    #    configDataをセット
    def setConfigTreeFoam(self, event):
        #comboBox読み込み
        lang = self.combo_box_lang.GetValue()
        log = self.combo_box_log.GetValue()
        bashrc = self.combo_box_bash.GetValue()
        helyx = self.combo_box_helyx.GetValue()
        para = self.combo_box_para.GetValue()
        salome = self.combo_box_salome.GetValue()
        cad = self.combo_box_cad.GetValue()
        editor = self.combo_box_editor.GetValue()
        #エラーチェック
        if checkWordInWords(lang, langs) == False:            
            lang = langs[0]
        if checkWordInWords(log, logs) == False:
            log = "yes"
        #fileへ書き込み
        f=open(configFile); lines=f.readlines(); f.close()
        nFlag = 0
        for i in range(len(lines)):
            line = lines[i]
            words = line.split()
            if len(words) >= 2:
                if words[0] == "language":
                    words[1] = lang
                    lines[i] = " ".join(words) + "\n"
                    nFlag += 1
                elif words[0] == "logFile":
                    words[1] = log
                    lines[i] = " ".join(words) + "\n"
                    nFlag += 1
                elif words[0] == "bashrcFOAM":
                    words[1:] = bashrc.split()
                    lines[i] = " ".join(words) + "\n"
                    nFlag += 1
                elif words[0] == "paraFoam":
                    words[1:] = para.split()
                    lines[i] = " ".join(words) + "\n"
                    nFlag += 1
                elif words[0] == "helyxos":
                    words[1:] = helyx.split()
                    lines[i] = " ".join(words) + "\n"
                    nFlag += 1
                elif words[0] == "salomeMeca":
                    words[1:] = salome.split()
                    lines[i] = " ".join(words) + "\n"
                    nFlag += 1
                elif words[0] == "CAD":
                    words[1:] = cad.split()
                    lines[i] = " ".join(words) + "\n"
                    nFlag += 1
                elif words[0] == "editor":
                    words[1:] = editor.split()
                    lines[i] = " ".join(words) + "\n"
                    nFlag += 1
        if nFlag != 8:
            title = _(u"エラー")
            mess = _(u"保存されていない項目があります")
            print mess
            self.errDialog(title, mess)
        else:
            f=open(configFile, "w")
            for line in lines:
                f.write(line)
            f.close()
            if lang != language_old:
                title = _(u"警告")
                mess = _(u"使用言語が変更されました。") + "\n"
                mess += _(u"変更内容は、次回TreeFoam起動時に適用されます。")
                self.okDialog(title, mess)
                return
            if log != logFile_old:
                title = _(u"警告")
                mess = _(u"logFile作成が変更されました。") + "\n"
                mess += _(u"変更内容は、次回TreeFoam起動時に適用されます。")
                self.okDialog(title, mess)
                return

            title = _(u"configTreeFoamの設定")
            mess =_(u"configTreeFoamを設定しました")
            print mess
            self.okDialog(title, mess)

    def setOFversion(self):
        bashrc = pyTreeFoam.getBashrcFoam()
        comm = ". " + bashrc
        [stat, cont] = pyTreeFoam.runCommandErrorCheck(comm)
        if stat == "ERROR":
            print "OpenFOAM - XXXX"
            comm = "getOFversionWriteConfig.py"
            pyTreeFoam.runCommand(comm)
        else:
            comm = "getOFversionWriteConfig.py"
            pyTreeFoam.runOFUtility(comm)

    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        res = dlg.ShowModal()
        if res == wx.ID_OK:
            ans = "OK"
        else:
            ans = "CANCEL"
        dlg.Destroy()
        return ans

# end of class MyDialog



#
#  initialize
#
def initialize():
    global bashes, helyxes, paras, salomes, cads, editors, language_old, logFile_old
    global configData
    #filesを取得
    folder = os.getenv("TreeFoamUserPath") + "/app"
    bashes = renameEnvVals(glob.glob(folder + "/bashrc-FOAM*"))
    helyxes = renameEnvVals(glob.glob(folder + "/runHelyxos*"))
    paras = renameEnvVals(glob.glob(folder + "/runParaFoam*"))
    salomes = renameEnvVals(glob.glob(folder + "/runSalomeMeca*"))
    cads = renameEnvVals(glob.glob(folder + "/runCAD*"))
    editors = renameEnvVals(glob.glob(folder + "/runEditor*"))
    bashes = remakeList(bashes)
    helyxes = remakeList(helyxes)
    paras = remakeList(paras)
    salomes = remakeList(salomes)
    cads = remakeList(cads)
    editors = remakeList(editors)
    #configTreeFoamの内容を取得
    configData = pyTreeFoam.readConfigTreeFoam()
    language_old = configData[9]
    logFile_old = configData[10]

#  remakeList
#    隠しfileとバックアップfileを削除し、sortする
def remakeList(names):
    newNames = []
    for name in names:
        if name[0] != "." and name[-1] != "~":
            newNames.append(name)
    newNames.sort()
    return newNames

#
#  renameEnvVals
#    環境変数に変換
def renameEnvVals(dirs):
    names = []
    for dirName in dirs:
        name = renameEnvVal(dirName)
        #dirName.split("/")[-1]
        names.append(name)
    return names

#  renameEnvVal
def renameEnvVal(dirName):
    val = os.getenv("TreeFoamUserPath")
    if dirName[:len(val)] == val:
        name = "$TreeFoamUserPath/" + "/".join(dirName.split("/")[-2:])
    else:
        name = dirName
    return name

#  checkWordInWords
#    文字列がlist内にあるかどうかチェック
def checkWordInWords(word, words):
    ans = False
    for name in words:
        if name == word:
            ans = True
            break
    return ans


if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    configFile = sys.argv[1]
    initialize()
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyDialog(None, wx.ID_ANY, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
