#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   copyToSystemClipBoar.py
#
#       systemClipBoardにコピーする
#
#   15/06/24    新規作成
#

import sys
import os
import pygtk
pygtk.require('2.0')
import gtk
import urllib
import threading
import time

import logFileCreater; logFileCreater.log()

timeStamp = 0

sysClipboard = gtk.clipboard_get()

def copyToSystemClipBoard(fileName):
    f=open(fileName); lines=f.readlines(); f.close()
    folders = "".join(lines[1:]).split()
    sysCopyFolders(folders)

def sysCopyFolders(folders):
    action = "copy"

    def get_func(sysClipboard, selectiondata, info, data):
        txt = action + "\n" + "\n".join(paths_to_uris(folders))
        selectiondata.set(selectiondata.get_target(), 8, txt)

    def clear_func(sysClipboard,data):
        print "clear_func"

    targets = [ ('x-special/gnome-copied-files', 0, 0), ("text/uri-list", 0, 0) ]
    ret = sysClipboard.set_with_data(targets, get_func, clear_func)

#
#  paths_to_uris
#    path名をURIに変換
def paths_to_uris(paths):
    uris = []
    for path in paths:
        uri = u"file://" + urllib.quote(path)
        uris.append(uri)
    return uris

#
#  checkFileCont
#    file内容が変わったかどうかチェック
def checkFileCont():
    for i in range(1000):
        time.sleep(1.0)
        newStamp = os.path.getmtime(fileName)
        if timeStamp != newStamp:
            break
    gtk.main_quit()


if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    fileName = sys.argv[1]
    timeStamp = os.path.getmtime(fileName)
    copyToSystemClipBoard(fileName)

    t=threading.Thread(target=checkFileCont)
    t.start()    

    #gtkから抜け出ない
    gtk.main()

