#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   createBafflesDialog.py
#
#       内部patch作成（OF-2.0以降）
#
#   13/01/01    新規作成
#      04/19    nullPatch作成ボタンを追加
#      12/21    stdout、stderrの設定（import logFileCreater）を追加
#   14/10/23    initialize:nullPatch取得時にmeshが無いとｴﾗｰが発生するので修正
#      12/17    runCommand:caseDir直下のfileをsubCaseにコピーする様に修正
#   15/07/17    dialog起動方法を修正
#

# generated by wxGlade 0.6.5 on Tue Jan  1 10:49:28 2013

import wx
import os
import glob
import getFoamContents
import pyTreeFoam

import logFileCreater; logFileCreater.log()


# begin wxGlade: extracode
# end wxGlade

def Show():
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, -1, _(u"内部patch（baffle）の作成"))
        self.label_11 = wx.StaticText(self, -1, _(u"faceZoneと空patchを選択して内部patch作成。\nsubCaseフォルダを作成し、subCase内のメッシュに内部patchを作成します。\n解析caseが「subCase」の場合は、そのまま内部patchを作成します。\nregion内に内部patchを作成する場合は、meshでregion名を選択。"))
        self.label_13 = wx.StaticText(self, -1, _("mesh"))
        self.combo_box_1 = wx.ComboBox(self, -1, choices=[], style=wx.CB_DROPDOWN)
        self.label_2 = wx.StaticText(self, -1, _("faceZones"))
        self.list_box_1 = wx.ListBox(self, -1, choices=[])
        self.label_6 = wx.StaticText(self, -1, _("faceZone"))
        self.button_1 = wx.Button(self, -1, _(u"↓選択"))
        self.button_7 = wx.Button(self, -1, _(u"nullPatch作成"))
        self.label_12 = wx.StaticText(self, -1, _(u"gridEditorの起動"))
        self.label_3 = wx.StaticText(self, -1, _("null patches name"))
        self.list_box_2 = wx.ListBox(self, -1, choices=[])
        self.label_4 = wx.StaticText(self, -1, _("master"))
        self.button_2 = wx.Button(self, -1, _(u"↓選択"))
        self.label_5 = wx.StaticText(self, -1, _("slave"))
        self.button_3 = wx.Button(self, -1, _(u"↓選択"))
        self.label_7 = wx.StaticText(self, -1, _("command"))
        self.label_10 = wx.StaticText(self, -1, _("createBaffles "))
        self.text_ctrl_1 = wx.TextCtrl(self, -1, "")
        self.label_8 = wx.StaticText(self, -1, _(" '("))
        self.text_ctrl_2 = wx.TextCtrl(self, -1, "")
        self.text_ctrl_3 = wx.TextCtrl(self, -1, "")
        self.label_9 = wx.StaticText(self, -1, _(")'"))
        self.sizer_2_staticbox = wx.StaticBox(self, -1, _("sorce"))
        self.button_4 = wx.Button(self, -1, _(u"↓ set command"))
        self.text_ctrl_4 = wx.TextCtrl(self, -1, "", style=wx.TE_MULTILINE)
        self.sizer_12_staticbox = wx.StaticBox(self, -1, _("commands"))
        self.button_5 = wx.Button(self, -1, _(u"キャンセル"))
        self.button_6 = wx.Button(self, -1, _(u"baffle作成"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_TEXT_ENTER, self.onChangeMesh, self.combo_box_1)
        self.Bind(wx.EVT_COMBOBOX, self.onChangeMesh, self.combo_box_1)
        self.Bind(wx.EVT_LISTBOX_DCLICK, self.onSetFaceZone, self.list_box_1)
        self.Bind(wx.EVT_LISTBOX, self.onSetFaceZone, self.list_box_1)
        self.Bind(wx.EVT_BUTTON, self.selectFaceZone, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onRunGridEditor, self.button_7)
        self.Bind(wx.EVT_LISTBOX_DCLICK, self.onSetPatchName, self.list_box_2)
        self.Bind(wx.EVT_LISTBOX, self.onSetPatchName, self.list_box_2)
        self.Bind(wx.EVT_BUTTON, self.selectMaster, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.selectSlave, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.setCommand, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.cancel, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.createBaffles, self.button_6)
        # end wxGlade
        stat = self.initialize()
        if stat != "OK":
            self.Destroy()


    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_("createBaffles"))
        self.list_box_1.SetMinSize((160, 150))
        self.button_1.SetMinSize((60, 30))
        self.list_box_2.SetMinSize((160, 150))
        self.button_2.SetMinSize((60, 30))
        self.button_3.SetMinSize((60, 30))
        self.text_ctrl_1.SetMinSize((120, 28))
        self.text_ctrl_2.SetMinSize((100, 28))
        self.text_ctrl_3.SetMinSize((100, 28))
        self.text_ctrl_4.SetMinSize((450, 100))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.VERTICAL)
        sizer_14 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_12_staticbox.Lower()
        sizer_12 = wx.StaticBoxSizer(self.sizer_12_staticbox, wx.VERTICAL)
        self.sizer_2_staticbox.Lower()
        sizer_2 = wx.StaticBoxSizer(self.sizer_2_staticbox, wx.VERTICAL)
        sizer_10 = wx.BoxSizer(wx.VERTICAL)
        sizer_11 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_9 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_4 = wx.BoxSizer(wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7 = wx.BoxSizer(wx.VERTICAL)
        sizer_6 = wx.BoxSizer(wx.VERTICAL)
        sizer_15 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3 = wx.BoxSizer(wx.VERTICAL)
        sizer_8 = wx.BoxSizer(wx.VERTICAL)
        sizer_16 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.label_1, 0, wx.ALL | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_1.Add(self.label_11, 0, wx.LEFT | wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 5)
        sizer_16.Add(self.label_13, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_16.Add(self.combo_box_1, 0, wx.RIGHT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_3.Add(sizer_16, 0, wx.EXPAND, 0)
        sizer_3.Add(self.label_2, 0, wx.LEFT | wx.TOP, 5)
        sizer_3.Add(self.list_box_1, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 5)
        sizer_8.Add(self.label_6, 0, wx.LEFT | wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_8.Add(self.button_1, 0, wx.LEFT | wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_3.Add(sizer_8, 1, wx.EXPAND, 0)
        sizer_9.Add(sizer_3, 1, wx.EXPAND, 0)
        sizer_15.Add(self.button_7, 0, wx.LEFT, 5)
        sizer_15.Add(self.label_12, 0, wx.LEFT | wx.RIGHT | wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_4.Add(sizer_15, 0, wx.EXPAND, 0)
        sizer_4.Add(self.label_3, 0, wx.LEFT | wx.TOP, 5)
        sizer_4.Add(self.list_box_2, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 5)
        sizer_6.Add(self.label_4, 0, wx.LEFT, 10)
        sizer_6.Add(self.button_2, 0, wx.LEFT, 10)
        sizer_5.Add(sizer_6, 1, wx.EXPAND, 0)
        sizer_7.Add(self.label_5, 0, 0, 0)
        sizer_7.Add(self.button_3, 0, 0, 0)
        sizer_5.Add(sizer_7, 1, wx.EXPAND, 0)
        sizer_4.Add(sizer_5, 0, wx.EXPAND, 0)
        sizer_9.Add(sizer_4, 1, wx.EXPAND, 0)
        sizer_2.Add(sizer_9, 0, wx.EXPAND, 0)
        sizer_10.Add(self.label_7, 0, 0, 0)
        sizer_11.Add(self.label_10, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_11.Add(self.text_ctrl_1, 0, wx.EXPAND, 0)
        sizer_11.Add(self.label_8, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_11.Add(self.text_ctrl_2, 0, wx.EXPAND, 0)
        sizer_11.Add(self.text_ctrl_3, 0, wx.EXPAND, 0)
        sizer_11.Add(self.label_9, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_10.Add(sizer_11, 0, wx.EXPAND, 0)
        sizer_2.Add(sizer_10, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_2, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_1.Add(self.button_4, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_12.Add(self.text_ctrl_4, 0, wx.ALL | wx.EXPAND, 5)
        sizer_1.Add(sizer_12, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_14.Add(self.button_5, 0, wx.ALL | wx.EXPAND | wx.ALIGN_RIGHT, 10)
        sizer_14.Add(self.button_6, 0, wx.RIGHT | wx.TOP | wx.BOTTOM, 10)
        sizer_13.Add(sizer_14, 1, wx.ALIGN_RIGHT, 0)
        sizer_1.Add(sizer_13, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    def onSetFaceZone(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setFaceZoneToCommand()        
        event.Skip()

    def onSetPatchName(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setPatchName()
        event.Skip()

    def selectFaceZone(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setFaceZoneToCommand()

    def selectMaster(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setMasterPatchToCommand()

    def selectSlave(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setSlavePatchToCommand()

    def setCommand(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setCommandToBox()

    def cancel(self, event):  # wxGlade: MyFrame.<event_handler>
        self.Destroy()

    def createBaffles(self, event):  # wxGlade: MyFrame.<event_handler>
        stat = self.runCommand()
        if stat == "OK":
            self.Destroy()

    def onRunGridEditor(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runGridEditor(event)

    def onChangeMesh(self, event):  # wxGlade: MyFrame.<event_handler>
        self.changeMesh(event)

# end of class MyFrame

    #  changeMesh
    #    mesh(region)変更時、faceZone、nullPatchを読み直す。
    def changeMesh(self, event):
        n = self.combo_box_1.GetSelection()
        if n == 0:
            region = "."
        else:
            region = self.combo_box_1.GetStringSelection()
        caseDir = os.getcwd()
        iniTime = pyTreeFoam.getTimeFolders(caseDir)[0]
        polyMeshDir = caseDir + "/" + iniTime + "/" + region + "/polyMesh"
        if len(glob.glob(polyMeshDir + "/boundary")) == 0:
            polyMeshDir = caseDir + "/constant/" + region + "/polyMesh"
        #faceZoneの取得
        faceZonesFile = polyMeshDir + "/faceZones"
        faceZoneNames = getFoamContents.getZoneNamesF_sub(faceZonesFile)
        self.setFaceZoneNames(faceZoneNames)
        #nullPatchの取得
        patchConts = getFoamContents.getPatchCont(polyMeshDir)
        patches = []
        for patchCont in patchConts:
            if patchCont[1] == 0:
                patches.append(patchCont[0])
        self.setNullPatchNames(patches)


    #  setFaceZoneToCommand
    #    faceZoneをコマンドラインにセット
    def setFaceZoneToCommand(self):
        faceZone = self.list_box_1.GetStringSelection()
        self.text_ctrl_1.SetValue(faceZone)
        self.text_ctrl_2.SetValue("")
        self.text_ctrl_3.SetValue("")

    #  setPatchName
    #    patchNameをセット
    def setPatchName(self):
        if self.text_ctrl_2.GetValue() == "":
            masterPatch = self.list_box_2.GetStringSelection()
            self.text_ctrl_2.SetValue(masterPatch)
            self.text_ctrl_3.SetValue(masterPatch)
        else:
            slavePatch = self.list_box_2.GetStringSelection()
            self.text_ctrl_3.SetValue(slavePatch)

    #  setMasterPatchToCommand
    #    masterPatchNameをコマンドラインにセット
    def setMasterPatchToCommand(self):
        masterPatch = self.list_box_2.GetStringSelection()
        self.text_ctrl_2.SetValue(masterPatch)

    #  setSlavePatchToCommand
    #    slavePatchNameをコマンドラインにセット
    def setSlavePatchToCommand(self):
        slavePatch = self.list_box_2.GetStringSelection()
        self.text_ctrl_3.SetValue(slavePatch)

    #  setCommandToBox
    #    コマンドラインをboxにセット
    def setCommandToBox(self):
        cellZone = self.text_ctrl_1.GetValue()
        master = self.text_ctrl_2.GetValue()
        slave = self.text_ctrl_3.GetValue()
        n = self.combo_box_1.GetSelection()
        if n == 0:
            region = ""
        else:
            name = self.combo_box_1.GetStringSelection()
            region = " -region " + name
        command = "createBaffles "
        command += cellZone + " '("
        command += master + " "
        command += slave + ")' -overwrite"
        command += region + "\n"
        commCont = self.text_ctrl_4.GetValue()
        commCont += command
        self.text_ctrl_4.SetValue(commCont)

    #  runCommand
    #    createBafflesコマンド実行
    def runCommand(self):
        caseDir = "/".join(os.getcwd().split("/")[:-1])
        fileNames = pyTreeFoam.getFieldNames(caseDir)
        for fileName in fileNames:
            comm = "cp " + caseDir + "/" + fileName + " ./"
            print comm
            os.system(comm)
        comm = self.text_ctrl_4.GetValue()
        [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
        if stat != "OK":
            title = _(u"エラー")
            msg = _(u"エラーが発生しました。\n  logを確認してください。")
            self.errDialog(title, msg)
        else:
            title = u"createBaffles"
            msg = _(u"内部patch（baffle）を作成しました。\n  解析caseを「subCase」に設定してください。")
            self.okDialog(title, msg)
        return stat

    #
    #  runGridEditor
    #    gridEditorの起動
    def runGridEditor(self, event):
        caseDir = os.getcwd()
        #regionを取得
        n = self.combo_box_1.GetSelection()
        if n == 0:
            region = "."
        else:
            region = self.combo_box_1.GetString(n)
        caseFolder = caseDir.split("/")[-1]
        timeFolders = pyTreeFoam.getTimeFolders(caseDir)
        timeFolder = timeFolders[0]
        title = ": " + caseFolder + "/" + timeFolder + "/" + region
        fieldDir = caseDir + "/" + timeFolder + "/" + region
        if len(glob.glob(fieldDir + "/polyMesh/boundary")) != 0:
            boundaryDir = fieldDir + "/polyMesh"
        else:
            boundaryDir = caseDir + "/constant/" + region + "/polyMesh"
        #grid表示
        nTreeFoam = "-1"
        comm = "runGridEditor.py "
        comm+= nTreeFoam + " '" + title + "' " + boundaryDir + " " + fieldDir
        os.system(comm)
        #nullPatchの取得
        n = self.combo_box_1.GetSelection()
        if n == 0:
            region = "."
        else:
            region = self.combo_box_1.GetStringSelection()
        caseDir = os.getcwd()
        iniTime = pyTreeFoam.getTimeFolders(caseDir)[0]
        polyMeshDir = caseDir + "/" + iniTime + "/" + region + "/polyMesh"
        if len(glob.glob(polyMeshDir + "/boundary")) == 0:
            polyMeshDir = caseDir + "/constant/" + region + "/polyMesh"
        #  nullPatchの取得
        patchConts = getFoamContents.getPatchCont(polyMeshDir)
        patches = []
        for patchCont in patchConts:
            if patchCont[1] == 0:
                patches.append(patchCont[0])
        self.setNullPatchNames(patches)

    #
    #  initialize
    #
    def initialize(self):
        #subCaseの作成
        stat = self.makeSubCase()
        if stat == "OK":
            caseDir = os.getcwd()
            #region、polyMeshDirの取得
            iniTime = pyTreeFoam.getTimeFolders(caseDir)[0]
            [isRegion, loc, regions] = pyTreeFoam.checkMultiRegion(caseDir)
            if isRegion == True:
                self.setRegionNames(regions)
                n = self.combo_box_1.GetSelection()
                if n == 0:
                    region = "."
                else:
                    region = self.combo_box_1.GetStringSelection()
                polyMeshDir = caseDir + "/" + iniTime + "/" + region + "/polyMesh"
                if len(glob.glob(polyMeshDir + "/boundary")) == 0:
                    polyMeshDir = caseDir + "/constant/" + region + "/polyMesh"
            else:
                self.setRegionNames([])
                polyMeshDir = caseDir + "/" + iniTime + "/polyMesh"
                if len(glob.glob(polyMeshDir + "/boundary")) == 0:
                    polyMeshDir = caseDir + "/constant/polyMesh"
            #faceZoneの取得
            faceZonesFile = polyMeshDir + "/faceZones"
            faceZoneNames = getFoamContents.getZoneNamesF_sub(faceZonesFile)
            self.setFaceZoneNames(faceZoneNames)
            #nullPatchの取得
            #エラー発生時は、patchesは、空白のまま
            patches = []
            try:
                patchConts = getFoamContents.getPatchCont(polyMeshDir)
                for patchCont in patchConts:
                    if patchCont[1] == 0:
                        patches.append(patchCont[0])
                self.setNullPatchNames(patches)
            except:
                self.setNullPatchNames(patches)
        return stat

    #  setRegionNames
    #    regionNameをcombo_boxにセット
    def setRegionNames(self, regions):
        names = []
        names.append(_(u"(現在のフォルダ)"))
        ans = names + regions
        self.combo_box_1.Clear()
        self.combo_box_1.AppendItems(ans)
        self.combo_box_1.SetSelection(0)

    #  makeSubCase
    #    subCaseの作成
    def makeSubCase(self):
        caseDir = os.path.abspath("./")
        caseName = caseDir.split("/")[-1]
        if caseName == "subCase":
            return "OK"

        if len(glob.glob("./subCase")) != 0:
            title = _(u"エラー")
            msg = _(u"既に「subCase」が存在しています。\n　「subCase」を削除してください。")
            self.errDialog(title, msg)
            return "ERROR"
        else:
            comm = "mkdir ./subCase"
            os.system(comm)
            times = pyTreeFoam.getTimeFolders("./")
            timeFolder = times[0]
            comm = "cp -a ./" + timeFolder + " ./subCase"
            print comm
            os.system(comm)
            comm = "cp -a ./constant ./subCase"
            os.system(comm)
            comm = "cp -a ./system ./subCase"
            os.system(comm)
            os.chdir("./subCase")
            return "OK"  

    #  setFaceZoneNames
    #    faceZoneNamesをlistBoxに設定
    def setFaceZoneNames(self, faceZoneNames):
        self.list_box_1.Clear()
        self.list_box_1.AppendItems(faceZoneNames)

    #  setNullPatchNames
    #    nullPatchNameをlistBoxに設定
    def setNullPatchNames(self, patches):
        self.list_box_2.Clear()
        self.list_box_2.AppendItems(patches)

    #------------------
    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    


if __name__ == "__main__":
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
