#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   createBafflesDialog220.py
#
#       内部patch（baffle）作成
#       OpenFOAM-2.2.0用
#
#   13/06/29    新規作成
#      07/10    初期化のバグ修正
#      10/15    国際化のため修正
#      12/21    stdout、stderrの設定（import logFileCreater）を追加
#   14/04/12    faceZone、空patchの選択方法、Dictファイルの作成方法修正
#      07/14    createBafflesDict作成dirを修正（バグ）
#      07/16    subCase作成時、fileもコピーする様に修正
#      11/04    setFaceZoneToTextBox:クリックのみで作動するように修正
#      12/07    runDict:buffleをconstant/polyMeshに作成するように修正
#      12/17    runDict:subCase作成時caseDir直下のfileもコピーする様に修正
#   15/06/30    空patchが無しでpatch（patch、cyclic、mapped）が作れる様に修正
#      07/17    dialog起動方法修正
#
# generated by wxGlade 0.6.5 on Sat Jun 29 15:53:47 2013


import wx
import os
import glob
import pyTreeFoam
import getFoamContents
import setFoamContents
import gaugeDDialog

# begin wxGlade: extracode
# end wxGlade


caseDir = ""
timeFolder = ""
startFrom = ""
selRegion = ""
polyMeshDir = ""
regionNames = []
times = []



def Show():
    initialize()
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, wx.ID_ANY, _(u"内部patch（baffle）の作成"))
        self.label_2 = wx.StaticText(self, wx.ID_ANY, _(u"createBafflesDictを編集し、内部patchを作成する。\nsubCaseフォルダを作成し、subCase内のメッシュに内部patchを作成する。\n解析case名が「subCase」の場合は、そのまま内部patchを作成する。"))
        self.label_3 = wx.StaticText(self, wx.ID_ANY, _("time"))
        self.combo_box_1 = wx.ComboBox(self, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.label_4 = wx.StaticText(self, wx.ID_ANY, _("region"))
        self.combo_box_2 = wx.ComboBox(self, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.sizer_2_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"meshの選択"))
        self.button_2 = wx.Button(self, wx.ID_ANY, _(u"faceZone作成..."))
        self.label_5 = wx.StaticText(self, wx.ID_ANY, _(u"topoSetEditor起動"))
        self.label_7 = wx.StaticText(self, wx.ID_ANY, _(u"現在のfaceZone"))
        self.list_box_1 = wx.ListBox(self, wx.ID_ANY, choices=[])
        self.sizer_8_staticbox = wx.StaticBox(self, wx.ID_ANY, _("faceZone"))
        self.button_1 = wx.Button(self, wx.ID_ANY, _(u"patch名確認..."))
        self.label_9 = wx.StaticText(self, wx.ID_ANY, _(u"gridEditor起動"))
        self.label_11 = wx.StaticText(self, wx.ID_ANY, _(u"作成するpatch名を入力\n（空patchは必要なし）"))
        self.label_6 = wx.StaticText(self, wx.ID_ANY, _("master"))
        self.text_ctrl_4 = wx.TextCtrl(self, wx.ID_ANY, "")
        self.label_8 = wx.StaticText(self, wx.ID_ANY, _("slave"))
        self.text_ctrl_5 = wx.TextCtrl(self, wx.ID_ANY, "")
        self.sizer_9_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"作成するpatch名"))
        self.sizer_18_staticbox = wx.StaticBox(self, wx.ID_ANY, _("source"))
        self.label_10 = wx.StaticText(self, wx.ID_ANY, _(u"↓ nameSet"))
        self.button_9 = wx.Button(self, wx.ID_ANY, _(u"patch作成"))
        self.button_3 = wx.Button(self, wx.ID_ANY, _(u"cyclic作成"))
        self.button_7 = wx.Button(self, wx.ID_ANY, _(u"mappedPatch作成"))
        self.label_12 = wx.StaticText(self, wx.ID_ANY, _("(type  faceZone  master  slave)"))
        self.list_box_3 = wx.ListBox(self, wx.ID_ANY, choices=[])
        self.button_4 = wx.Button(self, wx.ID_ANY, _(u"Dict作成"))
        self.button_5 = wx.Button(self, wx.ID_ANY, _(u"Dict実行"))
        self.button_10 = wx.Button(self, wx.ID_ANY, _(u"Dict編集"))
        self.button_11 = wx.Button(self, wx.ID_ANY, _(u"行削除"))
        self.sizer_12_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"createBafflesDictの名前リスト"))
        self.button_6 = wx.Button(self, wx.ID_ANY, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_TEXT_ENTER, self.onChangeTime, self.combo_box_1)
        self.Bind(wx.EVT_COMBOBOX, self.onChangeTime, self.combo_box_1)
        self.Bind(wx.EVT_TEXT_ENTER, self.onChangeRegion, self.combo_box_2)
        self.Bind(wx.EVT_COMBOBOX, self.onChangeRegion, self.combo_box_2)
        self.Bind(wx.EVT_BUTTON, self.onRunTopoSetEditor, self.button_2)
        self.Bind(wx.EVT_LISTBOX, self.onClickFaceZone, self.list_box_1)
        self.Bind(wx.EVT_BUTTON, self.onRunGridEditor, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onNamesSet, self.button_9)
        self.Bind(wx.EVT_BUTTON, self.onCyclicNamesSet, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onMappedNamesSet, self.button_7)
        self.Bind(wx.EVT_BUTTON, self.onCreateDict, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onRunDict, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.onEditDict, self.button_10)
        self.Bind(wx.EVT_BUTTON, self.onDeleteLine, self.button_11)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_6)
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_("frame_1"))
        self.button_2.SetMinSize((115, 30))
        self.list_box_1.SetMinSize((200, 100))
        self.label_6.SetMinSize((50, 18))
        self.label_8.SetMinSize((50, 18))
        # end wxGlade

        self.SetTitle(_(u"内部patchの作成"))
        self.setTimes()
        self.setRegions()
        self.setFaceZones()
        #self.setNullPatches()


    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_16 = wx.BoxSizer(wx.VERTICAL)
        sizer_17 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_12_staticbox.Lower()
        sizer_12 = wx.StaticBoxSizer(self.sizer_12_staticbox, wx.HORIZONTAL)
        sizer_29 = wx.BoxSizer(wx.VERTICAL)
        sizer_30 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_31 = wx.BoxSizer(wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.VERTICAL)
        sizer_28 = wx.BoxSizer(wx.VERTICAL)
        sizer_32 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_18_staticbox.Lower()
        sizer_18 = wx.StaticBoxSizer(self.sizer_18_staticbox, wx.VERTICAL)
        sizer_7 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_9_staticbox.Lower()
        sizer_9 = wx.StaticBoxSizer(self.sizer_9_staticbox, wx.VERTICAL)
        sizer_11 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_14 = wx.BoxSizer(wx.VERTICAL)
        sizer_26 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_15 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_27 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_8_staticbox.Lower()
        sizer_8 = wx.StaticBoxSizer(self.sizer_8_staticbox, wx.VERTICAL)
        sizer_10 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_2_staticbox.Lower()
        sizer_2 = wx.StaticBoxSizer(self.sizer_2_staticbox, wx.HORIZONTAL)
        sizer_4 = wx.BoxSizer(wx.VERTICAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3 = wx.BoxSizer(wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.label_1, 0, wx.ALL | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_1.Add(self.label_2, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_5.Add(self.label_3, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_5.Add(self.combo_box_1, 1, wx.RIGHT | wx.TOP | wx.BOTTOM | wx.EXPAND, 5)
        sizer_3.Add(sizer_5, 1, wx.EXPAND, 0)
        sizer_2.Add(sizer_3, 1, wx.EXPAND, 0)
        sizer_6.Add(self.label_4, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_6.Add(self.combo_box_2, 1, wx.RIGHT | wx.TOP | wx.BOTTOM | wx.EXPAND, 5)
        sizer_4.Add(sizer_6, 1, wx.EXPAND, 0)
        sizer_2.Add(sizer_4, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_2, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_10.Add(self.button_2, 0, 0, 0)
        sizer_10.Add(self.label_5, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_8.Add(sizer_10, 0, wx.EXPAND, 0)
        sizer_8.Add(self.label_7, 0, wx.LEFT | wx.TOP, 5)
        sizer_8.Add(self.list_box_1, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_7.Add(sizer_8, 1, wx.LEFT | wx.RIGHT | wx.TOP | wx.EXPAND, 5)
        sizer_27.Add(self.button_1, 0, 0, 0)
        sizer_27.Add(self.label_9, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_9.Add(sizer_27, 0, wx.EXPAND, 0)
        sizer_14.Add(self.label_11, 0, wx.LEFT, 10)
        sizer_15.Add(self.label_6, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_15.Add(self.text_ctrl_4, 1, wx.RIGHT, 5)
        sizer_14.Add(sizer_15, 0, wx.EXPAND | wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_26.Add(self.label_8, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_26.Add(self.text_ctrl_5, 1, wx.RIGHT, 5)
        sizer_14.Add(sizer_26, 0, wx.EXPAND | wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_11.Add(sizer_14, 1, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_9.Add(sizer_11, 1, wx.EXPAND | wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_7.Add(sizer_9, 1, wx.LEFT | wx.RIGHT | wx.TOP | wx.EXPAND, 5)
        sizer_18.Add(sizer_7, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 3)
        sizer_1.Add(sizer_18, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_32.Add(self.label_10, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_32.Add(self.button_9, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_32.Add(self.button_3, 0, wx.LEFT | wx.RIGHT, 5)
        sizer_32.Add(self.button_7, 0, 0, 0)
        sizer_28.Add(sizer_32, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_1.Add(sizer_28, 0, wx.ALL | wx.EXPAND, 0)
        sizer_29.Add(self.label_12, 0, wx.LEFT, 10)
        sizer_30.Add(self.list_box_3, 1, wx.LEFT | wx.TOP | wx.BOTTOM | wx.EXPAND, 5)
        sizer_13.Add(self.button_4, 0, wx.LEFT | wx.RIGHT | wx.TOP, 5)
        sizer_13.Add(self.button_5, 0, wx.LEFT | wx.RIGHT | wx.TOP, 5)
        sizer_30.Add(sizer_13, 0, wx.EXPAND, 0)
        sizer_31.Add(self.button_10, 0, wx.LEFT | wx.RIGHT | wx.TOP, 5)
        sizer_31.Add(self.button_11, 0, wx.LEFT | wx.RIGHT | wx.TOP, 5)
        sizer_30.Add(sizer_31, 0, wx.EXPAND, 0)
        sizer_29.Add(sizer_30, 0, wx.EXPAND, 0)
        sizer_12.Add(sizer_29, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_12, 0, wx.LEFT | wx.RIGHT | wx.TOP | wx.EXPAND, 10)
        sizer_17.Add(self.button_6, 0, wx.ALL, 10)
        sizer_16.Add(sizer_17, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_16, 0, wx.ALIGN_RIGHT, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    def onChangeTime(self, event):  # wxGlade: MyFrame.<event_handler>
        self.changeTime(event)

    def onChangeRegion(self, event):  # wxGlade: MyFrame.<event_handler>
        self.changeRegion(event)

    def onRunTopoSetEditor(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runTopoSetEditor(event)

    def onRunGridEditor(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runGridEditor(event)

    #selectFaceZone
    def onSelectFaceZone(self, event):  # wxGlade: MyFrame.<event_handler>
        self.selectFaceZone(event)

    #selectMasterName
    def onSelectMasterName(self, event):  # wxGlade: MyFrame.<event_handler>
        self.selectMasterName(event)

    #selectSlaveName
    def onSelectSlaveName(self, event):  # wxGlade: MyFrame.<event_handler>
        self.selectSlaveName(event)

    #namesSet
    def onNamesSet(self, event):  # wxGlade: MyFrame.<event_handler>
        self.namesSet(event)

    #cyclic作成
    def onCyclicNamesSet(self, event):  # wxGlade: MyFrame.<event_handler>
        self.cyclicNamesSet(event)

    #mapped作成
    def onMappedNamesSet(self, event):  # wxGlade: MyFrame.<event_handler>
        self.mappedNamesSet(event)

    #createDict
    def onCreateDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.createDict(event)

    #editDict
    def onEditDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.editDict(event)

    #runDict
    def onRunDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runDict(event)

    #deleteLine
    def onDeleteLine(self, event):  # wxGlade: MyFrame.<event_handler>
        self.deleteLine(event)

    #close
    def onClose(self, event):  # wxGlade: MyFrame.<event_handler>
        self.Destroy()

    #clickFaceZone
    def onClickFaceZone(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setFaceZoneToTextBox(event)

    """
    #clickNullPatch
    def onClickNullPatch(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setNullPatchToTextBox(event)
    """

# end of class MyFrame

    #  setFaceZoneToTextBox
    #    faceZoneをtextBoxにセット
    def setFaceZoneToTextBox(self, event):
        faceZoneName = self.list_box_1.GetStringSelection()
        #self.text_ctrl_3.SetValue(faceZoneName)
        self.text_ctrl_4.SetValue(faceZoneName + "_master")
        self.text_ctrl_5.SetValue(faceZoneName + "_slave")

    #  setNullPatchToTextBox
    #    nullPatchをtextBoxにセット
    def setNullPatchToTextBox(self, event):
        nullPatchName = self.list_box_2.GetStringSelection()
        if self.text_ctrl_4.GetValue() == "":
            self.text_ctrl_4.SetValue(nullPatchName)
            self.text_ctrl_5.SetValue(nullPatchName)
        else:
            self.text_ctrl_5.SetValue(nullPatchName)

    #  setTimes
    #    timeをセット
    def setTimes(self):
        global times, startFrom
        self.combo_box_1.Clear()
        self.combo_box_1.AppendItems(times)
        if startFrom == "firstTime":
            self.combo_box_1.SetSelection(0)
        elif startFrom == "startTime":
            self.combo_box_1.SetSelection(1)
        else:
            self.combo_box_1.SetSelection(2)

    #  getTimeFolder
    #    選択しているtimeFolderを取得
    def getTimeFolder(self):
        selTime = self.combo_box_1.GetStringSelection()
        startFrom = selTime.split(":")[0].split()[0]
        timeFolder = selTime.split(":")[1]
        return [startFrom, timeFolder]

    #  setRegions
    #    regionをセット
    def setRegions(self):
        global regionNames
        self.combo_box_2.Clear()
        self.combo_box_2.AppendItems(regionNames)
        self.combo_box_2.SetSelection(0)

    #  getSelRegion
    #    選択しているregionを取得
    def getSelRegion(self):
        n = self.combo_box_2.GetSelection()
        if n == 0:
            region = "."
        else:
            region = self.combo_box_2.GetStringSelection()
        return region

    #  setFaceZones
    #    faceZoneをセット
    def setFaceZones(self):
        global polyMeshDir
        faceZones = getFoamContents.faceZoneNamesDir(polyMeshDir)
        self.list_box_1.Clear()
        self.list_box_1.AppendItems(faceZones)

    """
    #  setNullPatches
    #    空patchをセット
    def setNullPatches(self):
        global polyMeshDir
        patchConts = getFoamContents.getPatchCont(polyMeshDir)
        nullPatches = []
        for patchCont in patchConts:
            if patchCont[1] == 0:
                nullPatches.append(patchCont[0])
        nullPatches.sort()
        self.list_box_2.Clear()
        self.list_box_2.AppendItems(nullPatches)
    """

    #  changeTime
    #    timeを変更
    def changeTime(self, event):
        global timeFolder, polyMeshDir, startFrom, selRegion
        [startFrom, timeFolder] = self.getTimeFolder()
        selRegion = self.getSelRegion()
        polyMeshDir = getPolyMeshDir(caseDir, timeFolder, selRegion)
        self.setFaceZones()
        #self.setNullPatches()
        systemDir = caseDir + "/system"
        setFoamContents.controlDict(systemDir, [["startFrom", startFrom]]) 

    #  changeRegion
    #    regionを変更
    def changeRegion(self, event):
        self.changeTime(event)

    #  runTopoSetEditor
    #    topoSetEditorの起動
    def runTopoSetEditor(self, event):
        global timeFolder, selRegion
        stlDir = caseDir
        comm = "cd " + caseDir + ";" 
        comm += "topoSetEditor.py " + caseDir + " " + stlDir
        comm += " " + timeFolder + " " + selRegion
        pyTreeFoam.runOFUtility(comm)
        self.changeTime(event)

    #  runGridEditor
    #    gridEditorの起動
    def runGridEditor(self, event):
        global caseDir, timeFolder, selRegion
        region = selRegion
        caseFolder = caseDir.split("/")[-1]
        title = ": " + caseFolder + "/" + timeFolder + "/" + region
        fieldDir = caseDir + "/" + timeFolder + "/" + region
        if len(glob.glob(fieldDir + "/polyMesh/boundary")) != 0:
            boundaryDir = fieldDir + "/polyMesh"
        else:
            boundaryDir = caseDir + "/constant/" + region + "/polyMesh"
        #grid表示
        nTreeFoam = "-1"
        comm = "runGridEditor.py "
        comm+= nTreeFoam + " '" + title + "' " + boundaryDir + " " + fieldDir
        os.system(comm)
        self.changeTime(event)

    #  selectFaceZone
    #    faceZone名取得
    def selectFaceZone(self, event):
        selectName = self.list_box_1.GetStringSelection()
        if selectName == "":
            title = _(u"エラー")
            mess = _(u"faceZoneを選択してください。")
            self.errDialog(title, mess)
            return
        self.text_ctrl_3.SetValue(selectName)

    #  selectMasterName
    def selectMasterName(self, event):
        selectName = self.list_box_2.GetStringSelection()
        if selectName == "":
            title = _(u"エラー")
            mess = _(u"空patch名を選択してください。")
            self.errDialog(title, mess)
            return
        self.text_ctrl_4.SetValue(selectName)
        self.text_ctrl_5.SetValue(selectName)

    #  selectSlaveName
    def selectSlaveName(self, event):
        selectName = self.list_box_2.GetStringSelection()
        if selectName == "":
            title = _(u"エラー")
            mess = _(u"空patch名を選択してください。")
            self.errDialog(title, mess)
            return
        self.text_ctrl_5.SetValue(selectName)

    #  namesSet
    #    名前リストの作成
    def namesSet(self, event):
        self.patchNamesSet("patch")

    #  patchNamesSet
    #    名前リスト作成
    def patchNamesSet(self, patchType):
        faceZone = self.list_box_1.GetStringSelection()
        master = self.text_ctrl_4.GetValue()
        slave = self.text_ctrl_5.GetValue()
        if faceZone == "" or master == "" or slave == "":
            title = _(u"エラー")
            mess = _(u"名前が選択されていません。")
            self.errDialog(title, mess)
            return
        patchConts = getFoamContents.getPatchCont(polyMeshDir)
        flag = 0
        for patchCont in patchConts:
            if master == patchCont[0] or slave == patchCont[0]:
                flag = 1
                break
        if flag == 1:
            title = _(u"警告")
            mess = _(u"master or slaveのpatch名は、既に使用されています。\n")
            mess += _(u"このまま設定しますか？")
            stat = self.yesNoDialog(title, mess)
            if stat != "YES":
                return

        names = patchType + " " + " ".join([faceZone, master, slave])
        self.list_box_3.AppendItems([names])
        self.list_box_3.SetSelection(self.list_box_3.GetCount()-1)

    #  cyclicNamesSet
    #    cyclicの名前リスト作成
    def cyclicNamesSet(self, event):
        faceZone = self.list_box_1.GetStringSelection()
        master = self.text_ctrl_4.GetValue()
        slave = self.text_ctrl_5.GetValue()
        if faceZone == "" or master == "" or slave == "":
            title = _(u"エラー")
            mess = _(u"名前が選択されていません。")
            self.errDialog(title, mess)
            return 
        names = "cyclic " + " ".join([faceZone, master, slave])
        self.list_box_3.AppendItems([names])
        self.list_box_3.SetSelection(self.list_box_3.GetCount()-1)

    #  mappedNamesSet
    #    mappedの名前リスト作成
    def mappedNamesSet(self, event):
        faceZone = self.list_box_1.GetStringSelection()
        master = self.text_ctrl_4.GetValue()
        slave = self.text_ctrl_5.GetValue()
        if faceZone == "" or master == "" or slave == "":
            title = _(u"エラー")
            mess = _(u"名前が選択されていません。")
            self.errDialog(title, mess)
            return 
        names = "mapped " + " ".join([faceZone, master, slave])
        self.list_box_3.AppendItems([names])
        self.list_box_3.SetSelection(self.list_box_3.GetCount()-1)

    #  createDict
    #    Dictファイル作成
    def createDict(self, event):
        #nameSetを取得
        namesList = []
        n = self.list_box_3.GetCount()
        i = 0
        while i<n:
            namesList.append(self.list_box_3.GetString(i))
            i += 1
        contents = """// Whether to convert internal faces only (so leave boundary faces intact).
// This is only relevant if your face selection type can pick up boundary
// faces.
internalFacesOnly true;

// Baffles to create.
baffles
{
"""
        i = 0
        sp = " "
        for names in namesList:
            cont = ""
            words = names.split()
            patchType = words[0]
            faceZone = words[1]
            master = words[2]
            slave = words[3]
            [patchMaster, patchSlave] = self.getPatchContFromPatchType(patchType, master, slave)
            cont += "    " + faceZone + sp*5 + "//baffles is created\n"
            cont += "    {\n"
            cont += "        //- Use predefined faceZone to select faces and orientation.\n"
            cont += "        type        faceZone;\n"
            cont += "        zoneName    " + faceZone + ";\n"
            cont += "        patches\n"
            cont += "        {\n"
            cont += "            master\n"
            cont += "            {\n"
            cont += "                //- Master side patch\n"
            cont += "                name        " + master + ";\n"
            #cont += "                type        patch;\n"
            cont += patchMaster
            cont += "            }\n"
            cont += "            slave\n"
            cont += "            {\n"
            cont += "                //- Slave side patch\n"
            cont += "                name        " + slave + ";\n"
            #cont += "                type        patch;\n"
            cont += patchSlave
            cont += "            }\n"
            cont += "        }\n"
            cont += "    }\n"
            contents += cont
            i += 1
        contents += "}\n"
        version = pyTreeFoam.readConfigTreeFoam()[0]
        header = setFoamContents.makeFoamHeaderVersion(version)
        foamFile = setFoamContents.makeFoamFile("2.0", "ascii", "dictionary", "", "createBafflesDict") 
        footer = setFoamContents.makeFooter()
        fileCont = header + foamFile + contents + footer
        #fileName = caseDir + "/system/createBafflesDict"
        fileName = caseDir + "/system/" + selRegion + "/createBafflesDict"
        f=open(fileName, "w"); f.write(fileCont); f.close()
        title = _(u"createBafflesDict作成")
        mess = _(u"createBafflesDictを作成しました。")
        self.okDialog(title, mess)

    #  getPatchContFromPatchType
    #    patchTypeからそのpatch内容を取得する
    def getPatchContFromPatchType(self, patchType, master, slave):
        contMaster = ""
        contSlave = ""
        if patchType == "patch":
            contMaster += "                type        patch;\n"
            contSlave = contMaster
        elif patchType == "cyclic":
            contMaster += "                type        cyclic;\n"
            contMaster += "                neighbourPatch " + slave + ";\n"
            contSlave  += "                type        cyclic;\n"
            contSlave  += "                neighbourPatch " + master + ";\n"
        elif patchType == "mapped":
            region = self.combo_box_2.GetStringSelection()
            if region == "(region0)":
                region = "region0"
            contMaster += "                type        patch;\n"
            contSlave  += "                type        mappedPatch;\n"
            contSlave  += "                sampleRegion " + region + ";\n" 
            contSlave  += "                sampleMode  nearestPatchFace;\n"
            contSlave  += "                samplePatch " + master + ";\n"
        else:
            contMaster += "                type        patch;\n"
            contSlave = contMaster
        return [contMaster, contSlave]

    #  editDict
    #    createBafflesDictの編集
    def editDict(self, event):
        global caseDir, selRegion
        selRegion = self.getSelRegion()
        fileName = caseDir + "/system/" + selRegion + "/createBafflesDict"
        if len(glob.glob(fileName)) == 0:
            cont = makeCreateBafflesDict()
            f=open(fileName, "w"); f.write(cont); f.close()
            title = _(u"createBafflesDict編集")
            mess = _(u"標準の「createBafflesDict」を作成しました。")
            self.okDialog(title, mess)
        openFileName = fileName
        pyTreeFoam.runEditor(openFileName)

    #  deleteLine
    #    namesSetの行を削除
    def deleteLine(self, event):
        count = self.list_box_3.GetCount()
        delNo = self.list_box_3.GetSelection()
        names = []
        i = 0
        while i<count:
            if i != delNo:
                names.append(self.list_box_3.GetString(i))
            i += 1
        self.list_box_3.Clear()
        self.list_box_3.AppendItems(names)

    #  runDict
    #    createBafflesの実行
    def runDict(self, event):
        global caseDir, timeFolder, selRegion
        #「subCase」有無確認
        if len(glob.glob(caseDir + "/subCase")) != 0:
            title = _(u"エラー")
            mess = _(u"既に「subCase」が存在します。\n削除後、実行してください。")
            self.errDialog(title, mess)
            return

        #case名のチェック
        if caseDir.split("/")[-1] != "subCase":
            #dir作成
            comm = "mkdir " + caseDir + "/subCase"
            os.system(comm)
            #caseをコピー
            times = pyTreeFoam.getTimeFolders("./")
            timeFolder = times[0]
            comm = "cp -a ./" + timeFolder + " ./subCase"
            print comm
            os.system(comm)
            comm = "cp -a ./constant ./subCase"
            print comm
            os.system(comm)
            comm = "cp -a ./system ./subCase"
            print comm
            os.system(comm)
            fileNames = pyTreeFoam.getFieldNames(caseDir)
            for fileName in fileNames:
                comm = "cp " + fileName + " ./subCase"
                print comm
                os.system(comm)
            os.chdir("./subCase")
            initialize()

        #createBaffles実行
        selRegion = self.getSelRegion()
        if selRegion == ".":
            comm = "createBaffles -overwrite"
        else:
            comm = "createBaffles -region " + selRegion + " -overwrite"
        print comm
        [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
        if stat != "OK":
            title = _(u"エラー")
            mess = _(u"実行エラーが発生しました。\nlogを確認してください。")
            self.errDialog(title, mess)
            return

        if caseDir.split("/")[-1] == "subCase":
            #空Patchを再セット、textBoxをクリア
            #self.setNullPatches()
            #self.text_ctrl_3.SetValue("")
            self.text_ctrl_4.SetValue("")
            self.text_ctrl_5.SetValue("")
            self.list_box_3.Clear()
            #終了メッセージ
            title = _(u"内部patch作成")
            mess = _(u"内部patchを作成しました。")
        else:
            self.setNullPatches()
            self.text_ctrl_3.SetValue("")
            self.text_ctrl_4.SetValue("")
            self.text_ctrl_5.SetValue("")
            self.list_box_3.Clear()
            #終了メッセージ
            title = _(u"内部patch作成")
            mess = _(u"内部patchを作成しました。\n解析caseを「subCase」に設定してください。")
        self.okDialog(title, mess)

    #----------------------------------------------------------
    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def yesNoDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.YES | wx.NO | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        stat = ""
        if ans == wx.ID_YES:
            stat = "YES"
        else:
            stat = "NO"
        return stat


#  copyCaseFolders
#    caseをコピーする
def copyCaseFolders(copyCase, copyFolders, meshFolder, copyTo):
    copyDirs = []
    newDirs = []
    for folder in copyFolders:
        copyDirs.append(copyCase + "/" + folder)
        newDirs.append(copyTo + "/" + folder)
    copyDirs.append(copyCase + "/" + meshFolder)
    timeFolder = copyFolders[0]
    polyMesh = "/".join(meshFolder.split("/")[1:])
    newDirs.append(copyTo + "/" + timeFolder + "/" + polyMesh)
    #paste開始
    gaugeDDialog.job = "copy"
    gaugeDDialog.title = _(u"folder, fileのコピー")
    gaugeDDialog.copyDirs = copyDirs
    gaugeDDialog.newDirs = newDirs
    dialog = gaugeDDialog.MyDialog(None)
    reult = dialog.ShowModal()
    ans = gaugeDDialog.status
    #コピーをキャンセルした場合
    #  ans="NG"
    #エラーが発生した場合
    #  ans="ERR"
    return ans

#  copyMeshFolder
#    meshFolderをコピー
def copyMeshFolder(caseDir, meshFolder, copyTo):
    copyDirs = [caseDir+"/"+meshFolder]
    newDirs = [caseDir+"/"+copyTo]
    #paste開始
    gaugeDDialog.job = "copy"
    gaugeDDialog.title = _(u"folder, fileのコピー")
    gaugeDDialog.copyDirs = copyDirs
    gaugeDDialog.newDirs = newDirs
    dialog = gaugeDDialog.MyDialog(None)
    reult = dialog.ShowModal()
    ans = gaugeDDialog.status
    #コピーをキャンセルした場合
    #  ans="NG"
    #エラーが発生した場合
    #  ans="ERR"
    return ans


#
#  makeCreateBafflesDict
#    createBafflesDictを作成
def makeCreateBafflesDict():
    version = pyTreeFoam.readConfigTreeFoam()[0]
    header = setFoamContents.makeFoamHeaderVersion(version)
    foamFile = setFoamContents.makeFoamFile("2.0", "ascii", "dictionary", "", "createBafflesDict") 
    footer = setFoamContents.makeFooter()
    cont = """// Whether to convert internal faces only (so leave boundary faces intact).
// This is only relevant if your face selection type can pick up boundary
// faces.
internalFacesOnly true;

// Baffles to create.
baffles
{""" + getOrgBaffleCont() + "\n}"
    allCont = header + foamFile + cont + footer
    return allCont

def getOrgBaffleCont():
    cont = """
    creatBaffle         //baffle is created
    {
        //- Use predefined faceZone to select faces and orientation.
        type        faceZone;
        zoneName    cycLeft;

        patches
        {
            master
            {
                //- Master side patch

                name            cycRightPatch;
                type            patch;
            }
            slave
            {
                //- Slave side patch

                name            cycLeftPatch;
                type            patch;
            }
        }
    }"""
    return cont


def initialize():
    global caseDir, timeFolder, regionNames, startFrom, times, regionNames
    global polyMeshDir, selRegion
    caseDir = os.getcwd()
    #timesを取得
    contDir = caseDir + "/system"
    [startFrom, startTime] = getFoamContents.controlDict(contDir, ["startFrom", "startTime"])
    timeFolders = pyTreeFoam.getTimeFolders(caseDir)
    firstTime = timeFolders[0]
    latestTime = timeFolders[-1]
    times = []
    times.append("firstTime :" + firstTime)
    times.append("startTime :" + startTime)
    times.append("latestTime:" + latestTime)
    if startFrom == "firstTime":
        timeFolder = firstTime
    elif startFrom == "startTime":
        timeFolder = startTime
    else:
        timeFolder = latestTime
    #regionsを取得
    regionNames = []
    [isRegion, loc, names] = pyTreeFoam.checkMultiRegion(caseDir)
    if isRegion == False:
        names = []
    regionNames.append("(region0)")
    for name in names:
        regionNames.append(name)
    selRegion = "."
    #polyMeshDirを取得
    polyMeshDir = getPolyMeshDir(caseDir, timeFolder, selRegion)

#
#  getPolyMeshDir
#    polyMeshDirを取得
def getPolyMeshDir(caseDir, timeFolder, region):
    polyMeshDir = caseDir + "/" + timeFolder + "/" + region + "/polyMesh"
    if len(glob.glob(polyMeshDir+"/boundary")) == 0:
        polyMeshDir = caseDir + "/constant/" + region + "/polyMesh"
    return polyMeshDir




if __name__ == "__main__":
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
