#!/usr/bin/env python
# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.5 on Sun Mar 24 14:35:45 2013
#
#   createNewCaseDDialog.py
#
#       新しいcaseをtutorialsからコピーして作成
#
#       13/03/24    新規作成
#          04/18    casesを取得時に、subCaseがダブって表示されていたものを修正
#          04/20    tutorialsのsolver選択時、稀にエラーが発生していたのを修正
#          05/12    cases取得時、取得洩れがあったものを修正
#          10/15    国際化のため、修正
#          10/20    英語版のsolverListデータを準備
#       15/07/13    clipBoardの場所をTreeFoam/dataに変更
#          07/17    dialogの起動方法修正
#       16/12/31    iniSetTutorialsDir:OF-ext用に修正
#

import wx
import os
import glob
import csv
import pyTreeFoam
import getOpenFolderDDialog
import gaugeDDialog

#clipBoard = os.environ["TreeFoamPath"] + "/data/clipBoard"
clipBoard = os.environ["TreeFoamUserPath"] + "/data/clipBoard"
#tutorials_data = os.environ["TreeFoamPath"] + "/data/tutorials_data"
tutorials_data = os.environ["TreeFoamUserPath"] + "/data/tutorials_data"
OFversion = ""
status = "NG"
caseDir = ""
tutorialsDir = ""
tutoCaseDir = ""
newCaseName = ""
solverList = ""
listData = []           #solverListのデータ[<item>, <solver>, <solverCont>]
items = []
solvers = []
solverCont = []
cases = []
selItemNo = 0
selSolverNo = 0
selCaseNo = 0
switchChangeTutoDir = "off"     #tutorials場所変更flag
title = ""
message = ""

# begin wxGlade: extracode
# end wxGlade


#  Show
#    turorialsからcaseをコピー
def Show(title1, mess1):
    global title, message
    initialize()
    title = title1
    message = mess1
    dialog = MyDialog(None)
    result = dialog.ShowModal()
    return [status, tutoCaseDir]


def initialize():
    global solverList
    if os.environ["LANG"][:2] == "ja":
        #solverList = os.environ["TreeFoamPath"] + "/data/solverList.csv"
        solverList = os.environ["TreeFoamUserPath"] + "/data/solverList.csv"
    else:
        #solverList = os.environ["TreeFoamPath"] + "/data/solverList_en.csv"
        solverList = os.environ["TreeFoamUserPath"] + "/data/solverList_en.csv"


class MyDialog(wx.Dialog):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyDialog.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE | wx.RESIZE_BORDER | wx.THICK_FRAME
        wx.Dialog.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, -1, _(u"tutorialsからコピーして、新しいcaseを作成。\n　（区分、solver、caseを選択して作成。）"))
        self.checkbox_1 = wx.CheckBox(self, -1, _(u"場所を変更する"))
        self.label_2 = wx.StaticText(self, -1, _(u"場所:"))
        self.text_ctrl_3 = wx.TextCtrl(self, -1, "")
        self.button_4 = wx.Button(self, -1, _(u"参照..."))
        self.sizer_3_staticbox = wx.StaticBox(self, -1, _("tutorials"))
        self.label_5 = wx.StaticText(self, -1, _(u"区分"))
        self.list_box_4 = wx.ListBox(self, -1, choices=[])
        self.label_6 = wx.StaticText(self, -1, _("solver"))
        self.list_box_5 = wx.ListBox(self, -1, choices=[])
        self.label_7 = wx.StaticText(self, -1, _("case"))
        self.list_box_6 = wx.ListBox(self, -1, choices=[])
        self.label_8 = wx.StaticText(self, -1, _(u"<solverの内容＞"))
        self.label_11 = wx.StaticText(self, -1, _("label_11"))
        self.sizer_2_staticbox = wx.StaticBox(self, -1, _(u"solver, caseを選択"))
        self.button_2 = wx.Button(self, -1, _(u"キャンセル"))
        self.button_3 = wx.Button(self, -1, _("OK"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_CHECKBOX, self.onChangeTutorialsDir, self.checkbox_1)
        self.Bind(wx.EVT_BUTTON, self.onReferenceTutorialsDir, self.button_4)
        self.Bind(wx.EVT_LISTBOX_DCLICK, self.onOpenItemFolder, self.list_box_4)
        self.Bind(wx.EVT_LISTBOX, self.onSelectItem, self.list_box_4)
        self.Bind(wx.EVT_LISTBOX_DCLICK, self.onOpenSolverFolder, self.list_box_5)
        self.Bind(wx.EVT_LISTBOX, self.onSelectSolver, self.list_box_5)
        self.Bind(wx.EVT_LISTBOX_DCLICK, self.onOpenCaseFolder, self.list_box_6)
        self.Bind(wx.EVT_LISTBOX, self.onSelectCase, self.list_box_6)
        self.Bind(wx.EVT_BUTTON, self.onCancel, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onOK, self.button_3)
        # end wxGlade
        
        self.initialize()
        self.text_ctrl_3.Enable(False)
        self.button_4.Enable(False)
        self.text_ctrl_3.Bind(wx.EVT_KEY_DOWN, self.onSetTutorialsDir)
        #toolTip追加
        self.list_box_4.SetToolTipString(_(u"ダブルクリックでfolderが開きます。"))
        self.list_box_5.SetToolTipString(_(u"ダブルクリックでfolderが開きます。"))
        self.list_box_6.SetToolTipString(_(u"ダブルクリックでfolderが開きます。"))
        #tutorialsのdirを設定
        iniSetTutorialsDir()
        self.text_ctrl_3.SetValue(tutorialsDir)
        #csvデータの読み込み
        readCsvData()
        getItemsSolversCases()
        self.setListBoxData()


    def __set_properties(self):
        # begin wxGlade: MyDialog.__set_properties
        self.SetTitle(_("dialog_1"))
        self.label_2.SetMinSize((35, 18))
        self.text_ctrl_3.SetMinSize((500, 28))
        self.button_4.SetMinSize((60, 30))
        self.list_box_4.SetMinSize((100, 150))
        self.list_box_5.SetMinSize((100, 150))
        self.list_box_6.SetMinSize((100, 150))
        self.label_11.SetMinSize((56, 72))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyDialog.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.VERTICAL)
        sizer_14 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_2_staticbox.Lower()
        sizer_2 = wx.StaticBoxSizer(self.sizer_2_staticbox, wx.VERTICAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_9 = wx.BoxSizer(wx.VERTICAL)
        sizer_8 = wx.BoxSizer(wx.VERTICAL)
        sizer_7 = wx.BoxSizer(wx.VERTICAL)
        self.sizer_3_staticbox.Lower()
        sizer_3 = wx.StaticBoxSizer(self.sizer_3_staticbox, wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_15 = wx.BoxSizer(wx.VERTICAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.label_1, 0, wx.TOP | wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_4.Add(self.checkbox_1, 0, wx.LEFT, 70)
        sizer_3.Add(sizer_4, 0, wx.EXPAND, 0)
        sizer_15.Add(self.label_2, 0, wx.LEFT | wx.ALIGN_RIGHT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_5.Add(sizer_15, 0, wx.ALIGN_RIGHT | wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_5.Add(self.text_ctrl_3, 1, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_5.Add(self.button_4, 0, wx.RIGHT | wx.ALIGN_CENTER_VERTICAL, 10)
        sizer_3.Add(sizer_5, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_3, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 10)
        sizer_6.Add((5, 150), 0, 0, 0)
        sizer_7.Add(self.label_5, 0, wx.LEFT, 20)
        sizer_7.Add(self.list_box_4, 1, wx.LEFT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_6.Add(sizer_7, 3, wx.EXPAND, 0)
        sizer_8.Add(self.label_6, 0, wx.LEFT, 20)
        sizer_8.Add(self.list_box_5, 1, wx.LEFT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_6.Add(sizer_8, 2, wx.EXPAND, 0)
        sizer_9.Add(self.label_7, 0, wx.LEFT, 20)
        sizer_9.Add(self.list_box_6, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_6.Add(sizer_9, 2, wx.EXPAND, 0)
        sizer_2.Add(sizer_6, 1, wx.EXPAND, 0)
        sizer_2.Add(self.label_8, 0, wx.LEFT, 100)
        sizer_2.Add(self.label_11, 0, wx.LEFT | wx.EXPAND, 100)
        sizer_1.Add(sizer_2, 1, wx.LEFT | wx.RIGHT | wx.TOP | wx.EXPAND, 10)
        sizer_14.Add(self.button_2, 0, wx.ALL, 10)
        sizer_14.Add(self.button_3, 0, wx.ALL, 10)
        sizer_13.Add(sizer_14, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_13, 0, wx.ALIGN_RIGHT, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    def initialize(self):
        global title, message
        self.SetTitle(title)
        self.label_1.SetLabel(message)


    #checkBoxの確認
    def onChangeTutorialsDir(self, event):  # wxGlade: MyDialog.<event_handler>
        self.changeTutorialsDir(event)
        event.Skip()

    #tutorialsDirの決定
    def onSetTutorialsDir(self, event):  # wxGlade: MyDialog.<event_handler>
        self.setTutorialsDir(event)
        event.Skip()

    #tutorialsDirの参照
    def onReferenceTutorialsDir(self, event):  # wxGlade: MyDialog.<event_handler>
        self.referenceTutorialsDir(event)

    #区分のfolderをopen
    def onOpenItemFolder(self, event):  # wxGlade: MyDialog.<event_handler>
        self.openItemFolder(event)

    #solverのfolderをopen
    def onOpenSolverFolder(self, event):  # wxGlade: MyDialog.<event_handler>
        self.openSolverFolder(event)

    #caseのfolderをopen
    def onOpenCaseFolder(self, event):  # wxGlade: MyDialog.<event_handler>
        self.openCaseFolder(event)

    #区分を選択
    def onSelectItem(self, event):  # wxGlade: MyDialog.<event_handler>
        self.selectItemShowSolver(event)
        event.Skip()

    #solverを選択
    def onSelectSolver(self, event):  # wxGlade: MyDialog.<event_handler>
        self.selectSolverShowCase(event)
        event.Skip()

    #caseを選択
    def onSelectCase(self, event):  # wxGlade: MyDialog.<event_handler>
        self.selectCasePutCaseName(event)
        event.Skip()

    #キャンセル
    def onCancel(self, event):  # wxGlade: MyDialog.<event_handler>
        global status
        status = "NG"
        self.Destroy()

    #OK
    def onOK(self, event):  # wxGlade: MyDialog.<event_handler>
        global status, tutoCaseDir
        tutoCaseDir = self.getTutoCaseDir()
        status = "OK"
        self.Destroy()


    #
    #  setListBoxData
    #    listBoxにデータセット（初期化）
    def setListBoxData(self):
        global selItemNo, selSolverNo, selCaseNo
        global items, solvers, cases, solverCont
        selItemNo = 0
        selSolverNo = 0
        selCaseNo = 0
        #itemsのセット
        if len(items) == 0:
            self.list_box_4.Clear()
            self.list_box_5.Clear()
            self.list_box_6.Clear()
            #self.setNewCaseName("")
            self.label_11.SetLabel("")
            return
        self.list_box_4.Clear()
        self.list_box_4.AppendItems(items)
        self.list_box_4.SetSelection(selItemNo)
        #solversのセット
        if len(solvers) == 0:
            self.list_box_5.Clear()
            self.list_box_6.Clear()
            #self.setNewCaseName("")
            self.label_11.SetLabel("")
            return
        self.list_box_5.Clear()
        self.list_box_5.AppendItems(solvers)
        self.list_box_5.SetSelection(selSolverNo)
        self.label_11.SetLabel(solverCont[0])
        #casesのセット
        if len(cases) == 0:
            self.list_box_6.Clear()
            #self.setNewCaseName("")
            self.label_11.SetLabel("")
            return
        item = getItemName(items[0])
        cases = getCaseNames(item, solvers[0])
        self.list_box_6.Clear()
        self.list_box_6.AppendItems(cases)
        self.list_box_6.SetSelection(selCaseNo)

    #
    #  referenceTutorialsDir
    #    tutorialsDirの参照
    def referenceTutorialsDir(self, event):
        global tutorialsDir
        title = _(u"tutorialsDirの設定")
        mess = _(u"tutorialsのdirを設定します。")
        rootDir = os.environ["HOME"]
        currDir = os.getcwd()
        selDir = tutorialsDir
        [status, resDir] = getOpenFolderDDialog.Show(title, mess, rootDir, currDir, selDir)
        if status == "OK":
            tutorialsDir = resDir
            self.text_ctrl_3.SetValue(tutorialsDir)
            getItemsSolversCases()
            self.setListBoxData()
            writeTutorials_data(OFversion, tutorialsDir)

    #
    #  setTutorialsDir
    #    tutorialsDirをセットする
    def setTutorialsDir(self, event):
        global tutorialsDir, OFversion
        key = str(event.GetKeyCode())
        if key == "13":
            tutorialsDir = self.text_ctrl_3.GetValue()
            getItemsSolversCases()
            self.setListBoxData()
            writeTutorials_data(OFversion, tutorialsDir)

    #
    #  changeTutorialsDir
    #    tutorialsのdirの変更処理（checkBox）
    def changeTutorialsDir(self, event):
        global switchChangeTutoDir
        if switchChangeTutoDir == "off":
            switchChangeTutoDir = "on"
            self.text_ctrl_3.Enable(True)
            self.button_4.Enable(True)
        else:
            switchChangeTutoDir = "off"
            self.text_ctrl_3.Enable(False)
            self.button_4.Enable(False)

    #
    #  openItemFolder
    #    区分のfilderをopenする
    def openItemFolder(self, event):
        item = items[selItemNo]
        itemName = getItemName(item)
        itemDir = tutorialsDir + "/" + itemName
        pyTreeFoam.openFolderNautilus(itemDir)

    #
    #  openSolverFolder
    #    solverのfolderをopenする
    def openSolverFolder(self, event):
        item = items[selItemNo]
        solver = solvers[selSolverNo]
        solverDir = getSolverDir(item, solver)
        pyTreeFoam.openFolderNautilus(solverDir)

    #
    #  openCaseFolder
    #    caseFolderをopenする
    def openCaseFolder(self, event):
        item = items[selItemNo]
        solver = solvers[selSolverNo]
        case = cases[selCaseNo]
        solverDir = getSolverDir(item, solver)
        caseDir = solverDir + "/" + case
        pyTreeFoam.openFolderNautilus(caseDir)

    #
    #  selectItemShowSolver
    #    区分を選択、solverを表示
    def selectItemShowSolver(self, event):
        global items, solvers, selItemNo, selSolverNo, selCaseNo
        if len(items) == 0:
            return
        itemNo = self.list_box_4.GetSelection()
        if itemNo >= 0:
            selItemNo = itemNo
        item = items[selItemNo]
        itemName = getItemName(item)
        selSolverNo = 0
        selCaseNo = 0
        #solversを取得
        solvers = getSolverNames(item)
        self.list_box_5.Clear()
        self.label_11.SetLabel("")
        if len(solvers) == 0:
            return
        self.list_box_5.AppendItems(solvers)
        self.list_box_5.SetSelection(selSolverNo)
        #solver内容セット
        cont = self.getSolverContents(solvers[selSolverNo])
        self.label_11.SetLabel(cont)
        self.selectSolverShowCase(event)

    #
    #  selectSolverShowCase
    #    solverを選択、caseを表示
    def selectSolverShowCase(self, event):
        global items, solvers, cases, selSolverNo, selCaseNo
        if len(items) == 0:
            return
        item = items[selItemNo]
        itemName = getItemName(item)
        if len(solvers) == 0:
            self.list_box_5.Clear()
            self.label_11.SetLabel("")
            cases = []
            self.list_box_6.Clear()
            #self.setNewCaseName("")
            return
        solverNo = self.list_box_5.GetSelection()
        if solverNo >= 0:
            selSolverNo = solverNo
        solver = solvers[selSolverNo]
        #solver内容をセット
        cont = self.getSolverContents(solver)
        self.label_11.SetLabel(cont)
        #caseを取得
        cases = getCaseNames(itemName, solver)
        if len(cases) == 0:
            self.list_box_6.Clear()
            #self.setNewCaseName("")
            return
        self.list_box_6.Clear()
        self.list_box_6.AppendItems(cases)
        selCaseNo = 0
        self.list_box_6.SetSelection(selCaseNo)

    #
    #  selectCasePutCaseName
    #    caseを選択、case名をtextBoxにセット
    def selectCasePutCaseName(self, event):
        global selCaseNo
        if len(cases) == 0:
            return
        caseNo = self.list_box_6.GetSelection()
        if caseNo >= 0:
            selCaseNo = caseNo
        if selCaseNo >= len(cases):
            selCaseNo = 0
        caseName = cases[selCaseNo]
        #self.setNewCaseName(caseName)

    #
    #  getCaseCopyDir
    #    caseのコピー先を取得
    def getCaseCopyDir(self, event):
        title = _(u"新しいcaseの作成場所を設定")
        mess = _(u"tutorialsのcaseのコピー先folderを設定します")
        root = os.environ["HOME"]
        currDir = os.getcwd()
        selDir = self.text_ctrl_2.GetValue()
        if len(glob.glob(selDir)) > 0:
            if selDir[0] != "/":
                selDir = os.path.abspath(selDir.encode("utf-8"))
        else:
            selDir = currDir
        [stat, selDir] = getOpenFolderDDialog.Show(title, mess, root, currDir, selDir)
        if stat == "OK":
            self.text_ctrl_2.SetValue(selDir)


    #  getSolverContents
    #    solverの内容を表示
    def getSolverContents(self, solver):
        global listData
        cont = ""
        i=0
        for names in listData:
            if names[1] == solver:
                cont = listData[i][2]
                break
            i += 1
        return cont


    #  getTutoCaseDir
    #    選択されているTutorialsのcaseDirを取得
    def getTutoCaseDir(self):
        item = items[selItemNo]
        solver = solvers[selSolverNo]
        caseName = cases[selCaseNo]
        ansDir = getCaseDir(item, solver, caseName)
        return ansDir


    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

# end of class MyDialog



#
#  getSolverNames
#    itemに該当するsolver名を取得（nestingは、2段まで）
def getSolverNames(item):
    itemName = getItemName(item)
    solverList = glob.glob(tutorialsDir + "/" + itemName + "/*")
    solvers = []
    if len(solverList) > 0:
        #solverを取得
        for solverDir in solverList:
            name = solverDir.split("/")[-1]
            if name[-4:] == "Foam" or name[-4:] == "Mesh":
                solvers.append(name)
            else:
                subList = glob.glob(solverDir + "/*")
                if len(subList) > 0:
                    for subDir in subList:
                        name = subDir.split("/")[-1]
                        if name[-4:] == "Foam" or name[-4:] == "Mesh":
                            solvers.append(name)
        solvers.sort()
    return solvers

#
#  getCaseDir
#    tutorialsのcasedirの取得
def getCaseDir(item, solver, case):
    solverDir = getSolverDir(item, solver)
    caseDir = solverDir + "/" + cases[selCaseNo]
    return caseDir

#
#  getCaseNames
#    solverに該当するcase名を取得
def getCaseNames(item, solver):
    #solverDirの取得
    solverDir = getSolverDir(item, solver)
    #casesを取得
    #  3レベルまで探す
    caseNames = []
    [folders, files] = pyTreeFoam.getFoldersFiles(solverDir)
    for folder in folders:
        checkDir = solverDir + "/" + folder
        if pyTreeFoam.checkFolder(checkDir) == "case":
            caseNames.append(folder)
        else:
            [folders1, files] = pyTreeFoam.getFoldersFiles(checkDir)
            for folder1 in folders1:
                checkDir1 = checkDir + "/" + folder1
                if pyTreeFoam.checkFolder(checkDir1) == "case":
                    caseNames.append(folder + "/" + folder1)
                else:
                    [folders2, files] = pyTreeFoam.getFoldersFiles(checkDir1)
                    for folder2 in folders2:
                        checkDir2 = checkDir1 + "/" + folder2
                        if pyTreeFoam.checkFolder(checkDir2) == "case":
                            caseNames.append(folder+"/"+folder1+"/"+folder2)
    caseNames.sort()
    return caseNames


#
#  getSolverDir
#    itemとsolverNameからsolverDirを取得
def getSolverDir(item, solver):
    itemName = getItemName(item)
    checkDir = tutorialsDir + "/" + itemName
    solverDir = walkGetFolderDir(checkDir, solver)
    return solverDir

#
#  walkGetFolderDir
#    checkDirからfolderを探し、dirを返す
def walkGetFolderDir(rootDir, folder):
    folderDir = ""
    for (root, dirs, files) in os.walk(rootDir):
        for dirName in dirs:
            name = dirName.split("/")[-1]
            if folder == name:
                folderDir = root + "/" + dirName
                break
        if folderDir != "":
            break
    return folderDir

#
#  getItemName
#    区分からitemを取得
def getItemName(itemCont):
        item = itemCont.split(":")[0]
        if len(item) == len(itemCont):
            item = itemCont.split(u"：")[0]
        return item

#
#  iniSetTutorialsDir
#    tutorialsのdirを取得
def iniSetTutorialsDir():
    global tutorialsDir, OFversion
    config = pyTreeFoam.readConfigTreeFoam()
    OFversion = config[0]
    if len(glob.glob(tutorials_data)) != 0:
        [ver, tutoDir] = readTutorials_data()
        if (len(glob.glob(tutoDir)) != 0) and (ver == OFversion):
            tutorialsDir = tutoDir
            return

    tutorialsDir = ""
    if OFversion[:3] == "ext":
        #foam-extend
        ver = OFversion[4:]
        tutoDir = os.environ["HOME"] + "/foam/" + os.environ["USER"] + "-" + ver + "/run/tutorials"
        if len(glob.glob(tutoDir)) == 0:
            tutoDir = os.environ["HOME"] + "/foam/foam-extend-" + ver + "/tutorials"
        tutorialsDir = tutoDir
    else:
        #OpenFOAM
        tutoDir = os.environ["HOME"] + "/OpenFOAM/" + os.environ["USER"] + "-" + OFversion + "/run/tutorials"
        if len(glob.glob(tutoDir)) == 0:
            tutoDir = os.environ["HOME"] + "/OpenFOAM/OpenFOAM-" + OFversion + "/tutorials"
        tutorialsDir = tutoDir
    writeTutorials_data(OFversion, tutorialsDir)
    return

#  readTutorials_data
#    tutorials_dataのデータを読み込み
#    戻り値：[ver, tutoDir]
def readTutorials_data():
    f=open(tutorials_data); cont=f.readlines(); f.close()
    ver = ""
    tutoDir = ""
    for line in cont:
        comms = line.split()
        if len(comms) > 1:
            item = comms[0]
            data = comms[1]
            if item == "OFversion":
                ver = data
            elif item == "tutorialsDir":
                tutoDir = data
    return [ver, tutoDir] 

#  writeTutorials_data
#    tutorials_dataの書き込み
def writeTutorials_data(ver, tutoDir):
    cont  = "\n"
    cont += "OFversion    " + ver + "\n"
    cont += "tutorialsDir " + tutoDir + "\n"
    f=open(tutorials_data, "w")
    f.write(cont)
    f.close()


#
#  readCsvData
#    csvデータの読み込み, items, solvers, solverCont, casesをセット
def readCsvData():
    global listData
    fileName = solverList
    cont = csv.reader(file(fileName))
    i=0
    for row in cont:
        if i != 0:
            line = []
            for item in row:
                line.append(item.decode("utf-8"))
            listData.append(line)
        i+=1
            

#
#  getItemsSolversCases
#    item,solver, caseをセット
def getItemsSolversCases():
    global items, solvers, solverCont, cases
    #  csvデータ内の区分を取得
    setData = u""
    readItems = []
    for data in listData:
        #data[0] = data[0].decode("utf-8")
        data[0] = data[0]
        if setData != data[0]:
            readItems.append(data[0])
            setData = data[0]
    #  tutorials内の区分を取得
    [itemNames, files] = pyTreeFoam.getFoldersFiles(tutorialsDir)
    subItems = []
    for gName in itemNames:
        flag = 0
        i=0
        for item in readItems:
            iName = getItemName(item)
            if gName == iName:
                subItems.append([i, item])
                flag = 1
                break
            i+=1
        if flag == 0:
            subItems.append([100, gName])
    #  itemsをセット
    subItems.sort()
    items = []
    for item in subItems:
        items.append(item[1])
    if len(items) != 0:
        #solver、内容を取得
        solvers = getSolverNames(items[0])
        solverCont = []
        for solver in solvers:
            cont = u""
            for data in listData:
                if solver == data[1]:
                    cont = data[2]
                    break
            solverCont.append(cont)
        #caseを取得
        if len(solvers) != 0:
            cases = getCaseNames(items[0], solvers[0])
    else:
        solvers = []
        cases = []
        solverCont = []



if __name__ == "__main__":
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    dialog_1 = MyDialog(None, -1, "")
    app.SetTopWindow(dialog_1)
    dialog_1.Show()
    app.MainLoop()
