#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   createSetFieldsDictDialog.py
#
#       setFieldsDictを作成する。
#
#   13/11/16    新規作成
#      11/24    field追加時、fieldTypesを取得するよう修正
#      12/02    grid上にpopupMenuを追加
#      12/10    paste時のバグを修正
#      12/21    stdout、stderrの設定（import logFileCreater）を追加
#   14/03/06    readWinSize, saveWinSizeを修正（null行があった場合ｴﾗｰ発生）
#   15/01/19    saveWinSize:バグ修正（行末に「\n」を追加）
#      02/02    getDefaultFieldValues:バグ修正（値がvectorの場合ｴﾗｰ発生）
#      06/25    createMatrixでcellEditorのセットをwxのversionで変更
#               windowのサイズ設定も同様
#      12/02    「Dict保存・実行」ボタンを追加（saveExecを追加）
#   16/07/28    起動時のwindowsサイズをwxとTreeFoamのバージョンのセットで変更
#   17/02/02    copyToClipBoard,getPasteValsFromClipBoard:バグ修正
#               copy&pasteが作動しなかった事を修正
#

#---------code生成後の修正項目-----------------------------------
#
#　・「size=winSize」を追加
#        wx.Frame.__init__(self, size=winSize, *args, **kwds)
#
#　・以下の行をコメントアウトする
#       sizer_3.Fit(self)
#

# generated by wxGlade 0.6.5 on Sat Nov 16 16:23:40 2013

import wx
import sys
import os
import wx.grid
import glob
import csv
import codecs
import getFoamContents
import setFoamContents
import pyTreeFoam
import inputTextDDialog
import getOpenFileDDialog
import setDataInFieldsDialog
import selectNamesDDialog
import topoSetEditor
import saveAndNextJobDDialog

import logFileCreater; logFileCreater.log()


# begin wxGlade: extracode
# end wxGlade

setFieldsDict = "system/setFieldsDict"
fields = []
cellSets = []
winSize = (400, 300)        #windowSize
colNames = []
rowNames = []
colRowData = []
fieldTypes = []
nonFieldNames = []
nonSetNames = []
caseDir = ""
timeFolder = ""
selRegion = ""
polyMeshDir = ""
csvFileName = "setFieldsDict.csv"
curRow = -1
curCol = -1



class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, wx.ID_ANY, _(u"各Fieldへのデータセット"))
        self.static_line_1 = wx.StaticLine(self, wx.ID_ANY)
        self.label_2 = wx.StaticText(self, wx.ID_ANY, _(u" ファイル:"), style=wx.ALIGN_RIGHT)
        self.button_3 = wx.Button(self, wx.ID_ANY, _(u"Dict読込"))
        self.button_4 = wx.Button(self, wx.ID_ANY, _(u"Dict保存"))
        self.button_18 = wx.Button(self, wx.ID_ANY, _(u"Dict保存・実行"))
        self.button_7 = wx.Button(self, wx.ID_ANY, _(u"csv読込..."))
        self.button_8 = wx.Button(self, wx.ID_ANY, _(u"csv保存..."))
        self.label_3 = wx.StaticText(self, wx.ID_ANY, _(u"     追加:"), style=wx.ALIGN_RIGHT)
        self.button_15 = wx.Button(self, wx.ID_ANY, _(u"cellSet追加..."))
        self.button_14 = wx.Button(self, wx.ID_ANY, _(u"field追加..."))
        self.button_17 = wx.Button(self, wx.ID_ANY, _(u"topoSetEditor起動"))
        self.button_16 = wx.Button(self, wx.ID_ANY, _(u"gridEditor起動"))
        self.label_4 = wx.StaticText(self, wx.ID_ANY, _(" geometry:"), style=wx.ALIGN_RIGHT)
        self.button_9 = wx.Button(self, wx.ID_ANY, _(u"box追加"))
        self.button_10 = wx.Button(self, wx.ID_ANY, _(u"cylinder追加"))
        self.button_11 = wx.Button(self, wx.ID_ANY, _(u"sphere追加"))
        self.label_5 = wx.StaticText(self, wx.ID_ANY, _(u"     削除:"), style=wx.ALIGN_RIGHT)
        self.button_1 = wx.Button(self, wx.ID_ANY, _(u"行(cellSet)削除"))
        self.button_2 = wx.Button(self, wx.ID_ANY, _(u"列(field)削除"))
        self.button_12 = wx.Button(self, wx.ID_ANY, _(u"cellのクリア"))
        self.label_6 = wx.StaticText(self, wx.ID_ANY, _(u"   コピー:"), style=wx.ALIGN_RIGHT)
        self.button_5 = wx.Button(self, wx.ID_ANY, _(u"コピー"))
        self.button_13 = wx.Button(self, wx.ID_ANY, _(u"貼り付け"))
        self.grid_1 = wx.grid.Grid(self, wx.ID_ANY, size=(1, 1))
        self.static_line_2 = wx.StaticLine(self, wx.ID_ANY)
        self.button_6 = wx.Button(self, wx.ID_ANY, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onReloadData, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onSaveData, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onSaveExce, self.button_18)
        self.Bind(wx.EVT_BUTTON, self.onLoadCsvData, self.button_7)
        self.Bind(wx.EVT_BUTTON, self.onSaveCsvData, self.button_8)
        self.Bind(wx.EVT_BUTTON, self.onAddCellSets, self.button_15)
        self.Bind(wx.EVT_BUTTON, self.onAddFields, self.button_14)
        self.Bind(wx.EVT_BUTTON, self.onRunTopoSetEditor, self.button_17)
        self.Bind(wx.EVT_BUTTON, self.onRunGridEditor, self.button_16)
        self.Bind(wx.EVT_BUTTON, self.onAddBox, self.button_9)
        self.Bind(wx.EVT_BUTTON, self.onAddCylinder, self.button_10)
        self.Bind(wx.EVT_BUTTON, self.onAddSphere, self.button_11)
        self.Bind(wx.EVT_BUTTON, self.onDeleteRows, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onDeleteCols, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onAllCellsClear, self.button_12)
        self.Bind(wx.EVT_BUTTON, self.onCopyCells, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.onPaseteCells, self.button_13)
        self.Bind(wx.grid.EVT_GRID_CMD_SELECT_CELL, self.onSelectCell, self.grid_1)
        self.Bind(wx.grid.EVT_GRID_CMD_EDITOR_HIDDEN, self.onEditorHidden, self.grid_1)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_6)
        # end wxGlade

        self.Bind(wx.grid.EVT_GRID_CMD_CELL_RIGHT_CLICK, self.onCellRightClick, self.grid_1)
        self.Bind(wx.grid.EVT_GRID_CMD_LABEL_RIGHT_CLICK, self.onLabelRightClick, self.grid_1)
        self.Bind(wx.EVT_KEY_DOWN, self.onKeyDownEvent)
        #windowSizeの設定
        ver = wx.version().split()[0]
        tfVer = getTreeFoamVersion().split("+")
        if ver >= "3.0" and len(tfVer) == 1:
            self.SetSizeWH(winSize[0], winSize[1]-28)
        else:
            self.SetSize(winSize)
        #cellSet, fieldの有無をチェックし、警告表示
        self.checkNonSetsFieldName()


    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_(u"Fieldへのデータセット"))
        self.label_2.SetMinSize((70, 18))
        self.button_3.SetToolTipString(_(u"setFieldsDict内容を読み込み、cellにセット"))
        self.button_4.SetToolTipString(_(u"cell内容をsetFieldsDictに保存する"))
        self.button_18.SetToolTipString(_(u"setFieldsDictを作成し、実行する。"))
        self.button_7.SetToolTipString(_(u"csvファイルを読み込み、cellにセット"))
        self.button_8.SetToolTipString(_(u"cellデータをcsvファイルに保存"))
        self.label_3.SetMinSize((70, 18))
        self.button_15.SetToolTipString(_(u"cellSet（行）を追加する"))
        self.button_14.SetToolTipString(_(u"field（列）を追加する"))
        self.button_17.SetToolTipString(_(u"cellSetを作成"))
        self.button_16.SetToolTipString(_(u"field内容を確認"))
        self.label_4.SetMinSize((70, 18))
        self.button_9.SetToolTipString(_(u"boxToCellをcellにセット"))
        self.button_10.SetToolTipString(_(u"cylinderToCellをcellにセット"))
        self.button_11.SetToolTipString(_(u"sphereToCellをcellにセット"))
        self.label_5.SetMinSize((70, 18))
        self.button_1.SetToolTipString(_(u"選択行を削除する"))
        self.button_2.SetToolTipString(_(u"選択列（field）を削除する"))
        self.button_12.SetToolTipString(_(u"選択したcellデータをクリア"))
        self.label_6.SetMinSize((70, 18))
        self.button_5.SetToolTipString(_(u"選択したcellの内容をクリップボードにコピーする"))
        self.button_13.SetToolTipString(_(u"クリップボードの内容をcellに貼り付ける"))
        self.grid_1.CreateGrid(3, 3)
        # end wxGlade

        #表を作成
        self.checkFieldNamesSetNames()
        self.createMatrix()
        self.setDataToMatrix()
        self.grid_1.AutoSize()
        #popupMenuをセット
        self.setPopupCellMenu()
        self.setPopupColMenu()
        self.setPopupRowMenu()


    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_3 = wx.BoxSizer(wx.VERTICAL)
        sizer_10 = wx.GridSizer(1, 1, 0, 0)
        sizer_11 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.VERTICAL)
        sizer_8 = wx.BoxSizer(wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_14 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_13 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3.Add(self.label_1, 0, wx.TOP | wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_3.Add(self.static_line_1, 0, wx.ALL | wx.EXPAND, 5)
        sizer_13.Add(self.label_2, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_13.Add(self.button_3, 0, 0, 0)
        sizer_13.Add(self.button_4, 0, 0, 0)
        sizer_13.Add(self.button_18, 0, 0, 0)
        sizer_13.Add(self.button_7, 0, 0, 0)
        sizer_13.Add(self.button_8, 0, 0, 0)
        sizer_8.Add(sizer_13, 0, wx.EXPAND, 0)
        sizer_6.Add(self.label_3, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_6.Add(self.button_15, 0, 0, 0)
        sizer_6.Add(self.button_14, 0, 0, 0)
        sizer_6.Add(self.button_17, 0, 0, 0)
        sizer_6.Add(self.button_16, 0, 0, 0)
        sizer_8.Add(sizer_6, 1, wx.EXPAND, 0)
        sizer_14.Add(self.label_4, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_14.Add(self.button_9, 0, 0, 0)
        sizer_14.Add(self.button_10, 0, 0, 0)
        sizer_14.Add(self.button_11, 0, 0, 0)
        sizer_8.Add(sizer_14, 0, wx.EXPAND, 0)
        sizer_4.Add(self.label_5, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_4.Add(self.button_1, 0, 0, 0)
        sizer_4.Add(self.button_2, 0, 0, 0)
        sizer_4.Add(self.button_12, 0, 0, 0)
        sizer_8.Add(sizer_4, 1, wx.EXPAND, 0)
        sizer_5.Add(self.label_6, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_5.Add(self.button_5, 0, 0, 0)
        sizer_5.Add(self.button_13, 0, 0, 0)
        sizer_8.Add(sizer_5, 1, wx.EXPAND, 0)
        sizer_3.Add(sizer_8, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 0)
        sizer_2.Add(self.grid_1, 1, wx.ALL | wx.EXPAND, 10)
        sizer_1.Add(sizer_2, 1, wx.EXPAND, 0)
        sizer_3.Add(sizer_1, 1, wx.EXPAND, 0)
        sizer_3.Add(self.static_line_2, 0, wx.ALL | wx.EXPAND, 5)
        sizer_11.Add(self.button_6, 0, wx.ALL | wx.ALIGN_RIGHT, 15)
        sizer_10.Add(sizer_11, 1, wx.ALIGN_RIGHT, 0)
        sizer_3.Add(sizer_10, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_3)
        sizer_3.Fit(self)
        self.Layout()
        # end wxGlade

    #--------------setPopupMenu-------------
    #  setPopupCellMenu
    #    cellのpopupMenuを定義
    def setPopupCellMenu(self):
        self.popupCellMenu = wx.Menu()
        menu = [_(u"cellコピー\tCtrl+C"), _(u"cell貼付\tCtrl+V"), "-", _(u"cellクリア")]
        for text in menu:
            if text == "-":
                self.popupCellMenu.AppendSeparator()
            else:
                item = self.popupCellMenu.Append(-1, text)
                self.Bind(wx.EVT_MENU, self.onPopCellItemSelected, item)

    #  setPopupColMenu
    #    col（列）のpopupMenuを定義
    def setPopupColMenu(self):
        self.popupColMenu = wx.Menu()
        menu = [_(u"field追加..."), "-",  _(u"列(field)削除")]
        for text in menu:
            if text == "-":
                self.popupColMenu.AppendSeparator()
            else:
                item = self.popupColMenu.Append(-1, text)
                self.Bind(wx.EVT_MENU, self.onPopColItemSelected, item)

    #  setPopupRowMenu
    #    row（行）のpopupMenuを定義
    def setPopupRowMenu(self):
        self.popupRowMenu = wx.Menu()
        menu = [_(u"cellSet追加..."), _(u"box追加"), _(u"cylinder追加"), _(u"sphere追加"), "-", _(u"行(cellSet)削除")]
        for text in menu:
            if text == "-":
                self.popupRowMenu.AppendSeparator()
            else:
                item = self.popupRowMenu.Append(-1, text)
                self.Bind(wx.EVT_MENU, self.onPopRowItemSelected, item)



    #Dict読み込み
    def onReloadData(self, event):  # wxGlade: MyFrame.<event_handler>
        self.reloadData(event)

    #Dict保存
    def onSaveData(self, event):  # wxGlade: MyFrame.<event_handler>
        self.saveData(event)

    #Dict保存・実行
    def onSaveExce(self, event):  # wxGlade: MyFrame.<event_handler>
        self.saveExec(event)

    #csv読み込み
    def onLoadCsvData(self, event):  # wxGlade: MyFrame.<event_handler>
        self.loadCsvData(event)

    #csv保存
    def onSaveCsvData(self, event):  # wxGlade: MyFrame.<event_handler>
        self.saveCsvData(event)

    #field追加
    def onAddFields(self, event):  # wxGlade: MyFrame.<event_handler>
        self.addFields(event)

    #cellSet追加
    def onAddCellSets(self, event):  # wxGlade: MyFrame.<event_handler>
        self.addCellSets(event)

    #gridEditor起動
    def onRunGridEditor(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runGridEditor(event)

    #topoSetEditor起動
    def onRunTopoSetEditor(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runTopoSetEditor(event)

    #box追加
    def onAddBox(self, event):  # wxGlade: MyFrame.<event_handler>
        self.addBox(event)

    #cylinder追加
    def onAddCylinder(self, event):  # wxGlade: MyFrame.<event_handler>
        self.addCylinder(event)

    #sphere追加
    def onAddSphere(self, event):  # wxGlade: MyFrame.<event_handler>
        self.addSphere(event)

    #行削除（cellSet）
    def onDeleteRows(self, event):  # wxGlade: MyFrame.<event_handler>
        self.deleteRows(event)

    #列削除（field）
    def onDeleteCols(self, event):  # wxGlade: MyFrame.<event_handler>
        self.deleteCols(event)

    #cellクリア
    def onAllCellsClear(self, event):  # wxGlade: MyFrame.<event_handler>
        self.cellsClear(event)

    #コピー
    def onCopyCells(self, event):  # wxGlade: MyFrame.<event_handler>
        self.copyCells(event)

    #貼り付け
    def onPaseteCells(self, event):  # wxGlade: MyFrame.<event_handler>
        self.pasteCells(event)

    #閉じる
    def onClose(self, event):  # wxGlade: MyFrame.<event_handler>
        self.endingProc()
        flag = self.checkSaveFlagExit()
        if flag == "RETURN":
            return
        elif flag == "SAVE":
            self.saveData(event)
            self.Destroy()
        elif flag == "EXIT":
            self.Destroy()

    #cellEditorが閉じた時
    def onEditorHidden(self, event):  # wxGlade: MyFrame.<event_handler>
        self.editorHidden(event)
        event.Skip()

    #cellを選択した時
    def onSelectCell(self, event):  # wxGlade: MyFrame.<event_handler>
        self.autoCellSize(event)
        event.Skip()

    #cellを右クリックした時
    def onCellRightClick(self, event):
        self.cellRightClick(event)

    #labelを右クリックした時
    def onLabelRightClick(self, event):
        self.labelRightClick(event)

    #cellを右クリック
    def onPopCellItemSelected(self, event):
        PPitem = self.popupCellMenu.FindItemById(event.GetId())
        text = PPitem.GetText()
        #cellコピー
        if text == _(u"cellコピー\tCtrl+C"):
            self.copyCells(event)
        #cell貼付
        elif text == _(u"cell貼付\tCtrl+V"):
            self.pasteCells(event)
        #クリア
        elif text == _(u"cellクリア"):
            self.cellsClear(event)

    #colLabelを右クリック
    def onPopColItemSelected(self, event):
        PPitem = self.popupColMenu.FindItemById(event.GetId())
        text = PPitem.GetText()
        #field追加
        if text == _(u"field追加..."):
            self.addFields(event)
        #列(field)削除
        elif text == _(u"列(field)削除"):
            self.deleteCols(event)

    #rowLabelを右クリック
    def onPopRowItemSelected(self, event):
        PPitem = self.popupRowMenu.FindItemById(event.GetId())
        text = PPitem.GetText()
        #cellSet追加
        if text == _(u"cellSet追加..."):
            self.addCellSets(event)
        #box追加
        elif text == _(u"box追加"):
            self.addBox(event)
        #cylinder追加
        elif text == _(u"cylinder追加"):
            self.addCylinder(event)
        #sphere追加
        elif text == _(u"sphere追加"):
            self.addSphere(event)
        #行(cellSet）削除
        elif text == _(u"行(cellSet)削除"):
            self.deleteRows(event)

    #keyEvent
    def onKeyDownEvent(self, event):
        code = event.GetKeyCode()
        #cellコピー(ctrl+C)
        if code == 67:
            self.copyCells(event)
        #cell貼付(ctrl+V)
        elif code == 86:
            self.pasteCells(event)
        event.Skip()

# end of class MyFrame


    #--------------popupMenu----------------------
    #
    #  cellRightClick
    #    cellを右クリックした時
    def cellRightClick(self, event):
        global curRow, curCol
        curRow = event.GetRow()
        curCol = event.GetCol()
        pos = event.GetPosition()
        self.grid_1.PopupMenu(self.popupCellMenu, pos)
        event.Skip()

    #
    #  labelRightClick
    #    labelを右クリックした時
    def labelRightClick(self, event):
        global curRow, curCol
        curRow = event.GetRow()
        curCol = event.GetCol()
        pos = event.GetPosition()
        if (curRow==-1) and (curCol>=0):
            #列を選択
            self.grid_1.PopupMenu(self.popupColMenu, pos)
        elif (curRow>=0) and (curCol==-1):
            #行を選択
            self.grid_1.PopupMenu(self.popupRowMenu, pos)           
        event.Skip()
    #---------------------------------------------------

    #
    #  pasteCells
    #    cellに貼り付け
    def pasteCells(self, event):
        pasteVals = self.getPasteValsFromClipBoard()
        #行を取得
        vals = getMultiLines(pasteVals)
        #1行毎に値を取得しlistを作成
        values = []
        for line in vals:
            row = line.split("\t")
            rows = []
            for val in row:
                #「"」マークの処理
                if len(val) == 0:
                    b = ""
                elif len(val) == 1:
                    b = val
                elif val[0] == '"':
                    b = val[1:-1]
                else:
                    b = val
                rows.append(b)
            values.append(rows)
        #値をgridにセット
        self.pasteValsToCells(values)
        #saveFlagをセット
        self.setSaveWarningFlag()

    #
    #  copyCells
    #    クリップボードにコピー
    def copyCells(self, event):
        copyValues = self.getCopyValues()
        flag = self.copyToClipBoard(copyValues)
        if flag == False:
            title = _(u"エラー")
            mess = _(u"クリップボードにコピーできませんでした。")
            self.errDialog(title, mess)

    #  pasteValsToCells
    #    値をcellにセット
    def pasteValsToCells(self, vals):
        global colNames, rowNames, colRowNames, curRow, curCol
        #選択場所を取得
        firstSelection = []
        endSelection = []
        flag = 0
        row = 0
        while row<len(rowNames):
            col = 0
            while col<len(colNames):
                if self.grid_1.IsInSelection(row, col) == True:
                    if flag == 0:
                        firstSelection = [row, col]
                    endSelection = [row, col]
                    flag = 1
                col += 1
            row += 1
        if len(firstSelection) == 0:
            endSelection = [curRow, curCol]
            firstSelection = [curRow, curCol]
        #paste開始
        #  1ヶ分をpaste
        row = firstSelection[0]
        vRow = 0
        while vRow<len(vals):
            col = firstSelection[1]
            vCol = 0
            while vCol<len(vals[vRow]):
                val = vals[vRow][vCol]
                if row<len(rowNames) and col<len(colNames):
                    colRowData[col][row] = val
                col += 1
                vCol += 1
            row += 1
            vRow += 1
        #  残りをpaste(row側)
        if row<endSelection[0]+1:
            vRow = 0
            while row<endSelection[0]+1:
                col = firstSelection[1]
                vCol = 0
                while vCol<len(vals[vRow]):
                    if row<len(rowNames) and col<len(colNames):
                        val = vals[vRow][vCol]
                        colRowData[col][row] = val
                    col += 1
                    vCol += 1
                row += 1
                vRow += 1
                if vRow>=len(vals):
                    vRow = 0
            endPaste = [row, col]
        else:
            endPaste = [row, col]
        #  残りpaste（col側）
        if col<endSelection[1]+1:
            vCol = 0
            col = endPaste[1]
            while col<endSelection[1]+1:
                row = firstSelection[0]
                vRow = 0
                while row<endPaste[0]:
                    if row<len(rowNames) and col<len(colNames):
                        val = vals[vRow][vCol]
                        colRowData[col][row] = val
                    row += 1
                    vRow += 1
                    if vRow>=len(vals):
                        vRow = 0
                col += 1
                vCol += 1
                if vCol>=len(vals[vRow]):
                    vCol = 0
        self.createMatrix()
        self.setDataToMatrix()
        self.grid_1.AutoSize()
        self.Layout()

    #  getCopyValues
    #    copy値を取得
    def getCopyValues(self):
        global colNames, rowNames, colRowData, curRow, curCol
        #vals = []
        colRows = []
        #flag = 0
        #選択範囲を取得
        row = 0
        while row<len(rowNames):
            col = 0
            while col<len(colNames):
                if self.grid_1.IsInSelection(row, col) == True:
                    colRows.append([col, row])
                col += 1
            row += 1
        #選択範囲が空文の場合、選択範囲をcurrentCellに設定
        if len(colRows) == 0:
            if curRow>=0 and curCol>=0:
                colRows.append([curCol, curRow])
        #選択範囲が設定されている場合
        if len(colRows) != 0:
            #行毎に値を取得
            ans = ""
            bRow = colRows[0][1]
            rows = []
            for [col, row] in colRows:
                if row == bRow:
                    rows.append('"'+colRowData[col][row]+'"')
                else:
                    bRow = row
                    line = "\t".join(rows)
                    #line = ",".join(rows)
                    ans += line + "\r\n"
                    rows = []
                    rows.append('"'+colRowData[col][row]+'"')
            #行毎の値を tab区切りデータ＋\n のデータ形式に変換
            if len(rows) != 0:
                line = "\t".join(rows)
                #line = ",".join(rows)
                ans += line + "\r\n"
            ans = ans[:-2]
        else:
            ans = ""
        return ans

    #  getPasteValsFromClipBoard
    #    クリップボードからテキストデータを取得
    #    clipBoardをcloseする
    def getPasteValsFromClipBoard(self):
        clipBoard = os.getenv("TreeFoamUserPath") + "/data/clipBoard"
        f=open(clipBoard); pasteVals = f.read(); f.close()
        return pasteVals
        """
        success = False
        pasteVals = ""
        data = wx.URLDataObject()
        wx.TheClipboard.Open()
        success = wx.TheClipboard.GetData(data)
        if success:
            #self.t2.SetValue(data.GetText())
            #self.t2.SetValue(data.GetURL())
            pasteVals = data.GetURL()
        wx.TheClipboard.Close()
        return pasteVals
        """

    #  copyToClipBoard
    #    クリップボードへコピー
    #    clipBoardはcloseしない
    def copyToClipBoard(self, copyValues):
        clipBoard = os.getenv("TreeFoamUserPath") + "/data/clipBoard"
        f=open(clipBoard, "w"); f.write(copyValues); f.close()
        """
        wx.TheClipboard.Close()
        data = wx.TextDataObject()
        success = False
        data.SetText(copyValues)
        if wx.TheClipboard.Open():
            wx.TheClipboard.SetData(data)
            #wx.TheClipboard.Close()
            success = True
        return success
        """

    #
    #  deleteCols
    #    列（field）削除
    def deleteCols(self, event):
        global colNames, rowNames, colRowData
        delCols = self.grid_1.GetSelectedCols()
        for delCol in delCols:
            if delCol == 0:
                title = _(u"エラー")
                mess = _(u"最初の列は、削除できません。")
                self.errDialog(title, mess)
                return
        if len(delCols) == 0:
            title = _(u"列削除")
            mess = _(u"削除する列が選択されていません。\n")
            mess += _(u"列を選択してください。")
            self.warningDialog(title, mess)
            return
        #colLabelData削除
        newColNames = []
        newColRowData = []
        col = 0
        while col<len(colNames):
            flag = 0
            cols = colRowData[col]
            for delCol in delCols:
                if col == delCol:
                    flag = 1
                    break
            if flag == 0:
                newColNames.append(colNames[col])
                newColRowData.append(cols)
            col += 1
        colNames = newColNames
        colRowData = newColRowData
        self.createMatrix()
        self.setDataToMatrix()
        self.grid_1.AutoSize()
        self.Layout()
        #saveFlagをセット
        self.setSaveWarningFlag()

    #
    #  deleteRows
    #    行（cellSet）削除
    def deleteRows(self, event):
        global colNames, rowNames, colRowData
        delRows = self.grid_1.GetSelectedRows()
        for delRow in delRows:
            if delRow == 0:
                title = _(u"エラー")
                mess = _(u"最初の行は、削除できません。")
                self.errDialog(title, mess)
                return
        if len(delRows) == 0:
            title = _(u"行削除")
            mess = _(u"削除する行が選択されていません。\n")
            mess += _(u"行を選択してください。")
            self.warningDialog(title, mess)
            return
        #rowLabel削除
        newRowNames = []
        row = 0
        while row<len(rowNames):
            flag = 0
            for delRow in delRows:
                if row == delRow:
                    flag = 1
                    break
            if flag == 0:
                newRowNames.append(rowNames[row])
            row += 1
        #dataを削除
        newColRowData = []
        col = 0
        while col<len(colNames):
            cols = []
            row = 0
            while row<len(rowNames):
                flag = 0
                for delRow in delRows:
                    if row == delRow:
                        flag = 1
                        break
                if flag == 0:
                    cols.append(colRowData[col][row])
                row += 1
            newColRowData.append(cols)
            col += 1
        rowNames = newRowNames
        colRowData = newColRowData
        self.createMatrix()
        self.setDataToMatrix()
        self.grid_1.AutoSize()
        self.Layout()
        #saveFlagをセット
        self.setSaveWarningFlag()

    #
    #  addCellSets
    #    表にcellSetsを追加
    def addCellSets(self, event):
        global rowNames, colNames, colRowData, caseDir, timeFolder, selRegion
        #選択できるcellSetsを取得
        relativeDir = getFoamContents.getCurrMeshDir(caseDir, timeFolder, selRegion, "sets")
        polyMeshDir = caseDir + "/" + relativeDir
        [allCellSets, faceSets, pointSets] = topoSetEditor.getSetsFiles(polyMeshDir)
        selCellSets = rowNames
        remCellSets = []
        for cellSet in allCellSets:
            flag = 0
            for selCellSet in selCellSets:
                if cellSet == selCellSet:
                    flag = 1
                    break
            if flag == 0:
                remCellSets.append(cellSet)
        #追加するcellSetを取得
        title = _(u"cellSet追加")
        mess = _(u"追加するcellSetを選択してください。\n複数選択が可能。")
        itemName = _(u"選択できるcellSet")
        [stat, cellSets] = selectNamesDDialog.Show(title, mess, itemName, remCellSets)
        if stat == "OK":
            rowNames += cellSets
            col = 0
            while col<len(colNames):
                cols = []
                for cellSet in cellSets:
                    cols.append("")
                colRowData[col] += cols
                col += 1
            self.createMatrix()
            self.setDataToMatrix()
            self.grid_1.AutoSize()
            self.Layout()
            #saveFlagをセット
            self.setSaveWarningFlag()

    #
    #  addFields
    #    表にfieldを追加
    def addFields(self, event):
        global rowNames, colNames, colRowData, caseDir, timeFolder, selRegion
        global fieldTypes
        #選択できるfieldを取得
        fieldDir = caseDir + "/" + timeFolder + "/" + selRegion
        allFields = pyTreeFoam.getFieldNames(fieldDir)
        selFields = colNames[1:]
        remFields = []
        for field in allFields:
            flag = 0
            for selField in selFields:
                if field == selField:
                    flag = 1
                    break
            if flag == 0:
                remFields.append(field)
        #追加するfieldを取得
        title = _(u"field追加")
        mess = _(u"追加するFieldを選択してください。\n複数選択が可能。")
        itemName = _(u"選択できるfield")
        [stat, fields] = selectNamesDDialog.Show(title, mess, itemName, remFields)
        if stat == "OK":
            #表の変数を設定
            colNames += fields
            cols = []
            row = 0
            while row<len(rowNames):
                cols.append("")
                row += 1
            for field in fields:
                colRowData.append(cols)
            #fieldTypesを取得
            getFieldTypes()
            #表を作成
            self.createMatrix()
            self.setDataToMatrix()
            self.grid_1.AutoSize()
            self.Layout()
            #saveFlagをセット
            self.setSaveWarningFlag()


    #
    #  runGridEditor
    #    gridEditorの起動
    def runGridEditor(self, event):
        global caseDir, timeFolder, selRegion, colNames
        if len(colNames) < 2:
            return
        #gridEditor起動
        fields = colNames[1:]
        fieldDir = caseDir + "/" + timeFolder + "/" + selRegion
        pyTreeFoam.saveDisplayFields(fields, fieldDir)
        caseFolder = caseDir.split("/")[-1]
        title = ": " + caseFolder + "/" + timeFolder + "/" + selRegion
        boundaryDir = getFoamContents.getCurrMeshDir(caseDir, timeFolder, selRegion, "boundary")
        comm = "runGridEditor.py "
        comm+= "-1" + " '" + title + "' " + boundaryDir + " " + fieldDir
        comm+= " &"
        os.system(comm)

    #
    #  runTopoSetEditor
    #    topoSetEditorの起動
    def runTopoSetEditor(self, event):
        global timeFolder, selRegion
        comm = "topoSetEditor.py . ./model " + timeFolder + " " + selRegion + " &"
        os.system(comm)

    #
    #  cellsClear
    #    cellをクリア
    def cellsClear(self, event):
        global colRowData
        #cellクリア
        clear = 0
        col = 0
        while col<len(colNames):
            row = 0
            while row<len(rowNames):
                if self.grid_1.IsInSelection(row, col) == True:
                    colRowData[col][row] = ""
                    clear = 1
                row += 1
            col += 1
        if clear == 0:
            if curRow<0 and curCol<0:
                title = _(u"cellのクリア")
                mess = _(u"clearするcellが選択されていません。\n")
                mess += _(u"cellを選択してください。")
                self.warningDialog(title, mess)
            else:
                colRowData[curCol][curRow] = ""
                self.createMatrix()
                self.setDataToMatrix()
                self.grid_1.AutoSize()
                self.Layout()
                #saveFlagをセット
                self.setSaveWarningFlag()
        else:
            self.createMatrix()
            self.setDataToMatrix()
            self.grid_1.AutoSize()
            self.Layout()
            #saveFlagをセット
            self.setSaveWarningFlag()

    #
    #  addBox
    #    boxを追加
    def addBox(self, event):
        name = "(box)"
        nameCont = "box (0 0 0) (1 1 1);"
        self.addGeometry(name, nameCont)

    #
    #  addCylinder
    #    cylinderを追加
    def addCylinder(self, event):
        name = "(cylinder)"
        nameCont  = "p1 (0.2 0.2 -10);\n"
        nameCont += "p2 (0.2 0.2 0);\n"
        nameCont += "radias 5.0;"
        self.addGeometry(name, nameCont)

    #
    #  addSphere
    #    sphereを追加
    def addSphere(self, event):
        name = "(sphere)"
        nameCont  = "centre (0.2 0.2 -10);\n"
        nameCont += "radias 5.0;"
        self.addGeometry(name, nameCont)

    #  addGeometry
    #    geometryを追加
    def addGeometry(self, name, cont):
        global rowNames, colRowData
        rowNames.append(name)
        row = len(rowNames) - 1
        col = 0
        while col<len(colNames):
            colRowData[col].append("")
            col += 1
        colRowData[0][row] = cont
        self.createMatrix()
        self.setDataToMatrix()
        self.grid_1.AutoSize()
        self.Layout()
        #saveFlagをセット
        self.setSaveWarningFlag()

    #
    #  loadCsvData
    #    csvDataを読み込み
    def loadCsvData(self, event):
        global csvFileName, rowNames, colNames, colRowData, caseDir
        stat = self.checkSaveFlagGo()
        if stat == "RETURN":
            return
        elif stat == "SAVE":
            self.saveData(event)
        title = _(u"csvデータ読み込み")
        mess = _(u"setFieldsDict用のcsvファイルを読み込みます。\n")
        mess += _(u"読み込むcsvファイルを選択してください。")
        fileFilter = "*.csv"
        [stat, fileName] = getOpenFileDDialog.seledSelFileShow(title, mess, caseDir, fileFilter, csvFileName)
        if stat == "OK":
            #csv読み込み
            csvFileName = fileName
            csvFileNamePath = caseDir + "/" + fileName
            #tab区切りorカンマ区切りのチェック
            f=open(csvFileNamePath); line=f.readline(); f.close()
            if len(line.split("\t")) != 1:
                #tab区切りの読み込み
                f=open(csvFileNamePath); tabCont=f.readlines(); f.close()
                contents = []
                for line in tabCont:
                    contents.append(",".join(line.split("\t")))
                cont = csv.reader(contents)
            else:
                #カンマ区切りの読み込み
                cont = csv.reader(file(csvFileNamePath))
            #データの取り込み
            colNames = []
            rowNames = []
            rowCol = []
            flag = 0
            row = 0
            for line in cont:
                if flag == 1:
                    #データの読み込み
                    rowNames.append(line[0])
                    cols = []
                    col = 1
                    while col<len(line):
                        cols.append(line[col])
                        col += 1
                    rowCol.append(cols)
                    row += 1
                if line[0] == "items":
                    #title行の読み込み
                    flag = 1
                    col = 1
                    while col<len(line):
                        colNames.append(line[col])
                        col += 1
            #dataセット
            colRowData = []
            col = 0
            while col<len(colNames):
                row = 0
                rows = []
                while row<len(rowNames):
                    rows.append(rowCol[row][col])
                    row += 1
                colRowData.append(rows)
                col += 1
            #matrix作成
            self.checkFieldNamesSetNames()
            self.createMatrix()
            self.setDataToMatrix()
            self.grid_1.AutoSize()
            self.Layout()
            self.checkNonSetsFieldName()
            #saveFlagをクリア
            self.clearSaveWarningFlag()
            title = _(u"csvファイルの読み込み")
            mess = _(u"setFieldsDict用のcsvファイルを読み込みました。")
            self.okDialog(title, mess)

    #
    #  saveCsvData
    #    csv保存
    def saveCsvData(self, event):
        global csvFileName, rowNames, colNames, colRowData
        #file名の取得
        inputTextDDialog.title = _(u"ファイル名の入力")
        inputTextDDialog.message = _(u"csvファイル名を入力してください。")
        inputTextDDialog.inputText = "setFieldsDict.csv"
        dialog = inputTextDDialog.MyDialog(None)
        result = dialog.ShowModal()
        if inputTextDDialog.status == "OK":
            text = inputTextDDialog.inputText
        else:
            text = u""
        if text != u"":
            #保存開始
            csvFileName = text
            csvFileNamePath = caseDir + "/" + csvFileName 
            if len(glob.glob(csvFileNamePath)) != 0:
                title = _(u"csvファイルの作成")
                mess = _(u"既に同じファイルが存在します。")
                mess += _(u"上書きされます。")
                stat = self.okCancelDialog(title, mess)
                if stat != "OK":
                    return
            #表中のデータをcolRowDataに反映させる
            self.getMatrixData()
            #csvファイル作成
            error = createCsvSaveData(csvFileNamePath, rowNames, colNames, colRowData)
            if error[0] == "OK":
                #saveFlagをクリア
                self.clearSaveWarningFlag()
                #message表示
                title = _(u"csv保存")
                mess = _(u"scv形式で保存しました。")
                self.okDialog(title, mess)
            else:
                title = _(u"エラー")
                mess = error[1]
                self.errDialog(title, mess)
        return

    #  getMatrixData
    #    表中のデータをcolRowDataに反映させる。
    def getMatrixData(self):
        col = 0
        while col<len(colNames):
            row = 0
            while row<len(rowNames):
                colRowData[col][row] = self.grid_1.GetCellValue(row, col)
                row += 1
            col += 1

    #
    #  saveExec
    #    cellDataをDictに保存し、setFieldsを実行する。
    def saveExec(self, event):
        print _(u"setFieldsDictを作成します...")
        global rowNames, colNames, colRowData
        #cellデータ取得
        saveData = []
        col = 0
        while col<len(colNames):
            row = 0
            fieldData = []
            while row<len(rowNames):
                cellValue = self.grid_1.GetCellValue(row, col)
                fieldData.append(cellValue)
                row += 1
            saveData.append(fieldData)
            col += 1
        #データをDictに保存
        error = saveDictData(rowNames, colNames, saveData)
        if error[0] != "OK":
            title = _(u"エラー")
            mess = error[1]
            self.errDialog(title, mess)
            return

        #saveFlagをクリア
        self.clearSaveWarningFlag()
        #setFields実行
        print _(u"setFieldsを実行します...")
        comm = "setFields"
        stat = pyTreeFoam.runOFUtilityReturnStat(comm)
        if stat[0] == "OK":
            title = _(u"setFields実行")
            mess = _(u"setFieldsを実行して、dataをfieldにセットしました。")
            self.okDialog(title, mess)
        else:
            title = _(u"エラー")
            mess  = _(u"setFields実行時に、")
            mess += _(u"エラーが発生しました。\n  logを確認してください。")
            self.errDialog(title, mess)
        return

    #
    #  saveData
    #    cellDataをDictfileに保存
    def saveData(self, event):
        global rowNames, colNames, colRowData
        #cellデータ取得
        saveData = []
        col = 0
        while col<len(colNames):
            row = 0
            fieldData = []
            while row<len(rowNames):
                cellValue = self.grid_1.GetCellValue(row, col)
                fieldData.append(cellValue)
                row += 1
            saveData.append(fieldData)
            col += 1
        #データをDictに保存
        error = saveDictData(rowNames, colNames, saveData)
        if error[0] == "OK":
            #saveFlagをクリア
            self.clearSaveWarningFlag()
            #message表示
            title = _(u"Dictへ保存")
            mess = _(u"cellDataをsetFieldsDictに保存しました")
            self.okDialog(title, mess)
        else:
            title = _(u"エラー")
            mess = error[1]
            self.errDialog(title, mess)

    #
    #  reloadData
    #    Dict読み込み
    def reloadData(self, event):
        stat = self.checkSaveFlagGo()
        if stat == "RETURN":
            return
        elif stat == "SAVE":
            self.saveData(event)
        getColRowLabelFromDict()
        self.checkFieldNamesSetNames()
        self.createMatrix()
        self.setDataToMatrix()
        self.grid_1.AutoSize()
        self.Layout()
        self.checkNonSetsFieldName()
        #保存flagをクリア
        self.clearSaveWarningFlag()
        #messageを表示
        title = _(u"Dict読み込み")
        mess = _(u"setFieldsDictを読み込みました")
        print mess
        self.okDialog(title, mess)

    #
    #  editorHiiden
    #    cellEditorを隠したとき
    def editorHidden(self, event):
        #curRow, curColを取得し、表をautoSizeで書き換える
        self.autoCellSize(event)
        #データが書き換わったかどうかチェック
        self.checkRewrite()
        #表中のデータをcolRowDataに反映
        self.getMatrixData()

    #  autoCellSize
    #    cellSizeを修正する
    def autoCellSize(self, event):
        global curRow, curCol
        row = event.GetRow()
        col = event.GetCol()
        curRow = row
        curCol = col
        self.grid_1.AutoSizeColumn(col, True)
        self.grid_1.AutoSizeRow(row, True)
        self.grid_1.ForceRefresh()

    #
    #  checkSaveFlagGo
    #    処理前にsaveFlagをチェックする
    def checkSaveFlagGo(self):
        title     = _(u"setFieldsDict作成")
        message   = _(u"cell内容が変更されています。\n  このまま処理を継続すると、変更内容が失われます。")
        cancelMsg = _(u"キャンセル")
        goMsg     = _(u"このまま続行")
        saveGoMsg = _(u"保存して続行")
        ans = self.checkSaveFlagGetNextJob(title, message, cancelMsg, goMsg, saveGoMsg)
        return ans


    #  checkSaveFlagExit
    #    close時のsaveFlagをチェック
    def checkSaveFlagExit(self):
        title     = _(u"setFieldsDict作成")
        message   = _(u"cell内容が変更されています。\n  このまま終了しますか？")
        cancelMsg = _(u"キャンセル")
        goMsg     = _(u"このまま終了")
        saveGoMsg = _(u"保存して終了")
        ans = self.checkSaveFlagGetNextJob(title, message, cancelMsg, goMsg, saveGoMsg)
        return ans

    #
    #  checkSaveFlagGetNextJob
    #    saveFlagをチェックし、次の処理を取得
    #    戻り値
    #       "RETURN"   キャンセル
    #       "SAVE"     保存して処理
    #       "EXIT"     処理
    def checkSaveFlagGetNextJob(self, title, mess, cancel, go, saveGo):
        titleD = self.GetTitle()
        if titleD[0] == "*":
            saveAndNextJobDDialog.title     = title
            saveAndNextJobDDialog.message   = mess
            saveAndNextJobDDialog.cancelMsg = cancel
            saveAndNextJobDDialog.goMsg     = go
            saveAndNextJobDDialog.saveGoMsg = saveGo
            dialog = saveAndNextJobDDialog.MyDialog(None)
            result = dialog.ShowModal()
            ans = saveAndNextJobDDialog.status
            return ans
        else:
            return "EXIT"

    #  checkRewrite
    #    データが書き換わったかどうかチェックし、flagをセット
    def checkRewrite(self):
        global curRow, curCol, colRowData
        oldValue = colRowData[curCol][curRow]
        nowValue = self.grid_1.GetCellValue(curRow, curCol)
        if oldValue != nowValue:
            self.setSaveWarningFlag()

    #  setSaveWarningFlag
    #    表中のデータが書き換わった場合、falagを立てる
    def setSaveWarningFlag(self):
        title = self.GetTitle()
        if title[0] != "*":
            title = "*" + title
            self.SetTitle(title)

    #  clearSaveWarningFlag
    #    保存flagをクリアする
    def clearSaveWarningFlag(self):
        title = self.GetTitle()
        if title[0] == "*":
            self.SetTitle(title[1:])

    #
    #  createMatrix
    #    表を作成する
    def createMatrix(self):
        #row, colを作成
        rowLabelSize = 150.0        #rowLabelの幅
        colLabelSize = 60.0         #colLabelの高さ
        self.grid_1.SetRowLabelSize(rowLabelSize)
        self.grid_1.SetColLabelSize(colLabelSize)
        #表の大きさを合わせる
        if self.grid_1.GetNumberRows() < len(rowNames):
            addRows = len(rowNames) - self.grid_1.GetNumberRows()
            self.grid_1.AppendRows(addRows)
        else:
            delRows = self.grid_1.GetNumberRows() - len(rowNames)
            if delRows != 0:
                self.grid_1.DeleteRows(0, delRows)
        if self.grid_1.GetNumberCols() < len(colNames):
            addCols = len(colNames) - self.grid_1.GetNumberCols()
            self.grid_1.AppendCols(addCols)
        else:
            delCols = self.grid_1.GetNumberCols() - len(colNames)
            if delCols != 0:
                self.grid_1.DeleteCols(0, delCols)
        #項目をセット（行名）
        row = 0
        for rowName in rowNames:
            self.grid_1.SetRowLabelValue(row, rowName)
            row += 1
        #項目をセット（列名）
        col = 0
        for colName in colNames:
            self.grid_1.SetColLabelValue(col, colName)
            col += 1
        #editorをセット（全てmultiLineEditorにセット）
        #  ver3.0以上は、cellEditorをセットしない
        ver = wx.version().split()[0]
        if ver < "3.0":
            self.editor = wx.grid.GridCellAutoWrapStringEditor()
            self.grid_1.SetDefaultEditor(self.editor)
        """
        row = 0
        while row < len(rowNames):
            col = 0
            while col < len(colNames):
                self.grid_1.SetCellEditor(
                    row, col, wx.grid.GridCellAutoWrapStringEditor())
                col += 1
            row += 1
        """

    #
    #  checkFieldNamesSetNames
    #    fieldNameとsetNameをチェックする。
    def checkFieldNamesSetNames(self):
        global rowNames, colNames, polyMeshDir
        global nonFieldNames, nonSetNames
        newFieldNames = []
        nonFieldNames = []
        newSetNames = []
        nonSetNames = []
        #setNameをチェック
        row = 1
        files = glob.glob(polyMeshDir + "/sets/*")
        setsFiles = []
        for name in files:
            setsFiles.append(name.split("/")[-1])
        while row<len(rowNames):
            setName = rowNames[row]
            flag = 0
            if (setName == "(box)" or setName == "(cylinder)" or
                setName == "(sphere)"):
                newSetNames.append(setName)
                flag = 1
            else:
                for name in setsFiles:
                    if setName == name:
                        newSetNames.append(setName)
                        flag = 1
                        break
            if flag == 0:
                nonSetNames.append(setName)
            row += 1
        #fieldNameをチェック
        col = 1
        fields = pyTreeFoam.getFieldNames(caseDir + "/" + timeFolder + "/" + selRegion)
        while col<len(colNames):
            fieldName = colNames[col]
            flag = 0
            for name in fields:
                if fieldName == name:
                    newFieldNames.append(fieldName)
                    flag = 1
                    break
            if flag == 0:
                nonFieldNames.append(fieldName)
            col += 1
        #set, fieldNameをセット
        rowNames = [rowNames[0]] + newSetNames
        colNames = [colNames[0]] + newFieldNames

    #
    #  checkNonSetsFieldName
    #    存在しないcellSet、fieldを確認し、警告表示
    def checkNonSetsFieldName(self):
        global nonFieldNames, nonSetNames
        mess = ""
        if len(nonFieldNames) != 0:
            mess += _(u"以下のfieldが存在しないので、表示していません。\n")
            i = 0
            while i<10 and i<len(nonFieldNames):
                mess += nonFieldNames[i] + ", "
                i += 1
            mess = mess[:-2]
            if i >= 10:
                mess += "..."
        if len(nonSetNames) != 0:
            mess += _(u"\n以下のcellSetが存在しないので、表示していません。\n")
            i = 0
            while i<10 and i<len(nonSetNames):
                mess += nonSetNames[i] + ", "
                i += 1
            mess = mess[:-2]
            if i>=10:
                mess += "..."
        if mess != "":
            print mess
            title = _(u"警告")
            self.warningDialog(title, mess)

    #
    #  setDataToMatrix
    #    gridにデータセット
    def setDataToMatrix(self):
        global colRowData
        col = 0
        while col<len(colRowData):
            fieldData = colRowData[col]
            row = 0
            while row<len(fieldData):
                cellData = fieldData[row]
                self.grid_1.SetCellValue(row, col, cellData)
                row += 1
            col += 1

    #  endingProc
    #    終了処理
    def endingProc(self):
        winSize = self.GetSize()
        saveWinSize(winSize)

    #-----------------------------------
    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def warningDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_QUESTION) 
        dlg.ShowModal()
        dlg.Destroy()

    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        stat = ""
        if ans == wx.ID_OK:
            #dlg.Destroy()
            stat = "OK"
            #return "OK"
        else:
            #dlg.Destroy()
            stat = "CANCEL"
            #return "CANCEL"
        return stat

#  getTreeFoamVersion
#    TreeFoamのバージョンを取得
def getTreeFoamVersion():
    version = ""
    verFile = os.getenv("TreeFoamPath") + "/TreeFoamVersion"
    f = open(verFile)
    lines = f.readlines()
    f.close()
    for line in lines:
        words = line.split()
        if len(words) >= 2:
            if words[0] == "currentTreeFoamVersion":
                version = words[1]
                break
    return version

#  getMultiLines
#    複数の行listに変換する
def getMultiLines(cont):
    ans = []
    p = 0
    line = ""
    ps = 0
    while p<len(cont):
        chara = cont[p]
        if chara == '"':
            p += 1
            while p<len(cont) and cont[p] != '"':
                p += 1
            p += 1
        elif (chara == "\n" or chara == "\r"):
            ans.append(cont[ps:p])
            while p<len(cont) and (cont[p] == "\n" or cont[p] == "\r"):
                p += 1
            ps = p
        else:
            p += 1
    if ps < len(cont):
        ans.append(cont[ps:p])
    return ans

#
#  createCsvSaveData
#    csvファイル作成、保存
def createCsvSaveData(fileName, rowNames, colNames, colRowData):
    cont = [["<setFieldsDict>"]]
    #タイトル行
    line = ["items"]
    for item in colNames:
        line.append('"' + item + '"')
    cont.append(line)
    #データ行
    row = 0
    for rowName in rowNames:
        line = ['"'+rowName+'"', '"'+colRowData[0][row]+'"']
        col = 1
        while col<len(colNames):
            colRow = colRowData[col][row]
            line.append(colRow)
            col += 1
        cont.append(line)
        row += 1
    #saveCsv
    f=open(fileName, "w")
    for line in cont:
        sLine = ",".join(line) + "\n"
        f.write(sLine.encode("utf-8"))
    f.close()
    return ["OK", ""]

#
#  saveDictData
#    cellDataをDictに保存
def saveDictData(rowNames, colNames, colRowData):
    fileName = caseDir + "/" + selRegion + "/" + setFieldsDict
    if len(glob.glob(fileName)) == 0:
        #Dict作成
        makeSetFieldsDictFile(fileName)
    f=open(fileName); cont=f.read(); f.close()
    p = getFoamContents.skipFoamFileMem(cont, 0)
    [cont, p] = setDefaultFieldValuesToDict(colNames, colRowData, cont, p)
    [cont, p] = setRegionsToDict(rowNames, colNames, colRowData, cont, p)
    f=open(fileName, "w"); f.write(cont); f.close()
    return ["OK", ""]

#  makeSetFieldsDictFile
#    Dictを作成する
def makeSetFieldsDictFile(fileName):
    OFversion = pyTreeFoam.getOFversion()
    header = setFoamContents.makeFoamHeaderVersion(OFversion)
    foamFile = setFoamContents.makeFoamFile("2.0", "ascii", "dictionary",
                    "", "setFieldsDict")
    footer = setFoamContents.makeFooter()
    cont = """
defaultFieldValues
(
    volScalarFieldValue xxx 1e-10
);

regions
(
    cellToCell
    {
        set yyy;
        fieldValues
        (
            volScalarFieldValue xxx 6000
        );
    }
);
"""
    contents = header + foamFile +cont + footer
    f=open(fileName, "w"); f.write(contents); f.close()

#  setDefaultFieldValuesToDict
#    defaultFieldValuesをDictにセット
def setDefaultFieldValuesToDict(colNames, colRowData, cont, p):
    [keyword, p] = getFoamContents.getKeywordMem(cont, p)
    while keyword != "" and keyword != "defaultFieldValues":
        [keyword, p] = getFoamContents.getKeywordMem(cont, p)
    if keyword == "defaultFieldValues":
        ps = p
        [valCont, p] = getFoamContents.getSmallPairMem(cont, p)
        pe = p
        fieldValCont = ""
        row = 0
        col = 1
        while col<len(colNames):
            val = colRowData[col][row]
            if val != "":
                field = colNames[col]
                fieldType = fieldTypes[col] + "Value"
                fieldVal = " "*4 + " ".join([fieldType, field, val]) + "\n"
                fieldValCont += fieldVal
            col += 1
        valCont = "(\n" + fieldValCont + ")"
        newCont = cont[:ps] + valCont + cont[pe:]
        pp = len(cont[:ps] + valCont)
        return [newCont, pp]
    else:
        return [cont, p]

#  setRegionsToDict
#    regionsをDictにセット
def setRegionsToDict(rowNames, colNames, colRowData, cont, p):
    [keyword, p] = getFoamContents.getKeywordMem(cont, p)
    while keyword != "" and keyword != "regions":
        [keyword, p] = getFoamContents.getKeywordMem(cont, p)
    if keyword == "regions":
        ps = p
        [valCont, p] = getFoamContents.getSmallPairMem(cont, p)
        pe = p
        setValCont = ""
        row = 1
        while row<len(rowNames):
            col = 1
            setName = rowNames[row]
            if (setName == "(box)" or setName == "(cylinder)"
                or setName == "(sphere)"):
                setName = setName[1:-1]
                cellCont  = " "*4 + setName + "ToCell\n"
                cellCont += " "*4 + "{\n"
                lines = colRowData[0][row].split("\n")
                for line in lines:
                    cellCont += " "*8 + line + "\n"
            else:
                cellCont  = " "*4 + "cellToCell\n"
                cellCont += " "*4 + "{\n"
                cellCont += " "*8 + "set " + setName + ";\n"
            cellCont += " "*8 + "fieldValues\n"
            cellCont += " "*8 + "(\n"
            fieldVal = ""
            while col<len(colNames):
                val = colRowData[col][row]
                if val != "":
                    field = colNames[col]
                    fieldType = fieldTypes[col] + "Value"
                    fieldVal = " "*12 + " ".join([fieldType, field, val]) + "\n"
                    cellCont += fieldVal
                col += 1
            cellCont += " "*8 + ");\n"
            cellCont += " "*4 + "}\n\n"
            row += 1
            if fieldVal != "":
                setValCont += cellCont
        valCont = "(\n" + setValCont + ")"
        newCont = cont[:ps] + valCont + cont[pe:]
        pp = len(cont[:ps] + valCont)
        return [newCont, pp]
    else:
        return [cont, p]

#
#  readWinSize
#    windowSizeを読み込み
def readWinSize():
    global winSize
    #fileName = os.environ["TreeFoamPath"] + "/data/winSize"
    fileName = os.environ["TreeFoamUserPath"] + "/data/winSize"
    f=open(fileName); lines=f.readlines(); f.close()
    h = 536; w = 536
    for line in lines:
        words = line.split()
        if len(words) != 0:
            if words[0] == "createSetFields":
                h = int(words[1])
                w = int(words[2])
                break
    return (h, w)

#
#  saveWinSise
#    windowSizeを保存
def saveWinSize(winSize):
    [h, w] = winSize
    #fileName = os.environ["TreeFoamPath"] + "/data/winSize"
    fileName = os.environ["TreeFoamUserPath"] + "/data/winSize"
    f=open(fileName); lines=f.readlines(); f.close()
    flag = 0
    i = 0
    while i<len(lines):
        line = lines[i]
        words = line.split()
        if len(words) != 0:
            if words[0] == "createSetFields":
                words[1] = str(h)
                words[2] = str(w)
                lines[i] = " ".join(words) + "\n"
                flag = 1
        i += 1
    if flag == 0:
        line = "createSetFields " + str(h) + " " + str(w) + "\n"
        lines.append(line)
    f=open(fileName, "w")
    for line in lines:
        f.write(line)
    f.close()

#
#  getColRowLabelFromDict
#    DictファイルからLabelを取得
def getColRowLabelFromDict():
    global fields, cellSets, colNames, rowNames, colRowData, caseDir, timeFolder
    global selRegion
    [fields, cellSets] = setDataInFieldsDialog.getSeledFieldsCellSets(caseDir, timeFolder, selRegion)
    getColRowLabel()
    getColRowData()

#
#  getColRowLabel
#    列名、行名を取得
def getColRowLabel():
    global fields, cellSets, colNames, rowNames, colRowData
    colRowData = []
    colNames = ["geometry\ndata"] + fields
    rowNames = ["defaultFieldValues"]
    rowNames += cellSets
    for col in colNames:
        fieldData = []
        for row in rowNames:
            fieldData.append("")
        colRowData.append(fieldData)

#
#  getColRowData
#    データ取得
def getColRowData():
    global colRowData
    fileName = caseDir + "/" + selRegion + "/" + setFieldsDict
    if len(glob.glob(fileName)) != 0:
        f=open(fileName); cont=f.read(); f.close()
        p = getFoamContents.skipFoamFileMem(cont, 0)
        [keyword, p] = getFoamContents.getKeywordMem(cont, p)
        while keyword != "":
            if keyword == "defaultFieldValues":
                [valCont, p] = getFoamContents.getSmallPairMem(cont, p)
                [fields, values] = getDefaultFieldValues(valCont)
                setDefaultValues(fields, values)
            elif keyword == "cellToCell":
                [valCont, p] = getFoamContents.getMiddlePairMem(cont, p)
                [cellSet, fields, values] = getCellToCellValues(valCont)
                setCellToCellDataValues(cellSet, fields, values)
            elif (keyword == "boxToCell" or keyword == "cylinderToCell"
                    or keyword == "sphereToCell"):
                [valCont, p] = getFoamContents.getMiddlePairMem(cont, p)
                [geoCont, fields, values] = getBoxToCellValues(valCont)
                setGeoDataValues(keyword, geoCont, fields, values)
            [keyword, p] = getFoamContents.getKeywordMem(cont, p)

#
#  setCellToCellDataValues
#    cellToCellのdataをセット
def setCellToCellDataValues(cellSet, fields, values):
    global colRowData, rowNames, colNames
    n = -1
    i = 1
    while i<len(rowNames):
        if rowNames[i] == cellSet:
            n = i
            break
        i += 1
    if n>=0:
        i = 1
        while i<len(colNames):
            f = 0
            for field in fields:
                if field == colNames[i]:
                    colRowData[i][n] = values[f]
                    break
                f += 1
            i += 1

#
#  setGeoDataValues
#    geometryのdataをセット
def setGeoDataValues(keyword, geoCont, fields, values):
    global colRowData, rowNames, colNames
    name = "(" + keyword[:-len("ToCell")] + ")"
    nameCont = geoCont
    rowNames.append(name)
    colRowData[0].append(nameCont)
    i = 1
    while i<len(colNames):
        colRowData[i].append("")
        i += 1
    col = 1
    while col<len(colNames):
        i = 0
        while i<len(fields):
            if colNames[col] == fields[i]:
                colRowData[col][-1] = values[i]
                break
            i += 1
        col += 1

#
#  setDefaultValues
#    defaultValueをcolRowDataにセット
def setDefaultValues(fields, values):
    global colRowData, colNames
    row = 0
    col = 0
    while col<len(colNames):
        i = 0
        val = ""
        for field in fields:
            if colNames[col] == field:
                val = values[i]
                break
            i += 1
        colRowData[col][0] = val
        col += 1

#
#  getCellToCellValues
#    cellToCellの内容を取得
def getCellToCellValues(cont):
    fields = []
    vals = []
    cellSet = ""
    [keyword, p] = getFoamContents.getKeywordMem(cont, 0)
    while keyword != "":
        #cellSet
        if keyword == "set":    
            [cellSet, p] = getFoamContents.getKeywordMem(cont, p)
        #fieldValues
        if keyword == "fieldValues":
            [valCont, p] = getFoamContents.getSmallPairMem(cont, p)
            [fields, vals] = getDefaultFieldValues(valCont)
        [keyword, p] = getFoamContents.getKeywordMem(cont, p)
    return [cellSet, fields, vals]

#
#  getBoxToCellValues
#    boxToCellの内容を取得
def getBoxToCellValues(cont):
    fields = []
    vals = []
    boxCont = ""
    [keyword, p] = getFoamContents.getKeywordMem(cont, 0)
    while keyword != "":
        #box
        if keyword != "fieldValues":
            [valCont, p] = getFoamContents.getC1lineMem(cont, p)
            boxCont += keyword + " " + valCont + "\n"
        else:
            #fieldValues
            [valCont, p] = getFoamContents.getSmallPairMem(cont, p)
            [fields, vals] = getDefaultFieldValues(valCont)
        [keyword, p] = getFoamContents.getKeywordMem(cont, p)
    boxCont = boxCont[:-1]
    return [boxCont, fields, vals] 

#
#  getDefaultFieldValues
#    fieldと値を取得
def getDefaultFieldValues(cont):
    fields = []
    vals = []
    words = cont.split()
    words = mergeValue(words)
    i = 0
    while i<len(words):
        field = words[i+1]
        val = words[i+2]
        fields.append(field)
        vals.append(val)
        i += 3
    return [fields, vals]

#  mergeValue
#    ()付きの値を結合させて1ヶの値にする
def mergeValue(words):
    merge = []
    flag = 0
    for word in words:
        if (word[0] == "+" or word[0] == "-" or word[0] == "(" or word[0] == ")" or
            (word[0] >= "0" and word[0] <= "9")):
            if flag == 0:
                merge.append(word)
                flag = 1
            else:
                merge[-1] += " " + word
        else:
            merge.append(word)
            flag = 0
    return merge

#
#  getFieldTypes
#    fieldのtypeを取得
def getFieldTypes():
    global fieldTypes, colNames, timeFolder, caseDir, selRegion
    fieldTypes = [""]
    i = 1
    while i<len(colNames):
        field = colNames[i]
        fieldDir = caseDir + "/" + timeFolder + "/" + selRegion
        items = getFoamContents.getFoamFile(fieldDir, field)
        for item in items:
            if item[0] == "class":
                fieldType = item[1]
                break
        i += 1
        fieldTypes.append(fieldType)
    return

#
#  getCurrMeshDir
#    meshDirを検索
def getCurrMeshDir():
    global polyMeshDir
    #currTime = getFoamContents.getCurrTimeFolder(caseDir)
    meshDir = getFoamContents.getCurrMeshDir(caseDir, timeFolder, selRegion, "sets")
    polyMeshDir = caseDir + "/" + meshDir

#
#  initialize
#
def initialize():
    global winSize, caseDir
    caseDir = os.getcwd()
    winSize = readWinSize()
    getColRowLabel()
    getColRowData()
    getFieldTypes()
    getCurrMeshDir()


if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    i = 1
    flag = ""
    while i<len(sys.argv):
        comm = sys.argv[i]
        if comm == "-f":
            flag = "field"
        elif comm == "-c":
            flag = "cellSet"
        elif comm == "-r":
            flag = "region"
        elif comm == "-t":
            flag = "time"
        else:
            if flag == "field":
                fields.append(comm)
            elif flag == "cellSet":
                cellSets.append(comm)
            elif flag == "region":
                selRegion = comm
            elif flag == "time":
                timeFolder = comm
        i += 1

    initialize()
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_2 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_2)
    frame_2.Show()
    app.MainLoop()
