#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   editBoundaryConditionsDialog.py
#
#       12/01/03    patchの削除を可能にした。
#          01/08    patch名の修正を可能にした
#          01/17    patch削除時ﾊﾞｸﾞ修正（最後のcellにｺﾞﾐが残る）
#          02/05    windowClose時の終了処理追加
#          02/11    patch名変更、削除時にglobal変数を設定する様に変更（ﾊﾞｸﾞ修正）
#          02/18    ﾒﾆｭｰkeyとｼｮｰﾄｶｯﾄkey追加
#          02/19    読み込み時にｹﾞｰｼﾞ追加
#          02/25    gridEditorｺﾏﾝﾄﾞに対応できる様、cellDataの読込みをtimerEventで実施
#          02/26    終了時にwindowSizeを保存
#          03/10    iconNameを変数に修正
#          03/25    openメニュー追加
#          04/01    save時にもｹﾞｰｼﾞを追加
#          04/22    field非表示、表示順の設定追加
#          04/23    field保存時にｴﾗｰ表示追加
#          05/11    fieldCopy時に_copy0～_copy9まで可能な様に修正
#          05/25    ｱｲｺﾝの定義を相対pathに変更。
#          06/24    field削除をゴミ箱へ移動に変更。
#          08/04    cell内容変更して終了する時、保存確認するよう変更
#          08/05    最大cell内行数を変更
#          08/11    patch名変更・削除時にcell修正チェック追加
#          08/14    field名表示のバグ修正（field削除時、表示のみ削除できず）
#          08/16    cell(0,0),(1,0)のクリア追加
#          08/21    field全表示で隠しファイルが表示されていたので修正。
#          08/25    「全field表示」を「全表示/非表示の切替え」に変更。
#          09/12    表示変更関連（reload）時に保存確認を追加
#          09/22    reload時のcreateMatrix方法修正（ﾊﾞｸﾞ）
#          11/05    領域分割したとき、gridEditor開かずを修正（ﾊﾞｸﾞ）
#                   空patch追加,空白cell,internalFieldの処理追加
#       13/01/11    patch名をpatchTypeと同じ名前にrenameするとｴﾗｰ発生を修正
#          01/28    nRunningGridの場所を「/data」に変更
#          02/11    zeroGradient, fixedValueについてfontColourを設定
#          02/17    editor起動中はﾌｫﾝﾄ色をﾘｾｯﾄ
#          03/03    boundary内容取得ﾊﾞｸﾞ修正（patch名を含んだ時、正しく表示できず）
#          03/10    getDefinePatchDataを修正
#          03/11    font色をsystemFont色（#4c4c4c:グレー）に設定
#          03/12    ﾊﾞｸﾞ修正（fieldが無かった場合、ｴﾗｰ発生）
#          03/23    clearZeroGradient, clearUniformのアイコン追加
#          04/20    polyMesh（boundary）の場所をgridに表示
#          05/22    patch名をsortして表示。表示切り替えpopupメニュー追加
#          05/25    saveCSVの時、表示するdialogをinputTextDialogに変更
#          06/09    definePatchData読み込み時、「\n;」→「;」に修正
#          06/10    cell内に{}がある場合、ｲﾝﾃﾞﾝﾄを付けた
#          06/26    labelのダブルclick時の操作を追加（editorで開く、patch名変更）
#                   toolTip表示追加
#          07/06    cell内の表示行数が変更できる様にメニューに追加
#                   cellCopy時、「***...」は、pasteしない様修正。逆は可能。
#          08/11    patch名sort時、saveFlagのチェックを追加
#          08/14    patch名sortをinternalField行にもメニューを追加
#          09/07    圧縮file(gzip)に対応
#          09/13    書込みの高速化（getMiddlePairMemFを使用）
#                   cellEditorのバグ修正（2回目の編集ができない）
#          09/15    binaryFileへ対応
#          09/18    表示行数、nonuniform読込データ数変更dialog追加
#          09/25    getStartFaceNoAtNullPatch:取得方法変更(binMeshの場合ｴﾗｰ発生)
#          10/03    internalFieldのクリア:cellを選択後実行する様に修正
#          10/05    deletePatch時、空patchかどうか確認する様修正
#          10/12    多言語化のため修正
#          12/10    copy&paste時のclipBoardをsystemのclipBoardに変更
#          12/21    stdout、stderrの設定（import logFileCreater）を追加
#       14/02/08    patchデータ内にnull行があるとエラー発生を修正
#          03/18    setMatrixData:「;」のみの行があると表示されないｴﾗｰを修正
#          05/11    boundaryFieldの#includeとboundary内のinGroupsを追加
#          06/04    「全ての空patch削除」ﾒﾆｭｰを追加
#          08/03    getDefinePatchData:boundaryが存在しない場合ｴﾗｰ発生を修正
#          08/10    getDimensionInternalFieldData:変数名を追加
#          08/23    onSave:変数名の保存を追加
#                   変数定義行の表示・非表示切り替えを追加
#          08/25    setFontColour:バグ修正
#          09/21    addNullPatches:同時に複数行の追加ができる様に修正。
#          09/23    reformInternalFieldCellData:internalFieldが1行のみの時、表示変
#          09/27    runCellEditor:変数行があると保存する行が狂う。
#                   setEditCellBoundaryFieldData:保存時、wildCardPatchが有るとエラー
#          10/06    replaceOtherNames:変数を保存する場所を修正
#          10/25    labelクリック時、gridCursorをセット
#          10/26    getDimensionInternalFieldData:階層型変数名「$:」に対応
#          11/10    getInternalFieldRowFromGrid:patch名をsortさせた時、internalFieldの
#                   rowNoが取得できず
#        15/02/24   replaceOtherNames:バグ修正（変数挿入時pointerがずれていた）
#                   replaceVariables:deleteOver2NullLinesを追加して余分な行を削除
#           02/28   replaceOtherNames:バグ修正（変数挿入時pointerがずれていた。再修正）
#           06/25   wxPython-2.8→3.0に伴い修正。
#                   CreateGrid文は、2回記述できないので、1ヶをコメントアウト
#           06/26   createMatrixでcellEditorのセットをwxのversionで変更
#           06/27   labelのtoolTip出力を修正（wxのバージョンアップにより）
#           07/05   起動をimportからコマンド実行に変更。これにより、parameterの受け取り
#                   方法を修正。「import gio」を削除。これにより、fieldの削除をゴミ箱
#                   から削除に変更。
#                   上記2点は、GridCellAutoWrapStringEditorと共存させるとsegmentation 
#                   faultが発生する為。
#           07/10   loadFromGaugeDialog:loadを修正（gauge内を修正）
#           07/13   clipBoardの場所をTreeFoam/dataに変更
#           09/13   バグ修正。getAbsPath:環境変数の取得に$xxxを追加。
#                            getDimensionInternalFieldData:ポインタのズレ修正。
#           09/02   onNullCellZeroGrad:空白cellをzeroGradientで埋める時、emptyと
#                   symmetry等を考慮する様に修正。
#                   cell内容をクリア（空白cell作成）を追加。
#           10/07   「#includeEtc」を追加
#           11/02   バグ修正（popupMenuのcellコピー、cell貼付が機能しない）。
#        16/08/28   windowsサイズ設定を修正
#


# generated by wxGlade 0.6.3 on Sat Apr 23 14:08:58 2011

#------------修正内容---------------
#
#   ・アイコンのDirを書き直す（絶対Path→相対path）
#       →　./icon/***　に変更
#   ・1行コメントアウト
#       →　#self.grid_1.CreateGrid(1, 1)
#
#

import time

import wx
import wx.grid
import string
#import thread
import os
import sys
import glob
#import gio
import pyTreeFoam
import getFoamContents
import setFoamContents
import inputTextDDialog
import gaugeDDialog
import openGridEditorDialog
import openFieldForGridEditorDDialog
import saveAndNextJobDDialog
import getDisplayMaxLinesDataDDialog

import logFileCreater; logFileCreater.log()


openID = wx.NewId()
saveID = wx.NewId()
saveCSVID = wx.NewId()
reloadID = wx.NewId()
exitID = wx.NewId()
renamePatchID = wx.NewId()
delPatchID = wx.NewId()
copyID = wx.NewId()
pasteID = wx.NewId()
toolOpenID = wx.NewId()
toolSaveID = wx.NewId()
toolSaveCSVID = wx.NewId()
toolReloadID = wx.NewId()
toolExitID = wx.NewId()
toolCopyID = wx.NewId()
toolPasteID = wx.NewId()
toolZeroID = wx.NewId()
toolUniformID = wx.NewId()
allDispID = wx.NewId()
nonDispID = wx.NewId()
dispID = wx.NewId()



# begin wxGlade: extracode
# end wxGlade

gridTitle = ""                          #Gridのタイトル
boundaryDir = ""                        #boundaryのdir
dataDir = ""                            #fieldデータを取得したdir
frame_1 = ""
nTreeFoam = ""
clipBoard = ""
delPatchName = ""                       #削除するpatch名
gridSize = (500, 400)                   #gridのサイズ
displayFieldsFile = ".displayField"     #表示させるfield名を保存するﾌｧｲﾙ名
maxRowsInCellInternal = 5               #internalFieldCell内の最大表示行数
maxRowsInCell = 20                      #boundaryCell内の最大表示行数
sortPatchName = "yes"                   #patchNameのsortフラグ
winSizeFile = "data/winSize"            #window size の保存場所
nRunningGrid = "data/nRunningGrid"      #GridEditrの起動No保存場所
gridEditor_data = "data/gridEditor_data"    #gridEditorの設定file
nMaxLinesBinToAscii = 1000              #binary→asciiの変換行数


colNames = []       #  データ構造は、field単位で構成
rowNames = []       #       field1      field2
data = []           #data=[[p1,p2,..],[p1,p2,..],...]
otherData = []      #otherData=[dimData, intData, variables, variablesBoundary]
isVariable = False
isVariableBoundary = False
copyCol = 0; copyRow = 0
copyValue = ""; copyValues = []
curRow = 0; curCol = 0
sysFontColour = "#4c4c4c"               #systemのFontの色（グレー）
veryLightGreen = "#e9fff0"              #薄いlightGreen色
noEditCell = [-1, -1]                   #edit禁止cell
noEditCellCont = ""                     #edit禁止cellの内容
toolTipText = ""                        #toolTipTextの内容


def Show(nTreeFoam1, title, bdir, wdir, col):
    global dataDir, gridTitle, boundaryDir, colNames, rowNames, data, nTreeFoam
    initializeVal()             #変数の設定
    nTreeFoam = nTreeFoam1
    gridTitle = title           #タイトル
    boundaryDir = bdir          #boundaryのdir
    dataDir = wdir              #fieldのdir
    colNames = col              #fieldName
    if len(colNames) == 0:
        colNames = pyTreeFoam.getFieldNames(dataDir)
    rowNames = getRowNamesFromBoundary(boundaryDir)     #patchName
    initializeGrid()            #初期化（gridNo、title設定）
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()



class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):

        savePath = os.getcwd()
        treeFoamPath = os.getenv("TreeFoamPath")
        os.chdir(treeFoamPath)

        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        #wx.Frame.__init__(self, size=gridSize, *args, **kwds)
        # Menu Bar
        self.frame_1_menubar = wx.MenuBar()
        self.menuFile = wx.Menu()
        self.menuOpen = wx.MenuItem(self.menuFile, openID, _(u"開く(&O)"), _(u"boundaryとfieldを開く"), wx.ITEM_NORMAL)
        self.menuFile.AppendItem(self.menuOpen)
        self.menuSave = wx.MenuItem(self.menuFile, saveID, _(u"保存(&S)"), _(u"保存します"), wx.ITEM_NORMAL)
        self.menuFile.AppendItem(self.menuSave)
        self.menuSaveCSV = wx.MenuItem(self.menuFile, saveCSVID, _(u"CSV保存(&V)"), _(u"CSV形式で保存します"), wx.ITEM_NORMAL)
        self.menuFile.AppendItem(self.menuSaveCSV)
        self.menuReload = wx.MenuItem(self.menuFile, reloadID, _(u"再読み込み(&R)"), _(u"再読込みします"), wx.ITEM_NORMAL)
        self.menuFile.AppendItem(self.menuReload)
        self.menuFile.AppendSeparator()
        self.menuExit = wx.MenuItem(self.menuFile, exitID, _(u"閉じる(&Q)"), _(u"閉じる"), wx.ITEM_NORMAL)
        self.menuFile.AppendItem(self.menuExit)
        self.frame_1_menubar.Append(self.menuFile, _(u"ファイル(&F)"))
        self.menuEdit = wx.Menu()
        self.menuRenamePatch = wx.MenuItem(self.menuEdit, renamePatchID, _(u"patch名変更"), _(u"patch名を変更します"), wx.ITEM_NORMAL)
        self.menuEdit.AppendItem(self.menuRenamePatch)
        self.menuDelPatch = wx.MenuItem(self.menuEdit, delPatchID, _(u"patch削除"), _(u"patchを削除します\n削除後は元に戻りません"), wx.ITEM_NORMAL)
        self.menuEdit.AppendItem(self.menuDelPatch)
        self.menuEdit.AppendSeparator()
        self.menuCellCopy = wx.MenuItem(self.menuEdit, copyID, _(u"cellコピー(&C)\tCtrl+C"), _(u"cell内容をコピーします"), wx.ITEM_NORMAL)
        self.menuEdit.AppendItem(self.menuCellCopy)
        self.menuCellPaste = wx.MenuItem(self.menuEdit, pasteID, _(u"cell貼付け(&P)\tCtrl+V"), _(u"cell内容をを貼付けます"), wx.ITEM_NORMAL)
        self.menuEdit.AppendItem(self.menuCellPaste)
        self.menuEdit.AppendSeparator()
        self.menuRunCellEditor = wx.MenuItem(self.menuEdit, wx.NewId(), _(u"cell内容をEditorで編集"), _(u"cell内容をEditorで編集する"), wx.ITEM_NORMAL)
        self.menuEdit.AppendItem(self.menuRunCellEditor)
        self.frame_1_menubar.Append(self.menuEdit, _(u"編集(&E)"))
        self.menuView = wx.Menu()
        self.menuDispAllFields = wx.MenuItem(self.menuView, wx.NewId(), _(u"全表示/非表示fieldの切替え(&A)"), _(u"全field表示/非表示fieldを切替えます"), wx.ITEM_NORMAL)
        self.menuView.AppendItem(self.menuDispAllFields)
        self.menuNonDisp = wx.MenuItem(self.menuView, wx.NewId(), _(u"選択したfieldを非表示(&H)"), _(u"選択したfieldを非表示にします"), wx.ITEM_NORMAL)
        self.menuView.AppendItem(self.menuNonDisp)
        self.menuDisp = wx.MenuItem(self.menuView, dispID, _(u"fieldの再表示、表示順変更(&R)"), _(u"非表示fieldを再表示、表示順を変更します"), wx.ITEM_NORMAL)
        self.menuView.AppendItem(self.menuDisp)
        self.menuView.AppendSeparator()
        self.menuChangeMaxLinesData = wx.MenuItem(self.menuView, wx.NewId(), _(u"cell内の表示行数・データ数変更"), _(u"internalField、boundaryFieldのcellの表示行数やnonuniformの読込データ数を変更する"), wx.ITEM_NORMAL)
        self.menuView.AppendItem(self.menuChangeMaxLinesData)
        self.frame_1_menubar.Append(self.menuView, _(u"表示(&V)"))
        self.SetMenuBar(self.frame_1_menubar)
        # Menu Bar end
        self.frame_1_statusbar = self.CreateStatusBar(1, wx.ST_SIZEGRIP)
        
        # Tool Bar
        self.frame_1_toolbar = wx.ToolBar(self, -1, style=wx.TB_HORIZONTAL | wx.TB_NOALIGN)
        self.SetToolBar(self.frame_1_toolbar)
        self.frame_1_toolbar.AddLabelTool(toolOpenID, _("open"), wx.Bitmap("./icons/fileopen.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, _(u"開く"), _(u"boundaryとfieldを開く"))
        self.frame_1_toolbar.AddLabelTool(toolSaveID, _("save"), wx.Bitmap("./icons/save.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, _(u"保存"), _(u"boundaryとFieldを保存します"))
        self.frame_1_toolbar.AddLabelTool(toolSaveCSVID, _("saveCSV"), wx.Bitmap("./icons/document-revert.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, _(u"CSV保存"), _(u"CSV形式で保存"))
        self.frame_1_toolbar.AddLabelTool(toolReloadID, _("reload"), wx.Bitmap("./icons/reload.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, _(u"再読込み"), _(u"再読込みします"))
        self.frame_1_toolbar.AddLabelTool(toolExitID, _("exit"), wx.Bitmap("./icons/exit.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, _(u"閉じる"), _(u"閉じる"))
        self.frame_1_toolbar.AddSeparator()
        self.frame_1_toolbar.AddLabelTool(toolCopyID, _("cellCopy"), wx.Bitmap("./icons/copy.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, _(u"cell内容のコピー"), _(u"cell内容をコピーします"))
        self.frame_1_toolbar.AddLabelTool(toolPasteID, _("cellPaste"), wx.Bitmap("./icons/paste.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, _(u"cell内容の貼付け"), _(u"cell内容を貼り付けます"))
        self.frame_1_toolbar.AddSeparator()
        self.frame_1_toolbar.AddLabelTool(toolZeroID, _("clearZeroGragient"), wx.Bitmap("./icons/clearZeroGradient.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, _(u"空白cellをzeroGradientで埋める"), _(u"boundaryFieldの空白cellをzeroGradientで埋める"))
        self.frame_1_toolbar.AddLabelTool(toolUniformID, _("clearUniform"), wx.Bitmap("./icons/clearUniform.png", wx.BITMAP_TYPE_ANY), wx.NullBitmap, wx.ITEM_NORMAL, _(u"internalField内のnonuiformをuniform形式に置き換える"), _(u"internalField内のnonuniformをuniform形式に置き換える"))
        # Tool Bar end
        self.grid_1 = wx.grid.Grid(self, -1, size=(1, 1))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_MENU, self.onOpen, self.menuOpen)
        self.Bind(wx.EVT_MENU, self.onSave, self.menuSave)
        self.Bind(wx.EVT_MENU, self.onSaveCSV, self.menuSaveCSV)
        self.Bind(wx.EVT_MENU, self.onReload, self.menuReload)
        self.Bind(wx.EVT_MENU, self.onExit, self.menuExit)
        self.Bind(wx.EVT_MENU, self.onRenamePatch, self.menuRenamePatch)
        self.Bind(wx.EVT_MENU, self.onDelPatch, self.menuDelPatch)
        self.Bind(wx.EVT_MENU, self.onCellCopy, self.menuCellCopy)
        self.Bind(wx.EVT_MENU, self.onCellPaste, self.menuCellPaste)
        self.Bind(wx.EVT_MENU, self.onRunCellEditor, self.menuRunCellEditor)
        self.Bind(wx.EVT_MENU, self.onSwitchAllorHideFields, self.menuDispAllFields)
        self.Bind(wx.EVT_MENU, self.onNonDisp, self.menuNonDisp)
        self.Bind(wx.EVT_MENU, self.onDispFields, self.menuDisp)
        self.Bind(wx.EVT_MENU, self.onChangeMaxLinesData, self.menuChangeMaxLinesData)
        self.Bind(wx.EVT_TOOL, self.onOpen, id=toolOpenID)
        self.Bind(wx.EVT_TOOL, self.onSave, id=toolSaveID)
        self.Bind(wx.EVT_TOOL, self.onSaveCSV, id=toolSaveCSVID)
        self.Bind(wx.EVT_TOOL, self.onReload, id=toolReloadID)
        self.Bind(wx.EVT_TOOL, self.onExit, id=toolExitID)
        self.Bind(wx.EVT_TOOL, self.onCellCopy, id=toolCopyID)
        self.Bind(wx.EVT_TOOL, self.onCellPaste, id=toolPasteID)
        self.Bind(wx.EVT_TOOL, self.onClearZeroGradient, id=toolZeroID)
        self.Bind(wx.EVT_TOOL, self.onClearUniform, id=toolUniformID)
        self.Bind(wx.grid.EVT_GRID_CMD_CELL_RIGHT_CLICK, self.onRightClick, self.grid_1)
        self.Bind(wx.grid.EVT_GRID_CMD_CELL_LEFT_CLICK, self.onLeftClick, self.grid_1)
        self.Bind(wx.grid.EVT_GRID_CMD_LABEL_RIGHT_CLICK, self.onLabelRightClick, self.grid_1)
        self.Bind(wx.grid.EVT_GRID_CMD_SELECT_CELL, self.onAutoCellSize, self.grid_1)
        # end wxGlade

        os.chdir(savePath)
        self.Bind(wx.grid.EVT_GRID_EDITOR_SHOWN, self.onEditorShown, self.grid_1)
        self.Bind(wx.grid.EVT_GRID_EDITOR_HIDDEN, self.onEditorHidden, self.grid_1)
        self.Bind(wx.grid.EVT_GRID_CELL_CHANGE, self.onCellChange, self.grid_1)
        self.Bind(wx.EVT_CLOSE, self.onCloseWindow)
        self.Bind(wx.grid.EVT_GRID_CMD_LABEL_LEFT_DCLICK, self.onLabelDClick, self.grid_1)
        self.Bind(wx.grid.EVT_GRID_CMD_CELL_LEFT_DCLICK, self.onCellDClick, self.grid_1)
        #self.grid_1.SetToolTip(wx.ToolTip(toolTipText))
        self.grid_1.GetGridColLabelWindow().Bind(wx.EVT_MOTION, self.onShowColToolTip)
        self.grid_1.GetGridRowLabelWindow().Bind(wx.EVT_MOTION, self.onShowRowToolTip)
        #self.grid_1.GetGridWindow().Bind(wx.EVT_MOTION, self.onShowCellToolTip)
        self.Bind(wx.EVT_KEY_DOWN, self.onKeyDownEvent)
        self.Bind(wx.grid.EVT_GRID_CMD_LABEL_LEFT_CLICK, self.onLabelClick, self.grid_1)

        #timerEventを発生させ、eventでcellDataを読み込む
        self.Bind(wx.EVT_TIMER, self.getCellData)
        self.timer = wx.Timer(self)
        self.timer.Start(100)           #0.1sのタイマ設定

        #windowSizeの設定
        #self.SetSize(gridSize)
        ver = wx.version().split()[0]
        tfVer = pyTreeFoam.getTreeFoamVersion().split("+")
        if ver >= "3.0" and len(tfVer) == 1:
            self.SetSizeWH(gridSize[0], gridSize[1]-28)
        else:
            self.SetSize(gridSize)


    #keyEvent
    def onKeyDownEvent(self, event):
        code = event.GetKeyCode()
        if code == 127:
            self.clearCellCont()
        else:
            event.Skip()


    def __set_properties(self):
        global clipBoard, data
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_("Edit BoundaryFields"))
        self.frame_1_statusbar.SetStatusWidths([-1])
        # statusbar fields
        frame_1_statusbar_fields = [_("frame_1_statusbar")]
        for i in range(len(frame_1_statusbar_fields)):
            self.frame_1_statusbar.SetStatusText(frame_1_statusbar_fields[i], i)
        self.frame_1_toolbar.Realize()
        #self.grid_1.CreateGrid(1, 1)
        # end wxGlade

        #表を作成（colLabel、rowLabeの表のみ）
        #self.SetTitle("Edit BoundaryFields" + gridTitle)
        self.SetTitle("gridEditor" + gridTitle)
        self.grid_1.CreateGrid(len(rowNames), len(colNames))
        self.createMatrix()
        self.grid_1.AutoSize()


        #pouupMenuをセット
        self.setPopupMenu()
        #self.setLabelPopupIFMenu()
        self.setLabelPopupMenu()
        self.setFieldPopupMenu()
        #statusBarをクリア
        self.clearStatus()
        #clipBoardを定義
        try:
            #clipBoardPath = os.environ["TreeFoamPath"] + "/data"
            clipBoardPath = os.environ["TreeFoamUserPath"] + "/data"
        except:
            clipBoardPath = os.environ["HOME"]
        clipBoard = clipBoardPath + "/clipBoard"


    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_1.Add(self.grid_1, 1, wx.ALL | wx.EXPAND, 5)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #
    #  getCellData
    #    cellデータの読込み
    def getCellData(self, event):
        global dataDir, colNames, rowNames, data
        #timerEventを停止
        self.timer.Stop()
        #cellDataの読込み
        data = self.loadFromGaugeDialog(dataDir, colNames, rowNames)
        self.setMatrixData()
        self.grid_1.AutoSize()
        self.checkBadField(colNames, data)
        #レイアウトし直す
        self.Layout()



    #----menu---------------------
    #Open
    def onOpen(self, event): # wxGlade: MyFrame.<event_handler>
        #gridEditorのglobal変数を取得
        self.setGlobalValue()
        #編集しているdirectory（数字のフォルダ）を取得
        [boundaryDir, editSubDir] = self.getDirectoryFromGrid()
        editSubDirList = editSubDir.split("/")
        time = ""
        try:
            #数字フォルダ？
            a = float(editSubDirList[-1])
            editDir = editSubDir
            time = editSubDirList[-1]
        except:
            #数字フォルダに設定
            editDir = "/" + string.join(editSubDirList[:-1], "/")
            time = editSubDirList[-2]
        #gridEditor起動
        title = _(u"boundaryFieldの編集")
        mess = _(u"選択された boundaryField を編集します")
        openGridEditorDialog.Show(nTreeFoam, title, mess, editDir, time)
        event.Skip()

    #Save
    def onSave(self, event): # wxGlade: MyFrame.<event_handler>
        global dataDir, colNames, boundaryDir
        #global変数（dir, colNames, rowNames)を設定
        self.setGlobalValue()
        #dataを取得
        fieldCellData = self.getAllFieldCellsData()     #boundaryField
        intData = self.getInternalFieldCellData()       #internalField
        #rowNames, cellDataをboundaryの順番に直す
        [boundRow, boundCell] = fitRowNamesCellDataToBoundary(rowNames,
                                    fieldCellData)
        #fieldを保存
        self.saveAtGaugeDialog(dataDir, colNames, boundRow, boundCell, intData)
        #変数名を取得
        [variables, variablesBoundary] = self.getVariableNames()
        #変数名を保存
        self.replaceVariables(colNames, variables, variablesBoundary)
        #gridからpatch定義を取得
        defineCellData = self.getDefineCellData()
        #defineCellDataをboundaryの順番に戻す
        [dummy, boundDefine] = fitRowNamesCellDataToBoundary(rowNames,
                                    [defineCellData])
        #boundaryを保存
        error = self.replaceDefineData(boundDefine[0], boundRow)
        if error[0] == "OK":
            print _(u"boundaryFieldを保存しました")
        else:
            print _(u"error:boundaryが保存できませんでした")
        #保存フラグクリア
        self.alarmSaveFlagClear()

    #SaveCSV
    def onSaveCSV(self, event): # wxGlade: MyFrame.<event_handler>
        self.saveCSV()

    #Reload
    def onReload(self, event): # wxGlade: MyFrame.<event_handler>
        global data, boundaryDir, rowNames
        #boundaryDir, dataDir, rowNames, colNamesをGridから取得
        self.setGlobalValue()
        #rowNamesをboundayから取得
        rowNames = getRowNamesFromBoundary(boundaryDir)
        #rowNames, colNamesから再読込し、gridを作成
        self.readDataMakeGrid()
        #currentCellを表示させる
        self.showSelectCell()
        #保存フラグクリア
        self.alarmSaveFlagClear()

    #Exit
    def onExit(self, event): # wxGlade: MyFrame.<event_handler>
        flag = self.checkSaveFlag()
        if flag == "RETURN":
            return
        elif flag == "SAVE":
            self.onSave(event)
        #closeするGridNoを削除する
        title = self.GetTitle()
        gridSize = self.GetSize()
        self.setGlobalValue()
        endingGrid(title, gridSize, colNames, dataDir)
        #表示順を保存
        saveDisplayFieldsIfFile(colNames, dataDir)
        #Frame（Grid）をcloseする
        self.Destroy()

    #CellCopy
    def onCellCopy(self, event): # wxGlade: MyFrame.<event_handler>
        self.getCopyValues()
        event.Skip()

    #CellPaste
    def onCellPaste(self, event): # wxGlade: MyFrame.<event_handler>
        global curCol
        self.pasteCopyValues()
        if curCol < 0:
            curCol = 0
        self.grid_1.AutoSizeColumn(curCol, True)
        self.grid_1.AutoSizeRow(curRow, True)
        self.grid_1.ForceRefresh()
        event.Skip()

    #cellEditorで編集
    def onRunCellEditor(self, event):  # wxGlade: MyFrame.<event_handler>
        global curRow, curCol
        error = self.runCellEditor(curRow, curCol)
        if error != "OK":
            title = _(u"エラー")
            mess = _(u"選択したcellは、Editorで編集できません。")
            self.errDialog(title, mess)

    #renmePatch
    def onRenamePatch(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"patch名を変更します。")
        self.onRenamePatchName(event)

    #deletePatch
    def onDelPatch(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"patchを削除します。")
        self.onDeletePatch(event)

    #全field表示
    def onSwitchAllorHideFields(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"全fieldを表示します。表示設定はクリアしました。")
        self.onDisplayAllFields(event)

    #fieldの非表示
    def onNonDisp(self, event): # wxGlade: MyFrame.<event_handler>
        self.onNonDisplayFields(event)

    #fieldの非表示、表示設定、表示順の変更
    def onDispFields(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"表示設定を変更します。")
        self.onHideDisplayFields(event)

    #cell内の表示行数・データ数の変更
    def onChangeMaxLinesData(self, event):  # wxGlade: MyFrame.<event_handler>
        print _(u"cell内の表示行数・nonuniformの読込データ数を変更します。")
        self.getDisplayMaxLinesData(event)

    #clearZeroGradient
    def onClearZeroGradient(self, event):  # wxGlade: MyFrame.<event_handler>
        print _(u"空白cellにzeroGradient, empty etc. をセットします。")
        self.onNullCellZeroGrad(event)

    #clearUniform
    def onClearUniform(self, event):  # wxGlade: MyFrame.<event_handler>
        print _(u"internalFieldをuniform形式でクリアします。")
        self.onClearInternalField(event)

    #AutoCellSize(cell選択時)
    def onAutoCellSize(self, event): # wxGlade: MyFrame.<event_handler>
        global curRow, curCol
        curRow = event.GetRow()
        curCol = event.GetCol()
        self.grid_1.AutoSizeColumn(curCol, True)
        self.grid_1.AutoSizeRow(curRow, True)
        self.grid_1.ForceRefresh()
        event.Skip()

    #leftClick
    def onLeftClick(self, event): # wxGlade: MyFrame.<event_handler>
        curRow = event.GetRow()
        curCol = event.GetCol()
        self.grid_1.SetGridCursor(curRow, curCol)
        self.grid_1.ClearSelection()
        #cursorを設定するのみの為、event.Skip()しない
        #event.Skip()

    #windowClose時
    def onCloseWindow(self, event):
        #保存フラグをチェック
        flag = self.checkSaveFlag()
        if flag == "RETURN":
            return
        elif flag == "SAVE":
            self.onSave(event)
        #終了処理開始
        try:
            title = self.GetTitle()
            gridSize = self.GetSize()
            self.setGlobalValue()
            endingGrid(title, gridSize, colNames, dataDir)
            #表示順を保存
            saveDisplayFieldsIfFile(colNames, dataDir)
        except:
            title = _(u"エラー")
            message = _(u"書込エラーが発生しました。\n  強制終了します。")
            self.errDialog(title, message)
        self.Destroy()

    def onEditorShown(self, event):
        self.editorShown(event)              #FonfColourリセット
        #event.Skip()

    def onEditorHidden(self, event):        #FontColourセット
        self.editorHidden(event)

    def onCellChange(self, event):
        self.alarmSaveFlagSet()          #保存フラグセット,FonfColourセット

    #toolTipの表示
    def onShowCellToolTip(self, event):
        self.showCellToolTip(event)
        event.Skip()

    def onShowColToolTip(self, event):
        self.showColToolTip(event)
        event.Skip()

    def onShowRowToolTip(self, event):
        self.showRowToolTip(event)
        event.Skip()

    #label click
    def onLabelClick(self, event):
        global curRow, curCol
        curRow = event.GetRow()
        curCol = event.GetCol()
        pos = event.GetPosition()
        if curRow < 0:
            #列名をクリック
            self.grid_1.SetGridCursor(0, curCol)
        elif curCol < 0:
            #行明をクリック
            self.grid_1.SetGridCursor(curRow, 0)
        event.Skip()

    #-------ダブルクリック時 ---------------
    #label Double Click
    def onLabelDClick(self, event):
        global curRow, curCol
        curRow = event.GetRow()
        curCol = event.GetCol()
        pos = event.GetPosition()
        if curRow < 0:
            #列名をダブルクリック
            self.colDclick(event, curCol)
        elif curCol < 0:
            #行名をダブルクリック
            self.rowDclick(event, curRow)

    #cell Double Click
    def onCellDClick(self, event):
        global curRow, culCol
        curRow = event.GetRow()
        curCol = event.GetCol()
        pos = event.GetPosition()
        cellCont = self.grid_1.GetCellValue(curRow, curCol)
        if cellCont[-3:] == "...":
            title = _(u"cellの編集")
            mess = _(u"このcellは、文字数または行数が多すぎるため、エディタで編集します。")
            self.okDialog(title, mess)
            error = self.runCellEditor(curRow, curCol)
            if error != "OK":
                title = _(u"エラー")
                mess = _(u"cell内容編集時にエラーが発生しました。\n編集できていません。")
                self.errDialog(title, mess)
        else:
            event.Skip()

    #-------pop up menu (mouse event)-------------
    def onRightClick(self, event): # wxGlade: MyFrame.<event_handler>
        global copyRow, copyCol, curRow, curCol
        curRow = event.GetRow()
        curCol = event.GetCol()
        pos = event.GetPosition()
        self.grid_1.PopupMenu(self.popupmenu, pos)
        event.Skip()

    #popupMenu初期化
    def setPopupMenu(self):
        self.popupmenu = wx.Menu()
        menu = [_(u"cellコピー\tCtrl+C"), _(u"cell貼付\tCtrl+V"),
                _(u"cell内容をeditorで編集"), "-",
                _(u"internalFieldのクリア"), _(u"空白cellにzeroGradientをセット"),
                _(u"cell内容をクリア（空白cell作成）"),
                "-", _(u"全表示/非表示fieldの切替え"), _(u"選択したfieldを非表示"),
                _(u"field表示順変更"), "-", _(u"cell内の表示行数・データ数変更")]
        for text in menu:
            if text == "-":
                self.popupmenu.AppendSeparator()
            else:
                item = self.popupmenu.Append(-1, text)
                self.Bind(wx.EVT_MENU, self.OnPopItemSelected, item)

    #popupMenu実行    
    def OnPopItemSelected(self, event):
        PPitem = self.popupmenu.FindItemById(event.GetId())
        text = PPitem.GetText()
        #cellコピー
        if (text == _(u"cellコピー\tCtrl+C") or text == _(u"cellコピー")):
            self.onCellCopy(event)
        #cell貼付
        elif (text == _(u"cell貼付\tCtrl+V") or text == _(u"cell貼付")):
            self.onCellPaste(event)
        #cellをEditorで編集
        elif text == _(u"cell内容をeditorで編集"):
            self.onRunCellEditor(event)
        #空白cellをzeroGradにセット
        elif text == _(u"空白cellにzeroGradientをセット"):
            self.onNullCellZeroGrad(event)
        #internalFieldのクリア
        elif text == _(u"internalFieldのクリア"):
            self.onClearInternalField(event)
        #cell内容をクリア（空白cell作成）
        elif text == _(u"cell内容をクリア（空白cell作成）"):
            self.clearCellCont()
        #表示設定クリア、全field表示
        elif text == _(u"全表示/非表示fieldの切替え"):
            self.onSwitchAllorHideFields(event)
        #選択したfieldを非表示
        elif text == _(u"選択したfieldを非表示"):
            self.onNonDisplayFields(event)
        #fieldの再表示
        elif text == _(u"field表示順変更"):
            self.onHideDisplayFields(event)
        #cell行数変更・データ数
        elif text == _(u"cell内の表示行数・データ数変更"):
            self.getDisplayMaxLinesData(event)

    #-------pop up menu (label right click) ---------------
    def onLabelRightClick(self, event): # wxGlade: MyFrame.<event_handler>
        global rowNames, colNames, delPatchName, curRow, curCol
        curRow = event.GetRow()
        curCol = event.GetCol()
        pos = event.GetPosition()
        if (curCol == -1) and (curRow >= 1):        #dimm以外を選択？
            #行を選択？
            col=0
            flag = 0
            while col < len(colNames)+1:
                if (self.grid_1.IsInSelection(curRow, col) != True):
                    flag = 1
                    break
                col += 1
            if flag == 0:
                #global変数（dir, colNames, rowNames)を設定
                self.setGlobalValue()
                self.grid_1.PopupMenu(self.popupLabelMenu, pos)
        if (curCol >= 1) and (curRow == -1):        #field(col)の選択？
            #列を選択？
            row =0
            flag = 0
            while row < len(rowNames)+2:
                if (self.grid_1.IsInSelection(row, curCol) != True):
                    flag = 1
                    break
                row += 1
            if flag == 0:
                #global変数（dir, colNames, rowNames)を設定
                self.setGlobalValue()
                #popupmenuを表示
                self.grid_1.PopupMenu(self.popupFieldMenu, pos)
        event.Skip()

    #popupMenu初期化（label）
    def setLabelPopupMenu(self):
        self.popupLabelMenu = wx.Menu()
        for text in [_(u"行コピー"), _(u"行貼付"), "-",
                     _(u"patch名sortする/しない切替え"),
                     _(u"cell内の表示行数・データ数変更"), "-",
                     _(u"patch名変更"), _(u"新しい空patch追加"), _(u"空patch削除"), 
                     _(u"全ての空patch削除"), "-",
                     _(u"変数定義行（空）の表示/非表示切り替え")]:
            if text == "-":
                self.popupLabelMenu.AppendSeparator()
            else:
                item = self.popupLabelMenu.Append(-1, text)
                self.Bind(wx.EVT_MENU, self.OnPopLabelItemSelected, item)

    #popupMenu初期化（field）
    def setFieldPopupMenu(self):
        self.popupFieldMenu = wx.Menu()
        for text in [_(u"全表示/非表示fieldの切替え"), _(u"選択したfieldを非表示"),
                     _(u"field表示順変更"), "-", _(u"fieldコピー"),
                     _(u"field貼付(挿入)"), "-", _(u"field名変更"), _(u"field削除")]:
            if text == "-":
                self.popupFieldMenu.AppendSeparator()
            else:
                item = self.popupFieldMenu.Append(-1, text)
                self.Bind(wx.EVT_MENU, self.OnPopupFieldItemSelected, item)


    def OnPopLabelItemSelected(self, event):
        global delPatchName, rowNames
        PPitem = self.popupLabelMenu.FindItemById(event.GetId())
        text = PPitem.GetText()
        #cellコピー
        if text == _(u"行コピー"):
            self.onCellCopy(event)
        #cell貼付
        elif text == _(u"行貼付"):
            self.onCellPaste(event)
        #patch名sort切り替え
        elif text == _(u"patch名sortする/しない切替え"):
            self.onPatchSortChange(event)
        #patch名変更
        elif text == _(u"patch名変更"):
            self.onRenamePatchName(event)
        #空patch削除
        elif text == _(u"空patch削除"):
            self.onDeletePatch(event)
        #空patch追加
        elif text == _(u"新しい空patch追加"):
            self.onAddPatch(event)
        #cell行数・データ数変更
        elif text == _(u"cell内の表示行数・データ数変更"):
            self.getDisplayMaxLinesData(event)
        #全ての空patch削除
        elif text == _(u"全ての空patch削除"):
            self.deleteAllNullPatches(event)
        #変数定義行（空）の表示・非表示
        elif text == _(u"変数定義行（空）の表示/非表示切り替え"):
            self.showVariableRow(event)


    def onPatchSortChange(self, event):
        global sortPatchName
        flag = self.checkSaveReload()
        if flag == "RETURN":
            return
        elif flag == "SAVE":
            self.onSave(event)

        if sortPatchName == "yes":
            sortPatchName = "no"
        else:
            sortPatchName = "yes"
        itemsData = [["sortPatchName", sortPatchName]]
        writeConfigData(itemsData)
        self.onReload(event)

    def OnPopupFieldItemSelected(self, event):
        PPitem = self.popupFieldMenu.FindItemById(event.GetId())
        text = PPitem.GetText()
        #field非表示
        if text == _(u"選択したfieldを非表示"):
            self.onNonDisplayFields(event)
        #field再表示、表示順変更
        elif text == _(u"field表示順変更"):
            self.onHideDisplayFields(event)
        #表示設定クリア、全field表示
        elif text == _(u"全表示/非表示fieldの切替え"):
            self.onSwitchAllorHideFields(event)
        #fieldコピー
        elif text == _(u"fieldコピー"):
            self.onCopyFields(event)
        #field貼付(挿入)
        elif text == _(u"field貼付(挿入)"):
            self.onPasteFields(event)
        #field名変更
        elif text == _(u"field名変更"):
            self.onRenameField(event)
        #field削除
        elif text == _(u"field削除"):
            self.onDeleteFields(event)

    #-------------- 処理 --------------------

    #  clearCellCont
    #    cell内容をクリア（空白cellを作る）
    def clearCellCont(self):
        #選択範囲の先頭を取得
        [stRow, stCol] = self.getFirstSelectCell()
        if stRow < 0:
            #選択範囲が設定されていない場合は、currentCellをクリア
            self.grid_1.SetCellValue(curRow, curCol, "")
        else:
            #選択範囲を取得
            maxRow = self.grid_1.GetNumberRows()
            maxCol = self.grid_1.GetNumberCols()
            row = stRow
            while row < maxRow:
                col = stCol
                flag = 0
                while col < maxCol:
                    if self.grid_1.IsInSelection(row, col) == True:
                        self.grid_1.SetCellValue(row, col, "")
                        flag = 1
                    col += 1
                #行内に選択cellが無い場合は、終了
                if flag == 0:
                    break
                row += 1

    #  showVariableRow(event)
    #    変数定義行の表示・非表示切り替え
    def showVariableRow(self, event):
        global isVariable, isVariableBoundary
        flag = self.checkSaveReload()
        if flag == "RETURN":
            return
        elif flag == "SAVE":
            self.onSave(event)

        #変数定義行の表示・非表示
        if isVariable == False or isVariableBoundary == False:
            #表示
            isVariable = True
            isVariableBoundary = True
        else:
            #非表示
            if isVariable == True and isVariableBoundary == True:
                row = 1
                if self.nRowCellValue(row) == 0:
                    isVariable = False
                row = 3
                if self.nRowCellValue(row) == 0:
                    isVariableBoundary = False
            elif isVariable == False and isVariableBoundary == True:
                row = 2
                if self.nRowCellValue(row) == 0:
                    isVariableBoundary = False
            elif isVariable == True and isVariableBoundary == False:
                row = 1
                if self.nRowCellValue(row) == 0:
                    isVariable = False
        self.onReload(event)
        return

    def nRowCellValue(self, row):
        col = 0
        n = 0
        while col < self.grid_1.GetNumberCols():
            val = self.grid_1.GetCellValue(row, col)
            if len(val.split()) != 0:
                n += 1
            col += 1
        return n

    #  deleteAllNullPatches
    #    全ての空patchを削除する
    def deleteAllNullPatches(self, event):
        global dataDir, boundaryDir, colNames
        flag = self.checkSaveReload()
        if flag == "RETURN":
            return
        elif flag == "SAVE":
            self.onSave(event)
        
        patchConts = getFoamContents.getPatchCont(boundaryDir)
        nullPatches = []
        for patchCont in patchConts:
            patchName = patchCont[0]
            nFaces = patchCont[1]
            if nFaces == 0:
                nullPatches.append(patchName)
        title = _(u"全ての空patch削除")
        mess = _(u"全ての空patchを削除しますか？\n")
        mess += _(u"「") + str(len(nullPatches)) + _(u"」")
        mess += _(u"個の空patchがあります。")
        stat = self.okCancelDialog(title, mess)
        if stat != "OK":
            return

        mess = _(u"本当に削除しますか？\n  削除後は元に戻りません。")
        stat = self.okCancelDialog(title, mess)
        if stat != "OK":
            return

        #全ての空patch削除の処理
        #global変数（dir, colNames, rowNames）を設定
        self.setGlobalValue()
        #全ての空patchを削除
        print _(u"全ての空patchを削除しています。"),
        error = ["OK", ""]
        for nullPatch in nullPatches:
            sys.stdout.write(".")
            error = pyTreeFoam.deletePatch(boundaryDir, dataDir, colNames, nullPatch)
            if error[0] != "OK":
                break
        print _(u"削除しました。")
        if error[0] != "OK":
            title = _(u"エラー")
            mess = _(error[1])
            self.errDialog(title, mess)
        self.onReload(event)


    #cell内の表示行数変更
    #  internalField
    def changeMaxLinesCellInternal(self, event):
        global maxRowsInCellInternal
        flag = self.checkSaveReload()
        if flag == "RETURN":
            return
        elif flag == "SAVE":
            self.onSave(event)

        title = _(u"cell内の表示行数変更(internal)")
        mess = _(u"internalField内容を表示するcellの最大表示行数を変更します。\n\n　　現在の設定：") + str(maxRowsInCellInternal) + _(u" 行")
        text = str(maxRowsInCellInternal)
        inputTextDDialog.title = title
        inputTextDDialog.message = mess
        inputTextDDialog.inputText = text
        dialog = inputTextDDialog.MyDialog(None)
        result = dialog.ShowModal()
        if inputTextDDialog.status == "OK":
            text = inputTextDDialog.inputText
            maxRowsInCellInternal = int(text)
            self.onReload(event)
            itemsData = [["maxLinesCellInternal", text]]
            writeConfigData(itemsData)

    #cell内の表示行数変更
    #  patch
    def changeMaxLinesCellPatch(self, event):
        global maxRowsInCell
        flag = self.checkSaveReload()
        if flag == "RETURN":
            return
        elif flag == "SAVE":
            self.onSave(event)

        title = _(u"cell内の表示行数変更(patch)")
        mess = _(u"patch内容を表示するcellの最大表示行数を変更します。\n\n　　現在の設定：") + str(maxRowsInCell) + _(u" 行")
        text = str(maxRowsInCell)
        inputTextDDialog.title = title
        inputTextDDialog.message = mess
        inputTextDDialog.inputText = text
        dialog = inputTextDDialog.MyDialog(None)
        result = dialog.ShowModal()
        if inputTextDDialog.status == "OK":
            text = inputTextDDialog.inputText
            maxRowsInCell = int(text)
            self.onReload(event)
            itemsData = [["maxLinesCellPatch", text]]
            writeConfigData(itemsData)


    #toolTipの表示
    #  cell位置では、toolTipを隠す
    def showCellToolTip(self, event):
        global toolTipText
        (x, y) = event.GetPositionTuple()
        row = self.grid_1.YToRow(y)
        col = self.grid_1.XToCol(x)
        self.grid_1.SetToolTip(wx.ToolTip.Enable(False))

    #col Label でfieldOpenを表示
    def showColToolTip(self, event):
        global toolTipText
        (x, y) = event.GetPositionTuple()
        row = self.grid_1.YToRow(y)
        col = self.grid_1.XToCol(x)
        if col == 0:
            toolTipText = _(u"ここをダブルクリックすると\nEditorでboundaryをopenする。")
        elif col >= 1:
            toolTipText = _(u"ここをダブルクリックすると\nEditorでfieldをopenする。")
        else:
            toolTipText = ""
        self.grid_1.GetGridColLabelWindow().SetToolTipString(toolTipText)

    #row label でpatch名変更を表示 
    def showRowToolTip(self, event):
        global toolTipText
        (x, y) = event.GetPositionTuple()
        row = self.grid_1.YToRow(y)
        col = self.grid_1.XToCol(x, y)
        if row >=2:
            toolTipText = _(u"ここをダブルクリックすると\npatch名が変更できる。")
        else:
            toolTipText = ""
        self.grid_1.GetGridRowLabelWindow().SetToolTipString(toolTipText)

    #列名ダブルクリック
    def colDclick(self, event, curCol):
        global colNames, dataDir, boundaryDir
        self.setGlobalValue()
        if curCol >= 1:
            field = colNames[curCol-1]
            fieldDir = dataDir
            openFile = fieldDir + "/" + field
            self.runEditorAsciiBinaryFile(openFile)
        elif curCol == 0:
            openFile = boundaryDir + "/boundary"
            pyTreeFoam.runEditor(openFile)

    #行名ダブルクリック
    def rowDclick(self, event, curRow):
        global rowNames, dataDir, isVariable, isVariableBoundary
        posRowName = self.getPosRowName()
        if curRow >= posRowName:
            self.setGlobalValue()
            self.onRenamePatchName(event)

    #
    #  onClearInternalField
    #    internalFieldをuniform形式で全て変更
    def onClearInternalField(self, event):
        error = ["", ""]
        intRow = self.getInternalFieldRowFromGrid()
        #選択範囲を取得
        [firstRow, firstCol] = self.getFirstSelectCell()
        if firstRow > 0:
            [lastRow, lastCol] = self.getLastSelectCell(firstRow, firstCol)
            #if firstRow == 1 and lastRow == 1:
            if firstRow == intRow and lastRow == intRow:
                #選択範囲を取得
                maxRow = lastRow
                maxCol = lastCol
            else:
                #internalField以外を選択している場合
                error = ["NG", _(u"クリアするinternalFieldのcellを選択してください。")]
        else:
            #選択していない場合は、curCellを設定
            #if curRow == 1 and curCol != 0:
            if curRow == intRow and curCol != 0:
                firstCol = curCol
                maxCol = curCol
            else:
                error = ["NG", _(u"クリアするinternalFieldのcellを選択してください。")]
        if error[0] != "":
            title = _(u"エラー")
            self.errDialog(title, error[1])
            return

        flag = 0
        #maxRow = self.grid_1.GetNumberRows()
        #maxCol = self.grid_1.GetNumberCols()
        #col = 1
        col = firstCol
        if col == 0:
            col += 1
        while col<=maxCol:
            #value = self.grid_1.GetCellValue(1, col)
            value = self.grid_1.GetCellValue(intRow, col)
            if value[:len("uniform ")] != "uniform ":
                newValue = self.getNewUniform(col)
                #self.grid_1.SetCellValue(1, col, newValue)
                self.grid_1.SetCellValue(intRow, col, newValue)
                flag = 1
            col += 1
        self.grid_1.AutoSize()
        self.Layout()
        self.showSelectCell()
        #zeroGradientを書き込んだ場合保存flagをセット
        if flag == 1:
            self.alarmSaveFlagSet()

    #  getNewUniform
    #    uniform形式の値を取得して返す
    def getNewUniform(self, col):
        ans = ""
        volValue = self.grid_1.GetCellValue(0, col)
        if volValue.find("Scalar") >= 0:
            ans = "uniform 0;"
        elif volValue.find("Vector") >= 0:
            ans = "uniform (0 0 0);"
        elif volValue.find("SymmTensor") >= 0:
            ans = "uniform (0 0 0 0 0 0);"
        elif volValue.find("Tensor") >= 0:
            ans = "uniform (0 0 0 0 0 0 0 0 0);"
        else:
            ans = "uniform 0;"
        return ans

    #
    #  onNullCellZeroGrad
    #    空白cellをzeroGradient、uniform 0 で埋める
    def onNullCellZeroGrad(self, event):

        def getBoundaryType(row):
            patchType = ""
            bCont = self.grid_1.GetCellValue(row, 0)
            lines = bCont.split("\n")
            for line in lines:
                words = line.split()
                if words[0] == "type":
                    patchType = words[1]
                    break
            return patchType

        flag = 0
        maxRow = self.grid_1.GetNumberRows()
        maxCol = self.grid_1.GetNumberCols()
        col = 1
        while col < maxCol:
            #row = 2
            row = self.getStRowFromGrid()
            while row < maxRow:
                cellValue = self.grid_1.GetCellValue(row, col)
                if cellValue == "":
                    patchType = getBoundaryType(row)
                    value = getBoundaryContFromPatchType(patchType)
                    self.grid_1.SetCellValue(row, col, value)
                    flag = 1
                row += 1
            col += 1
        self.grid_1.AutoSize()
        self.Layout()
        self.showSelectCell()
        #zeroGradientを書き込んだ場合保存flagをセット
        if flag == 1:
            self.alarmSaveFlagSet()

    #
    #  onDeleteFields
    #    fieldの削除
    def onDeleteFields(self, event):
        global data, boundaryDir, colNames, dataDir, curCol
        flag = self.checkSaveReload()
        if flag == "RETURN":
            return
        elif flag == "SAVE":
            self.onSave(event)

        selCol = self.grid_1.GetSelectedCols()
        colNo = []
        delFieldDir = []
        for n in selCol:
            colNo.append(n-1)
            delFieldDir.append(dataDir + "/" + colNames[n-1])
        #field削除の確認メッセージ
        title = _(u"fieldの削除")
        #mess = _(u"次のfieldをゴミ箱へ移動します。\n")
        mess = _(u"次のfieldを完全に削除します。\n")
        for n in colNo:
            mess += colNames[n] + ", "
        mess = mess[:-1]
        ans = self.okCancelDialog(title, mess)
        if ans != "OK":
            return
        #field削除
        i=0
        while i<len(delFieldDir):
            #ファイルをゴミ箱へ移動
            comm = "rm -rf " + delFieldDir[i]
            os.system(comm)
            #obj = gio.File(delFieldDir[i])
            #obj.trash()
            i += 1
        #grid再表示
        newColNames = []
        i=0
        while i<len(colNames):
            flag = 0
            for n in colNo:
                if i == n:
                    flag = 1
                    break
            if flag == 0:
                newColNames.append(colNames[i])
            i += 1
        colNames = newColNames
        fileName = getSaveDisplayFieldsFileName(dataDir)
        if len(glob.glob(fileName)) != 0:
            dispNames = getDisplayFields(fileName)
            newDispNames = []
            i=0
            while i<len(dispNames):
                for name in colNames:
                    if dispNames[i] == name:
                        newDispNames.append(name)
                        break
                i += 1
            saveDisplayFields(newDispNames, dataDir)
        self.readDataMakeGrid()

    #
    #  onRenameField
    #    field名を変更する
    def onRenameField(self, event):
        global data, boundaryDir, colNames, dataDir, curCol
        flag = self.checkSaveReload()
        if flag == "RETURN":
            return
        elif flag == "SAVE":
            self.onSave(event)

        selCol = self.grid_1.GetSelectedCols()
        if len(selCol) != 1:
            title = _(u"エラー")
            mess = _(u"複数のfieldは選択しないでください。\n1個のfieldを選択して、field名を変更してください")
            self.errDialog(title, mess)
            return
        colNo = selCol[0] - 1
        title = _(u"field名の変更")
        message = _(u"新しいfield名を入力してください")
        defText = colNames[colNo]
        #field名のチェック
        flag = 0
        while flag == 0:
            newName = self.textDialog(title, message, defText)
            if newName == "":
                flag = 1
            else:
                sameName = 0
                for name in colNames:
                    if name == newName:
                        sameName = 1
                        break
                if sameName == 0:
                    flag = 1
                else:
                    message = _(u"同じ名前のfieldがあります。再入力してください。")
                    defText = newName
        if newName == "":
            return
        #field名の変更
        oldDir = dataDir + "/" + colNames[colNo]
        newDir = dataDir + "/" + newName
        comm = "mv " + oldDir + " " + newDir
        print comm
        os.system(comm)
        #grid表示
        colNames[colNo] = newName
        self.readDataMakeGrid()

    #
    #  onPasteFields
    #    fieldの貼付（挿入）
    def onPasteFields(self, event):
        global data, boundaryDir, colNames, dataDir, curCol
        flag = self.checkSaveReload()
        if flag == "RETURN":
            return
        elif flag == "SAVE":
            self.onSave(event)

        #pasteFieldsDir,Nameを取得
        f=open(clipBoard); contents=f.readlines(); f.close()
        pasteFieldsDir = []
        pasteFieldsName = []
        for fieldDir in contents:
            name = fieldDir[:-1].split("/")[-1]
            pasteFieldsName.append(name)
            pasteFieldsDir.append(fieldDir[:-(len(name)+1)])
        #貼り付けるデータが正しいデータかどうかをチェック
        i=0
        while i<len(pasteFieldsName):
            pasteDir = pasteFieldsDir[i] + pasteFieldsName[i]
            mess = ""
            if len(glob.glob(pasteDir)) == 0:
                title = _(u"エラー")
                mess = _(u"貼り付けるデータが間違っています。\n貼付を中止します。")
                self.errDialog(title, mess)
                break
            i += 1
        if mess != "":
            return
        #fieldNameのチェック
        #[folders, fields] = pyTreeFoam.getFoldersFiles(dataDir)
        fields = pyTreeFoam.getFieldNames(dataDir)
        newPasteName = []
        n=0
        for pasteName in pasteFieldsName:
            i = 0; flag = 0
            newName = pasteName
            while flag == 0 and i<=10:
                sameName = 0
                for field in fields:
                    if field == newName:
                        newName = pasteName + "_copy" + str(i)
                        i += 1
                        sameName = 1
                        break
                if sameName == 0:
                    flag = 1                #loop脱出
            newPasteName.append(dataDir + "/" + newName)
            n += 1
        if i>10:
            title = _(u"エラー")
            mess = _(u"fieldを貼り付ける事ができません")
            self.errDialog(title, mess)
            return
        #fieldを貼り付ける
        i=0
        while i<len(pasteFieldsName):
            copyName = pasteFieldsDir[i] + pasteFieldsName[i]
            pasteName = newPasteName[i]
            comm = "cp " + copyName + " " + pasteName
            os.system(comm)
            i += 1
        print "paste --->", pasteName
        #grid再表示
        fileName = getSaveDisplayFieldsFileName(dataDir)
        if len(glob.glob(fileName)) == 0:
            for nameDir in newPasteName:
                colNames.append(nameDir.split("/")[-1])
            colNames.sort()
            self.readDataMakeGrid()
        else:
            dispNames = getDisplayFields(fileName)
            selCols = self.grid_1.GetSelectedCols()
            insCol = selCols[0]
            i=0; newNames =[]
            while i<insCol:
                newNames.append(dispNames[i])
                i += 1
            for nameDir in newPasteName:
                newNames.append(nameDir.split("/")[-1])
            while i<len(dispNames):
                newNames.append(dispNames[i])
                i += 1
            saveDisplayFields(newNames, dataDir)
            colNames = newNames
            self.readDataMakeGrid()

    #
    #  onCopyField
    #    fieldのコピー
    def onCopyFields(self, event):
        global data, boundaryDir, colNames, dataDir, curCol
        copyFields = []
        #選択範囲の先頭を取得
        [selRow, selCol] = self.getFirstSelectCell()
        if selRow < 0:
            #選択されていない場合は、cuurentCellを選択
            copyFields.append(curCol)
        else:
            #選択範囲を取得
            maxCol = self.grid_1.GetNumberCols()
            col = selCol
            while col<maxCol:
                if self.grid_1.IsInSelection(selRow, col) == True:
                    copyFields.append(col)
                col += 1
        #非表示列が0列かどうかチェック
        if copyFields[0] == 0:
            copyFields = copyFields[1:]
        if len(copyFields) == 0:
            title = _(u"エラー")
            mess = _(u"fieldが選択されていません")
            self.errDialog(title, mess)
            return
        #copyFieldDirを取得
        copyFieldDir = []
        for fieldNo in copyFields:
            copyFieldDir.append(dataDir + "/" + colNames[fieldNo-1])
        #clipBoardに保存
        print "copy--> clipBoard"
        f=open(clipBoard, "w")
        for val in copyFieldDir:
            f.write(val + "\n")
        f.close()

    #
    #  onAddPatch
    #    空patch追加
    def onAddPatch(self, event):
        global boundaryDir, dataDir, curRow, curCol
        #cellの変更内容をチェック
        if self.checkEditedFlag() == 1:
            #cell修正
            title = _(u"警告")
            mess = _(u"cell内容が変更されています。\nこのまま継続すると変更内容が失われます。\n　　継続しますか？")
            ans = self.okCancelDialog(title, mess)
            if ans != "OK":
                return
        #挿入行数を取得
        nInsert = len(self.grid_1.GetSelectedRows())
        #errorチェック
        startFaceNo = getStartFaceNoAtNullPatch(boundaryDir)
        [error, boundaryCont, newPatchNames] = addNullPatches(boundaryDir, 
            startFaceNo, nInsert)
        #[error, boundaryCont, newPatchName] = addNullPatch(boundaryDir, startFaceNo)
        if error != "":
            title = _(u"エラー")
            self.errDialog(title, error)
            return

        setBoundaryContents(boundaryDir, boundaryCont)
        for newPatchName in newPatchNames:
            pyTreeFoam.addPatchAtBoundaryField(dataDir, newPatchName)
        """
        maxRow = self.grid_1.GetNumberRows()
        self.grid_1.SelectRow(maxRow)
        """
        self.onReload(event)
        #newPatchNameの行をselectさせる
        self.selectNewPatchName(newPatchName)
        #curRow = maxRow
        self.showSelectCell()
        if nInsert == 1:
            self.onRenamePatchName(event)

    #  selectNewPatchName
    #    追加したnewPatchNameをselectする
    def selectNewPatchName(self, newPatchName):
        global rowNames, curRow
        selectNo = 0
        i = 0
        for rowName in rowNames:
            if rowName == newPatchName:
                selectNo = i
                break
            i += 1
        #curRow = selectNo + 2
        curRow = selectNo + self.getPosRowName()
        self.grid_1.SelectRow(curRow)

    #
    #  onDeletePatch
    #    patchの削除
    def onDeletePatch(self, event):
        global delPatchName, rowNames
        #cellの変更内容をチェック
        if self.checkEditedFlag() == 1:
            #cell修正
            title = _(u"警告")
            mess = _(u"cell内容が変更されています。\nこのまま継続すると変更内容が失われます。\n　　継続しますか？")
            ans = self.okCancelDialog(title, mess)
            if ans != "OK":
                return
        #global変数（dir, colNames, rowNames）を設定
        self.setGlobalValue()
        #削除するpatch名を取得
        selRows = self.grid_1.GetSelectedRows()
        if len(selRows) >= 1 and selRows[0] > 1:
            #空patch削除
            title = _(u"空patchの削除")
            mess = _(u"patch「") + str(len(selRows)) + _(u"ヶ」を削除します。\n\n　　削除後は、元に戻せません。")
            ans = self.okCancelDialog(title, mess)
            if ans == "OK":
                mess = _(u"本当に削除しますか？\n  削除後は元に戻りません。")
                ans = self.okCancelDialog(title, mess)
                if ans == "OK":
                    #patchを削除
                    posRowName = self.getPosRowName()
                    for row in selRows:
                        delPatchName = rowNames[row-posRowName]
                        error = deletePatch(delPatchName)
                        if error[0] != "OK":
                            break
                    if error[0] != "OK":
                        #エラー処理
                        title = _(u"エラー")
                        mess = error[1]
                        self.errDialog(title, mess)
                    else:
                        self.onReload(event)
                        self.grid_1.SelectRow(selRows[0])
        else:
            if len(selRows) == 0:
                mess = _(u"行を選択していません。\n\npatch名（ラベル部）をクリックして行を選択してください。")
            elif selRows[0] <= 1:
                mess = _(u"patch名の行を選択してください。")
            else:
                mess = _(u"空patch削除時、エラーが発生しました。")
            self.errDialog(_(u"エラー"), mess)

    #
    #  onRenamePatchName
    #    patch名の変更
    def onRenamePatchName(self, event):
        global delPatchName, rowNames
        #cellの変更内容をチェック
        if self.checkEditedFlag() == 1:
            #cell修正
            title = _(u"警告")
            mess = _(u"cell内容が変更されています。\nこのまま継続すると変更内容が失われます。\n　　継続しますか？")
            ans = self.okCancelDialog(title, mess)
            if ans != "OK":
                return
        #global変数（dir, colNames, rowNames）を設定
        self.setGlobalValue()
        #renameするpatch名を取得
        selRows = self.grid_1.GetSelectedRows()
        if len(selRows) == 1:
            row = selRows[0]
            posRowName = self.getPosRowName()
            if row >= posRowName:
                #delPatchName = rowNames[row-2]
                delPatchName = rowNames[row-posRowName]
                #patch名変更
                title = _(u"patch名変更")
                message = _(u"patch名を変更します")
                defText = delPatchName
                newPatchName = self.textDialog(title, message, defText)
                if (newPatchName != "") and (newPatchName != delPatchName):
                    for patchName in rowNames:
                        error = ["OK", ""]
                        if patchName == newPatchName:
                            error = ["NG",
                                     _(u"「") + newPatchName + _(u"」は同じpatch名が存在します")]
                            break
                    if error[0] != "OK":
                        #エラー表示
                        self.errDialog(_(u"エラー"), error[1])
                    else:
                        #patch名を変更
                        error = changePatchName(delPatchName, newPatchName)
                        if error[0] != "OK":
                            self.errDialog(_(u"エラー"), error[1])
                        else:
                            self.onReload(event)
                            self.selectNewPatchName(newPatchName)
            else:
                mess = _(u"patch名の行を選択してください。")
                self.errDialog(_(u"エラー"), mess)    
        else:
            title = _(u"エラー")
            if len(selRows) > 1:
                mess = _(u"複数行を選択しています。\n\n1行を選択してください。")
            else:
                mess = _(u"行を選択していません。\n\npatch名（ラベル部）をクリックして行を選択してください。")
            self.errDialog(title, mess)

    #
    #  onSwitchAllorHideFields
    #    表示設定を全field/非表示切り替え
    def onSwitchAllorHideFields(self, event):
        global colNames
        flag = self.checkSaveReload()
        if flag == "RETURN":
            return
        elif flag == "SAVE":
            self.onSave(event)
        self.setGlobalValue()
        fileName = getSaveDisplayFieldsFileName(dataDir)
        if len(glob.glob(fileName)) == 0:
            if len(glob.glob(fileName + ".bak")) == 0:
                title = _(u"全field表示/非表示設定")
                mess = _(u"非表示設定ファイルがありません。\n")
                mess += _(u"fieldの非表示設定を行ってください。")
                self.okDialog(title, mess)
            else:
                #非表示設定
                comm = "mv " + fileName + ".bak " + fileName
                os.system(comm)
                colNames = getDisplayFields(fileName)
                self.readDataMakeGrid()
        else:
            #全field表示
            comm = "mv " + fileName + " " + fileName + ".bak"
            os.system(comm)
            colNames = pyTreeFoam.getFieldNames(dataDir)
            self.readDataMakeGrid()
        #保存フラグクリア
        self.alarmSaveFlagClear()


    #
    #  onDisplayAllFields
    #    表示設定クリア、全field表示
    def onDisplayAllFields(self, event):
        global colNames
        self.setGlobalValue()
        fileName = getSaveDisplayFieldsFileName(dataDir)
        if len(glob.glob(fileName)) == 0:
            title = _(u"全fieldの表示")
            mess = _(u"既に全fieldが表示されています。")
            self.okDialog(title, mess)
        else:
            title = _(u"全fieldの表示")
            mess = _(u"非表示設定ファイルをクリアして、全fieldを再読込します。")
            ans = self.okCancelDialog(title, mess)
            if ans == "OK":
                comm = "rm " + fileName
                os.system(comm)
                #[folders, fields] = pyTreeFoam.getFoldersFiles(dataDir)
                fields = pyTreeFoam.getFieldNames(dataDir)
                colNames = fields
                self.readDataMakeGrid()
                

    #
    #  onNonDisplayFields
    #    選択したfieldを非表示
    def onNonDisplayFields(self, event):
        global data, boundaryDir, rowNames, colNames, dataDir
        flag = self.checkSaveReload()
        if flag == "RETURN":
            return
        elif flag == "SAVE":
            self.onSave(event)
        self.setGlobalValue()
        nonDisplayFields = []
        #選択範囲の先頭を取得
        [selRow, selCol] = self.getFirstSelectCell()
        if selRow < 0:
            #選択されていない場合は、cuurentCellを選択
            nonDisplayFields.append(curCol)
        else:
            #選択範囲を取得
            maxCol = self.grid_1.GetNumberCols()
            col = selCol
            while col<maxCol:
                if self.grid_1.IsInSelection(selRow, col) == True:
                    nonDisplayFields.append(col)
                col += 1
        #非表示列が0列かどうかチェック
        if nonDisplayFields[0] == 0:
            nonDisplayFields = nonDisplayFields[1:]
        #colNamesを修正
        newColNames = []
        i = 0
        while i < len(colNames):
            flag = 0
            for j in nonDisplayFields:
                if (i == j-1):
                    flag = 1
            if flag == 0:
                newColNames.append(colNames[i])
            i += 1
        colNames = newColNames
        #fieldの非表示
        i=len(nonDisplayFields)
        while i>0:
            i -= 1
            col = nonDisplayFields[i]
            self.grid_1.DeleteCols(col, 1)
        #項目を再セット
        self.grid_1.SetColLabelValue(0, "define patch\n(boundary)")
        i=1
        for item in colNames:
            self.grid_1.SetColLabelValue(i, item)
            i+=1
        #表示設定ファイル有無確認
        self.checkDisplayFieldsFile(dataDir)
        #非表示設定を保存
        saveDisplayFields(colNames, dataDir)
        self.setLabelColour(dataDir)
        #保存フラグクリア
        self.alarmSaveFlagClear()

    #
    #  onHideDisplayFields
    #    Fieldの非表示、表示、表示順の設定
    def onHideDisplayFields(self, event):
        global colNames, dataDir
        flag = self.checkSaveReload()
        if flag == "RETURN":
            return
        elif flag == "SAVE":
            self.onSave(event)
        self.setGlobalValue()
        #[folders, fields] = pyTreeFoam.getFoldersFiles(dataDir)
        fields = pyTreeFoam.getFieldNames(dataDir)
        hideNames = []
        for field in fields:
            flag = 0
            for showName in colNames:
                if showName == field:
                    flag = 1
                    break
            if flag == 0:
                hideNames.append(field)
        hideNames.sort()
        openFieldForGridEditorDDialog.hideNames = hideNames
        openFieldForGridEditorDDialog.colNames = colNames
        dialog = openFieldForGridEditorDDialog.MyDialog(None)
        result = dialog.ShowModal()
        ans = openFieldForGridEditorDDialog.status
        dialog.Destroy()
        if ans == "OK":
            colNames = openFieldForGridEditorDDialog.colNames
            #表示設定ファイル有無確認
            self.checkDisplayFieldsFile(dataDir)
            #非表示設定を保存
            saveDisplayFields(colNames, dataDir)
            #grid再作成
            self.readDataMakeGrid()
            #保存フラグクリア
            self.alarmSaveFlagClear()


    def checkDisplayFieldsFile(self, dataDir):
        fileName = getSaveDisplayFieldsFileName(dataDir)
        if len(glob.glob(fileName)) == 0:
            title = _(u"表示field設定ファイルの作成")
            mess = _(u"非表示、表示fieldの設定ファイルを作成しました。\n")
            mess += _(u"  設定した内容は、次回のGridEditor起動時に反映されます。")
            self.okDialog(title, mess)
            

    #
    #  readDataMakeGrid
    #    cellデータを読込み、gridを再作成する
    def readDataMakeGrid(self):
        global data
        data = self.loadFromGaugeDialog(dataDir, colNames, rowNames)
        self.checkBadField(colNames, data)
        self.remakeGrid()

    #
    #  readDataMakeGridNoCheck
    #    cellデータを読込み、gridを再作成する
    def readDataMakeGridNoCheck(self):
        global data
        data = self.loadFromGaugeDialog(dataDir, colNames, rowNames)
        #self.checkBadField(colNames, data)
        self.remakeGrid()

    def remakeGrid(self):
        #Grid再作成
        title = self.GetTitle()
        self.initializeGridSize()           #（1x1）のgridに設定
        self.SetTitle(title)
        self.createMatrix()
        self.setMatrixData()
        self.grid_1.AutoSize()
        self.clearStatus()
        self.Layout()
        self.setLabelColour(dataDir)
        self.setCellFontColour()



    #
    #  loadFromGaugeDialog(dataDir, colNames, rowNames)
    #    gaugeDialogからデータを取得する
    def loadFromGaugeDialog(self, dataDir, colNames, rowNames):
        global boundaryData
        #boundaryの内容を取得
        defineDataSub = getDefinePatchData(boundaryDir, rowNames)
        defineData = self.deleteNonuniformListData(defineDataSub)
        #読み込み
        gaugeDDialog.job = "load"
        gaugeDDialog.title = _(u"fieldの読み込み")
        gaugeDDialog.dataDir = dataDir
        gaugeDDialog.colNames = colNames
        gaugeDDialog.rowNames = rowNames
        gaugeDDialog.defineData = defineData
        gaugeDDialog.maxRowsInCell = maxRowsInCell      #cell内の最大表示行数を設定
        gaugeDDialog.nMaxLinesBinToAscii = nMaxLinesBinToAscii
        dialog = gaugeDDialog.MyDialog(None)
        result = dialog.ShowModal()
        ans = gaugeDDialog.status
        dialog.Destroy()
        if ans == "OK":
            data = gaugeDDialog.data
        else:
            #読み込みをキャンセルした場合
            data = []
            col = 0; row = 0
            while col < len(colNames):
                dataCol = []
                while row < len(rowNames):
                    dataCol.append("")
                    row += 1
                data.append(dataCol)
                col += 1
        return data

    #
    #  saveAtGaugeDialog
    #    gaugeDialogを通してデータを保存する
    def saveAtGaugeDialog(self, dataDir, colNames, rowNames, cellData, intData):
        #fieldを保存
        gaugeDDialog.job = "save"
        gaugeDDialog.title = _(u"fieldの保存")
        gaugeDDialog.dataDir = dataDir
        gaugeDDialog.colNames = colNames
        gaugeDDialog.rowNames = rowNames
        gaugeDDialog.intData = intData
        gaugeDDialog.data = cellData
        dialog = gaugeDDialog.MyDialog(None)
        result = dialog.ShowModal()
        ans = gaugeDDialog.status
        error = gaugeDDialog.error
        dialog.Destroy()
        if error[0] != "OK":
            title = _(u"エラー")
            mess = error[1]
            self.errDialog(title, mess)
        if ans == "OK":
            return
        else:
            #保存をキャンセルした場合
            title = _(u"保存の中止")
            mess = _(u"保存を中止しました")
            self.okDialog(title, mess)
        return

    # getVariableNames
    #   変数名を表中から取得
    def getVariableNames(self):
        #変数名の取得
        variables = []
        if isVariable == False:
            for field in colNames:
                variables.append("")
        else:
            row = 1
            col = 1
            for field in colNames:
                names = self.grid_1.GetCellValue(row, col)
                variables.append(names)
                col += 1
        #変数名（boundary）の取得
        variablesBoundary = []
        if isVariableBoundary == False:
            for field in colNames:
                variablesBoundary.append("")
        else:
            name = ""
            row = 1
            maxRow = self.grid_1.GetNumberRows()
            rowName = self.grid_1.GetRowLabelValue(row)
            while rowName != "otherNames\n(boundary)" and row<maxRow:
                row += 1
                rowName = self.grid_1.GetRowLabelValue(row)
            if row >= maxRow:
                for field in colNames:
                    variablesBoundary.append("")
            else:
                col = 1
                for field in colNames:
                    names = self.grid_1.GetCellValue(row, col)
                    variablesBoundary.append(names)
                    col += 1
        #取得した内容を戻す
        return [variables, variablesBoundary]            

    #  replaceVariables
    #    変数名を保存する
    def replaceVariables(self, colNames, variables, variablesBoundary):
        global dataDir
        i = 0
        for field in colNames:
            fileName = dataDir + "/" + field
            #ファイルの読み込み
            [cont, data] = getFoamContents.readFileSeparate(fileName)
            #変数の置き換え
            ascii = replaceOtherNames(cont, variables[i])
            #boundaryFields変数の置き換え
            ascii = replaceOtherNamesBoundary(ascii, variablesBoundary[i])
            #余分な行を削除して整形
            ascii = deleteOver2NullLines(ascii)
            #データを保存
            getFoamContents.writeFileSeparate(fileName, [ascii, data])
            i += 1

    # saveCSV
    #  CSV形式で保存する
    def saveCSV(self):
        global dataDir
        print _("csv形式で保存します。")

        inputTextDDialog.title = _(u"csv形式で保存")
        inputTextDDialog.message = _(u"gridEditorのイメージのままをcsv形式で保存します。\n保存場所は、caseDirです。")
        inputTextDDialog.inputText = u"boundaryField.csv"
        dialog = inputTextDDialog.MyDialog(None)
        result = dialog.ShowModal()
        if inputTextDDialog.status == "OK":
            text = inputTextDDialog.inputText
        else:
            return

        csvName = text
        if len(csvName) > 0:
            if not (csvName[-4:] == ".csv" or csvName[-4:] == ".CSV"):
                csvName += ".csv"
            maxRow = self.grid_1.GetNumberRows()
            maxCol = self.grid_1.GetNumberCols()
            #cellデータ取得
            data = []
            row = 0
            while row < maxRow:
                col = 0
                line = []
                while col < maxCol:
                    line.append(self.grid_1.GetCellValue(row, col))
                    col += 1
                data.append(line)
                row += 1
            #rowName取得
            row = 0
            rowName = []
            while row < maxRow:
                rowName.append(self.grid_1.GetRowLabelValue(row))
                row += 1
            #colName取得
            col = 0
            colName = []
            while col < maxCol:
                colName.append(self.grid_1.GetColLabelValue(col))
                col += 1
            #csvデータ作成
            csvData = []
            #1行目（field名）作成
            line = u'""'
            col = 0
            while col < maxCol:
                line += ',"' + colName[col] + '"'
                col += 1
            line += '\n'
            csvData.append(line)
            #内部データ作成（patch名含む）
            row = 0
            while row < maxRow:
                line = '"' + rowName[row] + '"'
                col = 0
                while col < maxCol:
                    line += ',"' + data[row][col] + '"'
                    col += 1
                line += '\n'
                csvData.append(line)
                row += 1
            #保存
            res = "OK"
            if len(glob.glob(csvName)) != 0:
                title = _(u"csv保存")
                message = _(u"「") + csvName + _(u"」は、既に存在しています。\n　書き換えますか？")
                res = self.okCancelDialog(title, message)
            if res == "OK":
                f=open(csvName, "w")
                for line in csvData:
                    f.write(line)
                f.close()
                title = _(u"csv保存")
                message = _(u"boundaryFieldをcsv形式で保存しました。")
                self.okDialog(title, message)
        #エラー
        else:
            if len(csvName) == 0:
                title = _(u"エラー")
                message = _(u"ファイル名が入力されていません。")
                self.errDialog(title, message)
            

    #  getCopyValue
    #    コピーするデータをcopyValuesに入れる
    def getCopyValues(self):
        global copyValues, copyRow, copyCol
        #選択範囲の先頭を取得
        [copyRow, copyCol] = self.getFirstSelectCell()
        if copyRow < 0:
            #選択範囲が設定されていない場合は、currentCellをコピー
            value = self.grid_1.GetCellValue(curRow, curCol)
            copyValues = [[value]]
        else:
            #選択範囲の値を取得
            maxRow = self.grid_1.GetNumberRows()
            maxCol = self.grid_1.GetNumberCols()
            copyValues=[]
            row = copyRow
            while row<maxRow:
                rowVal = []
                col = copyCol
                flag = 0
                while col<maxCol:
                    if self.grid_1.IsInSelection(row, col) == True:
                        value = self.grid_1.GetCellValue(row, col)
                        rowVal.append(value)
                        flag = 1
                    col+=1
                #行内に選択範囲があればその行を保存、無ければ終了
                if flag == 1:
                    copyValues.append(rowVal)
                else:
                    row = maxRow        #終了
                row+=1
        #TreeFoamのclipBoardに保存
        print "copy--> clipBoard"
        f=open(clipBoard, "w")
        for rowVal in copyValues:
            for val in rowVal:
                f.write(val + "\b")
            f.write("\a")
        f.close()

        #systemのclipBoardに保存
        lines = ""
        for rowVal in copyValues:
            i = 0
            while i<len(rowVal):
                rowVal[i] = '"' + rowVal[i] + '"'
                i += 1
            lines += "\t".join(rowVal) + "\r\n"
        lines = lines[:-1]
        #  clipBoardにコピー
        #wx.TheClipboard.Close()
        data = wx.TextDataObject()
        success = False
        data.SetText(lines)
        if wx.TheClipboard.Open():
            wx.TheClipboard.SetData(data)
            wx.TheClipboard.Close()
            success = True
        return success


    #  pasteCopyValues
    #    コピーで取得したデータを貼り付ける
    def pasteCopyValues(self):
        global copyValues, curRow, curCol

        #clipBoardから読み込み
        pasteVals = ""
        #data = wx.URLDataObject()
        data = wx.TextDataObject()
        wx.TheClipboard.Open()
        success = wx.TheClipboard.GetData(data)
        if success:
            #self.t2.SetValue(data.GetText())
            #self.t2.SetValue(data.GetURL())
            pasteVals = data.GetText()
        wx.TheClipboard.Close()

        #pasteデータをlist形式に変換
        copyVals = []
        lines = getMultiLines(pasteVals)
        for line in lines:
            rowVal = line.split("\t")
            rowVals = []
            for val in rowVal:
                if len(val) == 0:
                    b = ""
                elif len(val) == 1:
                    b = val
                elif val[0] == '"':
                    b = val[1:-1]
                else:
                    b = val
                rowVals.append(b)
            copyVals.append(rowVals)

        print "clipBoard--> paste"
        copyValues = copyVals

        #コピー先の選択範囲をチェック
        maxRow = self.grid_1.GetNumberRows()
        maxCol = self.grid_1.GetNumberCols()
        [row, col] = self.getFirstSelectCell()
        if row>=0:
            #選択範囲の先頭をコピー先に指定
            [lastRow, lastCol] = self.getLastSelectCell(row, col)
            copRow = row
            copCol = col
            #コピー開始
            row = copRow
            i=0; j=0
            while row <= lastRow:
                col = copCol
                while col <= lastCol:
                    [copVal, copyValues, i, j] = self.getCopyValueForCell(copyValues, i, j)
                    #cell内容が「...」の場合、pasteしない
                    if len(copVal) > 3:
                        if copVal[-3:] != "...":
                            self.grid_1.SetCellValue(row, col, copVal)
                    col += 1
                row += 1
        else:
            #current位置をコピー先に指定
            copRow = curRow
            copCol = curCol
            #コピー開始
            row = copRow
            for rowVal in copyValues:
                col = copCol
                for value in rowVal:
                    if row<maxRow and col<maxCol:
                        #cell内容が「...」の場合、pasteしない
                        if len(value) > 3:
                            if value[-3:] != "...":
                                self.grid_1.SetCellValue(row, col, value)
                    col+=1
                row+=1
            self.grid_1.SelectBlock(curRow, curCol, row-1, col-1)
        #保存フラグをセット
        self.alarmSaveFlagSet()


    def getCopyValueForCell(self, copyValues, i, j):
        value = copyValues[i][j]
        j+=1
        if j >= len(copyValues[i]):
            j=0
            i+=1
            if i>= len(copyValues):
                i=0
        return [value, copyValues, i, j]

    #  getFirstSelectCell
    #    選択範囲の先頭cell位置を返す
    #    選択されていない場合は、-1が返る
    def getFirstSelectCell(self):
        #選択範囲の先頭を取得
        maxRow = self.grid_1.GetNumberRows()
        maxCol = self.grid_1.GetNumberCols()
        selRow = 0
        selCol = 0
        flag = 0
        row = 0
        while row<maxRow:
            col = 0
            while col<maxCol:
                if self.grid_1.IsInSelection(row, col) == True:
                    selRow = row; selCol = col
                    row = maxRow; col = maxCol
                    flag = 1
                col+=1
            row+=1
        if flag == 0:
            #選択されていない場合
            selRow = -1; selCol = -1
        return [selRow, selCol]

    #  getLastSelectCell
    #    選択範囲の最終cell位置を返す
    #　　選択されていない場合は、-1が返る
    def getLastSelectCell(self, iniRow, iniCol):
        maxRow = self.grid_1.GetNumberRows()
        maxCol = self.grid_1.GetNumberCols()
        row = iniRow
        while row<maxRow and self.grid_1.IsInSelection(row, iniCol)==True:
            row += 1
        lastRow = row -1
        col = iniCol
        while col<maxCol and self.grid_1.IsInSelection(iniRow, col)==True:
            col += 1
        lastCol = col -1
        return [lastRow, lastCol]

    #  setGlobalValue
    #    global変数（dir, colNames, rowNames）をセット
    #    multiTaskの場合、global変数が信用できなくなる為、処理の直前で設定できる様にする為
    #    表から変数を読み取る。
    #    上記以外のglobal変数は、基本的に読み込むので不要
    def setGlobalValue(self):
        global boundaryDir, dataDir, colNames, rowNames
        #dirの取得
        [boundaryDir, dataDir] = self.getDirectoryFromGrid()
        #colNmes（fields）の取得
        maxCol = self.grid_1.GetNumberCols()
        fields = []
        col=1
        row=0
        while col<maxCol:
            fields.append(self.grid_1.GetColLabelValue(col))
            col+=1
        colNames = fields
        #rowNames（patches）の取得
        maxRow = self.grid_1.GetNumberRows()
        patches = []
        row = self.getStRowFromGrid()
        while row<maxRow:
            patch = self.grid_1.GetRowLabelValue(row)
            patch = string.join(patch.split("\n"), "")
            patches.append(patch)
            row += 1
        rowNames = patches

    #
    #  getStRowFromGrid
    #    表中からpatchNameの初期位置（row）を取得
    def getStRowFromGrid(self):
        stRow = 2
        maxRow = self.grid_1.GetNumberRows()
        row = stRow
        while row < maxRow:
            patch = self.grid_1.GetRowLabelValue(row)
            if (patch != "otherNames" and patch != "internal\nField"
                and patch != "otherNames\n(boundary)" ):
                stRow = row
                break
            row += 1
        return stRow

    #
    #  getInternalFieldRowFromGrid
    #    表中からinternalFieldの行を取得
    def getInternalFieldRowFromGrid(self):
        intRow = 1
        maxRow = self.grid_1.GetNumberRows()
        row = intRow
        while row < maxRow:
            rowName = self.grid_1.GetRowLabelValue(row)
            rowName = "".join(rowName.split())
            if rowName[:len("internalField")] == "internalField":
                intRow = row
                break
            row += 1
        return intRow

    #
    #  getDirectoryFromGrid
    #    gridからDirectoryを取得
    #    戻り値:[bondaryDir, dataDir]
    def getDirectoryFromGrid(self):
        gridNo = (((self.GetTitle()).split("("))[1].split(")")[0])
        #gridList = treefoam.gridNo
        gridList = getGridList()
        bondDir = ""
        dataDir = ""
        for cont in gridList:
            if gridNo == cont[0]:
                bondDir = cont[1]
                dataDir = cont[2]
                break
        if bondDir=="" or dataDir=="":
            title = _(u"エラー")
            mess = _(u"gridに対応するdirが取得できません。")
            print mess
            self.errDialog(title, mess)
        return [bondDir, dataDir]

    #
    #  initializeGridSize
    #    gridの初期化（1x1）のgridに設定
    def initializeGridSize(self):
        #既にある表を（1x1）の表に設定すると、見かけ上（1x1）になるだけで
        #「self.grid_1.GetNumberRows()」で取得した行数は変わらないので注意。
        nRows = self.grid_1.GetNumberRows()
        nCols = self.grid_1.GetNumberCols()
        self.grid_1.DeleteRows(nRows-1, nRows-1)
        self.grid_1.DeleteCols(nCols-1, nCols-1)
        """
        self.grid_1.DeleteRows(pos, delRows-1)
        self.grid_1.DeleteCols(pos, delCols)
        """
        #self.grid_1.CreateGrid(1, 1)
        self.grid_1.SetCellValue(0, 0, "")      #cellを空白に設定

    #  createMatrix
    #    matrixデータからGridを作成する
    def createMatrix(self):
        global otherData, isVariable, isVariableBoundary
        #その他data（変数名など）読み込み
        otherData = getDimensionInternalFieldData(dataDir, colNames)
        variables = otherData[2]
        variablesBoundary = otherData[3]
        #row,colの幅、高さを設定
        rowLabelSize = 100.0        #rowLabelの幅
        colLabelSize = 60.0         #colLabelの高さ
        self.grid_1.SetRowLabelSize(rowLabelSize)
        self.grid_1.SetColLabelSize(colLabelSize)
        #表の大きさを設定
        if self.variableListSize(variables) > 0:
            isVariable = True
        if self.variableListSize(variablesBoundary) > 0:
            isVariableBoundary = True
        rowSize = len(rowNames) + 2
        colSize = len(colNames) + 1
        if isVariable == True:
            rowSize += 1
        if isVariableBoundary == True:
            rowSize += 1
        #表の大きさを合わせる
        if self.grid_1.GetNumberRows() < rowSize:
            self.grid_1.AppendRows(rowSize - (self.grid_1.GetNumberRows()))
        elif self.grid_1.GetNumberRows() > rowSize:
            self.grid_1.DeleteRows(0, self.grid_1.GetNumberRows() - rowSize)
        if self.grid_1.GetNumberCols() < colSize:
            self.grid_1.AppendCols(colSize - (self.grid_1.GetNumberCols()))
        elif self.grid_1.GetNumberCols() > colSize:
            self.grid_1.DeleteCols(0, self.grid_1.GetNumberCols() - colSize)
        #editorをセット（全てmultiLineEditorにセット）
        #  versionによってeditorをセットしない
        ver = wx.version().split()[0]
        if ver < "3.0":
            self.editor = wx.grid.GridCellAutoWrapStringEditor()
            self.grid_1.SetDefaultEditor(self.editor)
        self.editor = wx.grid.GridCellAutoWrapStringEditor()
        self.grid_1.SetDefaultEditor(self.editor)
        #self.renderer = wx.grid.GridCellAutoWrapStringRenderer()
        #self.grid_1.SetDefaultRenderer(self.renderer)
        """
        row=0
        while row < rowSize:
            col=0
            while col < colSize:
                self.grid_1.SetCellEditor(
                    row, col, wx.grid.GridCellAutoWrapStringEditor())
                col += 1
            row += 1
        """
        #全行背景色を無くす
        maxCol = self.grid_1.GetNumberCols()
        maxRow = self.grid_1.GetNumberRows()
        row = 0
        while row < maxRow:
            col = 0
            while col < maxCol:
                self.grid_1.SetCellBackgroundColour(row, col, "white")
                #self.grid_1.SetCellFont(row, col, wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "VL ゴシック"))
                col += 1
            row += 1
        #0列（boundary）をyellowに設定
        row = 0
        while row < maxRow:
            self.grid_1.SetCellBackgroundColour(row, 0, "yellow")
            row += 1
        #0行（dimension）をpinkに設定
        maxCol = self.grid_1.GetNumberCols()
        col = 0
        while col < maxCol:
            self.grid_1.SetCellBackgroundColour(0, col, "pink")
            col+=1
        #variables、internalFieldの色を設定
        if isVariable == False:
            col = 0
            while col < maxCol:
                self.grid_1.SetCellBackgroundColour(1, col, "yellow")
                col += 1
        else:
            col = 0
            while col < maxCol:
                #self.grid_1.SetCellBackgroundColour(1, col, "lightGreen")
                self.grid_1.SetCellBackgroundColour(1, col, veryLightGreen)
                self.grid_1.SetCellBackgroundColour(2, col, "yellow")
                col += 1
        #variablesBoundaryの色を設定
        if isVariableBoundary == True:
            if isVariable == True:
                row = 3
            else:
                row = 2
            col = 0
            while col < maxCol:
                #self.grid_1.SetCellBackgroundColour(row, col, "lightGreen")
                self.grid_1.SetCellBackgroundColour(row, col, veryLightGreen)
                col += 1
        #項目をセット（行名)
        self.grid_1.SetRowLabelValue(0, "field type\ndimensions")
        #  variablesを確認
        row = 1
        if isVariable == True:
            self.grid_1.SetRowLabelValue(row, "otherNames")
            row += 1
        if sortPatchName == "yes":
            self.grid_1.SetRowLabelValue(row, "internal\nField\n<sort patch>")
        else:
            self.grid_1.SetRowLabelValue(row, "internal\nField")
        row += 1 
        #  variablesBoundaryを確認
        if isVariableBoundary == True:
            self.grid_1.SetRowLabelValue(row, "otherNames\n(boundary)")
            row += 1
        rowLabels = line2lines(rowNames, 10)
        rowBoundary = row
        for rowLabel in rowLabels:
            self.grid_1.SetRowLabelValue(row, rowLabel)
            row += 1
        #項目をセット（列名）
        place = self.getPlacePolyMesh(boundaryDir)
        self.grid_1.SetColLabelValue(0, "define patch\nat " + place + "\n(boundary)")
        col = 1
        for item in colNames:
            self.grid_1.SetColLabelValue(col, item)
            col += 1
        #表中のcell(0,0)、(1,0)をクリア
        row = 0
        self.grid_1.SetCellValue(row, 0, "")
        row += 1
        if isVariable == True:
            self.grid_1.SetCellValue(row, 0, "")
            row += 1
        self.grid_1.SetCellValue(row, 0, "")
        row += 1
        if isVariableBoundary == True:
            self.grid_1.SetCellValue(row, 0, "")



    #  getPlacePolyMesh
    #    boundaryDirからpolyMeshの場所を返す
    def getPlacePolyMesh(self, boundaryDir):
        dirList = boundaryDir.split("/")
        if dirList[-2] == "constant":
            place = "constant"
        elif dirList[-3] == "constant":
            place = "constant/" + dirList[-2]
        else:
            flag = 0
            try:
                a=float(dirList[-2])
                place = dirList[-2]
                flag = 1
            except:
                flag = 0
            if flag == 0:
                try:
                    a=float(dirList[-3])
                    place = dirList[-3] + "/" + dirList[-2]
                except:
                    place = "****"
        return place

    #  setMatrixData
    #    gridにデータセット
    def setMatrixData(self):
        global boundaryDir, dataDir, rowNames, colNames, data
        global isVariable, isVariableBounary
        #  0列にpatch定義データのセット
        defineDataSub = getDefinePatchData(boundaryDir, rowNames)
        #nonuniform list形式のデータは読み込まないので、削除する
        defineData = self.deleteNonuniformListData(defineDataSub)

        col=0
        i=0
        addRow = 2
        if isVariable == True:
            addRow += 1
        if isVariableBoundary == True:
            addRow += 1
        while i<len(defineData):
            row = i + addRow
            lines = defineData[i].split("\n")
            subData = []
            flag = 0
            for line in lines:
                lineData = line.split(";")
                words = lineData[0].split()
                if len(words) > 1:
                    if words[0] != "nFaces" and words[0] != "startFace":
                        subData.append(line)
                    if words[0] == "nFaces" and words[1] == "0":
                        flag = 1
                else:
                    #「;」のみの行の場合、前行に「;」を追加する
                    if len(line) > 0:
                        if line[0] == ";":
                            subData[-1] += ";"
                if len(words) == 1:
                    subData.append(line)
            if len(lines) > 0:
                lines = string.join(subData, "\n")
            self.grid_1.SetCellValue(row, col, lines)
            if flag == 1:
                #self.grid_1.SetCellFont(row, col,  wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, "VL ゴシック"))
                maxCol = self.grid_1.GetNumberCols()
                coll = 0
                while coll < maxCol:
                    self.grid_1.SetCellBackgroundColour(row, coll, "yellow")
                    coll+=1
            i+=1
        #  1列以降にデータをセット
        col=1
        for labels in data:
            i = 0
            while i<len(labels):
                row = i + addRow
                #データセット
                self.grid_1.SetCellValue(row, col, labels[i])
                i+=1
            col+=1
        #  0行にデータ（dimensions）をセット
        [dimData, intData, variables, variablesBoundary] = otherData
        row = 0
        col = 1
        for value in dimData:
            if len(value) != 0:
                self.grid_1.SetCellValue(row, col, value)
            col += 1
        #  1行にデータ（internalField）をセット
        row = 1
        if isVariable == True:
            #variablesをセット
            col = 1
            for value in variables:
                #if value != "":
                self.grid_1.SetCellValue(row, col, value)
                col += 1
            row += 1
        col = 1
        for value in intData:
            self.grid_1.SetCellValue(row, col, value)
            col+=1
        row += 1
        if isVariableBoundary == True:
            #variablesBoundaryをセット
            col = 1
            for value in variablesBoundary:
                self.grid_1.SetCellValue(row, col, value)
                col += 1
        self.setLabelColour(dataDir)
        self.setCellFontColour()

    #  deleteNonuniformListData
    #    patch定義データからnonuniform形式のデータを削除する
    def deleteNonuniformListData(self, defineDataSub):
        defines = []
        for definePatch in defineDataSub:
            define = ""
            lines = definePatch.split(";")
            for line in lines:
                words = line.split()
                if len(words)>=3:
                    if not (words[1] == "nonuniform" and words[2][:len("List")] == "List"):
                        define += line + ";\n"
                elif len(line) != 0:
                    define += line + ";\n"
            defines.append(define)
        return defines


    def setLabelColour(self, dataDir):
        #field非表示設定ファイルの有無チェック
        fileName = getSaveDisplayFieldsFileName(dataDir)
        if len(glob.glob(fileName)) != 0:
            #ラベル色をdarkblueにセット
            self.grid_1.SetLabelTextColour("darkblue")
        else:
            #ラベル色をblackにセット
            #self.grid_1.SetLabelTextColour("black")
            self.grid_1.SetLabelTextColour(sysFontColour)


    def setCellFontColour(self):
        global boundaryDir, dataDir, rowNames, colNames, data
        maxRow = self.grid_1.GetNumberRows()
        col = 0
        while col < len(colNames) + 1:
            row = 0
            stRow = self.getStRowFromGrid()
            while row < maxRow:
                #fontの色をセット
                self.setFontColour(row, col, stRow)
                row += 1
            col += 1

    def editorShown(self, event):
        global noEditCell, noEditCellCont
        row = event.GetRow()
        col = event.GetCol()
        #self.grid_1.SetCellTextColour(row, col, "black")
        self.grid_1.SetCellTextColour(row, col, sysFontColour)
        cellCont = self.grid_1.GetCellValue(row, col)
        if len(cellCont)>3:
            if cellCont[-3:] == "...":
                noEditCell = [row, col]
                noEditCellCont = cellCont
                title = _(u"cellの編集")
                mess = _(u"このcellは、文字数または行数が多すぎるため、エディタで編集します。")
                self.okDialog(title, mess)
                error = self.runCellEditor(row, col)
                if error != "OK":
                    title = _(u"エラー")
                    mess = _(u"cell内容編集時にエラーが発生しました。\n編集できていません。")
                    self.errDialog(title, mess)
            else:
                noEditCell = [-1, -1]

    def editorHidden(self, event):
        row = event.GetRow()
        col = event.GetCol()
        stRow = self.getStRowFromGrid()
        self.setFontColour(row, col, stRow)

    #
    #  runCellEditor
    #    cell内容の編集用
    def runCellEditor(self, row, col):
        error = "OK"
        if col < 1:
            return "NG"
            
        field = colNames[col-1]                 #field名取得
        rowInt = self.getPosInternalRow()       #internalField行No取得
        rowName = self.getPosRowName()          #boundaryField行No取得
        if row == rowInt:
            #internalFieldの処理
            n = getEditCellInternalFieldData(field)
            if self.checkEditLines(n) == "OK":
                editCellEditor(field, "")
                newCont = setEditCellInternalFieldData(field)
                cellData = reformInternalFieldCellDataCheck(newCont)
                self.grid_1.SetCellValue(row, col, cellData)
        elif row >= rowName:
            #boundaruFieldの処理
            patchName = rowNames[row-rowName]
            n = getEditCellBoundaryFieldData(field, patchName)
            if self.checkEditLines(n) == "OK":
                editCellEditor(field, patchName)
                newCont = setEditCellBoundaryFieldData(field, patchName)
                cellData = reformBoundaryFieldCellData(newCont)
                self.grid_1.SetCellValue(row, col, cellData)
        else:
            error = "NG"
        return error

    #  checkEditLines
    def checkEditLines(self, n):
        ans = "OK"
        if n>500:
            title = _(u"cellの編集")
            mess = _(u"編集する行数が、500行を越えています。\n\n本当に編集しますか？")
            ans = self.okCancelDialog(title, mess)
        return ans

    #  font色をセット
    def setFontColour(self, row, col, stRow):
        if col <= 0 or row < stRow:
            #0列、stRow以前は、systemFont色
            self.grid_1.SetCellTextColour(row, col, sysFontColour)
        else:
            #1列以降は内容に応じた色
            cellCont = self.grid_1.GetCellValue(row, col).split("\n")[0]
            if cellCont == "type zeroGradient;":
                self.grid_1.SetCellTextColour(row, col, "blue")
            elif cellCont == "type fixedValue;":
                self.grid_1.SetCellTextColour(row, col, "brown")
            elif cellCont == "type empty;":
                self.grid_1.SetCellTextColour(row, col, "dark green")
            else:
                self.grid_1.SetCellTextColour(row, col, sysFontColour)


    #
    #  getAllFieldCellsData
    #    全cell内のデータを取得
    def getAllFieldCellsData(self):
        fpatches = []
        col = 1
        while col<len(colNames)+1:
            #row = 2
            stRow = self.getStRowFromGrid()
            maxRow = self.grid_1.GetNumberRows()
            row = stRow
            fpatch = []
            while row<maxRow:
                patch = rowNames[row-stRow]
                value = self.grid_1.GetCellValue(row, col)
                if value != "":
                    value = self.reformPatchContents(value)
                fpatch.append(value)
                row+=1
            fpatches.append(fpatch)
            col+=1
        return fpatches

    #
    #  getDefineCellData
    #    patchの定義データ(boundary)をcellから取得
    def getDefineCellData(self):
        defineData = []
        col = 0
        #row = 2
        stRow = self.getStRowFromGrid()
        maxRow = self.grid_1.GetNumberRows()
        row = stRow
        while row<maxRow:
            value = self.grid_1.GetCellValue(row, col)
            if value != "":
                value = self.reformPatchContents(value)
            defineData.append(value)
            row+=1
        return defineData

    #
    #  getInternalFieldCellData
    #    internalFieldデータをcellから取得
    def getInternalFieldCellData(self):
        intData = []
        #row = 1
        row = self.getInternalFieldRowFromGrid()
        i=0
        while i<len(colNames):
            col = i + 1
            value = self.grid_1.GetCellValue(row, col)
            if value != "":
                value = self.reformInternalData(value)
            intData.append(value)
            i+=1
        return intData

    #
    #  reformInternalData
    #    internalFieldデータを整形
    #    uniform以外は""に設定
    def reformInternalData(self, value):
        tab2 = 19
        words = value.split()
        line = ""
        if len(words)>1:
            if words[0] == "uniform":
                line += "internalField"
                if len(line) < tab2:
                    line += (tab2-len(line))*" "
                else:
                    line += " "
                line += string.join(words[0:], " ") + "\n"
            else:
                line = ""
        else:
            line = ""
        return line

    #
    #  reformPatchContents
    #    patch内容を整形
    def reformPatchContents(self, value):
        #行頭に空白追加
        words = value.split("\n")
        i=0
        while i<len(words):
            wds = words[i].split()
            if len(wds)>0:
                if not (wds[0] == "(" or
                        wds[0] == ")" or
                        (wds[0]<="0" and wds[0]>="9")):
                    words[i] = "        " + words[i]
                    if len(wds) > 1:
                        #spをskip
                        p=0
                        while p<len(words[i]):
                            if words[i][p] == " ":
                                p += 1
                            else:
                                ep = p + 16
                                break
                        #文字をskip
                        while p<len(words[i]):
                            if words[i][p] != " ":
                                p += 1
                            else:
                                break
                        #sp追加
                        if p < ep:
                            sp = " " * (ep-p)
                            words[i] = words[i][:p] + sp + words[i][p+1:]

            i+=1
        value = "\n".join(words) + "\n"
        return value

    #
    #  replaceBoundaryData
    #
    def replaceBoundaryData(self, fields, cellData, intData):
        global rowNames, dataDir
        patches = []
        for patch in rowNames:
            patches.append("    " + patch)
        #print patches
        error = pyTreeFoam.setFieldsPatchesName(
                    dataDir, fields, patches, cellData, intData)
        return error

    #
    #  replaceDefineData
    #
    def replaceDefineData(self, cellData, boundRow):
        global rowNames, boundaryDir
        patches = []
        #for patch in rowNames:
        for patch in boundRow:
            patches.append("    " + patch)
        error = pyTreeFoam.setBoundaryData(boundaryDir, patches, cellData)
        return error


    #  checkBadField
    #    patchDataのチェック、エラー表示
    def checkBadField(self, fields, patchData):
        i=0; badFields=[]
        while i<len(fields):
            flag = 0
            for bpData in patchData[i]:
                if bpData == "":
                    flag = 1
                    badFields.append(fields[i])
                    break
            i+=1
        if len(badFields) > 0:
            title = _(u"警告")
            mess = _(u"「") + string.join(badFields, ",") + _(u"」のfieldが正しく読み込めていません。")
            #self.errDialog(title, mess)
            self.warningDialog(title, mess)

    def clearStatus(self):
        self.frame_1_statusbar.SetStatusText("")

    def checkSaveFlag(self):
        if self.checkEditedFlag() == 0:
            return "EXIT"
        else:
            saveAndNextJobDDialog.title     = _(u"gridEditorの終了確認")
            saveAndNextJobDDialog.message   = _(u"cell内容が変更されています。\n  このまま終了しますか？")
            saveAndNextJobDDialog.cancelMsg = _(u"キャンセル")
            saveAndNextJobDDialog.goMsg     = _(u"このまま終了")
            saveAndNextJobDDialog.saveGoMsg = _(u"保存して終了")
            dialog = saveAndNextJobDDialog.MyDialog(None)
            result = dialog.ShowModal()
            ans = saveAndNextJobDDialog.status
            return ans

    def checkSaveReload(self):
        if self.checkEditedFlag() == 0:
            return "EXIT"
        else:
            saveAndNextJobDDialog.title     = _(u"reload時の保存確認")
            saveAndNextJobDDialog.message   = _(u"cell内容が変更されています。\n  このまま処理を継続すると、変更内容が失われます。")
            saveAndNextJobDDialog.cancelMsg = _(u"キャンセル")
            saveAndNextJobDDialog.goMsg     = _(u"このまま続行")
            saveAndNextJobDDialog.saveGoMsg = _(u"保存して続行")
            dialog = saveAndNextJobDDialog.MyDialog(None)
            result = dialog.ShowModal()
            ans = saveAndNextJobDDialog.status
            return ans

    #
    #  showSelectCell
    #    currentCellをスクロールして表示させる
    def showSelectCell(self):
        global curRow, curCol
        row = curRow; col = curCol
        if row < 0:
            row = 0
        if col < 0:
            col = 0
        self.grid_1.MakeCellVisible(row, col)

    #
    #  editFlagSetClear
    #    editFlagをチェック、clear、setする。
    def checkEditedFlag(self):
        alarmSaveFlag = self.GetTitle().split(":")[1][0]
        if alarmSaveFlag == " ":
            return 0            #修正無し
        else:
            return 1            #修正あり

    def alarmSaveFlagClear(self):
        title = self.GetTitle()
        currFlag = title.split(":")[1][0]
        if currFlag == " ":
            return
        else:
            newTitle = title.split(":")
            newTitle[1] = " " + newTitle[1][1:]
            self.SetTitle(":".join(newTitle))

    def alarmSaveFlagSet(self):
        #gridのtitleに「*」マーク追加
        self.setCellFontColour()
        title = self.GetTitle()
        currFlag = title.split(":")[1][0]
        if currFlag != "*":
            newTitle = title.split(":")
            newTitle[1] = "*" + newTitle[1][1:]
            self.SetTitle(":".join(newTitle))
        #edit禁止cellのチェック
        if noEditCell == [-1, -1]:
            return
        else:
            row = noEditCell[0]
            col = noEditCell[1]
            cellCont = noEditCellCont
            self.grid_1.SetCellValue(row, col, cellCont)
            title = _(u"編集禁止")
            mess = _(u"このcellは、編集禁止cellです。\n変更内容は反映されません。")
            self.warningDialog(title, mess)

    #  runEditorAsciiBinaryFile
    #    ascii binaryFileをeditorで編集
    def runEditorAsciiBinaryFile(self, openFile):
        global nMaxLinesBinToAscii
        if nMaxLinesBinToAscii > 0:
            title = _(u"fileの編集")
            mess = _(u"nonuniform List の行は、「") + str(nMaxLinesBinToAscii) + _(u"」ヶのデータのみ表示します。\n")
            mess += u"    xxxx nonuniform List<xxx>\n"
            mess += u"    xx(xxx xxx xxx...);\n"
            if checkBinary(openFile) == True:
                mess += _(u"binaryの場合は、nonuniform Listを含む行は、編集できません。")
            else:
                mess += _(u"nonuniform Listのデータ数が「") + str(nMaxLinesBinToAscii) + _(u"」以下の場合、編集できます。\n")
                mess += _(u"データ数が「") + str(nMaxLinesBinToAscii) + _(u"」ヶを越える場合は、nonuniform Listを含む行のみ編集できません。")
            self.okDialog(title, mess)
        #tempFolder = os.environ["TreeFoamPath"] + "/temp"
        tempFolder = os.environ["TreeFoamUserPath"] + "/temp"
        comm = "editFoamFile.py -t " + tempFolder + " " + openFile + " &"
        os.system(comm)

    #
    #  getDisplayMaxLinesData
    #    表示行数、データ数を取得
    def getDisplayMaxLinesData(self, event):
        global maxRowsInCellInternal, maxRowsInCell, nMaxLinesBinToAscii
        #警告を表示
        flag = self.checkSaveReload()
        if flag == "RETURN":
            return
        elif flag == "SAVE":
            self.onSave(event)

        #行数変更dialogを表示
        getDisplayMaxLinesDataDDialog.maxLinesCellInternal = maxRowsInCellInternal
        getDisplayMaxLinesDataDDialog.maxLinesCellPatch = maxRowsInCell
        getDisplayMaxLinesDataDDialog.nMaxLinesBinToAscii = nMaxLinesBinToAscii
        dialog = getDisplayMaxLinesDataDDialog.MyDialog(None)
        result = dialog.ShowModal()
        stat = getDisplayMaxLinesDataDDialog.status
        if stat == "OK":
            #値を取得
            maxRowsInCellInternal = getDisplayMaxLinesDataDDialog.maxLinesCellInternal
            maxRowsInCell = getDisplayMaxLinesDataDDialog.maxLinesCellPatch
            nMaxLinesBinToAscii = getDisplayMaxLinesDataDDialog.nMaxLinesBinToAscii
            self.onReload(event)
            #値を書込み
            itemsData = [["maxLinesCellInternal", str(maxRowsInCellInternal)],
                         ["maxLinesCellPatch", str(maxRowsInCell)],
                         ["nMaxLinesBinToAscii", str(nMaxLinesBinToAscii)]]
            writeConfigData(itemsData)



    #------------------

    #  variableListSize
    #    変数listのサイズを返す
    def variableListSize(self, varList):
        nVar = 0
        for var in varList:
            if var != "":
                nVar += 1
        return nVar

    #  getPosRowName
    #    rowNamesの先頭位置を返す
    def getPosRowName(self):
        posRowName = 2              #defaultの位置
        if isVariable == True:
            posRowName += 1
        if isVariableBoundary == True:
            posRowName += 1
        return posRowName

    #  getPosInternalRow
    #    internalFieldの先頭行を返す
    def getPosInternalRow(self):
        posRowName = 1              #defaultの位置
        if isVariable == True:
            posRowName += 1
        return posRowName 

    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def warningDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_QUESTION) 
        dlg.ShowModal()
        dlg.Destroy()

    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        res = dlg.ShowModal()
        if res == wx.ID_OK:
            ans = "OK"
        else:
            ans = "CANCEL"
        dlg.Destroy()
        return ans

    def yesNoDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.YES | wx.NO | wx.ICON_INFORMATION) 
        res = dlg.ShowModal()
        if res == wx.ID_YES:
            ans = "YES"
        else:
            ans = "NO"
        dlg.Destroy()
        return ans


    def textDialog(self, title, message, defText):
        dlg = wx.TextEntryDialog(self, message, title, defaultValue=defText)
        ansBtn = dlg.ShowModal()
        ansTxt = dlg.GetValue()
        if ansBtn == wx.ID_OK:
            text = ansTxt
        else:
            text = ""
        return text


# end of class MyFrame

#  getBoundaryContFromPatchType
#    patchTypeからboundary内容を取得（clear時）
def getBoundaryContFromPatchType(pType):
    if (pType == "empty;" or pType == "symmetry;" or pType == "symmetryPlane;" or
        pType == "cyclic;" or pType == "cyclicAMI;" or pType == "cyclicACMI;" or
        pType == "cyclicSlip;" or pType == "wedge;"):
        pCont = "type " + pType
    else:
        pCont = "type zeroGradient;"
    return pCont

#  backSkipUntilCR
#    CRのまで戻る
def backSkipUntilCR(cont, p):
    while cont[p] == " ":
        p -= 1
    p += 1
    return p

#  skipUntilCR
#    spをskip
def skipUntilCR(cont, p):
    while cont[p] == " ":
        p += 1
    if cont[p] == "\n":
        p += 1
    return p

#  replaceOtherNames
#    変数名の置き換え
def replaceOtherNames(ascii, variable):
    pData = getFoamContents.skipFoamFileMem(ascii, 0)

    #変数を削除
    [lineCont, p, kind] = getFoamContents.get1lineMem(ascii, pData)
    valName = lineCont.split()[0]
    while valName == "boundaryField" or lineCont != "":
        if ((kind == "line" or kind == "other" ) and valName != "dimensions"
                and valName != "internalField"):
            ascii = ascii[:p-len(lineCont)-1] + ascii[p:]
            p -= len(lineCont)
        [lineCont, p, kind] = getFoamContents.get1lineMem(ascii, p)
        if lineCont != "":
            valName = lineCont.split()[0]
        else:
            valName = ""
    #変数を挿入
    if variable != "":
        #挿入場所を検索
        pinc = 0
        [lineCont, p, kind] = getFoamContents.get1lineMem(ascii, pData)
        valName = lineCont.split()[0]
        while valName == "boundaryField" or lineCont != "":
            if (kind == "line" and valName == "dimensions"):
                pdim = p
            if (kind == "include" or kind == "includeEtc"):
                pinc = p
            [lineCont, p, kind] = getFoamContents.get1lineMem(ascii, p)
            if lineCont != "":
                valName = lineCont.split()[0]
            else:
                valName = ""
        if pinc != 0:
            ps = pinc
        else:
            ps = pdim
        #変数を挿入
        #ascii = ascii[:ps] + "\n" + variable + "\n" + ascii[ps+1:]
        #ascii = ascii[:ps-1] + "\n" + variable + "\n" + ascii[ps:]
        ascii = ascii[:ps] + "\n" + variable + "\n" + ascii[ps:]
    return ascii

#  deleteOver2NullLines
#    空白行を2行に縮める（3行以上を削除）
def deleteOver2NullLines(cont):
    newCont = ""
    nLines = 0
    lines = cont.split("\n")
    for line in lines:
        if len(line.split()) != 0:
            newCont += line + "\n"
            nLines = 0
        else:
            if nLines == 0:
                newCont += "\n"
                nLines += 1
    return newCont



#  replaceOtherNamesBoundary
#    変数名の置き換え
def replaceOtherNamesBoundary(ascii, variableBoundary):
    pData = getFoamContents.skipFoamFileMem(ascii, 0)

    #変数boundaryを削除
    [boundaryCont, p] = getFoamContents.getKeywordContentsMem("boundaryField",
            ascii, pData)
    #  header、footerを取得（"{"、"}"の1文字戻す
    header = ascii[:p-len(boundaryCont)-1]
    footer = ascii[p-1:]
    [lineCont, p, kind] = getFoamContents.get1lineMem(boundaryCont, 0)
    while lineCont != "":
        if kind == "line" or kind == "other":
            ps = backSkipUntilCR(boundaryCont, p-len(lineCont)-1)
            pe = skipUntilCR(boundaryCont, p)
            #boundaryCont = boundaryCont[:p-len(lineCont)-1] + boundaryCont[p:]
            #p -= len(lineCont)
            boundaryCont = boundaryCont[:ps] + boundaryCont[pe:]
            p = ps
        [lineCont, p, kind] = getFoamContents.get1lineMem(boundaryCont, p)
    #変数boundaryを挿入
    if variableBoundary != "":
        #  variableBoundaryにspを追加
        varis = variableBoundary.split("\n")
        i = 0
        while i<len(varis):
            varis[i] = "    " + varis[i]
            i += 1
        variableBoundary = "\n".join(varis)
        #  変数boundaryを挿入
        ps = 0
        [lineCont, p, kind] = getFoamContents.get1lineMem(boundaryCont, 0)
        flag = 0
        i = 0
        while lineCont != "":
            if kind == "keyword":
                boundaryCont = boundaryCont[:ps] + variableBoundary + "\n" + boundaryCont[ps:]
                flag = 1
                break
            i += 1
            ps = p
            [lineCont, p, kind] = getFoamContents.get1lineMem(boundaryCont, p)
        if flag == 0:
            boundaryCont += "\n" + variableBoundary
    ascii = header + boundaryCont + footer
    return ascii


#  getMultiLines
#    csvデータの1行を取得
def getMultiLines(cont):
    ans = []
    p = 0
    line = ""
    ps = 0
    while p<len(cont):
        chara = cont[p]
        if chara == '"':
            p += 1
            while p<len(cont) and cont[p] != '"':
                p += 1
            p += 1
        elif (chara == "\n" or chara == "\r"):
            ans.append(cont[ps:p])
            while p<len(cont) and (cont[p] == "\n" or cont[p] == "\r"):
                p += 1
            ps = p
        else:
            p += 1
    if ps < len(cont):
        ans.append(cont[ps:p])
    return ans


#  checkBinary
#    binaryFileのチェック
def checkBinary(fileName):
    cont100 = getFoamContents.readFile2000Bytes(fileName)
    fileFormat = getFoamContents.checkBinary(cont100)
    if fileFormat == "binary":
        ans = True
    else:
        ans = False
    return ans

#
#  getEditCellInternalFieldData
#    internalFieldDataを取得し、tempCellData.txtを作成する
def getEditCellInternalFieldData(field):
    global dataDir, nMaxLinesBinToAscii
    fileName = dataDir + "/" + field
    wFileName = getCellEditTempFileName(field, "")
    cont = getFoamContents.readField(fileName, nMaxLinesBinToAscii)
    p = getFoamContents.skipFoamFileMem(cont, 0)
    p = getFoamContents.getKeywordPointerMem("internalField", cont, p)
    [keyword, p] = getFoamContents.getKeywordMem(cont, p)
    [chara, p] = getFoamContents.skipNoCharaMem(cont, p)
    ps = p
    n = cont[ps:].find(";")
    p = ps + n
    pe = p + len(";")
    internalCont = cont[ps:pe]
    fw=open(wFileName, "w"); fw.write(internalCont); fw.close()
    nLines = len(internalCont.split("\n"))
    return nLines

#  editCellEditor
#    cellEditorを起動
def editCellEditor(field, patchName):
    #editFileName = os.environ["TreeFoamPath"] + "/temp/tempCellData.txt"
    editFileName = getCellEditTempFileName(field, patchName)
    pyTreeFoam.runEditorWait(editFileName)

#  setEditCellInternalFieldData
#    internalFieldDataを書き換える
def setEditCellInternalFieldData(field):
    global dataDir, nMaxLinesBinToAscii
    fieldName = dataDir + "/" + field
    tempFileName = getCellEditTempFileName(field, "")
    cont = getFoamContents.readField(fieldName, nMaxLinesBinToAscii)
    p = getFoamContents.skipFoamFileMem(cont, 0)
    p = getFoamContents.getKeywordPointerMem("internalField", cont, p)
    [keyword, p] = getFoamContents.getKeywordMem(cont, p)
    [chara, p] = getFoamContents.skipNoCharaMem(cont, p)
    ps = p
    n = cont[ps:].find(";")
    p = ps + n
    pe = p + len(";")
    f=open(tempFileName); newCont=f.read(); f.close()
    fieldCont = cont[:ps] + newCont + cont[pe:]
    getFoamContents.writeField(fieldName, fieldCont)
    return newCont

#  reformInternalFieldCellDataCheck
#
def reformInternalFieldCellDataCheck(newCont):
    lines = newCont.split("\n")
    if len(lines) > maxRowsInCellInternal:
        conts = reformInternalFieldCellData(newCont)
    else:
        words = lines[0].split()
        lines[0] = " ".join(words)
        conts = "\n".join(lines)
    return conts

#
#  getEditCellBoundaryFieldData
#    boundaryFieldDataを取得し、tempCellData.txtを作成する
def getEditCellBoundaryFieldData(field, patchName):
    global dataDir, nMaxLinesBinToAscii
    fieldName = dataDir + "/" + field
    tempFileName = getCellEditTempFileName(field, patchName)
    cont = getFoamContents.readField(fieldName, nMaxLinesBinToAscii)
    p = getFoamContents.skipFoamFileMem(cont, 0)
    [boundCont, p] = getFoamContents.getKeywordContentsMem("boundaryField", cont, p)
    lCont = " "
    p = 0
    while lCont != "":
        [lCont, p, lType] = getFoamContents.get1lineMem(boundCont, p)
        if lType == "keyword":
            [keyword, pp] = getFoamContents.getKeywordMem(lCont, 0)
            if pyTreeFoam.isMatchName(patchName, keyword) == True:
                [patchCont, pp] = getFoamContents.getMiddlePairMem(lCont, 0)
                break
    if lCont == "":
        patchCont = ""
    else:
        lines = patchCont.split("\n")
        newLines = []
        for line in lines:
            if len(line.split()) > 0:
                i=0
                while i<8 and line[i]==" ":
                    i += 1
                newLine = line[i:]
                newLines.append(newLine)
        patchCont = "\n".join(newLines)
    f=open(tempFileName, "w"); f.write(patchCont); f.close()
    nLines = len(patchCont.split("\n"))
    return nLines

#  setEditCellBoundaryFieldData
#    boundaryFieldDataを書き換える
def setEditCellBoundaryFieldData(field, patchName):
    global dataDir, nMaxLinesBinToAscii
    returnCont = ""
    fieldName = dataDir + "/" + field
    tempFileName = getCellEditTempFileName(field, patchName)
    f=open(tempFileName); cont=f.read(); f.close()
    returnCont = cont
    conts = cont.split("\n")
    newConts = []
    for line in conts:
        if len(line) != 0:
            #数字、()、;で始まる行は、空白追加しない
            if (("0"<=line[0] and line[0]<="9") or
                 line[0]=="(" or line[0]==")" or line[0]==";"):
                newConts.append(line)
            else:
                newConts.append("        " + line)
    newCont = "\n".join(newConts)
    cont = getFoamContents.readField(fieldName, nMaxLinesBinToAscii)
    p = getFoamContents.skipFoamFileMem(cont, 0)
    [boundCont, p] = getFoamContents.getKeywordContentsMem("boundaryField", cont, p)
    sp = p - (len(boundCont)) - 2
    ep = p - 2
    newBoundConts = []
    lCont = " "
    p = 0
    setFlag = 0
    while lCont != "":
        [lCont, p, lType] = getFoamContents.get1lineMem(boundCont, p)
        if lType == "keyword":
            [keyword, pp] = getFoamContents.getKeywordMem(lCont, 0)
            if keyword == patchName:
                newCont = keyword + "\n    {\n" + newCont + "\n    }"
                lCont = newCont
                setFlag = 1
        if len(lCont.split()) > 0:
            newBoundConts.append("    " + lCont)
    if setFlag == 0:
        lCont = patchName + "\n    {\n" + newCont + "\n    }"
        newBoundConts.append("    " + lCont)
    newBoundCont = "\n" + "\n".join(newBoundConts) + "\n"
    header = cont[:sp]
    footer = cont[ep:]
    contents = header + newBoundCont + footer
    getFoamContents.writeField(fieldName, contents)
    return returnCont

#  reformBoundaryFieldCellData
#    空白を圧縮する
def reformBoundaryFieldCellData(newCont):
    patchCont = newCont.split("\n")
    if len(patchCont) > maxRowsInCell:
        conts = patchCont[:maxRowsInCell]
        conts[-1] += "..."
    else:
        conts = patchCont
    i = 0    
    for cont in conts:
        words = cont.split()
        [keyword, p] = getFoamContents.getKeywordMem(cont, 0)
        conts[i] = conts[i][:p] + " ".join(words[1:])
        i += 1
    newCont = "\n".join(conts)
    return newCont

#  getCellEditTempFileName
#    cellEdit用のtempFile名を取得
def getCellEditTempFileName(field, patchName):
    global gridTitle
    [nTreeGrid, p] = getFoamContents.getSmallPairMem(gridTitle, 0)
    name = nTreeGrid + ":" + field + "." + patchName + ".temp"
    #fileName = os.environ["TreeFoamPath"] + "/temp/" + name
    fileName = os.environ["TreeFoamUserPath"] + "/temp/" + name
    return fileName

#
#  fitRowNamesCellDataToBoundary
#    rowNames, cellDataをboundaryの順番に合わせる
def fitRowNamesCellDataToBoundary(rowNames, cellData):
    global boundaryDir
    #boundaryからpatchを取得
    values = getFoamContents.getPatchNameFromBoundary(boundaryDir)
    boundNames = []
    for patchG in values:
        boundNames.append(patchG[0])
    #patchの順番をboundaryに合わせる
    boundData = []
    for boundField in cellData:
        fieldData = []
        for boundName in boundNames:
            i = 0
            for rowName in rowNames:
                if boundName == rowName:
                    fieldData.append(boundField[i])
                    break
                i += 1
        boundData.append(fieldData)
    return [boundNames, boundData]

#
#  getStartFaceNoAtNullPatch
#    空patchのstartFaceNoを取得
def getStartFaceNoAtNullPatch(boundaryDir):
    patchCont = getFoamContents.getPatchCont(boundaryDir)
    lastPatch = patchCont[-1]
    startFaceNo = str(lastPatch[1] + lastPatch[2])
    return startFaceNo

#
#  addNullPatches
#    複数の空patchをboundaryに追加
def addNullPatches(boundaryDir, startFaceNo, nLines):
    fileName = boundaryDir + "/boundary"
    f=open(fileName); contents = f.read(); f.close()
    p = getFoamContents.skipFoamFileMem(contents, 0)
    [nPatch, p] = getFoamContents.getKeywordMem(contents, p)
    [boundary, p] = getFoamContents.getSmallPairMem(contents, p)
    #「newPatch_」のpatch名を取得
    newPatchNames = []
    patchNames = []
    [[patchName, dummy], p] = getFoamContents.getNextKeywordAndContentsMem(boundary, 0)
    while dummy != "":
        patchNames.append(patchName)
        if patchName[:len("newPatch_")] == "newPatch_":
            newPatchNames.append(int(patchName[len("newPatch_"):]))
        [[patchName, dummy], p] = getFoamContents.getNextKeywordAndContentsMem(
            boundary, p)
    #最新のnewPatchNoを取得
    if len(newPatchNames) == 0:
        nPatch = -1
    else:
        newPatchNames.sort()
        nPatch = newPatchNames[-1]
    #boundary数を設定
    boundary = str(len(patchNames) + nLines) + "\n(" + boundary
    #空patchを行数分追加
    newPatchNames = []
    i = 0
    while i < nLines:
        nPatch += 1
        newPatchName = "newPatch_" + str(nPatch)
        newPatchNames.append(newPatchName)
        boundary += "    " + newPatchName + "\n"
        boundary += "    {\n"
        boundary += "        type        patch;\n"
        boundary += "        nFaces      0;\n"
        boundary += "        startFace   " + startFaceNo + ";\n"
        boundary += "    }\n"
        i += 1
    #boundaryを整形
    boundary += ")"
    return ["", boundary, newPatchNames]

"""
#
#  addNullPatch
#    空patchをboundaryに追加
def addNullPatch(boundaryDir, startFaceNo):
    fileName = boundaryDir + "/boundary"
    f=open(fileName); contents = f.read(); f.close()
    p = getFoamContents.skipFoamFileMem(contents, 0)
    [nPatch, p] = getFoamContents.getKeywordMem(contents, p)
    [boundary, p] = getFoamContents.getSmallPairMem(contents, p)
    newPatch = "newPatch_0"
    nFlag = 0
    eFlag = 0
    p=0
    while (eFlag == 0):
        [[patchName, dummy], p] = getFoamContents.getNextKeywordAndContentsMem(boundary, p)
        if patchName == newPatch:
            nFlag += 1
            newPatch = newPatch.split("_")[0] + "_" + str(nFlag)
            p=0
        if p >= len(boundary) or dummy == "":
            eFlag = 1
        if nFlag > 10:
            eFlag = 1
            newPatch = ""
    error = ""
    if newPatch == "":
        error = _(u"patchが作成できません")
        return [error, ""]
    nPatch = str(int(nPatch) + 1)
    boundary  = nPatch + "\n(" + boundary
    boundary += "    " + newPatch + "\n"
    boundary += "    {\n"
    boundary += "        type        patch;\n"
    boundary += "        nFaces      0;\n"
    boundary += "        startFace   " + startFaceNo + ";\n"
    boundary += "    }\n"
    boundary += ")"
    return ["", boundary, newPatch]
"""

#
#  setBoundaryContents
#    boundaryの内容を書き換え
def setBoundaryContents(boundaryDir, boundaryCont):
    fileName = boundaryDir + "/boundary"
    f=open(fileName); contents=f.read(); f.close()
    p = getFoamContents.skipFoamFileMem(contents, 0)
    [nPatch, p] = getFoamContents.getKeywordMem(contents, p)
    #pointerをkeywordの前まで戻す
    flag = 0
    while flag == 0:
        if contents[p:p+len(nPatch)] == nPatch:
            flag = 1
        else:
            p -= 1
    sp = p
    [boundary, p] = getFoamContents.getSmallPairMem(contents, p)
    ep = p
    newCont = contents[:sp] + boundaryCont + contents[ep:]
    #newContを書き込み
    f=open(fileName, "w"); f.write(newCont); f.close()


#
#  getRowNamesFromBoundary
#    rowNamesをbundaryから取得する。
def getRowNamesFromBoundary(boundaryDir):
    ans = []
    values = getFoamContents.getPatchNameFromBoundary(boundaryDir)
    for patchG in values:
        ans.append(patchG[0])
    if sortPatchName == "yes":
        ans.sort()
    return ans


#
#  changePatchName
#    patch名の変更
def changePatchName(oldPatchName, newPatchName):
    global boundaryDir, dataDir, colNames
    fields = pyTreeFoam.getFieldNames(dataDir)      #全てのfieldを取得
    error = pyTreeFoam.changePatchName(boundaryDir, dataDir, fields,
                                       oldPatchName, newPatchName)
    return error

#
#  line2lines
#    lineをlength幅で複数lineに分割
def line2lines(lines, length):
    ans = []
    for line in lines:
        j=0; n=length ;l=[]
        while len(line) > j*n:
            l.append(line[j*n:(j+1)*n]) 
            j+=1
        word = string.join(l,"\n")
        ans.append(word)
    return ans

#
#  deletePatch
#    patchを削除する
def deletePatch(delPatch):
    global boundaryDir, dataDir, colNames
    #空patchのチェック
    nFace = ""
    boundary = boundaryDir + "/boundary"
    patchConts = getFoamContents.getPatchCont(boundaryDir)
    for patchCont in patchConts:
        patchName = patchCont[0]
        if patchName == delPatch:
            nFace = patchCont[1]
            break
    if nFace == 0:
        fields = pyTreeFoam.getFieldNames(dataDir)      #全てのfieldを取得
        error = pyTreeFoam.deletePatch(boundaryDir, dataDir, fields, delPatch)
    else:
        error = ["NG", _(u"削除するpatchは、空patchではありません。\n削除できません。")]
    return error

def getDefinePatchData(wdir, names):
    #boundaryの定義内容を取得
    fileName = wdir + "/boundary"
    if len(glob.glob(fileName)) == 0:
        return []

    f=open(fileName); contents=f.read(); f.close()
    defineD = []
    p = getFoamContents.skipFoamFileMem(contents, 0)
    [boundCont, p] = getFoamContents.getSmallPairMem(contents, p)
    for keyword in names:
        p=0
        [[patchName, cont], p] = getFoamContents.getNextKeywordAndContentsMem(
                                        boundCont, p)
        while(p <= len(boundCont) and patchName != ""): 
            if keyword == patchName:
                defineD.append(cont)
                break
            [[patchName, cont], p] = getFoamContents.getNextKeywordAndContentsMem(
                                        boundCont, p)

    #空白を詰める
    newDefine = []
    for define in defineD:
        newLines = []
        lines = define.split("\n")
        for line in lines:
            words = line.split()
            if len(words)>0:
                wd = string.join(words, " ")
                newLines.append(wd)
        if len(newLines)>0:
            newDefine.append(string.join(newLines, "\n"))
        else:
            newDefine.append("")
    return newDefine

def getDimensionInternalFieldData(fieldDir, fields):
    global nMaxLinesBinToAscii
    dimData = []
    intData = []
    variables = []
    variablesBoundary = []
    for field in fields:
        fileName = fieldDir + "/" + field
        fileName = getFoamContents.checkFileName(fileName)
        dimW = []
        if len(glob.glob(fileName)) != 0:
            #fieldの読込
            contents = getFoamContents.readField(fileName, nMaxLinesBinToAscii)

            #dimensionデータ取得
            [dummy, p] = getFoamContents.getKeywordContentsMem(
                    "FoamFile", contents, 0)
            pData = p
            value = getKeywordValue("class", dummy, 0)
            dimW = value + "\n"
            value = getKeywordValue("dimensions", contents, p)
            if value == "":
                print field + _(u"のdimensionsが取得できません。")
            dimW += value
            dimData.append(dimW)

            #internalField取得
            p = pData
            [keyword, p] = getFoamContents.getKeywordMem(contents, p)
            while keyword != "internalField" and keyword != "":
                [keyword, p] = getFoamContents.getKeywordMem(contents, p)
            if keyword != "":
                a = reformInternalFieldCellData(contents[p:p+1000])
                intData.append(a)
            else:
                print field + _(u"のinternalFieldのデータが取得できません。")
                intData.append("")

            #変数名を取得
            topCont = ""
            varNames = []
            p = pData
            [lineCont, p, kind] = getFoamContents.get1lineMem(contents, p)
            while lineCont != "":
                if kind == "line":
                    [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
                    if keyword != "dimensions" and keyword != "internalField":
                        name = lineCont
                        varNames.append(name)
                elif kind == "include":
                    #includefileの読み込み
                    name = (lineCont.split()[1]).split('"')[1]
                    currDir = fieldDir
                    name = getAbsPath(currDir, name)
                    includeCont = readIncludeCont(currDir, name)
                    contents = contents[:p] + includeCont + contents[p:]
                elif kind == "includeEtc":
                    #includefileの読み込み
                    name = "${WM_PROJECT_DIR}/etc/" + (lineCont.split()[1]).split('"')[1]
                    currDir = fieldDir
                    name = getAbsPath(currDir, name)
                    includeCont = readIncludeCont(currDir, name)
                    contents = contents[:p] + includeCont + contents[p:]
                elif kind == "other":
                    name = lineCont
                    varNames.append(name)
                elif kind == "keyword":
                    topCont += lineCont
                [lineCont, p, kind] = getFoamContents.get1lineMem(contents, p)
            #  変数名を取得
            nameCont = ""
            if len(varNames) > 0:
                nameCont = reformNameCont(varNames)
            #  「$:」をチェック修正
            newNameCont = getVariableLevelAndCheck(nameCont, topCont)
            #  変数名を保存
            variables.append(newNameCont)
            #internalField value「$:」のチェック修正
            i = 0
            for val in intData:
                p = val.find("$:")
                if p >= 0:
                    ps = p
                    chara = val[p]
                    while (chara != " " and chara != "\n" and chara != "\t"
                        and chara != ";" and p<len(val)):
                         p += 1
                         chara = val[p]
                    keyList = val[ps+2:p].split(".")
                    keyCont = getKeyContFromVariableValue(keyList, field, contents)
                    if keyCont != "":
                        newVal = val[:ps] + keyCont + val[p:]
                        intData[i] = newVal
                        break                    
                i += 1

            #変数名（boundary）を取得
            varNames = []
            p = pData
            [boundaryCont, p] = getFoamContents.getKeywordContentsMem(
                                    "boundaryField", contents, p)
            [lineCont, p, kind] = getFoamContents.get1lineMem(boundaryCont, 0)
            while lineCont != "":
                if kind == "line" or kind == "other":
                    name = lineCont
                    varNames.append(name)
                elif kind == "include":
                    #includeFileの読み込み
                    name = (lineCont.split()[1]).split('"')[1]
                    currDir = fieldDir
                    name = getAbsPath(currDir, name)
                    includeCont = readIncludeCont(currDir, name)
                    #p -= 1
                    #boundaryCont = boundaryCont[:p] + includeCont + boundaryCont[p+1:]
                    boundaryCont = boundaryCont[:p] + includeCont + boundaryCont[p:]
                elif kind == "includeEtc":
                    #includeFileの読み込み
                    name = "${WM_PROJECT_DIR}/etc/" + (lineCont.split()[1]).split('"')[1]
                    currDir = fieldDir
                    name = getAbsPath(currDir, name)
                    includeCont = readIncludeCont(currDir, name)
                    boundaryCont = boundaryCont[:p] + includeCont + boundaryCont[p:]

                [lineCont, p, kind] = getFoamContents.get1lineMem(boundaryCont, p)
            #  boundaryの変数をセット
            nameCont = ""
            if len(varNames) > 0:
                nameCont = reformNameCont(varNames)
            #  「$:」をチェック修正
            newNameCont = getVariableLevelAndCheck(nameCont, topCont)
            #  変数名を保存
            variablesBoundary.append(newNameCont)

        else:
            #fieldが存在しない場合
            dimData.append("")
            intData.append("")
            variables.append("")
            variablesBoundary.append("")
    return [dimData, intData, variables, variablesBoundary]

#  getVariableLevelAndCheck
#    「$:」が無くなるまで取得する
def getVariableLevelAndCheck(nameCont, topCont):
    end = False; nloop = 0
    while end == False and nloop < 10:
        nameCont = getVariableLevelCont(nameCont, topCont)
        n = nameCont.find("$:")
        if n < 0:
            end = True
        nloop += 1
    return nameCont

#  getVariableLevelCont
#    「$:」を取得する
def getVariableLevelCont(variCont, topCont):
    if variCont == " ":
        return varicont

    #変数のlistを取得
    variables = []
    lineCont = " "; p = 0
    while lineCont != "":
        [lineCont, p, kind] = getFoamContents.get1lineMem(variCont, p)
        if kind == "line":
            variables.append(lineCont)

    ans = []
    for vari in variables:
        words = vari.split()
        if len(words) > 1:
            variName = words[1]
            if variName[:2] == "$:":
                if variName[-1] == ";":
                    variName = variName[:-1]
                variCont = getVariableLevelContFromContents(variName, topCont, variCont)
                ans.append(words[0] + " " + variCont + ";")
            else:
                ans.append(vari)
        else:
            ans.append(vari)
    return "\n".join(ans)

#  getVariableLevelContFromContents
#    「$:」を取得
def getVariableLevelContFromContents(variName, topCont, variCont):

    #  getKeyCont
    #    keyの内容をcontentsから取得
    def getKeyCont(key, contents):
        ans = ""
        lineCont = " "; keyword = " "; p = 0
        while lineCont != "" and keyword != "boundaryField":
            [lineCont, p, kind] = getFoamContents.get1lineMem(contents, p)
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
            if keyword == key and kind == "keyword":
                [ans, pp] = getFoamContents.getMiddlePairMem(lineCont, 0)
                break
        return ans

    #  getKeyLastCont
    #    最終のkeyの内容をcontentsから取得
    def getKeyLastCont(key, contents):
        ans = ""
        lineCont = " "; keyword = " "; p = 0
        while lineCont != "" and keyword != "boundaryField":
            [lineCont, p, kind] = getFoamContents.get1lineMem(contents, p)
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
            if keyword == key and kind == "line":
                keyLine = lineCont.split(";")[0]
                ans = " ".join(keyLine.split()[1:])
                break
        return ans

    #処理----------------------
    ans = ""
    keyList = variName[2:].split(".")
    if len(keyList) == 1:
        contents = variCont
        ans = getKeyLastCont(keyList[0], contents)
        if ans == "":
            ans = variName
        return ans

    #keyListを順番に解釈
    contents = topCont
    for key in keyList[:-1]:
        keyCont = getKeyCont(key, contents)
        if keyCont == "":
            break
        contents = keyCont
    #最後のkeyを解釈
    if keyCont == "":
        ans = variName
    else:
        contents = keyCont
        ans = getKeyLastCont(keyList[-1], contents)
        if ans == "":
            ans = variName
    return ans


#  getKeyContFromVariableValue
#    「$:」value変数の内容を取得
def getKeyContFromVariableValue(keyList, field, contents):
    ans = ""
    [lineCont, p, kind] = getFoamContents.get1lineMem(contents, 0)
    while lineCont != "" and p<len(contents):
        if kind == "keyword":
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
            if keyword == keyList[0]:
                [subCont, pp] = getFoamContents.getMiddlePairMem(lineCont, 0)
                [subLine, pi, subKind] = getFoamContents.get1lineMem(subCont, 0)
                while subLine != "" and pi<len(subCont):
                    if subKind == "line":
                        [subKey, pp] = getFoamContents.getKeywordMem(subLine, 0)
                        if subKey == keyList[1]:
                            [lcont, pp, dm] = getFoamContents.get1lineMem(subLine, pp)
                            ans = lcont[:-1]
                            break
                    [subLine, pi, subKind] = getFoamContents.get1lineMem(subCont, pi)
        [lineCont, p, kind] = getFoamContents.get1lineMem(contents, p)
    return ans

#  reformNameCont
#    変数名を整形する
def reformNameCont(varNames):
    varList = []
    for var in varNames:
        nameList = var.split()
        if nameList[0] != "#":
            flag = 0
            i = 0
            for newVar in varList:
                if newVar.split()[0] == nameList[0]:
                    flag = 1
                    break
                i += 1
            if flag == 1:
                varList[i] = " ".join(nameList)
            else:
                varList.append(" ".join(nameList))
    ans = "\n".join(varList)
    return ans

def getAbsPath(currDir, cont):
    #環境変数を取得
    sp = cont.find("${")
    if sp >= 0:
        # ${xxx}記述の解釈
        [envPath, p] = getFoamContents.getMiddlePairMem(cont, sp)
        if os.getenv(envPath) != None:
            cont = cont[:sp] + os.getenv(envPath) + cont[p:]
        else:
            if envPath == "FOAM_CASE":
                caseDirList = currDir.split("/")
                try:
                    a = float(caseDirList[-1])
                    caseDir = "/".join(caseDirList[:-1])
                except:
                    caseDir = "/".join(caseDirList[:-2])
                cont = cont[:sp] + caseDir + cont[p:]
    elif cont.find("$") >= 0:
        # $xxx記述の解釈
        sp = cont.find("$")
        newCont = cont[sp+1:]
        envPath = newCont.split("/")[0]
        p = sp + len(envPath) + 1
        if os.getenv(envPath) != None:
            cont = cont[:sp] + os.getenv(envPath) + cont[p:]
        else:
            if envPath == "FOAM_CASE":
                caseDirList = currDir.split("/")
                try:
                    a = float(caseDirList[-1])
                    caseDir = "/".join(caseDirList[:-1])
                except:
                    caseDir = "/".join(caseDirList[:-2])
                cont = cont[:sp] + caseDir + cont[p:]
    #絶対pathを取得
    if cont[0] != "/":
        cont = currDir + "/" + cont
    return cont

#  readIncludeCont
#    includeFileの読み込み
def readIncludeCont(currDir, fileName):
    cont = ""
    cont = readIncludeSub(currDir, fileName, cont)
    return cont

def readIncludeSub(currDir, fileName, cont):
    if len(glob.glob(fileName)) == 0:
        print _(u"\nerror: includeファイル「") + fileName + _(u"」が存在しません。")
        return ""

    f=open(fileName); fileCont=f.read(); f.close()
    newCont = getFoamContents.deleteCommentsNullLines(fileCont)
    includeCont = cont
    [lineCont, p, kind] = getFoamContents.get1lineMem(newCont, 0)
    while lineCont != "":
        if kind == "include":
            fileName = (lineCont.split()[1]).split('"')[1]
            fileName = getAbsPath(currDir, fileName)
            includeCont += readIncludeSub(currDir, fileName, includeCont)
        elif kind == "includeEtc":
            fileName ="${WM_PROJECT_DIR}/etc/" + (lineCont.split()[1]).split('"')[1]
            fileName = getAbsPath(currDir, fileName)
            includeCont += readIncludeSub(currDir, fileName, includeCont)
        else:
            #includeCont += lineCont
            includeCont += lineCont + "\n"
        [lineCont, p, kind] = getFoamContents.get1lineMem(newCont, p)
    if len(includeCont) != 0:
        if includeCont[-1] != "\n":
            includeCont += "\n"
    return includeCont


def getKeywordValue(searchW, contents, p):
        [keyword, p] = getFoamContents.getKeywordMem(contents, p)
        while keyword != searchW and keyword != "":
            [keyword, p] = getFoamContents.getKeywordMem(contents, p)
        if keyword != "":
            p=getFoamContents.skipSpaceMem(contents, p)
            pEnd = getFoamContents.skipUntilCRMem(contents, p)
            value = contents[p:pEnd]
        else:
            value = ""
        return value

#  reformInternalFieldCellData
#    internalFieldDataをcellData用に整形する
#    maxRowsInCellInternalの値（5行）の行数に縮める
def reformInternalFieldCellData(contents):
    [lineCont, p, kind] = getFoamContents.get1lineMem(contents, 0)
    [keyword, p] = getFoamContents.getKeywordMem(lineCont, 0)
    if keyword == "uniform":
        a = lineCont
    else:
        lines = lineCont.split("\n")
        if len(lines) > maxRowsInCellInternal:
            a = "\n".join(lines[:maxRowsInCellInternal]) + "..."
        else:
            a = "\n".join(lines)
    return a

    """
    #intW = contents.split("\n")
    intW = lineCont.split("\n")
    alist=(intW[0]).split()
    if alist[0] == "uniform":
        #a=string.join(alist, " ")
        a = " ".join(alist)
    else:
        a = pyTreeFoam.compressSPCR(intW[0]) + "\n"
        #a += string.join(intW[1:maxRowsInCellInternal], "\n") + "..."
        #a += string.join(intW[1:maxRowsInCellInternal], "\n")
        a += "\n".join(intW[1:maxRowsInCellInternal])
        if a[-2] == ";":
            pass
        else:
            a += "..."
    return a    
    """

#
#  endingGrid
#    終了処理
def endingGrid(title, gridSize, colNames, dataDir):
    #closeする前にgridNoを削除
    ownGridNoStr = title
    gridList = getGridList()
    [gridNoStr, p] = getFoamContents.getSmallPairMem(ownGridNoStr, 0)
    newGridList = []
    for grid in gridList:
        if (grid[0]) != (gridNoStr):
            newGridList.append(grid)
    saveGridList(newGridList)
    #windowSizeを保存
    saveGridSize(gridSize)
    #tempFileを削除
    deleteTempFile(title)

#  deleteTempFile
#    自身が作成したtempFileを削除
def deleteTempFile(title):
    [nTreeGrid, p] = getFoamContents.getSmallPairMem(title, 0)
    #tempDir = os.environ["TreeFoamPath"] + "/temp"
    tempDir = os.environ["TreeFoamUserPath"] + "/temp"
    [folders, files] = pyTreeFoam.getFoldersFiles(tempDir)
    for name in files:
        if name[:len(nTreeGrid)] == nTreeGrid and name[-5:] == ".temp":
            comm = "rm " + tempDir + "/" + name
            os.system(comm)

#
#  initializeVal
#    変数の初期化
def initializeVal():
    global isVariable, isVariableBoundary
    #gridEdtorの設定
    setConfigData()
    #変数表示有無の初期化
    isVariable = False
    isVariableBoundary = False

#
#  initializeGrid
#    初期化
def initializeGrid():
    #gridNoの取得
    global gridTitle, nTreeFoam, gridSize
    gridList = getGridList()
    if len(gridList) == 0:
        newGridNo = "0"
    else:
        currNo = "-1"
        for cont in gridList:
            treeFoamNo = cont[0].split(":")[0]
            gridNo = cont[0].split(":")[1]
            if nTreeFoam == treeFoamNo:
                currNo = gridNo
        newGridNo = str(int(currNo) + 1)
    newGridNoAbs = nTreeFoam + ":" + newGridNo
    newGrid = [newGridNoAbs, boundaryDir, dataDir]
    gridList.append(newGrid)
    saveGridList(gridList)
    gridTitle = gridTitle + " (" + newGridNoAbs + ")"
    #windowSizeの読み込み
    gridSize = getGridSize()
    #tempFileの削除
    if newGridNo == "0":
        #tempDir = os.environ["TreeFoamPath"] + "/temp"
        tempDir = os.environ["TreeFoamUserPath"] + "/temp"
        [folders, files] = pyTreeFoam.getFoldersFiles(tempDir)
        for name in files:
            nTreeGrid = name.split(":")
            flag = 1
            if len(nTreeGrid) > 2:
                try:
                    a=int(nTreeGrid[0])
                    flag = 0
                except:
                    flag = 1
                try:
                    a = int(nTreeGrid[1])
                except:
                    flag = 1
            if flag == 0 and name[-5:]==".temp":
                comm = "rm " + tempDir + "/" + name
                os.system(comm)

def setConfigData():
    global sortPatchName, maxRowsInCellInternal, maxRowsInCell, nMaxLinesBinToAscii
    [sortPatchName, maxRowsInCellInternal,
        maxRowsInCell, nMaxLinesBinToAscii] = readConfigData()


def readConfigData():
    #初期値を設定
    sortPatchName = "no"
    maxRowsInCellInternal = 5
    maxRowsInCell = 10
    nMaxLinesBinToAscii = 20
    #fileName = os.environ["TreeFoamPath"] + "/" + gridEditor_data
    fileName = os.environ["TreeFoamUserPath"] + "/" + gridEditor_data
    if len(glob.glob(fileName)) != 0:
        f=open(fileName); cont=f.readlines(); f.close()
        for line in cont:
            words = line.split()
            if len(words) > 1:
                if words[0][0] != "#":
                    if words[0] == "sortPatchName":
                        sortPatchName = words[1]
                    elif words[0] == "maxLinesCellInternal":
                        maxRowsInCellInternal = int(words[1])
                    elif words[0] == "maxLinesCellPatch":
                        maxRowsInCell = int(words[1])
                    elif words[0] == "nMaxLinesBinToAscii":
                        nMaxLinesBinToAscii = int(words[1])
    else:
        writeConfigData([["sortPatchName", sortPatchName],
                        ["maxLinesCellInternal", maxRowsInCellInternal],
                        ["maxLinesCellPatch", maxRowsInCell],
                        ["nMaxLinesBinToAscii", nMaxLinesBinToAscii]])
    return [sortPatchName, maxRowsInCellInternal,
                maxRowsInCell, nMaxLinesBinToAscii]

#  writeConfigData
#    itemsData = [[item0, data0], [item1, data1], ...]
def writeConfigData(itemsData):
    #fileName = os.environ["TreeFoamPath"] + "/" + gridEditor_data
    fileName = os.environ["TreeFoamUserPath"] + "/" + gridEditor_data
    if len(glob.glob(fileName)) != 0:
        f=open(fileName); cont=f.readlines(); f.close()
        for itemData in itemsData:
            item = itemData[0]
            data = itemData[1]
            i = 0
            for line in cont:
                words = line.split()
                if len(words) > 1:
                    if words[0] == item:
                        words[1] = data
                        cont[i] = " ".join(words) + "\n"
                        break
                i += 1
        f=open(fileName, "w")
        for line in cont:
            f.write(line)
        f.close()
    else:
        #値を取得
        for items in itemsData:
            if items[0] == "sortPatchName":
                sortPatchName = items[1]
            elif items[0] == "maxLinesCellInternal":
                maxRowsInCellInternal = items[1]
            elif items[0] == "maxLinesCellPatch":
                maxRowsInCell = items[1]
            elif items[0] == "nMaxLinesBinToAscii":
                nMaxLinesBinToAscii = items[1]
        #file作成
        cont = """#
#   gridEDitorの設定
#


#patch名をsortさせて表示させる
sortPatchName """ + sortPatchName + """

#cell内の表示行数
maxLinesCellInternal """ + str(maxRowsInCellInternal) + """
maxLinesCellPatch """ + str(maxRowsInCell) + "\n" + """

#binary -> ascii変換する行数
nMaxLinesBinToAscii """ + str(nMaxLinesBinToAscii) + "\n"
        f=open(fileName, "w"); f.write(cont); f.close()

def getGridSize():
    global gridSize
    ans = gridSize
    #fileName = os.environ["TreeFoamPath"] + "/" + winSizeFile
    fileName = os.environ["TreeFoamUserPath"] + "/" + winSizeFile
    if len(glob.glob(fileName)) != 0:
        f = open(fileName); lines = f.readlines(); f.close()
        for line in lines:
            words = line.split()
            if len(words) == 3:
                if words[0] == "gridEditor":
                    ans = (int(words[1]), int(words[2]))
    if ans[0] < 100 or ans[1] < 100:
        ans = gridSize
    return ans

def saveDisplayFieldsIfFile(colNames, dataDir):
    fileName = getSaveDisplayFieldsFileName(dataDir)
    if len(glob.glob(fileName)) != 0:
        saveDisplayFields(colNames, dataDir)

def saveDisplayFields(colNames, dataDir):
    fileName = getSaveDisplayFieldsFileName(dataDir)
    f=open(fileName, "w")
    for name in colNames:
        line = name + "\n"
        f.write(line)
    f.close()

def getSaveDisplayFieldsFileName(dataDir):
    dataDirList = dataDir.split("/")
    caseDir = ""
    subFolder = 0
    try:
        a = float(dataDirList[-1])
        caseDir = string.join(dataDirList[:-1], "/")
    except:
        caseDir = string.join(dataDirList[:-2], "/")
        subFolder = 1
    timeFolders = pyTreeFoam.getTimeFolders(caseDir)
    saveDir = caseDir + "/" + timeFolders[0]
    if subFolder == 1:
        saveDir += "/" + dataDirList[-1]
    fileName = saveDir + "/" + displayFieldsFile
    return fileName

def getDisplayFields(fileName):
    f=open(fileName)
    contents = f.read()
    f.close()
    fields = contents.split()
    return fields


def saveGridSize(gridSize):
    (h, w) = gridSize
    #fileName = os.environ["TreeFoamPath"] + "/" + winSizeFile
    fileName = os.environ["TreeFoamUserPath"] + "/" + winSizeFile
    contents = []
    if len(glob.glob(fileName)) != 0:
        f=open(fileName); contents=f.readlines(); f.close()
        flag = 0
        i=0
        for line in contents:
            words = line.split()
            if words[0] == "gridEditor":
                words[1] = str(h)
                words[2] = str(w)
                contents[i] = words[0] + " " + words[1] + " " + words[2] + "\n"
                flag = 1
                break
            i += 1
        if flag == 0:
            contents += "gridEditor " + str(h) + " " + str(w) + "\n"
    else:
        line = "gridEditor " + str(h) + " " + str(w) + "\n"
        contents.append(line)
    f=open(fileName, "w")
    for line in contents:
        f.write(line)
    f.close()

def getGridList():
    #fileName = os.environ["TreeFoamPath"] + "/" + nRunningGrid
    fileName = os.environ["TreeFoamUserPath"] + "/" + nRunningGrid
    if len(glob.glob(fileName)) == 0:
        gridList = []
    else:
        gridList = []
        f=open(fileName); lines=f.readlines(); f.close()
        for line in lines:
            elements = line.split()
            if len(elements) > 0:
                gridList.append(line.split())
    return gridList

def saveGridList(gridList):
    #fileName = os.environ["TreeFoamPath"] + "/" + nRunningGrid
    fileName = os.environ["TreeFoamUserPath"] + "/" + nRunningGrid
    f=open(fileName, "w")
    for cont in gridList:
        line = string.join(cont, " ") + "\n"
        f.write(line)
    f.close()



if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    initializeVal()             #変数の設定
    nTreeFoam = sys.argv[1]
    gridTitle = sys.argv[2]
    boundaryDir = sys.argv[3]
    dataDir = sys.argv[4]
    colNames = []
    i = 5
    while i < len(sys.argv):
        colNames.append(sys.argv[i])
        i += 1
    if len(colNames) == 0:
        colNames = pyTreeFoam.getFieldNames(dataDir)
    rowNames = getRowNamesFromBoundary(boundaryDir)     #patchName
    initializeGrid()            #初期化（gridNo、title設定）

    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()

