#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   editStlFilesDialog
#
#       stlファイルのsolid名や倍率を変更する
#
#   13/10/31    新規作成
#      11/02    binaryの場合は、solid名、サイズとも空白で表示
#      11/03    binaryの場合も表示、ascii変換追加
#      12/21    stdout、stderrの設定（import logFileCreater）を追加
#   14/12/27    solid名の取得、変更方法を修正、stl結合ボタンを追加
#   15/01/10    mergeStlFile:バグ修正（stl結合時、cancelできない）
#      01/13    「face向き反転」「solid名設定」「stl内部結合」「folder開く」ﾎﾞﾀﾝ追加
#               toolTip追加、ﾀﾞﾌﾞﾙｸﾘｯｸの動作追加、「paraview起動」ボタン追加
#      01/15    setSolidName:バグ修正
#      06/27    windowのサイズをwxのバージョンによって方法を変える
#      07/14    winSizeの保存場所変更
#      07/17    dialog起動方法修正
#   16/05/09    binaryの読み込み方法を修正
#      08/28    windowサイズ設定を修正
#

# generated by wxGlade 0.6.5 on Thu Oct 31 15:59:56 2013

import wx
import os
import sys
import glob
import math
import struct
import gio
import pyTreeFoam
import inputTextDDialog

import logFileCreater; logFileCreater.log()


# begin wxGlade: extracode
# end wxGlade


stlFiles = []
solidNames = []
stlSize = []
caseDir = ""
stlDir = ""
clipBoard = []
winSize = (470, 470)        #windowのサイズ
colWidth = [120, 50, 120]   #list_ctrlの幅


def Show(caseDirW, stlDirW):
    global caseDir, stlDir
    caseDir = caseDirW
    stlDir = stlDirW
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, wx.ID_ANY, _(u"stlファイルの編集"))
        self.static_line_1 = wx.StaticLine(self, wx.ID_ANY)
        self.label_2 = wx.StaticText(self, wx.ID_ANY, _(u"stlファイルのsolid名やscaleを変更する"))
        self.list_ctrl_1 = wx.ListCtrl(self, wx.ID_ANY, style=wx.LC_REPORT | wx.SUNKEN_BORDER)
        self.label_3 = wx.StaticText(self, wx.ID_ANY, _(u"stlファイルを選択し、各ボタンをクリックする事で変更できる。\n複数選択が可能。"))
        self.button_4 = wx.Button(self, wx.ID_ANY, _(u"ascii変換"))
        self.button_8 = wx.Button(self, wx.ID_ANY, _(u"solid名設定"))
        self.button_1 = wx.Button(self, wx.ID_ANY, _(u"solid名変更..."))
        self.button_2 = wx.Button(self, wx.ID_ANY, _(u"scale変更..."))
        self.button_6 = wx.Button(self, wx.ID_ANY, _(u"face向き反転"))
        self.button_5 = wx.Button(self, wx.ID_ANY, _(u"stl結合..."))
        self.button_7 = wx.Button(self, wx.ID_ANY, _(u"内部solid名削除"))
        self.static_line_2 = wx.StaticLine(self, wx.ID_ANY)
        self.button_10 = wx.Button(self, wx.ID_ANY, _(u"形状確認(paraview)"))
        self.button_9 = wx.Button(self, wx.ID_ANY, _(u"folder開く"))
        self.button_3 = wx.Button(self, wx.ID_ANY, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onBinToAscii, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onSetSolidName, self.button_8)
        self.Bind(wx.EVT_BUTTON, self.onChangeSolidName, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onChangeScale, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onReverseSurface, self.button_6)
        self.Bind(wx.EVT_BUTTON, self.onMergeStlFile, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.onDeleteInnerName, self.button_7)
        self.Bind(wx.EVT_BUTTON, self.onRunParaview, self.button_10)
        self.Bind(wx.EVT_BUTTON, self.onOpenFolder, self.button_9)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_3)
        # end wxGlade

        self.list_ctrl_1.Bind(wx.EVT_LEFT_DCLICK, self.onOpenStlFile)

        #toolTip追加
        self.button_4.SetToolTipString(_(u"選択したstlファイルの形式を\nascii形式に変換します。"))
        self.button_8.SetToolTipString(_(u"選択したstlファイルのsolid名を\nファイル名に設定します。"))
        self.button_1.SetToolTipString(_(u"選択したstlファイルのsolid名を変更します。"))
        self.button_2.SetToolTipString(_(u"選択したstlファイルのscaleを変更します。"))
        self.button_6.SetToolTipString(_(u"選択したstlファイルのfaceの向きを反転して、\nファイル名を「***_rev.stl」として保存します。"))
        self.button_5.SetToolTipString(_(u"選択したstlファイルを結合して\n新しいstlファイルを作成します。"))
        self.button_7.SetToolTipString(_(u"結合されたファイル内のsolid名を削除して\n1ヶのsolid名に設定します。"))
        self.list_ctrl_1.SetToolTipString(_(u"ここをダブルクリックすと\nファイルを開きます。"))

        #popupMenue--------------------------------------------
        menu = [_(u"開く"), _(u"_"), _(u"コピー"), _(u"フォルダに貼付け"), _(u"_"),
                _(u"ファイル名変更"), _(u"削除")]
        self.popupMenu = wx.Menu()
        i = 0
        for text in menu:
            if text == "_":
                self.popupMenu.AppendSeparator()
            else:
                item = self.popupMenu.Append(-1, text)
                self.Bind(wx.EVT_MENU, self.onPopupMenu, item)
            i += 1
        self.list_ctrl_1.Bind(wx.EVT_RIGHT_UP, self.onShowPopupMenu)
        #-------------------------------------------------------

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_("frame_1"))
        self.list_ctrl_1.SetMinSize((450, 200))
        # end wxGlade

        self.SetTitle(_(u"stlファイルの編集"))
        #listCtrlの設定
        self.list_ctrl_1.InsertColumn(0, _(u"現在のサイズ(xyz)"), wx.LIST_FORMAT_LEFT, 150)
        self.list_ctrl_1.InsertColumn(0, _(u"solid名"), wx.LIST_FORMAT_LEFT, 100)
        self.list_ctrl_1.InsertColumn(0, _(u"file"), wx.LIST_FORMAT_LEFT, 50)
        self.list_ctrl_1.InsertColumn(0, _(u"stl"), wx.LIST_FORMAT_LEFT, 120)
        self.setDataToListCtrl()

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_5 = wx.BoxSizer(wx.VERTICAL)
        sizer_7 = wx.BoxSizer(wx.VERTICAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_9 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3 = wx.BoxSizer(wx.VERTICAL)
        sizer_1.Add(self.label_1, 0, wx.ALL | wx.ALIGN_CENTER_HORIZONTAL, 20)
        sizer_1.Add(self.static_line_1, 0, wx.ALL | wx.EXPAND, 5)
        sizer_1.Add(self.label_2, 0, wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 5)
        sizer_3.Add(self.list_ctrl_1, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_2.Add(sizer_3, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_2, 1, wx.EXPAND, 0)
        sizer_5.Add(self.label_3, 0, wx.LEFT | wx.RIGHT | wx.TOP | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_6.Add((10, 20), 0, 0, 0)
        sizer_6.Add(self.button_4, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM, 5)
        sizer_6.Add(self.button_8, 0, 0, 0)
        sizer_6.Add(self.button_1, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM, 5)
        sizer_6.Add(self.button_2, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM, 5)
        sizer_6.Add((10, 20), 0, 0, 0)
        sizer_5.Add(sizer_6, 0, wx.EXPAND, 1)
        sizer_9.Add((10, 20), 0, 0, 0)
        sizer_9.Add(self.button_6, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM, 5)
        sizer_9.Add(self.button_5, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM, 5)
        sizer_9.Add(self.button_7, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM, 5)
        sizer_9.Add((10, 20), 0, 0, 0)
        sizer_5.Add(sizer_9, 0, wx.EXPAND, 0)
        sizer_5.Add(self.static_line_2, 0, wx.ALL | wx.EXPAND, 5)
        sizer_7.Add((20, 15), 0, 0, 0)
        sizer_8.Add(self.button_10, 0, 0, 0)
        sizer_8.Add(self.button_9, 0, 0, 0)
        sizer_8.Add(self.button_3, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.ALIGN_RIGHT, 20)
        sizer_7.Add(sizer_8, 1, wx.EXPAND, 0)
        sizer_5.Add(sizer_7, 1, wx.ALIGN_RIGHT, 0)
        sizer_4.Add(sizer_5, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_4, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

        #widowのサイズ設定
        [winSize, colWidth] = readWinSize()
        ver = wx.version().split()[0]
        tfVer = pyTreeFoam.getTreeFoamVersion().split("+")
        if ver >= "3.0" and len(tfVer) == 1:
            self.SetSizeWH(winSize[0], winSize[1]-28)
        else:
            self.SetSize(winSize)
        self.list_ctrl_1.SetColumnWidth(0, colWidth[0])
        self.list_ctrl_1.SetColumnWidth(1, colWidth[1])
        self.list_ctrl_1.SetColumnWidth(2, colWidth[2])

    #----------popupMenu------------------------------
    #onPopupMenu
    def onPopupMenu(self, event):
        PPitem = self.popupMenu.FindItemById(event.GetId())
        text = PPitem.GetText()
        if text == _(u"開く"):
            self.openStlFile()
        elif text == _(u"コピー"):
            self.copyFiles()
        elif text == _(u"フォルダに貼付け"):
            self.pasteFiles()
        elif text == _(u"ファイル名変更"):
            self.renameStlFile()
        elif text == _(u"削除"):
            self.deleteStlFile()

    #onShowPopupMenu
    def onShowPopupMenu(self, event):
        pos = event.GetPosition()
        self.list_ctrl_1.PopupMenu(self.popupMenu, pos)
    #--------------------------------------------------

    #----Dclick----------------------------------------
    #stlファイルを開く
    def onOpenStlFile(self, event):
        self.openStlFile()
    #--------------------------------------------------

    #menuボタン-----------------------------------------
    #ascii変換
    def onBinToAscii(self, event):  # wxGlade: MyFrame.<event_handler>
        self.binToAscii(event)

    #solid名変更
    def onChangeSolidName(self, event):  # wxGlade: MyFrame.<event_handler>
        self.changeSolidName(event)

    #stlFile結合
    def onMergeStlFile(self, event):  # wxGlade: MyFrame.<event_handler>
        self.mergeStlFile(event)

    #scale変更
    def onChangeScale(self, event):  # wxGlade: MyFrame.<event_handler>
        self.changeScale(event)

    #solid名セット
    def onSetSolidName(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setSolidName(event)

    #内部solid名削除（内部結合）
    def onDeleteInnerName(self, event):  # wxGlade: MyFrame.<event_handler>
        self.deleteInnerName(event)

    #faceの向きを反転
    def onReverseSurface(self, event):  # wxGlade: MyFrame.<event_handler>
        self.reverseSurface(event)

    #folder開く
    def onOpenFolder(self, event):  # wxGlade: MyFrame.<event_handler>
        self.openFolder(event)

    #paraview起動
    def onRunParaview(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runParaview(event)

    #閉じる
    def onClose(self, event):  # wxGlade: MyFrame.<event_handler>
        self.endingJob()
        self.Destroy()

# end of class MyFrame

    #  pasteFiles
    #    fileをペースト
    def pasteFiles(self):
        global clipBoard
        for fileName in clipBoard:
            copyName = fileName.split("/")[-1]
            No = 0
            pasteName = copyName[:-4] + "_copy" + str(No) + ".stl"
            same = 0
            for stlName in stlFiles:
                if stlName == pasteName:
                    same = 1
                    break
            while same == 1:
                same = 0
                No += 1
                pasteName = copyName[:-4] + "_copy" + str(No) + ".stl"
                for stlName in stlFiles:
                    if stlName == pasteName:
                        same = 1
                        break
            
            comm = "cp " + fileName + " " + stlDir + "/" + pasteName
            os.system(comm)
            self.setDataToListCtrl()
                    
    #  copyFiles
    #    fileをコピー
    def copyFiles(self):
        global clipBoard
        #選択fileを取得
        files = []
        row = 0
        for stl in stlFiles:
            if self.list_ctrl_1.IsSelected(row) == True:
                files.append(stl)
            row += 1
        #エラーチェック
        if len(files) == 0:
            title = _(u"エラー")
            mess = _(u"stlファイルを選択してください")
            self.errDialog(title, mess)
            return

        clipBoard = []
        for name in files:
            clipBoard.append(stlDir+"/"+name)

    #  deleteStlFile
    #    ファイルの削除
    def deleteStlFile(self):
        #選択fileを取得
        files = []
        row = 0
        for stl in stlFiles:
            if self.list_ctrl_1.IsSelected(row) == True:
                files.append(stl)
            row += 1
        #エラーチェック
        if len(files) == 0:
            title = _(u"エラー")
            mess = _(u"stlファイルを選択してください")
            self.errDialog(title, mess)
            return

        title = _(u"ファイルの削除")
        mess = _(u"選択したファイルをゴミ箱に移動します。")
        stat = self.okCancelDialog(title, mess)
        if stat == "OK":
            for name in files:
                delName = stlDir + "/" + name
                obj = gio.File(delName.encode("utf-8"))
                obj.trash()
            self.setDataToListCtrl()
        return

    #  runParaview
    #    paraview起動
    def runParaview(self, event):
        print _(u"paraviewを起動します。")
        comm = "cd " + stlDir + "; paraview &"
        pyTreeFoam.runOFUtility(comm)

    #  openStlFile
    #    stlファルを開く
    def openStlFile(self):
        #選択fileを取得
        files = []
        row = 0
        for stl in stlFiles:
            if self.list_ctrl_1.IsSelected(row) == True:
                files.append(stl)
            row += 1
        #エラーチェック
        if len(files) == 0:
            title = _(u"エラー")
            mess = _(u"stlファイルを選択してください")
            self.errDialog(title, mess)
            return
        for name in files:
            fileName = stlDir + "/" + name
            if isBinaryStl(fileName) == True:
                title = _(u"エラー")
                mess = _(u"binaryファイルが含まれています。\n")
                mess += _(u"ファイルが開けません。")
                self.errDialog(title, mess)
                return

        openFiles = ""
        for name in files:
            fileName = stlDir + "/" + name
            openFiles += fileName + " "
        pyTreeFoam.runEditor(openFiles)

    #  renameStlFile
    #    ファイル名変更
    def renameStlFile(self):
        #選択fileを取得
        files = []
        row = 0
        for stl in stlFiles:
            if self.list_ctrl_1.IsSelected(row) == True:
                files.append(stl)
            row += 1
        #エラーチェック
        if len(files) == 0:
            title = _(u"エラー")
            mess = _(u"stlファイルを選択してください")
            self.errDialog(title, mess)
            return
        if len(files) != 1:
            title = _(u"エラー")
            mess = _(u"stlファイルを選択してください")
            self.errDialog(title, mess)
            return

        newName = files[0]
        fileName = stlDir + "/" + newName
        inputTextDDialog.title = _(u"stlファイル名の変更")
        inputTextDDialog.message = _(u"新しいstlファイル名を入力してください")
        inputTextDDialog.inputText = newName
        dialog = inputTextDDialog.MyDialog(None)
        result = dialog.ShowModal()
        if inputTextDDialog.status == "OK":
            if files[0] == inputTextDDialog.inputText:
                return
            newName = inputTextDDialog.inputText
            newFileName = stlDir + "/" + newName
            comm = "mv " + fileName + " " + newFileName
            os.system(comm)
        else:
            return
        self.setDataToListCtrl()
        return

    #  openFolder
    #    folder開く
    def openFolder(self, event):
        pyTreeFoam.openFolderNautilus(stlDir)

    #  reverseSurface
    #    faceを反転させる
    def reverseSurface(self, event):
        #選択fileを取得
        files = []
        row = 0
        for stl in stlFiles:
            if self.list_ctrl_1.IsSelected(row) == True:
                files.append(stl)
            row += 1
        #エラーチェック
        if len(files) == 0:
            title = _(u"エラー")
            mess = _(u"stlファイルを選択してください")
            self.errDialog(title, mess)
            return

        newNames = []
        for name in files:
            fileName = stlDir + "/" + name
            comm = "reverseSurface.py " + fileName
            os.system(comm)
            newName = name[:-4] + "_rev.stl"
            newNames.append(newName)
        self.setAndSelectDataInListCtrl(newNames)
        print _(u"faceの向きを反転させました。")
        return


    #  deleteInnerName
    #    stlファイル内部のsolid名を削除する
    def deleteInnerName(self, event):
        #選択fileを取得
        files = []
        row = 0
        for stl in stlFiles:
            if self.list_ctrl_1.IsSelected(row) == True:
                files.append(stl)
            row += 1
        #エラーチェック
        if len(files) == 0:
            title = _(u"エラー")
            mess = _(u"stlファイルを選択してください")
            self.errDialog(title, mess)
            return

        for name in files:
            fileName = stlDir + "/" + name
            f=open(fileName); lines=f.readlines(); f.close()
            solidName = name[:-4]
            #header部取得
            i = 0
            while i < len(lines):
                if lines[i].split()[0] == "solid":
                    stLine = i
                    lines[i] = lines[i].split()[0] + " " + solidName + "\n"
                    break
                i += 1
            #footer部取得
            i = len(lines)-1
            while i > 0:
                if lines[i].split()[0] == "endsolid":
                    edLine = i
                    lines[i] = "endsolid " + solidName
                    break
                i -= 1
            #内部solid名削除
            newLines = lines[:stLine+1]
            i = stLine + 1
            while i < edLine:
                name = lines[i].split()[0]
                if name != "solid" and name != "endsolid":
                    newLines.append(lines[i])
                i += 1
            newLines.append(lines[edLine])
            f=open(fileName, "w")
            for line in newLines:
                f.write(line)
            f.close()
        self.setAndSelectDataInListCtrl(files)
        print _(u"内部solid名を削除しました。")
        return
        
    #  setSolidName
    #    file名をsolid名にセットする
    def setSolidName(self, event):
        #選択fileを取得
        files = []
        row = 0
        for stl in stlFiles:
            if self.list_ctrl_1.IsSelected(row) == True:
                files.append(stl)
            row += 1
        #エラーチェック
        if len(files) == 0:
            title = _(u"エラー")
            mess = _(u"stlファイルを選択してください")
            self.errDialog(title, mess)
            return

        #solid名セット
        for stlName in files:
            flag = 0
            fileName = stlDir + "/" + stlName
            name = stlName[:-4]
            f=open(fileName); lines=f.readlines(); f.close()
            words = lines[0].split()
            oldName = ""
            if len(words) > 1:
                oldName = words[1]
            lines[0] = " ".join([words[0], name]) + "\n"
            i = len(lines) - 1
            while i > 0:
                words = lines[i].split()
                if words[0] == "endsolid":
                    endName = ""
                    if len(words) > 1:
                        endName = words[1]
                    break
                i -= 1
            if oldName != endName:
                flag += 1
            else:
                lines[i] = " ".join([words[0], name]) + "\n"
                f=open(fileName, "w")
                for line in lines:
                    f.write(line)
                f.close()
        self.setAndSelectDataInListCtrl(files)
        if flag == 0:
            print _(u"solid名をセットしました。")
        else:
            title = _(u"エラー")
            mess = _(u"solid名がセットできないファイルがあります。")
            mess += _(u"\nstlファイルの書式を確認してください。")
            self.errDialog(title, mess)
        return


    #  mergeStlFile
    #    stlFileを結合する
    def mergeStlFile(self, event):
        #選択fileを取得
        files = []
        row = 0
        for stl in stlFiles:
            if self.list_ctrl_1.IsSelected(row) == True:
                files.append(stl)
            row += 1
        #エラーチェック
        if len(files) == 0:
            title = _(u"エラー")
            mess = _(u"stlファイルを選択してください")
            self.errDialog(title, mess)
            return

        solids = []
        for stlFile in files:
            names = getSolidNames(stlDir, stlFile)
            solids += names
        flag = 0
        solids.sort()
        oldName = ""
        for solid in solids:
            if len(solid.split()) == 0:
                flag = 1
                break
            elif oldName == solid:
                flag = 2
                break
            oldName = solid
        if flag == 1:
            title = _(u"エラー")
            mess = _(u"solid名が設定されていないファイルがあります")
            mess += _(u"\nstlファイルが結合できません")
            self.errDialog(title, mess)
            return
        if flag == 2:
            title = _(u"エラー")
            mess = _(u"同じsolid名が使われているファイルがあります。")
            mess += _(u"\nstlファイルが結合できません")
            self.errDialog(title, mess)
            return

        #defaultのnewStl名を設定
        stlNums = []
        for stl in stlFiles:
            if stl[:7] == "newStl_":
                try:
                    name = stl.split(".")[0]
                    num = int(name[7:])
                    stlNums.append(num)
                except:
                    pass
        if len(stlNums) == 0:
            stlNo = 0
        else:
            stlNums.sort()
            stlNo = stlNums[-1] + 1
        newName = "newStl_" + str(stlNo) + ".stl"
        #newStl名を取得
        loop = "yes"
        stat = "ok"
        while loop == "yes":
            inputTextDDialog.title = _(u"stlファイルの結合")
            inputTextDDialog.message = _(u"新しいstlファイル名を入力してください")
            inputTextDDialog.inputText = newName
            dialog = inputTextDDialog.MyDialog(None)
            result = dialog.ShowModal()
            if inputTextDDialog.status != "OK":
                loop = "no"
                stat = "cancel"
            else:
                newName = inputTextDDialog.inputText
                if newName.split(".")[-1] != "stl":
                    title = _(u"エラー")
                    mess = _(u"ファイル名の拡張子を「stl」に設定してください。")
                    self.errDialog(title, mess)
                else:
                    loop = "no"
                    stat = "ok"
                for stl in stlFiles:
                    if stl == newName:
                        title = _(u"エラー")
                        mess = _(u"同じファイル名が存在します。")
                        mess += _(u"\nファイル名を変更してください。")
                        self.errDialog(title, mess)
                        loop = "yes"
                        break
        if stat != "ok":
            return
        writeName = stlDir + "/" + newName
        #stlFileを結合
        for stl in files:
            readName = stlDir + "/" + stl
            f=open(readName); cont=f.read(); f.close()
            if cont[-1] != "\n":
                cont += "\n"
            fa=open(writeName, "a"); fa.write(cont); fa.close()
        title = _(u"stlファイルの結合")
        mess = _(u"stlファイルを結合しました。")
        self.okDialog(title, mess)
        #listBoxに反映
        self.setAndSelectDataInListCtrl([newName])
        print _(u"stlファイルを結合しました。")
        return

    #  binToAscii
    #    fileFormatをbin→asciiに変換
    def binToAscii(self, event):
        global stlDir, stlFiles, stlSize
        #選択fileを取得
        files = []
        row = 0
        for stl in stlFiles:
            if self.list_ctrl_1.IsSelected(row) == True:
                files.append(stl)
                #solidName = solidNames[row]
            row += 1
        #エラーチェック
        if len(files) == 0:
            title = _(u"エラー")
            mess = _(u"stlファイルを選択してください")
            self.errDialog(title, mess)
            return

        #倍率を変更
        for name in files:
            fileName = stlDir + "/" + name
            comm = "surfaceTransformPoints -scale '(1.0 1.0 1.0)' " + fileName + " " + fileName
            #os.system(comm)
            pyTreeFoam.runOFUtility(comm)
        #fileをtriSurfaceにコピー
        copyFileToTriSurface(caseDir, stlDir, files)
        #listBoxに反映
        self.setAndSelectDataInListCtrl(files)
        print _(u"binaryをasciiに変換しました。")


    #  changeScale
    #    scaleの変更
    def changeScale(self, event):
        global stlDir, stlFiles, stlSize
        #選択fileを取得
        files = []
        row = 0
        for stl in stlFiles:
            if self.list_ctrl_1.IsSelected(row) == True:
                files.append(stl)
                #solidName = solidNames[row]
            row += 1
        #エラーチェック
        if len(files) == 0:
            title = _(u"エラー")
            mess = _(u"stlファイルを選択してください")
            self.errDialog(title, mess)
            return

        #変更する倍率を取得
        inputTextDDialog.title = _(u"倍率の入力")
        inputTextDDialog.message = _(u"変更する倍率を入力してください")
        inputTextDDialog.inputText = "1.0"
        dialog = inputTextDDialog.MyDialog(None)
        result = dialog.ShowModal()
        if inputTextDDialog.status == "OK":
            scale = inputTextDDialog.inputText
        else:
            return

        #倍率を変更
        for name in files:
            fileName = stlDir + "/" + name
            comm = "surfaceTransformPoints -scale '(" + scale + " " + scale + " " + scale + ")' " + fileName + " " + fileName
            #os.system(comm)
            pyTreeFoam.runOFUtility(comm)
        #fileをtriSurfaceにコピー
        copyFileToTriSurface(caseDir, stlDir, files)
        #listBoxに反映
        self.setAndSelectDataInListCtrl(files)
        print _(u"scaleを変更しました。"), " x", scale


    #  changeSolidName
    #    solidNameの変更
    def changeSolidName(self, event):
        global stlDir, stlFiles, solidNames
        #選択fileを取得
        files = []
        row = 0
        for stl in stlFiles:
            if self.list_ctrl_1.IsSelected(row) == True:
                files.append(stl)
                solidName = solidNames[row]
            row += 1
        #エラーチェック
        if len(files) == 0:
            title = _(u"エラー")
            mess = _(u"stlファイルを選択してください")
            self.errDialog(title, mess)
            return
        if len(files) != 1:
            title = _(u"エラー")
            mess = _(u"複数のstlファイルを選択しています。")
            mess += _(u"\n1ヶのstlファイルを選択してください。")
            self.errDialog(title, mess)
            return

        #変更するsolidNameを取得
        inputTextDDialog.title = _(u"solid名の入力")
        inputTextDDialog.message = _(u"新しいsolid名を入力してください")
        inputTextDDialog.inputText = solidName
        dialog = inputTextDDialog.MyDialog(None)
        result = dialog.ShowModal()
        if inputTextDDialog.status == "OK":
            newName = inputTextDDialog.inputText
        else:
            return

        #solid名を変更
        oldName = " ".join(solidName.split())
        changeFlag = 0
        for stl in files:
            fileName = stlDir + "/" + stl
            #fileFormatをチェック
            if isBinaryStl(fileName) == False:
                #asciiの場合
                f=open(fileName); lines=f.readlines(); f.close()
                i = 0
                for line in lines:
                    if line[:5] == "solid":
                        if " ".join(line.split()[1:]) == oldName:
                            lines[i] = "solid " + newName + "\n"
                            changeFlag += 1
                    if line[:8] == "endsolid":
                        if changeFlag == 1:
                            lines[i] = "endsolid " + newName + "\n"
                            changeFlag += 1
                    i += 1
                if changeFlag == 2:
                    f=open(fileName, "w")
                    for line in lines:
                        f.write(line)
                    f.close()
                    print _(u"solid名を変更しました。"), solidName, "->", newName
                else:
                    title = _(u"エラー")
                    mess = _(u"solid名が変更できませんでした。")
                    mess += _(u"\nstlファイルの書式を確認してください。")
                    self.errDialog(title, mess)
            else:
                #binaryの場合
                f=open(fileName, "rb"); cont=f.read(); f.close()
                header = newName.encode("utf-8") + "\00"*(80-len(newName))
                cont = header + cont[80:]
                f=open(fileName, "w"); f.write(cont); f.close()
                print _(u"solid名を変更しました。"), solidName, "->", newName
        #fileをtriSurfaceにコピー
        copyFileToTriSurface(caseDir, stlDir, files)
        #listBoxに反映
        self.setAndSelectDataInListCtrl(files)

    #
    #  setAndSelectDataInListCtrl
    #    list_ctrlにデータセットし、selectItemを復活させる
    def setAndSelectDataInListCtrl(self, selItems):
        global stlFiles, solidNames, stlSize
        self.setDataToListCtrl()
        i = 0
        for stl in stlFiles:
            for selItem in selItems:
                if stl == selItem:
                    self.list_ctrl_1.Select(i, True)
                    self.list_ctrl_1.Focus(i)
                    break
            i += 1

    #
    #  setDataToListCtrl
    #    list_ctrlにデータセット
    def setDataToListCtrl(self):
        global stlFiles, solidNames, stlSize
        [stlFiles, fileFmt, solidNames, stlSize] = getStlFiles(stlDir)
        self.list_ctrl_1.DeleteAllItems()
        i = 0
        for stl in stlFiles:
            self.list_ctrl_1.InsertStringItem(i, stl)
            self.list_ctrl_1.SetStringItem(i, 1, fileFmt[i])
            self.list_ctrl_1.SetStringItem(i, 2, solidNames[i])
            size = stlSize[i]
            if size == [0.0, 0.0, 0.0]:
                 sizeStr = ""
            else:
                sizeStr = " ".join([str(size[0]), str(size[1]), str(size[2])])
            self.list_ctrl_1.SetStringItem(i, 3, sizeStr)
            i += 1

    #
    #  endingJob
    #    終了処理
    def endingJob(self):
        winSize = self.GetSize()
        colWidth = [self.list_ctrl_1.GetColumnWidth(0),
                    self.list_ctrl_1.GetColumnWidth(1),
                    self.list_ctrl_1.GetColumnWidth(2)]
        writeWinSize(winSize, colWidth)

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        stat = ""
        if ans == wx.ID_OK:
            stat = "OK"
        else:
            stat = "CANCEL"
        return stat



#  getSolidNames
#    stlファイルからsolid名を取得
def getSolidNames(stlDir, stlFile):
    names = []
    fileName = stlDir + "/" + stlFile
    f=open(fileName); lines=f.readlines(); f.close()
    for line in lines:
        if line[:5] == "solid":
            name = " ".join(line.split()[1:])
            names.append(name)
    return names

#
#  copyFileToTriSurface
#    fileをコピー
def copyFileToTriSurface(caseDir, stlDir, files):
    folder = caseDir + "/constant/triSurface"
    if len(glob.glob(folder)) == 0:
        comm = "mkdir " + folder
        os.system(comm)
    for name in files:
        comm = "cp " + stlDir + "/" + name + " " + folder + "/" + name
        os.system(comm)

#
#  getStlFiles
#    stlファイルのデータ取得
def getStlFiles(stlDir):
    fileFmt = []
    stlFiles = []
    solidNames = []
    stlSize = []
    files = glob.glob(stlDir+"/*.stl")
    files.sort()
    for fileName in files:
        #f=open(fileName); cont=f.read(80); f.close()
        if isBinaryStl(fileName) == False:
            fileFmt.append("ascii")
            [solidName, xVals, yVals, zVals] = getAsciiSolidNameStlSize(fileName)
        else:
            fileFmt.append("bin")
            [solidName, xVals, yVals, zVals] = getBinSolidNameStlSize(fileName)
        solidNames.append(solidName)
        if len(xVals) != 0:
            minx = min(xVals); maxx = max(xVals)
            miny = min(yVals); maxy = max(yVals)
            minz = min(zVals); maxz = max(zVals)
        else:
            minx=0.0; maxx=0.0
            miny=0.0; maxy=0.0
            minz=0.0; maxz=0.0
        dx = maxx - minx
        dy = maxy - miny
        dz = maxz - minz
        dx = getValueLog10(dx)
        dy = getValueLog10(dy)
        dz = getValueLog10(dz)
        stlSize.append([dx, dy, dz])
        #stlFiles取得
        stlFileName = fileName.split("/")[-1]
        stlFiles.append(stlFileName)
    return [stlFiles, fileFmt, solidNames, stlSize]

#  isBinaryStl
#    binaryファイルかどうかチェック
#    header(80byte)を除いた9文字をチェック
def isBinaryStl(fileName):
    f=open(fileName); cont=f.read(100); f.close()
    if len(cont) <100:
        return False

    ans = False
    i = 81
    while i<90:
        if ((" " <= cont[i] and cont[i] <= "z") or 
            cont[i] == "\n" or cont[i] == "\r" or cont[i] == "\t"):
            pass
        else:
            ans = True
            break
        i += 1
    return ans 

#  getAsciiSolidNameStlSize
#    asciiのstlファイルからsolidName、stlSizeを取得
def getAsciiSolidNameStlSize(fileName):
    f=open(fileName); lines=f.readlines(); f.close()
    #solidName取得
    names = []
    for line in lines:
        if line[:5] == "solid":
            name = " ".join(line.split()[1:])
            names.append(name)
    solidName = ",".join(names)
    #stlSize取得
    xValues=[]; yValues=[]; zValues=[]
    for line in lines:
        if line.find("vertex") >= 0:
            values = line.split()
            xValues.append(float(values[1]))
            yValues.append(float(values[2]))
            zValues.append(float(values[3]))
    return [solidName, xValues, yValues, zValues]    

#  getBinSolidNameStlSize
#    binaryのstlファイルからsolidName、stlSizeを取得
def getBinSolidNameStlSize(fileName):
    f=open(fileName, "rb"); cont=f.read(); f.close()
    #header部を取得
    i = 80
    header = cont[:i]
    #solidNameを取得
    solidName = ""
    for chara in header:
        if " " <= chara and chara <= "z":
            solidName += chara
        else:
            break
    #三角形の数
    num = struct.unpack("1i", cont[i:i+4])
    nTet = num[0]
    i += 4
    #座標を取得
    xVal=[]; yVal=[]; zVal=[]
    while i<len(cont):
        num = struct.unpack("12f", cont[i:i+48])
        #単位ベクトルはスキップ
        xVal += [num[3]] + [num[6]] + [num[9]]
        yVal += [num[4]] + [num[7]] + [num[10]]
        zVal += [num[5]] + [num[8]] + [num[11]]
        #最後の2byte分も加えてスキップ
        i += 48 + 2
    return [solidName, xVal, yVal, zVal]

#  getValueLog10
#    値を2桁に丸める
def getValueLog10(x):
    if x<=0.0:
        return 0.0
    lx = math.log10(x)
    if lx>0.0:
        llx = 10**float(int(lx) - 1)
    else:
        llx = 10**float(int(lx) - 2)
    xx = int(x/llx + 0.5) * llx
    return xx

#  readWinSize
#    winSizeの読み込み
def readWinSize():
    global winSize, colWidth
    #fileName = os.environ["TreeFoamPath"] + "/data/winSize"
    fileName = os.environ["TreeFoamUserPath"] + "/data/winSize"
    f=open(fileName); lines=f.readlines(); f.close()
    i = 0
    flagWinSize = 0
    flagWidth = 0
    for line in lines:
        words = line.split()
        if words[0] == "editStlFiles":
            winSize = (int(words[1]), int(words[2]))
            flagWinSize = 1
        elif words[0] == "editStlFiles_colWidth":
            a = int(words[1])
            b = int(words[2])
            c = int(words[3])
            colWidth = [a, b, c]
            flagWidth = 1
        if flagWinSize == 1 and flagWidth == 1:
            break
    return [winSize, colWidth]        
               
    

#  writeWinsize
#    winSizeの書き込み
def writeWinSize(winSize, colWidth):
    #fileName = os.environ["TreeFoamPath"] + "/data/winSize"
    fileName = os.environ["TreeFoamUserPath"] + "/data/winSize"
    f=open(fileName); lines=f.readlines(); f.close()
    if lines[-1][-1] != "\n":
        lines[-1] += "\n"
    i = 0
    flagWinSize = 0
    flagWidth = 0
    for line in lines:
        words = line.split()
        if words[0] == "editStlFiles":
            words[1] = str(winSize[0])
            words[2] = str(winSize[1])
            lines[i] = ("editStlFiles " + words[1] + " " + 
                        words[2] + "\n")
            flagWinSize = 1
        elif words[0] == "editStlFiles_colWidth":
            words[1] = str(colWidth[0])
            words[2] = str(colWidth[1])
            words[3] = str(colWidth[2])
            lines[i] = ("editStlFiles_colWidth " + str(colWidth[0]) + " " +
                        str(colWidth[1]) + " " + str(colWidth[2]) + "\n")
            flagWidth = 1
        if flagWinSize == 1 and flagWidth == 1:
            break
        i += 1
    if flagWinSize == 0:
        addLine = "editStlFiles " + str(winSize[0]) + " " + str(winSize[1]) + "\n"
        lines.append(addLine)
    if flagWidth == 0:
        addLine = ("editStlFiles_colWidth " + str(colWidth[0]) + " " +
                    str(colWidth[1]) + " " + str(colWidth[2]) + "\n")
        lines.append(addLine)
    f=open(fileName, "w")
    for line in lines:
        f.write(line)
    f.close()



if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    caseDir = sys.argv[1]
    stlDir = sys.argv[2]

    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
