#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   fileOperationInProcessorDialog.py
#
#       並列計算時のprocessor*フォルダ内のファイル操作（コピー、削除）
#
#   12/11/24    新規作成
#      12/02    processor数を表示
#   13/01/08    ボタン形状変更
#      01/29    数字ﾌｫﾙﾀﾞをsortするように修正
#      02/04    バグ修正（processor内のfaile削除時、ｴﾗｰmsg出ていた）
#      06/07    file表示で日本語可能に修正(日本語でｴﾗｰ発生していた）
#      10/15    国際化のため、修正
#      12/21    stdout、stderrの設定（import logFileCreater）を追加
#   15/07/17    dialogの起動方法を修正
#

# generated by wxGlade 0.6.3 on Sat Nov 24 15:38:14 2012

import wx
import sys
import os
import glob
import gio
import shutil
import pyTreeFoam

import logFileCreater; logFileCreater.log()


caseDir = ""
caseFF = []
processorFF = []
charaFolder = ""      #folder識別（1文字）
charaFile = ""        #fileの識別（1文字）
charaCase = ""        #caseの識別（1文字）


# begin wxGlade: extracode
# end wxGlade


def Show(wdir):
    global caseDir
    caseDir = wdir
    initialize()
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, -1, _(u"processorフォルダ内の操作"))
        self.static_line_1 = wx.StaticLine(self, -1)
        self.label_4 = wx.StaticText(self, -1, _(u"folderまたはfileを選択して、コピー、削除します。"))
        self.label_5 = wx.StaticText(self, -1, _(u"processor数: 2 ヶ"))
        self.list_box_1 = wx.ListBox(self, -1, choices=[], style=wx.LB_MULTIPLE)
        self.sizer_3_staticbox = wx.StaticBox(self, -1, _(u"caseフォルダ"))
        self.button_3 = wx.Button(self, -1, _(">>\ncopy"))
        self.list_box_2 = wx.ListBox(self, -1, choices=[], style=wx.LB_MULTIPLE)
        self.sizer_4_staticbox = wx.StaticBox(self, -1, _(u"processorフォルダ"))
        self.button_2 = wx.Button(self, -1, _(u"case内から削除"))
        self.label_2 = wx.StaticText(self, -1, _(u"選択したfolder, fileを削除"))
        self.button_4 = wx.Button(self, -1, _(u"processor内から削除"))
        self.label_3 = wx.StaticText(self, -1, _(u"選択したfolder, fileを削除"))
        self.static_line_2 = wx.StaticLine(self, -1)
        self.button_1 = wx.Button(self, -1, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onCopyToProcessor, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onDeleteFromCase, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onDeleteFromProcessor, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_1)
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_(u"processor内の操作"))
        self.list_box_1.SetMinSize((175, 150))
        self.button_3.SetMinSize((50, 48))
        self.list_box_2.SetMinSize((175, 150))
        self.button_2.SetMinSize((200, 30))
        self.button_4.SetMinSize((200, 30))
        # end wxGlade
        self.setNameInListBox()
        self.setNProcInLabel()

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.VERTICAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_12 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_14 = wx.BoxSizer(wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.VERTICAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_4_staticbox.Lower()
        sizer_4 = wx.StaticBoxSizer(self.sizer_4_staticbox, wx.VERTICAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_3_staticbox.Lower()
        sizer_3 = wx.StaticBoxSizer(self.sizer_3_staticbox, wx.VERTICAL)
        sizer_7 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_9 = wx.BoxSizer(wx.VERTICAL)
        sizer_10 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_11 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.label_1, 0, wx.TOP | wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_1.Add(self.static_line_1, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 10)
        sizer_1.Add((20, 10), 0, 0, 0)
        sizer_1.Add(self.label_4, 0, wx.LEFT, 50)
        sizer_10.Add((100, 20), 0, 0, 0)
        sizer_11.Add(self.label_5, 0, wx.TOP, 5)
        sizer_10.Add(sizer_11, 1, wx.EXPAND, 0)
        sizer_9.Add(sizer_10, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_9, 0, wx.EXPAND, 0)
        sizer_2.Add((10, 20), 0, 0, 0)
        sizer_7.Add(self.list_box_1, 1, wx.ALL | wx.EXPAND | wx.FIXED_MINSIZE, 5)
        sizer_3.Add(sizer_7, 1, wx.EXPAND, 0)
        sizer_2.Add(sizer_3, 1, wx.ALL | wx.EXPAND, 5)
        sizer_2.Add(self.button_3, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_8.Add(self.list_box_2, 1, wx.ALL | wx.EXPAND, 5)
        sizer_4.Add(sizer_8, 1, wx.EXPAND, 0)
        sizer_2.Add(sizer_4, 1, wx.ALL | wx.EXPAND, 5)
        sizer_2.Add((10, 20), 0, 0, 0)
        sizer_1.Add(sizer_2, 1, wx.EXPAND, 0)
        sizer_12.Add((10, 20), 0, 0, 0)
        sizer_13.Add(self.button_2, 0, wx.LEFT | wx.RIGHT | wx.TOP, 5)
        sizer_13.Add(self.label_2, 0, wx.LEFT, 10)
        sizer_12.Add(sizer_13, 1, wx.EXPAND, 0)
        sizer_12.Add((50, 20), 0, 0, 0)
        sizer_14.Add(self.button_4, 0, wx.LEFT | wx.RIGHT | wx.TOP, 5)
        sizer_14.Add(self.label_3, 0, wx.LEFT, 10)
        sizer_12.Add(sizer_14, 1, wx.EXPAND, 0)
        sizer_12.Add((10, 20), 0, 0, 0)
        sizer_1.Add(sizer_12, 0, wx.EXPAND, 0)
        sizer_5.Add(self.static_line_2, 0, wx.LEFT | wx.RIGHT | wx.TOP | wx.EXPAND, 10)
        sizer_6.Add(self.button_1, 0, wx.ALL | wx.ALIGN_RIGHT, 10)
        sizer_5.Add(sizer_6, 0, wx.ALIGN_RIGHT, 0)
        sizer_1.Add(sizer_5, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    def onCopyToProcessor(self, event): # wxGlade: MyFrame.<event_handler>
        self.copyToProcessor()
        event.Skip()

    def onDeleteFromProcessor(self, event): # wxGlade: MyFrame.<event_handler>
        self.deleteFromProcessor()
        event.Skip()

    def onDeleteFromCase(self, event):  # wxGlade: MyFrame.<event_handler>
        self.deleteFromCase()
        event.Skip()

    def onClose(self, event): # wxGlade: MyFrame.<event_handler>
        self.Destroy()


    #  setNProcInLabel
    #    processor数をセット
    def setNProcInLabel(self):
        global caseDir
        nProc = len(glob.glob(caseDir + "/processor*"))
        text = _(u"prosessor数: ") + str(nProc) + _(u" ヶ")
        self.label_5.SetLabel(text)

    #  setNameInListBox
    #    listBox内にfolder, fileをセット
    def setNameInListBox(self):
        global caseFF, processorFF
        self.list_box_1.Clear()
        self.list_box_1.AppendItems(caseFF)
        self.list_box_2.Clear()
        self.list_box_2.AppendItems(processorFF)

    #  deleteFromProcessor
    #    processor*から削除
    def deleteFromProcessor(self):
        global caseDir, processorFF, charaFolder, charaFile
        delNo = self.list_box_2.GetSelections()
        title = _(u"folder, fileの削除")
        mess = str(len(delNo)) + _(u"ヶの file or folder が選択されています。\n")
        mess += _(u"  これらの file or folder を全processorから削除します。")
        ans = self.okCancelDialog(title, mess)
        if ans != "OK":
            return

        delNames = []
        for num in delNo:
            delName = processorFF[num]
            delNames.append(delName[1:])
        processors = glob.glob(caseDir + "/processor*")
        processors.sort()
        flag = 0
        for processor in processors:
            for delName in delNames:
                name = processor + "/" + delName
                try:
                    comm = "rm -rf " + name
                    os.system(comm)
                    """
                    obj = gio.File(name.encode("utf-8"))
                    obj.trash()
                    """
                    print name + _(u" を削除。")
                except:
                    mess = name + _(u" が削除できませんでした。")
                    print mess
                    flag += 1
        if flag != 0:
            mess = _(u"「") + str(flag) + _(u"」ヶのファイルが削除できていません\n")
            mess += _(u"　　logを確認してください。")
            self.errDialog(title, mess)
        initialize()
        self.setNameInListBox()

    #  deleteFromCase
    #    caseフォルダ内から削除
    def deleteFromCase(self):
        global caseDir, caseFF, charaFolder, charaFile
        delNo = self.list_box_1.GetSelections()
        title = _(u"folder, fileの削除")
        mess = str(len(delNo)) + _(u"ヶの file or folder が選択されています。\n")
        mess += _(u"  これらの file or folder をゴミ箱に移動します。")
        ans = self.okCancelDialog(title, mess)
        if ans != "OK":
            return
        delNames = []
        for num in delNo:
            delName = caseFF[num]
            delNames.append(delName[1:])
        flag = 0
        for delName in delNames:
            name = caseDir + "/" + delName
            try:
                obj = gio.File(name.encode("utf-8"))
                obj.trash()
                print name + _(u" を削除。")
            except:
                mess = name + _(u" が削除できませんでした。\n")
                print mess
                flag += 1
        if flag != 0:
            mess = _(u"「") + str(flag) + _(u"」ヶのファイルが削除できていません。")
            mess += _(u"　　logを確認してください。")
            self.errDialog(title, mess)
        initialize()
        self.setNameInListBox()

    #  copyToProcessor
    #    各processor*にファイルをコピーする
    def copyToProcessor(self):
        global caseDir
        copyNo = self.list_box_1.GetSelections()
        copyFolders = []
        copyFiles = []
        for num in copyNo:
            name = caseFF[num]
            if name[0] == charaFolder:
                copyFolders.append(name[1:])
            if name[0] == charaFile:
                copyFiles.append(name[1:])
        #processor取得
        processors = glob.glob(caseDir + "/processor*")
        processors.sort()
        #folder copy
        for copyFolder in copyFolders:
            copyName = caseDir + "/" + copyFolder
            for processor in processors:
                src = copyName
                dst = processor + "/" + copyName.split("/")[-1]
                print src + " " + processor
                shutil.copytree(src, dst)
        #file copy
        for copyFile in copyFiles:
            copyName = caseDir + "/" + copyFile
            for processor in processors:
                comm = "cp " + copyName + " " + processor
                print comm
                os.system(comm)
        initialize()
        self.setNameInListBox()

    #--------------------
    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        stat = ""
        if ans == wx.ID_OK:
            #dlg.Destroy()
            stat = "OK"
            #return "OK"
        else:
            #dlg.Destroy()
            stat = "CANCEL"
            #return "CANCEL"
        return stat

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()


# end of class MyFrame


#
#  initialize
#    初期化
def initialize():
    global caseDir, caseFF, processorFF, charaFolder, charaFile, charaCase
    #変数を設定
    charaFolder = _(u"◇")       #folder識別（1文字）
    charaFile = _(u"　")         #fileの識別（1文字）
    charaCase = _(u"▽")         #caseの識別（1文字）
    #caseDirのfolder, fileを取得
    [folders, files] = pyTreeFoam.getFoldersFiles(caseDir)
    folders = sortNumFolders(folders)
    caseFF = []
    for folder in folders:
        if (folder != "system" and folder != "constant"
            and folder[:len("processor")] != "processor"):
            folderType = pyTreeFoam.checkFolder(caseDir + "/" + folder)
            if folderType == "case":
                caseFF.append(charaCase + folder)
            else:
                caseFF.append(charaFolder + folder)
    for name in files:
        if name[0] != "." and name[-1] != "~":
            caseFF.append(charaFile + name.decode("utf-8"))
    #processorのfolder, fileを取得
    processorFF = []
    procDir = caseDir + "/processor0"
    if len(glob.glob(procDir)) == 1:
        [folders, files] = pyTreeFoam.getFoldersFiles(procDir)
        folders = sortNumFolders(folders)
        for folder in folders:
            processorFF.append(charaFolder + folder)
        for name in files:
            if name[0] != "." and name[-1] != "~":
                processorFF.append(charaFile + name)


#  sortNumFolders
#    数字folderをsortする。
def sortNumFolders(folders):
    num = []
    string = []
    for folder in folders:
        try:
            a = float(folder)
            num.append([a,folder])
        except:
            string.append(folder)
    num.sort()
    string.sort()
    ans = []
    for numFolder in num:
        ans.append(numFolder[1])
    for folder in string:
        ans.append(folder)
    return ans

if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    caseDir = sys.argv[1]
    initialize()
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
