#!/usr/bin/env python
# -*- coding: UTF-8 -*-
#
#       focusJobControlDialog.py
#
#       FOCUSのJob管理用
#       JobFileの選択、作成、投入。slurmコマンドは自動作成される。
#
#   16/10/20    新規作成
#      10/28    「#sbatch」を大文字「#SBATCH」に変更。logファイルが設定されないため。
#               「#SBATCH -J」の場所を変更。jib名をjobFile名と同じ設定に修正。
#      11/06    caseDirを引数から取得する様に修正。
#      12/05    runJob:submit時にjobIdファイル作成を追加
#               setQueueCpu:logFile名をfocus_data内データから設定
#      12/10    showLog、getLogFile追加。tail-fコマンドでlogを表示。
#   17/01/15    plotWatcherを追加
#      02/26    「nCPUs」→「nPs」に修正。
#
#
# generated by wxGlade 0.6.7+ on Sun Oct 23 10:54:16 2016
#

import wx
import os
import sys
import glob
import time
import pyTreeFoam
import getFoamContents
import getOpenFileDDialog


# begin wxGlade: dependencies
import gettext
# end wxGlade

# begin wxGlade: extracode
# end wxGlade

caseDir = ""
jobFile = ""
queue = ""
nCpu = ""
nNode = ""
queueNames = []         #queue名のlist


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, wx.ID_ANY, _(u"FOCUS Job管理"))
        self.label_13 = wx.StaticText(self, wx.ID_ANY, _(u"Jobファイルを選択、作成して、Jobを投入する。\nsbatchオプション（キュー名、プロセス数等）は、右画面上で、再設定できる。"))
        self.label_10 = wx.StaticText(self, wx.ID_ANY, _(u"Job File名"))
        self.text_ctrl_4 = wx.TextCtrl(self, wx.ID_ANY, "")
        self.button_5 = wx.Button(self, wx.ID_ANY, _(u"参照..."))
        self.button_6 = wx.Button(self, wx.ID_ANY, _(u"Job編集"))
        self.static_line_2 = wx.StaticLine(self, wx.ID_ANY, style=wx.LI_VERTICAL)
        self.panel_3 = wx.Panel(self, wx.ID_ANY)
        self.label_5 = wx.StaticText(self.panel_3, wx.ID_ANY, _(u"キュー:"))
        self.combo_box_1 = wx.ComboBox(self.panel_3, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.panel_1 = wx.Panel(self, wx.ID_ANY)
        self.label_11 = wx.StaticText(self.panel_1, wx.ID_ANY, _("nPs:"))
        self.text_ctrl_1 = wx.TextCtrl(self.panel_1, wx.ID_ANY, "")
        self.label_12 = wx.StaticText(self.panel_1, wx.ID_ANY, _("nNodes:"))
        self.text_ctrl_5 = wx.TextCtrl(self.panel_1, wx.ID_ANY, "")
        self.button_7 = wx.Button(self, wx.ID_ANY, _(u"設定file編集"))
        self.button_8 = wx.Button(self, wx.ID_ANY, _(u"設定"))
        self.button_9 = wx.Button(self, wx.ID_ANY, _(u"Job投入実行..."))
        self.static_line_1 = wx.StaticLine(self, wx.ID_ANY)
        self.label_6 = wx.StaticText(self, wx.ID_ANY, _(u"ノードの状況確認"))
        self.button_10 = wx.Button(self, wx.ID_ANY, _("freenodes"))
        self.button_11 = wx.Button(self, wx.ID_ANY, _("squeues"))
        self.button_12 = wx.Button(self, wx.ID_ANY, _("sinfo"))
        self.label_7 = wx.StaticText(self, wx.ID_ANY, _(u"その他コマンド"))
        self.text_ctrl_2 = wx.TextCtrl(self, wx.ID_ANY, "")
        self.button_13 = wx.Button(self, wx.ID_ANY, _("run"))
        self.text_ctrl_3 = wx.TextCtrl(self, wx.ID_ANY, "", style=wx.TE_MULTILINE)
        self.sizer_3_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"Job投入"))
        self.label_3 = wx.StaticText(self, wx.ID_ANY, "")
        self.label_8 = wx.StaticText(self, wx.ID_ANY, _(u"投入Job読込・表示"))
        self.button_14 = wx.Button(self, wx.ID_ANY, _("squeue"))
        self.label_4 = wx.StaticText(self, wx.ID_ANY, _(u"Jobを選択後、クリック"))
        self.label_14 = wx.StaticText(self, wx.ID_ANY, _(u"log表示"))
        self.button_4 = wx.Button(self, wx.ID_ANY, _("tail -f"))
        self.label_15 = wx.StaticText(self, wx.ID_ANY, _(u" 残渣の表示"))
        self.button_16 = wx.Button(self, wx.ID_ANY, _("plotWatcher"))
        self.label_9 = wx.StaticText(self, wx.ID_ANY, _(u"Job停止"))
        self.button_15 = wx.Button(self, wx.ID_ANY, _("scancel"))
        self.label_2 = wx.StaticText(self, wx.ID_ANY, _("label_2"))
        self.list_box_1 = wx.ListBox(self, wx.ID_ANY, choices=[])
        self.sizer_4_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"Job実行状況の確認"))
        self.button_2 = wx.Button(self, wx.ID_ANY, _(u"folder開く"))
        self.button_3 = wx.Button(self, wx.ID_ANY, _(u"login端末起動"))
        self.button_1 = wx.Button(self, wx.ID_ANY, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onSelectJob, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.onEditJob, self.button_6)
        self.Bind(wx.EVT_BUTTON, self.onEditSettingFile, self.button_7)
        self.Bind(wx.EVT_BUTTON, self.onSetQueueCpu, self.button_8)
        self.Bind(wx.EVT_BUTTON, self.onRunJob, self.button_9)
        self.Bind(wx.EVT_BUTTON, self.onFreenodes, self.button_10)
        self.Bind(wx.EVT_BUTTON, self.onSqueues, self.button_11)
        self.Bind(wx.EVT_BUTTON, self.onSinfo, self.button_12)
        self.Bind(wx.EVT_BUTTON, self.onRunCommand, self.button_13)
        self.Bind(wx.EVT_BUTTON, self.onSqueue, self.button_14)
        self.Bind(wx.EVT_BUTTON, self.onShowLog, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onPlotWatcher, self.button_16)
        self.Bind(wx.EVT_BUTTON, self.onScancel, self.button_15)
        self.Bind(wx.EVT_BUTTON, self.onOpenFolder, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onRunTerminal, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_1)
        # end wxGlade

        self.Bind(wx.EVT_TEXT, self.onSetJobFile, self.text_ctrl_4)
        self.text_ctrl_2.Bind(wx.EVT_KEY_DOWN, self.onKey)
        self.setComboBox()
        self.hideSbatchOption()
        self.setSqueueLabe()

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_("frame_1"))
        self.text_ctrl_4.SetMinSize((150, 28))
        self.button_5.SetMinSize((50, 30))
        self.combo_box_1.SetMinSize((138, 30))
        self.panel_3.SetMinSize((190, 30))
        self.text_ctrl_1.SetMinSize((50, 28))
        self.text_ctrl_5.SetMinSize((35, 28))
        self.panel_1.SetMinSize((190, 30))
        self.button_8.SetMinSize((110, 60))
        self.button_9.SetMinSize((110, 40))
        self.text_ctrl_2.SetMinSize((120, 28))
        self.button_13.SetMinSize((50, 30))
        self.text_ctrl_3.SetMinSize((520, 130))
        # end wxGlade

        self.SetTitle(_(u"FOCUS Job管理"))

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_6 = wx.BoxSizer(wx.VERTICAL)
        sizer_7 = wx.BoxSizer(wx.VERTICAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.VERTICAL)
        self.sizer_4_staticbox.Lower()
        sizer_4 = wx.StaticBoxSizer(self.sizer_4_staticbox, wx.VERTICAL)
        sizer_26 = wx.BoxSizer(wx.VERTICAL)
        sizer_30 = wx.BoxSizer(wx.VERTICAL)
        sizer_27 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_29 = wx.BoxSizer(wx.VERTICAL)
        sizer_12 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_34 = wx.BoxSizer(wx.VERTICAL)
        sizer_36 = wx.BoxSizer(wx.VERTICAL)
        sizer_35 = wx.BoxSizer(wx.VERTICAL)
        sizer_28 = wx.BoxSizer(wx.VERTICAL)
        self.sizer_3_staticbox.Lower()
        sizer_3 = wx.StaticBoxSizer(self.sizer_3_staticbox, wx.VERTICAL)
        sizer_18 = wx.BoxSizer(wx.VERTICAL)
        sizer_24 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_25 = wx.BoxSizer(wx.VERTICAL)
        sizer_11 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_19 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_22 = wx.BoxSizer(wx.VERTICAL)
        sizer_23 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_20 = wx.BoxSizer(wx.VERTICAL)
        sizer_21 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_9 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_13 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_17 = wx.BoxSizer(wx.VERTICAL)
        sizer_14 = wx.BoxSizer(wx.VERTICAL)
        sizer_16 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_15 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_42 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_47 = wx.BoxSizer(wx.VERTICAL)
        sizer_48 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_45 = wx.BoxSizer(wx.VERTICAL)
        sizer_46 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_39 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_40 = wx.BoxSizer(wx.VERTICAL)
        sizer_41 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_10 = wx.BoxSizer(wx.VERTICAL)
        sizer_31 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_32 = wx.BoxSizer(wx.VERTICAL)
        sizer_33 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.label_1, 0, wx.TOP | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_3.Add(self.label_13, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 5)
        sizer_10.Add(self.label_10, 0, wx.LEFT, 5)
        sizer_33.Add(self.text_ctrl_4, 0, wx.LEFT, 5)
        sizer_33.Add(self.button_5, 0, 0, 0)
        sizer_32.Add(sizer_33, 0, wx.EXPAND, 0)
        sizer_31.Add(sizer_32, 1, wx.EXPAND, 0)
        sizer_10.Add(sizer_31, 0, wx.EXPAND, 0)
        sizer_10.Add(self.button_6, 0, wx.LEFT, 5)
        sizer_9.Add(sizer_10, 0, wx.EXPAND, 0)
        sizer_9.Add(self.static_line_2, 0, wx.LEFT | wx.EXPAND, 20)
        sizer_41.Add(self.label_5, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_40.Add(sizer_41, 1, wx.ALIGN_RIGHT, 0)
        sizer_39.Add(sizer_40, 1, wx.EXPAND | wx.ALIGN_RIGHT, 0)
        sizer_39.Add(self.combo_box_1, 0, 0, 0)
        self.panel_3.SetSizer(sizer_39)
        sizer_14.Add(self.panel_3, 1, wx.EXPAND, 0)
        sizer_46.Add(self.label_11, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_45.Add(sizer_46, 1, wx.ALIGN_RIGHT, 0)
        sizer_42.Add(sizer_45, 1, wx.EXPAND, 0)
        sizer_42.Add(self.text_ctrl_1, 0, 0, 0)
        sizer_48.Add(self.label_12, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_47.Add(sizer_48, 1, wx.LEFT | wx.ALIGN_RIGHT, 10)
        sizer_42.Add(sizer_47, 1, wx.EXPAND, 0)
        sizer_42.Add(self.text_ctrl_5, 0, 0, 0)
        self.panel_1.SetSizer(sizer_42)
        sizer_15.Add(self.panel_1, 1, wx.ALIGN_RIGHT, 0)
        sizer_14.Add(sizer_15, 1, wx.EXPAND, 0)
        sizer_16.Add(self.button_7, 0, wx.LEFT, 45)
        sizer_14.Add(sizer_16, 1, wx.EXPAND, 0)
        sizer_13.Add(sizer_14, 0, wx.LEFT | wx.EXPAND, 0)
        sizer_17.Add(self.button_8, 0, 0, 0)
        sizer_17.Add(self.button_9, 0, 0, 0)
        sizer_13.Add(sizer_17, 0, wx.EXPAND, 0)
        sizer_9.Add(sizer_13, 0, wx.LEFT | wx.EXPAND, 5)
        sizer_3.Add(sizer_9, 0, wx.EXPAND, 0)
        sizer_3.Add(self.static_line_1, 0, wx.LEFT | wx.RIGHT | wx.TOP | wx.EXPAND, 10)
        sizer_20.Add(self.label_6, 0, wx.LEFT, 5)
        sizer_21.Add(self.button_10, 0, wx.LEFT, 5)
        sizer_21.Add(self.button_11, 0, 0, 0)
        sizer_21.Add(self.button_12, 0, 0, 0)
        sizer_20.Add(sizer_21, 0, wx.EXPAND, 0)
        sizer_19.Add(sizer_20, 0, wx.EXPAND, 0)
        sizer_22.Add(self.label_7, 0, 0, 0)
        sizer_23.Add(self.text_ctrl_2, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_23.Add(self.button_13, 0, 0, 0)
        sizer_22.Add(sizer_23, 0, wx.EXPAND, 0)
        sizer_19.Add(sizer_22, 0, wx.LEFT | wx.EXPAND, 10)
        sizer_18.Add(sizer_19, 0, wx.EXPAND, 0)
        sizer_11.Add(self.text_ctrl_3, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 0)
        sizer_25.Add(sizer_11, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_24.Add(sizer_25, 1, wx.EXPAND, 0)
        sizer_18.Add(sizer_24, 1, wx.EXPAND, 0)
        sizer_3.Add(sizer_18, 1, wx.TOP | wx.EXPAND, 5)
        sizer_2.Add(sizer_3, 1, wx.LEFT | wx.RIGHT | wx.EXPAND, 10)
        sizer_28.Add(self.label_3, 0, 0, 0)
        sizer_28.Add(self.label_8, 0, 0, 0)
        sizer_28.Add(self.button_14, 0, 0, 0)
        sizer_27.Add(sizer_28, 0, wx.LEFT | wx.EXPAND, 5)
        sizer_29.Add(self.label_4, 0, wx.LEFT, 20)
        sizer_35.Add(self.label_14, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_35.Add(self.button_4, 0, 0, 0)
        sizer_12.Add(sizer_35, 0, wx.EXPAND, 0)
        sizer_36.Add(self.label_15, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_36.Add(self.button_16, 0, 0, 0)
        sizer_12.Add(sizer_36, 0, wx.EXPAND, 0)
        sizer_34.Add(self.label_9, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_34.Add(self.button_15, 0, 0, 0)
        sizer_12.Add(sizer_34, 1, wx.LEFT | wx.EXPAND, 20)
        sizer_29.Add(sizer_12, 1, wx.EXPAND, 0)
        sizer_27.Add(sizer_29, 0, wx.LEFT | wx.EXPAND, 20)
        sizer_26.Add(sizer_27, 0, wx.EXPAND, 0)
        sizer_30.Add(self.label_2, 0, wx.LEFT, 5)
        sizer_30.Add(self.list_box_1, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_26.Add(sizer_30, 1, wx.EXPAND, 0)
        sizer_4.Add(sizer_26, 1, wx.EXPAND, 0)
        sizer_2.Add(sizer_4, 0, wx.LEFT | wx.RIGHT | wx.TOP | wx.EXPAND, 10)
        sizer_1.Add(sizer_2, 1, wx.EXPAND, 0)
        sizer_8.Add(self.button_2, 0, wx.LEFT | wx.RIGHT, 10)
        sizer_8.Add(self.button_3, 0, 0, 0)
        sizer_7.Add(sizer_8, 1, wx.TOP | wx.BOTTOM | wx.EXPAND, 10)
        sizer_5.Add(sizer_7, 1, wx.EXPAND, 0)
        sizer_6.Add(self.button_1, 0, wx.RIGHT | wx.TOP | wx.ALIGN_RIGHT, 10)
        sizer_5.Add(sizer_6, 1, wx.ALIGN_RIGHT, 0)
        sizer_1.Add(sizer_5, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #参照...（job選択）
    def onSelectJob(self, event):  # wxGlade: MyFrame.<event_handler>
        self.selectJob()

    #Job編集
    def onEditJob(self, event):  # wxGlade: MyFrame.<event_handler>
        self.editJob()

    #設定file編集
    def onEditSettingFile(self, event):  # wxGlade: MyFrame.<event_handler>
        self.editSettingFile()

    #設定
    def onSetQueueCpu(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setQueueCpu()

    #job投入実行
    def onRunJob(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runJob()

    #freenodes
    def onFreenodes(self, event):  # wxGlade: MyFrame.<event_handler>
        self.freenodes()

    #squeues
    def onSqueues(self, event):  # wxGlade: MyFrame.<event_handler>
        self.squeues()

    #sinfo
    def onSinfo(self, event):  # wxGlade: MyFrame.<event_handler>
        self.sinfo()

    #その他コマンド実行
    def onRunCommand(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runCommand()

    #squeue（実行状況のリスト）
    def onSqueue(self, event):  # wxGlade: MyFrame.<event_handler>
        self.squeue()

    #log表示（tail-f）
    def onShowLog(self, event):  # wxGlade: MyFrame.<event_handler>
        self.showLog()

    #残渣の表示（plotWatcher）
    def onPlotWatcher(self, event):  # wxGlade: MyFrame.<event_handler>
        self.plotWatcher()

    #scancel（jobの停止)
    def onScancel(self, event):  # wxGlade: MyFrame.<event_handler>
        self.scancel()

    #folder開く
    def onOpenFolder(self, event):  # wxGlade: MyFrame.<event_handler>
        self.openFolder()

    #login端末を開く
    def onRunTerminal(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runTerminal()

    #閉じる
    def onClose(self, event):  # wxGlade: MyFrame.<event_handler>
        self.Destroy()

    #jobFile入力
    def onSetJobFile(self, event):
        self.showSbatchOption()

    #コマンドのkey入力
    def onKey(self, event):
        key = event.GetKeyCode()
        if key == 13:
            self.onRunCommand(event)
        event.Skip()

# end of class MyFrame

    #
    #  setComboBox
    #    comboBoxにデータセット
    def setComboBox(self):
        self.combo_box_1.Clear()
        self.combo_box_1.AppendItems(queueNames)

    #
    #  setSqueueLabe
    #    squeue実行時のtitle行を設定
    def setSqueueLabe(self):
        titleLine = "   JOBID PARTITION     NAME     USER ST       TIME  NODES NODELIST(REASON)"
        self.label_2.SetLabel(titleLine)

    #
    #  selectJob
    #    jobファイルの選択
    def selectJob(self):
        global jobFile, queue, nCpu, nNode
        title = _(u"Jobファイルの選択")
        mess = _(u"編集するJobファイルを選択する。")
        fileFilter = "*"
        [stat, fileName] = getOpenFileDDialog.Show(title, mess, caseDir, fileFilter)
        if stat == "OK":
            jobFile = fileName
            self.text_ctrl_4.SetValue(jobFile)
            [queue, nCpu, nNode] = readJobFile(fileName)
            self.setSbatchOption(queue, nCpu, nNode)

    #
    #  editJob
    #    jobFileの編集
    def editJob(self):
        jobName = self.text_ctrl_4.GetValue()
        fileName = caseDir + "/" + jobName
        pyTreeFoam.runEditor(fileName)

    #
    #  editSettingFile
    #    focus設定file編集
    def editSettingFile(self):
        global queueNames
        path = os.getenv("TreeFoamUserPath") + "/data"
        fileName = path + "/focus_data"
        pyTreeFoam.runEditorWait(fileName)
        [data, logFiles] = readFocusData()
        queueNames = data
        selQueue = self.combo_box_1.GetStringSelection()
        self.setComboBox()
        self.combo_box_1.SetStringSelection(selQueue)

    #
    #  setQueueCpu
    #    sbatchのoptionを書き込み
    def setQueueCpu(self):
        jobFile = self.text_ctrl_4.GetValue()
        job = jobFile
        queue = self.combo_box_1.GetStringSelection()
        nCpu = self.text_ctrl_1.GetValue()
        nNode = self.text_ctrl_5.GetValue()
        [oFile, eFile] = getFocusOutputLogFileNames(job)
        #oFile = job+".o%J"
        #eFile = job+".e%J"
        error = writeJobFile(jobFile, job, queue, nCpu, nNode, oFile, eFile)
        if error != "":
            title = _(u"エラー")
            self.errDialog(title, error)
            return
        title = _(u"Jobファイルの修正")
        mess = _(u"以下の内容を書き込みました。\n")
        mess += ("  #SBATCH -p " + queue + "\n")
        mess += ("  #SBATCH -n " + nCpu + "\n")
        if nNode != "":
            mess += ("  #SBATCH -N " + nNode + "\n")
        mess += ("  #SBATCH -J " + job + "\n")
        mess += ("  #SBATCH -e " + eFile + "\n")
        mess += ("  #SBATCH -o " + oFile + "\n")
        self.okDialog(title, mess)

    #
    #  runJob
    #    job投入・実行
    def runJob(self):
        jobFile = self.text_ctrl_4.GetValue()
        [queue, nCpu, nNode] = readJobFile(jobFile)
        error = ""
        if queue == "":
            error = _(u"キューが設定されていません。")
        elif nCpu == "":
            error = _(u"nCpu（プロセス数）が設定されていません。")
        if error != "":
            title = _(u"エラー")
            self.errDialog(title, error)
            return

        title = _(u"Jobの投入")
        mess = _(u"以下の条件でJobを投入します。\n")
        mess += _(u"  キュー名: ") + queue + "\n"
        mess += _(u"  cpu数:    ") + nCpu + "\n"
        if nNode != "":
            mess += _(u"  node数:   ") + nNode + "\n"
        stat = self.okCancelDialog(title, mess)
        if stat == "OK":
            #hostデータ読み込み
            data = pyTreeFoam.readSshfsData()
            hostDir = data[2]
            mountPoint = data[3]
            login = data[4]
            #実行
            workDir = hostDir + caseDir[len(mountPoint):]
            focusOutputFile = hostDir + "/TreeFoamServer/tmp/output"
            comm = "sbatch " + jobFile
            cont = runFocusCommandReturnCont(mountPoint, login, workDir, comm, focusOutputFile)
            #旧のjobIdファイルを削除
            jobIdFiles = glob.glob(caseDir + "/jobId:*")
            comm = "rm -rf " + caseDir + "/jobId:*"
            os.system(comm)
            #新しいjobId取得、jobIdファイル作成
            words = cont.split()
            jobId = "jobId:" + words[-1]
            fileName = caseDir + "/" + jobId
            f=open(fileName, "w"); f.write(jobFile); f.close()
            #実行の状況を表示
            title = _(u"Jobの投入")
            mess = _(u"Jobを投入しました。") + "\n\n"
            mess += cont.decode("utf-8")
            self.okDialog(title, mess)

    #
    #  freenodes
    #    freenodesコマンド実行
    def freenodes(self):
        comm = "freenodes"
        outputFile = os.getenv("TreeFoamUserPath") + "/temp/output"
        runFocusCommand(comm, outputFile)
        f = open(outputFile); cont = f.read(); f.close()
        self.text_ctrl_3.SetValue(cont)

    #
    #  squeues
    #    squeuesコマンド実行
    def squeues(self):
        comm = "squeues"
        outputFile = os.getenv("TreeFoamUserPath") + "/temp/output"
        runFocusCommand(comm, outputFile)
        f = open(outputFile); cont = f.read(); f.close()
        self.text_ctrl_3.SetValue(cont)

    #
    #  sinfo
    #    sinfoコマンド実行
    def sinfo(self):
        comm = "sinfo"
        outputFile = os.getenv("TreeFoamUserPath") + "/temp/output"
        runFocusCommand(comm, outputFile)
        f = open(outputFile); cont = f.read(); f.close()
        self.text_ctrl_3.SetValue(cont)

    #
    #  runCommand
    #    その他コマンド実行
    def runCommand(self):
        data = pyTreeFoam.readSshfsData()
        hostDir = data[2]
        mountPoint = data[3]
        login = data[4]
        #実行
        workDir = hostDir + caseDir[len(mountPoint):]
        focusOutputFile = hostDir + "/TreeFoamServer/tmp/output"
        comm = self.text_ctrl_2.GetValue()
        cont = runFocusCommandReturnCont(mountPoint, login, workDir, comm, focusOutputFile)
        #実行状況を表示
        self.text_ctrl_3.SetValue(cont)

    #
    #  squeue
    #    squeueコマンドの実行（実行状況のリスト）
    def squeue(self):
        comm = "squeue"
        outputFile = os.getenv("TreeFoamUserPath") + "/temp/output"
        runFocusCommand(comm, outputFile)
        f = open(outputFile); lines = f.readlines(); f.close()
        items = []
        for line in lines[1:]:
            i = 0
            while i <= 10:
                chara = line[i]
                if chara == " ":
                    i += 1
                else:
                    break
            items.append(line[i:-1])
        self.list_box_1.Clear()
        self.list_box_1.AppendItems(items)

    #
    #  showLog
    #    選択されたJobのlogを表示（tail-f）
    def showLog(self):
        item = self.list_box_1.GetStringSelection()
        if item == "":
            title = _(u"エラー")
            mess = _(u"jobが選択されていません。")
            self.errDialog(title, mess)
            return

        jobId = item.split()[0]
        logFile = getLogFile(jobId)
        if logFile == "":
            title = _(u"エラー")
            mess = _(u"logFileが検出できませんでした。")
            self.errDialog(title, mess)
            return

        #setEnvironを作成
        foamTermSize = "110x24"
        data = pyTreeFoam.readSshfsData()
        hostName = data[0]
        userName = data[1]
        hostDir = data[2]
        mountDir = data[3]
        login = data[4]
        setEnviron = data[5]
        openDir = "/".join(logFile.split("/")[:-1])
        lines = setEnviron.split("\n")
        i = len(lines) - 1
        while i >= 0:
            if lines[i][:len("cd")] == "cd":
                words = lines[i].split()
                lines[i] = "cd " + openDir
                break
            i -= 1
        setEnviron = "\n".join(lines)
        #tmpFileを作成
        setEnviron += "tail -n 200 -f " + logFile + "\n"
        name = "setEnviron"
        fileName = os.getenv("TreeFoamUserPath") + "/temp/" + name
        f=open(fileName, "w"); f.write(setEnviron); f.close()
        #envファイルを転送
        comm = "scp " + fileName + " " + userName + "@" + hostName + ":" + "~/"
        [stat, err] = pyTreeFoam.runCommandErrorCheck(comm)
        f=open(fileName, "w"); f.write(login); f.close()
        title = ".../".join(openDir.split("/")[-2:])
        comm = "gnome-terminal --name=" + title + " --geometry=" + foamTermSize + " -x bash --rcfile " + fileName + " &"
        os.system(comm.encode("utf-8"))

    #
    #  plotWatcher
    #    plotWatcherを起動
    def plotWatcher(self):
        item = self.list_box_1.GetStringSelection()
        if item == "":
            title = _(u"エラー")
            mess = _(u"jobが選択されていません。")
            self.errDialog(title, mess)
            return

        jobId = item.split()[0]
        logFile = getLogFile(jobId)
        if logFile == "":
            title = _(u"エラー")
            mess = _(u"logFileが検出できませんでした。")
            self.errDialog(title, mess)
            return

        #logFileを取得
        data = pyTreeFoam.readSshfsData()
        hostName = data[0]
        userName = data[1]
        hostDir = data[2]
        mountDir = data[3]
        login = data[4]
        setEnviron = data[5]
        logFile = mountDir + logFile[len(hostDir):]
        #OpenFOAMの環境設定fileを取得
        configData = pyTreeFoam.readConfigTreeFoam()
        envOpenFOAMFix = configData[1]
        #caseDirを取得
        solveCase = "/".join(logFile.split("/")[:-1])
        #起動スクリプト作成
        cont = "#!/ban/bash\n"
        cont = cont + ". " + envOpenFOAMFix + "\n"
        cont = cont + 'echo -n "running plotWatcher"\n'
        cont = cont + "pyFoamPlotWatcher.py " + logFile + " 1> /dev/null 2> /dev/null\n"
        plotWatcher = solveCase + "/plotWatcher"
        f = open(plotWatcher, "w")
        f.write(cont)
        f.close()
        #plotWatcher実行
        os.system("chmod a+x " + plotWatcher)
        title = solveCase
        if len(title) > 30:
            title = "_..." + title[-30:]
        title = "plotWatcher:" + title
        comm = "gnome-terminal --name=" + title + " --geometry=80x2 --hide-menubar -x bash --rcfile " + plotWatcher
        os.system(comm)

    #
    #  scancel
    #    jobの停止
    def scancel(self):
        item = self.list_box_1.GetStringSelection()
        if item == "":
            title = _(u"エラー")
            mess = _(u"停止させるjobが選択されていません。")
            self.errDialog(title, mess)
            return

        outputFile = os.getenv("TreeFoamUserPath") + "/temp/output"
        jobId = item.split()[0]
        comm = "scancel " + jobId
        runFocusCommand(comm, outputFile)
        title = _(u"jobの停止")
        mess = _(u"以下のjobIdに対し、停止コマンド（scancel）を送出しました。") + "\n\n"
        mess += "jobId: " + jobId
        self.okDialog(title, mess)

    #
    #  openFolder
    #    folderを開く
    def openFolder(self):
        pyTreeFoam.openFolderNautilus(caseDir)

    #
    #  runTerminal
    #    login端末を開く
    def runTerminal(self):
        foamTermSize = "110x24"
        data = pyTreeFoam.readSshfsData()
        hostName = data[0]
        userName = data[1]
        hostDir = data[2]
        mountDir = data[3]
        login = data[4]
        setEnviron = data[5]
        if mountDir == "":
            setEnviron = ""
        else:
            if mountDir == caseDir[:len(mountDir)]:
                openDir = "~" + caseDir[len(mountDir):]
                lines = setEnviron.split("\n")
                i = len(lines) - 1
                while i >= 0:
                    if lines[i][:len("cd")] == "cd":
                        words = lines[i].split()
                        lines[i] = "cd " + openDir
                        break
                    i -= 1
                setEnviron = "\n".join(lines)
            else:
                setEnviron = ""
        #tempFileを作成
        name = "setEnviron"
        fileName = os.getenv("TreeFoamUserPath") + "/temp/" + name
        f=open(fileName, "w"); f.write(setEnviron); f.close()
        #envファイルを転送
        comm = "scp " + fileName + " " + userName + "@" + hostName + ":" + "~/"
        [stat, err] = pyTreeFoam.runCommandErrorCheck(comm)
        f=open(fileName, "w"); f.write(login); f.close()
        comm = "gnome-terminal --geometry=" + foamTermSize + " -x bash --rcfile " + fileName + " &"
        os.system(comm.encode("utf-8"))

    #
    #  setSbatchOption
    #    sbatchのoptionをtextBoxに設定
    def setSbatchOption(self, queue, nCpu, nNode):
        self.combo_box_1.SetStringSelection(queue)
        self.text_ctrl_1.SetValue(nCpu)
        self.text_ctrl_5.SetValue(nNode)

    #
    #  hideSbatchOption
    #    sbatchオプション関連を隠す
    def hideSbatchOption(self):
        self.combo_box_1.Enable(False)
        self.text_ctrl_1.Enable(False)
        self.text_ctrl_5.Enable(False)
        self.button_7.Enable(False)
        self.button_8.Enable(False)
        self.button_9.Enable(False)

    #
    #  showSbatchOption
    #    sbatchオプション関連を表示する
    def showSbatchOption(self):
        self.combo_box_1.Enable(True)
        self.text_ctrl_1.Enable(True)
        self.text_ctrl_5.Enable(True)
        self.button_7.Enable(True)
        self.button_8.Enable(True)
        self.button_9.Enable(True)



    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        stat = ""
        if ans == wx.ID_OK:
            #dlg.Destroy()
            stat = "OK"
            #return "OK"
        else:
            #dlg.Destroy()
            stat = "CANCEL"
            #return "CANCEL"
        return stat

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()



#
#  initialize
#
def initialize():
    global caseDir, queueNames
    [conts, logFiles] = readFocusData()
    queueNames = conts

#
#  deleteComment
#    コメント文を削除
def deleteComment(lines):
    newLines = []
    for line in lines:
        n = line.find("#")
        if n >= 0:
            newLine = line[:n] + "\n"
        else:
            newLine= line
        newLines.append(newLine)
    return newLines

#
#  getFocusOutputLogFileNames
#    logFile名を取得
def getFocusOutputLogFileNames(job):
    treeFoamUserPath = os.getenv("TreeFoamUserPath")
    fileName = treeFoamUserPath + "/data/focus_data"
    [data, logFiles] = readFocusData()
    [logFile, errLogFile] = logFiles
    logFile = getStringNameFromEnv(logFile, job)
    errLogFile = getStringNameFromEnv(errLogFile, job)
    return [logFile, errLogFile]

#
#  getStringNameFromEnv
#    環境変数を文字列に変換
def getStringNameFromEnv(name, job):

    def getEnvName(name, j):
        if name[j] == "{":
            n = name[j:].find("}")
            if n >= 0:
                jj = j + n
                strName = name[j+1:jj]
            else:
                strName = name[j+1:]
                jj = len(name)
        else:
            strName = name[j:]
            jj = len(name)
        return [strName, jj]

    newName = ""
    i = 0
    while i < len(name):
        chara = name[i]
        if chara == "$":
            [envName, i] = getEnvName(name, i+1)
            if envName == "jobName":
                strName = job
            else:
                strName = os.getenv(envName)
                if strName == None:
                    strName = ""
            newName += strName
        else:
            newName += chara
        i += 1
    return newName

#
#  readFocusData
#    focusの設定データの読み込み
def readFocusData():
    treeFoamUserPath = os.getenv("TreeFoamUserPath")
    fileName = treeFoamUserPath + "/data/focus_data"
    if len(glob.glob(fileName)) == 0:
        treeFoamPath = os.getenv("TreeFoamPath")
        orgName = treeFoamPath + "/data/focus_data"
        comm = "cp " + orgName + " " + treeFoamUserPath + "/data"
        os.system(comm)
    f = open(fileName); lines = f.readlines(); f.close()
    lines = deleteComment(lines)
    flag = 0; logFlag = 0; eLogFlag = 0
    queueNames = []; logFile = "solve.log"; errLogFile = "${jobName}.e%J"
    for line in lines:
        if line[0] != " ":
            words = line.split()
            if len(words) > 0:
                if words[0] == "queueNames":
                    flag = 1
                elif words[0] == "logFileName":
                    flag = 0
                    if len(words) >= 2:
                        logFile = words[1]
                        logFlag = 1
                elif words[0] == "errLogFileName":
                    flag = 0
                    if len(words) >= 2:
                        errLogFile = words[1]
                        eLogFlag = 1
                else:
                    flag = 0
        else:
            if flag == 1:
                words = line.split()
                if len(words) > 0:
                    queueNames.append(words[0])
    queueNames.sort()
    logFiles = [logFile, errLogFile]
    if logFlag == 1 and eLogFlag == 1:
        return [queueNames, logFiles]

    #fileを読み込み再作成する
    f = open(fileName); lines = f.readlines(); f.close()
    if logFlag == 0 and eLogFlag == 0:
        #logFile errLogFile共、再作成
        addLines = ["#  Log file names\n"]
        addLines += ["#    These names are able to change at following lines.\n"]
        addLines += ["logFileName     " + logFile + "\n"]
        addLines += ["errLogFileName  " + errLogFile + "\n"]
        lines += addLines
    elif logFlag == 0:
        #logFileを追加
        addLines = ["logFileName     " + logFile + "\n"]
        for i in range(len(lines)):
            line = lines[i]
            if line[:len("errLogFileName ")] == "errLogFileName ":
                break
        lines = lines[:i] + addLines + lines[i:]
    elif eLogFlag == 0:
        #errLogFileを追加
        addLines = ["errLogFileName  " + errLogFile + "\n"]
        for i in range(len(lines)):
            line = lines[i]
            if line[:len("logFileName ")] == "logFileName ":
                break
        lines = lines[:i] + addLines + lines[i:]
    #書き込み
    f = open(fileName, "w")
    for line in lines:
        f.write(line)
    f.close()
    #戻る
    return [queueNames, logFiles]

#
#  readJobFile
#    jobFileの読み込み
def readJobFile(jobName):
    fileName = caseDir + "/" + jobName
    f = open(fileName); lines = f.readlines(); f.close()
    queue = ""; nCpu = ""; nNode = ""
    for line in lines:
        if line[:len("#SBATCH ")].upper() == "#SBATCH ":
            words = line.split()
            if len(words) >= 3:
                if words[1] == "-n":
                    nCpu = words[2]
                elif words[1] == "-N":
                    nNode = words[2]
                elif words[1] == "-p":
                    queue = words[2]
    return [queue, nCpu, nNode]

#
#  writeJobFile
#    jobFileに書き込む
def writeJobFile(jobFile, job, queue, nCpu, nNode, oFile, eFile):
    error = ""
    #errorチェック
    if job == "":
        error = _(u"Jobファイル名が設定されていません。")
        return error

    if queue == "" and nCpu == "" and nNode == "":
        error = _(u"queue, nCpu, nNodeが入力されていません。")
        return error

    jobFile = caseDir + "/" + jobFile
    #ファイルが存在しない場合、作成する
    if len(glob.glob(jobFile)) == 0:
        f=open(jobFile, "w"); f.write("#!/bin/bash\n"); f.close()
    #ファイルを読み込む
    f = open(jobFile); lines = f.readlines(); f.close()
    #関係する行を削除
    newLines = []
    for line in lines:
        if line[:len("#SBATCH ")].upper() == "#SBATCH ":
            words = line.split()
            if not (words[1] == "-J" or words[1] == "-n" or words[1] == "-N" 
                or words[1] == "-p" or words[1] == "-e" or words[1] == "-o"):
                newLines.append(line)
        else:
            newLines.append(line)
    #追加する行を作成
    addLines = ["#SBATCH -p " + queue + "\n"]
    addLines += ["#SBATCH -n " + nCpu + "\n"]
    if nNode != "":
        addLines += ["#SBATCH -N " + nNode + "\n"]
    addLines += ["#SBATCH -J " + job + "\n"]
    addLines += ["#SBATCH -e " + eFile + "\n"]
    addLines += ["#SBATCH -o " + oFile + "\n"]
    #行を追加
    newLines = newLines[:1] + addLines + newLines[1:]
    #書き込み
    f = open(jobFile, "w")
    for line in newLines:
        f.write(line)
    f.close()
    return error

#
#  runFocusCommand
#    FOCUSコマンドをそのまま実行
def runFocusCommand(comm, outputFile):
    data = pyTreeFoam.readSshfsData()
    login = data[4]
    commLine = login + " " + comm + " 1> " + outputFile + " 2> " + outputFile
    os.system(commLine)

#
#  runFocusCdCommand
#    FOCUSコマンドをカレントdirで実行
def runFocusCdCommand(login, workDir, comm, hostOutput):
    comm = "cd " + workDir + " ; " + comm + " 1> " + hostOutput + " 2> " + hostOutput
    commLine = login + ' "' + comm + '"'
    print commLine
    os.system(commLine)

#
#  runFocusCommandReturnCont
#    FOCUSコマンドを実行し、その結果を返す
def runFocusCommandReturnCont(mountPoint, login, workDir, comm, hostOutput):
    #コマンド作成
    hostName = login.split()[1]
    readFile = os.getenv("TreeFoamUserPath") + "/temp/output"
    cont = "cd " + workDir + "; "
    cont += comm + " 1> " + hostOutput + " 2> " + hostOutput
    #コマンド実行
    commLine = login + ' "' + cont + '"'
    print commLine
    os.system(commLine)
    #実行結果の読み取り
    commLine = "scp " + hostName + ":" + hostOutput + " " + readFile
    print commLine
    os.system(commLine)
    f = open(readFile); cont = f.read(); f.close()
    return cont


#
#  getLogFile
#    logFileを探す
def getLogFile(jobId):
    data = pyTreeFoam.readSshfsData()
    hostDir = data[2]
    mountPoint = data[3]
    #jobIdのファイルを検索
    if type(jobId) == unicode:
        jobId = jobId.encode("utf-8")
    serverDir = "~" + caseDir[len(mountPoint):]
    comm = "python TreeFoamServer/bin/server_findJobFiles.py " + jobId + " " + serverDir
    resultFile = "output"
    stat = pyTreeFoam.getTreeFoamServerResult(comm, resultFile)
    if stat != "OK":
        return ""

    #検索結果を取得
    fileName = mountPoint + "/TreeFoamServer/tmp/" + resultFile
    f=open(fileName); lines=f.readlines(); f.close()
    logFile = lines[0]
    return logFile


if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    caseDir = sys.argv[1]
    initialize()
    #app = wx.PySimpleApp(0)
    #wx.InitAllImageHandlers()
    app = wx.App(0)
    frame_1 = MyFrame(None, wx.ID_ANY, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
