#!/usr/bin/env python
# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.3 on Sat Feb 18 16:47:12 2012
#
#   gaugeDDialog.py
#
#     load, save, copy時にゲージを出力させる。
#
#       12/02/19    新規作成
#          02/26    load部分をclass外に出す
#          04/01    save部分を追加
#          04/08    copy部分を追加（folderのコピー:TreeFoam）
#          04/23    load, saveでｴﾗｰ処理追加
#          05/10    copy部分のメッセージ追加
#          06/22    copy：folder複数選択を可能に変更。絶対pathのlinkのコピーを可能に設定
#          10/10    copy：空フォルダのコピーを追加。相対pathのlinkを可能に設定
#       13/06/09    shutil.copyfileをshutil.copyに変更（ﾊﾟｰﾐｯｼｮﾝがｺﾋﾟｰされない為）
#                   load時、「patch.*」が読めるように修正
#          06/10    save時、「patch.*」が保存できる様に修正
#                   load, save時「"(xxx.*|yyyy)"」も追加
#                   save時、boundaryField内のpatch以外の行（#include等）を残す様に修正
#          10/15    国際化のため修正
#          12/21    stdout、stderrの設定（import logFileCreater）を追加
#       14/05/11    boundaryField内の#include、inGroupsの読み込み追加
#          05/12    複数のinGroupsに対応
#          05/14    load時、includeファイルが存在しない場合、読み飛ばす
#          09/16    load時、inGroups, includeのバグ修正
#          09/27    checkRemakePatchCont:バグ修正
#          10/05    addInGroupsPatchCont:バグ修正（ﾊﾝｸﾞｱｯﾌﾟ）
#          10/17    getFieldsPatchesName:load時、field頭の変数部読み込み追加、
#                   階層型変数の検索をfield頭部のみに修正。
#                   addInGroupsPatchCont:inGroupsの検索を最後まで実施。
#          10/20    addInGroupsPatchCont:バグ修正（正しく上書きしない）
#          10/28    load時の変数ﾀｲﾌﾟ「$:xx.xx.xx...」に対応
#          11/11    getKeyContFromVariable:「$:」型の変数取得時、lineのみ→全て取得に修正
#       15/07/10    addInGroupsPatchCont:バグ修正（typeが2行目以降の場合、表示せず）
#          07/17    dialogの起動方法を修正
#          09/13    バグ修正。getAbsPath:環境変数$xxx記述を追加。
#          10/07    「#includeEtc」を追加
#

import wx
import getFoamContents
import pyTreeFoam
import thread
import string
import os
import glob
import shutil
import codecs
import re

import logFileCreater; logFileCreater.log()



# begin wxGlade: extracode
# end wxGlade

title = ""
status = ""
error = ["OK", ""]
job = ""
dataDir = ""
Value = 0.0
Message = ""
colNames = []
rowNames = []
defineData = []
data = []
intData = []
defineData = []
deltaT = 100            #event timerの間隔(ms)をセット
copyDir = ""            #copy元Dir
newDir = ""             #copy先Dir
copyDirs = []
newDirs = []
oldDir = ""
checkDir = ""
maxRowsInCell = 15              #gridEditorの最大cell内行数（load時）
nMaxLinesBinToAscii = 500       #binary→ascii変換する行数


class MyDialog(wx.Dialog):
    def __init__(self, *args, **kwds):
        global job, status, deltaT
        # begin wxGlade: MyDialog.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, -1, _("label_1\n"))
        self.gauge_1 = wx.Gauge(self, -1, 100)
        self.button_1 = wx.Button(self, -1, _(u"キャンセル"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onCancel, self.button_1)
        # end wxGlade

        self.Bind(wx.EVT_TIMER, self.setGaugeValue)
        self.timer = wx.Timer(self)
        self.timer.Start(deltaT)

        status = "OK"
        thread.start_new_thread(loadSaveData, ())
       


    def __set_properties(self):
        global title
        # begin wxGlade: MyDialog.__set_properties
        self.SetTitle(_("dialog_1"))
        self.gauge_1.SetMinSize((300, 14))
        # end wxGlade

        self.SetTitle(title)


    def __do_layout(self):
        # begin wxGlade: MyDialog.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_1.Add(self.label_1, 0, wx.ALL, 10)
        sizer_1.Add(self.gauge_1, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM, 10)
        sizer_1.Add(self.button_1, 0, wx.RIGHT | wx.BOTTOM | wx.ALIGN_RIGHT, 10)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade


    def onCancel(self, event): # wxGlade: MyDialog.<event_handler>
        global status, Value
        status = "NG"
        Value = 101.0
        self.Destroy()


    def setGaugeValue(self, event):
        global Value, Message, deltaT
        self.timer.Stop()
        if Value >= 100:
            self.Destroy()
        else:
            self.label_1.SetLabel(Message)
            self.gauge_1.SetValue(Value)
            self.timer.Start(deltaT)

# end of class MyDialog

    #-----------------------
    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()



#
#  loadSaveData
#    jobの振り分け
def loadSaveData():
    global job, dataDir, colNames, data, intData, Value, error
    error = ["OK", ""]
    if job == "load":
        data = getLoadData(dataDir, colNames)
    elif job == "save":
        error = saveData(dataDir, colNames, rowNames, data, intData)
    elif job == "copy":
        global copyDirs, newDirs
        copyFolder(copyDirs, newDirs)
    elif job == "checkLink":
        global checkDir, oldDir, newDir
        checkLink(checkDir, oldDir, newDir)
    #処理の終了（timerHandlerへ知らせる）
    Value = 101.0
    return

#----------------
#  load ------------------------------------------------
#----------------

#  getLoadData
#    dataの読み込み
def getLoadData(dataDir, fields):
    global rowNames, maxRowsInCell
    if len(fields) == 0:
        patchData = []
        return patchData
    #patchDataを各Fieldから取得
    [files, patchesF, patchData] = getFieldsPatchesName(dataDir, fields, rowNames)
    #patchDataを修正
    data=[]; j=0
    for fieldPatch in patchData:
        fieldData=[]
        for patch in rowNames:
            i=0; flag=0
            while i<len(fieldPatch) and flag==0:
                if patch == patchesF[i]:
                    fieldData.append(fieldPatch[i])
                    flag = 1
                i += 1
            if flag == 0:
                fieldData.append("")
        data.append(fieldData)
        j += 1
    patchData = data
    #patchDataの文字数をチェック、修正
    data = []
    for field in patchData:
        i=0
        while i<len(field):
            patchCont = field[i].split("\n")
            if len(patchCont) > maxRowsInCell:
                field[i] = "\n".join(patchCont[:maxRowsInCell]) + "..."
            i+=1
        data.append(field)
    dataA = reformPatchData(data)
    return dataA

#  reformPatchData
#    patch内容を修正
#    {}内は、sp(4)を加える
def reformPatchData(data):
    ans = []
    sp = " "
    for patchCont in data:
        patchConts = []
        for cont in patchCont:
            flag = 0
            lines = []
            linesCont = cont.split("\n")
            for line in linesCont:
                if len(line) > 0:
                    if line[0] == "}":
                        flag -= 1
                    if line[0] == "{":
                        flag += 1
                    if flag != 0:
                        #flagの値に応じてspを加える
                        if line[0] == "{":
                            line = (sp * (flag-1)*4) + line
                        else:
                            line = (sp * (flag*4)) + line
                    lines.append(line)
            conts = "\n".join(lines)
            patchConts.append(conts)
        ans.append(patchConts)
    return ans

#
#  getFieldsPatchesName
#    各fieldのpatchDataを取得
def getFieldsPatchesName(wdir, files, rowNames):
    global Value, Message, nMaxLinesBinToAscii
    Value = 0.0                                 #gauge：値をクリア
    dValue = 100.0 / float(len(files) + 1)      #gauge：増分をセット
    fieldsTop = []          #field頭部（boundaryFieldの外）の変数
    fieldsPatch = []        #boundaryField内の変数
    patchData = []
    for name in files:
        pValue = str(int(Value))
        Message = pValue + "% " + name + _(u" ...読み込み中")        #gauge：メッセージ
        topCont = []        #field頭部
        patchesCont = []    #boundaryField内
        fileName = wdir + "/" + name
        fileName = getFoamContents.checkFileName(fileName)
        if len(glob.glob(fileName)) != 0:
            contents = getFoamContents.readField(fileName, nMaxLinesBinToAscii)
            #field頭のinclude行、keyword行を取得
            p = getFoamContents.skipFoamFileMem(contents, 0)
            [lineCont, p, kind] = getFoamContents.get1lineMem(contents, p)
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
            while lineCont != "" and keyword != "boundaryField":
                if kind == "include":
                    #includefileの読み込み
                    fileName = (lineCont.split()[1]).split('"')[1]
                    fileName = getAbsPath(fileName)
                    includeHeadCont = readIncludeGetPatchCont(fileName)
                    topCont += includeHeadCont
                elif kind == "includeEtc":
                    #includefileの読み込み
                    fileName ="${WM_PROJECT_DIR}/etc/" + (lineCont.split()[1]).split('"')[1]
                    fileName = getAbsPath(fileName)
                    includeHeadCont = readIncludeGetPatchCont(fileName)
                    topCont += includeHeadCont
                elif kind == "keyword":
                    #keyword行を取得
                    [patchCont, pp] = getFoamContents.getNextKeywordAndContentsMem(
                        lineCont, 0)
                    topCont.append(patchCont)
                elif (kind == "line" and keyword != "dimensions"
                        and keyword != "internalField"):
                    #line行を取得
                    keyCont = " ".join(lineCont.split()[1:])
                    topCont.append([keyword, keyCont])
                [lineCont, p, kind] = getFoamContents.get1lineMem(contents, p)
                [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
            #boundaryFieldの内容を取得
            [boundary, pp] = getFoamContents.getMiddlePairMem(lineCont, 0)
            #patch内容を取得
            [lineCont, p, kind] = getFoamContents.get1lineMem(boundary, 0)
            while lineCont != "":
                if kind == "keyword":
                    [patchCont, pp] = getFoamContents.getNextKeywordAndContentsMem(
                        lineCont, 0)
                    patchesCont.append(patchCont)
                elif kind == "include":
                    #includefileの読み込み
                    fileName = (lineCont.split()[1]).split('"')[1]
                    fileName = getAbsPath(fileName)
                    includePatchesCont = readIncludeGetPatchCont(fileName)
                    patchesCont += includePatchesCont
                elif kind == "includeEtc":
                    #includefileの読み込み
                    fileName = "${WM_PROJECT_DIR}/etc/" + (lineCont.split()[1]).split('"')[1]
                    fileName = getAbsPath(fileName)
                    includePatchesCont = readIncludeGetPatchCont(fileName)
                    patchesCont += includePatchesCont
                #次のpatchを取得
                [lineCont, p, kind] = getFoamContents.get1lineMem(boundary, p)
        #結果を保存
        fieldsTop.append(topCont)               #field頭の変数
        fieldsPatch.append(patchesCont)         #boundaryField内の変数（patch名含む）
        Value += dValue                         #gauge：増分を加える

    fieldi = 0
    for fieldPatch in fieldsPatch:
        fieldName = files[fieldi]
        topCont = fieldsTop[fieldi]
        fieldi += 1
        col=[]
        patches = []
        for patchC in fieldPatch:
            patches.append(patchC[0])
        for patch in patches:
            col.append("")
        i = 0
        for fpatch in fieldPatch:
            flag = 0
            for patch in patches:
                if fpatch[0] == patch:
                    col[i]=pyTreeFoam.compressSPCR(fpatch[1])
                    flag = 1
                    break
            if flag == 0:
                patches.append(fpatch[0])
                col.append(pyTreeFoam.compressSPCR(fpatch[1]))
            i += 1
        #boundaryのpatchに対するpatchContに変換
        colPatch = getFitBoundaryPatchCont(col, patches, rowNames)
        #inGroupsの処理
        colPatch = addInGroupsPatchCont(colPatch, defineData,
                        fieldPatch, rowNames, topCont)
        #wildCard「".*"」の処理
        colPatch = addWildCardCont(col, patches, rowNames, colPatch,
                        fieldPatch, topCont)
        patchData.append(colPatch)
    return [files, rowNames, patchData]

#  addInGroupsPatchCont
#    boundary内のinGroupsを追加
def addInGroupsPatchCont(col, defineData, fieldPatch, rowNames, topCont):

    #  checkRemakePatchCont
    #    patchContをチェックする
    def checkRemakePatchCont(cont):
        if cont == "":
            return cont
        if cont[:len("type")] == "type" or cont[:len("$")] == "$":
            return cont
        else:
            #1行目が「type」でない場合、type行を探す
            lines = cont.split("\n")
            lineType = ""
            linesNoType = []
            for line in lines:
                if line[:len("type")] == "type":
                    lineType = line
                else:
                    linesNoType.append(line)
            if lineType != "":
                #type行を1行目に移動して返す
                newLines = [lineType] + linesNoType
                newCont = "\n".join(newLines)
                return newCont
            else:
                #type行が無い場合、空文を返す
                return ""

    #  isInGroups
    #    fieldContがpatchのinGroupsに属するかどうかチェック
    def isInGroups(defineCont, fieldPatchName):
        ans = False
        lineCont = " "; p = 0
        while lineCont != "":
            [lineCont, p, kind] = getFoamContents.get1lineMem(defineCont, p)
            if kind == "line":
                if lineCont.split()[0] == "inGroups":
                    [words, pp] = getFoamContents.getSmallPairMem(lineCont, 0)
                    inGroups = words.split()
                    for inGroup in inGroups:
                        if inGroup == fieldPatchName:
                            ans = True
                            break
            if ans == True:
                break
        return ans

    #patchContが正しい内容かチェック。正しくない場合、「""」をセット
    #チェック結果をansに転送
    ans = []
    for fpCont in col:
        fpCont = checkRemakePatchCont(fpCont)
        ans.append(fpCont)
    #field側のpatchを順番に確認
    p = 0
    for fpCont in col:
        #field側のpatchを順番に解釈し、該当はansに保存
        for fieldCont in fieldPatch:
            fieldPatchName = fieldCont[0]
            #field側のpatch名がinGroupsに属するかチェック
            if isInGroups(defineData[p], fieldPatchName) == True:
                #属する場合、groupの内容を取得
                groupCont = pyTreeFoam.compressSPCR(fieldCont[1])
                groupCont = pyTreeFoam.compressSPCR(groupCont)
                groupCont = checkRemakePatchCont(groupCont)
                #patch内容が定義されていない（「""」）場合、groupの内容をセット
                if groupCont != "" and fpCont == "":
                    ans[p] = groupCont
        p += 1
    #ansを元に戻す
    col = ans
    #patchType「$」のチェック修正
    col = remakePatchTypeVariable(col, topCont+fieldPatch)
    #patchType「$:」のチェック修正（field頭の変数のみ検索）
    col = remakePatchTypeLevelVariable(col, topCont)
    #value「$:」のチェック修正(field頭の変数のみ検索）
    col = remakeValueLevelVariable(col, topCont)
    #value「$」は、修正しない。（そのまま）
    return col


#  remakePatchTypeVariable
#    patchType「$」のチェック修正（field頭の変数のみ検索）
def remakePatchTypeVariable(col, fieldPatch):
    end = False; nloop = 0
    while end == False and nloop < 10:
        i = 0
        end = True
        for fpCont in col:
            if len(fpCont)>4:       #「type」の4文字以上
                if fpCont[:2] != "$:" and fpCont[0] == "$":
                    key = fpCont[1:].split(";")[0]
                    keyCont = getKeyContFromSingleVariable(key, col, fieldPatch)
                    if keyCont != "":
                        col[i] = pyTreeFoam.compressSPCR(keyCont)
                        end = False
            i += 1
    return col

#  remakePatchTypeLeveVariable
#    patchType「$:」のチェック修正（field頭の変数のみ検索）
def remakePatchTypeLevelVariable(col, topCont):
    end = False; nloop = 0
    while end == False and nloop < 10:
        i = 0
        end = True
        for fpCont in col:
            if len(fpCont)>4:       #「type」の4文字以上
                if fpCont[:2] == "$:":
                    cont = fpCont[2:].split(";")[0]
                    keyList = cont.split(".")
                    keyCont = getKeyContFromVariable(keyList, col, topCont)
                    if keyCont != "":
                        col[i] = pyTreeFoam.compressSPCR(keyCont)
                        end = False
            i += 1
        nloop += 1
    return col

#  remakeValueLevelVariable
#    value「$:」のチェック修正(field頭の変数のみ検索）
def remakeValueLevelVariable(col, topCont):
    end = False; nloop = 0
    while end == False and nloop < 10:
        end = True
        i = 0
        for fpCont in col:
            lines = fpCont.split("\n")
            l = 0
            for line in lines:
                n = line[1:].find("$:")
                if n >= 0:
                    ps = n + 1
                    p = ps
                    chara = line[p]
                    while (chara != " " and chara != "\n" and chara != "\t"
                        and chara != ";" and p<len(line)):
                        p += 1
                        chara = line[p]
                    keyList = line[ps+2:p].split(".")
                    keyCont = getKeyContFromVariableValue(keyList, col, topCont)
                    if keyCont != "":
                        newLine = line[:ps] + keyCont + line[p:]
                        newLines = lines[:l] + [newLine] + lines[l+1:]
                        col[i] = "\n".join(newLines)
                        end = False
                        break
                l += 1 
            i += 1
        nloop += 1
    return col

#  getKeyContFromSingleVariable
#    「$」Type変数の内容を取得
def getKeyContFromSingleVariable(key, col, fieldPatch):
    ans = ""
    for fpCont in fieldPatch:
        if fpCont[0] == key:
            ans = fpCont[1]
            break
    return ans

#  getKeyContFromVariableValue
#    「$:」Value変数の内容を取得
def getKeyContFromVariableValue(keyList, col, fieldPatch):
    ans = ""
    if len(keyList) == 1:
        #「$:xx」の場合
        for fpCont in fieldPatch:
            if fpCont[0] == keyList[0]:
                ans = fpCont[1].split(";")[0]
                break

    if len(keyList) == 2:
        #「$:xx.xx」の場合
        for fpCont in fieldPatch:
            if fpCont[0] == keyList[0]:
                [lineCont, p, kind] = getFoamContents.get1lineMem(fpCont[1], 0)
                while lineCont != "" and p<len(fpCont[1]):
                    if kind == "line":
                        [keyword, pp] = getFoamContents.getKeywordMem(lineCont,0)
                        if keyword == keyList[1]:
                            [lcont, pp, dummy] = getFoamContents.get1lineMem(lineCont, pp)
                            ans = lcont[:-1]    #「;」を削除
                            break
                    [lineCont, p, kind] = getFoamContents.get1lineMem(fpCont[1], p)
    if len(keyList) >= 3:
        #「$:xx.xx.xx」以上の場合
        for fpCont in fieldPatch:
            if fpCont[0] == keyList[0]:
                contents = fpCont[1]
                keyCont = ""
                for key in keyList[1:-1]:
                    [keyCont, p] = getFoamContents.getKeywordContentsMem(key, contents, 0)
                    if keyCont == "":
                        break
                    contents = keyCont
                if keyCont != "":
                    [lineCont, p, kind] = getFoamContents.get1lineMem(keyCont, 0)
                    while lineCont != "":
                        if kind == "line":
                            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
                            if keyword == keyList[-1]:
                                ans = " ".join(lineCont.split()[1:])[:-1]
                                break
                        [lineCont, p, kind] = getFoamContents.get1lineMem(keyCont, p)
                    if ans != "":
                        break
    return ans

#  getKeyContFromVariable
#    「$:」Type変数の内容を取得
def getKeyContFromVariable(keyList, col, fieldPatch):

    def getOnlyLines(cont):
        ans = ""
        [lineCont, p, kind] = getFoamContents.get1lineMem(cont, 0)
        while lineCont != "":
            if kind == "line":
                ans += lineCont + "\n"
            [lineCont, p, kind] = getFoamContents.get1lineMem(cont, p)
        return ans

    #処理----------
    ans = ""
    if len(keyList) == 1:
        #「$:xx」の場合
        for fpCont in fieldPatch:
            if fpCont[0] == keyList[0]:
                ans = fpCont[1]
                #ans = getOnlyLines(ans)
    if len(keyList) == 2:
        #「$:xx.xx」の場合
        for fpCont in fieldPatch:
            if fpCont[0] == keyList[0]:
                [lineCont, p, kind] = getFoamContents.get1lineMem(fpCont[1], 0)
                while lineCont != "" and p<len(fpCont[1]):
                    if kind == "keyword":
                        [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
                        if keyword == keyList[1]:
                            [lastCont, pp] = getFoamContents.getMiddlePairMem(lineCont, 0)
                            #line文のみ取得
                            #ans = getOnlyLines(lastCont)
                            ans = lastCont
                            break
                    [lineCont, p, kind] = getFoamContents.get1lineMem(fpCont[1], p)
    if len(keyList) >= 3:
        #「$:xx.xx.xx」以上の場合
        for fpCont in fieldPatch:
            if fpCont[0] == keyList[0]:
                contents = fpCont[1]
                #2番目以降はloopして確認
                for key in keyList[1:]:
                    [keyCont, p] = getFoamContents.getKeywordContentsMem(key, contents, 0)
                    if keyCont == "":
                        break
                    contents = keyCont
                if keyCont != "":
                    #line文のみ取得
                    #ans = getOnlyLines(keyCont)
                    ans = keyCont
                    break
    return ans

#  addWildCardCont
#    wildCardの内容をチェック、取得
def addWildCardCont(col, patches, rowNames, colPatch, fieldPatch, topCont):
    #colPatchの内容ををansに転送
    ans = []
    for colp in colPatch:
        ans.append(colp)
    #waildCardのチェック
    p=0
    while p<len(patches):
        patch = patches[p]
        if patch[0] == '"':
            i=0
            while i<len(rowNames):
                #patternマッチングをチェック
                pattern = patch[1:-1]
                if pyTreeFoam.isMatchName(rowNames[i], pattern) == True:
                    if colPatch[i] == "":
                        ans[i] = col[p]
                i += 1
        p += 1
    #ansの内容をcolPatchに転送
    colPatch = ans
    #patchType「$」のチェック
    ans = remakePatchTypeVariable(ans, fieldPatch)
    #patchType「$:」のチェック修正（field頭の変数を検索）
    ans = remakePatchTypeLevelVariable(ans, topCont)
    #value「$:」のチェック修正（field頭の変数を検索）
    ans = remakeValueLevelVariable(ans, topCont)
    return ans


#  getFitBoundaryPatchCont
#    boundaryのpatchに対するpatchContに変換
#    boundaryFieldに「"patch_to_.*"」が存在する場合がある為
def getFitBoundaryPatchCont(col, patches, rowNames):
    ans = []
    for name in rowNames:
        ans.append("")
    p=0
    while p<len(patches):
        patch = patches[p]
        i=0
        while i<len(rowNames):
            if patch == rowNames[i]:
                ans[i] = col[p]
                break
            i += 1
        p += 1
    return ans


#  getAbsPath
#    dirのpathを取得
def getAbsPath(cont):
    #環境変数を取得
    sp = cont.find("${")
    if sp >= 0:
        # ${xxx}記述の解釈
        [envPath, p] = getFoamContents.getMiddlePairMem(cont, sp)
        if os.getenv(envPath) != None:
            cont = cont[:sp] + os.getenv(envPath) + cont[p:]
        else:
            if envPath == "FOAM_CASE":
                # $FOAM_CAEEは、bashの環境変数ではないのでここでセット
                caseDirList = dataDir.split("/")
                try:
                    #dataDirの最後が数字の場合、その1ヶ前がcaseName
                    a = float(caseDirList[-1])
                    caseDir = "/".join(caseDirList[:-1])
                except:
                    #dataDirの最後が文字ならば、region名なのでその2ヶ前がcaseName
                    caseDir = "/".join(caseDirList[:-2])
                cont = cont[:sp] + caseDir + cont[p:]
    elif cont.find("$") >= 0:
        # $xxx記述の解釈
        sp = cont.find("$")
        newCont = cont[sp+1:]
        envPath = newCont.split("/")[0]
        p = sp + len(envPath) + 1
        if os.getenv(envPath) != None:
            cont = cont[:sp] + os.getenv(envPath) + cont[p:]
        else:
            if envPath == "FOAM_CASE":
                caseDirList = dataDir.split("/")
                try:
                    a = float(caseDirList[-1])
                    caseDir = "/".join(caseDirList[:-1])
                except:
                    caseDir = "/".join(caseDirList[:-2])
                cont = cont[:sp] + caseDir + cont[p:]

    #絶対pathを取得
    if cont[0] != "/":
        cont = dataDir + "/" + cont
    return cont


#  readIncludeGetPatchCont
#    includeFileを読み込み、patchContを取得
def readIncludeGetPatchCont(fileName):
    cont = []
    cont = readIncludeSub(fileName, cont)
    return cont

def readIncludeSub(fileName, cont):
    if len(glob.glob(fileName)) == 0:
        print _(u"\nerror: includeファイル「") + fileName + _(u"」が存在しません。")
        return cont

    f=open(fileName); fileCont=f.read(); f.close()
    newCont = getFoamContents.deleteCommentsNullLines(fileCont)
    patchesCont = cont
    [lineCont, p, kind] = getFoamContents.get1lineMem(newCont, 0)
    while lineCont != "":
        if kind == "keyword":
            [patchCont, pp] = getFoamContents.getNextKeywordAndContentsMem(
                lineCont, 0)
            if patchCont[0] != "FoamFile":
                patchesCont.append(patchCont)
        elif kind == "include":
            fileName = (lineCont.split()[1]).split('"')[1]
            fileName = getAbsPath(fileName)
            patchesCont = readIncludeSub(fileName, patchesCont)
        elif kind == "includeEtc":
            fileName = "${WM_PROJECT_DIR}/etc/" + (lineCont.split()[1]).split('"')[1]
            fileName = getAbsPath(fileName)
            patchesCont = readIncludeSub(fileName, patchesCont)
        [lineCont, p, kind] = getFoamContents.get1lineMem(newCont, p)
    return patchesCont


#----------------
#  save ------------------------------------------------
#----------------

#
#  saveData
#    データ保存
def saveData(dataDir, fields, rowNames, patchData, intData):
    global Value, Message, nMaxLinesBinToAscii
    patches = []
    for patch in rowNames:
        patches.append("    " + patch)

    #fieldの保存
    Value = 0.0                             #gauge値をクリア
    dValue = 100.0 / float(len(fields) + 1) #増分をセット
    i=0
    mess = ""
    while i<len(fields) and status=="OK":
        pValue = str(int(Value))
        Message = pValue + "% " + fields[i] + _(u" ...保存中")        #gauge：メッセージ
        #fieldをオープン
        field = fields[i]
        fileName = dataDir + "/" + field
        fileName = getFoamContents.checkFileName(fileName)
        #ファイルがopenできるかどうかチェック
        if len(glob.glob(fileName)) != 0:
            contents = getFoamContents.readField(fileName, nMaxLinesBinToAscii)
            #internalFieldを作成、置き換え
            contents = pyTreeFoam.makeReplaceInternalField(fields, intData[i], contents)
            #patchDataを元に戻す（"..."がある場合）
            patchDataH = pyTreeFoam.remakeBoundaryField(contents, patches, patchData[i])
            #patchDataから「boundaryField」を作成
            newBoundary = pyTreeFoam.makeBoundaryField(patches, patchData[i])
            #patchData以外を追加(#include 等)
            newBoundary = addWithoutPatchCont(newBoundary, contents, rowNames)
            #「boundaryField」を置き換える
            newContents = pyTreeFoam.replaceBoundaryField(newBoundary, contents)
            if newContents != "":
                getFoamContents.writeField(fileName, newContents)
            else:
                print "error:",field,_(u"が置き換えできませんでした。")
                mess += field + ","
        else:
            print "error:",field,_(u"が置き換えできませんでした。")
            mess += field + ","
        i+=1
        Value += dValue                     #増分を加える

    if mess == "":
        error = ["OK", ""]
    else:
        error = ["NG", mess[:-1]+_(u" が保存できていません。")]
        title = _(u"エラー")
        mess = error[1]
    return error

#  addWithoutPatchCont
#    boundaryFieldにpatchCont以外（#include等）を追加する
def addWithoutPatchCont(newBoundary, allCont, rowNames):
    p = getFoamContents.skipFoamFileMem(allCont, 0)
    [boundaryCont, p] = getFoamContents.getKeywordContentsMem(
                        "boundaryField", allCont, p)
    #boundaryContからpatchデータ以外を取得
    addCont = ""
    p=0
    cont = " "
    while cont != "" and p<len(boundaryCont):
        [cont, p, kind] = getFoamContents.get1lineMem(boundaryCont, p)
        if kind != "keyword":
            addCont += "    " + cont + "\n"
    #boundaryContに行を追加
    newBoundary = addCont + newBoundary
    return newBoundary
    


#----------------
#  copy ------------------------------------------------
#----------------

#
#  copyFolder
#    flderのコピー
def copyFolder(copyDirs, newDirs):
    global Value, Message, status, error
    Value = 0.0                                 #gauge値をクリア

    #コピーするファイル名を取得
    MessageC = _(u"コピーの準備中...")
    copyFiles = []
    newFiles = []
    copyFolders = []
    newFolders = []
    linkDir = []
    newLinkDir = []
    newLinktoDir = []          #相対リンク先
    linkFiles = []
    newLinkFiles = []
    newLinktoFiles = []
    i=-1
    for copyDir in copyDirs:
        i += 1
        if os.path.isdir(copyDir) == True:
            #コピーするフォルダ内のファイル名とコピー先のファイル名を取得
            for (root, dirs, files) in os.walk(copyDir):
                #フォルダのリンクのみを検索
                for name in dirs:
                    dirName = root + "/" + name
                    if os.path.islink(dirName) == True:
                        linkDir.append(dirName)
                        newDirName = newDirs[i] + dirName[len(copyDir):]
                        newLinkDir.append(newDirName)
                        linkto = os.readlink(dirName)
                        newLinktoDir.append(getNewLink(dirName, linkto, newDirName))
                    if status != "OK":
                        break
                #空フォルダの検索
                for name in dirs:
                    dirName = root + "/" + name
                    if len(glob.glob(dirName+"/*")) == 0:
                        copyFolders.append(dirName)
                        newDirName = newDirs[i] + dirName[len(copyDir):]
                        newFolders.append(newDirName)
                    if status != "OK":
                        break
                #フォルダ内のファイルのリスト作成
                for name in files:
                    copyFile = root + "/" + name
                    newFile = newDirs[i] + copyFile[len(copyDir):]
                    if os.path.islink(copyFile) == True:
                        linkto = os.readlink(copyFile)
                        #linkFiles.append(copyFile)
                        linkDir.append(copyFile)
                        #newLinkFiles.append(newFile)
                        newLinkDir.append(newFile)
                        #linkto = os.readlink(copyFile)
                        #newLinktoFiles.append(getNewLink(copyFile, linkto, newFile))
                        newLinktoDir.append(getNewLink(copyFile, linkto, newFile))
                    else:
                        copyFiles.append(copyFile)
                        newFiles.append(newFile)
                    Message = MessageC + " " + str(len(copyFiles))
                    if status != "OK":
                        break
            if status != "OK":
                break
        else:
            #ファイルのコピーの場合
            copyFiles.append(copyDir)
            newFiles.append(newDirs[i])
    if status == "OK":
        dValue = 100.0 / float(len(copyFiles) + len(linkDir) + 1)  #gaugeの増分をセット
    else:
        return


    #ファイルのコピー開始
    i = 0
    errorFiles = []
    while i<len(copyFiles) and status=="OK":
        newName = newFiles[i].split("/")[-1]
        newNameDir = newFiles[i][:-(len(newName)+1)]
        pValue = str(int(Value))
        Message = pValue + "% " + newName + _(u" ...コピー中")        #gauge：メッセージ
        #コピー先にフォルダがあるか？
        if len(glob.glob(newNameDir)) == 0:
            #フォルダ作成
            comm = "mkdir -p " + newNameDir
            os.system(comm.encode("utf-8"))
        #ファイルをコピー
        if os.path.isfile(copyFiles[i]) == True:
            print "copy:", newFiles[i]
            #shutil.copyfile(copyFiles[i], newFiles[i])
            shutil.copy(copyFiles[i], newFiles[i])
        elif os.path.islink(copyFiles[i]) == True:
            linkto = os.readlink(copyFiles[i])
            os.symlink(linkto, newFiles[i])
        else:
            errorFiles.append(newFiles[i])
        Value += dValue
        i += 1
    #空フォルダのコピー
    i=0
    while i<len(copyFolders) and status == "OK":
        newNameDir = newFolders[i]
        comm = "mkdir -p " + newNameDir
        os.system(comm.encode("utf-8"))
        i += 1
    #リンクを作成
    i=0
    while i<len(linkDir) and status == "OK":
        newName = newLinkDir[i].split("/")[-1]
        newNameDir = "/".join(newLinkDir[i].split("/")[:-1])
        pValue = str(int(Value))
        Message = pValue + "% " + newName + _(u" ...コピー中")        #gauge：メッセージ
        #コピー先にフォルダがあるか？
        if len(glob.glob(newNameDir)) == 0:
            #フォルダ作成
            comm = "mkdir -p " + newNameDir
            os.system(comm.encode("utf-8"))
        #リンク作成
        linkto = os.readlink(linkDir[i])
        if linkto[0] != ".":
            #絶対pathのリンク
            flag = 0
            if os.path.isdir(newLinktoDir[i]) == True:
                try:
                    os.symlink(newLinktoDir[i], newLinkDir[i])
                    flag = 1
                    print _(u"相対参照で「") + newLinkDir[i] + _(u"」リンクを作成しました。")
                except:
                    flag = 0
            if flag == 0:
                try:
                    os.symlink(linkto, newLinkDir[i])
                    print _(u"絶対参照で「") + newLinkDir[i] + _(u"」リンクを作成しました。")
                except:
                    errorFiles.append(newLinkDir[i])
        else:
            #相対pathのリンク
            print _(u"相対pathで「") + linkto + _(u"」リンクを作成しました。")
            os.symlink(linkto, newLinkDir[i])
        Value += dValue
        i += 1

    if len(errorFiles) != 0:
        i=0
        msg = _(u"以下のファイルがコピーできませんでした。\n")
        for errorFile in errorFiles:
            if i<5:
                msg += errorFile + "\n"
            if i == 5:
                msg += "...\n"
            i += 1
            print "error:", errorFile
        print _(u"上記fileは、コピーできませんでした。")
        status = "ERR"
        error = [u"ERR", msg]


def getNewLink(copyDir, linkto, newDir):
    copyList = copyDir.split("/")
    linktoList = linkto.split("/")
    newList = newDir.split("/")
    i=0
    while i<len(copyList) and copyList[i]==linktoList[i]:
        i += 1
    newLinkto = ""    
    if copyList[i]!=linktoList[i]:
        endDir = "/".join(linktoList[i:])
        topDir = "/".join(newList[:-(len(copyList) - i)])
        newLinkto = topDir + "/" + endDir
    return newLinkto


#----------------
#  checkLink ------------------------------------------------
#----------------

#
#  checkLink
#    リンクをチェック修正
def checkLink(checkDir, oldDir, newDir):
    global Value, Message, status, data
    Value = 0.0                                 #gauge値をクリア

    number = 0
    contCheckDir = getCheckDir(checkDir, newDir)
    dValue = 90.0 / float(len(contCheckDir))

    for checkLinkDir in contCheckDir:
        data = []
        #folder毎にlinkをチェック
        MessageC = checkLinkDir.split("/")[-1] + u"\n"
        for (root, folders, files) in os.walk(checkLinkDir):
            for folder in folders:
                number += 1
                #Message = MessageC + " " + str(number)
                if os.path.islink(root+"/"+folder) == True:
                    data.append(root+"/"+folder)
            for fileName in files:
                number += 1
                #Message = MessageC + " " + str(number)
                if os.path.islink(root+"/"+fileName) == True:
                    data.append(root+"/"+fileName)

        #linkの修正開始
        for linkDir in data:
            pValue = str(int(Value))
            Message = MessageC + pValue + _(u"% ...チェック中") 
            linkto = os.readlink(linkDir)
            if len(linkto) >= len(oldDir):
                if (oldDir == linkto[:len(oldDir)] and linkto[len(oldDir)] == "/"):
                    newlinkto = newDir + linkto[len(oldDir):]
                    if len(glob.glob(newlinkto)) != 0:
                        os.remove(linkDir)
                        os.symlink(newlinkto, linkDir)
                        print _(u"link修正--> "), linkDir
        Value += dValue

def getCheckDir(checkDir, newDir):
    [contDirs, files] = pyTreeFoam.getFoldersFiles(checkDir)
    ans = [newDir]
    for folder in contDirs:
        Dir = checkDir + "/" + folder
        if Dir != newDir:
            ans.append(Dir)
    return ans    


def checkLink_bak(checkDir, oldDir, newDir):
    global Value, Message, status, data
    Value = 0.0                                 #gauge値をクリア

    MessageC = _(u"準備中...")
    number = 0
    data = []
    for (root, folders, files) in os.walk(checkDir):
        for folder in folders:
            number += 1
            Message = MessageC + " " + str(number)
            if os.path.islink(root+"/"+folder) == True:
                data.append(root+"/"+folder)
        for fileName in files:
            number += 1
            Message = MessageC + " " + str(number)
            if os.path.islink(root+"/"+fileName) == True:
                data.append(root+"/"+fileName)

    #linkの修正開始
    dValue = 100.0 / float(number + 1)
    messageC = _(u"link修正中...")
    for linkDir in data:
        pValue = str(int(Value))
        message = pValue + "% " + messageC 
        linkto = os.readlink(linkDir)
        if len(linkto) >= len(oldDir):
            if (oldDir == linkto[:len(oldDir)] and linkto[len(oldDir)] == "/"):
                newlinkto = newDir + linkto[len(oldDir):]
                if len(glob.glob(newlinkto)) != 0:
                    os.remove(linkDir)
                    os.symlink(newlinkto, linkDir)
                    print _(u"link修正--> "), linkDir
        Value += dValue




if __name__ == "__main__":
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    dialog_1 = MyDialog(None, -1, "")
    app.SetTopWindow(dialog_1)
    dialog_1.Show()
    app.MainLoop()
