#!/usr/bin/env python
# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.5 on Sat Feb  9 15:31:26 2013
#
#   getOpenFileDDialog.py
#
#       file名の取得
#
#       13/02/09    新規作成
#          06/02    Dクリックでfileがopenするを追加
#          07/13    複数fileの選択を追加
#          10/15    国際化による修正
#       15/07/17    dialogの起動方法を修正
#

import wx
import os
import glob
import pyTreeFoam
import getOpenFolderDDialog

# begin wxGlade: extracode
# end wxGlade

fileFilter = ""
selFile = ""
status = "NG"
currDir = ""
fileList = []
selFiles = []

#  複数fileの選択（既に選択しているfileを表示）
def seledSelFilesShow(titleW, messageW, currDirW, fileFilterW, seledFiles):
    global title, message, currDir, fileFilter, fileList, selFiles
    title = titleW
    message = messageW
    currDir = currDirW
    fileFilter = fileFilterW
    fileList = getFileList(currDir, fileFilter)
    selFiles = []
    for name in fileList:
        for selName in seledFiles:
            if name == selName:
                selFiles.append(name)
                break
    dialog = MyDialog(None)
    result = dialog.ShowModal()
    return [status, selFiles]

#  複数fileの選択
def selFilesShow(titleW, messageW, currDirW, fileFilterW):
    global title, message, currDir, fileFilter, fileList
    title = titleW
    message = messageW
    currDir = currDirW
    fileFilter = fileFilterW
    fileList = getFileList(currDir, fileFilter)
    dialog = MyDialog(None)
    result = dialog.ShowModal()
    return [status, selFiles]

#  1ヶのfile選択（既に選択しているfileを表示）
def seledSelFileShow(titleW, messageW, currDirW, fileFilterW, selectedFile):
    global title, message, currDir, fileFilter, fileList, selFiles
    title = titleW
    message = messageW
    currDir = currDirW
    fileFilter = fileFilterW
    fileList = getFileList(currDir, fileFilter)
    selFiles = [selectedFile]
    dialog = MyDialog(None)
    result = dialog.ShowModal()
    return [status, selFile]
    
#  1ヶのfile選択
def Show(titleW, messageW, currDirW, fileFilterW):
    global title, message, currDir, fileFilter, fileList
    title = titleW
    message = messageW
    currDir = currDirW
    fileFilter = fileFilterW
    fileList = getFileList(currDir, fileFilter)
    dialog = MyDialog(None)
    result = dialog.ShowModal()
    return [status, selFile]

def getFileList(currDir, fileFilter):
    nameDirs = glob.glob(currDir + "/" + fileFilter)
    ans = []
    for nameDir in nameDirs:
        if os.path.isfile(nameDir) == True:
            name = nameDir.split("/")[-1]
            if name[0] != "." and name[-1] != "~":
                ans.append(name)
    ans.sort()
    return ans

class MyDialog(wx.Dialog):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyDialog.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE | wx.RESIZE_BORDER | wx.THICK_FRAME
        wx.Dialog.__init__(self, *args, **kwds)
        self.label_3 = wx.StaticText(self, -1, _(u"編集するfaileを選択してください"))
        self.label_4 = wx.StaticText(self, -1, _(u"  場所:"))
        self.text_ctrl_2 = wx.TextCtrl(self, -1, "")
        self.button_4 = wx.Button(self, -1, _(u"参照..."))
        self.label_1 = wx.StaticText(self, -1, _("filter:"))
        self.text_ctrl_1 = wx.TextCtrl(self, -1, "")
        self.button_3 = wx.Button(self, -1, _(u"表示"))
        self.label_2 = wx.StaticText(self, -1, _(u"fileを選択"))
        self.list_box_1 = wx.ListBox(self, -1, choices=[], style=wx.LB_EXTENDED)
        self.button_1 = wx.Button(self, -1, _(u"キャンセル"))
        self.button_2 = wx.Button(self, -1, _("OK"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onChangeDir, self.button_4)
        self.Bind(wx.EVT_TEXT_ENTER, self.onEnter, self.text_ctrl_1)
        self.Bind(wx.EVT_BUTTON, self.onShowFileName, self.button_3)
        self.Bind(wx.EVT_LISTBOX_DCLICK, self.onOpenFile, self.list_box_1)
        self.Bind(wx.EVT_BUTTON, self.onCancel, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onGetFileName, self.button_2)
        # end wxGlade


    def __set_properties(self):
        # begin wxGlade: MyDialog.__set_properties
        self.SetTitle(_(u"fileの選択"))
        self.label_4.SetMinSize((50, 18))
        self.button_4.SetMinSize((50, 30))
        self.label_1.SetMinSize((50, 18))
        self.button_3.SetMinSize((50, 30))
        self.list_box_1.SetMinSize((350, 200))
        # end wxGlade

        self.SetTitle(title)
        self.label_3.SetLabel(message)
        self.text_ctrl_2.SetValue(currDir)
        self.text_ctrl_1.SetValue(fileFilter)
        self.list_box_1.Clear()
        self.list_box_1.AppendItems(fileList)
        self.setSelectedItems()
        #textBoxを隠す
        self.text_ctrl_2.Enable(False)
        self.button_4.Enable(False)

    def __do_layout(self):
        # begin wxGlade: MyDialog.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.VERTICAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3 = wx.BoxSizer(wx.VERTICAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_9 = wx.BoxSizer(wx.VERTICAL)
        sizer_10 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7.Add((20, 30), 0, 0, 0)
        sizer_7.Add(self.label_3, 0, wx.TOP | wx.BOTTOM | wx.ALIGN_CENTER_VERTICAL, 10)
        sizer_1.Add(sizer_7, 0, wx.EXPAND, 0)
        sizer_10.Add(self.label_4, 0, wx.LEFT | wx.TOP | wx.ALIGN_RIGHT, 5)
        sizer_9.Add(sizer_10, 0, wx.EXPAND | wx.ALIGN_RIGHT, 0)
        sizer_8.Add(sizer_9, 0, wx.EXPAND, 0)
        sizer_8.Add(self.text_ctrl_2, 1, wx.RIGHT | wx.EXPAND | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_8.Add(self.button_4, 0, wx.RIGHT, 5)
        sizer_1.Add(sizer_8, 0, wx.EXPAND, 0)
        sizer_2.Add(self.label_1, 0, wx.LEFT | wx.TOP | wx.BOTTOM | wx.ALIGN_RIGHT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_2.Add(self.text_ctrl_1, 1, wx.RIGHT | wx.TOP | wx.BOTTOM | wx.EXPAND | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_2.Add(self.button_3, 0, wx.RIGHT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_1.Add(sizer_2, 0, wx.EXPAND, 0)
        sizer_1.Add(self.label_2, 0, wx.LEFT | wx.RIGHT | wx.TOP, 5)
        sizer_4.Add(self.list_box_1, 1, wx.ALL | wx.EXPAND, 5)
        sizer_3.Add(sizer_4, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_3, 1, wx.EXPAND, 0)
        sizer_6.Add(self.button_1, 0, wx.ALL, 5)
        sizer_6.Add(self.button_2, 0, wx.RIGHT | wx.TOP | wx.BOTTOM, 5)
        sizer_5.Add(sizer_6, 0, wx.ALIGN_RIGHT, 0)
        sizer_1.Add(sizer_5, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #dir変更
    def onChangeDir(self, event):  # wxGlade: MyDialog.<event_handler>
        self.changeDir(event)

    #表示
    def onShowFileName(self, event):  # wxGlade: MyDialog.<event_handler>
        self.showFileName()
        event.Skip()

    #cancel
    def onCancel(self, event):  # wxGlade: MyDialog.<event_handler>
        global status
        status = "NG"
        self.Destroy()

    #OK
    def onGetFileName(self, event):  # wxGlade: MyDialog.<event_handler>
        global status, selFile, selFiles
        selFile = self.getFileName()
        selFiles = self.getFileNames()
        #print selFile
        if selFile != "":
            status = "OK"
            self.Destroy()
        else:
            title = _(u"エラー")
            message = _(u"fileを選択してください")
            self.errDialog(title, message)

    #Dクリック
    def onOpenFile(self, event):  # wxGlade: MyDialog.<event_handler>
        fileName = self.getFileName()
        openFile = currDir + "/" + fileName
        pyTreeFoam.runEditor(openFile)
        event.Skip()

    #enter
    def onEnter(self, event):  # wxGlade: MyDialog.<event_handler>
        self.onShowFileName(event)


# end of class MyDialog

    #  changeDir
    #    dirを変更
    def changeDir(self, event):
        global currDir, fileList
        title = _(u"Dirの変更")
        mess = _(u"folderを選択してください。")
        rootDir = os.environ["HOME"]
        selDir = currDir
        [stat, selDir] = getOpenFolderDDialog.Show(title, mess, rootDir,
                            currDir, selDir)
        if stat == "OK":
            currDir = selDir
            self.text_ctrl_2.SetValue(currDir)
            print currDir
            self.showFileName()

    #  setSelectedItems
    #    選択fileを設定
    def setSelectedItems(self):
        i = 0
        for name in fileList:
            for selName in selFiles:
                if name == selName:
                    self.list_box_1.Select(i)
            i += 1

    #  showFileName
    #    listBoxにfileNameを表示
    def showFileName(self):
        global fileList, fileFilter
        fileFilter = self.text_ctrl_1.GetValue()
        fileList = getFileList(currDir, fileFilter)
        self.list_box_1.Clear()
        self.list_box_1.AppendItems(fileList)

    #  getFileName
    #    listBoxからfileNameを取得
    def getFileName(self):
        nameNums = self.list_box_1.GetSelections()
        if len(nameNums) > 0:
            No = nameNums[0]
            name = fileList[No]
        else:
            name = ""
        return name

    #  getFileNames
    #    listBoxから複数のfileNameを取得
    def getFileNames(self):
        nameNums = self.list_box_1.GetSelections()
        names = []
        if len(nameNums) > 0:
            for n in nameNums:
                names.append(self.list_box_1.GetString(n))
        return names


    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()


if __name__ == "__main__":
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    dialog_1 = MyDialog(None, -1, "")
    app.SetTopWindow(dialog_1)
    dialog_1.Show()
    app.MainLoop()
