#!/usr/bin/env python
# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.5 on Sun Nov 25 15:29:56 2012
#
#   getOpenFolderDDialog.py
#
#       treeListからfolderを選択して返す
#
#   12/11/25    新規作成
#      12/02    相対参照も取得できるよう変更
#   13/01/07    ﾀﾞﾌﾞﾙｸﾘｯｸでfolderをopenする事を追加
#      01/12    currentDirにﾁｪｯｸﾏｰｸを追加
#      01/31    open, newFolderﾎﾞﾀﾝを追加
#      02/01    ﾎﾟｯﾌﾟｱｯﾌﾟﾒﾆｭｰを追加
#      02/09    treeにcurrentDirも表示させる事を追加
#      02/10    ｱｲｺﾝが正しく表示されないﾊﾞｸﾞ修正。
#      02/11    ｱｲｺﾝをimageFileから読むように修正
#      02/22    選択行をreload時ｽｸﾛｰﾙする様に修正
#      04/27    messageの表示をhorizontal centerに修正。
#      10/15    国際化のため、修正
#      12/21    stdout、stderrの設定（import logFileCreater）を追加
#   15/06/25    wxPython-2.8→3.0変更に伴う修正
#

#------------コード生成後の変更内容---------------
#
#　・アイコンのdirを　絶対path→相対path　に変更
#　　　./icons/***　に変更
#  ・treeCtrl_1 = の行をコメントアウト
#

import wx
import wx.gizmos
import sys
import os
import shutil
import gio
import pyTreeFoam
import inputTextDDialog

import logFileCreater; logFileCreater.log()


rootDir = u""               #rootDir
caseDir = u""
selDir = u""                #選択した（設定しようとしている）dir
status = ""
currDir = u""               #表示用の現在のdir（長い場合、縮小している）
currentDir = u""            #現在のdir
title = u"開く"
message = u"filderの選択"
treeData = []
selDirList = []
colWidth = [300,            #Tree width
            200,            #solver width
            40,             #nR width
            60,             #st width
            60]             #ed width
dialogShow = "no"


toolOpenID = wx.NewId()
toolSaveID = wx.NewId()


# begin wxGlade: extracode
# end wxGlade

#
#  Show
#    dialogを表示
def Show(titleW, mess, rootDirW, currDirW, selDirW):
    global rootDir, selDir, currDir,currentDir, title, message
    rootDir = rootDirW
    selDir = selDirW
    currDir = currDirW
    currentDir = currDirW
    title = titleW
    message = mess
    #initialize()
    dialog = MyDialog1(None)
    result = dialog.ShowModal()
    return [status, selDir]


class MyDialog1(wx.Dialog):
    def __init__(self, *args, **kwds):
        initialize()
        savePath = os.getcwd()
        treeFoamPath = os.getenv("TreeFoamPath")
        os.chdir(treeFoamPath)

        # begin wxGlade: MyDialog1.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE | wx.RESIZE_BORDER | wx.THICK_FRAME
        wx.Dialog.__init__(self, *args, **kwds)
        self.static_line_7 = wx.StaticLine(self, -1)
        self.label_1 = wx.StaticText(self, -1, _(u"folderを選択"))
        self.bitmap_button_5 = wx.BitmapButton(self, -1, wx.Bitmap("./icons/reload.png", wx.BITMAP_TYPE_ANY))
        self.bitmap_button_1 = wx.BitmapButton(self, -1, wx.Bitmap("./icons/document-open.png", wx.BITMAP_TYPE_ANY))
        self.bitmap_button_2 = wx.BitmapButton(self, -1, wx.Bitmap("./icons/folder-new.png", wx.BITMAP_TYPE_ANY))
        self.bitmap_button_3 = wx.BitmapButton(self, -1, wx.Bitmap("./icons/folder-system.png", wx.BITMAP_TYPE_ANY))
        self.bitmap_button_4 = wx.BitmapButton(self, -1, wx.Bitmap("./icons/user-trash-full.png", wx.BITMAP_TYPE_ANY))
        #self.tree_ctrl_1 = wx.TreeCtrl(self, -1, style=wx.TR_HAS_BUTTONS | wx.TR_NO_LINES | wx.TR_MULTIPLE | wx.TR_MULTIPLE | wx.TR_DEFAULT_STYLE | wx.SUNKEN_BORDER)
        self.checkbox_1 = wx.CheckBox(self, -1, _(u"相対参照で取得する"))
        self.label_2 = wx.StaticText(self, -1, _(u"現在のフォルダ:"))
        self.button_1 = wx.Button(self, -1, _(u"キャンセル"))
        self.button_2 = wx.Button(self, -1, _(u"決定"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onReloadItems, self.bitmap_button_5)
        self.Bind(wx.EVT_BUTTON, self.onOpenFolder, self.bitmap_button_1)
        self.Bind(wx.EVT_BUTTON, self.onInsertFolder, self.bitmap_button_2)
        self.Bind(wx.EVT_BUTTON, self.onRenameFolder, self.bitmap_button_3)
        self.Bind(wx.EVT_BUTTON, self.onDeleteFolder, self.bitmap_button_4)
        self.Bind(wx.EVT_TREE_ITEM_ACTIVATED, self.onItemActivated, self.tree_ctrl_1)
        self.Bind(wx.EVT_TREE_ITEM_COLLAPSED, self.onItemCollapsed, self.tree_ctrl_1)
        self.Bind(wx.EVT_TREE_ITEM_EXPANDED, self.onItemExpanded, self.tree_ctrl_1)
        self.Bind(wx.EVT_BUTTON, self.onCancel, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onSetOpenFolder, self.button_2)
        # end wxGlade

        #tool tipの作成
        self.bitmap_button_1.SetToolTipString(_(u"選択されたフォルダを開く"))
        self.bitmap_button_2.SetToolTipString(_(u"選択されたフォルダ内に\n 新しいフォルダを追加する"))
        self.bitmap_button_3.SetToolTipString(_(u"選択されたフォルダの名称を変更する"))
        self.bitmap_button_4.SetToolTipString(_(u"選択されたフォルダをゴミ箱に移動する"))
        self.bitmap_button_5.SetToolTipString(_(u"treeDataを再読み込みする"))
        self.button_1.SetToolTipString(_(u"何もせずに戻る"))
        self.button_2.SetToolTipString(_(u"フォルダを決定して閉じる"))

        #popup menuのevent
        self.popupmenu = wx.Menu()
        for text in self.setPopupMenuItems():
            if text == "-":
                self.popupmenu.AppendSeparator()
            else:
                item = self.popupmenu.Append(-1, text)
                self.Bind(wx.EVT_MENU, self.OnPopItemSelected, item)
        self.Bind(wx.EVT_TREE_ITEM_RIGHT_CLICK, self.OnShowPopup, self.tree_ctrl_1)   

        #currDirを戻す
        os.chdir(savePath)



    def __set_properties(self):
        # begin wxGlade: MyDialog1.__set_properties
        self.SetTitle(_("dialog_1"))
        self.bitmap_button_5.SetSize(self.bitmap_button_5.GetBestSize())
        self.bitmap_button_1.SetSize(self.bitmap_button_1.GetBestSize())
        self.bitmap_button_2.SetSize(self.bitmap_button_2.GetBestSize())
        self.bitmap_button_3.SetSize(self.bitmap_button_3.GetBestSize())
        self.bitmap_button_4.SetSize(self.bitmap_button_4.GetBestSize())
        # end wxGlade

        self.SetTitle(title)
        self.label_1.SetLabel(message)
        self.setCurrFolder()

        #treeList作成
        self.tree_ctrl_1 = wx.gizmos.TreeListCtrl(self, -1,
            style=
                wx.TR_DEFAULT_STYLE|
                wx.TR_FULL_ROW_HIGHLIGHT|
                wx.TR_HAS_BUTTONS|
                wx.TR_MULTIPLE)
        self.tree_ctrl_1.AddColumn("Tree")
        self.tree_ctrl_1.AddColumn("solver")
        self.tree_ctrl_1.AddColumn("nR")
        self.tree_ctrl_1.AddColumn("st")
        self.tree_ctrl_1.AddColumn("ed")
        self.tree_ctrl_1.SetMainColumn(0)
        self.tree_ctrl_1.SetColumnWidth(0, colWidth[0])
        self.tree_ctrl_1.SetColumnWidth(1, colWidth[1])
        self.tree_ctrl_1.SetColumnWidth(2, colWidth[2])
        self.tree_ctrl_1.SetColumnWidth(3, colWidth[3])
        self.tree_ctrl_1.SetColumnWidth(4, colWidth[4])
        self.tree_ctrl_1.SetMinSize((700, 50))
        self.tree_ctrl_1.SetBackgroundColour(wx.Colour(229, 229, 229))

        #treeCtrlへimageセット
        ilist = wx.ImageList(16,16)
        folderImg = wx.Bitmap("./icons/folder16.png", wx.BITMAP_TYPE_PNG)
        folderDocImg = wx.Bitmap("./icons/folder-documents16.png", wx.BITMAP_TYPE_PNG)
        fileImg = wx.Bitmap("./icons/x-office-document16.png", wx.BITMAP_TYPE_PNG)
        checkImg = wx.Bitmap("./icons/setCase16.png", wx.BITMAP_TYPE_PNG)
        salomeImg = wx.Bitmap("./icons/edit-copy16.png", wx.BITMAP_TYPE_PNG)
        ilist = wx.ImageList(16,16)
        self.fldridx = ilist.Add(folderImg)
        self.OFidx = ilist.Add(fileImg)
        self.OFsolveridx = ilist.Add(folderDocImg)
        self.curridx = ilist.Add(checkImg)
        self.salomeidx = ilist.Add(salomeImg)
        self.tree_ctrl_1.AssignImageList(ilist)

        #treeDataのセット
        self.setTreeData()


    #  setTreeData
    #    treeDataのセット
    def setTreeData(self):
        root = self.tree_ctrl_1.AddRoot(treeData[0])
        rootName = self.tree_ctrl_1.GetItemText(root)
        data = self.setValue(treeData)
        self.AddTreeNodes(root, data)
        self.tree_ctrl_1.SetItemImage(root, self.fldridx,
            wx.TreeItemIcon_Normal)
        selDirList = self.getDirList(rootDir, selDir)
        self.setInitialImage(selDirList)
        self.showFolderInTree(currentDir)       #currentDirまでのfolder取得
        self.setCurrentDirImage()
        currentDirList = self.getDirList(rootDir, currentDir)
        self.setSelectCase(currentDirList)      #currentDirまで表示、選択
        self.setSelectCase(selDirList)          #selDirまで表示、選択


    def __do_layout(self):
        # begin wxGlade: MyDialog1.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_3 = wx.BoxSizer(wx.VERTICAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_6 = wx.BoxSizer(wx.VERTICAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_12 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.static_line_7, 0, wx.BOTTOM | wx.EXPAND, 4)
        sizer_12.Add(self.label_1, 0, wx.TOP | wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_1.Add(sizer_12, 0, wx.ALIGN_CENTER_HORIZONTAL | wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_7.Add((20, 20), 0, 0, 0)
        sizer_7.Add(self.bitmap_button_5, 0, 0, 0)
        sizer_7.Add(self.bitmap_button_1, 0, 0, 0)
        sizer_7.Add(self.bitmap_button_2, 0, 0, 0)
        sizer_7.Add(self.bitmap_button_3, 0, 0, 0)
        sizer_7.Add(self.bitmap_button_4, 0, 0, 0)
        sizer_1.Add(sizer_7, 0, wx.EXPAND, 0)
        sizer_1.Add((500, 5), 0, 0, 0)
        sizer_2.Add((5, 300), 0, 0, 0)
        sizer_2.Add(self.tree_ctrl_1, 1, wx.RIGHT | wx.EXPAND, 0)
        sizer_2.Add((5, 100), 0, 0, 0)
        sizer_1.Add(sizer_2, 1, wx.EXPAND, 0)
        sizer_6.Add(self.checkbox_1, 0, wx.LEFT | wx.TOP, 10)
        sizer_6.Add(self.label_2, 0, wx.LEFT, 40)
        sizer_5.Add(sizer_6, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_5, 0, wx.EXPAND, 0)
        sizer_4.Add(self.button_1, 0, wx.LEFT | wx.TOP | wx.BOTTOM | wx.ALIGN_RIGHT, 10)
        sizer_4.Add(self.button_2, 0, wx.ALL, 10)
        sizer_3.Add(sizer_4, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_3, 0, wx.ALIGN_RIGHT, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    def onItemActivated(self, event):  # wxGlade: MyDialog1.<event_handler>
        self.itemOpen(event)
        #event.Skip()

    def onItemCollapsed(self, event):  # wxGlade: MyDialog1.<event_handler>
        self.itemCollapsed(event)
        event.Skip()

    def onItemExpanded(self, event):  # wxGlade: MyDialog1.<event_handler>
        self.itemExpand(event)
        event.Skip()

    def onOpenFolder(self, event):  # wxGlade: MyDialog1.<event_handler>
        self.itemOpen(event)
        event.Skip()

    def onInsertFolder(self, event):  # wxGlade: MyDialog1.<event_handler>
        self.insertNewFolder(event)
        event.Skip()

    def onCancel(self, event):  # wxGlade: MyDialog1.<event_handler>
        global status
        status = "NG"
        self.Destroy()

    def onSetOpenFolder(self, event):  # wxGlade: MyDialog1.<event_handler>
        global status
        self.getSelectFolder(event)
        status = "OK"
        self.Destroy()
        event.Skip()

    def onReloadItems(self, event):  # wxGlade: MyDialog1.<event_handler>
        print _(u"treeを再読み込みします。")
        self.reloadItems()
        event.Skip()

    def onRenameFolder(self, event):  # wxGlade: MyDialog1.<event_handler>
        self.renameFolder(event)
        event.Skip()

    def onDeleteFolder(self, event):  # wxGlade: MyDialog1.<event_handler>
        self.deleteFolder(event)
        event.Skip()

# end of class MyDialog1

    #------ popup menu -------------------------- 
    def setPopupMenuItems(self):
        menu = [_(u"再読み込み"),"-", _(u"開く"), _(u"新しいfolder追加"),
                _(u"folder名変更"),"-", _(u"削除")]
        return menu

    def OnPopItemSelected(self, event):
        PPitem = self.popupmenu.FindItemById(event.GetId())
        text = PPitem.GetText()
        if text == _(u"再読み込み"):
            self.onReloadItems(event)
        elif text == _(u"開く"):
            self.itemOpen(event)
        elif text == _(u"新しいfolder追加"):
            self.insertNewFolder(event)
        elif text == _(u"folder名変更"):
            self.renameFolder(event)
        elif text == _(u"削除"):
            self.deleteFolder(event)

    def OnShowPopup(self, event):
        item = event.GetItem()
        pos = event.GetPoint()
        self.tree_ctrl_1.PopupMenu(self.popupmenu, pos)
    #--------------------------------------------


    #  deleteFolder
    #    folder削除
    def deleteFolder(self, event):
        global selDir
        print _(u"フォルダを削除します")
        item = self.tree_ctrl_1.GetSelection()
        delDir = self.getDirectory(item)
        title = _(u"フォルダの削除")
        if delDir == currentDir:
            mess = _(u"currDirは、削除できません")
            self.warningDialog(title, mess)
            return

        if len(delDir) < len(currentDir):
            if currentDir[:len(delDir)+1] == delDir + "/":
                mess = _(u"削除するフォルダ内にcurrDirが含まれるので、削除できません")
                self.warningDialog(title, mess)
                return

        mess = _(u"以下のフォルダをゴミ箱に移動します。\n ") + delDir
        stat = self.okCancelDialog(title, mess)
        if stat != "OK":
            return

        parent = self.tree_ctrl_1.GetItemParent(item)
        childrenList = self.getChildrenList(parent)
        if len(childrenList) == 1:
            #親itemをselDirに設定
            selDir = self.getDirectory(parent)
        else:
            #子item[0]をselDirに設定
            selDir = self.getDirectory(parent) + "/" + childrenList[0]
        item = self.getItem(selDir)
        self.tree_ctrl_1.SelectItem(item, item, True)
        mess = ""
        try:
            #ファイルをゴミ箱へ移動
            obj = gio.File(delDir.encode("utf-8"))
            obj.trash()
        except:
            mess = _(u"「") + delDir + _(u"」フォルダが削除できませんでした。")
            print mess
        if mess != "":
            self.errDialog(title, mess)
        self.reloadItems()


    #  insertNewFolder
    #    folder追加
    def insertNewFolder(self, event):
        global selDir
        print _(u"フォルダを追加します")
        item = self.tree_ctrl_1.GetSelection()
        itemDir = self.getDirectory(item)
        folderName = itemDir + "/newFolder"
        n = 0
        error = "NG"
        while error == "NG":
            newFolderName = folderName + "_" + str(n)
            try:
                os.mkdir(newFolderName)
                error = "OK"
            except:
                n += 1
        selDir = newFolderName
        self.reloadItems()
        self.renameFolder(event)

    #  reloadItems
    #    Tree data からリスト作成
    def reloadItems(self):
        global rootDir, selDir, currentDir, treeData
        #全てのdataを削除
        self.tree_ctrl_1.DeleteAllItems()
        #rootのdirを取得
        treeData = pyTreeFoam.getTreeDirOnlylRootChildren(rootDir.encode("utf-8"))
        root = self.tree_ctrl_1.AddRoot(treeData[0])
        rootName = self.tree_ctrl_1.GetItemText(root)
        #treeDataの作成
        data = self.setValue(treeData)
        self.AddTreeNodes(root, data)
        self.tree_ctrl_1.SetItemImage(root, self.fldridx,
            wx.TreeItemIcon_Normal)
        #currentDirの設定（チェックマーク）
        self.setInitialImage(currentDir)
        selDirList = self.getDirList(rootDir, selDir)
        self.setSelectCase(selDirList)
        item = self.tree_ctrl_1.GetSelection()
        self.tree_ctrl_1.ScrollTo(item)
        item = self.getItem(currentDir)
        self.tree_ctrl_1.SetItemImage(item, self.curridx, 0,
            wx.TreeItemIcon_Normal)
        #currentDirをTreeに追加（隠れている場合）
        self.showFolderInTree(currentDir)
        #selDirを表示
        item = self.getItem(selDir)
        self.tree_ctrl_1.ScrollTo(item)

    #  showFolderInTree
    #    指定したfolderを表示させる（既に表示されている場合は変化無し）
    def showFolderInTree(self, folderDir):
        folderList = folderDir[len(rootDir)+1:].split(u"/")
        RootDir = convUnicode(rootDir)
        FolderDir = convUnicode(folderDir)
        [childrenList, files] = pyTreeFoam.getFoldersFiles(RootDir)
        wdir = RootDir
        parent = self.getItem(wdir)
        for name in folderList:
            flag = 0
            self.tree_ctrl_1.Expand(parent)
            self.setImageToChildren(wdir, childrenList, FolderDir)
            for child in childrenList:
                if name == child:
                    wdir += "/" + name
                    parent = self.getItem(wdir)
                    childrenList = self.getChildrenList(parent)
                    self.checkGrandChildren(wdir, childrenList)
                    flag = 1
                    break
            if flag == 0:
                print _(u"「") + FolderDir + _(u"」が存在しません")
                break

    def setImageToChildren(self, wdir, childrenList, showDir):
        for child in childrenList:
            directory = wdir + u"/" + child
            item = self.getItem(directory)
            itemText = child
            check = pyTreeFoam.checkFolder(directory)
            if check == "folder":
                self.tree_ctrl_1.SetItemImage(item, self.fldridx,
                    wx.TreeItemIcon_Normal)
            elif check == "case":
                solver = pyTreeFoam.getSolver(directory)
                nRst = pyTreeFoam.getNumberResult(directory)
                self.setItemOFImage(item, solver, nRst)
            elif check == "salome":
                self.tree_ctrl_1.SetItemImage(item, self.salomeidx,
                    wx.TreeItemIcon_Normal)
            if directory == showDir:
                self.tree_ctrl_1.SetItemImage(item, self.curridx, 0,
                    wx.TreeItemIcon_Normal)

    def checkGrandChildren(self, Pdir, childrenList):
        for child in childrenList:
            wdir = Pdir + "/" + child
            parent = self.getItem(wdir)
            dummyList = self.getChildrenList(parent)
            if len(dummyList) == 0:
                folders = pyTreeFoam.getFoldersOnlyCurrDir(wdir)
                folders.sort()
                for folder in folders:
                    itemText = folder.split("/")[-1]
                    check = pyTreeFoam.checkFolder(folder)
                    if check == "folder":
                        newItem = self.tree_ctrl_1.AppendItem(parent, itemText)
                        self.tree_ctrl_1.SetItemImage(newItem, self.fldridx,
                            wx.TreeItemIcon_Normal)
                    elif (check == "case"):
                        newItem = self.tree_ctrl_1.AppendItem(parent, itemText)
                        solver = pyTreeFoam.getSolver(folder)
                        nRst = pyTreeFoam.getNumberResult(folder)
                        self.setItemOFImage(newItem, solver, nRst)
                    elif (check == "salome"):
                        newItem = self.tree_ctrl_1.AppendItem(parent, itemText)
                        self.tree_ctrl_1.SetItemImage(newItem, self.salomeidx,
                            wx.TreeItemIcon_Normal)


    #  renameFolder
    #    folder名変更
    def renameFolder(self, event):
        global selDir
        item = self.tree_ctrl_1.GetSelection()
        saveDir = self.getDirectory(item)
        saveCaseItem = self.getItem(currentDir)
        #editName = self.tree_ctrl_1.GetItemText(item)
        editName = self.getTreeNameFromItem(item)
        if editName == rootDir:
            title = _(u"フォルダ名変更")
            mess = _(u"root名は、変更できません。")
            self.errDialog(title, mess)
            return

        parent = self.tree_ctrl_1.GetItemParent(item)
        childrenList = self.getChildrenList(parent)
        inputTextDDialog.title = _(u"folder名の変更")
        inputTextDDialog.message = _(u"変更するfolder名を入力してください。")
        inputTextDDialog.inputText = editName
        dialog = inputTextDDialog.MyDialog(None)
        result = dialog.ShowModal()
        if inputTextDDialog.status == "OK":
            text = inputTextDDialog.inputText
        else:
            text = u""
        if text != u"":
            flag = 0
            for name in childrenList:
                if name == text:
                    if name != editName:
                        msg = _(u"フォルダ内に同じ名前があります。")
                        self.errDialog(_(u"エラー"), msg)
                    flag = 1
                    break
            if flag == 0:
                self.tree_ctrl_1.SetItemText(item, text)
                parentDir = self.getDirectory(parent)
                editDir = parentDir + "/" + editName
                textDir = parentDir + "/" + text
                shutil.move(editDir, textDir)
                selDir = textDir
        self.reloadItems()



    def setCurrFolder(self):
        global currDir
        if currDir[0] != "/":
            currDir = os.path.abspath(currDir)
        maxl = 80
        if len(currDir) > maxl:
            currDir = u"..." + currDir[-(maxl-3):]
        text = _(u"現在のフォルダ: ") + currDir
        self.label_2.SetLabel(text)

    def itemOpen(self, event):
        item = self.tree_ctrl_1.GetSelection()
        directory = self.getDirectory(item)
        pyTreeFoam.openFolderNautilus(directory)

#-------------------TreeData---------------------------------------------------
    #
    # setValue
    #   treeのデータ構造
    #    ['root', [
    #        '0', 
    #        ['constant', [
    #             ['polyMesh', [
    #                'sets',
    #                'sets.bak',
    #                'sss']]]], 
    #        'model',
    #        'solve.log.analyzed', 
    #        ['system', [
    #            'test']]]]
    #
    def setValue(self, treeData):
        data = treeData[1]
        return data

    # AddTreeNode
    def AddTreeNodes(self, parentItem, items):
        for item in items:
            #if type(item) == str:
            if type(item) == str or type(item) == unicode:
                newItem = self.tree_ctrl_1.AppendItem(parentItem, item)
                self.tree_ctrl_1.SetItemImage(newItem, self.fldridx,
                    wx.TreeItemIcon_Normal)
            else:
                newItem = self.tree_ctrl_1.AppendItem(parentItem, item[0])
                self.AddTreeNodes(newItem, item[1])
                self.tree_ctrl_1.SetItemImage(newItem, self.fldridx,
                    wx.TreeItemIcon_Normal)

    #
    #  getDirList
    #    directoryのlistを求める
    def getDirList(self, root, directory):
        dirList = []
        dirList.append(root)
        wlist = directory[len(root)+1:].split("/")
        for name in wlist:
            dirList.append(name)
        return dirList

    #
    #  setInitialImage
    #    初期のimageアイコンをセット
    def setInitialImage(self, selDirList):
        parent = self.tree_ctrl_1.GetRootItem()
        #parentName = self.tree_ctrl_1.GetItemText(parent)
        parentName = self.getTreeNameFromItem(parent)
        setDir = parentName
        for folder in selDirList[1:]:
            #parentのchildren[]を取得
            children = self.getChildrenList(parent)
            #全childrenをチェック
            item, cookie = self.tree_ctrl_1.GetFirstChild(parent)
            for child in children:
                checkDir = setDir + "/" + child
                checkResult = pyTreeFoam.checkFolder(checkDir)
                if (checkResult == "case"):
                    itemOF = item
                    solver = pyTreeFoam.getSolver(checkDir)
                    nRst = pyTreeFoam.getNumberResult(checkDir)
                    self.setItemOFImage(itemOF, solver, nRst)
                elif (checkResult == "salome"):
                    self.tree_ctrl_1.SetItemImage(item, self.salomeidx, 0,
                        wx.TreeItemIcon_Normal)
                item, cookie = self.tree_ctrl_1.GetNextChild(parent, cookie)
            item, cookie = self.tree_ctrl_1.GetFirstChild(parent)
            for child in children:
                parentName = ""
                if type(folder) == str:
                    folder = folder.decode("utf-8")
                if folder == child:
                    parent = item
                    #parentName = self.tree_ctrl_1.GetItemText(parent)
                    parentName = self.getTreeNameFromItem(parent)
                    setDir = setDir + "/" + parentName
                    break
                item, cookie = self.tree_ctrl_1.GetNextChild(parent, cookie)
            if parentName == "":
                break

    # setCurrentDirImage
    #  currentDirのImage（アイコン）を設定
    def setCurrentDirImage(self):
        item = self.getItem(currentDir)
        wdir = self.getDirectory(item)
        if currentDir == wdir:
            self.tree_ctrl_1.SetItemImage(item, self.curridx, 0,
                wx.TreeItemIcon_Normal)

    # setSelectCase
    #  treeDataからcurrentCaseをselectする
    #  dataDirは、listデータ[**, **, .., **]を受け取る。
    def setSelectCase(self, dataDir):
        i=0
        while (i<len(dataDir)):
            if type(dataDir[i]) == str:
                dataDir[i] = dataDir[i].decode("utf-8")
            i=i+1
        parent = self.tree_ctrl_1.GetRootItem()
        i=1
        while (i<len(dataDir)):
            self.tree_ctrl_1.Expand(parent)
            #全chilrenをチェック
            items = self.getChildrenItems(parent)
            itemNames = self.getChildrenList(parent)
            ii=0
            while ii<len(itemNames):
                if type(itemNames[ii]) == str:
                    itemNames[ii] = itemNames[ii].decode("utf-8")
                ii=ii+1
            flag = 0
            ii=0
            while ii<len(itemNames):
                if itemNames[ii] == dataDir[i]:
                    parent = items[ii]
                    flag = 1
                    break
                ii=ii+1
            if flag == 0:
                print dataDir, _(u"のDirがありません。")
                break
            i=i+1
        self.tree_ctrl_1.SelectItem(parent, parent, True)

    # getChildrenList
    #  親itemから子のtextを取得
    def getChildrenList(self, parent):
        children = []
        #firstChild
        item, cookie = self.tree_ctrl_1.GetFirstChild(parent)
        while item:
            #children.append(self.tree_ctrl_1.GetItemText(item))
            children.append(self.getTreeNameFromItem(item))
            #nextChild
            item, cookie = self.tree_ctrl_1.GetNextChild(parent, cookie)
        return children

    # setItemOFImage
    #  OpenFoamのImageをセット
    def setItemOFImage(self, itemOF, solver, nRst):
        self.tree_ctrl_1.SetItemImage(itemOF, self.OFidx, 0,
            wx.TreeItemIcon_Normal)
        self.tree_ctrl_1.SetItemText(itemOF, solver, 1)
        self.tree_ctrl_1.SetItemImage(itemOF, self.OFsolveridx, 1,
            wx.TreeItemIcon_Normal)
        if len(nRst)>0:
            self.tree_ctrl_1.SetItemText(itemOF, nRst[0], 2)
            self.tree_ctrl_1.SetItemText(itemOF, nRst[1], 3)
            self.tree_ctrl_1.SetItemText(itemOF, nRst[2], 4)

    #  getSelectFolder
    #    選択したfolderを取得
    def getSelectFolder(self, event):
        global selDir, currentDir
        selItem = self.tree_ctrl_1.GetSelection()
        selDir = self.getDirectory(selItem)
        if self.checkbox_1.GetValue() == True:
            selDir = os.path.relpath(selDir, currentDir)

    #  itemCollapsed
    #    folderTree縮小時
    def itemCollapsed(self, event):
        collItem = event.GetItem()
        rootItem = self.tree_ctrl_1.GetRootItem()
        selItem = self.tree_ctrl_1.GetSelection()
        if collItem == rootItem:
            self.tree_ctrl_1.SelectItem(rootItem, rootItem, True)
        if selItem == rootItem:
            parent = rootItem
        else:
            parent = self.tree_ctrl_1.GetItemParent(selItem)
        while parent != rootItem:
            if parent == collItem:
                self.tree_ctrl_1.SelectItem(parent, parent, True)
                break
            parent = self.tree_ctrl_1.GetItemParent(parent)
        #孫item削除
        self.delGrandChildrenItem(collItem)
        #self.clearStatus()
        #self.setBackgroundColour()

    #
    #  delGrandChildrenItem
    #    孫itemの削除
    def delGrandChildrenItem(self, parent):
        children = self.getChildrenItems(parent)
        for childItem in children:
            self.tree_ctrl_1.DeleteChildren(childItem)

    #
    #  itemExpand
    #    folderTree展開
    def itemExpand(self, event):
        parent = event.GetItem()
        #parentの子itemのイメージをセット
        self.setChildrenImage(parent)
        #parentの子itemに解析caseあればimageをセット
        self.setChildrenImageSolveCase(parent)
        #parentの孫itemを追加（孫が
        self.addGrandChildren(parent)
        #子itemを折りたたむ
        self.collapseChildren(parent)
        #self.setBackgroundColour()

    # setChildrenImage
    #  childrenにイメージをセット
    def setChildrenImage(self, parent):
        childrenItems = self.getChildrenItems(parent)
        for childItem in childrenItems:
            checkDir = self.getDirectory(childItem)
            if (pyTreeFoam.checkFolder(checkDir) == "case"):
                solver = pyTreeFoam.getSolver(checkDir)
                nRst = pyTreeFoam.getNumberResult(checkDir)
                self.setItemOFImage(childItem, solver, nRst)                
            elif (pyTreeFoam.checkFolder(checkDir) == "salome"):
                self.tree_ctrl_1.SetItemImage(childItem, self.salomeidx, 0,
                    wx.TreeItemIcon_Normal)

    # setChildrenImageSolveCase
    #  childrenに解析caseがあればimageをセット
    def setChildrenImageSolveCase(self, parent):
        childrenItems = self.getChildrenItems(parent)
        for childItem in childrenItems:
            checkDir = self.getDirectory(childItem)
            if checkDir == currentDir:
                self.tree_ctrl_1.SetItemImage(childItem, self.curridx, 0,
                    wx.TreeItemIcon_Normal)

    #
    #  addGrandChildren
    #    親itemから孫itemを追加
    def addGrandChildren(self, parent):
        childrenItems = self.getChildrenItems(parent)
        for childItem in childrenItems:
            directory = self.getDirectory(childItem)
            folders = pyTreeFoam.getFoldersOnlyCurrDir(directory)
            folders.sort()
            nowFolders = self.getChildrenList(childItem)
            #孫itemが空なら孫itemを追加
            if len(nowFolders) == 0:
                for folder in folders:
                    itemText = folder.split("/")[-1]
                    check = pyTreeFoam.checkFolder(folder)
                    if (check == "folder"):
                        newItem = self.tree_ctrl_1.AppendItem(childItem, itemText)
                        self.tree_ctrl_1.SetItemImage(newItem, self.fldridx,
                            wx.TreeItemIcon_Normal)
                    elif (check == "case"):
                        newItem = self.tree_ctrl_1.AppendItem(childItem, itemText)
                        solver = pyTreeFoam.getSolver(folder)
                        nRst = pyTreeFoam.getNumberResult(folder)
                        self.setItemOFImage(newItem, solver, nRst)
                    elif (check == "salome"):
                        newItem = self.tree_ctrl_1.AppendItem(childItem, itemText)
                        self.tree_ctrl_1.SetItemImage(newItem, self.salomeidx,
                            wx.TreeItemIcon_Normal)

    #
    #  getChildrenItems
    #    親itemから子itemを取得
    def getChildrenItems(self, parent):
        items = []
        #firstChild
        item, cookie = self.tree_ctrl_1.GetFirstChild(parent)
        while item:
            items.append(item)
            #nextChild
            item, cookie = self.tree_ctrl_1.GetNextChild(parent, cookie)
        return items


    # getItem
    #  directoryからTreeItemを取得
    def getItem(self, directory):
        global rootDir
        treeDir = directory[len(rootDir)+1:].split("/")
        parent = self.tree_ctrl_1.GetRootItem()
        for name in treeDir:
            childrenItem = self.getChildrenItems(parent)
            flag = 0
            for item in childrenItem:
                #child = self.tree_ctrl_1.GetItemText(item)
                child = self.getTreeNameFromItem(item)
                if name == child:
                    flag = 1
                    break
            if flag == 1:
                parent = item
            else:
                ans = ""
                break
        ans = item
        return ans


    # getDirectory
    #  TreeDataからdirectoryを取得
    def getDirectory(self, item):
        #name = self.tree_ctrl_1.GetItemText(item)
        name = self.getTreeNameFromItem(item)
        selectDir = ""
        while (name != ""):
            selectDir = "/" + name + selectDir
            item = self.tree_ctrl_1.GetItemParent(item)
            #name = self.tree_ctrl_1.GetItemText(item)
            name = self.getTreeNameFromItem(item)
        selectDir = selectDir[1:]
        return selectDir

    def getTreeNameFromItem(self, item):
        if item.IsOk():
            name = self.tree_ctrl_1.GetItemText(item)
        else:
            name = ""
        return name

    def collapseChildren(self, parent):
        children = self.getChildrenItems(parent)
        for childItem in children:
            self.tree_ctrl_1.Collapse(childItem)


    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        stat = ""
        if ans == wx.ID_OK:
            stat = "OK"
        else:
            stat = "CANCEL"
        return stat

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def warningDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_QUESTION) 
        dlg.ShowModal()
        dlg.Destroy()



#
#  initilize
#    初期化
def initialize():
    global rootDir, selDir, treeData
    treeData = pyTreeFoam.getTreeDirUntilCurrCase(rootDir.encode("utf-8"), selDir.encode("utf-8"))

#  convUnicode
#    文字列をunicodeに変換
def convUnicode(string):
    if type(string) == str:
        ans = string.decode("utf-8")
    else:
        ans = string
    return ans


if __name__ == "__main__":
    rootDir = sys.argv[1]
    selDir = sys.argv[2]
    initialize()
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    dialog_1 = MyDialog1(None, -1, "")
    app.SetTopWindow(dialog_1)
    dialog_1.Show()
    app.MainLoop()
