#!/usr/bin/env python
# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.3 on Sun Apr 10 13:38:31 2011
#
#       meshOperationDialog.py
#
#       メッシュ操作に関する処理
#
#       programed by s.fujii
#           11/04/10    新規作成
#           12/12/09    領域分割方法をOFver2.0.0以降のchtMultiRegionに対応
#           13/01/08    changeDict編集ボタンを追加
#              01/25    ﾊﾞｸﾞ修正（zone名変更時に違うzoneが変更される事がある）
#              02/09    changeDictの編集、実行方法を変更
#              04/07    メッシュ抽出を削除
#              04/21    pyOFLauncherをpyMeshOperationに変更
#              05/20    makeRegionPropertiesの内容をversionで変更する。
#              05/21    changeDictにUのfixedValueを追加
#              06/29    makeInternalPatchをOF-2.2.0用を追加
#              06/30    setsファイルを各regionに配布する様に修正
#              09/25    makeSetsFileInRegionをgzip、binaryに対応させる
#              10/15    国際化のため修正
#              11/15    modelの場所が変更できるようtextBox追加
#              12/08    csvによるmesh作成を追加
#              12/21    stdout、stderrの設定（import logFileCreater）を追加
#           14/02/08    snappyDialogを表示させる時、closeする様に修正
#              05/03    領域分割方法をOFver2.3.0に対応
#              07/21    メッシュ分割時、T fieldが存在しない場合ｴﾗｰ発生を修正
#              07/26    meshSplitRegion:constant/polyMeshの削除を追加
#              10/05    meshSplitRegion:fluidRegions, solidRegions内のfileｺﾋﾟｰと
#                       includefileのｺﾋﾟｰ。界面の境界条件設定を追加
#              10/13    copyIncludeFile:バグ修正
#              10/24    checkNullPatchInAddFieldsを追加
#              11/11    copyIncludeFile:errorメッセージ修正
#              12/09    changeCellZoneName, changeFaceZoneName, openPolyMesh,
#                       meshSplitCellZones:meshDirをcurrMeshに変更
#                       onOpenPolyMesh:meshが無かった場合、caseDirを開く
#              12/25    copyFilesInRegions:fluidSolidRegions内の「***.**」ﾌｧｲﾙｺﾋﾟｰの
#                       バグ修正。
#           15/02/07    meshSplitRegion:timeFolder内のfield作成方法を修正。
#                       constant、system、timeFolderとも同じ方法に設定した。
#              02/11    runBlockMesh:FOAM端末上で実行する様に修正
#              07/13    helyxOS_dataの場所変更
#              07/17    dialog起動方法を修正
#              10/02    changeCellZoneName, changeFaceZoneName, openPolyMeshを削除
#                       cfMesh、checkMeshボタンを追加
#              11/28    snappyHexMesh:OF-3.0.0用を追加
#           16/09/08    meshSplitRegion:mesh分割をOF-4.0用を追加
#              12/30    replacementDict400,replacementSolidDict400:OF-4.0用に
#                       changeDictionaryの書式を修正（バグ）
#              12/31    snappyHexMesh,makeInternalPatch,makeRegionProperties,
#                       copyIncludeFile,replacementDict,replacementSolidDict:
#                       OF-ext用に修正
#

import wx
import os
import glob
import string
import pyMeshOperation
import pyTreeFoam
import getFoamContents
import splitMeshCellZones
import separateCellZoneGroupDialog
import selectConjugateCouplingFieldsDialog
import changeZoneNameDialog
import setCouplingConjugateDialog
import setFoamContents
import getOpenFolderDDialog
from createBafflesDialog import Show as createBafflesDialogShow
from createBafflesDialog220 import Show as createBafflesDialog220Show
from snappyHexMeshDialog import Show as snappyHexMeshDialogShow
from snappyHexMeshDialog220 import Show as snappyHexMeshDialog220Show
from snappyHexMeshDialog300 import Show as snappyHexMeshDialog300Show
from createBCsForMultiRegionDialog import replaceRegionFieldBoundaryConditions

import logFileCreater; logFileCreater.log()


helyxDataFile = "data/helyxOS_data"
caseDir = ""
blockMeshDir = ""


# begin wxGlade: extracode
# end wxGlade

def Show():
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()

class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_8 = wx.StaticText(self, wx.ID_ANY, _(u"メッシュ操作に関する処理の実行"))
        self.button_14 = wx.Button(self, wx.ID_ANY, _(u"blockMeshDict編集"))
        self.button_15 = wx.Button(self, wx.ID_ANY, _(u"blockMesh実行"))
        self.button_10 = wx.Button(self, wx.ID_ANY, _("checkMesh"))
        self.button_16 = wx.Button(self, wx.ID_ANY, _(u"snappyHexMeshによる\nmesh作成..."))
        self.label_5 = wx.StaticText(self, wx.ID_ANY, _(u"snappyHeMeshDictを直接編集、または\ncsvファイルからDict作成し、meshを作成する"))
        self.button_5 = wx.Button(self, wx.ID_ANY, _(u"    cfMeshによる   \n    mesh作成..."))
        self.label_6 = wx.StaticText(self, wx.ID_ANY, _(u"csvファイルからmeshDictを作成し、\ncfMeshでmeshを作成する。"))
        self.sizer_15_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"メッシュ作成"))
        self.label_1 = wx.StaticText(self, wx.ID_ANY, _(u"変換fileの場所"))
        self.button_6 = wx.Button(self, wx.ID_ANY, _(u"開く"))
        self.text_ctrl_1 = wx.TextCtrl(self, wx.ID_ANY, "")
        self.button_12 = wx.Button(self, wx.ID_ANY, _(u"参照..."))
        self.button_1 = wx.Button(self, wx.ID_ANY, _(u"unv2gmshToFoam...\n(face,volumeをｸﾞﾙｰﾌﾟ化)"))
        self.button_2 = wx.Button(self, wx.ID_ANY, _(u"ideasUnvToFoam...\n(faceのみｸﾞﾙｰﾌﾟ化)"))
        self.label_2 = wx.StaticText(self, wx.ID_ANY, _(u"unv形式からfoam形式に変換。「mesh.unv」ﾌｧｲﾙを変換する"))
        self.button_3 = wx.Button(self, wx.ID_ANY, _(u"スケール変更..."))
        self.label_3 = wx.StaticText(self, wx.ID_ANY, _(u"メッシュのスケールを変更"))
        self.sizer_11_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"メッシュ変換"))
        self.button_4 = wx.Button(self, wx.ID_ANY, _(u"内部patch作成..."))
        self.label_4 = wx.StaticText(self, wx.ID_ANY, _(u"internal patchの作成\n(baffle,cyclic,mapped etc.)"))
        self.sizer_6_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"内部パッチの作成"))
        self.button_7 = wx.Button(self, wx.ID_ANY, _(u"領域分割(Region)...   "))
        self.button_13 = wx.Button(self, wx.ID_ANY, _(u"領域分割(Conjugate)..."))
        self.button_9 = wx.Button(self, wx.ID_ANY, _(u"coupling再設定..."))
        self.label_7 = wx.StaticText(self, wx.ID_ANY, _(u"cellZone毎に領域分割"))
        self.sizer_7_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"領域分割"))
        self.button_8 = wx.Button(self, wx.ID_ANY, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onEditBlockMeshDict, self.button_14)
        self.Bind(wx.EVT_BUTTON, self.onRunBlockMesh, self.button_15)
        self.Bind(wx.EVT_BUTTON, self.onCheckMesh, self.button_10)
        self.Bind(wx.EVT_BUTTON, self.onSnappyHexMesh, self.button_16)
        self.Bind(wx.EVT_BUTTON, self.onCfMesh, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.onOpenFolder, self.button_6)
        self.Bind(wx.EVT_BUTTON, self.onSetFolderDir, self.button_12)
        self.Bind(wx.EVT_BUTTON, self.onUnv2gmshToFoam, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onIdeasUnvToFoam, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onScaleChange, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onMakeInternalPatch, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onMeshSplitCellZones, self.button_7)
        self.Bind(wx.EVT_BUTTON, self.onMeshSplitConjugate, self.button_13)
        self.Bind(wx.EVT_BUTTON, self.recoupleConjugate, self.button_9)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_8)
        # end wxGlade

        self.setDataInTextBox()


    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_(u"メッシュ操作"))
        self.button_6.SetMinSize((40, 30))
        self.button_12.SetMinSize((60, 30))
        self.button_1.SetMinSize((180, 48))
        self.button_2.SetMinSize((180, 48))
        self.button_4.SetMinSize((120, 30))
        self.button_7.SetToolTipString(_(u"chtMutiRegion用に分割"))
        self.button_13.SetToolTipString(_(u"conjugate用に分割"))
        self.button_9.SetMinSize((148, 25))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_8 = wx.BoxSizer(wx.VERTICAL)
        sizer_9 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_7_staticbox.Lower()
        sizer_7 = wx.StaticBoxSizer(self.sizer_7_staticbox, wx.VERTICAL)
        sizer_14 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_6_staticbox.Lower()
        sizer_6 = wx.StaticBoxSizer(self.sizer_6_staticbox, wx.VERTICAL)
        self.sizer_11_staticbox.Lower()
        sizer_11 = wx.StaticBoxSizer(self.sizer_11_staticbox, wx.VERTICAL)
        sizer_12 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_16 = wx.BoxSizer(wx.VERTICAL)
        sizer_4 = wx.BoxSizer(wx.VERTICAL)
        sizer_17 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_15_staticbox.Lower()
        sizer_15 = wx.StaticBoxSizer(self.sizer_15_staticbox, wx.VERTICAL)
        sizer_10 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_20 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_19 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_13 = wx.BoxSizer(wx.VERTICAL)
        sizer_18 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.label_8, 0, wx.TOP | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_19.Add(self.button_14, 0, wx.ALL, 3)
        sizer_19.Add(self.button_15, 0, wx.ALL, 3)
        sizer_18.Add(self.button_10, 0, wx.ALL, 3)
        sizer_13.Add(sizer_18, 1, wx.ALIGN_RIGHT, 0)
        sizer_19.Add(sizer_13, 1, wx.EXPAND, 0)
        sizer_15.Add(sizer_19, 0, wx.EXPAND, 0)
        sizer_20.Add(self.button_16, 0, wx.ALL, 3)
        sizer_20.Add(self.label_5, 0, wx.LEFT | wx.RIGHT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_15.Add(sizer_20, 0, wx.EXPAND, 0)
        sizer_10.Add(self.button_5, 0, wx.ALL, 3)
        sizer_10.Add(self.label_6, 0, wx.LEFT | wx.RIGHT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_15.Add(sizer_10, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_15, 1, wx.ALL | wx.EXPAND, 10)
        sizer_11.Add(self.label_1, 0, wx.LEFT | wx.ALIGN_BOTTOM, 5)
        sizer_2.Add(self.button_6, 0, wx.LEFT | wx.TOP | wx.ALIGN_BOTTOM, 3)
        sizer_3.Add(self.text_ctrl_1, 1, wx.ALIGN_BOTTOM, 0)
        sizer_2.Add(sizer_3, 1, wx.EXPAND, 0)
        sizer_2.Add(self.button_12, 0, wx.RIGHT | wx.ALIGN_BOTTOM, 5)
        sizer_11.Add(sizer_2, 0, wx.EXPAND, 5)
        sizer_17.Add(self.button_1, 0, wx.LEFT | wx.RIGHT, 3)
        sizer_17.Add(self.button_2, 0, wx.LEFT | wx.RIGHT, 3)
        sizer_4.Add(sizer_17, 1, wx.EXPAND, 0)
        sizer_11.Add(sizer_4, 1, wx.EXPAND, 0)
        sizer_11.Add(self.label_2, 0, wx.LEFT | wx.BOTTOM, 5)
        sizer_16.Add(self.button_3, 0, wx.ALL, 3)
        sizer_12.Add(sizer_16, 0, wx.EXPAND, 0)
        sizer_12.Add(self.label_3, 0, wx.LEFT | wx.BOTTOM | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_11.Add(sizer_12, 0, wx.TOP | wx.EXPAND, 3)
        sizer_1.Add(sizer_11, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_6.Add(self.button_4, 0, wx.LEFT | wx.RIGHT | wx.TOP, 3)
        sizer_6.Add(self.label_4, 0, wx.LEFT | wx.BOTTOM, 5)
        sizer_5.Add(sizer_6, 1, wx.LEFT | wx.RIGHT | wx.EXPAND, 10)
        sizer_7.Add(self.button_7, 0, wx.LEFT | wx.TOP, 3)
        sizer_7.Add(self.button_13, 0, wx.LEFT, 3)
        sizer_14.Add(self.button_9, 0, wx.LEFT, 15)
        sizer_7.Add(sizer_14, 1, wx.EXPAND, 0)
        sizer_7.Add(self.label_7, 0, wx.LEFT | wx.BOTTOM, 5)
        sizer_5.Add(sizer_7, 1, wx.LEFT | wx.RIGHT | wx.EXPAND, 10)
        sizer_1.Add(sizer_5, 0, wx.EXPAND, 0)
        sizer_9.Add(self.button_8, 0, wx.ALL | wx.ALIGN_RIGHT, 10)
        sizer_8.Add(sizer_9, 0, wx.ALIGN_RIGHT, 0)
        sizer_1.Add(sizer_8, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #blockMesh編集
    def onEditBlockMeshDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.editBlockMeshDict()

    #blockMesh実行
    def onRunBlockMesh(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runBlockMesh()

    #checkMesh実行
    def onCheckMesh(self, event):  # wxGlade: MyFrame.<event_handler>
        self.checkMesh()

    #snappyHexMesh
    def onSnappyHexMesh(self, event):  # wxGlade: MyFrame.<event_handler>
        self.snappyHexMesh()

    #cfMesh
    def onCfMesh(self, event):  # wxGlade: MyFrame.<event_handler>
        self.cfMesh()

    #開く
    def onOpenFolder(self, event):  # wxGlade: MyFrame.<event_handler>
        modelDir = self.text_ctrl_1.GetValue()
        if len(glob.glob(modelDir)) == 0:
            mess = _(u"設定したfolderは存在しません。\n場所を再設定してください。")
            self.errDialog(_(u"エラー"), mess)
            return
        pyTreeFoam.openFolderNautilus(modelDir)

    #参照...
    def onSetFolderDir(self, event):  # wxGlade: MyFrame.<event_handler>
        self.getModelDir()

    #unv2gmshToFoam
    def onUnv2gmshToFoam(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"mesh変換します。")
        title = _(u"メッシュ変換")
        message = _(u"「unv2gmshToFoam」でメッシュ変換します。\n　（volumeを定義した上で変換してください。）")
        ans = self.okCancelDialog(title, message)
        if ans == "OK":
            #modelDir = "./model"
            modelDir = self.text_ctrl_1.GetValue()
            pyMeshOperation.unv2gmshToFoam(modelDir)
            pyMeshOperation.changeMagScale(modelDir)
        event.Skip()

    #ideasUnvToFoam
    def onIdeasUnvToFoam(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"mesh変換します。")
        title = _(u"メッシュ変換")
        message = _(u"「ideasUnvToFoam」でメッシュ変換します。\n　（volumeを定義した場合は、unv2gmshToFoamでメッシュ変換してください。）")
        ans = self.okCancelDialog(title, message)
        if ans == "OK":
            #modelDir = "./model"
            modelDir = self.text_ctrl_1.GetValue()
            pyMeshOperation.ideasUnvToFoam(modelDir)
            pyMeshOperation.changeMagScale(modelDir)
        event.Skip()

    #scaleChange
    def onScaleChange(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"モデルのスケールを変更します。")
        pyMeshOperation.scaleMesh()
        event.Skip()

    #makeInternalPatch
    def onMakeInternalPatch(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"内部パッチを作成します。")
        self.makeInternalPatch()
        event.Skip()

    #meshSplitCellZones
    def onMeshSplitCellZones(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"cellZone毎にメッシュの領域を分割します。")
        if self.okCancelDialog(_(u"メッシュの領域分割"),
                  _(u"メッシュをcellZone毎に領域分割します。")) == "OK":            
            self.meshSplitRegion()
        event.Skip()

    #close
    def onClose(self, event): # wxGlade: MyFrame.<event_handler>
        #終了時にmodelDirを保存する
        caseDir = os.getcwd()
        modelDir = self.text_ctrl_1.GetValue()
        saveModelDir(caseDir, modelDir)
        #self.Close(True)
        self.Destroy()

    #meshSplitConjugate
    def onMeshSplitConjugate(self, event): # wxGlade: MyFrame.<event_handler>
        title = _(u"メッシュ分割（conjugate用）")
        mess = _(u"メッシュをconjugate用に分割します。")
        result = self.okCancelDialog(title, mess)
        if result == "OK":
            self.meshSplitConjugate()
        event.Skip()

    #recoupleConjugate
    def recoupleConjugate(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"couplingを再設定します")
        self.recoupleConju()
        event.Skip()

# end of class MyFrame


    #
    #  cfMesh
    #    cfMeshDialogを表示
    def cfMesh(self):
        global caseDir, stlDir
        stlDir = self.text_ctrl_1.GetValue()
        comm = "cfMeshDialog.py " + caseDir + " " + stlDir + " &"
        os.system(comm)
        self.Destroy()

    #
    #  snappyHexMesh
    #    snappyHexMeshDialogを表示
    def snappyHexMesh(self):
        global caseDir, blockMeshDir
        stlDir = self.text_ctrl_1.GetValue()
        config = pyTreeFoam.readConfigTreeFoam()
        OFversion = config[0]
        if OFversion[:3] == "ext":
            #OF-ext
            self.Destroy()
            snappyHexMeshDialogShow(caseDir, blockMeshDir, stlDir)
        elif OFversion < "2.2.0":
            #ver 2.1以下の場合
            self.Destroy()
            snappyHexMeshDialogShow(caseDir, blockMeshDir, stlDir)
        elif OFversion < "3.0.0":
            #ver 2.4以下の場合
            self.Destroy()
            snappyHexMeshDialog220Show(caseDir, blockMeshDir, stlDir)
        else:
            #ver 3.0.0以上の場合
            self.Destroy()
            blockMeshDir = "system"
            snappyHexMeshDialog300Show(caseDir, blockMeshDir, stlDir)

    #
    #  runBlockMesh
    #    blockMesh作成
    def runBlockMesh(self):
        global caseDir, blockMeshDir
        config = pyTreeFoam.readConfigTreeFoam()
        envOpenFOAM = config[1]
        blockDict = blockMeshDir + "/blockMeshDict"
        caseName = caseDir.split("/")[-1]
        cont = "#!/bin/bash\n"
        cont = ". " + envOpenFOAM + "\n"
        cont += "blockMesh -dict " + blockDict + " | tee solve.log\n"
        #スクリプト作成
        comm = "echo " + "'" + cont + "'" + " > run"
        os.system(comm)
        os.system("chmod a+x run")
        comm = "gnome-terminal -t " + caseName + " --geometry=120x20 --zoom=0.9 -x bash --rcfile run"
        os.system(comm)

    #
    #  checkMesh
    #    checkMesh実行
    def checkMesh(self):
        caseName = caseDir.split("/")[-1]
        cont  = "#!/bin/bash\n"
        cont += "checkMesh | tee solve.log\n"
        comm = "echo " + "'" + cont + "'" + " > run"
        os.system(comm)
        os.system("chmod a+x run")
        comm = "gnome-terminal -t " + caseName + " --geometry=120x20 --zoom=0.9 -x bash --rcfile run"
        #os.system(comm)
        pyTreeFoam.runOFUtility(comm)

    #
    #  editBlockMeshDict
    #    blockMeshDict編集
    def editBlockMeshDict(self):
        global caseDir, blockMeshDir
        fileName = caseDir + "/" + blockMeshDir + "/blockMeshDict"
        if len(glob.glob(fileName)) == 0:
            title = _(u"エラー")
            mess = _(u"blockMeshDictが存在しません。\n")
            self.errDialog(title, mess)
            return
        pyTreeFoam.runEditor(fileName)


    #  getModelDir
    #    modelDirを取得
    def getModelDir(self):
        #caseDir = os.getcwd()
        rootDir = os.environ["HOME"].encode("utf-8")
        title = _(u"開く")
        message = _(u"folderを選択する")
        modelDir = self.text_ctrl_1.GetValue()
        if modelDir[0] != "/":
            modelDir = os.path.abspath(modelDir).encode("utf-8")
        else:
            modelDir = modelDir.encode("utf-8")
        [stat, ansDir] = getOpenFolderDDialog.Show(title, message, rootDir, caseDir, modelDir)
        if stat == "OK":
            modelDir = ansDir
            self.text_ctrl_1.SetValue(modelDir)
            saveModelDir(caseDir, modelDir)


    #  setDataInTextBox
    #    textBoxにデータセット
    def setDataInTextBox(self):
        caseDir = os.getcwd()
        modelDir = getStlDir(caseDir)
        self.text_ctrl_1.SetValue(modelDir)

    #
    #  makeInternalPatch
    #    内部patch作成
    def makeInternalPatch(self):
        print _(u"内部patchを作成しています。")
        config = pyTreeFoam.readConfigTreeFoam()
        OFversion = config[0]
        if OFversion[:3] == "ext":
            pyMeshOperation.makePatch()
        elif OFversion >= "2.2.0":
            createBafflesDialog220Show()
        elif OFversion >= "2.0.0":
            createBafflesDialogShow()
        else:
            pyMeshOperation.makePatch()

    #
    #  recoupleConju
    #    couplingの再設定
    def recoupleConju(self):
        regions = self.getRegionList()
        setCouplingConjugateDialog.regionList = regions
        dialog = setCouplingConjugateDialog.MyDialog(None)
        result = dialog.ShowModal()

    #  getRegionList
    def getRegionList(self):
        caseDir = os.getcwd()
        mess = ""
        regions = []
        region0 = caseDir + "/constant/polyMesh"
        if len(glob.glob(region0)) != 0:
            regions.append(["region0", region0])
            wdir = caseDir + "/constant"
            [folders, files] = pyTreeFoam.getFoldersFiles(wdir)
            for folder in folders:
                if folder != "polyMesh":
                    region1 = wdir + "/" + folder + "/polyMesh"
                    if len(glob.glob(region1)) != 0:
                        regions.append([folder, region1])
                    else:
                        mess = region1 + _(u"は、存在しません。")
            if len(regions) <= 1:
                mess = _(u"couplingする相手のregionが存在しません。") 
        else:
            mess = _(u"OpenFOAMのcaseDirではありません。")
        if mess != "":
            title = _(u"エラー")
            self.errDialog(title, mess)
        if len(regions)<=1:
            regions=[]
        return regions

    #
    #  meshSplitRegion
    #    chtMultiRegion用にメッシュ分割
    def meshSplitRegion(self):
        error = splitMeshCellZones.Run()
        if error[0] == "NG":
            self.okCancelDialog(_(u"エラー"), error[1])
        else:
            msg = _(u"領域（region）に分割しました。")
            saveDir = os.getcwd()
            regDir = saveDir + "/regCase"
            os.chdir(regDir)
            currTime = getFoamContents.getCurrTimeFolder(regDir)
            reDir = getFoamContents.getCurrMeshDir(saveDir, currTime, ".", "boundary")
            #wdir = regDir + "/constant/polyMesh"
            wdir = saveDir + "/" + reDir
            zoneNames = getFoamContents.cellZoneNamesDir(wdir)
            zoneNames.sort()
            #流体・固体領域を設定
            separateCellZoneGroupDialog.cellZoneNames = zoneNames
            dialog = separateCellZoneGroupDialog.MyDialog(None)
            result = dialog.ShowModal()
            if separateCellZoneGroupDialog.status == "OK":
                fluidCellZones = separateCellZoneGroupDialog.liquidCellZones
                solidCellZones = separateCellZoneGroupDialog.solidCellZones
                dialog.Destroy()
                self.makeRegionProperties(fluidCellZones, solidCellZones)
                #changeDictionaryAllRegionsを作成
                makeChangeDictionaryAllRegionsDict(regDir,
                    fluidCellZones, solidCellZones)
                #changeDictionaryAllRegionsを実行
                self.runChangeDictionaryAllRegions()
                #setsを各region毎に作成
                makeSetsFileInRegion(regDir, zoneNames)
                #constant/polyMeshを削除
                #deleteConstantPolyMesh(regDir)
                #fluidRegions, solidRegionsフォルダ内のfileを各regionにコピー
                timeFolders = pyTreeFoam.getTimeFolders(regDir)
                deleteTimeSystemRegionFiles(regDir, timeFolders[0], zoneNames)
                copyFilesInFluidRegions(regDir, timeFolders[0], fluidCellZones)
                copyFilesInSolidRegions(regDir, timeFolders[0], solidCellZones)
                copyIncludeFile(regDir, fluidCellZones, solidCellZones)
                #終了処理
                msg = _(u"メッシュをcellZone毎に領域分割し、新しい分割Case「regCase」を作成しました。\n解析caseを「regCase」に設定してください。")
                self.okDialog(_(u"メッシュの領域分割"), msg)
            else:
                dialog.Destroy()
            os.chdir(saveDir)

    """
    #  checkChangeDictionaryRegions200
    #    changeDictionaryAllRegionsの修正
    def checkChangeDictionaryRegions200(self, solidCellZones):
        config = pyTreeFoam.readConfigTreeFoam()
        OFversion = config[0]
        if OFversion >= "2.2.0":
            #OF-2.2以降の場合
            fileName = "system/changeDictionaryAllRegionsDict"
            f=open(fileName); contents=f.read(); f.close()
            ps = getFoamContents.skipFoamFileMem(contents, 0)
            for zone in solidCellZones:
                pz = getFoamContents.getKeywordPointerMem(zone, contents, ps)
                [kCont,p] = getFoamContents.getKeywordContentsMem(zone, contents, pz)
                newCont = self.replaceKeyword(kCont, "fluidThermo", "solidThermo")
                newCont = zone + "\n{" + newCont + "}\n"
                contents = contents[:pz] + newCont + contents[pz+len(newCont):]
            #修正版を書き込み
            f=open(fileName, "w"); f.write(contents); f.close()
            print _(u"changeDictionaryAllRegionsDictを書き換えました。")
        elif OFversion >= "2.0.0":
            #OF-2.0以降（2.0〜2.1）の場合
            fileName = "system/changeDictionaryAllRegionsDict"
            f=open(fileName); contents=f.read(); f.close()
            ps = getFoamContents.skipFoamFileMem(contents, 0)
            for zone in solidCellZones:
                pz = getFoamContents.getKeywordPointerMem(zone, contents, ps)
                [kCont,p] = getFoamContents.getKeywordContentsMem(zone, contents, pz)
                newCont = self.replaceKeyword(kCont, "basicThermo", "solidThermo")
                newCont = zone + "\n{" + newCont + "}\n"
                contents = contents[:pz] + newCont + contents[pz+len(newCont):]
            #修正版を書き込み
            f=open(fileName, "w"); f.write(contents); f.close()
            print _(u"changeDictionaryAllRegionsDictを書き換えました。")
    """

    #  replaceKeyword
    #    bNameをnewNameに置き換える
    def replaceKeyword(self, cont, bName, newName):
        p=0; n=0
        while p<len(cont) and n>=0:
            n = cont[p:].find(bName)
            if n > 0:
                newCont = cont[:p+n] + newName + cont[p+n+len(bName):]
                cont = newCont
                p += n
        return cont

    def runChangeDictionaryAllRegions(self):
        comm = "changeDictionaryAllRegions.py"
        pyTreeFoam.runOFUtility(comm)


    def makeRegionProperties(self, fluidRegions, solidRegions):
        config = pyTreeFoam.readConfigTreeFoam()
        OFversion = config[0]
        if OFversion[:3] == "ext":
            #version extの場合
            #foamFile作成
            foamFile = setFoamContents.makeFoamHeader()
            foamFile += setFoamContents.makeFoamFile("2.0", "ascii", "dictionary",
                    "constant", "regionProperties")
            footer = setFoamContents.makeFooter()

            #regionPropertiesの内容作成
            contents = "fluidRegionNames ( "
            for name in fluidRegions:
                contents += name + " "
            contents += ");\n\n"

            contents += "solidRegionNames ( "
            for name in solidRegions:
                contents += name + " "
            contents += ");\n"

        elif OFversion >= "2.2.0":
            #version 2.2.0以降の場合
            #foamFile作成
            foamFile = setFoamContents.makeFoamHeader()
            foamFile += setFoamContents.makeFoamFile("2.2", "ascii", "dictionary",
                    "constant", "regionProperties")
            footer = setFoamContents.makeFooter()

            #regionPropertiesの内容作成
            contents = "regions\n(\n"
            contents += "    fluid       ( "
            for name in fluidRegions:
                contents += name + " "
            contents += ")\n"

            contents += "    solid       ( "
            for name in solidRegions:
                contents += name + " "
            contents += ")\n);\n"
        else:
            #version 2.1.1以前の場合
            #foamFile作成
            foamFile = setFoamContents.makeFoamHeader()
            foamFile += setFoamContents.makeFoamFile("2.0", "ascii", "dictionary",
                    "constant", "regionProperties")
            footer = setFoamContents.makeFooter()

            #regionPropertiesの内容作成
            contents = "fluidRegionNames ( "
            for name in fluidRegions:
                contents += name + " "
            contents += ");\n\n"

            contents += "solidRegionNames ( "
            for name in solidRegions:
                contents += name + " "
            contents += ");\n"

        #書き込み
        contentsDict = foamFile + contents + footer
        fileName = os.getcwd() + "/constant/regionProperties"
        f = open(fileName, "w")
        f.write(contentsDict)
        f.close()


    #
    #  meshSplitCojugate
    #    conjugate用にメッシュ分割
    def meshSplitConjugate(self):
        #regCaseフォルダ有無チェック
        error = checkRegCase()
        if error[0] != "NG":
            #領域分割
            error = splitMeshCellZones.RunConjugate()
        if error[0] != "NG":
            #領域分割後のfluid,solidグループ分け
            saveDir = os.getcwd()
            regDir = saveDir + "/regCase"
            os.chdir(regDir)
            wdir = regDir + "/constant/polyMesh"
            zoneNames = getFoamContents.cellZoneNamesDir(wdir)
            os.chdir(saveDir)
            zoneNames.sort()
            separateCellZoneGroupDialog.cellZoneNames = zoneNames
            dialog = separateCellZoneGroupDialog.MyDialog(None)
            result = dialog.ShowModal()
            if separateCellZoneGroupDialog.status == "OK":
                fluidCellZones = separateCellZoneGroupDialog.liquidCellZones
                solidCellZones = separateCellZoneGroupDialog.solidCellZones
                dialog.Destroy()
                if len(fluidCellZones) != 1:
                    mess = _(u"流体側のcellZoneが選択されていないか、2ヶ以上選択しています。\n  流体側のcellZoneを1ヶのみ選択してください。")
                    error = ["NG", mess]
                else:
                    #boundaryFileをconjugate用に修正
                    time = pyTreeFoam.getTimeFolders(regDir)
                    splitMeshCellZones.remakeBoundaryFileConjugate(regDir,
                        time[0], fluidCellZones[0])
                    #各fieldのboundaryをregionCouplingに変更
                    wdir = regDir + "/" + time[0] + "/" + fluidCellZones[0]
                    [status, fields] = self.getCouplingFields(wdir)
                    if status == "OK":
                        splitMeshCellZones.remakeBoundaryRegionCoupling(
                            regDir, time[0], fields)
                    #folder整形、リンクの作成
                    pyTreeFoam.remakeFolderConjugate(fluidCellZones,
                        solidCellZones)
                    title = _(u"メッシュの領域分割")
                    mess = _(u"メッシュをconjugate用に分割しました。\n  引き続き継続する場合は、「regCase」に移動してください。")
                    self.okDialog(title, mess)
            else:
                dialog.Destroy()
        # error表示
        if error[0] == "NG":
            title = _(u"エラー")
            mess = error[1]
            self.errDialog(title, mess)

    def getCouplingFields(self, wdir):
        [folders, files] = pyTreeFoam.getFoldersFiles(wdir)
        selectConjugateCouplingFieldsDialog.cellZoneNames = files
        dialog = selectConjugateCouplingFieldsDialog.MyDialog(None)
        result = dialog.ShowModal()
        status = selectConjugateCouplingFieldsDialog.status
        dialog.Destroy()
        fields = []
        if status == "OK":
            fields = selectConjugateCouplingFieldsDialog.liquidCellZones
        return [status, fields]


    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        if ans == wx.ID_OK:
            dlg.Destroy()
            return "OK"
        else:
            dlg.Destroy()
            return "CANCEL"

    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

#-----------------------

#  deleteTimeSystemRegionFiles
#    各region内の全fieldを削除
def deleteTimeSystemRegionFiles(regDir, timeFolder, zoneNames):
    for name in zoneNames:
        delNameDir = regDir + "/" + timeFolder + "/" + name
        comm = "rm " + delNameDir + "/*"
        os.system(comm)
        delNameDir = regDir + "/system/" + name
        comm = "rm " + delNameDir + "/*"
        os.system(comm)

#
#  copyIncludeFile
#    includeファイルや境界条件を再設定
def copyIncludeFile(regCaseDir, fluidRegions, solidRegions):
    config = pyTreeFoam.readConfigTreeFoam()
    OFversion = config[0]
    if OFversion >= "2.2.0" and OFversion[:3] != "ext":
        #境界条件を再設定
        [error, mess] = replaceRegionFieldBoundaryConditions(regCaseDir,
            fluidRegions, solidRegions)
        if error != "OK":
            print _(u"\nregionWallBoundaryConditionsDictのの内容は、反映されていません。")
        else:
            print _(u"\nregion間の境界条件を「regionWallBoundaryConditionsDict」に従って再設定しました。")


#
#  copyFilesInFluidRegions
#    fluidRegions内のfileを各regionにコピー
def copyFilesInFluidRegions(regCaseDir, timeFolder, fluidRegions):
    if len(fluidRegions) == 0:
        return
    baseDir = regCaseDir + "/" + timeFolder
    copyFilesInRegions(baseDir, "fluidRegions", fluidRegions)
    checkNullPatchInAddFields(regCaseDir, timeFolder, "fluidRegions", fluidRegions)
    baseDir = regCaseDir + "/constant"
    copyFilesInRegions(baseDir, "fluidRegions", fluidRegions)
    baseDir = regCaseDir + "/system"
    copyFilesInRegions(baseDir, "fluidRegions", fluidRegions)

#
#  copyFilesInSolidRegions
#    solidRegions内のfileを各regionにコピー
def copyFilesInSolidRegions(regCaseDir, timeFolder, solidRegions):
    if len(solidRegions) == 0:
        return
    baseDir = regCaseDir + "/" + timeFolder
    copyFilesInRegions(baseDir, "solidRegions", solidRegions)
    checkNullPatchInAddFields(regCaseDir, timeFolder, "fluidRegions", solidRegions)
    baseDir = regCaseDir + "/constant"
    copyFilesInRegions(baseDir, "solidRegions", solidRegions)
    baseDir = regCaseDir + "/system"
    copyFilesInRegions(baseDir, "solidRegions", solidRegions)

#  copyFilesInRegions
#
def copyFilesInRegions(baseDir, fluidSolidRegions, regNames):
    sourceDir = baseDir + "/" + fluidSolidRegions
    files = glob.glob(sourceDir+"/*")
    for fileName in files:
        nameList = (fileName.split("/")[-1]).split(".")
        if len(nameList) == 1:
            for regName in regNames:
                sourceName = fileName
                pasteFolder = baseDir + "/" + regName
                comm = "cp -f " + sourceName + " " + pasteFolder
                os.system(comm)
    for fileName in files:
        nameList = (fileName.split("/")[-1]).split(".")
        if len(nameList) > 1:
            nameDir = "/".join(fileName.split("/")[:-1])
            sourceName = nameDir + "/" + ".".join(nameList)
            pasteFolder = baseDir + "/" + nameList[-1]
            pasteName = pasteFolder + "/" + ".".join(nameList[:-1])
            comm = "cp -f " + sourceName + " " + pasteName
            os.system(comm)

#  checkNullPatchInAddFields
#    追加したfieldの空patchをチェック修正
def checkNullPatchInAddFields(regCaseDir, timeFolder, fluidSolidRegions, regNames):
    baseDir = regCaseDir + "/" + timeFolder
    sourceDir = baseDir + "/" + fluidSolidRegions
    files = glob.glob(sourceDir+"/*")
    if len(files) == 0:
        return

    fields = []
    for name in files:
        field = name.split("/")[-1]
        fields.append(field)
    for regName in regNames:
        relativePolyMeshDir = getFoamContents.getCurrMeshDir(regCaseDir, timeFolder,
            regName, "boundary")
        polyMeshDir = regCaseDir + "/" + relativePolyMeshDir
        fieldDir = baseDir + "/" + regName
        clearFields = []
        for field in fields:
            if len(glob.glob(fieldDir + "/" + field)) != 0:
                clearFields.append(field)
        if len(clearFields) > 0:
            setFoamContents.clearNullBoundaryFields(fieldDir, polyMeshDir,
                clearFields)
    return


def deleteConstantPolyMesh(regCaseDir):
    comm = "rm -rf " + regCaseDir + "/constant/polyMesh"
    os.system(comm)


def saveModelDir(caseDir, modelDir):
    helyxData = helyxDataFile.split("/")[-1]
    fileNameCase = caseDir + "/" + helyxData
    #fileNameTr = os.environ["TreeFoamPath"] + "/" + helyxDataFile
    fileNameTr = os.environ["TreeFoamUserPath"] + "/" + helyxDataFile
    if len(glob.glob(fileNameCase)) == 0:
        comm = "cp " + fileNameTr + " " + caseDir
        os.system(comm)
    fileName = fileNameCase
    f=open(fileName); cont=f.readlines(); f.close()
    i = 0
    while i < len(cont):
        line = cont[i]
        comm = line.split()
        if comm[0] == "stlDir":
            cont[i] = comm[0] + " " + modelDir + "\n"
            break            
        i += 1
    f=open(fileName, "w")
    for line in cont:
        f.write(line)
    f.close()

def getStlDir(caseDir):
    helyxData = helyxDataFile.split("/")[-1]
    fileNameCase = caseDir + "/" + helyxData
    #fileNameTr = os.environ["TreeFoamPath"] + "/" + helyxDataFile
    fileNameTr = os.environ["TreeFoamUserPath"] + "/" + helyxDataFile
    if len(glob.glob(fileNameCase)) == 1:
        fileName = fileNameCase
    else:
        fileName = fileNameTr
    stlDir = ""
    if len(glob.glob(fileName)) != 0:
        f=open(fileName); cont=f.readlines(); f.close()
        for line in cont:
            comm = line.split()
            if comm[0] == "stlDir":
                stlDir = comm[1]
                break
    else:
        cont = "stlDir  ./model\n"
        cont += "surfaceAngle  150\n"
        cont += "clearMesh  yes\n"
        f=open(fileNameTr, "w"); f.write(cont); f.close()
    if stlDir == "":
        stlDir = "./model"
    return stlDir


def checkRegCase():
    wdir = os.getcwd()
    if len(glob.glob(wdir + "/regCase")) == 0:
        error = ["OK", ""]
    else:
        mess = _(u"既に「regCase」が存在します。\n  「regCase」フォルダを削除して再実行してください。")
        error = ["NG", mess]
    return error


def getSplitedRegions():
    wdir = os.getcwd() + "/regCase"
    timeFolders = pyTreeFoam.getTimeFolders(wdir)
    timeFolder = timeFolders[0]
    regions = glob.glob(wdir + "/" + timeFolder + "/*")
    ans = []
    for name in regions:
        region = name.split("/")[-1]
        ans.append(region)
    ans.sort()
    return ans

#
#  makeSetsFileInRegion
#    各region毎にsetsfile作成
def makeSetsFileInRegion(caseDir, regions):
    iniTime = pyTreeFoam.getTimeFolders(caseDir)[0]
    #分割前のmesh
    meshDir = caseDir + "/" + iniTime
    if len(glob.glob(meshDir+"/polyMesh/boundary")) == 0:
        meshDir = caseDir + "/constant"
    #regionのmesh
    regMeshDir = caseDir + "/" + iniTime
    if len(glob.glob(regMeshDir+"/"+regions[0]+"/polyMesh/boundary")) == 0:
        regMeshDir = caseDir + "/constant"
    #分割前のsetsFile取得
    [folders, setsFiles] = pyTreeFoam.getFoldersFiles(meshDir+"/polyMesh/sets")
    cellSets = []
    faceSets = []
    pointSets = []
    for setsFile in setsFiles:
        fileName = meshDir + "/polyMesh/sets/" + setsFile
        cont = getFoamContents.readFileFull(fileName)
        [foamCont, p] = getFoamContents.getKeywordContentsMem("FoamFile", cont, 0)
        foamLines = foamCont.split("\n")
        for line in foamLines:
            words = line.split()
            if len(words) == 2:
                if words[0] == "class":
                    [name, p] = getFoamContents.getKeywordMem(words[1], 0)
                    if name == "cellSet":
                        cellSets.append(setsFile)
                    elif name == "faceSet":
                        faceSets.append(setsFile)
                    elif name == "pointSet":
                        pointSets.append(setsFile)
    #各regionにsets作成
    for region in regions:
        #setsフォルダ作成
        folderDir = regMeshDir + "/" + region + "/polyMesh/sets"
        comm = "mkdir " + folderDir
        os.system(comm)
    #cellSet作成
    OFversion = pyTreeFoam.readConfigTreeFoam()[0]
    for cellSet in cellSets:
        print "cellSet:", cellSet, _(u"を確認中...")
        #allCell取得
        sourceFile = meshDir + "/polyMesh/sets/" + cellSet
        cells = getFileData(sourceFile)
        #各region毎に作成
        for region in regions:
            #meetするcellを取得
            IdFile = regMeshDir + "/" + region + "/polyMesh/cellRegionAddressing"
            cellAdds = getFileData(IdFile)
            newCells = getMeetSetsData(cells, cellAdds)
            if len(newCells) > 0:
                #meetするcellを保存
                data = ["cellSet", cellSet, newCells]
                fileName = regMeshDir + "/" + region + "/polyMesh/sets/" + cellSet
                createNewSetsFile(OFversion, fileName, data)
    #faceSet作成
    for faceSet in faceSets:
        print "faceSet:", faceSet, _(u"を確認中...")
        sourceFile = meshDir + "/polyMesh/sets/" + faceSet
        faces = getFileData(sourceFile)
        #各region毎に作成
        for region in regions:
            #meetするcellを取得
            IdFile = regMeshDir + "/" + region + "/polyMesh/faceRegionAddressing"
            faceAdds = getFileData(IdFile)
            newFaces = getMeetSetsData(faces, faceAdds)
            if len(newFaces) > 0:
                #meetするcellを保存
                data = ["faceSet", faceSet, newFaces]
                fileName = regMeshDir + "/" + region + "/polyMesh/sets/" + faceSet
                createNewSetsFile(OFversion, fileName, data)
    #pointSet作成
    for pointSet in pointSets:
        print "pointSet:", faceSet, _(u"を確認中...")
        sourceFile = meshDir + "/polyMesh/sets/" + pointSet
        points = getFileData(sourceFile)
        #各region毎に作成
        for region in regions:
            #meetするcellを取得
            IdFile = regMeshDir + "/" + region + "/polyMesh/pointRegionAddressing"
            pointAdds = getFileData(IdFile)
            newPoints = getMeetSetsData(points, pointAdds)
            if len(newPoints) > 0:
                #meetするcellを保存
                data = ["pointSet", pointSet, newPoints]
                fileName = regMeshDir + "/" + region + "/polyMesh/sets/" + pointSet
                createNewSetsFile(OFversion, fileName, data)
    


#  getMeetSetsData
#    合致するSetsdataを取得
def getMeetSetsData(cells, cellAdds):
    newCells = []
    n = 0
    i = 0
    while n < len(cells) and i < len(cellAdds):
        cell = cells[n]
        cellAdd = cellAdds[i]
        if cell == cellAdd:
            newCells.append(i)
            i += 1
            n += 1
        elif cell > cellAdd:
            i += 1
        else:
            n += 1
    return newCells        

#  createNewSetsFile
#    setsFileを保存
def createNewSetsFile(OFversion, fileName, data):
    className = data[0]
    name = data[1]
    numCells = data[2]
    #数字を文字に変換
    newCells = []
    for numCell in numCells:
        newCells.append(str(numCell))
    #保存内容を取得
    header = setFoamContents.makeFoamHeaderVersion(OFversion)
    name = getFoamContents.getOrgFileName(name)     #非圧縮のfile名に戻す
    foamFile = setFoamContents.makeFoamFile("2.0", "ascii", className, "", name)
    cont = makeFileData(newCells)
    footer = setFoamContents.makeFooter()
    #保存
    writeCont = header + foamFile + cont + footer
    getFoamContents.writeFileFull(fileName, writeCont)


#  makeFileData
#    fileData作成
def makeFileData(cells):
    cont = str(len(cells)) + "\n"
    cont += "(\n"
    cont += "\n".join(cells) + "\n"
    cont += ")\n"
    return cont


#  getFileData
#    file内のデータをlist形式の整数で取得
def getFileData(fileName):
    [ascii, data] = getFoamContents.readFileSeparate(fileName)
    ans = []
    if getFoamContents.checkBinary(ascii) == "binary":
        numData = getFoamContents.structBinData(data[0])
        for n in numData:
            ans.append(n)
    else:
        numList = data[0][1].split()
        for n in numList:
            if len(n) > 0:
                ans.append(int(n))
    ans.sort()
    return ans
        

#
#  makeChangeDictionaryAllRegionsDict
#    changeDictionaryAllRegionsDictを作成する。
#    OpenFOAMのバージョンに応じて作成
def makeChangeDictionaryAllRegionsDict(regCaseDir, fluidRegions, solidRegions):
    #OFversion取得
    config = pyTreeFoam.readConfigTreeFoam()
    OFversion = config[0]
    times = pyTreeFoam.getTimeFolders(regCaseDir)
    timeFolder = times[0]
    #各region毎にchangeDictionaryRegionsDict作成
    c = []
    c.append(headerDict(OFversion))
    #fluidRegionの設定
    for regName in fluidRegions:
        field = "T"
        fieldDir = regCaseDir + "/" + timeFolder + "/" + regName + "/" + field
        if len(glob.glob(fieldDir)) != 0:
            patches = getPatches(fieldDir)
            repContents = replacementDict(regName, field, patches, OFversion)
            c.append(regName + "\n")
            c.append("{\n")
            c.append(repContents)
            c.append("}\n")
            c.append("\n")
    #solidRegionの設定
    for regName in solidRegions:
        field = "T"
        fieldDir = regCaseDir + "/" + timeFolder + "/" + regName + "/" + field
        if len(glob.glob(fieldDir)) != 0:
            patches = getPatches(fieldDir)
            repContents = replacementSolidDict(regName, field, patches, OFversion)
            c.append(regName + "\n")
            c.append("{\n")
            c.append(repContents)
            c.append("}\n")
            c.append("\n")
    c.append(footerDict())
    f=open(regCaseDir + "/system/changeDictionaryAllRegionsDict", "w")
    for line in c:
        f.write(line)
    f.close()
    print _(u"\nsystemフォルダ内に「changeDictionaryAllRegionsDict」を作成しました。")


def getPatches(fieldDir):
    regName = fieldDir.split("/")[-2]
    fileName = fieldDir
    cont = getFoamContents.readField(fileName, 100)
    [boundaryCont, p] = getFoamContents.getKeywordContentsMem("boundaryField", cont, 0)
    lines = boundaryCont.split("\n")
    patches = []
    for line in lines:
        n = line.find(regName + "_to_")
        if n>=0:
            patch = line.split()[0]
            patches.append(patch)
    return patches

#
#  replacementDict
#    OpenFOAMのバージョンに応じたfluid側のdictを作成する
def replacementDict(regName, field, patches, OFversion):
    if OFversion[:3] == "ext":
        cont = replacementDict171(field, patches)
    elif OFversion >= "4.0":
        cont = replacementDict400(field, patches)
    elif OFversion >= "2.3.0":
        cont = replacementDict230(field, patches)
    elif OFversion >= "2.2.0":
        cont = replacementDict220(field, patches)
    elif OFversion >= "2.0.0":
        cont = replacementDict200(field, patches)
    else:
        cont = replacementDict171(field, patches)
    return cont


def replacementDict171(field, patches):
    c=""
    c=c+    "    dictionaryReplacement\n"
    c=c+    "    {\n"
    c=c+    "        " + field + "\n"
    c=c+    "        {\n" 
    c=c+    "            boundaryField\n"
    c=c+    "            {\n"
    for patch in patches:
        c=c+"                " + patch + "\n"
        c=c+"                {\n"
        c=c+"                    type            solidWallMixedTemperatureCoupled;\n"
        c=c+"                    neighbourFieldName  " + field + ";\n"
        c=c+"                    K               K;\n"
        c=c+"                    value           uniform 0;\n"
        c=c+"                }\n"
    c=c+    "            }\n"
    c=c+    "        }\n"
    c=c+    "        U\n"
    c=c+    "        {\n" 
    c=c+    "            boundaryField\n"
    c=c+    "            {\n"
    for patch in patches:
        c=c+"                " + patch + "\n"
        c=c+"                {\n"
        c=c+"                    type        fixedValue;\n"
        c=c+"                    value       uniform (0 0 0);\n"
        c=c+"                }\n"
    c=c+    "            }\n"
    c=c+    "        }\n"
    c=c+    "    }\n"
    return c

def replacementDict200(field, patches):
    c=""
    c=c+    "    dictionaryReplacement\n"
    c=c+    "    {\n"
    c=c+    "        " + field + "\n"
    c=c+    "        {\n" 
    c=c+    "            boundaryField\n"
    c=c+    "            {\n"
    for patch in patches:
        c=c+"                " + patch + "\n"
        c=c+"                {\n"
        c=c+"                    type            compressible::turbulentTemperatureCoupledBaffleMixed;\n"
        c=c+"                    value           uniform 300;\n"
        c=c+"                    neighbourFieldName  " + field + ";\n"
        c=c+"                    K               basicThermo;\n"
        c=c+"                    KName           none;\n"
        c=c+"                }\n"
    c=c+    "            }\n"
    c=c+    "        }\n"
    c=c+    "        U\n"
    c=c+    "        {\n" 
    c=c+    "            boundaryField\n"
    c=c+    "            {\n"
    for patch in patches:
        c=c+"                " + patch + "\n"
        c=c+"                {\n"
        c=c+"                    type        fixedValue;\n"
        c=c+"                    value       uniform (0 0 0);\n"
        c=c+"                }\n"
    c=c+    "            }\n"
    c=c+    "        }\n"
    c=c+    "    }\n"
    return c

def replacementDict220(field, patches):
    c=""
    c=c+    "    dictionaryReplacement\n"
    c=c+    "    {\n"
    c=c+    "        " + field + "\n"
    c=c+    "        {\n" 
    c=c+    "            boundaryField\n"
    c=c+    "            {\n"
    for patch in patches:
        c=c+"                " + patch + "\n"
        c=c+"                {\n"
        c=c+"                    type            compressible::turbulentTemperatureCoupledBaffleMixed;\n"
        c=c+"                    value           uniform 300;\n"
        c=c+"                    neighbourFieldName  " + field + ";\n"
        c=c+"                    kappa           fluidThermo;\n"
        c=c+"                    kappaName       none;\n"
        c=c+"                }\n"
    c=c+    "            }\n"
    c=c+    "        }\n"
    c=c+    "        U\n"
    c=c+    "        {\n" 
    c=c+    "            boundaryField\n"
    c=c+    "            {\n"
    for patch in patches:
        c=c+"                " + patch + "\n"
        c=c+"                {\n"
        c=c+"                    type        fixedValue;\n"
        c=c+"                    value       uniform (0 0 0);\n"
        c=c+"                }\n"
    c=c+    "            }\n"
    c=c+    "        }\n"
    c=c+    "    }\n"
    return c

def replacementDict230(field, patches):
    c=""
    c=c+    "    dictionaryReplacement\n"
    c=c+    "    {\n"
    c=c+    "        " + field + "\n"
    c=c+    "        {\n" 
    c=c+    "            boundaryField\n"
    c=c+    "            {\n"
    for patch in patches:
        c=c+"                " + patch + "\n"
        c=c+"                {\n"
        c=c+"                    type            compressible::turbulentTemperatureCoupledBaffleMixed;\n"
        c=c+"                    value           uniform 300;\n"
        c=c+"                    Tnbr            " + field + ";\n"
        c=c+"                    kappa           fluidThermo;\n"
        c=c+"                    kappaName       none;\n"
        c=c+"                }\n"
    c=c+    "            }\n"
    c=c+    "        }\n"
    c=c+    "        U\n"
    c=c+    "        {\n" 
    c=c+    "            boundaryField\n"
    c=c+    "            {\n"
    for patch in patches:
        c=c+"                " + patch + "\n"
        c=c+"                {\n"
        c=c+"                    type        fixedValue;\n"
        c=c+"                    value       uniform (0 0 0);\n"
        c=c+"                }\n"
    c=c+    "            }\n"
    c=c+    "        }\n"
    c=c+    "    }\n"
    return c

def replacementDict400(field, patches):
    c=""
    c=c+    "    " + field + "\n"
    c=c+    "    {\n" 
    c=c+    "        boundaryField\n"
    c=c+    "        {\n"
    for patch in patches:
        c=c+"            " + patch + "\n"
        c=c+"            {\n"
        c=c+"                type            compressible::turbulentTemperatureCoupledBaffleMixed;\n"
        c=c+"                value           uniform 300;\n"
        c=c+"                Tnbr            " + field + ";\n"
        c=c+"                kappaMethod     fluidThermo;\n"
        c=c+"            }\n"
    c=c+    "        }\n"
    c=c+    "    }\n"
    c=c+    "    U\n"
    c=c+    "    {\n" 
    c=c+    "        boundaryField\n"
    c=c+    "        {\n"
    for patch in patches:
        c=c+"            " + patch + "\n"
        c=c+"            {\n"
        c=c+"                type        fixedValue;\n"
        c=c+"                value       uniform (0 0 0);\n"
        c=c+"            }\n"
    c=c+    "        }\n"
    c=c+    "    }\n"
    return c

#
#  replacementSolidDict
#    OpenFOAMのバージョンに応じたsolid側のdictを作成する
def replacementSolidDict(regName, field, patches, OFversion):
    if OFversion[:3] == "ext":
        cont = replacementDictSolid171(field, patches)
    elif OFversion >= "4.0":
        cont = replacementSolidDict400(field, patches)
    elif OFversion >= "2.3.0":
        cont = replacementSolidDict230(field, patches)
    elif OFversion >= "2.2.0":
        cont = replacementSolidDict220(field, patches)
    elif OFversion >= "2.0.0":
        cont = replacementSolidDict200(field, patches)
    else:
        #fluid側と同じ
        cont = replacementDictSolid171(field, patches)
    return cont

def replacementSolidDict400(field, patches):
    c=""
    c=c+    "    " + field + "\n"
    c=c+    "    {\n" 
    c=c+    "        boundaryField\n"
    c=c+    "        {\n"
    for patch in patches:
        c=c+"            " + patch + "\n"
        c=c+"            {\n"
        c=c+"                type            compressible::turbulentTemperatureCoupledBaffleMixed;\n"
        c=c+"                value           uniform 300;\n"
        c=c+"                Tnbr            " + field + ";\n"
        c=c+"                kappaMethod     solidThermo;\n"
        c=c+"            }\n"
    c=c+    "        }\n"
    c=c+    "    }\n"
    return c

def replacementSolidDict230(field, patches):
    c=""
    c=c+    "    dictionaryReplacement\n"
    c=c+    "    {\n"
    c=c+    "        " + field + "\n"
    c=c+    "        {\n" 
    c=c+    "            boundaryField\n"
    c=c+    "            {\n"
    for patch in patches:
        c=c+"                " + patch + "\n"
        c=c+"                {\n"
        c=c+"                    type            compressible::turbulentTemperatureCoupledBaffleMixed;\n"
        c=c+"                    value           uniform 300;\n"
        c=c+"                    Tnbr            " + field + ";\n"
        c=c+"                    kappa           solidThermo;\n"
        c=c+"                    kappaName       none;\n"
        c=c+"                }\n"
    c=c+    "            }\n"
    c=c+    "        }\n"
    c=c+    "    }\n"
    return c

def replacementSolidDict220(field, patches):
    c=""
    c=c+    "    dictionaryReplacement\n"
    c=c+    "    {\n"
    c=c+    "        " + field + "\n"
    c=c+    "        {\n" 
    c=c+    "            boundaryField\n"
    c=c+    "            {\n"
    for patch in patches:
        c=c+"                " + patch + "\n"
        c=c+"                {\n"
        c=c+"                    type            compressible::turbulentTemperatureCoupledBaffleMixed;\n"
        c=c+"                    value           uniform 300;\n"
        c=c+"                    neighbourFieldName  " + field + ";\n"
        c=c+"                    kappa           solidThermo;\n"
        c=c+"                    kappaName       none;\n"
        c=c+"                }\n"
    c=c+    "            }\n"
    c=c+    "        }\n"
    c=c+    "    }\n"
    return c

def replacementSolidDict200(field, patches):
    c=""
    c=c+    "    dictionaryReplacement\n"
    c=c+    "    {\n"
    c=c+    "        " + field + "\n"
    c=c+    "        {\n" 
    c=c+    "            boundaryField\n"
    c=c+    "            {\n"
    for patch in patches:
        c=c+"                " + patch + "\n"
        c=c+"                {\n"
        c=c+"                    type            compressible::turbulentTemperatureCoupledBaffleMixed;\n"
        c=c+"                    value           uniform 300;\n"
        c=c+"                    neighbourFieldName  " + field + ";\n"
        c=c+"                    K               solidThermo;\n"
        c=c+"                    KName           none;\n"
        c=c+"                }\n"
    c=c+    "            }\n"
    c=c+    "        }\n"
    c=c+    "    }\n"
    return c

def replacementSolidDict171(field, patches):
    c=""
    c=c+    "    dictionaryReplacement\n"
    c=c+    "    {\n"
    c=c+    "        " + field + "\n"
    c=c+    "        {\n" 
    c=c+    "            boundaryField\n"
    c=c+    "            {\n"
    for patch in patches:
        c=c+"                " + patch + "\n"
        c=c+"                {\n"
        c=c+"                    type            solidWallMixedTemperatureCoupled;\n"
        c=c+"                    neighbourFieldName  " + field + ";\n"
        c=c+"                    K               K;\n"
        c=c+"                    value           uniform 0;\n"
        c=c+"                }\n"
    c=c+    "            }\n"
    c=c+    "        }\n"
    c=c+    "    }\n"
    return c

def headerDict(OFversion):
    header = setFoamContents.makeFoamHeader()
    foamFile = setFoamContents.makeFoamFile(OFversion, "ascii", "dictionary",
        "system", "changeDictionaryAllRegionsDict")
    header += foamFile
    return header


def footerDict():
    footer = setFoamContents.makeFooter()
    return footer

def initialize():
    global blockMeshDir, caseDir
    caseDir = os.getcwd()
    fileName = caseDir + "/system/blockMeshDict"
    if len(glob.glob(fileName)) == 0:
        fileName = caseDir + "/constant/polyMesh/blockMeshDict"
        if len(glob.glob(fileName)) == 0:
            blockMeshDir = ""
        else:
            blockMeshDir = "constant/polyMesh"
    else:
        blockMeshDir = "system"
    return


if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")
    initialize()
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
