#### import the simple module from the paraview
from paraview.simple import *
#### disable automatic camera reset on 'Show'
paraview.simple._DisableFirstRenderCameraReset()

# create a new 'PVFoamReader'
regCaseairOpenFOAM = PVFoamReader(FileName='/home/caeuser/CAE/CAE-FOAM/OF-4.0/multiRegion/multiRegionAirMaster_copy0/regCase/regCase{air}.OpenFOAM')
regCaseairOpenFOAM.MeshParts = ['internalMesh']
regCaseairOpenFOAM.VolumeFields = ['p', 'U']

# create a new 'PVFoamReader'
regCaseheaterOpenFOAM = PVFoamReader(FileName='/home/caeuser/CAE/CAE-FOAM/OF-4.0/multiRegion/multiRegionAirMaster_copy0/regCase/regCase{heater}.OpenFOAM')
regCaseheaterOpenFOAM.MeshParts = ['internalMesh']
regCaseheaterOpenFOAM.VolumeFields = ['p']

# set active source
SetActiveSource(regCaseairOpenFOAM)

# find source
regCaseOpenFOAM = FindSource('regCase.OpenFOAM')

# get active view
renderView1 = GetActiveViewOrCreate('RenderView')
# uncomment following to set a specific view size
# renderView1.ViewSize = [600, 423]

# show data in view
regCaseOpenFOAMDisplay = Show(regCaseOpenFOAM, renderView1)
# trace defaults for the display properties.
regCaseOpenFOAMDisplay.ColorArrayName = [None, '']
regCaseOpenFOAMDisplay.GlyphType = 'Arrow'
regCaseOpenFOAMDisplay.ScalarOpacityUnitDistance = 0.003276374111137098

# reset view to fit data
renderView1.ResetCamera()

# Properties modified on regCaseairOpenFOAM
regCaseairOpenFOAM.VolFieldArrayStatus = ['T', '1', 'p', '1', 'p_rgh', '1', 'rho', '1', 'U', '1']
regCaseairOpenFOAM.VolumeFields = ['T', 'p', 'p_rgh', 'rho', 'U']

# show data in view
regCaseairOpenFOAMDisplay = Show(regCaseairOpenFOAM, renderView1)
# trace defaults for the display properties.
regCaseairOpenFOAMDisplay.ColorArrayName = [None, '']
regCaseairOpenFOAMDisplay.GlyphType = 'Arrow'
regCaseairOpenFOAMDisplay.ScalarOpacityUnitDistance = 0.0033029341846698606

# show data in view
regCaseheaterOpenFOAMDisplay = Show(regCaseheaterOpenFOAM, renderView1)
# trace defaults for the display properties.
regCaseheaterOpenFOAMDisplay.ColorArrayName = [None, '']
regCaseheaterOpenFOAMDisplay.GlyphType = 'Arrow'
regCaseheaterOpenFOAMDisplay.ScalarOpacityUnitDistance = 0.0025210216001274014

# set scalar coloring
ColorBy(regCaseOpenFOAMDisplay, ('FIELD', 'vtkBlockColors'))

# show color bar/color legend
regCaseOpenFOAMDisplay.SetScalarBarVisibility(renderView1, True)

# set scalar coloring
ColorBy(regCaseairOpenFOAMDisplay, ('FIELD', 'vtkBlockColors'))

# show color bar/color legend
regCaseairOpenFOAMDisplay.SetScalarBarVisibility(renderView1, True)

# set scalar coloring
ColorBy(regCaseheaterOpenFOAMDisplay, ('FIELD', 'vtkBlockColors'))

# show color bar/color legend
regCaseheaterOpenFOAMDisplay.SetScalarBarVisibility(renderView1, True)

# get color transfer function/color map for 'vtkBlockColors'
vtkBlockColorsLUT = GetColorTransferFunction('vtkBlockColors')

# get opacity transfer function/opacity map for 'vtkBlockColors'
vtkBlockColorsPWF = GetOpacityTransferFunction('vtkBlockColors')

# set active source
SetActiveSource(regCaseheaterOpenFOAM)

# Properties modified on regCaseairOpenFOAM
regCaseairOpenFOAM.VolumeFields = ['T', 'p', 'p_rgh', 'U']

# Properties modified on regCaseheaterOpenFOAM
regCaseheaterOpenFOAM.PartArrayStatus = ['internalMesh', '1', 'wall - group', '0', 'mappedPatch - group', '0', 'sideW - patch', '0', 'heater_to_air - patch', '0']
regCaseheaterOpenFOAM.VolFieldArrayStatus = ['T', '1', 'p', '1']
regCaseheaterOpenFOAM.VolumeFields = ['T', 'p']

# set active source
SetActiveSource(regCaseairOpenFOAM)

# set active source
SetActiveSource(regCaseheaterOpenFOAM)

# create a new 'Group Datasets'
groupDatasets1 = GroupDatasets(Input=[regCaseairOpenFOAM, regCaseheaterOpenFOAM])

# Properties modified on regCaseheaterOpenFOAM
regCaseheaterOpenFOAM.MeshParts = ['internalMesh']

# show data in view
groupDatasets1Display = Show(groupDatasets1, renderView1)
# trace defaults for the display properties.
groupDatasets1Display.ColorArrayName = [None, '']
groupDatasets1Display.GlyphType = 'Arrow'
groupDatasets1Display.ScalarOpacityUnitDistance = 0.003276374111137098

# hide data in view
Hide(regCaseairOpenFOAM, renderView1)

# hide data in view
Hide(regCaseheaterOpenFOAM, renderView1)

# set scalar coloring
ColorBy(groupDatasets1Display, ('FIELD', 'vtkBlockColors'))

# show color bar/color legend
groupDatasets1Display.SetScalarBarVisibility(renderView1, True)

#### saving camera placements for all active views

# current camera placement for renderView1
renderView1.CameraPosition = [0.03999999910593033, 0.019999999552965164, 0.20928202762493717]
renderView1.CameraFocalPoint = [0.03999999910593033, 0.019999999552965164, 0.019999999552965164]
renderView1.CameraParallelScale = 0.04898979376065632

#### uncomment the following to render all views
# RenderAllViews()
# alternatively, if you want to write images, you can use SaveScreenshot(...).