#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   pasteFromSystemClipBoar.py
#
#       systemClipBoardのfileを貼り付ける
#
#   15/06/24    新規作成
#

import sys
import os
import pygtk
pygtk.require('2.0')
import gtk
import urllib

import logFileCreater; logFileCreater.log()

sysClipboard = gtk.clipboard_get()

def pasteFromSystemClipBoard(pasteContFile):

    def callback(clipboard, selectiondata, udata):
        lines = selectiondata.data.splitlines()
        action = lines[0].rstrip()
        uris = lines[1:]
        files = uris_to_paths(uris)
        #ファイルを貼り付け
        pasteFolders(pasteContFile, files)
        #終了
        gtk.main_quit()

    #clipBoard呼び出し
    sysClipboard.request_contents("x-special/gnome-copied-files", callback)

#
#  uris_to_paths
#    URIをpathに変換
def uris_to_paths(uris):
    paths = []
    for uri in uris:
        if uri.startswith(u"file:/"):
            uri = uri[5:]
            while uri.startswith("//"):
                uri = uri[1:]
            paths.append(urllib.unquote(uri))
    return paths

#
#  pasteFolders
#    folderNameを書き込み
def pasteFolders(pasteContFile, files):
    #fileName = os.getenv("TreeFoamPath") + "/temp/pasteNames"
    fileName = pasteContFile
    f=open(fileName, "w")
    for name in files:
        f.write(name + "\n")
    f.close()



if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    pasteContFile = sys.argv[1]
    pasteFromSystemClipBoard(pasteContFile)
    gtk.main()

