#!/usr/bin/env python
# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.3 on Sat Sep 22 15:15:09 2012
#
#   runHelyxosDialog.py
#      module: helyxosShow
#
#   HelyxOS起動用のdialog
#
#
#   12/09/22    新規作成
#      09/30    topoSetEditorの起動を追加
#      11/17    caseDir, stlDir, eMeshDirをrunHlyxOS側に送る様に修正
#   13/04/20    cellSet抽出を削除（toposetEditorに置き換え）
#      05/02    stlDirの相対参照→絶対参照変換方法修正
#      07/14    featureEdge作成fileの選択を追加。snappyDict編集実行ﾎﾞﾀﾝ追加
#      07/20    meshClear用のcheckBoxを追加、meshデータcheck方法変更
#      09/06    paraFoam起動ボタン追加
#      10/15    国際化のため、修正
#      10/20    csv作成、meshDict作成ボタンを追加
#      10/31    stlチェックにscale変更を追加
#      11/03    patch名修正ボタン追加
#      11/15    csvファイル編集時、officeを起動
#      12/02    csvファイルの指定をcomboBoxに変更
#      12/21    stdout、stderrの設定（import logFileCreater）を追加
#   14/02/03    csv作成後、編集する様に修正
#      03/18    createEMeshFiles:圧縮fileNameが取得できなかった事を修正
#      05/14    newCase作成、version取得方法修正
#      05/18    runParaFoam, runHelyxosの起動をos.system(comm)に変更
#      06/01    checkAndCreateTimeFolderを追加
#      07/12    バグ修正（圧縮時、eMesh.gzを認識しなかった）
#   15/07/13    clipBoardの場所をTreeFoam/dataに変更
#      07/17    dialog起動方法を修正
#
#---------code生成後の修正項目----------------
#   
#   ・アイコンのDirを書き直す（絶対path→相対path[./icons/***.png]）
#

import wx
import os
import sys
import gio
import glob
import shutil
import codecs
import pyTreeFoam
import getFoamContents
import setFoamContents
import getOpenFolderDDialog
import getOpenFileDDialog
import createBlockAndSnappyDict
import inputTextDDialog
from setHelyxosPath import getHelyxVersion
from getOpenFileDDialog import selFilesShow as getFilesDialog

import logFileCreater; logFileCreater.log()


version = ""                 #HelyxOSのバージョン
caseDir = ""
stlDir = ""
csvFileNames = []
csvFileName = ""
#clipBoard = os.environ["TreeFoamPath"] + "/data/clipBoard"
clipBoard = os.environ["TreeFoamUserPath"] + "/data/clipBoard"
helyxDataFile = "data/helyxOS_data"
clearMesh = "yes"

# begin wxGlade: extracode
# end wxGlade

#
def helyxosShow(wdir):
    global caseDir
    caseDir = wdir
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()



class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):

        #現在のpathを保存
        savePath = os.getcwd()
        #pathをTreeFoamに設定
        #treeFoamPath = os.getenv("HOME") + "/TreeFoam"
        treeFoamPath = os.getenv("TreeFoamPath")
        os.chdir(treeFoamPath)

        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.bitmap_1 = wx.StaticBitmap(self, -1, wx.Bitmap("./icons/helyxos-F.png", wx.BITMAP_TYPE_ANY))
        self.label_1 = wx.StaticText(self, -1, _(u"Helyx-OSによる編集"), style=wx.ALIGN_CENTRE)
        self.button_9 = wx.Button(self, -1, _(u"newCase作成"))
        self.label_11 = wx.StaticText(self, -1, _(u"HelyxOSが編集できるようにfolder, fileを準備\n(既にfileが存在する場合は、そのまま)  "))
        self.sizer_25_staticbox = wx.StaticBox(self, -1, _("newCase"))
        self.button_6 = wx.Button(self, -1, _(u"開く"))
        self.text_ctrl_2 = wx.TextCtrl(self, -1, "")
        self.button_8 = wx.Button(self, -1, _(u"参照..."))
        self.button_2 = wx.Button(self, -1, _(u"stlチェック..."))
        self.label_4 = wx.StaticText(self, -1, _(u"stlのsolid名やscaleを変更する"))
        self.sizer_27_staticbox = wx.StaticBox(self, -1, _(u"stlファイル"))
        self.button_1 = wx.Button(self, -1, _(u"特徴線の抽出..."))
        self.text_ctrl_1 = wx.TextCtrl(self, -1, "")
        self.label_2 = wx.StaticText(self, -1, _(u"(角度)"))
        self.label_3 = wx.StaticText(self, -1, _(u"fileを選択し、「surfaceFeatureExtract -includedAngle」 を実行"))
        self.button_4 = wx.Button(self, -1, _(u"HelyxOSの起動"))
        self.label_7 = wx.StaticText(self, -1, _(u"snappyHexMeshによるメッシュ作成、一部solverの実行"))
        self.checkbox_1 = wx.CheckBox(self, -1, _(u"mesh作成、編集する"))
        self.button_3 = wx.Button(self, -1, _(u"paraFoam起動"))
        self.label_5 = wx.StaticText(self, -1, _(u"paraFoamを起動して、mesh確認"))
        self.sizer_30_staticbox = wx.StaticBox(self, -1, _("HelyxOS"))
        self.combo_box_1 = wx.ComboBox(self, -1, choices=[], style=wx.CB_DROPDOWN)
        self.label_9 = wx.StaticText(self, -1, _(u":編集・実行の対象となるcsvファイル名"))
        self.button_12 = wx.Button(self, -1, _(u"csv作成..."))
        self.button_14 = wx.Button(self, -1, _(u"csv編集"))
        self.button_13 = wx.Button(self, -1, _(u"snappyDict作成..."))
        self.button_10 = wx.Button(self, -1, _(u"snappyDict編集"))
        self.button_11 = wx.Button(self, -1, _(u"snappy実行..."))
        self.button_15 = wx.Button(self, -1, _(u"patch名修正..."))
        self.label_13 = wx.StaticText(self, -1, _(u"csvファイルから、blockMeshDict、snappyHexMeshDictを作り出し、\nDictを実行してmeshを作る。 多くのcellZoneを作る場合は、有用。\ncsvファイルは、stlファイルと同じfolderに保存される。"))
        self.sizer_35_staticbox = wx.StaticBox(self, -1, _(u"csvファイルによるmesh作成"))
        self.button_5 = wx.Button(self, -1, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onCaseInitialize, self.button_9)
        self.Bind(wx.EVT_BUTTON, self.onOpenStlFolder, self.button_6)
        self.Bind(wx.EVT_BUTTON, self.onSetStlLocation, self.button_8)
        self.Bind(wx.EVT_BUTTON, self.onStlCheck, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onFeatureEdge, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onRunHelyxos, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onRunParaFoam, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onCreateCsv, self.button_12)
        self.Bind(wx.EVT_BUTTON, self.onOpenCaseFolder, self.button_14)
        self.Bind(wx.EVT_BUTTON, self.onCreateMeshDict, self.button_13)
        self.Bind(wx.EVT_BUTTON, self.onEditSnappyDict, self.button_10)
        self.Bind(wx.EVT_BUTTON, self.onRunSnappy, self.button_11)
        self.Bind(wx.EVT_BUTTON, self.onChangePatchName, self.button_15)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_5)
        # end wxGlade

        #pathを戻す
        os.chdir(savePath)



    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_("frame_1"))
        self.button_9.SetMinSize((110, 30))
        self.button_6.SetMinSize((40, 30))
        self.button_8.SetMinSize((60, 30))
        self.button_2.SetMinSize((110, 30))
        self.button_1.SetMinSize((110, 40))
        self.button_4.SetMinSize((110, 50))
        self.button_3.SetMinSize((110, 40))
        self.combo_box_1.SetMinSize((220, 30))
        self.button_12.SetMinSize((110, 30))
        self.button_14.SetMinSize((110, 30))
        # end wxGlade

        self.text_ctrl_1.SetValue("150")
        self.SetTitle(_(u"HelyxOSによる編集"))
        self.setDataToTextBox()
        self.setCsvFileNamesToBox()
        self.setCheckBox()

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_10 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_11 = wx.BoxSizer(wx.VERTICAL)
        self.sizer_35_staticbox.Lower()
        sizer_35 = wx.StaticBoxSizer(self.sizer_35_staticbox, wx.VERTICAL)
        sizer_37 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_36 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_30_staticbox.Lower()
        sizer_30 = wx.StaticBoxSizer(self.sizer_30_staticbox, wx.VERTICAL)
        sizer_34 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_32 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_33 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_39 = wx.BoxSizer(wx.VERTICAL)
        sizer_31 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_27_staticbox.Lower()
        sizer_27 = wx.StaticBoxSizer(self.sizer_27_staticbox, wx.VERTICAL)
        sizer_29 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_28 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_25_staticbox.Lower()
        sizer_25 = wx.StaticBoxSizer(self.sizer_25_staticbox, wx.VERTICAL)
        sizer_26 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2.Add((50, 50), 0, 0, 0)
        sizer_2.Add(self.bitmap_1, 0, wx.ALL | wx.ALIGN_CENTER_HORIZONTAL | wx.ALIGN_CENTER_VERTICAL, 10)
        sizer_2.Add(self.label_1, 0, wx.ALL | wx.ALIGN_CENTER_VERTICAL, 10)
        sizer_1.Add(sizer_2, 0, wx.EXPAND, 0)
        sizer_26.Add(self.button_9, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_26.Add(self.label_11, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_25.Add(sizer_26, 0, wx.EXPAND, 0)
        sizer_25.Add((20, 5), 0, 0, 0)
        sizer_1.Add(sizer_25, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_28.Add(self.button_6, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_28.Add(self.text_ctrl_2, 1, wx.EXPAND | wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_28.Add(self.button_8, 0, wx.EXPAND | wx.ALIGN_RIGHT | wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_27.Add(sizer_28, 0, wx.EXPAND, 0)
        sizer_29.Add(self.button_2, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_29.Add(self.label_4, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_27.Add(sizer_29, 0, wx.EXPAND, 0)
        sizer_27.Add((20, 5), 0, 0, 0)
        sizer_1.Add(sizer_27, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_31.Add(self.button_1, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_31.Add(self.text_ctrl_1, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_31.Add(self.label_2, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_30.Add(sizer_31, 0, wx.EXPAND, 0)
        sizer_30.Add(self.label_3, 0, wx.LEFT | wx.RIGHT, 40)
        sizer_30.Add((20, 10), 0, 0, 0)
        sizer_32.Add(self.button_4, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_39.Add(self.label_7, 0, wx.LEFT | wx.RIGHT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_39.Add(self.checkbox_1, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_33.Add(sizer_39, 1, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_32.Add(sizer_33, 1, wx.EXPAND, 0)
        sizer_30.Add(sizer_32, 1, wx.EXPAND, 0)
        sizer_34.Add(self.button_3, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_34.Add(self.label_5, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_30.Add(sizer_34, 0, wx.EXPAND, 0)
        sizer_30.Add((20, 5), 0, 0, 0)
        sizer_1.Add(sizer_30, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_3.Add(self.combo_box_1, 0, wx.LEFT, 20)
        sizer_3.Add(self.label_9, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_35.Add(sizer_3, 1, wx.EXPAND, 0)
        sizer_36.Add(self.button_12, 0, wx.LEFT, 20)
        sizer_36.Add(self.button_14, 0, wx.LEFT, 20)
        sizer_36.Add(self.button_13, 0, wx.LEFT, 10)
        sizer_35.Add(sizer_36, 0, wx.EXPAND, 0)
        sizer_37.Add((130, 20), 0, 0, 0)
        sizer_37.Add(self.button_10, 0, wx.LEFT, 20)
        sizer_37.Add(self.button_11, 0, wx.LEFT, 10)
        sizer_37.Add(self.button_15, 0, wx.LEFT | wx.RIGHT, 10)
        sizer_35.Add(sizer_37, 1, wx.EXPAND, 0)
        sizer_35.Add(self.label_13, 0, wx.LEFT, 40)
        sizer_35.Add((20, 5), 0, 0, 0)
        sizer_1.Add(sizer_35, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_11.Add(self.button_5, 0, wx.RIGHT | wx.TOP | wx.BOTTOM | wx.ALIGN_RIGHT | wx.ALIGN_BOTTOM, 20)
        sizer_10.Add(sizer_11, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_10, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #checkBoxをv2.0.0以上は、unenableに設定
    def setCheckBox(self):
        version = getHelyxosVersion()
        if version >= "2.0.0":
            self.checkbox_1.SetValue(False)
            self.checkbox_1.Enable(False)

    #---------コマンドボタン-----------------------
    #newCase作成
    def onCaseInitialize(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"casen内のfaileを初期化します。")
        self.caseInitialize()

    #stl場所参照
    def onSetStlLocation(self, event): # wxGlade: MyFrame.<event_handler>
        self.getStlDir()

    #stl場所を開く
    def onOpenStlFolder(self, event):  # wxGlade: MyFrame.<event_handler>
        self.openStlFolder()

    #stlファイルチェック
    def onStlCheck(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"stlファイルのsolid名をチェックします。")
        self.stlCheck()

    #特徴線抽出
    def onFeatureEdge(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"特徴線を抽出します。")
        self.featureEdge()

    #Helyxos起動
    def onRunHelyxos(self, event): # wxGlade: MyFrame.<event_handler>
        self.runHelyxos()

    #paraFoam起動
    def onRunParaFoam(self, event):  # wxGlade: MyFrame.<event_handler>
        print _(u"paraFoamを起動します")
        self.runParaFoam(event)

    #csvファイル作成
    def onCreateCsv(self, event):  # wxGlade: MyFrame.<event_handler>
        self.createCsvFile()
        self.openCaseFolder()

    #case開く・編集
    def onOpenCaseFolder(self, event):  # wxGlade: MyFrame.<event_handler>
        self.openCaseFolder()

    #meshDict作成
    def onCreateMeshDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.createMeshDict()

    #snappyDict編集
    def onEditSnappyDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.editSnappyDict(event)

    #snappy実行
    def onRunSnappy(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runSnappy(event)

    #patch名修正
    def onChangePatchName(self, event):  # wxGlade: MyFrame.<event_handler>
        self.changePatchName(event)

    #メッシュ抽出
    def onTopoSetEditor(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"topoSetEditorを起動します")
        self.runTopoSetEditor()

    #閉じる
    def onClose(self, event): # wxGlade: MyFrame.<event_handler>
        self.endingProcess()
        self.Close(True)

    #----------sub関数------------

    #  changePatchName
    #    patchMeiを修正する
    def changePatchName(self, event):
        title = _(u"patch名修正")
        mess = _(u"patch名をstlファイル名に変更します。\n")
        mess += _(u"  未定義patchを「zeroGradient」で定義した上で\n")
        mess += _(u"  patch名に含まれるsolid名を削除する。")
        stat = self.okCancelDialog(title, mess)
        if stat == "OK":
            error = meetPatchNameToStl(caseDir)
            if error[0] == "OK":
                title = _(u"mesh作成")
                mess = _(u"patch名をstlファイル名に変更しました。")
                print mess
                self.okDialog(title, mess)
            else:
                title = _(u"エラー")
                mess = error[1]
                self.errDialog(title, mess)

    #
    #  createCsvFile
    #    blockMesh, snappyHexMeshDict作成用のcsvファイル作成
    def createCsvFile(self):
        global csvFileName, csvFileNames
        #file名の取得
        inputTextDDialog.title = _(u"ファイル名の入力")
        inputTextDDialog.message = _(u"csvファイル名を入力してください。")
        inputTextDDialog.inputText = "createMeshDict.csv"
        dialog = inputTextDDialog.MyDialog(None)
        result = dialog.ShowModal()
        if inputTextDDialog.status == "OK":
            text = inputTextDDialog.inputText
        else:
            text = u""
        if text != u"":
            csvFileName = text
            #stlDirのチェック
            if stlDir[0] != "/":
                stlDirAbs = caseDir + "/" + stlDir
            else:
                stlDirAbs = stlDir

            #csvファイル作成
            error = createBlockAndSnappyDict.createCsvFile(caseDir, stlDirAbs,
                        csvFileName)
            if error != 0:
                title = _(u"エラー")
                mess = _(u"エラーが発生しました。\nlogを確認してください。")
                self.errDialog(title, mess)
                return

            title = _(u"csvファイル作成")
            mess = _(u"blockMesh、snappyHexMeshDict作成用のcsvファイルをstlDir内に作成しました。\n")
            mess += _(u"office等でcsvファイルを編集し、cellSize等を設定してください。")
            self.okDialog(title, mess)
            self.setCsvFileNamesToBox()
            self.combo_box_1.SetStringSelection(csvFileName)
        return

    #
    #  createMeshDict
    #    blockMesh, snappyHexMeshDictを作成する
    def createMeshDict(self):
        global csvFileName
        fileName = self.combo_box_1.GetStringSelection()
        if fileName == "":
            title = _(u"csvファイル編集")
            mess = _(u"csvファイルが選択されていません。\n")
            mess += _(u"編集するcsvファイルを選択してください。")
            self.errDialog(title, mess)
            return
        else:
            os.chdir(caseDir)
            #stlDirのチェック
            if stlDir[0] != "/":
                stlDirAbs = caseDir + "/" + stlDir
            else:
                stlDirAbs = stlDir
            csvFileName = fileName
            csvFileNameDir = stlDir + "/" + fileName
            #blockMesh, snappyHexMeshDict, decomposeParDict有無チェック
            self.checkBlockMeshSnappyHexMesh(caseDir)
            #csv, stl, eMeshファイルの有無チェック
            [error, nonFiles] = createBlockAndSnappyDict.checkStlEMeshFiles(
                                    caseDir, stlDirAbs, csvFileNameDir)
            if error != 0:
                title = _(u"エラー")
                #csvfileのエラー
                if len(nonFiles) == 0:
                    mess =_(u"csvファイルから値が取得できません。\n")
                    mess += _(u"詳細は、logを確認してください。")
                    self.errDialog(title, mess)
                    return
                else:
                    #必要なファイル（stl、eMesh）が存在しない場合
                    stlFiles = []
                    eMeshFiles = []
                    for name in nonFiles:
                        fileType = name.split(".")[1]
                        if fileType == "stl":
                            stlFiles.append(name)
                        if fileType == "eMesh":
                            eMeshFiles.append(name)
                    #stlFile有無チェック
                    if len(stlFiles) != 0:
                        mess = _(u"以下のstlFileが存在しません。\n")
                        for name in stlFiles:
                            mess += name +", "
                        self.errDialog(title, mess)
                        return
                    #eMeshFileのチェック
                    if len(eMeshFiles) != 0:
                        for name in eMeshFiles:
                            fileName = stlDirAbs + "/" + name.split(".")[0] + ".stl"
                            if len(fileName) == 0:
                                mess = name + _(u" が存在しません。\n")
                                mess += _(u"stlファイルも存在しません。")
                                self.errDialog(title, mess)
                                break
                                return
                        #eMeshFileを作成するかどうか
                        title = _(u"警告")
                        mess = _(u"以下のeMeshファイルが存在しません。\n")
                        for name in eMeshFiles:
                            mess += name + ", "
                        mess += _(u"作成しますか？")
                        stat = self.okCancelDialog(title, mess)
                        if stat == "OK":
                            files = []
                            for name in eMeshFiles:
                                files.append(name.split(".")[0] + ".stl")
                            deg = self.text_ctrl_1.GetValue()
                            createEMeshFiles(caseDir, stlDirAbs, files, deg)
                        else:
                            return

            #Dict作成
            error = createBlockAndSnappyDict.createMeshDict(caseDir, stlDirAbs,
                        csvFileNameDir)
            if error != 0:
                title = _(u"エラー")
                mess = _(u"Dictファイル作成中にエラーが発生しました。\n")
                mess += _(u"詳細はlogを確認してください。")
                self.errDialog(title, mess)
                return

            title = _(u"meshDict作成")
            mess = _(u"blocMeshDict、snappyHexMeshDictファイが作成できました。\n")
            mess += _(u"引き続き、snappyHexMeshを実行してmeshを作成しますか？")
            print mess
            stat = self.yesNoDialog(title, mess)
            if stat == "NO":
                return
            #mesh作成
            self.runSnappy_sub()


    #  checkBlockMeshSnappyHexMesh
    #    meshのDictファイルのチェック
    def checkBlockMeshSnappyHexMesh(self, caseDir):
        #blockMeshのチェック
        fileName = caseDir + "/system/blockMeshDict"
        copyFiles = []
        if len(glob.glob(fileName)) == 0:
            copyFiles.append("blockMeshDict")
        fileName = caseDir + "/system/snappyHexMeshDict"
        if len(glob.glob(fileName)) == 0:
            copyFiles.append("snappyHexMeshDict")
        fileName = caseDir + "/system/decomposeParDict"
        if len(glob.glob(fileName)) == 0:
            copyFiles.append("decomposeParDict")
        if len(copyFiles) != 0:
            helyxosFolders = glob.glob(os.environ["TreeFoamPath"] +
                                "/data/HelyxOS/newCase*")
            helyxosFolders.sort()
            sourceDir = helyxosFolders[-1]
            for name in copyFiles:
                sourceFile = sourceDir + "/system/" + name
                distFile = caseDir + "/system/" + name
                comm = "cp " + sourceFile + " " + distFile
                os.system(comm)
            title = _(u"meshDictファイルのコピー")
            mess = _(u"以下のファイルが存在しなかったので、default設定のDictファイルをコピーしました。\n")
            for name in copyFiles:
                mess += name + ", "
            mess = mess[:-2]
            self.okDialog(title, mess)

    #
    #  editSnappyDict
    #    snappyHexMeshDict, blockMeshDictを編集する
    def editSnappyDict(self, event):
        editFiles  = caseDir + "/system/snappyHexMeshDict "
        editFiles += caseDir + "/system/blockMeshDict"
        pyTreeFoam.runEditor(editFiles)

    #
    #  runSnappy
    #    blockMesh, snappyHexMeshを実行
    def runSnappy(self, event):
        blockDict = "system/blockMeshDict"
        snappyDict = "system/snappyHexMeshDict"
        if (len(glob.glob(caseDir+"/"+blockDict)) == 0
                or len(glob.glob(caseDir+"/"+snappyDict)) == 0):
            title = _(u"エラー")
            message = _(u"「blockMeshDict」または「snappyHexhMeshDict」ファイルがsystemフォルダ内に存在しない為、実行できません。")
            self.errDialog(title, message)
            return

        #実行の確認
        title = _(u"dict実行")
        mess = _(u"meshデータを削除して、blockMesh、snappyHexMeshを実行し、meshを作り出します。")
        stat = self.okCancelDialog(title, mess)
        if stat != "OK":
            return
        self.runSnappy_sub()

    #  runSnappy_sub
    #    mesh作成
    def runSnappy_sub(self):
        blockDict = "system/blockMeshDict"
        snappyDict = "system/snappyHexMeshDict"
        #meshデータ削除
        delFolder = caseDir + "/constant/polyMesh"
        comm = "rm -r " + delFolder
        os.system(comm)
        #blockMesh実行 
        comm = "cd " + caseDir + ";"
        comm += "blockMesh -dict " + blockDict
        [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
        if stat != "OK":
            title = _(u"snappyHexMesh実行")
            mess = _(u"blockMesh, snappyHexMeshを実行し、meshが完成しました。")
            self.okDialog(title, mess)
            return
        #snappyHexkMesh実行 
        comm = "cd " + caseDir + ";"
        comm += "snappyHexMesh -overwrite"
        [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
        if stat != "OK":
            title = _(u"エラー")
            message = _(u"mesh エラーが発生しました。logを確認してください")
            self.errDialog(title, message)
            return
        else:
            title = _(u"snappyHexMesh実行")
            mess = _(u"blockMesh, snappyHexMeshを実行し、meshが完成しました。")
            self.okDialog(title, mess)

    #
    #  caseInitialize
    #    case内のfolder, fileをコピーし、caseを初期化する
    def caseInitialize(self):
        global caseDir, version
        version = getHelyxosVersion()
        newCaseDir = getNewCaseDir(version)
        checkAndCreateTimeFolder(caseDir)
        checkAndCopyConstant(caseDir, newCaseDir)
        checkAndCopyLog(caseDir, newCaseDir)
        checkAndCopySystem(caseDir, newCaseDir)
        title = _(u"caseの初期化")
        mess = u"HelyxOS(" + version + u")" + _(u"が必要とするfolder, fileを設定しました。")
        print mess
        self.okDialog(title, mess)

    #  getStlDir
    #    stlDirの取得
    def getStlDir(self):
        global stlDir, caseDir, csvFileNames
        rootDir = os.environ["HOME"].encode("utf-8")
        title = _(u"開く")
        message = _(u"folderを選択する")
        saveDir = os.getcwd()
        os.chdir(caseDir)
        if stlDir[0] != "/":
            stlDir = os.path.abspath(stlDir).encode("utf-8")
        else:
            stlDir = stlDir.encode("utf-8")
        [stat, ansDir] = getOpenFolderDDialog.Show(title, message, rootDir, caseDir, stlDir)
        if stat == "OK":
            stlDir = ansDir
            self.text_ctrl_2.SetValue(stlDir)
            self.setCsvFileNamesToBox()
        os.chdir(saveDir)

    #  openStlFolder
    #    stlFolderを開く
    def openStlFolder(self):
        global caseDir
        stlFolder = self.text_ctrl_2.GetValue()
        if stlFolder[0] == "/":
            stlDir = stlFolder
        else:
            stlDir = caseDir + "/" + stlFolder
        if len(glob.glob(stlDir)) == 0:
            mess = _(u"設定したfolderは存在しません。\nstlファイルの場所を再設定してください。")
            self.errDialog(_(u"エラー"), mess)
            return
        #os.system(("nautilus " + stlDir).encode("utf-8"))
        pyTreeFoam.openFolderNautilus(stlDir)


    #  openCaseFolder
    #    csv fileを開く
    def openCaseFolder(self):
        global csvFileName, caseDir, stlDir
        stlAbsDir = stlDir
        if stlAbsDir[0] != "/":
            stlAbsDir = caseDir + "/" + stlAbsDir
        office = ""
        pathes = os.environ["PATH"].split(":")
        for path in pathes:
            name = glob.glob(path + "/loffice")
            if len(name) != 0:
                office = "loffice"
                break
            name = glob.glob(path + "/ooffice")
            if len(name) != 0:
                office = "ooffice"
                break
        if office == "":
            pyTreeFoam.openFolderNautilus(stlAbsDir)
        else:
            fileName = self.combo_box_1.GetStringSelection()
            if fileName == "":
                title = _(u"csvファイル編集")
                mess = _(u"csvファイルが選択されていません。\n")
                mess += _(u"編集するcsvファイルを選択してください。")
                self.errDialog(title, mess)
                return
            else:
                csvFileName = stlAbsDir + "/" + fileName
                comm = office + " " + csvFileName + "&"
                os.system(comm)

    #  setDataToTextBox
    #    textBoxへdataをセット
    def setDataToTextBox(self):
        global caseDir, stlDir, surfaceAngle, clearMesh
        [stlDir, surfaceAngle, clearMesh] = getHelyxosData(caseDir)
        self.text_ctrl_2.SetValue(stlDir)
        self.text_ctrl_1.SetValue(surfaceAngle)
        if clearMesh == "no":
            self.checkbox_1.SetValue(False)
        else:
            self.checkbox_1.SetValue(True)

    #  runHelyxos
    #    HelyxOSの起動
    def runHelyxos(self):
        global caseDir, stlDir
        config = pyTreeFoam.readConfigTreeFoam()
        OFversion = config[0]
        bashrcFoam = config[1]
        helyxos = config[8]
        if stlDir[0] != "/":
            stlPath = caseDir + "/" + stlDir
        else:
            stlPath = stlDir
        eMeshPath = stlPath
        if OFversion >= "2.1.0":
            if self.checkbox_1.GetValue() == True:
                #meshデータをクリア
                ans = self.deletePolyMesh()
                if ans == "NO":
                    return
            #HelyxOSを起動
            comm = (helyxos + " " + caseDir + " " + stlPath + " "
                    + eMeshPath + " &")
            os.system(comm)
            #pyTreeFoam.runOFUtility(comm)
        else:
            title = _(u"エラー")
            mess = _(u"OpenFOAMのバージョンが違っています。\n「Helyxos」は、「OpenFOAM 2.1.x」以上で起動してください。")
            self.errDialog(title, mess)

    #  deletePolyMesh
    #    polyMeshフォルダごとゴミ箱に移動
    def deletePolyMesh(self):
        global caseDir
        ans = "YES"
        delDir = caseDir + "/constant/polyMesh"
        checkDir = delDir + "/*"
        if len(glob.glob(checkDir)) >= 1:
            title = _(u"polyMeshの削除")
            mess = _(u"meshデータがあるので、mesh編集できません。\n「./constant/polyMesh」をゴミ箱へ移動しますか？")
            ans = self.yesNoDialog(title, mess)
            if ans == "YES":
                #ゴミ箱へ移動
                obj = gio.File(delDir)
                obj.trash()
        return ans                

    #  featureEdge
    #    特徴線を抽出
    def featureEdge(self):
        global caseDir, stlDir
        saveDir = os.getcwd()
        os.chdir(caseDir)
        bashrc = pyTreeFoam.getBashrcFoam()
        stlDir = self.text_ctrl_2.GetValue()
        deg = self.text_ctrl_1.GetValue()
        #files = glob.glob(stlDir + "/all*.stl")
        files = self.getFeatureFiles(stlDir)
        if len(files) == 0:
            return

        title = _(u"特徴線（feature edge）の抽出")
        if len(files) == 0:
            mess  = _(u"特徴線（feature edge）を抽出するファイルが選択されていません。\n")
            mess += _(u"　stl ファイルを選択してください。")
            self.errDialog(title, mess)
            os.chdir(saveDir)
            return
        
        for name in files:
            stlFile = stlDir + "/" + name
            stlName = stlFile.split("/")[-1]
            eMeshFile = stlName.split(".")[0]
            comm = "surfaceFeatureExtract -includedAngle " + deg + " "
            comm+= stlFile + " " + eMeshFile
            [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
            #comm = "cp ./constant/triSurface/" + eMeshFile + ".eMesh "
            #comm+= stlDir
            #print comm
            eMeshFilePathName = "./constant/triSurface/" + eMeshFile + ".eMesh"
            eMeshFileName = getFoamContents.checkFileName(eMeshFilePathName)
            comm = "cp " + eMeshFileName + " " + stlDir
            print comm
            os.system(comm)
        eMeshFiles = glob.glob("./constant/triSurface/*.eMesh*")
        eMeshFilesStl = glob.glob(stlDir + "/*eMesh*")
        message = str(len(files)) + _(u"ヶの stl ファイルから特徴線（feature edge）を抽出しました。")
        self.okDialog(title, message)
        os.chdir(saveDir)

    #  stlCheck
    #    stlファイルのsolid名をチェック
    def stlCheck(self):
        global stlDir, caseDir
        stlDir = self.text_ctrl_2.GetValue()
        wdir = os.getcwd()
        os.chdir(caseDir)
        stlFolder = pyTreeFoam.convAbsDir(stlDir)
        comm = "editStlFilesDialog.py " + caseDir + " " + stlDir + " &"
        os.system(comm)
        os.chdir(wdir)

    #  setCsvFilNamesToBox
    #    csvファイル名をcomboBoxにセット
    def setCsvFileNamesToBox(self):
        global csvFileNames
        stlAbsDir = stlDir
        if stlAbsDir[0] != "/":
            stlAbsDir = caseDir + "/" + stlDir
        csvFileNames = getCsvFileNames(stlAbsDir)
        self.combo_box_1.Clear()
        self.combo_box_1.AppendItems(csvFileNames)


    #  runParaFoam
    #    paraFoamを起動
    def runParaFoam(self, event):
        global caseDir
        config = pyTreeFoam.readConfigTreeFoam()
        paraFoam = config[4]
        comm = "cd " + caseDir + ";" + paraFoam + "&"
        #pyTreeFoam.runOFUtility(comm)
        os.system(comm)

    #  runTopoSetEditor
    #    toposetEditorを起動
    def runTopoSetEditor(self):
        global caseDir, stlDir
        stlDir = self.text_ctrl_2.GetValue()
        comm = "cd " + caseDir + ";" 
        comm += "topoSetEditor.py " + caseDir + " " + stlDir + " &"
        pyTreeFoam.runOFUtility(comm)

    #  endingProcess
    #    終了処理
    def endingProcess(self):
        global caseDir, stlDir, surfaceAngle, clearMesh
        stlDir = self.text_ctrl_2.GetValue()
        surfaceAngle = self.text_ctrl_1.GetValue()
        if self.checkbox_1.GetValue() == True:
            clearMesh = "yes"
        else:
            clearMesh = "no"
        setHelyxosData(caseDir, stlDir, surfaceAngle, clearMesh)

    #------------------


    #  getFeatureFiles
    #    特徴線を作成するstlファイルを取得
    def getFeatureFiles(self, currDir):
        title = _(u"特徴線抽出fileの選択")
        mess = _(u"特徴線（featureEdge）を抽出します。\n特徴線を抽出するfileを選択してください。")
        fileFilter = u"*.stl"
        [status, selFiles] = getFilesDialog(title, mess, currDir, fileFilter)
        if status == "OK":
            return selFiles
        else:
            return []
        

    def versionError(self):
        title = _(u"エラー")
        message = _(u"HelyxOSは、OpenF2.1.0 以上で起動してください。")
        self.errDialog(title, message)

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        stat = ""
        if ans == wx.ID_OK:
            #dlg.Destroy()
            stat = "OK"
            #return "OK"
        else:
            #dlg.Destroy()
            stat = "CANCEL"
            #return "CANCEL"
        return stat

    def yesNoDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.YES | wx.NO | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        stat = ""
        if ans == wx.ID_YES:
            stat = "YES"
        else:
            stat = "NO"
        return stat

    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()


# end of class MyFrame

#
#  getCsvFileNames
#    csvファイルを取得し、返す
def getCsvFileNames(csvDir):
    files = glob.glob(csvDir + "/*.csv")
    names = []
    for name in files:
        names.append(name.split("/")[-1])
    names.sort()
    return names

#  meetPatchNameToStl
#    patch名をstlファイル名に合わせる
#    patch名の_以下を削除する
def meetPatchNameToStl(caseDir):
    #定数を取得
    currTime = getFoamContents.getCurrTimeFolder(caseDir)
    boundaryDir = caseDir + "/" + getFoamContents.getCurrMeshDir(caseDir,
                    currTime, ".", "boundary")
    fieldDir = caseDir + "/" + currTime
    #空白cellをzeroGradientで埋める
    pairPolyMeshDir = "/".join(boundaryDir.split("/")[:-1])
    setFoamContents.clearNullBoundaryAllFields(fieldDir, pairPolyMeshDir)
    #patch名変更
    patchConts = getFoamContents.getPatchCont(boundaryDir)
    currPatchNames = []
    for patch in patchConts:
        name = patch[0]
        if name.find("_")>=0:
            currPatchNames.append(name)
    newPatchNames = []
    error = ["OK", ""]
    #  newPatchName取得
    newPatchNames = []
    for currPatch in currPatchNames:
        newPatchName = "_".join(currPatch.split("_")[:-1])
        newPatchNames.append(newPatchName)
    #  同じpatchNameがあるかチェック
    i = 0
    same = 0
    while i<len(newPatchNames):
        nFlag = 0
        for name in newPatchNames:
            if newPatchNames[i] == name:
                nFlag += 1
        if nFlag > 1:
            same = 1
            break
        i += 1
    if same == 1:
        error = ["NG", _(u"solid名を削除すると同じpatch名が存在するので、削除できません。")]
        return error
    #  patch名変更
    fields = pyTreeFoam.getFieldNames(fieldDir)
    i = 0
    for currPatch in currPatchNames:
        newPatchName = newPatchNames[i]
        error = pyTreeFoam.changePatchName(boundaryDir, fieldDir, fields, currPatch, newPatchName)
        i += 1
    return error

#  createEMeshFiles
#    eMeshファイルを作成する
def createEMeshFiles(caseDir, stlDir, files, deg):
    bashrc = pyTreeFoam.getBashrcFoam()
    for name in files:
        stlFile = stlDir + "/" + name
        stlName = stlFile.split("/")[-1]
        eMeshFile = stlName.split(".")[0]
        comm = ". " + bashrc + ";"
        comm+= "surfaceFeatureExtract -includedAngle " + deg + " "
        comm+= stlFile + " " + eMeshFile
        os.system(comm)
        #圧縮・非圧縮時のfileNameを取得
        resultName = "./constant/triSurface/" + eMeshFile + ".eMesh"
        resultEMeshFile = getFoamContents.checkFileName(resultName)
        comm = "cp " + resultEMeshFile + " "
        comm+= stlDir
        print comm
        os.system(comm)


#  getHelyxosVersion
#    HelyxOSのバージョンを取得
def getHelyxosVersion():
    version = getHelyxVersion()
    return version

#  getNewCaseDir
#    newCaseのdirを取得
def getNewCaseDir(version):
    #name = os.environ["TreeFoamPath"] + "/data/HelyxOS/newCase-" + version
    vName = os.environ["TreeFoamPath"] + "/data/HelyxOS/newCase-" + version[0]
    nameList = glob.glob(vName + "*")
    if len(nameList) != 0:
        nameList.sort()
        newCaseDir = nameList[-1]
    else:
        vName = vName[:-1]
        nameList = glob.glob(vName + "*")
        nameList.sort()
        newCaseDir = nameList[-1]
    return newCaseDir

def checkAndCreateTimeFolder(caseDir):
    timeFolders = pyTreeFoam.getTimeFolders(caseDir)
    if len(timeFolders) == 0:
        comm = "mkdir " + caseDir + "/0"
        print comm
        os.system(comm)

def checkAndCopyConstant(caseDir, newCaseDir):
    needFolders = []
    needFolders.append("/constant/polyMesh")
    needFolders.append("/constant/triSurface")
    writeFolders = []
    for folder in needFolders:
        if len(glob.glob(caseDir + folder)) == 0:
            writeFolders.append(newCaseDir + folder)
    writeClipBoard(writeFolders)
    pasteFolderClipBoard(caseDir + "/constant")

def checkAndCopyLog(caseDir, newCaseDir):
    needFolder = "/log"
    if len(glob.glob(caseDir + needFolder)) == 0:
        folderDir = caseDir + needFolder
        comm = "mkdir " + folderDir
        print comm
        os.system(comm)

def checkAndCopySystem(caseDir, newCaseDir):
    files = glob.glob(newCaseDir + "/system/*")
    needFiles = []
    for name in files:
        needFile = "/".join(name.split("/")[-2:])
        needFiles.append(needFile)
    writeFiles = []
    for name in needFiles:
        if len(glob.glob(caseDir + "/" + name)) == 0:
            writeFiles.append(newCaseDir + "/" + name)
    writeClipBoard(writeFiles)
    pasteClipBoard(caseDir+"/system")

def writeClipBoard(folders):
    global clipBoard
    f=open(clipBoard, "w")
    f.write("foldersCopy\n")
    for folder in folders:
        f.write(folder + "\n")
    f.close()

def pasteFolderClipBoard(pasteDir):
    global clipBoard
    if len(glob.glob(pasteDir)) == 0:
        #folder作成
        comm = "mkdir " + pasteDir
        os.system(comm)
    f=open(clipBoard); contents=f.readlines(); f.close()
    files = contents[1:]
    for name in files:
        folderName = name[:-1].split("/")[-1]
        folderDir = pasteDir + "/" + folderName
        comm = "mkdir " + folderDir
        print comm
        os.system(comm)

def pasteClipBoard(pasteDir):
    global clipBoard
    if len(glob.glob(pasteDir)) == 0:
        #folder作成
        comm = "mkdir " + pasteDir
        os.system(comm)
    f=open(clipBoard); contents=f.readlines(); f.close()
    files = contents[1:]
    for name in files:
        src = name[:-1]
        dst = pasteDir
        print "copy " + src
        shutil.copy(src, dst)

#
#  getHelyxOS_data
#    HelyxOS_dataを取得
def getHelyxosData(caseDir):
    global helyxDataFile, stlDir, surfaceAngle, clearMesh
    helyxData = helyxDataFile.split("/")[-1]
    fileNameCase = caseDir + "/" + helyxData
    #fileNameTr = os.environ["TreeFoamPath"] + "/" + helyxDataFile
    fileNameTr = os.environ["TreeFoamUserPath"] + "/" + helyxDataFile
    if len(glob.glob(fileNameCase)) == 1:
        fileName = fileNameCase
    elif len(glob.glob(fileNameTr)) == 1:
        fileName = fileNameTr
    else:
        fileName = fileNameTr
        stlDir = "./model"
        surfaceAngle = "150"
        clearMesh = "yes"
        contents = "stlDir   " + stlDir + "\n"
        contents+= "surfaceAngle    " + surfaceAngle + "\n"
        contents+= "clearMesh    " + clearMesh + "\n"
        f=open(fileName, "w")
        f.write(contents)
        f.close()

    f=open(fileName)
    contents = f.readlines()
    f.close()
    for line in contents:
        comm = line.split()
        if len(comm) > 1:
            if comm[0] == "stlDir":
                stlDir = comm[1]
            elif comm[0] == "surfaceAngle":
                surfaceAngle = comm[1]
            elif comm[0] == "clearMesh":
                clearMesh = comm[1]
    return [stlDir, surfaceAngle, clearMesh]


#  setHelyxOS_data
#    HelyxOS_dataをfileに書き込む    
def setHelyxosData(caseDir, stlDir, surfaceAngle, clearMesh):
    helyxData = helyxDataFile.split("/")[-1]
    fileName = caseDir + "/" + helyxData
    contents  = "stlDir " + stlDir + "\n"
    contents += "surfaceAngle " + surfaceAngle + "\n"
    contents += "clearMesh " + clearMesh + "\n"
    f=open(fileName, "w"); f.write(contents); f.close()

    


if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    caseDir = sys.argv[1]
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
