#!/usr/bin/env python
# -*- coding: UTF-8 -*-
#
#   runParaFoamOptionDialog
#
#       paraFoamをoption付きで起動するかどうかを確認して起動する。
#
#   14/07/13    新規作成
#      07/27    ラジオボタンに変更
#   15/07/17    dialogの起動方法を修正
#      07/23    radioボタンの設定を常時「option無し」に設定
#
#
#
#------------code作成後の修正内容------------------------------
#
#   アイコンのpathを修正
#       ***/icons/***  →  ./icons/***
#
#
# generated by wxGlade 0.6.7+ on Sun Jul 13 14:51:03 2014
#


import wx
import os
import sys
import pyTreeFoam

import logFileCreater; logFileCreater.log()

paraFoamFix = ""
caseDir = ""
mess = ""


# begin wxGlade: dependencies
import gettext
# end wxGlade

# begin wxGlade: extracode
# end wxGlade


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):

        savePath = os.getcwd()
        treeFoamPath = os.getenv("TreeFoamPath")
        os.chdir(treeFoamPath)

        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.bitmap_1 = wx.StaticBitmap(self, wx.ID_ANY, wx.Bitmap("./icons/warning32.png", wx.BITMAP_TYPE_ANY))
        self.label_1 = wx.StaticText(self, wx.ID_ANY, _("label_1"))
        self.radio_btn_2 = wx.RadioButton(self, wx.ID_ANY, _("paraFoam"))
        self.radio_btn_3 = wx.RadioButton(self, wx.ID_ANY, _("paraFoam -builtin"))
        self.sizer_7_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"起動コマンド（option）"))
        self.button_1 = wx.Button(self, wx.ID_ANY, _(u"キャンセル"))
        self.button_2 = wx.Button(self, wx.ID_ANY, _("OK"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onCancel, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onOK, self.button_2)
        # end wxGlade

        os.chdir(savePath)
        #self.setMessage()



    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_(u"paraFoam起動オプション"))
        self.button_2.SetFocus()
        # end wxGlade

        self.SetTitle(_(u"paraFoamの起動option"))


    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_2 = wx.BoxSizer(wx.VERTICAL)
        sizer_3 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_5 = wx.BoxSizer(wx.VERTICAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_7_staticbox.Lower()
        sizer_7 = wx.StaticBoxSizer(self.sizer_7_staticbox, wx.VERTICAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_4.Add(self.bitmap_1, 0, wx.ALL, 20)
        sizer_4.Add(self.label_1, 0, wx.ALL | wx.ALIGN_CENTER_VERTICAL, 10)
        sizer_1.Add(sizer_4, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_7.Add(self.radio_btn_2, 0, 0, 0)
        sizer_7.Add(self.radio_btn_3, 0, 0, 0)
        sizer_6.Add(sizer_7, 1, wx.ALL | wx.EXPAND, 10)
        sizer_5.Add(sizer_6, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_5, 1, wx.EXPAND, 0)
        sizer_3.Add(self.button_1, 0, wx.ALL, 10)
        sizer_3.Add(self.button_2, 0, wx.ALL, 10)
        sizer_2.Add(sizer_3, 0, wx.ALIGN_RIGHT, 0)
        sizer_1.Add(sizer_2, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

        self.setMessage()
        sizer_1.Fit(self)
        self.Layout()
        
    def onCancel(self, event):  # wxGlade: MyFrame.<event_handler>
        self.Destroy()

    def onOK(self, event):  # wxGlade: MyFrame.<event_handler>
        option = ""
        if self.radio_btn_2.GetValue() == True:
            option = ""
        elif self.radio_btn_3.GetValue() == True:
            option = "-builtin"
        comm = "cd " + caseDir + ";" + paraFoamFix + " " + option + " &"
        pyTreeFoam.runCommand(comm.encode("utf-8"))
        self.Destroy()


    def setMessage(self):
        global mess
        self.radio_btn_3.SetLabel(_(u"paraFoam -builtin  （各fieldをチェックした状態で起動）"))
        mess  = _(u"paraFoamの起動方法（option）を指定してください。")
        [isRegion, loc, regNames] = pyTreeFoam.checkMultiRegion(caseDir)
        if isRegion == True:
            mess += "\n\n"
            mess += _(u"このcaseは、multiRegionのcaseです。\n")
            mess += _(u"  「-builtin」optionを選択するか\n")
            mess += _(u"  paraFoamにマクロを追加してください。")
            self.radio_btn_2.SetValue(True)
        else:
            self.radio_btn_2.SetValue(True)
        self.label_1.SetLabel(mess)



# end of class MyFrame
if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    paraFoamFix = sys.argv[1]
    caseDir = sys.argv[2]

    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, wx.ID_ANY, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
