#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   runParallelDialog.py
#
#       並列計算の設定、実行
#
#   12/04/30    新規作成
#      11/02    バグ修正（接続状態確認時、currentDirを設定する様に変更）
#      12/09    multiRegionの分割方法、結果再構築方法を変更
#   13/01/11    メッセージ内容を修正
#      01/19    multiRegionの場合のreconstructParを修正
#      03/16    regionPropertiesの有無でmultiRegionかどうかを判定する様に修正
#      05/09    分割後、timeFolder内にmeshをコピーするように修正
#      05/23    decompose,reconstructでzone取得にバグあり、修正
#      10/15    国際化のため、修正
#      12/21    stdout、stderrの設定（import logFileCreater）を追加
#   14/11/13    decompose, reconstruct:OF-2.3以上で処理変更
#      11/30    couplingPatchの設定を追加
#      12/02    initialize:decomposeParDict有無、regionCouplingPatchを取得追加
#      12/03    couplingPatch部分を削除
#      12/05    initialize:ﾊﾞｸﾞ修正
#      12/13    runDecomposePar:「-constant」optionを削除
#   15/06/29    decomposeParDict中のmethodとmethodCoeffsの表示、編集追加
#      07/07    decomposeParDict内のsetPreserveを追加
#      07/17    dialogの起動方法を修正
#   16/12/31    runDecomposePar,reconstruct:OF-ext用に修正
#   17/02/13    runMpi:gnome-terminalの起動オプションを「-t」→「--name=」に修正。
#

# generated by wxGlade 0.6.3 on Mon Apr 30 10:37:28 2012

import wx
import os
import sys
import glob

import setFoamContents
import getFoamContents
import pyTreeFoam
#import decomposeSetCouplingPatchDDialog
from fileOperationInProcessorDialog import Show as fileOperationInProcessor
from fileOperationInRegionDialog import Show as fileOperationInRegionDialogShow
from treefoam import machinesFile as treefoamMachinesFile

import logFileCreater; logFileCreater.log()


caseDir = ""
regionPatches = []
regionCouplingPatches = []

# begin wxGlade: extracode
# end wxGlade



def Show(caseDir1):
    global caseDir
    caseDir = caseDir1
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, wx.ID_ANY, _(u"並列計算の設定、計算開始"))
        self.button_1 = wx.Button(self, wx.ID_ANY, _(u"machines編集"))
        self.button_2 = wx.Button(self, wx.ID_ANY, _(u"接続状態の確認"))
        self.label_2 = wx.StaticText(self, wx.ID_ANY, _(u"並列計算するsubDomainを定義。\n（/etc/hostsで定義されているhostから選択）"))
        self.sizer_6_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"machines作成"))
        self.label_7 = wx.StaticText(self, wx.ID_ANY, _("-nCPU"))
        self.text_ctrl_1 = wx.TextCtrl(self, wx.ID_ANY, "")
        self.label_9 = wx.StaticText(self, wx.ID_ANY, _(u"並列計算させる為のcpu数を設定"))
        self.label_8 = wx.StaticText(self, wx.ID_ANY, _("-method"))
        self.combo_box_1 = wx.ComboBox(self, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.label_3 = wx.StaticText(self, wx.ID_ANY, _(u"mesh分割方法を設定"))
        self.text_ctrl_2 = wx.TextCtrl(self, wx.ID_ANY, "", style=wx.TE_MULTILINE)
        self.button_10 = wx.Button(self, wx.ID_ANY, _(u" nCPU,\nmethod\n 設定"))
        self.label_4 = wx.StaticText(self, wx.ID_ANY, _("-preserve"))
        self.checkbox_2 = wx.CheckBox(self, wx.ID_ANY, _(u"特定の面の対を分割せず同じcpuに配布する"))
        self.button_13 = wx.Button(self, wx.ID_ANY, _(u"preserve\n設定..."))
        self.button_3 = wx.Button(self, wx.ID_ANY, _(u"Dict確認・編集"))
        self.button_11 = wx.Button(self, wx.ID_ANY, _(u"defaultDictに戻す"))
        self.sizer_16_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"deconposeParDict作成"))
        self.sizer_2_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"設定ファイルの作成"))
        self.button_4 = wx.Button(self, wx.ID_ANY, _(u"mesh分割"))
        self.button_8 = wx.Button(self, wx.ID_ANY, _(u"各領域のfile操作"))
        self.sizer_10_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"領域分割（decomposePar:cpu毎のmesh分割）"))
        self.checkbox_1 = wx.CheckBox(self, wx.ID_ANY, _(u"machinesファイルを使用する"))
        self.button_5 = wx.Button(self, wx.ID_ANY, _(u"並列計算開始"))
        self.button_6 = wx.Button(self, wx.ID_ANY, _(u"lam(mpi)の停止"))
        self.sizer_4_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"並列計算（mpirun）"))
        self.button_7 = wx.Button(self, wx.ID_ANY, _(u"結果の再構築"))
        self.button_12 = wx.Button(self, wx.ID_ANY, _(u"各領域のfile操作"))
        self.sizer_12_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"結果の確認（reconstructPar:cpu毎の結果を結合）"))
        self.button_9 = wx.Button(self, wx.ID_ANY, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onEditMachines, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onCheckNodes, self.button_2)
        self.Bind(wx.EVT_TEXT, self.onSetNcpu, self.text_ctrl_1)
        self.Bind(wx.EVT_COMBOBOX, self.onSetMethod, self.combo_box_1)
        self.Bind(wx.EVT_TEXT, self.onSetMethodCoeffs, self.text_ctrl_2)
        self.Bind(wx.EVT_BUTTON, self.onCreateDecomposeParDict, self.button_10)
        self.Bind(wx.EVT_CHECKBOX, self.onCheckPreserve, self.checkbox_2)
        self.Bind(wx.EVT_BUTTON, self.onSetPreserve, self.button_13)
        self.Bind(wx.EVT_BUTTON, self.onEditDecomposeParDict, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onSetDefaultDict, self.button_11)
        self.Bind(wx.EVT_BUTTON, self.onDecomposePar, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onFileOperation, self.button_8)
        self.Bind(wx.EVT_BUTTON, self.onRunMpi, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.onHaltMpi, self.button_6)
        self.Bind(wx.EVT_BUTTON, self.onReconstruct, self.button_7)
        self.Bind(wx.EVT_BUTTON, self.onFileOperation, self.button_12)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_9)
        # end wxGlade

        self.initialize()

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_(u"並列計算"))
        self.button_1.SetMinSize((130, 30))
        self.label_7.SetMinSize((63, 18))
        self.label_8.SetMinSize((63, 18))
        self.combo_box_1.SetMinSize((130, 30))
        self.text_ctrl_2.SetMinSize((80, 2))
        self.label_4.SetMinSize((63, 18))
        self.button_3.SetMinSize((120, 30))
        self.button_4.SetMinSize((130, 30))
        self.button_5.SetMinSize((130, 30))
        self.button_7.SetMinSize((130, 30))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_9 = wx.BoxSizer(wx.VERTICAL)
        sizer_14 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_12_staticbox.Lower()
        sizer_12 = wx.StaticBoxSizer(self.sizer_12_staticbox, wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_4_staticbox.Lower()
        sizer_4 = wx.StaticBoxSizer(self.sizer_4_staticbox, wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_10_staticbox.Lower()
        sizer_10 = wx.StaticBoxSizer(self.sizer_10_staticbox, wx.VERTICAL)
        sizer_11 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_2_staticbox.Lower()
        sizer_2 = wx.StaticBoxSizer(self.sizer_2_staticbox, wx.VERTICAL)
        self.sizer_16_staticbox.Lower()
        sizer_16 = wx.StaticBoxSizer(self.sizer_16_staticbox, wx.VERTICAL)
        sizer_18 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7 = wx.BoxSizer(wx.VERTICAL)
        sizer_25 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_26 = wx.BoxSizer(wx.VERTICAL)
        sizer_27 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_28 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_30 = wx.BoxSizer(wx.VERTICAL)
        sizer_31 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_29 = wx.BoxSizer(wx.VERTICAL)
        sizer_19 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_23 = wx.BoxSizer(wx.VERTICAL)
        sizer_24 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_20 = wx.BoxSizer(wx.VERTICAL)
        sizer_3 = wx.BoxSizer(wx.VERTICAL)
        sizer_22 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_21 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_17 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_6_staticbox.Lower()
        sizer_6 = wx.StaticBoxSizer(self.sizer_6_staticbox, wx.VERTICAL)
        sizer_15 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.label_1, 0, wx.TOP | wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_15.Add(self.button_1, 0, wx.LEFT | wx.RIGHT, 10)
        sizer_15.Add(self.button_2, 0, wx.LEFT | wx.RIGHT, 10)
        sizer_6.Add(sizer_15, 0, wx.EXPAND, 0)
        sizer_6.Add(self.label_2, 0, wx.LEFT, 20)
        sizer_2.Add(sizer_6, 0, wx.ALL | wx.EXPAND, 5)
        sizer_17.Add(self.label_7, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_17.Add(self.text_ctrl_1, 0, 0, 0)
        sizer_17.Add(self.label_9, 0, wx.LEFT | wx.RIGHT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_29.Add(sizer_17, 0, wx.EXPAND, 0)
        sizer_21.Add(self.label_8, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_21.Add(self.combo_box_1, 0, 0, 0)
        sizer_20.Add(sizer_21, 1, wx.EXPAND, 0)
        sizer_22.Add(self.label_3, 0, wx.LEFT | wx.RIGHT, 5)
        sizer_3.Add(sizer_22, 1, wx.EXPAND, 0)
        sizer_20.Add(sizer_3, 1, wx.ALIGN_RIGHT, 0)
        sizer_19.Add(sizer_20, 0, wx.TOP | wx.EXPAND, 3)
        sizer_24.Add(self.text_ctrl_2, 1, wx.LEFT | wx.TOP | wx.EXPAND, 3)
        sizer_23.Add(sizer_24, 1, wx.EXPAND, 0)
        sizer_19.Add(sizer_23, 1, wx.EXPAND, 0)
        sizer_29.Add(sizer_19, 1, wx.EXPAND, 0)
        sizer_28.Add(sizer_29, 0, wx.EXPAND, 0)
        sizer_31.Add(self.button_10, 0, wx.EXPAND, 0)
        sizer_30.Add(sizer_31, 1, wx.ALIGN_RIGHT, 0)
        sizer_28.Add(sizer_30, 1, wx.EXPAND, 0)
        sizer_16.Add(sizer_28, 1, wx.EXPAND, 0)
        sizer_25.Add(self.label_4, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_25.Add(self.checkbox_2, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_27.Add(self.button_13, 0, 0, 0)
        sizer_26.Add(sizer_27, 1, wx.ALIGN_RIGHT, 0)
        sizer_25.Add(sizer_26, 1, wx.TOP | wx.EXPAND, 3)
        sizer_7.Add(sizer_25, 0, wx.EXPAND, 0)
        sizer_16.Add(sizer_7, 0, wx.EXPAND, 0)
        sizer_18.Add(self.button_3, 0, wx.LEFT | wx.RIGHT, 10)
        sizer_18.Add(self.button_11, 0, wx.LEFT | wx.RIGHT, 10)
        sizer_16.Add(sizer_18, 0, wx.TOP | wx.BOTTOM | wx.EXPAND, 0)
        sizer_2.Add(sizer_16, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_1.Add(sizer_2, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_11.Add(self.button_4, 0, wx.LEFT | wx.RIGHT, 10)
        sizer_11.Add(self.button_8, 0, wx.LEFT, 10)
        sizer_10.Add(sizer_11, 0, wx.BOTTOM | wx.EXPAND, 5)
        sizer_1.Add(sizer_10, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_8.Add(self.checkbox_1, 0, wx.LEFT, 10)
        sizer_4.Add(sizer_8, 1, wx.EXPAND, 0)
        sizer_5.Add(self.button_5, 0, wx.LEFT | wx.RIGHT, 10)
        sizer_5.Add(self.button_6, 0, wx.LEFT | wx.RIGHT, 10)
        sizer_4.Add(sizer_5, 0, wx.BOTTOM | wx.EXPAND, 5)
        sizer_1.Add(sizer_4, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_13.Add(self.button_7, 0, wx.LEFT | wx.RIGHT, 10)
        sizer_13.Add(self.button_12, 0, wx.LEFT, 10)
        sizer_12.Add(sizer_13, 0, wx.BOTTOM | wx.EXPAND, 5)
        sizer_1.Add(sizer_12, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 10)
        sizer_14.Add(self.button_9, 0, wx.ALL | wx.ALIGN_RIGHT, 10)
        sizer_9.Add(sizer_14, 0, wx.ALIGN_RIGHT, 0)
        sizer_1.Add(sizer_9, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #machines編集
    def onEditMachines(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"並列計算：machinesを編集します。")
        self.editMachines()
        event.Skip()

    #接続状態の確認
    def onCheckNodes(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"並列計算：接続状態を確認します。")
        self.checkConnectedNodes()
        event.Skip()

    #nCPU入力
    def onSetNcpu(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setNcpu(event)
    #method入力
    def onSetMethod(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setMethod(event)
    #methodCoeffsを入力
    def onSetMethodCoeffs(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setMethodCoeffs(event)

    #checkPreserve
    def onCheckPreserve(self, event):  # wxGlade: MyFrame.<event_handler>
        self.checkPreserve(event)

    #setPreserve
    def onSetPreserve(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setPreserve(event)

    #Dict作成
    def onCreateDecomposeParDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.createDecomposeParDict(event)

    #decomposeParDict編集
    def onEditDecomposeParDict(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"並列計算：decomposeParDictを編集します。")
        self.editDecomposeParDict()

    #defaultDictに戻す
    def onSetDefaultDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setDefaultDict(event)

    #メッシュ分割
    def onDecomposePar(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"並列計算：メッシュを分割します。")
        self.runDecomposePar()

    #メッシュ分配
    def onDistToNode(self, event): # wxGlade: MyFrame.<event_handler>
        print "Event handler `onDistToNode' not implemented!"
        event.Skip()

    #processor内のfile操作
    def onFileOperation(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"processor内のfile操作")
        self.fileOperation()
        event.Skip()

    #並列計算開始
    def onRunMpi(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"並列計算を開始します。")
        self.runMpi()

    def onHaltMpi(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"lam, mpiを停止します。")
        self.haltMpi()
        event.Skip()

    def onReconstruct(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"結果を集め再構築します。")
        self.reconstruct()
        event.Skip()

    #Close
    def onClose(self, event): # wxGlade: MyFrame.<event_handler>
        self.Destroy()
        event.Skip()

    #  initialize
    #    初期化
    def initialize(self):
        global nCpu, caseDir, regionCouplingPatches
        #decomposeParDict確認
        [fluids, solids] = pyTreeFoam.getZonesInRegionProperties(caseDir)
        regions = ["."] + fluids + solids
        regions.sort()
        sourceFileName = caseDir + "/system/decomposeParDict"
        if len(glob.glob(sourceFileName)) == 0:
            cont = setFoamContents.makeDecomposeParDictDefault()
            f=open(sourceFileName, "w"); f.write(cont); f.close()
        flag = 0
        for region in regions:
            fileName = caseDir + "/system/" + region + "/decomposeParDict"
            if len(glob.glob(fileName)) == 0:
                comm = "cp " + sourceFileName + " " + fileName
                os.system(comm)
                flag = 1
        if flag == 1:
            msg = _(u"deconposeParDictが無かったので、標準のdecomposeParDictを作成しました。")
            self.okDialog(_(u"decomposeParDictの編集"), msg)
        #nCpuを読み込み
        f=open(sourceFileName); cont=f.read(); f.close()
        nCpu = ""
        [lineCont, p, kind] = getKeywordLineMem("numberOfSubdomains", cont, 0)
        if lineCont != "":
            nCpu = lineCont.split(";")[0].split()[1]
        self.text_ctrl_1.SetValue(nCpu)
        #methodを読込
        method = ""
        [lineCont, p, kind] = getKeywordLineMem("method", cont, 0)
        if lineCont != "":
            method = lineCont.split(";")[0].split()[1]
        methods = ["simple", "hierarchical", "scotch", "metis", "manual"]
        self.combo_box_1.Clear()
        self.combo_box_1.AppendItems(methods)
        self.combo_box_1.SetStringSelection(method)
        #methodの内容を読込
        methodCont = ""
        name = method + "Coeffs"
        [lineCont, p, kind] = getKeywordLineMem(name, cont, 0)
        if lineCont != "":
            [methodCont, pp] = getFoamContents.getMiddlePairMem(lineCont, 0)
            methodCont = pyTreeFoam.compressSPCR(methodCont)
            methodCont = getFoamContents.deleteNullLines(methodCont)
        self.text_ctrl_2.SetValue(methodCont)
        #Dict作成ボタンを非アクティブ設定
        self.button_10.Enable(False)
        #preserveの設定読込
        self.checkbox_2.SetValue(False)
        self.button_13.Enable(False)
        keywords = ["preserveFaceZones", "preservePatches", "preserveBaffles"]
        flag = 0
        for keyword in keywords:
            [lineCont, p, kind] = getKeywordLineMem(keyword, cont, 0)
            if lineCont != "":
                flag = 1
                break
        if flag == 1:
            self.checkbox_2.SetValue(True)
            self.button_13.Enable(True)
        else:
            #region内をチェック
            for region in regions[1:]:
                fileName = caseDir + "/system/" + region + "/decomposeParDict"
                f=open(fileName); cont=f.read(); f.close()
                flag = 0
                for keyword in keywords:
                    [lineCont, p, kind] = getKeywordLineMem(keyword, cont, 0)
                    if lineCont != "":
                        flag = 1
                        break
                if flag == 1:
                    self.checkbox_2.SetValue(True)
                    self.button_13.Enable(True)

    #
    #  setPreserve
    #    preserveの設定
    def setPreserve(self, event):
        comm = "runParallelSetPreserveDialog.py " + caseDir + " &"
        os.system(comm)

    #
    #  checkPreserve
    #    preserveCheckBoxをcheck
    def checkPreserve(self, event):
        if self.checkbox_2.GetValue() == True:
            self.button_13.Enable(True)
        else:
            self.button_13.Enable(False)


    #  setNcpu
    #    nCPUを修正した時
    def setNcpu(self, event):
        self.button_10.Enable(True)

    #  setMethod
    #    methodを修正
    def setMethod(self, event):
        self.button_10.Enable(True)
        method = self.combo_box_1.GetStringSelection()
        fileName = caseDir + "/system/decomposeParDict"
        f=open(fileName); cont=f.read(); f.close()
        methodCont = ""
        name = method + "Coeffs"
        [lineCont, p, kind] = getFoamContents.get1lineMem(cont, 0)
        [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
        while lineCont != "" and keyword != name:
            [lineCont, p, kind] = getFoamContents.get1lineMem(cont, p)
            [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
        if keyword == name:
            [methodCont, pp] = getFoamContents.getMiddlePairMem(lineCont, 0)
            methodCont = pyTreeFoam.compressSPCR(methodCont)
            methodCont = getFoamContents.deleteNullLines(methodCont)
        self.text_ctrl_2.SetValue(methodCont)

    #  setMethodCoeffs
    #    coeffsを修正
    def setMethodCoeffs(self, event):
        self.button_10.Enable(True)

    #  editMachies
    #    machinesの編集
    def editMachines(self):
        global caseDir
        machinesFile = treefoamMachinesFile
        fileName = caseDir + "/" + machinesFile
        if len(glob.glob(fileName)) == 0:
            cont = setFoamContents.makeMachinesDefault()
            f=open(fileName,"w"); f.write(cont); f.close()
            msg = _(u"machinesがなかったので、標準の「machines」を作成しました。\n 「localhost cpu=4」で作成しています。")
            self.okDialog(_(u"並列計算"), msg)
        pyTreeFoam.runEditor(fileName)

    #  checkConnectedNodes
    #    接続状態を確認
    def checkConnectedNodes(self):
        global caseDir
        machinesFile = treefoamMachinesFile
        fileName = caseDir + "/" + machinesFile
        if len(glob.glob(fileName)) == 0:
            title = _(u"nodeの表示")
            message = _(u"現在の解析Case内に「mashines」ファイルがありません。\n「machines」で並列計算させるノードを設定してください。")
            self.errDialog(title, message)
            return
        tempFile = caseDir + "/nodes.temp"
        command = "cd " + caseDir + ";lamboot -v machines; lamnodes | tee " + tempFile + "; lamhalt -d"
        pyTreeFoam.runOFUtility(command)
        f=open(tempFile); cont=f.read(); f.close()
        message = _(u"接続されているノードを表示します。\n\nnode\t内容\n-------------------------------------\n") + cont
        os.system("rm -rf " + tempFile)
        title = _(u"nodeの表示")
        self.okDialog(title, message)

    #  createDecomposeParDict
    #    decomposeParDict作成
    def createDecomposeParDict(self, event):
        global caseDir, nCpu, regionPatches, regionCouplingPatches
        #nCpu設定
        nCpu = self.text_ctrl_1.GetValue()
        method = self.combo_box_1.GetStringSelection()
        methodCoeffs = self.text_ctrl_2.GetValue()
        #errorチェック
        #  simple, hierarchicalの分割数とcpu数を確認
        if method == "simple" or method == "hierarchical":
            [nums, p] = getFoamContents.getSmallPairMem(methodCoeffs, 0)
            nSplit = 1
            for num in nums.split():
                nSplit = nSplit * int(num)
            if int(nCpu) != nSplit:
                title = _(u"エラー")
                mess = _(u"cpu数と分割数が合致していません")
                self.errDialog(title, mess)
                return

        #systemフォルダ直下を書き換え
        fileName = caseDir + "/system/decomposeParDict"
        f=open(fileName); cont=f.read(); f.close()
        #newLine = "numberOfSubdomains " + nCpu + ";"
        #[cont, p, keyword] = getFoamContents.replace1lineMem(cont, 0, newLine)
        cont = setNcpuMethodInDict(cont, nCpu, method, methodCoeffs)
        f=open(fileName, "w"); f.write(cont); f.close()
        mess = _(u"decomposeParDictを書き換えました。")
        [fluids, solids] = pyTreeFoam.getZonesInRegionProperties(caseDir)
        if len(fluids) > 0 or len(solids) > 0:
            #region内を書き換え
            regions = fluids + solids
            sourceFileName = caseDir + "/system/decomposeParDict"
            for region in regions:
                fileName = caseDir + "/system/" + region + "/decomposeParDict"
                if len(glob.glob(fileName)) == 0:
                    comm = "cp " + sourceFileName + " " + fileName
                    print comm
                    os.system(comm)
                f=open(fileName); cont=f.read(); f.close()
                #newLine = "numberOfSubdomains " + nCpu + ";"
                #[cont, p, keyword] = getFoamContents.replace1lineMem(cont, 0, newLine)
                cont = setNcpuMethodInDict(cont, nCpu, method, methodCoeffs)
                f=open(fileName, "w"); f.write(cont); f.close()
            #fluidRegionsを書き換え
            files = glob.glob(caseDir + "/system/fluidRegions/decomposeParDict*")
            for fileName in files:
                name = fileName.split("/")[-1].split(".")[0]
                if name == "decomposeParDict":
                    f=open(fileName); cont=f.read(); f.close()
                    #newLine = "numberOfSubdomains " + nCpu + ";"
                    #[cont, p, keyword] = getFoamContents.replace1lineMem(cont, 0,
                    #    newLine)
                    cont = setNcpuMethodInDict(cont, nCpu, method, methodCoeffs)
                    f=open(fileName, "w"); f.write(cont); f.close()
            #solidRegionsを書き換え
            files = glob.glob(caseDir + "/system/solidRegions/decomposeParDict*")
            for fileName in files:
                name = fileName.split("/")[-1].split(".")[0]
                if name == "decomposeParDict":
                    f=open(fileName); cont=f.read(); f.close()
                    #newLine = "numberOfSubdomains " + nCpu + ";"
                    #[cont, p, keyword] = getFoamContents.replace1lineMem(cont, 0,
                    #    newLine)
                    cont = setNcpuMethodInDict(cont, nCpu, method, methodCoeffs)
                    f=open(fileName, "w"); f.write(cont); f.close()
            mess = _(u"各region毎にdecomposeParDictを書き換えました。")
        #ボタンを非アクティブ設定
        self.button_10.Enable(False)
        title = _(u"decopmposeParDictの作成")
        print mess
        self.okDialog(title, mess)

    #  editDecomposeParDict
    #    decomposeParDictを編集する
    def editDecomposeParDict(self):
        global caseDir
        [fluids, solids] = pyTreeFoam.getZonesInRegionProperties(caseDir)
        if len(fluids) == 0 and len(solids) == 0:
            #シングルregionの場合 
            fileName = caseDir + "/system/decomposeParDict"
            if len(glob.glob(fileName)) == 0:
                cont = setFoamContents.makeDecomposeParDictDefault()
                f=open(fileName,"w"); f.write(cont); f.close()
                msg = _(u"deconposeParDictが無かったので、標準のdecomposeParDictを作成しました。")
                self.okDialog(_(u"decomposeParDictの編集"), msg)
            pyTreeFoam.runEditor(fileName) 
        else:
            #multiRegionの場合
            os.chdir(caseDir)
            fileOperationInRegionDialogShow("2")

    #
    #  setDefaultDict
    #    defaultのdecomposeParDictに戻す
    def setDefaultDict(self, event):
        cont = setFoamContents.makeDecomposeParDictDefault()
        fileName = caseDir + "/system/decomposeParDict"
        f=open(fileName, "w"); f.write(cont); f.close()
        #region有無確認
        [fluids, solids] = pyTreeFoam.getZonesInRegionProperties(caseDir)
        regions = fluids + solids
        if len(regions) != 0:
            #region内を修正
            regions += ["fluidRegions", "solidRegions"]
            sorceName = fileName
            for region in regions:
                pasteDir = caseDir + "/system/" + region + "/"
                comm = "cp " + sorceName + " " + pasteDir
                os.system(comm)
        #textBoxに表示
        self.initialize()
        title = _(u"並列計算")
        mess = _(u"defaultのdecomposeParDictの内容に戻しました")
        print mess
        self.okDialog(title, mess)

    #  runDecomposePar
    #    meshをcpu毎に分割
    def runDecomposePar(self):
        global caseDir
        fileName = caseDir + "/system/decomposeParDict"
        if len(glob.glob(fileName)) == 0:
            title = _(u"エラー")
            message = _(u"systemフォルダ内に「decomposeParDict」がありません。\n作成した上で実行してください。")
            self.errDialog(title, message)
            return

        saveDir = os.getcwd()
        os.chdir(caseDir)
        #既に分割ファイルがある場合は、削除する
        processorfile = caseDir + "/processor*"
        nCPU = len(glob.glob(caseDir + "/processor*"))
        if nCPU != 0:
            while nCPU > 0:
                cpuName = str(nCPU-1)
                command = "rm -rf processor" + cpuName
                print command
                os.system(command)
                nCPU -= 1
        #領域分割
        OFversion = pyTreeFoam.readConfigTreeFoam()[0]
        if OFversion >= "2.3.0" and OFversion[:3] != "ext":
            #OF-2.30以上
            if len(glob.glob("./constant/regionProperties")) != 0:
                #multiRegion場合
                #comm = "decomposePar -allRegions -constant"
                comm = "decomposePar -allRegions"
                print comm
                [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
                message = _(u"cpu > region 毎にメッシュを分割しました。")
            else:
                #singleRegionの場合
                #comm = "decomposePar -constant"
                comm = "decomposePar"
                print comm
                [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
                message = _(u"cpu 毎にメッシュを分割しました。")

        else:
            #OF-2.2以下
            if len(glob.glob("./constant/regionProperties")) != 0:
                #multiRegion場合
                [fluid, solid] = pyTreeFoam.getZonesInRegionProperties(caseDir)
                zones = fluid + solid
                for zone in zones:
                    comm = "decomposePar -region " + zone
                    print comm
                    [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
                    if stat != "OK":
                        break
                message = _(u"cpu > region 毎にメッシュを分割しました。")
            else:
                #singleRegionの場合
                comm = "decomposePar"
                print comm
                [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
                message = _(u"cpu 毎にメッシュを分割しました。")

        if stat != "OK":
            title = _(u"エラー")
            message = _(u"エラーが発生しました。\n　logを確認してください。")
            self.errDialog(title, message)
        else:
            title = _(u"並列計算")
            self.okDialog(title, message)
        os.chdir(saveDir)

    #
    #  distMeshTimeFolderRegion
    #    分割したmeshをtimeFolderにコピーする
    def distMeshTimeFolderRegion(self, caseDir, zones):
        times = pyTreeFoam.getTimeFolders(caseDir)
        if len(times) == 0:
            return "NG"

        nPro = len(glob.glob(caseDir + "/processor*"))
        timeFolder = times[0]
        i=0
        while i<nPro:
            for zone in zones:
                copyDir = caseDir + "/processor" + str(i) + "/constant/" + zone + "/polyMesh"
                distDir = caseDir + "/processor"+str(i)+"/" + timeFolder + "/" + zone
                if len(glob.glob(copyDir)) != 0:
                    comm = "cp -r " + copyDir + " " + distDir
                    os.system(comm)
            i += 1
        return "OK"

    #  distMeshTimeFolder
    #    分割したmeshをtimeFolderにコピーする。
    def distMeshTimeFolder(self, caseDir):
        times = pyTreeFoam.getTimeFolders(caseDir)
        if len(times) == 0:
            return "NG"

        timeFolder = times[0]
        copyDir = caseDir + "/constant/polyMesh"
        distDir = caseDir + "/" + timeFolder
        if len(glob.glob(copyDir)) != 0:
            comm = "cp -r " + copyDir + " " + distDir
            os.system(comm)
        return "OK"

    #  fileOperation
    #    各processor内のfile操作
    def fileOperation(self):
        global caseDir
        fileOperationInProcessor(caseDir)

    #  runMpi
    #    並列計算開始
    def runMpi(self):
        global caseDir
        solver = pyTreeFoam.getSolver(caseDir)
        nCpu = len(glob.glob(caseDir + "/processor*"))
        if solver != "" and nCpu>1:
            #dir保存
            saveDir = os.getcwd()
            os.chdir(caseDir)
            #solve.logのクリア
            f=open("solve.log", "w"); f.close()
            #machinesを取得
            machines = self.getMachinesData()
            #solverの実行ファイル作成
            envOF = pyTreeFoam.getBashrcFoam()
            cont  = "#!/bin/bash\n"
            cont += ". " + envOF + "\n"
            cont += "lamboot -v machines\n"
            comm = "mpirun" + machines + " -np " + str(nCpu) + " " + solver + " -parallel"
            cont += comm + " | tee solve.log\n"
            f=open("run", "w"); f.write(cont); f.close()
            #実行権付与
            os.system("chmod a+x run")
            #実行
            print comm
            caseName = caseDir.split("/")[-1]
            comm = "gnome-terminal --name=" + caseName + " --geometry=120x20 --zoom=0.9 -x bash --rcfile run &"
            os.system(comm)
            #dirを元に戻す
            os.chdir(saveDir)
        else:
            title = _(u"エラー")
            if solver == "":
                message = _(u"「controlDict」は、存在しません。\n")
                message += _(u"  case directoryが間違っています。")
            else:
                message = _(u"メッシュが並列計算用に領域分割されていません。") 
            self.okDialog(title, message)

    #  getMachinesData
    #    machinesファイル設定有無確認
    def getMachinesData(self):
        text = ""
        if self.checkbox_1.GetValue() == True:
            fileName = caseDir + "/machines"
            if len(glob.glob(fileName)) != 0:
                text = " -hostfile machines "
            else:
                title = _(u"並列計算")
                mess = _(u"machinesファイルが存在しません。\n")
                mess += _(u"hostのみで並列処理します。")
                print mess
                self.warningDialog(title, mess)
        return text

    #  haltMpi
    #    lam, mpiの中断
    def haltMpi(self):
        global caseDir
        saveDir = os.getcwd()
        os.chdir(caseDir)
        comm = "ompi-clean -v; lamhalt -d -v"
        print comm
        pyTreeFoam.runOFUtility(comm)
        os.chdir(saveDir)
        print _(u"\nlamを停止しました。")

    #  reconstruct
    #    結果を再構築します
    def reconstruct(self):
        global caseDir
        saveDir = os.getcwd()
        os.chdir(caseDir)
        OFversion = pyTreeFoam.readConfigTreeFoam()[0]
        if OFversion >= "2.3.0" and OFversion[:3] != "ext":
            #OF-2.3以上
            if len(glob.glob("./constant/regionProperties")) != 0:
                #multiRegionの場合
                comm = "reconstructPar -allRegions -constant"
                print comm
                [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
            else:
                #singleRegionの場合
                comm = "reconstructPar -constant"
                print comm
                [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)

        else:
            #OF-2.2以下
            if len(glob.glob("./constant/regionProperties")) != 0:
                #multiRegionの場合
                [fluid, solid] = pyTreeFoam.getZonesInRegionProperties(caseDir)
                zones = fluid + solid
                for zone in zones:
                    comm = "reconstructPar -region " + zone + " -zeroTime"
                    print comm
                    [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
                    if stat != "OK":
                        break
            else:
                #singleRegionの場合
                comm = "reconstructPar"
                print comm
                [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)

        if stat == "OK":
            title = _(u"結果の再構築")
            message = _(u"並列計算結果を再構築しました。")
            self.okDialog(title, message)
        else:
            title = _(u"エラー")
            message = _(u"結果の再構築中に、エラーが発生しました。\n  logを確認してください。")
            self.errDialog(title, message)
        os.chdir(saveDir)


    #------------------------------
    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def warningDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_QUESTION) 
        dlg.ShowModal()
        dlg.Destroy()

# end of class MyFrame

#
#  getKeywordLineMem
#    keywordを検索し、該当する行を戻す
def getKeywordLineMem(key, cont, p):
    [lineCont, p, kind] = getFoamContents.get1lineMem(cont, p)
    [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
    while lineCont != "" and keyword != key:
        [lineCont, p, kind] = getFoamContents.get1lineMem(cont, p)
        [keyword, pp] = getFoamContents.getKeywordMem(lineCont, 0)
    return [lineCont, p, kind]

#
#  setNcpuMethodInDict
#    nCPU, method, methodCoeffsをDictに設定（入れ替え）
def setNcpuMethodInDict(cont, nCpu, method, methodCoeffs):
        #nCPU書き換え
        newLine = "numberOfSubdomains " + nCpu + ";"
        [cont, p, keyword] = getFoamContents.replace1lineMem(cont, 0, newLine)
        #method書き換え
        newLine = "method          " + method + ";"
        [cont, p, keyword] = getFoamContents.replace1lineMem(cont, 0, newLine)
        #methodCoeffs書き換え
        newLine = ""
        if methodCoeffs != "":
            lines = methodCoeffs.split("\n")
            for i in range(len(lines)):
                words = lines[i].split()
                nSp = " "
                if len(words) > 1:
                    if len(words[0]) < 16:
                        nSp = " " * (16 - len(words[0])) 
                    lines[i] = "    " + words[0] + nSp + " ".join(words[1:]) + "\n"
                    newLine += lines[i]
                elif len(words) == 1:
                    newLine += "    " + words[0] + "\n"
            allNewLine = method + "Coeffs\n{\n" + newLine + "}"
            [cont, p, keyword] = getFoamContents.replace1lineMem(cont, 0, allNewLine)
        return cont


if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    caseDir = sys.argv[1]

    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
