#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#
#   selectConjugateCouplingFieldsDialog.py
#
#       coujugate用にcouplingするfieldを選択する
#
#       11/04/22    新規作成
#       12/03/18    アイコンの読み込み場所変更
#       15/07/17    dialogの起動方法を修正
#



# generated by wxGlade 0.6.3 on Mon Mar 29 21:19:05 2010

import wx
import os

warningIcon32Name = "warning32.png"
warningIcon = ""

#外側から値を代入
cellZoneNames = []

#Dialog内で値を代入し、呼出側で結果を読み取る
liquidCellZones = []        #起動時初期化すること
status = ""

#---------------------------修正内容---------------------------
#　アイコン変更
#


# begin wxGlade: extracode
# end wxGlade


class MyDialog(wx.Dialog):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyDialog.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)
        self.setIconNames()
        self.sizer_8_staticbox = wx.StaticBox(self, -1, u"couplingするfield")
        self.sizer_5_staticbox = wx.StaticBox(self, -1, u"全field名")
        self.bitmap_1 = wx.StaticBitmap(self, -1, wx.Bitmap(warningIcon32, wx.BITMAP_TYPE_ANY))
        self.label_1 = wx.StaticText(self, -1, u"全Fielsから「選択>>」ボタンをクリックして、\n　　　　　　couplingするfieldを選択してください。\n「OK」ボタンで、境界条件をcouplingします。")
        self.static_line_1 = wx.StaticLine(self, -1)
        self.list_box_4 = wx.ListBox(self, -1, choices=[], style=wx.LB_MULTIPLE)
        self.button_1 = wx.Button(self, -1, u"選択>>")
        self.button_5 = wx.Button(self, -1, u"<<戻す")
        self.list_box_2 = wx.ListBox(self, -1, choices=[], style=wx.LB_MULTIPLE)
        self.static_line_2 = wx.StaticLine(self, -1)
        self.button_3 = wx.Button(self, -1, u"キャンセル")
        self.button_4 = wx.Button(self, -1, "OK")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.selectLiquid, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.unselectLiquid, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.cancel, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.OK, self.button_4)
        # end wxGlade

        i=0
        while i < len(cellZoneNames):
            self.list_box_4.Insert(cellZoneNames[i],i)
            i=i+1
        self.clearVriableValue()        #変数の初期化


    def __set_properties(self):
        # begin wxGlade: MyDialog.__set_properties
        self.SetTitle(u"cellZoneの分割")
        self.list_box_4.SetMinSize((150, 200))
        self.button_1.SetMinSize((60, 29))
        self.button_5.SetMinSize((60, 29))
        self.list_box_2.SetMinSize((150, 200))
        self.button_3.SetFocus()
        # end wxGlade



    def __do_layout(self):
        # begin wxGlade: MyDialog.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_2 = wx.BoxSizer(wx.VERTICAL)
        sizer_10 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7 = wx.BoxSizer(wx.VERTICAL)
        sizer_8 = wx.StaticBoxSizer(self.sizer_8_staticbox, wx.VERTICAL)
        sizer_6 = wx.BoxSizer(wx.VERTICAL)
        sizer_5 = wx.StaticBoxSizer(self.sizer_5_staticbox, wx.VERTICAL)
        sizer_3 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2.Add((20, 20), 0, 0, 0)
        sizer_3.Add(self.bitmap_1, 0, wx.LEFT, 20)
        sizer_3.Add(self.label_1, 0, wx.LEFT|wx.ALIGN_CENTER_VERTICAL, 10)
        sizer_2.Add(sizer_3, 0, wx.EXPAND, 0)
        sizer_2.Add((20, 20), 0, 0, 0)
        sizer_2.Add(self.static_line_1, 1, wx.BOTTOM|wx.EXPAND, 10)
        sizer_5.Add(self.list_box_4, 0, wx.LEFT|wx.RIGHT, 4)
        sizer_4.Add(sizer_5, 0, wx.LEFT|wx.EXPAND, 15)
        sizer_6.Add((20, 45), 0, 0, 0)
        sizer_6.Add(self.button_1, 0, wx.LEFT|wx.RIGHT, 10)
        sizer_6.Add(self.button_5, 0, wx.LEFT|wx.RIGHT, 10)
        sizer_6.Add((20, 65), 0, 0, 0)
        sizer_4.Add(sizer_6, 0, wx.EXPAND, 0)
        sizer_8.Add(self.list_box_2, 0, wx.LEFT|wx.RIGHT, 4)
        sizer_7.Add(sizer_8, 1, wx.RIGHT|wx.EXPAND, 8)
        sizer_4.Add(sizer_7, 0, wx.EXPAND, 0)
        sizer_2.Add(sizer_4, 0, wx.EXPAND, 0)
        sizer_2.Add(self.static_line_2, 1, wx.TOP|wx.EXPAND, 10)
        sizer_2.Add((20, 10), 0, 0, 0)
        sizer_10.Add(self.button_3, 0, wx.LEFT, 250)
        sizer_10.Add(self.button_4, 0, wx.LEFT|wx.RIGHT, 20)
        sizer_2.Add(sizer_10, 0, wx.EXPAND, 0)
        sizer_2.Add((20, 10), 0, 0, 0)
        sizer_1.Add(sizer_2, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade


    #アイコン設定
    def setIconNames(self):
        global warningIcon32
        iconPath = os.getenv("HOME") + "/TreeFoam/icons/"
        warningIcon32 = iconPath + "/" + warningIcon32Name


    def selectLiquid(self, event): # wxGlade: MyDialog.<event_handler>
        global cellZoneNames
        selectNo = self.list_box_4.GetSelections()
        selectNames = []
        for n in selectNo:
            selectNames.append(cellZoneNames[n])
        self.deleteSelectionAll(selectNames)    #All listから削除
        self.insertSelectionLiquid(selectNames) #liquid listへ挿入
        event.Skip()

    def unselectLiquid(self, event): # wxGlade: MyDialog.<event_handler>
        global liquidCellZones
        selectNo = self.list_box_2.GetSelections()
        selectNames = []
        for n in selectNo:
            selectNames.append(liquidCellZones[n])
        self.deleteSelectionLiquid(selectNames)
        self.insertSelectionAll(selectNames)
        event.Skip()

    def cancel(self, event): # wxGlade: MyDialog.<event_handler>
        global status
        status = "cancel"
        self.Close()

    def OK(self, event): # wxGlade: MyDialog.<event_handler>
        global status
        status = "OK"
        self.Close()

# end of class MyDialog


    def clearVriableValue(self):
        global liquidCellZones, solidCellZones
        liquidCellZones = []

    def insertSelectionAll(self, selectNames):
        global cellZoneNames
        for name in selectNames:
            cellZoneNames.append(name)
        cellZoneNames.sort()
        i=0
        while i < len(selectNames):
            self.list_box_4.Insert("", 0)
            i=i+1
        i=0
        while i < len(cellZoneNames):
            self.list_box_4.SetString(i, cellZoneNames[i])
            i=i+1
        for selectName in selectNames:
            i=0
            while i < len(cellZoneNames):
                if selectName == cellZoneNames[i]:
                    self.list_box_4.SetSelection(i)
                    i=len(cellZoneNames)
                i=i+1

    def deleteSelectionAll(self, selectNames):
        global cellZoneNames
        n=0
        while n < len(selectNames):
            self.list_box_4.Delete(0)
            n=n+1
        newNames = []
        for name in cellZoneNames:
            flag = 0
            for selectName in selectNames:
                if name == selectName:
                    flag = 1
            if flag ==0:
                newNames.append(name)
        cellZoneNames = newNames
        i=0
        for name in cellZoneNames:
            self.list_box_4.SetString(i, name)
            i=i+1

    def insertSelectionLiquid(self, selectNames):
        global liquidCellZones
        for name in selectNames:
            liquidCellZones.append(name)
        liquidCellZones.sort()
        i=0
        while i < len(selectNames):
            self.list_box_2.Insert("", 0)
            i=i+1
        i=0
        while i < len(liquidCellZones):
            self.list_box_2.SetString(i, liquidCellZones[i])
            i=i+1
        for selectName in selectNames:
            i=0
            while i < len(liquidCellZones):
                if selectName == liquidCellZones[i]:
                    self.list_box_2.SetSelection(i)
                    i=len(liquidCellZones)
                i=i+1

    def deleteSelectionLiquid(self, selectNames):
        global liquidCellZones
        n=0
        while n < len(selectNames):
            self.list_box_2.Delete(0)
            n=n+1
        newNames = []
        for name in liquidCellZones:
            flag = 0
            for selectName in selectNames:
                if name == selectName:
                    flag = 1
            if flag ==0:
                newNames.append(name)
        liquidCellZones = newNames
        i=0
        for name in liquidCellZones:
            self.list_box_2.SetString(i, name)
            i=i+1
        

if __name__ == "__main__":
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()

