#!/usr/bin/env python
# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.3 on Thu Mar 11 21:50:08 2010
#
#  selectFolderFilesDialog.py
#
#     Fileの選択
#                   folder1                   folder2
#       入力データ:[[folder1,file1,file2,..], [folder2,file1,file2,..], ...]
#
#       10/03/11    新規作成
#       12/03/18    アイコンの読み込み場所変更
#       13/05/09    listBoxが拡張する様に修正。
#                   polyMeshDirの取得を「getBoundaryDir」に変更
#          05/23    バグ修正（clearZeroGradientでregion無しの場合ｴﾗｰ発生）
#          05/25    clearInternal、clearBoundaryで複数regionの選択が可能
#          06/30    起動時にregion選択して起動もできる様に追加修正
#          09/28    gzip, binaryファイルの編集ができる様に修正
#          10/15    国際化のため、修正
#          12/21    stdout、stderrの設定（import logFileCreater）を追加
#       14/04/07    fileの編集方法を変更
#          11/09    ダブルクリックでdirectoryの移動やfileOpenができるように修正
#       15/07/13    gridEditor_dataの保存場所変更
#          07/17    dialogの起動方法を修正
#

import wx
import os
import sys
import glob
import setFoamContents
import getFoamContents
import pyTreeFoam
from editBoundaryConditionsDialog import gridEditor_data

import logFileCreater; logFileCreater.log()


job = ""
title = ""
img = ""
message = ""
folderFileList = []
fileList = []
folderList = []
selectedFiles = []
frame_1 = ""
editDir = ""
selRegion = "."
selFiles = []
rootDir = ""
toolTipFolder = ""
toolTipFile = ""


def selRegFileShow(job1, title1, img1, mess1, editDir1, region, selFiles1):
    global selRegion, selFiles
    selRegion = region
    selFiles = selFiles1
    Show(job1, title1, img1, mess1, editDir1)


def selRegShow(job1, title1, img1, mess1, editDir1, region):
    global selRegion
    selRegion = region
    Show(job1, title1, img1, mess1, editDir1)

def Show(job1, title1, img1, mess1, editDir1):
    global job, frame_1, title, img, message, fileList, folderList, selectedFiles, folderFileList, editDir, FFlist
    job = job1
    editDir = editDir1
    #FFlist = pyTreeFoam.setEditFolders(editDir)
    FFlist = setEditFoldersAddParent(editDir)
    folderFileList = FFlist
    folderList = setFolders(FFlist)
    fileList = setFiles(FFlist[1])
    title = title1
    message = mess1
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
    return selectedFiles


def setFolders(FFlist):
    i=0; folders = []
    while i < len(FFlist):
        folder = FFlist[i][0]
        if folder == ".":
            folder = _(u"(現在のフォルダ）")
        folders.append(folder)
        i=i+1
    return folders


def setFiles(data):
    files = []
    if len(data) == 1:
        return files
    i=1
    while i < len(data):
        files.append(data[i])
        i=i+1
    return files



#----------------以下の内容を変更-----------------------------
#
#  アイコンの読み込み場所変更
#




# begin wxGlade: extracode
# end wxGlade


class MyFrame(wx.Frame):
    global job, frame_1, fileList, folderList, selectedFiles, folderFileList, message, img, title, editDir, rootDir
    def __init__(self, *args, **kwds):
        global rootDir, showDir
        savePath = os.getcwd()
        #os.chdir(os.getenv("HOME")+"/TreeFoam")
        os.chdir(os.getenv("TreeFoamPath"))
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.bitmap_1 = wx.StaticBitmap(self, wx.ID_ANY, wx.Bitmap("./icons/text-x-generic.png", wx.BITMAP_TYPE_ANY))
        self.label_1 = wx.StaticText(self, wx.ID_ANY, _(u"選択された Boundary Field を「zeroGradient」でクリアします"))
        self.label_3 = wx.StaticText(self, wx.ID_ANY, _("label_3"))
        self.bitmap_2 = wx.StaticBitmap(self, wx.ID_ANY, wx.Bitmap("./icons/folder8.png", wx.BITMAP_TYPE_ANY))
        self.label_4 = wx.StaticText(self, wx.ID_ANY, _(u"Folderを選択"))
        self.list_box_2 = wx.ListBox(self, wx.ID_ANY, choices=[_(u"(現在のフォルダ)")], style=wx.LB_MULTIPLE)
        self.bitmap_3 = wx.StaticBitmap(self, wx.ID_ANY, wx.Bitmap("./icons/text8.png", wx.BITMAP_TYPE_ANY))
        self.label_2 = wx.StaticText(self, wx.ID_ANY, _(u"Fieldを選択"))
        self.checkbox_1 = wx.CheckBox(self, wx.ID_ANY, _(u"全てのFieldを選択"))
        self.list_box_1 = wx.ListBox(self, wx.ID_ANY, choices=[_("Je"), _("ElPot")], style=wx.LB_MULTIPLE)
        self.button_1 = wx.Button(self, wx.ID_ANY, _(u"キャンセル"))
        self.button_2 = wx.Button(self, wx.ID_ANY, _("OK"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_LISTBOX_DCLICK, self.onOpenFolder, self.list_box_2)
        self.Bind(wx.EVT_LISTBOX, self.showFiles, self.list_box_2)
        self.Bind(wx.EVT_CHECKBOX, self.changeListBoxStatus, self.checkbox_1)
        self.Bind(wx.EVT_LISTBOX_DCLICK, self.onOpenFile, self.list_box_1)
        self.Bind(wx.EVT_BUTTON, self.cancel, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.OK, self.button_2)
        # end wxGlade

        #toolTip表示設定
        global toolTipFolder, toolTipFile
        toolTipFolder = _(u"ここをダブルクリックすると\n  directoryを移動します。")
        toolTipFile = _(u"ここをダブルクリックすると\n  fileを開きます。")
        self.list_box_2.Bind(wx.EVT_MOTION, self.showToolTipFolder)
        self.list_box_1.Bind(wx.EVT_MOTION, self.showToolTipFile)        

        os.chdir(savePath)
        #regionFolderの選択
        if selRegion == ".":
            self.list_box_2.Select(1)
        else:
            for region in folderList[1:]:
                if region == selRegion:
                    self.list_box_2.SetStringSelection(selRegion)
                    break
        folderNo = self.list_box_2.GetSelections()
        #fileの選択
        self.checkbox_1.SetValue(0)
        self.list_box_1.Enable(True)
        files = folderFileList[folderNo[0]]
        fileList = files[1:]
        self.list_box_1.Clear()
        self.list_box_1.AppendItems(fileList)
        for selFile in selFiles:
             self.list_box_1.SetStringSelection(selFile)
        #rootDirの設定
        rootDir = "/".join(editDir.split("/")[:-1])
        self.showCurrentDir(rootDir, editDir)

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_(u"Boudary Field のクリア"))
        self.list_box_2.SetMinSize((200, 150))
        self.list_box_2.SetSelection(0)
        self.checkbox_1.SetValue(1)
        self.list_box_1.SetMinSize((200, 150))
        self.list_box_1.Enable(False)
        self.list_box_1.SetSelection(0)
        self.button_1.SetFocus()
        # end wxGlade

        self.SetTitle(title)
        self.label_1.SetLabel(message)
        self.list_box_2.Clear()
        self.list_box_2.AppendItems(folderList)
        self.list_box_2.SetSelection(1)
        self.list_box_1.Clear()
        self.list_box_1.AppendItems(fileList)

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.VERTICAL)
        sizer_14 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7 = wx.BoxSizer(wx.VERTICAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_11 = wx.BoxSizer(wx.VERTICAL)
        sizer_12 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_9 = wx.BoxSizer(wx.VERTICAL)
        sizer_10 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3 = wx.BoxSizer(wx.VERTICAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add((20, 20), 0, 0, 0)
        sizer_2.Add((20, 20), 0, 0, 0)
        sizer_2.Add(self.bitmap_1, 0, 0, 0)
        sizer_2.Add((20, 20), 0, 0, 0)
        sizer_2.Add(self.label_1, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_2.Add((20, 20), 0, 0, 0)
        sizer_1.Add(sizer_2, 0, wx.EXPAND, 0)
        sizer_1.Add((20, 20), 0, 0, 0)
        sizer_4.Add(self.label_3, 0, wx.LEFT, 20)
        sizer_3.Add(sizer_4, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_3, 0, wx.EXPAND, 0)
        sizer_10.Add((20, 25), 0, 0, 0)
        sizer_10.Add(self.bitmap_2, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_10.Add(self.label_4, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_9.Add(sizer_10, 0, wx.EXPAND, 0)
        sizer_9.Add(self.list_box_2, 1, wx.LEFT | wx.EXPAND, 20)
        sizer_8.Add(sizer_9, 1, wx.EXPAND, 0)
        sizer_8.Add((20, 20), 0, 0, 0)
        sizer_12.Add(self.bitmap_3, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_12.Add(self.label_2, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_12.Add(self.checkbox_1, 0, wx.LEFT | wx.RIGHT | wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_11.Add(sizer_12, 0, wx.EXPAND, 0)
        sizer_11.Add(self.list_box_1, 1, wx.RIGHT | wx.EXPAND, 20)
        sizer_8.Add(sizer_11, 1, wx.EXPAND, 0)
        sizer_7.Add(sizer_8, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_7, 1, wx.EXPAND, 0)
        sizer_1.Add((20, 20), 0, 0, 0)
        sizer_14.Add(self.button_1, 0, wx.RIGHT | wx.ALIGN_RIGHT, 0)
        sizer_14.Add(self.button_2, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM, 20)
        sizer_13.Add(sizer_14, 0, wx.ALIGN_RIGHT, 0)
        sizer_1.Add(sizer_13, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    def showCurrentDir(self, rootDir, editDir):
        showDir = "./" + editDir[len(rootDir)+1:]
        self.label_3.SetLabel(_(u"場所: ") + showDir)

    def changeListBoxStatus(self, event): # wxGlade: MyFrame.<event_handler>
        if self.checkbox_1.Value == True:
            self.label_2.Enable(False)
            self.list_box_1.Enable(False)
        else:
            self.label_2.Enable(True)
            self.list_box_1.Enable(True)

    def showFiles(self, event): # wxGlade: MyFrame.<event_handler>
        global folderFileList
        folderNo = self.list_box_2.GetSelections()
        if len(folderNo) == 0:
            return
        files = folderFileList[folderNo[0]]
        fileList = files[1:]
        self.list_box_1.Clear()
        self.list_box_1.AppendItems(fileList)

    #folderのダブルクリック
    def onOpenFolder(self, event):  # wxGlade: MyFrame.<event_handler>
        self.openFolder(event)

    #fileのダブルクリック
    def onOpenFile(self, event):  # wxGlade: MyFrame.<event_handler>
        self.openFile(event)

    #OK
    def OK(self, event): # wxGlade: MyFrame.<event_handler>
        global selectedFiles, folderFileList, editDir
        #選択しているfolder、fileを取得
        selectedFiles = []
        folderNo = self.list_box_2.GetSelections()
        if len(folderNo) == 1:
            #選択folderが1ヶの場合（fileリストが正しい場合）
            if folderNo[0] == 0:
                folder = "."
            else:
                folder = folderList[folderNo[0]]
            nn = folderNo[0]
            if self.checkbox_1.Value == True:
                selectedFiles.append(folderFileList[nn])
            else:
                files = []
                files.append(folderFileList[nn][0])
                fileNo = self.list_box_1.GetSelections()
                for n in fileNo:
                    files.append(folderFileList[nn][n+1])
                selectedFiles.append(files)
        else:
            #選択folderが複数個の場合
            for nFolder in folderNo:
                #folder名を取得
                if nFolder == 0:
                    folder = "."
                else:
                    folder = folderList[nFolder]
                #folder内の全fieldを取得
                fields = folderFileList[nFolder][1:]
                if self.checkbox_1.Value == True:
                    #全てのfieldを選択している場合
                    selFields = [folder] + fields
                    selectedFiles.append(selFields)
                else:
                    #複数個のfieldを選択している場合
                    #　選択しているfield名を取得
                    fileNo = self.list_box_1.GetSelections()
                    sFiles = []
                    for n in fileNo:
                        sFiles.append(self.list_box_1.GetString(n))
                    #　選択fieldが実在するか確認
                    select = []
                    for sFile in sFiles:
                        for field in fields:
                            if sFile == field:
                                select.append(sFile)
                                break
                    if len(select) > 0:
                        #実在しているfield名を取得
                        selFields = [folder] + select
                        selectedFiles.append(selFields)
        #frame_1.Destroy()

        # ...Properties File の編集
        if job == "editProperties":
            wdir = os.getcwd()
            os.chdir(editDir)
            self.editFiles(selectedFiles)
            os.chdir(wdir)
        # Dict Fileの編集
        elif job == "editDictFile":
            wdir = os.getcwd()
            os.chdir(editDir)
            self.editFiles(selectedFiles)
            os.chdir(wdir)
        # boundary Field のクリア
        elif job == "clearBoundary":
            n = self.list_box_2.GetSelections()
            if len(n) > 1:
                title = _(u"警告")
                mess = _(u"複数フォルダを選択しています\nこのまま処理を継続しますか？")
                stat = self.okCancelDialog(title, mess)
                if stat != "OK":
                    return
            clearBoundaryOrInternal(job, editDir, selectedFiles)
            title = "clear boundary field"
            mess = _(u"boundary fieldをクリアしました。")
            self.okDialog(title, mess)
        # internalField のクリア
        elif job == "clearInternal":
            n = self.list_box_2.GetSelections()
            if len(n) > 1:
                title = _(u"警告")
                mess = _(u"複数フォルダを選択しています\nこのまま処理を継続しますか？")
                stat = self.okCancelDialog(title, mess)
                if stat != "OK":
                    return
            clearBoundaryOrInternal(job, editDir, selectedFiles)
            title = "clear internal field"
            mess = _(u"internal fieldをクリアしました。")
            self.okDialog(title, mess)


    def cancel(self, event): # wxGlade: MyFrame.<event_handler>
        global selectedFiles
        print "exit from selectFilesDialog."
        selectedFiles = []
        self.Destroy()

    def editFiles(self, editList):
        if len(editList) != 0:
            i = 0; arg = ""
            while i < len(editList):
                j = 1
                while j < len(editList[i]):
                    arg = arg + editList[i][0] + "/" + editList[i][j] + " "
                    j = j + 1
                i = i + 1
            #fileを編集
            self.openEditFiles(arg)

    #  showToolTipFolder
    def showToolTipFolder(self, event):
        self.list_box_2.SetToolTip(wx.ToolTip(toolTipFolder))
    def showToolTipFile(self, event):
        self.list_box_1.SetToolTip(wx.ToolTip(toolTipFile))


    #  openFolder
    #    folderを開く
    def openFolder(self, event):
        global editDir, FFlist, folderFileList, folderList, fileList
        n = event.GetSelection()
        #folder名を取得
        folder = FFlist[n][0]
        if folder == ".":
            return
        #rootDirと比較
        wdir = os.path.abspath(editDir + "/" + folder)
        if wdir < rootDir:
            return
        #新しいfolderへ移動
        editDir = wdir
        self.showCurrentDir(rootDir, editDir)
        FFlist = setEditFoldersAddParent(editDir)
        folderFileList = FFlist
        folderList = setFolders(FFlist)
        self.list_box_2.Clear()
        self.list_box_2.AppendItems(folderList)
        self.list_box_2.SetSelection(1)

    #  openFile
    #    editorでfileをopen
    def openFile(self, event):
        name = event.GetString()
        nFolder = self.list_box_2.GetSelections()
        folder = FFlist[nFolder[0]][0]
        fileName = editDir + "/" + folder + "/" + name
        self.openEditFiles(fileName)    

    #  openEditFiles
    #    editorでfileをopenする。
    def openEditFiles(self, files):
        #binary or size>2MB かどうかチェック
        if self.isBinaryFiles(files) == True:
            #binary or 2MB以上ファイルが含まれている場合
            title = _(u"fileの編集")
            mess = _(u"binary 又は 2MB以上のファイルが含まれている為、")
            mess += _(u"temporaryファイルを作ってファイルをopenします。\n")
            mess += _(u"  binary部（List <xxx> を含む行）は、編集できません。\n")
            mess += _(u"  編集内容は、editorを閉じた時に反映されます。\n")
            self.okDialog(title, mess)
            comm = "editFoamFile.py " + files + " &"
            os.system(comm)
        else:
            #2MB以下のasciiファイルの場合
            pyTreeFoam.runEditor(files)

    #  isBinaryFiles
    #    binary or 2MB以上のファイルかどうかチェック
    def isBinaryFiles(self, files):
        binary = False
        fileNames = files.split()
        for fileName in fileNames:
            cont = getFoamContents.readFile2000Bytes(fileName)
            if getFoamContents.checkBinary(cont) == "ascii":
                if os.path.getsize(fileName) > 2000000:
                    #2MBを超える場合は、binaryとして戻す
                    binary = True
                    break
                else:
                    #2MB以下はasciiとして戻す
                    binary = False
            else:
                binary = True
                break
        return binary


    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        if ans == wx.ID_OK:
            dlg.Destroy()
            return "OK"
        else:
            dlg.Destroy()
            return "CANCEL"

    def errorDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.ICON_HAND) 
        ans = dlg.ShowModal()
        dlg.Destroy()

    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        dlg.Destroy()

# end of class MyFrame


#
#  getMaxLines
#    nMaxLinesBinToAscii
def getMaxLines():
    #setFile = os.environ["TreeFoamPath"] + "/" + gridEditor_data
    setFile = os.environ["TreeFoamUserPath"] + "/" + gridEditor_data
    f=open(setFile); cont=f.readlines(); f.close()
    for line in cont:
        words = line.split()
        if len(words) >= 2:
            if words[0] == "nMaxLinesBinToAscii":
                nMaxLines = int(words[1])
    return nMaxLines    

#
#  clearBoundaryOrInternal
#
def clearBoundaryOrInternal(job, editDir, selectedFields):
    wdir = os.getcwd()
    [region, regLoc, regNames] = pyTreeFoam.checkMultiRegion(wdir)
    if region == False:
        #regionが無い場合
        fieldDir = editDir
        caseDir = "/".join(editDir.split("/")[:-1])
        currTime = getFoamContents.getCurrTimeFolder(caseDir)
        polyMeshDir = getFoamContents.getCurrMeshDir(caseDir, currTime, ".", "boundary")
        #dirを1ヶ縮める
        polyMeshDir = "/".join(polyMeshDir.split("/")[:-1])
        #fieldに対する処理
        Flist = selectedFields[0][1:]
        if len(Flist) != 0:
            if job == "clearBoundary":
                setFoamContents.clearBoundaryFields(fieldDir, polyMeshDir, Flist)
            elif job == "clearInternal":
                setFoamContents.clearInternalFields(fieldDir, polyMeshDir, Flist)
        else:
            print _(u"Fieldが選択されていません")
    else:
        #regionの場合
        n=0
        while n < len(selectedFields):
            region = selectedFields[n][0]
            fieldDir = editDir + "/" + region
            caseDir = "/".join(editDir.split("/")[:-1])
            currTime = getFoamContents.getCurrTimeFolder(caseDir)
            polyMeshDir = getFoamContents.getCurrMeshDir(caseDir, currTime, region, "boundary")
            #dirを1ヶ縮める
            polyMeshDir = "/".join(polyMeshDir.split("/")[:-1])
            #各fieldに対する処理
            Flist = selectedFields[n][1:]
            if len(Flist) != 0:
                if job == "clearBoundary":
                    setFoamContents.clearBoundaryFields(fieldDir, polyMeshDir,
                        Flist)
                elif job == "clearInternal":
                    setFoamContents.clearInternalFields(fieldDir, polyMeshDir,
                        Flist)
            else:
                print _(u"Fieldが選択されていません")
            n=n+1

#  setEditFoldersAddParent
#    親folderを含めたFFlistを取得
def setEditFoldersAddParent(editDir):
    parentDir = "/".join(editDir.split("/")[:-1])
    files = pyTreeFoam.getFieldNames(parentDir)
    FFlist = pyTreeFoam.setEditFolders(editDir)
    FFlist = [[".."] + files] + FFlist
    return FFlist


if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    #変数の取り込み
    job =       sys.argv[1]
    title =     sys.argv[2]
    img1 =      sys.argv[3]
    message =   sys.argv[4]
    editDir =   sys.argv[5]
    FFlist = setEditFoldersAddParent(editDir)
    folderFileList = FFlist
    folderList = setFolders(FFlist)
    fileList = setFiles(FFlist[0])
    #dialog表示
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
