#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   setMultiRegionDialog.py
#
#       multiRegionCaseの編集
#
#       13/04/13    新規作成
#          05/22    changeDictを読み込んで自動作成するを追加
#          06/22    regionの追加・削除ボタン追加
#          09/18    import先を修正
#          09/28    changeDictのdialogを変更
#          10/15    国際化のため修正
#       14/02/08    fileOperationInRegionを起動した時、closeする様に修正
#          05/11    loadFromGaugeDialogを修正（defineDataを追加）
#          06/07    loadFromGaugeDialogのバグ修正
#          10/05    setBoundaryConditionsを追加（境界面の境界条件）
#          11/15    regionWallBoundaryの編集、設定のﾎﾞﾀﾝ2ヶ追加
#          12/22    getBoundaryFieldData:getDimensionInternalFieldsDataからの
#                   戻り値を修正
#       15/02/27    getFieldBoundaryData:変数の書き込み追加
#          07/17    dialogの起動方法を修正
#       16/12/30    getFieldBoundaryData:OF-4.0用にchangeDictionaryの書式修正（バグ）
#          12/31    getFieldBoundaryData:OF-ext用に修正
#


# generated by wxGlade 0.6.5 on Sat Apr 13 15:37:45 2013

import wx
import os
import glob
import pyTreeFoam
import getFoamContents
import setFoamContents
import gaugeDDialog
import inputTextDDialog
from editBoundaryConditionsDialog import getDefinePatchData, getRowNamesFromBoundary, getDimensionInternalFieldData
from getOpenRunFileDDialog import Show as getOpenRunFileDDialogShow
from fileOperationInRegionDialog import Show as fileOperationInRegionDialogShow
from addDeleteRegionDialog import Show as addDeleteRegionDialogShow
from createBCsForMultiRegionDialog import checkAllFields, replaceRegionFieldBoundaryConditions, readDictFile


currCaseDir = ""
dictName = "regionWallBoundaryConditionsDict"


# begin wxGlade: extracode
# end wxGlade



def Show():
    initialize()
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, wx.ID_ANY, _(u"multiRegionの設定、各region内のfile操作"))
        self.label_8 = wx.StaticText(self, wx.ID_ANY, _(u"regionWallBoundaryConditionsDictによる境界条件の設定"))
        self.button_1 = wx.Button(self, wx.ID_ANY, _(u"regionBCsEditor\n編集・設定"))
        self.button_7 = wx.Button(self, wx.ID_ANY, _(u"textEditorによるDict編集"))
        self.button_8 = wx.Button(self, wx.ID_ANY, _(u"Dict実行（設定）"))
        self.label_2 = wx.StaticText(self, wx.ID_ANY, _(u"各regionの境界面の境界条件を編集・設定する。"))
        self.sizer_3_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"境界面（領域間）の境界条件設定"))
        self.label_7 = wx.StaticText(self, wx.ID_ANY, _(u"全regionに対して一括して変更を加える。"))
        self.button_5 = wx.Button(self, wx.ID_ANY, _(u"現設定を取得・作成"))
        self.label_5 = wx.StaticText(self, wx.ID_ANY, _(u"boundaryと各fieldの設定を読み込み、\nchangeDictionaryAllRegionsDictを作成する。"))
        self.button_2 = wx.Button(self, wx.ID_ANY, _(u"changeDict\n編集・実行..."))
        self.label_3 = wx.StaticText(self, wx.ID_ANY, _(u"changeDictionaryAllRegionsDictを編集・実行する。\nこの実行により全regionの設定が変更される。"))
        self.sizer_2_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"changeDictionaryAllRegionsの設定"))
        self.button_6 = wx.Button(self, wx.ID_ANY, _(u"region名の変更・\n　追加・削除..."))
        self.label_6 = wx.StaticText(self, wx.ID_ANY, _(u"設定されたregion名を変更・追加・削除する。\nregionを追加した場合、meshをコピーする必要がある。"))
        self.button_3 = wx.Button(self, wx.ID_ANY, _(u"region内file操作..."))
        self.label_4 = wx.StaticText(self, wx.ID_ANY, _(u"各regionへのfileコピーや固体領域の材料設定を行う。"))
        self.sizer_5_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"region内のfile操作"))
        self.button_4 = wx.Button(self, wx.ID_ANY, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onSetBoundaryConditions, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onEditDict, self.button_7)
        self.Bind(wx.EVT_BUTTON, self.onRunDict, self.button_8)
        self.Bind(wx.EVT_BUTTON, self.onMakeChangeDict, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.onEditRunChangeDict, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onAddDeleRegion, self.button_6)
        self.Bind(wx.EVT_BUTTON, self.onFileOperation, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_4)
        # end wxGlade

        ans = self.checkMultiRegion()

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_(u"multiRegionの設定"))
        self.button_1.SetMinSize((140, 50))
        self.button_5.SetMinSize((140, 30))
        self.button_2.SetMinSize((140, 50))
        self.button_6.SetMinSize((140, 50))
        self.button_3.SetMinSize((140, 50))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_7 = wx.BoxSizer(wx.VERTICAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_5_staticbox.Lower()
        sizer_5 = wx.StaticBoxSizer(self.sizer_5_staticbox, wx.VERTICAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_11 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_2_staticbox.Lower()
        sizer_2 = wx.StaticBoxSizer(self.sizer_2_staticbox, wx.VERTICAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_9 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_3_staticbox.Lower()
        sizer_3 = wx.StaticBoxSizer(self.sizer_3_staticbox, wx.VERTICAL)
        sizer_10 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_12 = wx.BoxSizer(wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.label_1, 0, wx.TOP | wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_3.Add(self.label_8, 0, wx.LEFT, 15)
        sizer_10.Add(self.button_1, 0, wx.ALL, 5)
        sizer_13.Add(self.button_7, 0, wx.TOP, 5)
        sizer_13.Add(self.button_8, 0, wx.TOP, 5)
        sizer_12.Add(sizer_13, 1, wx.EXPAND, 0)
        sizer_12.Add(self.label_2, 0, wx.ALL | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_10.Add(sizer_12, 1, wx.EXPAND, 0)
        sizer_3.Add(sizer_10, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_3, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_2.Add(self.label_7, 0, wx.LEFT, 15)
        sizer_9.Add(self.button_5, 0, wx.LEFT | wx.RIGHT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_9.Add(self.label_5, 0, wx.LEFT | wx.TOP | wx.BOTTOM | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_2.Add(sizer_9, 1, wx.EXPAND, 0)
        sizer_4.Add(self.button_2, 0, wx.ALL | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_4.Add(self.label_3, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_2.Add(sizer_4, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_2, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_11.Add(self.button_6, 0, wx.ALL, 5)
        sizer_11.Add(self.label_6, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_5.Add(sizer_11, 0, wx.EXPAND, 0)
        sizer_6.Add(self.button_3, 0, wx.ALL | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_6.Add(self.label_4, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_5.Add(sizer_6, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_5, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_8.Add(self.button_4, 0, wx.RIGHT | wx.BOTTOM, 20)
        sizer_7.Add(sizer_8, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_7, 0, wx.ALIGN_RIGHT, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #境界条件編集・設定
    def onSetBoundaryConditions(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setBoundaryConditions(event)

    #textEditorによるDic編集
    def onEditDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.editRegionWallBoundaryConditionsDict(event)

    #Dict実行（設定）
    def onRunDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runRegionWallBoundaryConditionsDict(event)

    #changeDict作成
    def onMakeChangeDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.makeChangeDict(event)

    #changeDict編集・実行
    def onEditRunChangeDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.editRunChangeDict(event)

    #file操作
    def onFileOperation(self, event):  # wxGlade: MyFrame.<event_handler>
        self.fileOperation(event)

    #region追加・削除
    def onAddDeleRegion(self, event):  # wxGlade: MyFrame.<event_handler>
        self.addDeleteRegion(event)

    #close
    def onClose(self, event):  # wxGlade: MyFrame.<event_handler>
        self.Destroy()

# end of class MyFrame

    #
    #  editRegionWallBoundaryConditionsDict
    #    textEditorによるDict編集
    def editRegionWallBoundaryConditionsDict(self, event):
        fileName = currCaseDir + "/system/" + dictName
        if len(glob.glob(fileName)) == 0:
            dummy = readDictFile(currCaseDir)
            title = _(u"警告")
            mess = dictName + _(u"ファイルが存在しなかったので、defaultのdictファイルをsysytemフォルダにコピーしました。")
            self.okDialog(title, mess)
        pyTreeFoam.runEditor(fileName)

    #
    #  runRegionWallBoundaryConditionsDict
    #    dict実行（設定）
    def runRegionWallBoundaryConditionsDict(self, event):
        #dict有無の確認
        fileName = currCaseDir + "/system/" + dictName
        if len(glob.glob(fileName)) == 0:
            title = _(u"エラー")
            mess = dictName + _(u"が存在しない為、実行（設定）できません。")
            self.errDialog(title, mess)
            return
        #各fieldの界面の境界条件が既に設定されているかどうかをチェック
        caseDir = currCaseDir
        [error, mess] = checkAllFields(caseDir)
        if error != "OK":
            title = _(u"警告")
            stat = self.okCancelDialog(title, mess)
            if stat == "CANCEL":
                return stat
        #fieldの置き換え
        [fluidRegions, solidRegions] = pyTreeFoam.getZonesInRegionProperties(caseDir)
        [error, errFields] = replaceRegionFieldBoundaryConditions(caseDir, 
                        fluidRegions, solidRegions)
        if error == "OK":
            title = _(u"界面の境界条件設定")
            mess = _(u"領域間の境界条件とinternalFieldを再設定しました。\n")
            if len(errFields) > 0:
                mess += _(u"以下のfieldは、存在しない為、修正していません。\n")
                if len(errFields) > 5:
                    addMess = ", ".join(errFields[:5]) + "..."
                else:
                    addMess = ", ".join(errFields)
                mess += addMess
            print mess
            self.okDialog(title, mess)
        else:
            title = _(u"エラー")
            self.errDialog(title, errFields)
        return error

    #
    #  setBoundaryConditions
    #    境界面の境界条件設定
    def setBoundaryConditions(self, event):
        config = pyTreeFoam.readConfigTreeFoam()
        OFversion = config[0]
        if OFversion[:3] == "ext":
            title = _(u"エラー")
            mess = _(u"この機能は、OpenFOAM-ext では使えません。\n")
            mess += _(u"OpenFOAM-2.2 以降で使用できます。")
            self.errDialog(title, mess)
        elif OFversion >= "2.2.0":
            caseDir = os.getcwd()
            comm = "createBCsForMultiRegionDialog.py " + caseDir + " &"
            pyTreeFoam.runOFUtility(comm)
        else:
            title = _(u"エラー")
            mess = _(u"この機能は、OpenFOAM-2.1 以前では使えません。\n")
            mess += _(u"OpenFOAM-2.2 以降で使用できます。")
            self.errDialog(title, mess)

    #
    #  addDeleteRegion
    #    regionの追加・削除
    def addDeleteRegion(self, event):
        caseDir = os.getcwd()
        addDeleteRegionDialogShow(caseDir)

    #
    #  makeChangeDict
    #    fieldデータを読み込みchangeDictを作成する
    def makeChangeDict(self, event):
        if self.checkMultiRegion() == False:
            return

        timeFolder = getFoamContents.getCurrTimeFolder(currCaseDir)
        inputTextDDialog.title = _(u"ファイル名の入力")
        inputTextDDialog.message = _(u"保存するファイル名を入力してください。\nboundaryFieldは、「") + timeFolder + _(u"」フォルダ(firstTime)から取得します。")
        inputTextDDialog.inputText = u"changeDictionaryAllRegionsDict-auto"
        dialog = inputTextDDialog.MyDialog(None)
        result = dialog.ShowModal()
        ans = inputTextDDialog.status
        if ans == "OK":
            fileName = currCaseDir + "/system/" + inputTextDDialog.inputText
            contents = getFieldBoundaryData(currCaseDir, timeFolder)
            f=open(fileName, "w"); f.write(contents); f.close()
            title = _(u"ファイルの保存")
            message = _(u"ファイルを保存しました\nboundaryFieldのデータは、「") + timeFolder + _(u"」フォルダから取得してchangeDictを作成しました。")
            self.okDialog(title, message)

    #
    #  checkMultiRegion
    #    multiRegionのcaseかどうかチェック
    def checkMultiRegion(self):
        global currCaseDir
        [ans, loc, regNames] = pyTreeFoam.checkMultiRegion(currCaseDir)
        if ans == False:
            title = _(u"エラー")
            mess = _(u"現在のcaseは、multiRegionではありません。")
            self.errDialog(title, mess)
        return ans

    #
    #  editRunChangeDict
    #    changeDictionaryの編集・実行
    #    編集はdialog内で実行するので、ここでは実行のみ記述
    def editRunChangeDict(self, event):
        if self.checkMultiRegion() == False:
            return

        #runFileの取得
        title = _(u"実行fileの選択")
        message = _(u"changeDictionaryAllRegionsを編集・実行します。\n  Dict fileを選択してください。")
        currDir = os.getcwd() + "/system"
        fileFilter = "changeDictionaryAllRegionsDict*"
        [stat, fileName] = getOpenRunFileDDialogShow(title, message,
                            currDir, fileFilter)
        if stat != "RUN":
            return
        #file名の確認
        runFile = currDir + "/" + fileName
        if len(glob.glob(runFile)) == 0:
            title = _(u"エラー")
            msg = _(u"「") + runFile + _(u"」ファイルがありません。")
            self.errDialog(title, msg)
            return

        #実行
        title = _(u"changeDictionaryAllRegionsの実行")
        mess = _(u"changeDictionaryAllRegionsを実行します。\n")
        mess += _(u"全regionのboundaryFieldの設定が変更されます。\n")
        mess += _(u"  実行しますか？")
        ans = self.okCancelDialog(title, mess)
        if ans == "OK":
            comm = "changeDictionaryAllRegions.py " + fileName
            [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
            if stat == "OK":
                msg = _(u"全てのregionに対して「changeDictionary」を適用しました。")
                self.okDialog(title, msg)
            else:
                msg = _(u"エラーが発生しました。\n　logを確認してください。")
                self.errDialog(title, msg)

    #
    #  fileOperation
    #    region内のfile操作
    def fileOperation(self, event):
        if self.checkMultiRegion() == False:
            return
        self.Destroy()
        fileOperationInRegionDialogShow("1")


    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        res = dlg.ShowModal()
        if res == wx.ID_OK:
            ans = "OK"
        else:
            ans = "CANCEL"
        dlg.Destroy()
        return ans

#
#  initialize
#
def initialize():
    global currCaseDir
    currCaseDir = os.getcwd()

#
#  getFieldBoundaryData
#    全fieldのinternal、boundaryFieldとboundaryの設定を取得
#    internalField:uniform形式のデータ
#    boundaryField:U, T fieldは、全データ。それ以外は、zeroGradient以外のデータを取得
#    boundary:全データを取得
def getFieldBoundaryData(caseDir, timeFolder):
    [flag, loc, regNames] = pyTreeFoam.checkMultiRegion(caseDir)
    if flag == False:
        contents = ""
        return contents

    OFversion = getOFversion()
    contents = foamHeader(OFversion)
    i=0
    while i<len(regNames):
        regName = regNames[i]
        #boundaryデータの取得
        fieldDir = caseDir + "/" + timeFolder + "/" + regName
        boundaryDir = getFoamContents.getCurrMeshDir(caseDir, timeFolder, regName, "boundary")
        rowNames = getRowNamesFromBoundary(boundaryDir)
        patchData = getPatchData(boundaryDir, rowNames)
        patchesCont = getAllPatchData(rowNames, patchData)
        if OFversion[:3] == "ext":
            patchesCont = addSpace(8, patchesCont)
            #boundaryFieldデータの取得
            fields = pyTreeFoam.getFieldNames(fieldDir)
            bcCont = getBoundaryFieldData(fieldDir, fields, rowNames)
            bcCont = addSpace(8, bcCont)
            contents += regName + "\n"
            contents += "{\n"
            contents += "    dictionaryReplacement\n"
            contents += "    {\n"
            contents += patchesCont
            contents += bcCont
            contents += "    }\n"
            contents += "}\n"
        elif OFversion >= "4.0":
            patchesCont = addSpace(4, patchesCont)
            #boundaryFieldデータの取得
            fields = pyTreeFoam.getFieldNames(fieldDir)
            bcCont = getBoundaryFieldData(fieldDir, fields, rowNames)
            bcCont = addSpace(4, bcCont)
            contents += regName + "\n"
            contents += "{\n"
            contents += patchesCont
            contents += bcCont
            contents += "}\n"
        else:
            patchesCont = addSpace(8, patchesCont)
            #boundaryFieldデータの取得
            fields = pyTreeFoam.getFieldNames(fieldDir)
            bcCont = getBoundaryFieldData(fieldDir, fields, rowNames)
            bcCont = addSpace(8, bcCont)
            contents += regName + "\n"
            contents += "{\n"
            contents += "    dictionaryReplacement\n"
            contents += "    {\n"
            contents += patchesCont
            contents += bcCont
            contents += "    }\n"
            contents += "}\n"
        i += 1
    contents += setFoamContents.makeFooter()
    return contents

#  getOFversion
#    OFのバージョンを取得
def getOFversion():
    config = pyTreeFoam.readConfigTreeFoam()
    return config[0]

#  foamHeader
#    headerを作成
def foamHeader(OFversion):
    cont = setFoamContents.makeFoamHeader()
    cont += setFoamContents.makeFoamFile(OFversion, "ascii", "dictionary",
                "system", "changeDictionaryAllRegionsDict")
    return cont

#  getBoundaryFieldData
#    各fieldのbaoundaryFieldのデータ作成
def getBoundaryFieldData(fieldDir, fields, rowNames):
    data = loadFromGaugeDialog(fieldDir, fields, rowNames)
    [dimData, intData, variables, variablesBoundary] = getDimensionInternalFieldData(fieldDir, fields)
    #variablesを整形
    i = 0
    for variable in variables:
        variables[i] = addSpace(4, variable)
        i += 1
    #variablesBoundaryを整形
    i = 0
    for variable in variablesBoundary:
        variablesBoundary[i] = addSpace(8, variable)
        i += 1
    #internalDataを選別（uniform形式のみ取得）
    i=0
    while i<len(intData):
        lines = intData[i].split("\n")
        if lines[0].split()[0] != "uniform":
            intData[i] = ""
        i += 1
    #boundaryFieldDataを選別（calculatedと20行以上は取得せず）
    i=0
    while i<len(data):
        j = 0
        while j<len(data[i]):
            lines = data[i][j].split("\n")
            if len(lines) > 20:
                data[i][j] = ""
            j += 1
        i += 1
    #field毎にdata作成
    cont = ""
    i=0
    while i<len(fields):
        #field名書き出し
        field = fields[i]
        cont += field + "\n"
        cont += "{\n"
        #variables書き出し
        cont += variables[i]
        #internalField書き出し
        if intData[i] != "":
            cont += "    internalField " + intData[i] + "\n"
        #TとU fieldの境界条件は全て書き出し
        if field == "T" or field == "U":
            cont += "    boundaryField\n"
            cont += "    {\n"
            if data[i] != "":
                #variableBoundaryの書き出し
                cont += variablesBoundary[i]
                #境界条件を書き出し
                j = 0
                labels = data[i]
                while j<len(labels):
                    cont += "        " + rowNames[j] + "\n"
                    cont += "        {\n"
                    cont += addSpace(12, labels[j])
                    cont += "        }\n"
                    j += 1
                cont += "    }\n"
        #T、U以外の境界条件を書き出し
        else:
            cont += "    boundaryField\n"
            cont += "    {\n"
            #variablesBoundaryの書き出し
            cont += variablesBoundary[i]
            #境界条件を書き出し
            j = 0
            labels = data[i]
            while j<len(labels):
                if labels[j] != "":
                    #zeroGradientは、書き出しせず
                    if labels[j].split("\n")[0].find("zeroGradient") < 0:
                        cont += "        " + rowNames[j] + "\n"
                        cont += "        {\n"
                        cont += addSpace(12, labels[j])
                        cont += "        }\n"
                j += 1
            cont += "    }\n"
        cont += "}\n"
        i += 1
    #cont = addSpace(8, cont)
    return cont

#  addSpace
#     行頭にスペース追加
def addSpace(n, cont):
    space = " "*n
    ans = ""
    lines = cont.split("\n")
    for line in lines:
        ans += space + line + "\n"
    return ans

#  getPatchData
#    boundaryのpatch定義を取得
def getPatchData(boundaryDir, rowNames):
    patchData = getDefinePatchData(boundaryDir, rowNames)
    ans = []
    for data in patchData:
        lines = data.split("\n")
        cont = ""
        for line in lines:
            words = line.split()
            if words[0] != "nFaces" and words[0] != "startFace":
                cont += line + "\n"
        ans.append(cont)
    return ans

#  getAllPatchData
#    boundaryのpatch dataを作成
def getAllPatchData(rowNames, patchData):
    cont = "boundary\n{\n"
    i=0
    while i<len(rowNames):
        patchLines = patchData[i].split("\n")
        cont += "    " + rowNames[i] + "\n"
        cont += "    {\n"
        for line in patchLines:
            if line != "":
                cont += "        " + line + "\n"
        cont += "    }\n"
        i += 1
    cont += "}\n"
    return cont

#  deleteNonuniformListData
#    patch定義データからnonuniform形式のデータを削除する
def deleteNonuniformListData(defineDataSub):
    defines = []
    for definePatch in defineDataSub:
        define = ""
        lines = definePatch.split(";")
        for line in lines:
            words = line.split()
            if len(words)>=3:
                if not (words[1] == "nonuniform" and words[2][:len("List")] == "List"):
                    define += line + ";\n"
            elif len(line) != 0:
                define += line + ";\n"
        defines.append(define)
    return defines

#
#  loadFromGaugeDialog(dataDir, colNames, rowNames)
#    gaugeDialogからデータを取得する
def loadFromGaugeDialog(dataDir, colNames, rowNames):
    #boundaryDirを取得
    caseDir = currCaseDir
    regName = dataDir.split("/")[-1]
    timeFolder = dataDir.split("/")[-2]
    fieldDir = dataDir
    boundaryDir = getFoamContents.getCurrMeshDir(caseDir, timeFolder, regName, "boundary")
    #boundaryの内容を取得
    defineDataSub = getDefinePatchData(boundaryDir, rowNames)
    defineData = deleteNonuniformListData(defineDataSub)
    gaugeDDialog.job = "load"
    gaugeDDialog.title = _(u"fieldの読み込み")
    gaugeDDialog.dataDir = dataDir
    gaugeDDialog.colNames = colNames
    gaugeDDialog.rowNames = rowNames
    gaugeDDialog.defineData = defineData
    gaugeDDialog.maxRowsInCell = 25             #cell内の最大表示行数を設定
    data = gaugeDDialog.getLoadData(dataDir, colNames)
    return data


if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    initialize()
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
