#!/usr/bin/env python
# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.5 on Sat Dec  7 17:23:14 2013
#
#   snappyHexMeshDialog220.py
#
#       snappyHexMeshDict作成、実行。
#       OpenFOAM-2.2.0以降の場合
#
#   13/12/08    新規作成
#      12/21    stdout、stderrの設定（import logFileCreater）を追加
#   14/01/04    バグ修正（dictファイルが無かった場合エラー発生）
#      02/03    csv作成後、csv編集するように修正
#      03/17    checkBlockMeshSnappyHexMesh:デフォルトのblockMeshDictの場所を修正
#      04/12    runFeatureEdge:triSurfaceﾌｫﾙﾀﾞが無かった場合、ｴﾗｰ発生を修正
#               runSnappy_sub:   同上
#      06/04    changePatchName:空patch削除を追加
#               getStlDir:stlDirを保存する様に修正
#      07/12    バグ修正（圧縮時、eMesh.gzを認識しなかった）
#      08/31    layer作成ルーチンを追加
#      09/08    runLayer:snappy実行前にcellLevel、pointLevelを削除
#      12/23    checkBlockMeshSnappyHexMesh:polyMeshフォルダが無い場合作成する
#   15/02/08    runSnappy_sub:mesh作成を端末表示させて実行する様に修正
#      07/17    dialogの起動方法を修正
#      10/02    checkMeshボタン追加
#      11/30    checkBlockMeshSnappyHexMesh:dictFileのコピー元dir取得方法変更。
#   16/05/08    getHelyxosData:default値を設定（バグ修正）
#      06/03    runLayer:cellLevel、pointLevelの削除を中止
#
#
#---------------code作成後の修正項目---------------------
#
#   ・アイコンのDirを書き直す（絶対path→相対path(./icons/***.png)）
#

import wx
import os
import glob
import pyTreeFoam
import getFoamContents
import setFoamContents
import getOpenFolderDDialog
import inputTextDDialog
import createBlockAndSnappyDict
import runHelyxosDialog220
import createLayersDDialog
from getOpenFileDDialog import selFilesShow as getFilesDialog
from getOpenFileDDialog import seledSelFilesShow as getFilesSelDialog

import logFileCreater; logFileCreater.log()



# begin wxGlade: extracode
# end wxGlade

helyxDataFile = "data/helyxOS_data"
caseDir = ""
blockMeshDir = ""
stlDir = ""
stlOrgDir = ""
csvFileNames = []
csvFileName = ""
surfaceAngle = ""


def Show(caseDir0, blockMeshDir0, stlDir0):
    global caseDir, blockMeshDir, stlDir, stlOrgDir
    caseDir = caseDir0
    os.chdir(caseDir)
    blockMeshDir = blockMeshDir0
    stlOrgDir = stlDir0
    stlDir = getAbsPath(stlDir0)
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):

        savePath = os.getcwd()
        os.chdir(os.environ["TreeFoamPath"])

        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.bitmap_1 = wx.StaticBitmap(self, wx.ID_ANY, wx.Bitmap("./icons/editMesh.png", wx.BITMAP_TYPE_ANY))
        self.label_1 = wx.StaticText(self, wx.ID_ANY, _(u"snappyHexMeshによるmesh作成"), style=wx.ALIGN_CENTRE)
        self.button_3 = wx.Button(self, wx.ID_ANY, _(u"開く"))
        self.text_ctrl_2 = wx.TextCtrl(self, wx.ID_ANY, "")
        self.button_8 = wx.Button(self, wx.ID_ANY, _(u"参照..."))
        self.button_2 = wx.Button(self, wx.ID_ANY, _(u"stlチェック..."))
        self.label_4 = wx.StaticText(self, wx.ID_ANY, _(u"stlのsolid名やscaleを変更する"))
        self.sizer_33_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"stlファイル"))
        self.text_ctrl_1 = wx.TextCtrl(self, wx.ID_ANY, "")
        self.label_15 = wx.StaticText(self, wx.ID_ANY, _(u"（角度）"))
        self.button_1 = wx.Button(self, wx.ID_ANY, _(u"Dict編集..."))
        self.label_10 = wx.StaticText(self, wx.ID_ANY, _(u"→"))
        self.button_6 = wx.Button(self, wx.ID_ANY, _(u"Dict実行(抽出)..."))
        self.label_3 = wx.StaticText(self, wx.ID_ANY, _(u"surfaceFeatureExtractDictを作成し、実行する事で抽出する"))
        self.sizer_13_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"特徴線の抽出"))
        self.combo_box_1 = wx.ComboBox(self, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.label_2 = wx.StaticText(self, wx.ID_ANY, _(u":編集・実行の対象となるcsvファイル名"))
        self.button_13 = wx.Button(self, wx.ID_ANY, _(u"csv作成..."))
        self.button_14 = wx.Button(self, wx.ID_ANY, _(u"csv編集"))
        self.button_15 = wx.Button(self, wx.ID_ANY, _(u"snappyDict作成..."))
        self.button_10 = wx.Button(self, wx.ID_ANY, _(u"snappyDict編集"))
        self.button_11 = wx.Button(self, wx.ID_ANY, _(u"snappy実行..."))
        self.button_16 = wx.Button(self, wx.ID_ANY, _(u"patch名修正..."))
        self.label_14 = wx.StaticText(self, wx.ID_ANY, _(u"csvファイルを作成・編集して、csvファイルから、blockMeshDict、\nsnappyHexMeshDictを作り出す。 多くのcellZoneを作る場合は、有用。\ncsvファイルは、stlファイルと同じfolderに保存される。"))
        self.sizer_41_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"csvファイルによるmesh作成"))
        self.button_4 = wx.Button(self, wx.ID_ANY, _(u"Dict作成..."))
        self.button_7 = wx.Button(self, wx.ID_ANY, _(u"Dict編集"))
        self.button_9 = wx.Button(self, wx.ID_ANY, _(u"layer作成"))
        self.label_5 = wx.StaticText(self, wx.ID_ANY, _(u"現在のmeshにlayerを追加します。snappyHexMeshを実行して作成する。\ntetra, polyHedra meshでもlayerが追加できる。"))
        self.sizer_4_staticbox = wx.StaticBox(self, wx.ID_ANY, _(u"meshにlayer追加"))
        self.button_17 = wx.Button(self, wx.ID_ANY, _("checkMesh"))
        self.button_12 = wx.Button(self, wx.ID_ANY, _(u"paraFoam起動"))
        self.button_5 = wx.Button(self, wx.ID_ANY, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onOpenFolder, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onSetStlLocation, self.button_8)
        self.Bind(wx.EVT_BUTTON, self.onStlCheck, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onFeatureEdge, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onRunFeatureEdge, self.button_6)
        self.Bind(wx.EVT_BUTTON, self.onCreateCsv, self.button_13)
        self.Bind(wx.EVT_BUTTON, self.onOpenCaseFolder, self.button_14)
        self.Bind(wx.EVT_BUTTON, self.onCreateMeshDict, self.button_15)
        self.Bind(wx.EVT_BUTTON, self.onEditSnappyDict, self.button_10)
        self.Bind(wx.EVT_BUTTON, self.onRunSnappyDict, self.button_11)
        self.Bind(wx.EVT_BUTTON, self.onChangePatchName, self.button_16)
        self.Bind(wx.EVT_BUTTON, self.onCreateLayerDict, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onEditLayerDict, self.button_7)
        self.Bind(wx.EVT_BUTTON, self.onRunLayer, self.button_9)
        self.Bind(wx.EVT_BUTTON, self.onCheckMesh, self.button_17)
        self.Bind(wx.EVT_BUTTON, self.onRunParaFoam, self.button_12)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_5)
        # end wxGlade

        os.chdir(savePath)
        self.SetTitle(_(u"snappyHexMeshによるmesh作成"))
        self.setDataToTextBox()
        self.setCsvFileNamesToBox()


    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_("frame_1"))
        self.button_3.SetMinSize((40, 30))
        self.text_ctrl_2.SetMinSize((330, 28))
        self.button_8.SetMinSize((60, 30))
        self.button_2.SetMinSize((110, 30))
        self.text_ctrl_1.SetMinSize((50, 25))
        self.button_1.SetMinSize((110, 30))
        self.button_6.SetMinSize((130, 50))
        self.combo_box_1.SetMinSize((220, 30))
        self.button_13.SetMinSize((110, 30))
        self.button_4.SetMinSize((110, 30))
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_10 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_11 = wx.BoxSizer(wx.VERTICAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_4_staticbox.Lower()
        sizer_4 = wx.StaticBoxSizer(self.sizer_4_staticbox, wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_41_staticbox.Lower()
        sizer_41 = wx.StaticBoxSizer(self.sizer_41_staticbox, wx.VERTICAL)
        sizer_43 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_42 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_13_staticbox.Lower()
        sizer_13 = wx.StaticBoxSizer(self.sizer_13_staticbox, wx.VERTICAL)
        sizer_14 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_36 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_15 = wx.BoxSizer(wx.VERTICAL)
        sizer_22 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_33_staticbox.Lower()
        sizer_33 = wx.StaticBoxSizer(self.sizer_33_staticbox, wx.VERTICAL)
        sizer_12 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_34 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_35 = wx.BoxSizer(wx.VERTICAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2.Add(self.bitmap_1, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_2.Add(self.label_1, 0, wx.ALL | wx.ALIGN_CENTER_VERTICAL, 10)
        sizer_1.Add(sizer_2, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_34.Add(self.button_3, 0, wx.LEFT | wx.ALIGN_BOTTOM, 20)
        sizer_35.Add(self.text_ctrl_2, 0, wx.EXPAND | wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_34.Add(sizer_35, 1, wx.EXPAND, 0)
        sizer_34.Add(self.button_8, 0, wx.LEFT | wx.RIGHT, 0)
        sizer_33.Add(sizer_34, 0, wx.EXPAND, 0)
        sizer_12.Add(self.button_2, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_12.Add(self.label_4, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_33.Add(sizer_12, 1, wx.EXPAND, 0)
        sizer_33.Add((20, 5), 0, 0, 0)
        sizer_1.Add(sizer_33, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_22.Add(self.text_ctrl_1, 0, wx.LEFT, 20)
        sizer_22.Add(self.label_15, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_15.Add(sizer_22, 1, wx.EXPAND, 0)
        sizer_15.Add(self.button_1, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_14.Add(sizer_15, 0, wx.EXPAND, 0)
        sizer_14.Add(self.label_10, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_36.Add(self.button_6, 0, wx.LEFT | wx.ALIGN_BOTTOM, 20)
        sizer_14.Add(sizer_36, 1, wx.EXPAND, 0)
        sizer_13.Add(sizer_14, 1, wx.EXPAND, 0)
        sizer_13.Add(self.label_3, 0, wx.LEFT | wx.RIGHT, 40)
        sizer_1.Add(sizer_13, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_3.Add(self.combo_box_1, 0, wx.LEFT, 20)
        sizer_3.Add(self.label_2, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_41.Add(sizer_3, 1, wx.EXPAND, 0)
        sizer_42.Add(self.button_13, 0, wx.LEFT, 20)
        sizer_42.Add(self.button_14, 0, wx.LEFT, 20)
        sizer_42.Add(self.button_15, 0, wx.LEFT, 10)
        sizer_41.Add(sizer_42, 1, wx.EXPAND, 0)
        sizer_43.Add((130, 20), 0, 0, 0)
        sizer_43.Add(self.button_10, 0, wx.LEFT, 20)
        sizer_43.Add(self.button_11, 0, wx.LEFT, 10)
        sizer_43.Add(self.button_16, 0, wx.LEFT, 10)
        sizer_41.Add(sizer_43, 0, wx.EXPAND, 0)
        sizer_41.Add(self.label_14, 0, wx.LEFT, 40)
        sizer_1.Add(sizer_41, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_5.Add(self.button_4, 0, wx.LEFT, 20)
        sizer_5.Add(self.button_7, 0, wx.LEFT, 20)
        sizer_5.Add(self.button_9, 0, wx.LEFT, 10)
        sizer_4.Add(sizer_5, 1, wx.EXPAND, 0)
        sizer_4.Add(self.label_5, 0, wx.LEFT, 40)
        sizer_1.Add(sizer_4, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 10)
        sizer_11.Add((20, 10), 0, 0, 0)
        sizer_6.Add(self.button_17, 0, wx.RIGHT, 5)
        sizer_6.Add(self.button_12, 0, wx.RIGHT | wx.BOTTOM, 20)
        sizer_6.Add(self.button_5, 0, wx.RIGHT | wx.BOTTOM | wx.ALIGN_RIGHT | wx.ALIGN_BOTTOM, 20)
        sizer_11.Add(sizer_6, 1, wx.ALIGN_RIGHT, 0)
        sizer_10.Add(sizer_11, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_10, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #開く
    def onOpenFolder(self, event):  # wxGlade: MyFrame.<event_handler>
        self.openStlFolder()

    #stl場所参照
    def onSetStlLocation(self, event):  # wxGlade: MyFrame.<event_handler>
        self.getStlDir()

    #stlファイルチェック
    def onStlCheck(self, event):  # wxGlade: MyFrame.<event_handler>
        self.stlCheck()

    #特徴線の抽出用Dict作成
    def onFeatureEdge(self, event):  # wxGlade: MyFrame.<event_handler>
        self.featureEdge()

    #特徴線抽出
    def onRunFeatureEdge(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runFeatureEdge()

    #csvファイル作成
    def onCreateCsv(self, event):  # wxGlade: MyFrame.<event_handler>
        self.createCsvFile()
        self.openCaseFolder()

    #csvファイル編集
    def onOpenCaseFolder(self, event):  # wxGlade: MyFrame.<event_handler>
        self.openCaseFolder()

    #meshDict作成
    def onCreateMeshDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.createMeshDict()

    #snappyDict編集
    def onEditSnappyDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.editSnappyDict()

    #snappy実行
    def onRunSnappyDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runSnappy()

    #patch名修正
    def onChangePatchName(self, event):  # wxGlade: MyFrame.<event_handler>
        self.changePatchName()

    #layerDict作成
    def onCreateLayerDict(self, event):  # wxGlade: MyFrame.<event_handler>
        print _(u"layer作成用のsnappyHexMeshDictを作成します")
        self.createLayerDict(event)

    #layerDict編集
    def onEditLayerDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.editLayerDict()

    #layer作成
    def onRunLayer(self, event):  # wxGlade: MyFrame.<event_handler>
        print _(u"meshにlayerを追加します")
        self.runLayer()

    #checkMesh実行
    def onCheckMesh(self, event):  # wxGlade: MyFrame.<event_handler>
        self.checkMesh()

    #paraFoam起動
    def onRunParaFoam(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runParaFoam()

    #閉じる
    def onClose(self, event):  # wxGlade: MyFrame.<event_handler>
        self.Destroy()

# end of class MyFrame


    #
    #  checkMesh
    #    checkMeshの実行
    def checkMesh(self):
        caseName = caseDir.split("/")[-1]
        cont  = "#!/bin/bash\n"
        cont += "checkMesh | tee solve.log\n"
        comm = "echo " + "'" + cont + "'" + " > run"
        os.system(comm)
        os.system("chmod a+x run")
        comm = "gnome-terminal -t " + caseName + " --geometry=120x20 --zoom=0.9 -x bash --rcfile run"
        #os.system(comm)
        pyTreeFoam.runOFUtility(comm)


    #  runParaFoam
    #    paraFoamの起動
    def runParaFoam(self):
        config = pyTreeFoam.readConfigTreeFoam()
        paraFoamFix = config[4]
        comm = "runParaFoamOptionDialog.py " + paraFoamFix + " " + caseDir + " &"
        pyTreeFoam.runCommand(comm.encode("utf-8"))

    #  runLayer
    #    layerの作成
    def runLayer(self):
        title = _(u"layerの作成")
        mess = _(u"現在のmeshにlayerを追加します。\n（snappyHexMeshの実行）")
        ans = self.okCancelDialog(title, mess)
        if ans == "OK":
            #cellLevel, pointLevelを削除
            #comm = "rm -rf constant/polyMesh/cellLevel constant/polyMesh/pointLevel"
            #os.system(comm)
            #snappy実行
            comm = "snappyHexMesh"
            pyTreeFoam.runOFUtility(comm)
            mess = _(u"layerを追加しました。")
            self.okDialog(title, mess)

    #  createLayerDict
    #    layer作成用Dictの作成
    def createLayerDict(self, event):
        stat = createLayersDDialog.Show(caseDir)


    #  setDataToTextBox
    #    textBoxにdataをセット
    def setDataToTextBox(self):
        global caseDir, stlDir, surfaceAngle
        [stlDir, surfaceAngle, clearMesh] = getHelyxosData(caseDir)
        self.text_ctrl_2.SetValue(stlDir)
        self.text_ctrl_1.SetValue(surfaceAngle)

    #  setCsvFilNamesToBox
    #    csvファイル名をcomboBoxにセット
    def setCsvFileNamesToBox(self):
        global csvFileNames
        csvFileNames = getCsvFileNames(stlDir)
        self.combo_box_1.Clear()
        self.combo_box_1.AppendItems(csvFileNames)

    #  getFeatureFiles
    #    特徴線を作成するstlファイルを取得
    def getFeatureFiles(self, currDir):
        title = _(u"特徴線抽出fileの選択")
        mess = _(u"特徴線（featureEdge）を抽出します。\n特徴線を抽出するfileを選択してください。")
        fileFilter = u"*.stl"
        [status, selFiles] = getFilesDialog(title, mess, currDir, fileFilter)
        if status == "OK":
            return selFiles
        else:
            return []

    #  checkBlockMeshSnappyHexMesh
    #    meshのDictファイルのチェック
    def checkBlockMeshSnappyHexMesh(self, caseDir):
        global blockMeshDir
        if len(blockMeshDir) == 0:
            #defaultのblockMeshDictの場所を設定
            blockMeshDir = "constant/polyMesh"
        copyFiles = []
        #blockMeshのチェック
        fileName = caseDir + "/constant/polyMesh/blockMeshDict"
        if len(glob.glob(fileName)) == 0:
            if len(glob.glob(caseDir + "/constant/polyMesh")) == 0:
                comm = "mkdir " + caseDir + "/constant/polyMesh"
                os.system(comm)
            copyFiles.append("blockMeshDict")
        #snappyHexMeshのチェック
        fileName = caseDir + "/system/snappyHexMeshDict"
        if len(glob.glob(fileName)) == 0:
            copyFiles.append("snappyHexMeshDict")
        #decomposeParDictのチェック
        fileName = caseDir + "/system/decomposeParDict"
        if len(glob.glob(fileName)) == 0:
            copyFiles.append("decomposeParDict")
        #チェックしたファイルが存在しなかった場合コピーする
        if len(copyFiles) != 0:
            #helyxosFolders = glob.glob(os.environ["TreeFoamPath"] +
            #                    "/data/HelyxOS/newCase*")
            #helyxosFolders = glob.glob(os.environ["TreeFoamPath"] +
            #                    "/data/OFDict/OF*")
            #helyxosFolders.sort()
            #sourceDir = helyxosFolders[-1]
            sourceDir = setFoamContents.getOFversionFolder()
            for name in copyFiles:
                sourceFile = sourceDir + "/system/" + name
                if name == "blockMeshDict":
                    distFile = caseDir + "/constant/polyMesh/" + name
                else:
                    distFile = caseDir + "/system/" + name
                comm = "cp " + sourceFile + " " + distFile
                os.system(comm)
            title = _(u"meshDictファイルのコピー")
            mess = _(u"以下のファイルが存在しなかったので、default設定のDictファイルをコピーしました。\n")
            for name in copyFiles:
                mess += name + ", "
            mess = mess[:-2]
            self.okDialog(title, mess)

    #
    #  runSnappy_sub
    #    mesh作成
    #    job:"block"  blockMesh作成
    #        "snappy" snappyHexMesh作成
    #        "patch"  patch名修正
    def runSnappy_sub(self, job):

        #  findJob
        #    job内容を解釈
        def findJob(find, job):
            ans = False
            for word in job:
                if word == find:
                    ans = True
                    break
            return ans

        global blockMeshDir, caseDir, stlDir
        blockDict = blockMeshDir + "/blockMeshDict"
        snappyDict = "system/snappyHexMeshDict"
        #meshデータ削除
        delFolder = caseDir + "/constant/polyMesh"
        [folders, files] = pyTreeFoam.getFoldersFiles(delFolder)
        for name in files:
            if name != "blockMeshDict":
                os.system("rm -r " + delFolder + "/" + name)
        #mesh作成
        caseName = caseDir.split("/")[-1]
        config = pyTreeFoam.readConfigTreeFoam()
        envOpenFOAM = config[1]
        saveDir = os.getcwd()
        os.chdir(caseDir)
        cont = "#!/bin/bash\n"
        cont = ". " + envOpenFOAM + "\n"
        #blockMesh
        if findJob("block", job) == True:
            cont += "blockMesh -dict " + blockDict + " | tee solve.log\n"
        #snappyHexMesh
        if findJob("snappy", job) == True:
            cont += "snappyHexMesh -overwrite | tee -a solve.log\n"
        #patch修正
        if findJob("patch", job) == True:
            cont += "meetPatchNameDeleteNullPatch220.py " + caseDir + " " + stlDir + "\n"
        #スクリプト作成
        comm = "echo " + "'" + cont + "'" + " > run"
        os.system(comm)
        os.system("chmod a+x run")
        comm = "gnome-terminal -t " + caseName + " --geometry=120x20 --zoom=0.9 -x bash --rcfile run"
        os.system(comm)
        os.chdir(saveDir)

    #
    #  runFeatureEdge
    #    Dict実行（特徴線を抽出）
    def runFeatureEdge(self):
        #Dictファイルの確認
        if len(glob.glob(caseDir + "/system/surfaceFeatureExtractDict")) == 0:
            title = _(u"エラー")
            mess = _(u"surfaceFeatureExtractDictファイルがありません。\n特徴線が抽出できません。")
            self.errDialog(title, mess)
            return

        #実行の確認
        title = _(u"特徴線の抽出")
        mess = _(u"surfaceFeatureExtractDict内容に基づき、特徴線を抽出します。")
        stat = self.okCancelDialog(title, mess)
        if stat != "OK":
            return

        #stlFileをtriSurfaceに移動
        if len(glob.glob("./constant/triSurface/")) == 0:
            comm = "mkdir ./constant/triSurface"
            os.system(comm)
        files = glob.glob(stlDir + "/*.stl")
        for stlFile in files:
            comm = "cp " + stlFile + " " + "./constant/triSurface"
            os.system(comm)
        #実行
        comm = "surfaceFeatureExtract"
        [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
        eMeshFiles = glob.glob("./constant/triSurface/*.eMesh*")
        for eMeshFile in eMeshFiles:
            comm = "cp " + eMeshFile + " " + stlDir
            print comm
            os.system(comm)
        eMeshFilesStl = glob.glob(stlDir + "/*eMesh*")

        title = _(u"特徴線（feature edge）の抽出")
        if len(eMeshFilesStl) == 0 or stat != "OK":
            message = _(u"エラーが発生しました。\n「./constant/triSurface」フォルダ内の*.eMeshファイルを確認してください。")
            self.errDialog(title, message)
        else:
            message = _(u"surfaceFeatureExtractDict から特徴線（feature edge）を抽出しました。")
            self.okDialog(title, message)

    #
    #  changePatchName
    #    patch名の修正
    def changePatchName(self):
        title = _(u"patch名修正")
        mess = _(u"patch名をstlファイル名に変更します。\n")
        mess += _(u"  未定義patchを「zeroGradient」で定義した上で\n")
        mess += _(u"  patch名に含まれるsolid名を削除する。")
        stat = self.okCancelDialog(title, mess)
        if stat == "OK":
            error = runHelyxosDialog220.meetPatchNameToStl(caseDir, stlDir)
            if error[0] == "OK":
                title = _(u"mesh作成")
                mess = _(u"patch名をstlファイル名に変更しました。")
                print mess
                mess += _(u"\n\n引き続き、以下の処理を行いますか？\n")
                mess += _(u"  faceの無い空patchを削除する。")
                stat = self.okCancelDialog(title, mess)
                if stat == "OK":
                    error = pyTreeFoam.deleteNullPatches(caseDir)
                    if error[0] == "OK":
                        mess = _(u"全ての空patchを削除しました。")
                        print mess
                        self.okDialog(title, mess)
                    else:
                        title = _(u"エラー")
                        mess = error[1]
                        self.errDialog(title, mess)
            else:
                title = _(u"エラー")
                mess = error[1]
                self.errDialog(title, mess)

    #
    #  runSnappy
    #    snappy実行
    def runSnappy(self):
        global caseDir, blockMeshDir
        blockDict = caseDir + "/" + blockMeshDir + "/blockMeshDict"
        snappyDict = caseDir + "/system/snappyHexMeshDict"
        if len(glob.glob(blockDict)) == 0 or len(glob.glob(snappyDict)) == 0:
            title = _(u"エラー")
            message = _(u"「blockMeshDict」または「snappyHexhMeshDict」ファイルがsystemフォルダ内に存在しない為、実行できません。")
            self.errDialog(title, message)
            return
        #実行の確認
        title = _(u"dict実行")
        mess = _(u"meshデータを削除して、blockMesh、snappyHexMeshを実行し、meshを作り出します。")
        stat = self.okCancelDialog(title, mess)
        if stat != "OK":
            return
        #mesh作成
        job = ["block", "snappy"]
        self.runSnappy_sub(job)

    #
    #  editSnappyDict
    #    snappyHexMeshDict、blockMeshの編集
    def editSnappyDict(self):
        global caseDir, blockMeshDir
        editFiles = caseDir + "/system/snappyHexMeshDict "
        editFiles += caseDir + "/" + blockMeshDir + "/blockMeshDict "
        pyTreeFoam.runEditor(editFiles)

    #
    #  editLayerDict
    #    snappyHexMeshDictの編集
    def editLayerDict(self):
        global caseDir, blockMeshDir
        editFiles = caseDir + "/system/snappyHexMeshDict "
        pyTreeFoam.runEditor(editFiles)

    #
    #  createMeshDict
    #    blockMesh, snappyHexMeshDictを作成する
    def createMeshDict(self):
        global csvFileName
        fileName = self.combo_box_1.GetStringSelection()
        if fileName == "":
            title = _(u"csvファイル編集")
            mess = _(u"csvファイルが選択されていません。\n")
            mess += _(u"編集するcsvファイルを選択してください。")
            self.errDialog(title, mess)
            return
        else:
            #stlDirのチェック
            stlDirAbs = stlDir
            csvFileName = fileName
            csvFileNameDir = stlDir + "/" + fileName
            #blockMesh, snappyHexMeshDict, decomposeParDict有無チェック
            self.checkBlockMeshSnappyHexMesh(caseDir)
            #csv, stl, eMeshファイルの有無チェック
            [error, nonFiles] = createBlockAndSnappyDict.checkStlEMeshFiles(
                                    caseDir, stlDirAbs, csvFileNameDir)
            if error != 0:
                title = _(u"エラー")
                #csvfileのエラー
                if len(nonFiles) == 0:
                    mess =_(u"csvファイルから値が取得できません。\n")
                    mess += _(u"詳細は、logを確認してください。")
                    self.errDialog(title, mess)
                    return
                else:
                    #必要なファイル（stl、eMesh）が存在しない場合
                    stlFiles = []
                    #eMeshFiles = []
                    for name in nonFiles:
                        fileType = name.split(".")[1]
                        if fileType == "stl":
                            stlFiles.append(name)
                    #stlFile有無チェック
                    if len(stlFiles) != 0:
                        mess = _(u"以下のstlFileが存在しません。\n")
                        for name in stlFiles:
                            mess += name +", "
                        self.errDialog(title, mess)
                        return
            #eMesh作成
            files = createBlockAndSnappyDict.getNeededEMeshFiles(
                            caseDir, stlDirAbs, csvFileNameDir)
            deg = self.text_ctrl_1.GetValue()
            runHelyxosDialog220.createEMeshFiles(caseDir, stlDirAbs, files, deg)
            #Dict作成
            error = createBlockAndSnappyDict.createMeshDict(caseDir, stlDirAbs,
                        csvFileNameDir)
            if error != 0:
                title = _(u"エラー")
                mess = _(u"Dictファイル作成中にエラーが発生しました。\n")
                mess += _(u"詳細はlogを確認してください。")
                self.errDialog(title, mess)
                return

            title = _(u"meshDict作成")
            mess = _(u"blocMeshDict、snappyHexMeshDictファイが作成できました。\n")
            mess += _(u"引き続き、snappyHexMeshを実行してmeshを作成しますか？")
            print mess
            stat = self.yesNoDialog(title, mess)
            if stat == "NO":
                return
            #mesh作成
            job = ["block", "snappy", "patch"]
            self.runSnappy_sub(job)

    #  copyFileToTriSurface
    #    fileをTriSurfaceへcopy
    def copyFileToTriSurface(self, caseDir, stlDirAbs, files):
        if len(glob.glob(caseDir+"/constant/triSurface/")) == 0:
            comm = "mkdir " + caseDir + "/constant/triSurface"
            os.system(comm)
        for name in files:
            sourceFile = stlDirAbs + "/" + name
            toCopy = caseDir + "/constant/triSurface/"
            comm = "cp " + sourceFile + " " + toCopy
            os.system(comm)

    #
    #  openCaseFolder
    #    csv fileを編集する
    def openCaseFolder(self):
        global csvFileName, caseDir, stlDir
        stlAbsDir = stlDir
        if stlAbsDir[0] != "/":
            stlAbsDir = caseDir + "/" + stlAbsDir
        office = ""
        pathes = os.environ["PATH"].split(":")
        for path in pathes:
            name = glob.glob(path + "/loffice")
            if len(name) != 0:
                office = "loffice"
                break
            name = glob.glob(path + "/ooffice")
            if len(name) != 0:
                office = "ooffice"
                break
        if office == "":
            pyTreeFoam.openFolderNautilus(stlAbsDir)
        else:
            fileName = self.combo_box_1.GetStringSelection()
            if fileName == "":
                title = _(u"csvファイル編集")
                mess = _(u"csvファイルが選択されていません。\n")
                mess += _(u"編集するcsvファイルを選択してください。")
                self.errDialog(title, mess)
                return
            else:
                csvFileName = stlAbsDir + "/" + fileName
                comm = office + " " + csvFileName + "&"
                os.system(comm)

    #
    #  createCsvFile
    #    blockMesh, snappyHexMeshDict作成用のcsvファイル作成
    def createCsvFile(self):
        global csvFileName, csvFileNames
        #file名の取得
        inputTextDDialog.title = _(u"ファイル名の入力")
        inputTextDDialog.message = _(u"csvファイル名を入力してください。")
        inputTextDDialog.inputText = "snappyMeshDict.csv"
        dialog = inputTextDDialog.MyDialog(None)
        result = dialog.ShowModal()
        if inputTextDDialog.status == "OK":
            text = inputTextDDialog.inputText
        else:
            text = u""
        if text != u"":
            csvFileName = text
            #stlDirのチェック
            #stlDirAbs = getAbsPath(stlDir)
            stlDirAbs = stlDir
            #csvファイル作成
            error = createBlockAndSnappyDict.createCsvFile(caseDir, stlDirAbs,
                        csvFileName)
            if error != 0:
                title = _(u"エラー")
                mess = _(u"エラーが発生しました。\nlogを確認してください。")
                self.errDialog(title, mess)
                return

            title = _(u"csvファイル作成")
            mess = _(u"blockMesh、snappyHexMeshDict作成用のcsvファイルをstlDir内に作成しました。\n")
            mess += _(u"office等でcsvファイルを編集し、cellSize等を設定してください。")
            self.okDialog(title, mess)
            self.setCsvFileNamesToBox()
            self.combo_box_1.SetStringSelection(csvFileName)
        return

    #  getFeatureSeledFiles
    #    特徴線を作成するstlファイルを取得
    def getFeatureSeledFiles(self, seledFiles):
        title = _(u"特徴線抽出fileの選択")
        mess = _(u"特徴線を抽出するfileを選択してください。\n")
        currDir = self.text_ctrl_2.GetValue()
        fileFilter = u"*.stl"
        [status, selFiles] = getFilesSelDialog(title, mess, currDir, fileFilter,
                                seledFiles)
        if status == "OK":
            return selFiles
        else:
            return []


    #
    #  featureEdge
    #    Dict作成
    def featureEdge(self):
        fileName = caseDir + "/system/surfaceFeatureExtractDict"
        angle = self.text_ctrl_1.GetValue()
        if len(glob.glob(fileName)) == 0:
            selFiles = self.getFeatureFiles(stlDir)
            if len(selFiles) > 0:
                cont = makeFeatureDict(fileName, selFiles, angle)
                title = _(u"surfaceFeatureExtractDictの作成")
                mess = _(u"「surfaceFeatureExtractDict」が無かったので、デフォルトのsurfaceFeatureExtractDictをsystemフォルダ内に作成しました。")
                self.okDialog(title, mess)
                pyTreeFoam.runEditor(fileName)
        else:
            seledFiles = getSelectedFiles(fileName)
            selFiles = self.getFeatureSeledFiles(seledFiles)
            if len(selFiles) != 0:
                runHelyxosDialog220.setFeatureEdgeFilesToDict(fileName, selFiles, angle)
                pyTreeFoam.runEditor(fileName)
        return

    #
    #  stlCheck
    #    stlファイルのsolid名をチェック
    def stlCheck(self):
        global stlDir, caseDir
        wdir = self.text_ctrl_2.GetValue()
        stlDir = getAbsPath(wdir)
        comm = "editStlFilesDialog.py " + caseDir + " " + stlDir + " &"
        os.system(comm)

    #
    #  openStlFolder
    #    stlFolderを開く
    def openStlFolder(self):
        global caseDir, stlDir
        if len(glob.glob(stlDir)) == 0:
            mess = _(u"設定したfolderは存在しません。\nstlファイルの場所を再設定してください。")
            self.errDialog(_(u"エラー"), mess)
            return
        pyTreeFoam.openFolderNautilus(stlDir)

    #
    #  getStlDir
    #    stlDirの取得
    def getStlDir(self):
        global stlDir, caseDir
        rootDir = os.environ["HOME"].encode("utf-8")
        title = _(u"開く")
        message = _(u"folderを選択する")
        stlAbsDir = getAbsPath(stlDir)
        [stat, ansDir] = getOpenFolderDDialog.Show(title, message, rootDir, caseDir, stlAbsDir)
        if stat == "OK":
            stlDir = ansDir
            self.text_ctrl_2.SetValue(stlDir)
            self.setCsvFileNamesToBox()
            saveStlDir(caseDir, stlDir)


    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def yesNoDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.YES | wx.NO | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        stat = ""
        if ans == wx.ID_YES:
            stat = "YES"
        else:
            stat = "NO"
        return stat

    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        stat = ""
        if ans == wx.ID_OK:
            #dlg.Destroy()
            stat = "OK"
            #return "OK"
        else:
            #dlg.Destroy()
            stat = "CANCEL"
            #return "CANCEL"
        return stat

#
#  getSelectedFiles
#    dictファイルに記述されているstlファイル
def getSelectedFiles(fileName):
    files = []
    lineCont = " "
    f=open(fileName); cont=f.read(); f.close()
    p = getFoamContents.skipFoamFileMem(cont, 0)
    while lineCont != "":
        [lineCont, p, kind] = getFoamContents.get1lineMem(cont, p)
        if kind == "keyword":
            [name, pp] = getFoamContents.getKeywordMem(lineCont, 0)
            files.append(name)
    return files

#
#  makeFeatureDict
#    dictFileを作成する。
def makeFeatureDict(fileName, selFiles, angle):
    contents = ""
    i = 0
    for selFile in selFiles:
        #stl名セット
        cont = setFoamContents.setSurfaceFeatureExtractDict().decode("utf-8")
        [keyword, p] = getFoamContents.getKeywordMem(cont, 0)
        cont = selFile + cont[p:]
        #角度をセット
        cont = runHelyxosDialog220.setIncludeAngle(angle, cont)
        if i > 0:
            cont = getFoamContents.deleteCommentsNullLines(cont)
        contents += cont
        i += 1
    OFversion = pyTreeFoam.readConfigTreeFoam()[0]
    header = setFoamContents.makeFoamHeaderVersion(OFversion)
    version = ".".join(OFversion.split(".")[:-1])
    foamFile = setFoamContents.makeFoamFile(version, "ascii",
                        "dictionary", "", "surfaceFeatureExtractDict")
    footer = setFoamContents.makeFooter()
    contents = header + foamFile + contents + footer
    f=open(fileName, "w"); f.write(contents); f.close()
    return contents

#
#  getHelyxosData
#    HelyxOSのデータ取得
def getHelyxosData(caseDir):
    global helyxDataFile, stlDir, surfaceAngle
    stlDir = "./model"
    surfaceAngle = "150"
    clearMesh = "yes"

    helyxData = helyxDataFile.split("/")[-1]
    fileNameCase = caseDir + "/" + helyxData
    #fileNameTr = os.environ["TreeFoamPath"] + "/" + helyxDataFile
    fileNameTr = os.environ["TreeFoamUserPath"] + "/" + helyxDataFile
    if len(glob.glob(fileNameCase)) == 1:
        fileName = fileNameCase
    elif len(glob.glob(fileNameTr)) == 1:
        fileName = fileNameTr
    else:
        fileName = fileNameTr
        #stlDir = "./model"
        #surfaceAngle = "150"
        #clearMesh = "yes"
        contents = "stlDir   " + stlDir + "\n"
        contents+= "surfaceAngle    " + surfaceAngle + "\n"
        contents+= "clearMesh    yes\n"
        f=open(fileName, "w")
        f.write(contents)
        f.close()

    f=open(fileName)
    contents = f.readlines()
    f.close()
    for line in contents:
        comm = line.split()
        if len(comm) > 1:
            if comm[0] == "stlDir":
                stlDir = comm[1]
            elif comm[0] == "surfaceAngle":
                surfaceAngle = comm[1]
            elif comm[0] == "clearMesh":
                clearMesh = comm[1]
    return [stlDir, surfaceAngle, clearMesh]

#
#  getCsvFileNames
#    csvファイルを取得し、返す
def getCsvFileNames(csvDir):
    files = glob.glob(csvDir + "/*.csv")
    names = []
    for name in files:
        names.append(name.split("/")[-1])
    names.sort()
    return names

#
#  getAbsPath
#    相対pathを絶対pathに変換する
def getAbsPath(wdir):
    if len(wdir) == 0:
        return wdir
    if wdir[0] != "/":
        paPath = os.getcwd()
        wdir = paPath + "/" + wdir
    wdir = os.path.abspath(wdir)
    return wdir

#  saveStlDir
#    stlDirをHelyxos_dataに保存する。
def saveStlDir(caseDir, modelDir):
    helyxData = helyxDataFile.split("/")[-1]
    fileNameCase = caseDir + "/" + helyxData
    #fileNameTr = os.environ["TreeFoamPath"] + "/" + helyxDataFile
    fileNameTr = os.environ["TreeFoamUserPath"] + "/" + helyxDataFile
    if len(glob.glob(fileNameCase)) == 0:
        comm = "cp " + fileNameTr + " " + caseDir
        os.system(comm)
    fileName = fileNameCase
    f=open(fileName); cont=f.readlines(); f.close()
    i = 0
    while i < len(cont):
        line = cont[i]
        comm = line.split()
        if comm[0] == "stlDir":
            cont[i] = comm[0] + " " + modelDir + "\n"
            break            
        i += 1
    f=open(fileName, "w")
    for line in cont:
        f.write(line)
    f.close()


if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
