#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   topoSetEditor
#
#       topoSetDictを編集する為のeditor
#
#   12/09/06    新規作成
#      10/10    actionの位置変更
#      10/13    sourceTypeのsetsを追加。
#               設定したcodeが出力されているかﾁｪｯｸを追加
#      11/24    polyMeshフォルダが無かった場合、ｴﾗｰ発生していたのを修正
#      12/01    openSlFolderボタン追加
#      12/16    combinedActionを追加
#      12/17    表示・非表示の設定修正
#   13/01/27    regionToCellがセットできる様に修正
#      02/03    newCellToFace(cellSet(Zone)の表面のfaceを抽出）を追加
#      04/15    regionsの取得方法を変更（未だregionの取得結果は使っていない）
#      04/17    getCellZoneNames、getFaceZonNmesを高速化
#      04/20    newZonesToSetsコマンドを追加
#      05/13    meshデータの場所をcontrolDictのstartFromの値によって変える。
#      06/25    操作対象のfieldやmeshを選択できるように修正。
#      07/09    topoSetの「-constant」オプションを削除
#      07/10    toposetの「-time」オプションを削除（controlDictに従う）
#      07/13    sourceMesh, resultMeshの場所を表示
#      07/15    ﾊﾞｸﾞ修正
#      10/15    国際化の為、修正
#      11/23    ﾊﾞｸﾞ修正（相対pathで起動できなかった）
#      12/21    stdout、stderrの設定（import logFileCreater）を追加
#   14/12/02    getSetsNames:setsDirの取得方法を修正（zoneよりも遡らない）
#   15/07/01    topoSetDictのをOF-2.4.0に合わせる 
#      07/02    resultTypeに「sets」と「zones」を追加。
#      07/03    「sets」「zones」に、add, delete, clear, invert, remove actionを追加
#      10/11    sourceName regionのradio_btnの処理を修正。regionBtnがONの時、
#               resultName cellZone,faceZoneの処理を追加。
#   16/12/14    checkTopoSetCommandDBを追加（topoSetが使えるかどうかをチェック）
#
#

#------修正内容------------------------------------------------------------
#   ・アイコンのDirを書き直す（絶対path→相対path[./icons/***.png]）
#


# generated by wxGlade 0.6.3 on Sun Sep 30 14:53:39 2012

import wx
import sys
import os
import glob
import getFoamContents
import setFoamContents
import pyTreeFoam
import makeRunTopoSet
from getOpenFolderDDialog import Show as getOpenFolderShow
from runHelyxosDialog import getHelyxosData, setHelyxosData

import logFileCreater; logFileCreater.log()


cellSets = []
faceSets = []
pointSets = []
cellZones = []
faceZones = []
pointZones = []
stlFiles = []
fields = []
patches = []
regions = []
caseDir = ""
stlDir = ""
timeFolders = []
selTimeFolder = ""
meshDirs = []
selMeshDir = ""
timeFoldersList = []
runTime = ""
startTime = ""
regionsList = []
selRegion = ""

# begin wxGlade: extracode
# end wxGlade

#
#  topoSetEditorShow
#    dialogを表示
def topoSetEditorShow(wdir, stl):
    global caseDir, stlDir, selTimeRegion
    selTimeRegion = []
    caseDir = wdir
    stlDir = stl
    initialize()
    #app = wx.PySimpleApp(0)
    app = wx.App(0)
    #wx.InitAllImageHandlers()
    frame_2 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_2)
    frame_2.Show()
    app.MainLoop()



class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):

        savePath = os.getcwd()
        treeFoamPath = os.getenv("TreeFoamPath")
        os.chdir(treeFoamPath)

        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, wx.ID_ANY, _(u"topoSet Editor （topoSetDictを作成し、meshを抽出）"))
        self.static_line_1 = wx.StaticLine(self, wx.ID_ANY)
        self.label_14 = wx.StaticText(self, wx.ID_ANY, _("time"))
        self.combo_box_2 = wx.ComboBox(self, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.label_13 = wx.StaticText(self, wx.ID_ANY, _("region"))
        self.combo_box_1 = wx.ComboBox(self, wx.ID_ANY, choices=[], style=wx.CB_DROPDOWN)
        self.label_16 = wx.StaticText(self, wx.ID_ANY, _(u"(-regionを設定して、topoSetを実行)"))
        self.panel_4 = wx.Panel(self, wx.ID_ANY, style=wx.SUNKEN_BORDER | wx.TAB_TRAVERSAL)
        self.label_6 = wx.StaticText(self.panel_4, wx.ID_ANY, _("<Action>"))
        self.label_10 = wx.StaticText(self.panel_4, wx.ID_ANY, _(u"コマンド"))
        self.radio_btn_18 = wx.RadioButton(self.panel_4, wx.ID_ANY, _("new"))
        self.radio_btn_19 = wx.RadioButton(self.panel_4, wx.ID_ANY, _("add"))
        self.radio_btn_20 = wx.RadioButton(self.panel_4, wx.ID_ANY, _("delete"))
        self.radio_btn_21 = wx.RadioButton(self.panel_4, wx.ID_ANY, _("subset"))
        self.sizer_22_staticbox = wx.StaticBox(self.panel_4, wx.ID_ANY, _("source"))
        self.radio_btn_22 = wx.RadioButton(self.panel_4, wx.ID_ANY, _("clear"))
        self.radio_btn_23 = wx.RadioButton(self.panel_4, wx.ID_ANY, _("invert"))
        self.radio_btn_24 = wx.RadioButton(self.panel_4, wx.ID_ANY, _("remove"))
        self.sizer_23_staticbox = wx.StaticBox(self.panel_4, wx.ID_ANY, _("no source"))
        self.radio_btn_31 = wx.RadioButton(self.panel_4, wx.ID_ANY, _("renameSetZone"))
        self.radio_btn_32 = wx.RadioButton(self.panel_4, wx.ID_ANY, _("newAddsSet"))
        self.radio_btn_33 = wx.RadioButton(self.panel_4, wx.ID_ANY, _("newCellToFace"))
        self.radio_btn_34 = wx.RadioButton(self.panel_4, wx.ID_ANY, _("newZonesToSets"))
        self.sizer_17_staticbox = wx.StaticBox(self.panel_4, wx.ID_ANY, _("combined"))
        self.panel_1 = wx.Panel(self, wx.ID_ANY, style=wx.SUNKEN_BORDER | wx.TAB_TRAVERSAL)
        self.label_2 = wx.StaticText(self.panel_1, wx.ID_ANY, _(u"<Source> 入力"))
        self.label_sourceMesh = wx.StaticText(self.panel_1, wx.ID_ANY, _("mesh:"))
        self.label_4 = wx.StaticText(self.panel_1, wx.ID_ANY, _("type"))
        self.radio_btn_1 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("cellSet"))
        self.radio_btn_2 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("faceSet"))
        self.radio_btn_3 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("pointSet"))
        self.radio_btn_30 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("sets"))
        self.sizer_31_staticbox = wx.StaticBox(self.panel_1, wx.ID_ANY, _("sets"))
        self.radio_btn_4 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("cellZone"))
        self.radio_btn_5 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("faceZone"))
        self.radio_btn_36 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("pointZone"))
        self.sizer_32_staticbox = wx.StaticBox(self.panel_1, wx.ID_ANY, _("zones"))
        self.radio_btn_7 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("box"))
        self.radio_btn_8 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("cylinder"))
        self.radio_btn_9 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("sphere"))
        self.sizer_33_staticbox = wx.StaticBox(self.panel_1, wx.ID_ANY, _(u"幾何図形"))
        self.radio_btn_6 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("surface"))
        self.button_9 = wx.Button(self.panel_1, wx.ID_ANY, _("..."))
        self.radio_btn_10 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("rotatedBox"))
        self.radio_btn_37 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("targetVolume"))
        self.radio_btn_38 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("searchableSurface"))
        self.radio_btn_11 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("region"))
        self.radio_btn_39 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("boundary"))
        self.radio_btn_12 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("field"))
        self.radio_btn_13 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("patch"))
        self.radio_btn_14 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("label"))
        self.radio_btn_15 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("shape"))
        self.radio_btn_16 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("normal"))
        self.radio_btn_17 = wx.RadioButton(self.panel_1, wx.ID_ANY, _("nearest"))
        self.sizer_35_staticbox = wx.StaticBox(self.panel_1, wx.ID_ANY, _(u"その他"))
        self.label_5 = wx.StaticText(self.panel_1, wx.ID_ANY, _("name"))
        self.list_box_1 = wx.ListBox(self.panel_1, wx.ID_ANY, choices=[], style=wx.LB_MULTIPLE)
        self.label_9 = wx.StaticText(self.panel_1, wx.ID_ANY, _(u"クリックして選択"))
        self.panel_2 = wx.Panel(self, wx.ID_ANY)
        self.bitmap_1 = wx.StaticBitmap(self.panel_2, wx.ID_ANY, wx.Bitmap("./icons/runSolver.png", wx.BITMAP_TYPE_ANY))
        self.panel_3 = wx.Panel(self, wx.ID_ANY, style=wx.SUNKEN_BORDER | wx.TAB_TRAVERSAL)
        self.label_3 = wx.StaticText(self.panel_3, wx.ID_ANY, _(u"<Result> 出力"))
        self.label_resultMesh = wx.StaticText(self.panel_3, wx.ID_ANY, _("mesh:"))
        self.label_7 = wx.StaticText(self.panel_3, wx.ID_ANY, _("type"))
        self.radio_btn_25 = wx.RadioButton(self.panel_3, wx.ID_ANY, _("cellSet"))
        self.radio_btn_26 = wx.RadioButton(self.panel_3, wx.ID_ANY, _("faceSet"))
        self.radio_btn_27 = wx.RadioButton(self.panel_3, wx.ID_ANY, _("pointSet"))
        self.radio_btn_40 = wx.RadioButton(self.panel_3, wx.ID_ANY, _("sets"))
        self.sizer_27_staticbox = wx.StaticBox(self.panel_3, wx.ID_ANY, _("sets"))
        self.radio_btn_28 = wx.RadioButton(self.panel_3, wx.ID_ANY, _("cellZoneSet"))
        self.radio_btn_29 = wx.RadioButton(self.panel_3, wx.ID_ANY, _("faceZoneSet"))
        self.radio_btn_35 = wx.RadioButton(self.panel_3, wx.ID_ANY, _("pointZoneSet"))
        self.radio_btn_41 = wx.RadioButton(self.panel_3, wx.ID_ANY, _("zones"))
        self.sizer_29_staticbox = wx.StaticBox(self.panel_3, wx.ID_ANY, _("zones"))
        self.button_7 = wx.Button(self.panel_3, wx.ID_ANY, _(u"code出力"))
        self.label_8 = wx.StaticText(self.panel_3, wx.ID_ANY, _("set name"))
        self.text_ctrl_1 = wx.TextCtrl(self.panel_3, wx.ID_ANY, "")
        self.button_1 = wx.Button(self.panel_3, wx.ID_ANY, _(u"↑ listから取得"))
        self.list_box_2 = wx.ListBox(self.panel_3, wx.ID_ANY, choices=[], style=wx.LB_MULTIPLE)
        self.label_12 = wx.StaticText(self, wx.ID_ANY, _(u"コード確認、編集"))
        self.button_2 = wx.Button(self, wx.ID_ANY, _(u"topoSetDictｸﾘｱ"))
        self.button_3 = wx.Button(self, wx.ID_ANY, _(u"topoSetDict追加"))
        self.button_8 = wx.Button(self, wx.ID_ANY, _(u"topoSet実行"))
        self.button_10 = wx.Button(self, wx.ID_ANY, _(u"ｸﾘｱ.追加.実行"))
        self.text_ctrl_2 = wx.TextCtrl(self, wx.ID_ANY, "", style=wx.TE_MULTILINE)
        self.label_11 = wx.StaticText(self, wx.ID_ANY, _(u"＜使用法＞\n・action（ｺﾏﾝﾄﾞ）を選択。\n・source type, nameを選択。\n・result type, nameを決定。\n・「topoSetDictに追加」"))
        self.button_4 = wx.Button(self, wx.ID_ANY, _(u"topoSetDict編集"))
        self.button_5 = wx.Button(self, wx.ID_ANY, _(u"paraFoam起動"))
        self.button_6 = wx.Button(self, wx.ID_ANY, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_TEXT_ENTER, self.onChangeTime, self.combo_box_2)
        self.Bind(wx.EVT_COMBOBOX, self.onChangeTime, self.combo_box_2)
        self.Bind(wx.EVT_TEXT_ENTER, self.onChangeMesh, self.combo_box_1)
        self.Bind(wx.EVT_COMBOBOX, self.onChangeMesh, self.combo_box_1)
        self.Bind(wx.EVT_RADIOBUTTON, self.onShowAll, self.radio_btn_18)
        self.Bind(wx.EVT_RADIOBUTTON, self.onShowAll, self.radio_btn_19)
        self.Bind(wx.EVT_RADIOBUTTON, self.onShowAll, self.radio_btn_20)
        self.Bind(wx.EVT_RADIOBUTTON, self.onShowAll, self.radio_btn_21)
        self.Bind(wx.EVT_RADIOBUTTON, self.onClear, self.radio_btn_22)
        self.Bind(wx.EVT_RADIOBUTTON, self.onInvert, self.radio_btn_23)
        self.Bind(wx.EVT_RADIOBUTTON, self.onRemove, self.radio_btn_24)
        self.Bind(wx.EVT_RADIOBUTTON, self.onRenameSetZone, self.radio_btn_31)
        self.Bind(wx.EVT_RADIOBUTTON, self.onNewAddsSet, self.radio_btn_32)
        self.Bind(wx.EVT_RADIOBUTTON, self.onNewCellToFace, self.radio_btn_33)
        self.Bind(wx.EVT_RADIOBUTTON, self.onNewZonesToSets, self.radio_btn_34)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourceCellSetNames, self.radio_btn_1)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourceFaceSetNames, self.radio_btn_2)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourcePointSetNames, self.radio_btn_3)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourceSetsSetNames, self.radio_btn_30)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourceCellZoneNames, self.radio_btn_4)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourceFaceZoneNames, self.radio_btn_5)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourcePointZoneNames, self.radio_btn_36)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourceBoxList, self.radio_btn_7)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourceCylinderList, self.radio_btn_8)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourceSphereList, self.radio_btn_9)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourceSurfaceNames, self.radio_btn_6)
        self.Bind(wx.EVT_BUTTON, self.onOpenStlFolder, self.button_9)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourceRotatedBoxList, self.radio_btn_10)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourceTargetVolume, self.radio_btn_37)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourceSearchableSurface, self.radio_btn_38)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourceRegionList, self.radio_btn_11)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourceBoundary, self.radio_btn_39)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourceFieldNames, self.radio_btn_12)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourcePatchNames, self.radio_btn_13)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourceLabelList, self.radio_btn_14)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourceShapeList, self.radio_btn_15)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourceNormalList, self.radio_btn_16)
        self.Bind(wx.EVT_RADIOBUTTON, self.onSourceNearestList, self.radio_btn_17)
        self.Bind(wx.EVT_LISTBOX, self.onGetSourceName, self.list_box_1)
        self.Bind(wx.EVT_RADIOBUTTON, self.onResultCellSetNames, self.radio_btn_25)
        self.Bind(wx.EVT_RADIOBUTTON, self.onResultFaceSetNames, self.radio_btn_26)
        self.Bind(wx.EVT_RADIOBUTTON, self.onResultPointSetNames, self.radio_btn_27)
        self.Bind(wx.EVT_RADIOBUTTON, self.onResultSetsNames, self.radio_btn_40)
        self.Bind(wx.EVT_RADIOBUTTON, self.onResultCellZoneNames, self.radio_btn_28)
        self.Bind(wx.EVT_RADIOBUTTON, self.onResultFaceZoneNames, self.radio_btn_29)
        self.Bind(wx.EVT_RADIOBUTTON, self.onResultPointZoneNames, self.radio_btn_35)
        self.Bind(wx.EVT_RADIOBUTTON, self.onResultZonesNames, self.radio_btn_41)
        self.Bind(wx.EVT_BUTTON, self.onDisplayCode, self.button_7)
        self.Bind(wx.EVT_TEXT_ENTER, self.onDisplayCode, self.text_ctrl_1)
        self.Bind(wx.EVT_TEXT, self.onDisplayCode, self.text_ctrl_1)
        self.Bind(wx.EVT_BUTTON, self.onGetListName, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onClearTopoSetDict, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onAddThisItem, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onRunTopoSet, self.button_8)
        self.Bind(wx.EVT_BUTTON, self.onClearAddRun, self.button_10)
        self.Bind(wx.EVT_BUTTON, self.onEditTopoSet, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onRunParaFoam, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_6)
        # end wxGlade

        #text_ctrl_1にマウスのイベントを追加
        self.text_ctrl_1.Bind(wx.EVT_LEFT_DOWN, self.onResultNameClick)

        #toolTip追加
        self.radio_btn_31.SetToolTipString(_(u"cellSet(Zone)、faceSet(Zone)の名前を変更します"))
        self.radio_btn_32.SetToolTipString(_(u"選択した複数のcellSet、faceSetを加えて\n新しい名前で作り出します"))
        self.radio_btn_33.SetToolTipString(_(u"選択したcellSet(Zone)から表面のfaceSet(Zone)を\n新しい名前で作り出します"))
        self.radio_btn_34.SetToolTipString(_(u"選択した複数のcellZone(faceZone)から\n同じ名前でcellSet(faceSet)を作り出します\n  resultNameは、入力不要"))
        setsZonesString =  _(u"選択した複数のsource名で繰り返し処理のコードを出力します\n")
        setsZonesString += _(u"noSourceActionの場合、選択した複数のresult名でコードを出力")
        self.radio_btn_40.SetToolTipString(setsZonesString)
        self.radio_btn_41.SetToolTipString(setsZonesString)

        os.chdir(savePath)
        self.checkPolyMesh()
        self.setTitle()
        self.setNameList()

        #radioButtonをグループ化
        self.sourceType = [self.radio_btn_1, self.radio_btn_2, self.radio_btn_3,
            self.radio_btn_4, self.radio_btn_5, self.radio_btn_6, self.radio_btn_7,
            self.radio_btn_8, self.radio_btn_9, self.radio_btn_10,
            self.radio_btn_11, self.radio_btn_12, self.radio_btn_13,
            self.radio_btn_14, self.radio_btn_15, self.radio_btn_16,
            self.radio_btn_17, self.radio_btn_30, self.radio_btn_36,
            self.radio_btn_37, self.radio_btn_38, self.radio_btn_39]
        self.resultType = [self.radio_btn_25, self.radio_btn_26, self.radio_btn_27,
            self.radio_btn_28, self.radio_btn_29, self.radio_btn_35,
            self.radio_btn_40, self.radio_btn_41]
        self.action = [self.radio_btn_17, self.radio_btn_18, self.radio_btn_19,
            self.radio_btn_20, self.radio_btn_21, self.radio_btn_22,
            self.radio_btn_23, self.radio_btn_24, self.radio_btn_31,
            self.radio_btn_32, self.radio_btn_33, self.radio_btn_34]
        self.combiAction = [self.radio_btn_31, self.radio_btn_32, self.radio_btn_33,
            self.radio_btn_34]

        #radioBtnの非表示設定
        self.showAllRadioButton()
        self.checkTopoSetCommandDB()


    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_(u"mesh操作"))
        self.combo_box_2.SetMinSize((190, 30))
        self.combo_box_1.SetMinSize((190, 30))
        self.label_6.SetFont(wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))
        self.label_10.SetFont(wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))
        self.panel_4.SetBackgroundColour(wx.Colour(213, 209, 206))
        self.label_2.SetFont(wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))
        self.button_9.SetMinSize((30, 24))
        self.list_box_1.SetMinSize((160, 200))
        self.panel_1.SetBackgroundColour(wx.Colour(213, 209, 206))
        self.label_3.SetFont(wx.Font(10, wx.DEFAULT, wx.NORMAL, wx.BOLD, 0, ""))
        self.text_ctrl_1.SetMinSize((160, 28))
        self.list_box_2.SetMinSize((160, 200))
        self.panel_3.SetBackgroundColour(wx.Colour(213, 209, 206))
        self.button_2.SetMinSize((120, 25))
        self.button_3.SetMinSize((120, 25))
        self.button_8.SetMinSize((120, 25))
        self.button_10.SetMinSize((120, 30))
        self.text_ctrl_2.SetMinSize((600, 200))
        self.button_4.SetMinSize((141, 30))
        self.button_5.SetMinSize((141, 30))
        # end wxGlade

        #combo_boxにデータ設定
        self.setComboBoxData()


    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_9 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_11 = wx.BoxSizer(wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.VERTICAL)
        sizer_12 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_10 = wx.BoxSizer(wx.VERTICAL)
        sizer_14 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_5 = wx.BoxSizer(wx.VERTICAL)
        sizer_24 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_26 = wx.BoxSizer(wx.VERTICAL)
        sizer_25 = wx.BoxSizer(wx.VERTICAL)
        self.sizer_29_staticbox.Lower()
        sizer_29 = wx.StaticBoxSizer(self.sizer_29_staticbox, wx.VERTICAL)
        self.sizer_27_staticbox.Lower()
        sizer_27 = wx.StaticBoxSizer(self.sizer_27_staticbox, wx.VERTICAL)
        sizer_28 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_4 = wx.BoxSizer(wx.VERTICAL)
        sizer_3 = wx.BoxSizer(wx.VERTICAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_21 = wx.BoxSizer(wx.VERTICAL)
        sizer_7 = wx.BoxSizer(wx.VERTICAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_34 = wx.BoxSizer(wx.VERTICAL)
        self.sizer_35_staticbox.Lower()
        sizer_35 = wx.StaticBoxSizer(self.sizer_35_staticbox, wx.VERTICAL)
        sizer_16 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_30 = wx.BoxSizer(wx.VERTICAL)
        self.sizer_33_staticbox.Lower()
        sizer_33 = wx.StaticBoxSizer(self.sizer_33_staticbox, wx.VERTICAL)
        self.sizer_32_staticbox.Lower()
        sizer_32 = wx.StaticBoxSizer(self.sizer_32_staticbox, wx.VERTICAL)
        self.sizer_31_staticbox.Lower()
        sizer_31 = wx.StaticBoxSizer(self.sizer_31_staticbox, wx.VERTICAL)
        sizer_20 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_15 = wx.BoxSizer(wx.VERTICAL)
        self.sizer_17_staticbox.Lower()
        sizer_17 = wx.StaticBoxSizer(self.sizer_17_staticbox, wx.VERTICAL)
        self.sizer_23_staticbox.Lower()
        sizer_23 = wx.StaticBoxSizer(self.sizer_23_staticbox, wx.VERTICAL)
        self.sizer_22_staticbox.Lower()
        sizer_22 = wx.StaticBoxSizer(self.sizer_22_staticbox, wx.VERTICAL)
        sizer_18 = wx.BoxSizer(wx.VERTICAL)
        sizer_19 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.label_1, 0, wx.TOP | wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_18.Add(self.static_line_1, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 20)
        sizer_18.Add((20, 5), 0, 0, 0)
        sizer_19.Add(self.label_14, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_19.Add(self.combo_box_2, 0, wx.RIGHT, 20)
        sizer_19.Add(self.label_13, 0, wx.LEFT | wx.ALIGN_CENTER_HORIZONTAL | wx.ALIGN_CENTER_VERTICAL, 10)
        sizer_19.Add(self.combo_box_1, 0, 0, 0)
        sizer_19.Add(self.label_16, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_18.Add(sizer_19, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_1.Add(sizer_18, 0, wx.EXPAND, 0)
        sizer_15.Add(self.label_6, 0, wx.TOP | wx.ALIGN_CENTER_HORIZONTAL, 5)
        sizer_15.Add(self.label_10, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_22.Add(self.radio_btn_18, 0, 0, 0)
        sizer_22.Add(self.radio_btn_19, 0, 0, 0)
        sizer_22.Add(self.radio_btn_20, 0, 0, 0)
        sizer_22.Add(self.radio_btn_21, 0, 0, 0)
        sizer_15.Add(sizer_22, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 8)
        sizer_23.Add(self.radio_btn_22, 0, 0, 0)
        sizer_23.Add(self.radio_btn_23, 0, 0, 0)
        sizer_23.Add(self.radio_btn_24, 0, 0, 0)
        sizer_15.Add(sizer_23, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 5)
        sizer_17.Add(self.radio_btn_31, 0, 0, 0)
        sizer_17.Add(self.radio_btn_32, 0, 0, 0)
        sizer_17.Add(self.radio_btn_33, 0, 0, 0)
        sizer_17.Add(self.radio_btn_34, 0, 0, 0)
        sizer_15.Add(sizer_17, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        self.panel_4.SetSizer(sizer_15)
        sizer_2.Add(self.panel_4, 0, wx.LEFT | wx.TOP | wx.BOTTOM | wx.EXPAND, 5)
        sizer_20.Add((20, 10), 0, 0, 0)
        sizer_20.Add(self.label_2, 0, wx.LEFT | wx.RIGHT | wx.TOP | wx.ALIGN_CENTER_HORIZONTAL, 5)
        sizer_20.Add(self.label_sourceMesh, 0, wx.LEFT | wx.RIGHT | wx.EXPAND | wx.ALIGN_BOTTOM, 10)
        sizer_3.Add(sizer_20, 0, wx.EXPAND, 0)
        sizer_7.Add(self.label_4, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_31.Add(self.radio_btn_1, 0, 0, 0)
        sizer_31.Add(self.radio_btn_2, 0, 0, 0)
        sizer_31.Add(self.radio_btn_3, 0, 0, 0)
        sizer_31.Add(self.radio_btn_30, 0, 0, 0)
        sizer_30.Add(sizer_31, 0, wx.LEFT | wx.EXPAND, 5)
        sizer_32.Add(self.radio_btn_4, 0, 0, 0)
        sizer_32.Add(self.radio_btn_5, 0, 0, 0)
        sizer_32.Add(self.radio_btn_36, 0, 0, 0)
        sizer_30.Add(sizer_32, 0, wx.LEFT | wx.EXPAND, 5)
        sizer_33.Add(self.radio_btn_7, 0, 0, 0)
        sizer_33.Add(self.radio_btn_8, 0, 0, 0)
        sizer_33.Add(self.radio_btn_9, 0, 0, 0)
        sizer_30.Add(sizer_33, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_8.Add(sizer_30, 0, wx.EXPAND, 0)
        sizer_16.Add(self.radio_btn_6, 0, 0, 0)
        sizer_16.Add(self.button_9, 0, 0, 0)
        sizer_35.Add(sizer_16, 1, wx.EXPAND, 0)
        sizer_35.Add(self.radio_btn_10, 0, 0, 0)
        sizer_35.Add(self.radio_btn_37, 0, 0, 0)
        sizer_35.Add(self.radio_btn_38, 0, 0, 0)
        sizer_35.Add(self.radio_btn_11, 0, 0, 0)
        sizer_35.Add(self.radio_btn_39, 0, 0, 0)
        sizer_35.Add(self.radio_btn_12, 0, 0, 0)
        sizer_35.Add(self.radio_btn_13, 0, 0, 0)
        sizer_35.Add(self.radio_btn_14, 0, 0, 0)
        sizer_35.Add(self.radio_btn_15, 0, 0, 0)
        sizer_35.Add(self.radio_btn_16, 0, 0, 0)
        sizer_35.Add(self.radio_btn_17, 0, 0, 0)
        sizer_34.Add(sizer_35, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 5)
        sizer_8.Add(sizer_34, 0, wx.EXPAND, 0)
        sizer_7.Add(sizer_8, 0, wx.EXPAND, 0)
        sizer_6.Add(sizer_7, 0, wx.EXPAND, 0)
        sizer_21.Add((20, 4), 0, 0, 0)
        sizer_21.Add(self.label_5, 0, wx.LEFT, 5)
        sizer_21.Add(self.list_box_1, 1, wx.RIGHT | wx.TOP | wx.EXPAND, 5)
        sizer_21.Add(self.label_9, 0, 0, 0)
        sizer_6.Add(sizer_21, 1, wx.EXPAND, 0)
        sizer_3.Add(sizer_6, 0, wx.EXPAND, 0)
        self.panel_1.SetSizer(sizer_3)
        sizer_2.Add(self.panel_1, 0, wx.ALL | wx.EXPAND, 5)
        sizer_4.Add(self.bitmap_1, 0, wx.TOP, 120)
        self.panel_2.SetSizer(sizer_4)
        sizer_2.Add(self.panel_2, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 5)
        sizer_28.Add((10, 10), 0, 0, 0)
        sizer_28.Add(self.label_3, 0, wx.LEFT | wx.RIGHT | wx.TOP | wx.ALIGN_CENTER_HORIZONTAL, 5)
        sizer_28.Add(self.label_resultMesh, 0, wx.LEFT | wx.RIGHT | wx.EXPAND | wx.ALIGN_BOTTOM, 10)
        sizer_5.Add(sizer_28, 0, wx.EXPAND, 0)
        sizer_25.Add(self.label_7, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_27.Add(self.radio_btn_25, 0, 0, 0)
        sizer_27.Add(self.radio_btn_26, 0, 0, 0)
        sizer_27.Add(self.radio_btn_27, 0, 0, 0)
        sizer_27.Add(self.radio_btn_40, 0, 0, 0)
        sizer_25.Add(sizer_27, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 5)
        sizer_29.Add(self.radio_btn_28, 0, 0, 0)
        sizer_29.Add(self.radio_btn_29, 0, 0, 0)
        sizer_29.Add(self.radio_btn_35, 0, 0, 0)
        sizer_29.Add(self.radio_btn_41, 0, 0, 0)
        sizer_25.Add(sizer_29, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 5)
        sizer_25.Add((20, 20), 0, 0, 0)
        sizer_25.Add(self.button_7, 0, wx.ALL, 5)
        sizer_24.Add(sizer_25, 0, wx.EXPAND, 0)
        sizer_26.Add((20, 4), 0, 0, 0)
        sizer_26.Add(self.label_8, 0, wx.LEFT, 5)
        sizer_26.Add(self.text_ctrl_1, 0, wx.RIGHT | wx.TOP | wx.EXPAND, 5)
        sizer_26.Add(self.button_1, 0, wx.TOP | wx.BOTTOM, 5)
        sizer_26.Add(self.list_box_2, 1, wx.RIGHT | wx.EXPAND, 5)
        sizer_24.Add(sizer_26, 1, wx.EXPAND, 0)
        sizer_5.Add(sizer_24, 0, wx.EXPAND, 0)
        self.panel_3.SetSizer(sizer_5)
        sizer_2.Add(self.panel_3, 0, wx.ALL | wx.EXPAND, 5)
        sizer_1.Add(sizer_2, 0, 0, 0)
        sizer_14.Add(self.label_12, 0, wx.LEFT | wx.TOP | wx.ALIGN_BOTTOM, 5)
        sizer_14.Add(self.button_2, 0, wx.LEFT | wx.ALIGN_BOTTOM, 5)
        sizer_14.Add(self.button_3, 0, wx.LEFT | wx.ALIGN_BOTTOM, 5)
        sizer_14.Add(self.button_8, 0, wx.LEFT | wx.ALIGN_BOTTOM, 5)
        sizer_14.Add(self.button_10, 0, wx.LEFT | wx.ALIGN_BOTTOM, 30)
        sizer_10.Add(sizer_14, 0, wx.EXPAND, 0)
        sizer_10.Add(self.text_ctrl_2, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_9.Add(sizer_10, 1, wx.EXPAND, 0)
        sizer_11.Add((20, 5), 0, 0, 0)
        sizer_11.Add(self.label_11, 0, 0, 0)
        sizer_11.Add((20, 20), 0, 0, 0)
        sizer_11.Add(self.button_4, 0, wx.LEFT | wx.TOP | wx.BOTTOM, 5)
        sizer_12.Add(self.button_5, 0, wx.ALL | wx.ALIGN_RIGHT, 5)
        sizer_11.Add(sizer_12, 0, wx.EXPAND, 0)
        sizer_13.Add(self.button_6, 0, wx.RIGHT | wx.TOP | wx.BOTTOM | wx.ALIGN_RIGHT, 10)
        sizer_11.Add(sizer_13, 1, wx.EXPAND | wx.ALIGN_RIGHT, 0)
        sizer_9.Add(sizer_11, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_9, 1, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #----radio button--------
    def onShowAll(self, event):  # wxGlade: MyFrame.<event_handler>
        self.showAllRadioButton()

    def onHideSource(self, event):  # wxGlade: MyFrame.<event_handler>
        self.hideSourceRadioButton()

    def onClear(self, event):  # wxGlade: MyFrame.<event_handler>
        self.hideSourceRadioButton()
        self.showResultSetsZonesRadioButton()

    def onInvert(self, event):  # wxGlade: MyFrame.<event_handler>
        self.hideSourceRadioButton()
        self.showResultSetsZonesRadioButton()

    def onRemove(self, event):  # wxGlade: MyFrame.<event_handler>
        self.hideSourceRadioButton()
        self.showResultSetsZonesRadioButton()

    def onHideResult(self, event):  # wxGlade: MyFrame.<event_handler>
        self.hideResultRadioButton()

    def onRenameSetZone(self, event):  # wxGlade: MyFrame.<event_handler>
        self.hideResultRadioButton()
        self.showSourceCellFaceSetZone()
       
    def onNewAddsSet(self, event):  # wxGlade: MyFrame.<event_handler>
        self.hideResultRadioButton()
        self.showSourceCellFaceSet()

    def onNewCellToFace(self, event):  # wxGlade: MyFrame.<event_handler>
        self.hideResultRadioButton()
        self.showSourceCellFaceSetZone()

    def onNewZonesToSets(self, event):  # wxGlade: MyFrame.<event_handler>
        self.hideResultRadioButton()
        self.showSourceCellFaceZone()

    def onSourceCellSetNames(self, event): # wxGlade: MyFrame.<event_handler>
        getSetsNames()
        self.setSourceNameInListBox(cellSets)
        self.showResultRadioButton("cellSet")

    def onSourceFaceSetNames(self, event): # wxGlade: MyFrame.<event_handler>
        getSetsNames()
        self.setSourceNameInListBox(faceSets)
        self.showResultRadioButton("faceSet")

    def onSourcePointSetNames(self, event): # wxGlade: MyFrame.<event_handler>
        getSetsNames()
        self.setSourceNameInListBox(pointSets)
        self.showResultRadioButton("pointSet")

    def onSourceCellZoneNames(self, event): # wxGlade: MyFrame.<event_handler>
        getCellZoneNames()
        self.setSourceNameInListBox(cellZones)
        self.showResultRadioButton("cellZone")

    def onSourceFaceZoneNames(self, event): # wxGlade: MyFrame.<event_handler>
        getFaceZoneNames()
        self.setSourceNameInListBox(faceZones)
        self.showResultRadioButton("faceZone")

    def onSourcePointZoneNames(self, event):  # wxGlade: MyFrame.<event_handler>
        getPointZoneNames()
        self.setSourceNameInListBox(pointZones)
        self.showResultRadioButton("pointZone")

    def onSourceSurfaceNames(self, event): # wxGlade: MyFrame.<event_handler>
        self.setSourceNameInListBox(stlFiles)
        self.showResultRadioButton("surface")

    def onSourceFieldNames(self, event): # wxGlade: MyFrame.<event_handler>
        getFieldNames()
        self.setSourceNameInListBox(fields)
        self.showResultRadioButton("field")

    def onSourcePatchNames(self, event): # wxGlade: MyFrame.<event_handler>
        getPatchNames()
        self.setSourceNameInListBox(patches)
        self.showResultRadioButton("patch")

    def onSourceBoxList(self, event): # wxGlade: MyFrame.<event_handler>
        self.setSourceNameInListBox([])
        self.showResultRadioButton("box")

    def onSourceCylinderList(self, event): # wxGlade: MyFrame.<event_handler>
        self.setSourceNameInListBox([])
        self.showResultRadioButton("cylinder")

    def onSourceSphereList(self, event): # wxGlade: MyFrame.<event_handler>
        self.setSourceNameInListBox([])
        self.showResultRadioButton("sphere")

    def onSourceRotatedBoxList(self, event): # wxGlade: MyFrame.<event_handler>
        self.setSourceNameInListBox([])
        self.showResultRadioButton("rotatedBox")

    def onSourceRegionList(self, event): # wxGlade: MyFrame.<event_handler>
        getSetsNames()
        if self.radio_btn_25.GetValue() == True:    #result cellSet
            self.setSourceNameInListBox(cellSets)
        elif self.radio_btn_26.GetValue == True:    #result faceSet
            self.setSourceNameInListBox(faceSets)
        else:
            self.setSourceNameInListBox([])
        self.showResultRadioButton("region")

    def onSourceLabelList(self, event): # wxGlade: MyFrame.<event_handler>
        self.setSourceNameInListBox([])
        self.showResultRadioButton("label")

    def onSourceShapeList(self, event): # wxGlade: MyFrame.<event_handler>
        self.setSourceNameInListBox([])
        self.showResultRadioButton("shape")

    def onSourceNormalList(self, event): # wxGlade: MyFrame.<event_handler>
        self.setSourceNameInListBox([])
        self.showResultRadioButton("normal")

    def onSourceNearestList(self, event): # wxGlade: MyFrame.<event_handler>
        self.setSourceNameInListBox([])
        self.showResultRadioButton("nearest")

    def onSourceSetsSetNames(self, event): # wxGlade: MyFrame.<event_handler>
        getSetsNames()
        self.setSourceSetsNamesInListBox()
        self.showResultRadioButton("sets")

    def onSourceTargetVolume(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setSourceNameInListBox([])
        self.showResultRadioButton("targetVolume")

    def onSourceSearchableSurface(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setSourceNameInListBox([])
        self.showResultRadioButton("searchableSurface")

    def onSourceBoundary(self, event):  # wxGlade: MyFrame.<event_handler>
        self.setSourceNameInListBox([])
        self.showResultRadioButton("boundary")

    #---- result radio button, text box ----------
    def onResultCellSetNames(self, event): # wxGlade: MyFrame.<event_handler>
        getSetsNames()
        self.setResultNameInListBox(cellSets)
        if self.radio_btn_11.GetValue() == True:    #region_btn == True?
            self.setSourceNameInListBox(cellSets)

    def onResultFaceSetNames(self, event): # wxGlade: MyFrame.<event_handler>
        getSetsNames()
        self.setResultNameInListBox(faceSets)
        if self.radio_btn_11.GetValue() == True:    #region_btn == True?
            self.setSourceNameInListBox(faceSets)

    def onResultPointSetNames(self, event): # wxGlade: MyFrame.<event_handler>
        getSetsNames()
        self.setResultNameInListBox(pointSets)

    def onResultCellZoneNames(self, event): # wxGlade: MyFrame.<event_handler>
        getCellZoneNames()
        self.setResultNameInListBox(cellZones)

    def onResultFaceZoneNames(self, event): # wxGlade: MyFrame.<event_handler>
        getFaceZoneNames()
        self.setResultNameInListBox(faceZones)

    def onResultPointZoneNames(self, event):  # wxGlade: MyFrame.<event_handler>
        getPointZoneNames()
        self.setResultNameInListBox(pointZones)

    def onResultSetsNames(self, event):  # wxGlade: MyFrame.<event_handler>
        getSetsNames()
        self.setResultAllNamesInListBox(cellSets, faceSets, pointSets)

    def onResultZonesNames(self, event):  # wxGlade: MyFrame.<event_handler>
        getCellZoneNames()
        getFaceZoneNames()
        getPointZoneNames()
        self.setResultAllNamesInListBox(cellZones, faceZones, pointZones)

    def onResultNameClick(self, event):
        self.setTopoSetCode()
        event.Skip()

    #----button----------------------
    def onGetSourceName(self, event): # wxGlade: MyFrame.<event_handler>
        self.getSourceName()

    def onDisplayCode(self, event): # wxGlade: MyFrame.<event_handler>
        self.setTopoSetCode()

    def onGetListName(self, event): # wxGlade: MyFrame.<event_handler>
        self.getListNameToResultName()
        event.Skip()

    def onAddThisItem(self, event): # wxGlade: MyFrame.<event_handler>
        self.addThisItemToDict()
        print _(u"topoSetDictにコードを追加しました。")

    def onClearTopoSetDict(self, event): # wxGlade: MyFrame.<event_handler>
        self.clearTopoSetDict()
        print _(u"topoSetDictの内容をクリア（初期化）しました。")

    def onRunTopoSet(self, event): # wxGlade: MyFrame.<event_handler>
        self.runTopoSet()

    def onClearAddRun(self, event):  # wxGlade: MyFrame.<event_handler>
        self.clearTopoSetDict()
        self.addThisItemToDict()
        self.runTopoSet()

    def onEditTopoSet(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"topoSetDictを編集します。")
        self.editTopoSet()

    def onRunParaFoam(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"paraFoamを起動します。")
        self.runParaFoam()

    def onOpenStlFolder(self, event): # wxGlade: MyFrame.<event_handler>
        print _(u"stlFolderをオープンします。")
        self.openStlFolder()

    def onClose(self, event): # wxGlade: MyFrame.<event_handler>
        self.Destroy()

    #-----combo_box----------------------------------------------------------

    def onChangeTime(self, event):  # wxGlade: MyFrame.<event_handler>
        self.changeTime(event)

    def onChangeMesh(self, event):  # wxGlade: MyFrame.<event_handler>
        self.changeMeshDir(event)

    #--------------------------------------------------------------------------


    #  checkTopoSetCommandDB
    #    topoSetDict有無をチェック
    def checkTopoSetCommandDB(self):
        db = makeRunTopoSet.getTopoSetCommandDB()
        if db == "":
            title = _(u"エラー")
            mess = _(u"使用しているversion内には、topoSetが存在しません。") + "\n"
            mess += _(u"topoSetは使用できません。")
            self.errDialog(title, mess)

    #  changeTime
    #    timeFolderを変更
    def changeTime(self, event):
        global timeFolders, selTimeFolder, meshDirs, selMeshDir
        #timeFolder取得
        nameTime = self.combo_box_2.GetStringSelection().split(":")
        name = nameTime[0].split()[0]
        setFoamContents.controlDict(caseDir+"/system", [["startFrom", name]])
        selTimeFolder = nameTime[1]
        #meshDir取得
        n = self.combo_box_1.GetSelection()
        if n == 0:
            region = "."
        else:
            region = self.combo_box_1.GetStringSelection()
        selMeshDir = getRegionMeshDir(region)
        initialize()
        self.setNameList()

    #  changeMashDir
    #    meshDirを変更
    def changeMeshDir(self, event):
        global timeFolders, selTimeFolder, selMeshDir, regionsList, selRegion
        n = self.combo_box_1.GetSelection()
        if n == 0:
            selRegion = "."
        else:
            selRegion = self.combo_box_1.GetStringSelection()
        selMeshDir = getRegionMeshDir(selRegion)
        initialize()
        self.setNameList()

    #  setComboBoxData
    #    combo_boxにデータ設定
    def setComboBoxData(self):
        global selTimeFolder, timeFolders, selMeshDir, timeFoldersList
        global runTime, startTime, regions, regionsList
        #timeをセット
        timeFoldersList = []
        timeFoldersList.append("firstTime :" + timeFolders[0])
        timeFoldersList.append("startTime :" + startTime)
        timeFoldersList.append("latestTime:" + timeFolders[-1])
        self.combo_box_2.Clear()
        self.combo_box_2.AppendItems(timeFoldersList)
        if runTime == "firstTime":
            n = 0
        elif runTime == "startTime":
            n = 1
        else:
            n = 2
        self.combo_box_2.SetSelection(n)
        #regionをセット
        regionsList = ["(region0)"] + regions
        self.combo_box_1.Clear()
        self.combo_box_1.AppendItems(regionsList)
        if selRegion == ".":
            self.combo_box_1.SetSelection(0)
        else:
            self.combo_box_1.SetStringSelection(region)
        selMeshDir = getRegionMeshDir(selRegion)
        #meshの場所をセット
        self.setMeshDirToSourceLabel()
        #self.setMeshDirToResultLabel()

    #  setMeshDirToSourceLabel
    #    meshDirをlabelに表示
    def setMeshDirToSourceLabel(self):
        global selMeshDir, selTimeFolder
        sourceMesh = "mesh:" + "/".join(selMeshDir.split("/")[:-1])
        self.label_sourceMesh.SetLabel(sourceMesh)

    #  setMeshDirToResultLabel
    #    meshDirをresultLabelに表示
    def setMeshDirToResultLabel(self):
        global selTimeFolder, selMeshDir
        #time = selMeshDir.split("/")[0]
        time = selTimeFolder
        sourceDirList = self.label_sourceMesh.GetLabel()[len("mesh:"):].split("/")
        if sourceDirList[0] == "constant":
            if selMeshDir.split("/")[0] != "constant":
                midDir = "/".join(selMeshDir.split("/")[1:-1])
                resultMesh = "mesh:" + time + "/" + midDir
            else:
                resultMesh = "mesh:" + "constant/" + "/".join(sourceDirList[1:])
        else:
            #数字folderの場合
            midDir = "/".join(selMeshDir.split("/")[1:-1])
            resultMesh = "mesh:" + time + "/" + midDir
        self.label_resultMesh.SetLabel(resultMesh)


    #  checkPolyMesh
    #    polyMeshフォルダ有無チェック
    def checkPolyMesh(self):
        global caseDir
        if len(glob.glob(caseDir + "/constant/polyMesh")) == 0:
            title = _(u"警告")
            mess = _(u"このフォルダには、polyMeshフォルダがありません。\n")
            mess += _(u"  メッシュ抽出できません。")
            self.okDialog(title, mess)

    #  setTitle
    #    titleをセット
    def setTitle(self):
        global caseDir
        subTitle = "/".join(caseDir.split("/")[-2:])
        title = _(u"mesh抽出　　:") + subTitle
        self.SetTitle(title)

    #  showAllRadioButton
    #    全てのradioButtonを表示させる
    def showAllRadioButton(self):
        for buttonName in self.sourceType:
            buttonName.Enable(True)
        self.button_9.Enable(True)
        self.list_box_1.Enable(True)
        for buttonName in self.resultType:
            buttonName.Enable(True)
        self.list_box_2.Enable(True)
        self.button_1.Enable(True)
        selName = ""
        for radioBtn in self.sourceType:
            if radioBtn.GetValue() == True:
                selName = radioBtn.GetLabel()
                break
        self.showResultRadioButton(selName)
        if self.radio_btn_18.GetValue() == True:
            self.radio_btn_40.Enable(False)

    #  hideSourceRadioButton
    #    sourceTypeのradioButtonを隠す
    def hideSourceRadioButton(self):
        for buttonName in self.sourceType:
            buttonName.Enable(False)
        self.list_box_1.Enable(False)
        self.button_9.Enable(False)
        for buttonName in self.resultType:
            buttonName.Enable(True)
        self.list_box_2.Enable(True)
        self.button_1.Enable(True)
        #result:sets, zonesを隠す
        self.radio_btn_40.Enable(False)
        self.radio_btn_41.Enable(False)

    #  hideResultRadioButton
    #    resultTypeのradioButtonを隠す
    def hideResultRadioButton(self):
        for buttonName in self.resultType:
            buttonName.Enable(False)
        self.list_box_2.Enable(False)
        self.button_1.Enable(False)
        for buttonName in self.sourceType:
            buttonName.Enable(True)
        self.button_9.Enable(True)
        self.list_box_1.Enable(True)

    #  showSourceCellFaceSetZone
    #    cellFaceのsetZoneを表示する。
    def showSourceCellFaceSetZone(self):
        for btnName in self.sourceType:
            btnName.Enable(False)
        self.radio_btn_1.Enable(True)   #cellSet
        self.radio_btn_2.Enable(True)   #faceSet
        self.radio_btn_4.Enable(True)   #cellZone
        self.radio_btn_5.Enable(True)   #faceZone

    #  showSourceCellFaceSet
    #    cellFaceのsetを表示する
    def showSourceCellFaceSet(self):
        for btnName in self.sourceType:
            btnName.Enable(False)
        self.radio_btn_1.Enable(True)   #cellSet
        self.radio_btn_2.Enable(True)   #faceSet

    #  showSourceCellFaceZone
    #    cellFaceのzoneを表示する
    def showSourceCellFaceZone(self):
        for btnName in self.sourceType:
            btnName.Enable(False)
        self.radio_btn_4.Enable(True)   #cellZone
        self.radio_btn_5.Enable(True)   #faceZone

    #  showResultSetsZonesRadioButton
    #    resultのsets, zonesを表示
    def showResultSetsZonesRadioButton(self):
        self.radio_btn_40.Enable(True)   #sets
        self.radio_btn_41.Enable(True)   #zones

    #  showResultRadioButton
    #    選択sourceによってresultRadioButtonを表示、非表示に設定
    def showResultRadioButton(self, selSource):
        self.radio_btn_25.Enable(False)  #cellSet
        #self.radio_btn_26.Enable(False)  #faceSet
        self.radio_btn_27.Enable(False)  #pointSet
        self.radio_btn_28.Enable(False)  #cellZone
        self.radio_btn_29.Enable(False)  #faceZone
        self.radio_btn_35.Enable(False)  #pointZone
        self.radio_btn_40.Enable(False)  #sets
        self.radio_btn_41.Enable(False)  #zones
        if self.IsCombinedAction() == True:
            return

        #cellSetのチェック
        sourceNames = makeRunTopoSet.cellSetSourceList()
        for sourceName in sourceNames:
            if sourceName[0] == selSource:
                self.radio_btn_25.Enable(True)
                break
        #faceSetのチェック
        sourceNames = makeRunTopoSet.faceSetSourceList()
        for sourceName in sourceNames:
            if sourceName[0] == selSource:
                self.radio_btn_26.Enable(True)
                break
        #pointSetのチェック
        sourceNames = makeRunTopoSet.pointSetSourceList()
        for sourceName in sourceNames:
            if sourceName[0] == selSource:
                self.radio_btn_27.Enable(True)
                break
        #setsのチェック
        if (self.radio_btn_18.GetValue() == True or      #action new?
            self.radio_btn_19.GetValue() == True or     #action add
            self.radio_btn_20.GetValue() == True):      #action delete
            sourceNames = makeRunTopoSet.setsSourceList()
            for sourceName in sourceNames:
                if sourceName[0] == selSource:
                    self.radio_btn_40.Enable(True)
                    break
            if (self.radio_btn_18.GetValue() == True and    #action new
                (self.radio_btn_1.GetValue() == True or     #source cellSet
                 self.radio_btn_2.GetValue() == True or     #source faceSet
                 self.radio_btn_3.GetValue() == True)):     #source pointSet
                self.radio_btn_40.Enable(False)             #result sets
        #cellZoneのチェック
        sourceNames = makeRunTopoSet.cellZoneSetSourceList()
        for sourceName in sourceNames:
            if sourceName[0] == selSource:
                self.radio_btn_28.Enable(True)
                break
        #faceZoneのチェック
        sourceNames = makeRunTopoSet.faceZoneSetSourceList()
        for sourceName in sourceNames:
            if sourceName[0] == selSource:
                self.radio_btn_29.Enable(True)
                break
        #pointZoneのチェック
        sourceNames = makeRunTopoSet.pointZoneSetSourceList()
        for sourceName in sourceNames:
            if sourceName[0] == selSource:
                self.radio_btn_35.Enable(True)
                break
        #zonesのチェック
        if (self.radio_btn_18.GetValue() == True or      #action new?
            self.radio_btn_19.GetValue() == True or     #action add
            self.radio_btn_20.GetValue() == True):      #action delete
            sourceNames = makeRunTopoSet.zonesSourceList()
            for sourceName in sourceNames:
                if sourceName[0] == selSource:
                    self.radio_btn_41.Enable(True)
                    break

    #  setNameList
    #    setNameList（起動時のみ）
    def setNameList(self):
        self.setSourceNameList()
        #self.setMeshDirToSourceLabel()
        self.setResultNameList()
        #self.setMeshDirToResultLabel()

    #  setSourceNameList
    #    sourceNameをlistBoxにセット
    def setSourceNameList(self):
        if self.radio_btn_1.GetValue() == True:
            getSetsNames()
            self.setSourceNameInListBox(cellSets)
        elif self.radio_btn_2.GetValue() == True:
            getSetsNames()
            self.setSourceNameInListBox(faceSets)
        elif self.radio_btn_3.GetValue() == True:
            getSetsNames()
            self.setSourceNameInListBox(pointSets)
        elif self.radio_btn_4.GetValue() == True:
            getCellZoneNames()
            self.setSourceNameInListBox(cellZones)
        elif self.radio_btn_5.GetValue() == True:
            getFaceZoneNames()
            self.setSourceNameInListBox(faceZones)
        elif self.radio_btn_6.GetValue() == True:
            getStlFileNames()
            self.setSourceNameInListBox(stlFiles)
        elif self.radio_btn_11.GetValue() == True:
            getSetsNames()
            self.setSourceNameInListBox(cellSets)
        elif self.radio_btn_12.GetValue() == True:
            getFieldNames()
            self.setSourceNameInListBox(fields)
        elif self.radio_btn_13.GetValue() == True:
            getPatchNames()
            self.setSourceNameInListBox(patches)
        elif self.radio_btn_30.GetValue() == True:
            getSetsNames()
            self.setSourceSetsNamesInListBox()
        else:
            self.setSourceNameInListBox([])

    #  setSourceNameInListBox
    def setSourceNameInListBox(self, listData):
        self.list_box_1.Clear()
        for data in listData:
            self.list_box_1.Append(data)
        self.setMeshDirToSourceLabel()
        self.setResultNameList()
        self.setMeshDirToResultLabel()

    #  setSourceSetsNamesInListBox
    #    setsの場合のnameをセット
    def setSourceSetsNamesInListBox(self):
        names = []
        for name in cellSets:
            names.append("c:"+name)
        for name in faceSets:
            names.append("f:"+name)
        for name in pointSets:
            names.append("p:"+name)
        self.setSourceNameInListBox(names)

    #  setResultNameList
    #    resultNameをlistBoxにセット
    def setResultNameList(self):
        if self.radio_btn_25.GetValue() == True:
            getSetsNames()
            self.setResultNameInListBox(cellSets)
        elif self.radio_btn_26.GetValue() == True:
            getSetsNames()
            self.setResultNameInListBox(faceSets)
        elif self.radio_btn_27.GetValue() == True:
            getSetsNames()
            self.setResultNameInListBox(pointSets)
        elif self.radio_btn_40.GetValue() == True:      #sets
            getSetsNames()
            self.setResultAllNamesInListBox(cellSets, faceSets, pointSets)
        elif self.radio_btn_28.GetValue() == True:
            getCellZoneNames()
            self.setResultNameInListBox(cellZones)
        elif self.radio_btn_29.GetValue() == True:
            getFaceZoneNames()
            self.setResultNameInListBox(faceZones)
        elif self.radio_btn_41.GetValue() == True:      #zones
            getCellZoneNames()
            getFaceZoneNames()
            getPointZoneNames()
            self.setResultAllNamesInListBox(cellZones, faceZones, pointZones)
        else:
            self.setResultNameInListBox([])

    #  getSourceName
    def getSourceName(self):
        #name = self.list_box_1.GetStringSelection()
        nums = self.list_box_1.GetSelections()
        #self.text_ctrl_3.SetValue(name)

    #  setResultNameInListBox
    def setResultNameInListBox(self, listData):
        self.list_box_2.Clear()
        for data in listData:
            self.list_box_2.Append(data)
        self.setMeshDirToResultLabel()

    #  setResultAllNamesInListBox
    def setResultAllNamesInListBox(self, cells, faces, points):
        setData = []
        for name in cells:
            setData.append("c:" + name)
        for name in faces:
            setData.append("f:" + name)
        for name in points:
            setData.append("p:" + name)
        self.list_box_2.Clear()
        self.list_box_2.AppendItems(setData)        

    #  getListNameToResultName
    #    resultNameをリストから取得
    def getListNameToResultName(self):
        #name = self.list_box_2.GetStringSelection()
        nSels = self.list_box_2.GetSelections()
        name = self.list_box_2.GetString(nSels[0])
        words = name.split(":")
        if len(words) > 1:
            name = words[1]
        self.text_ctrl_1.SetValue(name)

    #  setSourceOption
    #    sourceのoptionを表示する。
    def setSourceOption(self):
        [sourceType, sourceName, action, resultType, resultName] = self.readSettingItem()
        contents = makeRunTopoSet.getSourceInfo(sourceType, sourceName,
                        action, resultType)
        self.text_ctrl_2.SetValue(contents)

    #
    #  setTopoSetCode
    #    コードをセット（表示）
    def setTopoSetCode(self):
        #self.readSettingItem()
        [sourceType, sourceName, action, resultType, resultName] = self.readSettingItem()
        if self.IsCombinedAction() == True:
            code = makeRunTopoSet.makeCombiContents(sourceType, sourceName, action,
                    resultType, resultName)
            self.text_ctrl_2.SetValue(code)
        elif self.IsSetsOrZonesResult() == True:
            if (self.radio_btn_22.GetValue() == True or     #action clear?
                self.radio_btn_23.GetValue() == True or     #action invert?
                self.radio_btn_24.GetValue() == True):      #action remove?
                resultName = self.getSelectResultNames()
            code = makeRunTopoSet.makeSetsZonesContents(sourceType, sourceName, action,
                    resultType, resultName)
            self.text_ctrl_2.SetValue(code)
        else:
            code = makeRunTopoSet.makeContents(sourceType, sourceName, action,
                    resultType, resultName)
            self.text_ctrl_2.SetValue(code)

    #  getSelectResultNames
    #    選択しているresultNameを取得
    def getSelectResultNames(self):
        names = []
        nSels = self.list_box_2.GetSelections()
        for n in nSels:
            names.append(self.list_box_2.GetString(n))
        return names

    #  IsCombinedAction
    #    組み合わせのAction？
    def IsCombinedAction(self):
        flag = 0
        for combiActionName in self.combiAction:
            if combiActionName.GetValue() == True:
                flag = 1
                break
        if flag == 0:
            return False
        else:
            return True

    #  IsSetsOrZonesResult
    #    繰り返しのResult？
    def IsSetsOrZonesResult(self):
        flag = False
        if self.radio_btn_40.GetValue() == True or self.radio_btn_41.GetValue() == True:
            flag = True
        return flag

    #  clearSourceOption
    #    sourceOptionをクリア
    def clearSourceOption(self):
        self.text_ctrl_2.SetValue("")

    #  clearTopoSetDict
    #    topoSetDictの内容（actionsの内容）をクリアする。
    def clearTopoSetDict(self):
        header = makeRunTopoSet.makeHeader()
        actions = "\nactions\n(\n);\n\n"
        footer = makeRunTopoSet.makeFooter()
        dictCont = header + actions + footer
        writeTopoSetDict(caseDir, dictCont)

    #  addThisItemToDict
    #    確定した項目をtopoSetDictに追加する。
    def addThisItemToDict(self):
        error = self.errorCheck()
        if error == "":
            code = self.text_ctrl_2.GetValue()
            self.addThisItemToDictFile(caseDir, code)

    #  errorCheck
    #    入力データのエラーチェック
    def errorCheck(self):
        #入力データの読み込み
        [sourceType, sourceName, action, resultType, resultName] = self.readSettingItem()

        msg = ""
        #actionに応じたチェック
        if (action != "clear" and action != "invert" and action != "remove" and
            action != "renameSetZone" and action != "newAddsSet" and
            action != "newCellToFace" and action != "newZonesToSets" and
            resultType != "sets" and resultType != "zones"):
            """
            #sourceNameのチェック
            if type(sourceName) == list:
                #複数選択している場合
                if len(sourceName)  == 0:
                    msg = u"「sourceName」がセットされていません。"
            else:
                #sourceNameが1ヶの場合
                if len(sourceName.split()) == 0:
                    msg = u"「source name」がセットされていません。"
            """

            #sourceInfoのチェック
            sourceInfo = makeRunTopoSet.getSourceInfo(sourceType, sourceName,
                            action, resultType)
            if sourceInfo == "":
                msg = u"(" + action + u" " + sourceType + u" " + resultType + u") " + _(u"の組み合わせはできません。")
        elif (action == "renameSetZone" or action == "newAddsSet" or
              action == "newInvertSet"  or action == "newZonesToSets"):
            sourceInfo = makeRunTopoSet.makeCombiContents(sourceType, sourceName,
                            action, resultType, resultName)
            if sourceInfo == "":
                msg = u"(" + action + u" " + sourceType + u" " + resultType + u") " + _(u"の組み合わせはできません。")

        #resultNameのチェック
        if (len(resultName.split()) == 0):
            if (action != "newZonesToSets" and resultType != "sets" and resultType != "zones"):
                msg = _(u"「result name」がセットされていません。")

        #最新のcodeかどうかのチェック（sourceTypeのチェックはせず）
        if (action != "renameSetZone" and action != "newAddsSet" and
            action != "newCellToFace" and action != "newZonesToSets" and 
            resultType != "sets" and resultType != "zones"):
            currCont = self.text_ctrl_2.GetValue()
            errMsg = _(u"設定した組み合わせのcodeが表示されていません。\n「code出力」ボタンをクリックしてcodeを出力してください。")
            if (currCont.find(resultType) < 0 or currCont.find(resultName) < 0
                    or currCont.find(action) < 0):
                msg = errMsg

        #error表示
        if msg != "":
            title = _(u"エラー")
            print "error:" + msg
            self.errDialog(title, msg)

        return msg


    #  addThisItemToDictFile
    def addThisItemToDictFile(self, caseDir, addCont):
        cont = readTopoSetDict(caseDir)
        p = getFoamContents.skipFoamFileMem(cont, 0)
        p = getFoamContents.getKeywordPointerMem("actions", cont, p)
        sp = p
        [actionCont, p] = getFoamContents.getSmallPairMem(cont, p)
        ep = p
        actions = cont[sp:ep-1] + addCont + ")"
        dictCont = cont[:sp] + actions + cont[ep:]
        writeTopoSetDict(caseDir, dictCont)

    #  readSettingItem
    #    setした項目を読み込む
    def readSettingItem(self):

        sourceType = ""
        for source in self.sourceType:
            if source.GetValue() == True:
                sourceType = source.GetLabel()
                break

        sourceName = []
        sourceNamesNo = self.list_box_1.GetSelections()
        for no in sourceNamesNo:
            sourceName.append(self.list_box_1.GetString(no))
        if len(sourceName) > 0:
            name = sourceName[0].split(".")
            if len(name) == 2:
                if name[1] == "stl":
                    sourceName = stlDir + "/" + sourceName[0]
        if len(sourceName) == 1:
            sourceName = sourceName[0]
        if len(sourceName) == 0:
            if sourceType == "sets":
                sourceName = []
            else:
                sourceName = ""

        action = ""
        for actionName in self.action:
            if actionName.GetValue() == True:
                action = actionName.GetLabel()
                break

        resultType = ""
        for result in self.resultType:
            if result.GetValue() == True:
                resultType = result.GetLabel()
                break
        resultName = self.text_ctrl_1.GetValue()

        return [sourceType, sourceName, action, resultType, resultName]

    #  openStlFolder
    #    stlファイルフォルダのオープン
    def openStlFolder(self):
        global caseDir, stlDir, stlFiles
        title = _(u"stlファイルの場所")
        mess = _(u"stlファイルの場所を設定")
        rootDir = os.environ["HOME"].encode("utf-8")
        if stlDir[0] != "/":
            currDir = os.path.abspath(stlDir).encode("utf-8")
        else:
            currDir = stlDir.encode("utf-8")
        [stat, stlDir] = getOpenFolderShow(title, mess, rootDir, caseDir, currDir)
        if stat == "OK":
            [stl, surfaceAngle, clearMesh] = getHelyxosData(caseDir)
            setHelyxosData(caseDir, stlDir, surfaceAngle, clearMesh)
            stlFiles = getStlFiles(stlDir)
        self.radio_btn_6.SetValue(True)
        self.setSourceNameList()

    #  runTopoSet
    #    topoSetの実行
    def runTopoSet(self):
        #region有無チェック
        region = getRegion(selMeshDir)
        
        #comm作成
        comm = "topoSet "
        if region != "":
            comm += " -region " + region
        #topoSet実行
        print comm
        [stat, errCont] = pyTreeFoam.runOFUtilityReturnStat(comm)
        title = _(u"topoSet実行")
        if stat == "OK":
            mess = _(u"topoSetを実行しました。")
            self.okDialog(title, mess)
        else:
            mess = _(u"error または warning が発生しています。\n  logを確認してください。")
            self.errDialog(title, mess)
        #各nameを取得
        initialize()
        self.setNameList()

    #  editTopoSet
    #    topoSetDictの編集
    def editTopoSet(self):
        region = getRegion(selMeshDir)
        if region == "":
            pyTreeFoam.runEditor(caseDir + "/system/topoSetDict")
        else:
            pyTreeFoam.runEditor(caseDir + "/system/" + region + "/topoSetDict")


    #  runParaFoam
    #    paraFoamの起動
    def runParaFoam(self):
        config = pyTreeFoam.readConfigTreeFoam()
        paraFoam = config[4]
        comm = "cd " + caseDir + "; " + paraFoam + "&"
        os.system(comm)

    #------------
    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

# end of class MyFrame

#  getRegionMeshDir
#    regionのmeshDirを取得
def getRegionMeshDir(region):
    global caseDir, selTimeFolder, startTime, timeFolders
    #検索するtimesを作成
    currTime = getFoamContents.getCurrTimeFolder(caseDir)
    #meshDirを取得
    meshDir = getFoamContents.getCurrMeshDir(caseDir, currTime, region, "boundary")
    return meshDir

#
#  getTimeFolderMeshDir
#    現在のtimeFolderとmeshDirを取得
def getTimeFolderMeshDir():
    global selMeshDir, selTimeFolder, runTime, regions, selRegion
    [runTime, selTimeFolder] = getTimeControlDict(caseDir)
    regions = getRegions(caseDir)
    selRegion ="."
    selMeshDir = getRegionMeshDir(selRegion)

#
#  getSelTimeMeshDir
#    指定したtimeFolder、regionでmeshDirを取得
def getSelTimeMeshDir(timeFolder, region):
    global selMeshDir, selTimeFolder, runTime, selRegion, regions
    [runTime, dummy] = getTimeControlDict(caseDir)
    selTimeFolder = timeFolder
    regions = getRegions(caseDir)
    selRegion = region
    selMeshDir = getRegionMeshDir(selRegion)


#
#  initialize
#    各nameの取得
def initialize():
    pass


#  getCellZoneNames
#    cellZoneを取得
def getCellZoneNames():
    global cellZones, selMeshDir
    print _(u"cellZoneを"),
    relativeDir = getFoamContents.getCurrMeshDir(caseDir, selTimeFolder, selRegion, "cellZones")
    selMeshDir = relativeDir
    meshDir = "/".join(selMeshDir.split("/")[:-1])
    polyMeshDir = caseDir + "/" + relativeDir
    print polyMeshDir[len(caseDir):], _(u" から取得中...")
    cellZones = getFoamContents.cellZoneNamesDir(polyMeshDir)

#  getFaceZoneNames
#    faceZoneを取得
def getFaceZoneNames():
    global faceZones, selMeshDir
    print _(u"faceZoneを"),
    relativeDir = getFoamContents.getCurrMeshDir(caseDir, selTimeFolder, selRegion, "faceZones")
    selMeshDir = relativeDir
    meshDir = "/".join(selMeshDir.split("/")[:-1])
    polyMeshDir = caseDir + "/" + relativeDir
    print polyMeshDir[len(caseDir):], _(u" から取得中...")
    faceZones = getFoamContents.faceZoneNamesDir(polyMeshDir)

#  getPointZoneNames
#    pointZoneを取得
def getPointZoneNames():
    global pointZones, selMeshDir
    print _(u"pointZoneを"),
    relativeDir = getFoamContents.getCurrMeshDir(caseDir, selTimeFolder, selRegion, "pontZones")
    selMeshDir = relativeDir
    meshDir = "/".join(selMeshDir.split("/")[:-1])
    polyMeshDir = caseDir + "/" + relativeDir
    print polyMeshDir[len(caseDir):], _(u" から取得中...")
    pointZones = getFoamContents.pointZoneNamesDir(polyMeshDir)


#  getSetsNames
#    sets(cellSet, faceSet, pointSet)を取得
def getSetsNames():
    global selMeshDir, cellSets, faceSets, pointSets

    def getSetsDir():
        setsRelDir = getFoamContents.getCurrMeshDir(caseDir, selTimeFolder, selRegion, "sets")
        zoneRelDir = getFoamContents.getCurrMeshDir(caseDir, selTimeFolder, selRegion, "*Zones")
        setsLoc = setsRelDir.split("/")[0]
        zoneLoc = zoneRelDir.split("/")[0]
        if zoneLoc == "constant":
            return setsRelDir
        else:
            if setsLoc == "constant":
                return zoneRelDir
            else:
                if setsLoc < zoneLoc:
                    return zoneRelDir
                else:
                    return setsRelDir

    print _(u"setsを"),
    #relativeDir = getFoamContents.getCurrMeshDir(caseDir, selTimeFolder, selRegion, "sets")
    relativeDir = getSetsDir()
    selMeshDir = relativeDir
    meshDir = "/".join(selMeshDir.split("/")[:-1])
    polyMeshDir = caseDir + "/" + relativeDir
    print polyMeshDir[len(caseDir):], _(u" から取得中...")
    [cellSets, faceSets, pointSets] = getSetsFiles(polyMeshDir)



#  getStlFileNames
#    stlFileを取得
def getStlFileNames():
    global stlFiles
    print _(u"stlファイルを取得中...")
    stlFiles = getStlFiles(stlDir)

#  getFieldNames
#    fileを取得
def getFieldNames():
    global fields, selMeshDir
    print _(u"field名を"),
    region = selRegion
    fieldDir = caseDir + "/" + selTimeFolder + "/" + region
    selMeshDir = fieldDir[len(caseDir)+1:] + "/dummy"
    print fieldDir[len(caseDir):], _(u"から取得中...")
    fields = pyTreeFoam.getFieldNames(fieldDir)

#  getPatchNames
#    patchを取得
def getPatchNames():
    global selMeshDir, patches
    print _(u"patch名を"),
    relativeDir = getFoamContents.getCurrMeshDir(caseDir, selTimeFolder, selRegion, "boundary")
    selMeshDir = relativeDir
    meshDir = "/".join(selMeshDir.split("/")[:-1])
    polyMeshDir = caseDir + "/" + relativeDir
    print polyMeshDir[len(caseDir):], _(u" から取得中...")
    patches = getPatches(polyMeshDir)



#  getTimeContorolDict
#    controlDictの内容に応じてTimeを取得
def getTimeControlDict(caseDir):
    global startTime, timeFolders
    timeFolders = pyTreeFoam.getTimeFolders(caseDir)
    [latestTime, startTime, firstTime, runTime] = getFoamContents.getLatestStartFirstTimeFolder(caseDir)
    selTimeFolder = getFoamContents.getCurrTimeFolder(caseDir)
    return [runTime, selTimeFolder]


#  getSetsFiles
#    setsファイルを調べ、cellSet、faceSet、pointSetを取得
def getSetsFiles(polyMeshDir):
    cellSets = []
    faceSets = []
    pointSets = []
    wdir = polyMeshDir + "/sets"
    files = pyTreeFoam.getFieldNames(wdir)
    if len(files) > 0:
        for fileName in files:
            items = getFoamContents.getFoamFile(wdir, fileName)
            for item in items:
                if item[0] == "class":
                    if item[1] == "cellSet":
                        cellSets.append(fileName)
                    elif item[1] == "faceSet":
                        faceSets.append(fileName)
                    elif item[1] == "pointSet":
                        pointSets.append(fileName)
                    break
    else:
        print _(u"「") + wdir + _(u"」にファイルがありません。")
    return [cellSets, faceSets, pointSets]


#  getStlFiles
#    stlファイル名の取得
def getStlFiles(stlDir):
    files = glob.glob(stlDir + "/*.stl")
    fileNames = []
    for name in files:
        fileNames.append(name.split("/")[-1])
    fileNames.sort()
    return fileNames

#  getRegions
#    region名取得
def getRegions(caseDir):
    [isRegion, loc, regions] = pyTreeFoam.checkMultiRegion(caseDir)
    if isRegion == False:
        regions = []
    return regions

#  getPatches
#    patch名を取得
def getPatches(meshDir):
    patchConts = getFoamContents.getPatchNameFromBoundary(meshDir)
    patches = []
    if patchConts != None:
        for patchCont in patchConts:
            patches.append(patchCont[0])
    return patches

#  readTopoSetDict
#    toposetDictファイルの読み込み
def readTopoSetDict(caseDir):
    region = getRegion(selMeshDir)
    if region == "":
        fileName = caseDir + "/system/topoSetDict"
    else:
        fileName = caseDir + "/system/" + region + "/topoSetDict"
    f = open(fileName)
    cont = f.read()
    f.close()
    return cont

#  writeTopoSetDict
#    topoSetDictに書き込み
def writeTopoSetDict(caseDir, cont):
    region = getRegion(selMeshDir)
    if region == "":
        fileName = caseDir + "/system/topoSetDict"
    else:
        fileName = caseDir + "/system/" + region + "/topoSetDict"
    print fileName
    f = open(fileName, "w")
    f.write(cont)
    f.close()
    return

#  getRegion
#    region有無チェック
#    region有り：region名が戻る
#    region無し：""が戻る
def getRegion(selMeshDir):
    region = ""
    regionName = selMeshDir.split("/")[-2]
    if regionName != "constant":
        try:
            a = float(regionName)
            region = ""
        except:
            region = regionName
    else:
        region = ""
    return region


#  printHelp
#    ヘルプ表示
def printHelp():
    cont = """

<topoSetEditorの使い方（起動方法）>

topoSetEditor.py <caseDir> <stlDir> [<time> <region>]
    caseDir :case directory
    stlDir  :stlファイルの保存場所
             この場所からstlファイルを読み込み設定する
    time    :timeFolder
    region  :region

<使用例>
topoSetEditor.py . ../stlFile
topoSetEditor.py . ../stlFile 0 air
"""
    print cont


if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    if len(sys.argv) == 1:
        printHelp()

    elif len(sys.argv) == 3:
        caseDir = sys.argv[1]
        stlDir = sys.argv[2]
        if len(glob.glob(caseDir))==0:
            printHelp()
        else:
            caseDir = os.path.abspath(caseDir)
            getTimeFolderMeshDir()
            initialize()
            #app = wx.PySimpleApp(0)
            app = wx.App(0)
            #wx.InitAllImageHandlers()
            frame_2 = MyFrame(None, -1, "")
            app.SetTopWindow(frame_2)
            frame_2.Show()
            app.MainLoop()

    elif len(sys.argv) == 5:
        caseDir = sys.argv[1]
        stlDir = sys.argv[2]
        if len(glob.glob(caseDir))==0:
            printHelp()
        else:
            caseDir = os.path.abspath(caseDir)
            timeFolder = sys.argv[3]
            region = sys.argv[4]
            getSelTimeMeshDir(timeFolder, region)            
            initialize()
            #app = wx.PySimpleApp(0)
            app = wx.App(0)
            #wx.InitAllImageHandlers()
            frame_2 = MyFrame(None, -1, "")
            app.SetTopWindow(frame_2)
            frame_2.Show()
            app.MainLoop()

